
DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 1, 1328, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":[],"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 2, 3, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 4, 17, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 18, 19, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 20, 21, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 22, 23, 1, 'com_config', 'com_config', '{}'),
(7, 1, 24, 93, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(8, 1, 94, 1187, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 1188, 1189, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 1190, 1191, 1, 'com_installer', 'com_installer', '{"core.admin":{"7":1},"core.manage":{"7":1},"core.create":[],"core.delete":[],"core.edit.state":[]}'),
(11, 1, 1192, 1193, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 1194, 1195, 1, 'com_login', 'com_login', '{}'),
(13, 1, 1196, 1197, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 1198, 1199, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 1200, 1201, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1},"core.edit":[],"core.edit.state":[]}'),
(16, 1, 1202, 1203, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 43, 44, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 1206, 1207, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 1208, 1215, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(20, 1, 1216, 1217, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 1218, 1219, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 1220, 1221, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 1222, 1223, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 1224, 1225, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.own":{"6":1},"core.edit.state":[]}'),
(25, 1, 1226, 1243, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1,"10":0,"12":0},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(26, 1, 1244, 1245, 1, 'com_wrapper', 'com_wrapper', '{}'),
(39, 8, 117, 306, 2, 'com_content.category.14', 'Sample Data-Articles', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(38, 25, 1233, 1234, 2, 'com_weblinks.category.13', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(37, 19, 1211, 1212, 2, 'com_newsfeeds.category.12', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(36, 7, 29, 30, 2, 'com_contact.category.11', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(35, 3, 7, 8, 2, 'com_banners.category.10', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(34, 8, 111, 116, 2, 'com_content.category.9', 'Uncategorised', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(40, 3, 9, 10, 2, 'com_banners.category.15', 'Sample Data-Banners', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 7, 31, 92, 2, 'com_contact.category.16', 'Sample Data-Contact', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 19, 1213, 1214, 2, 'com_newsfeeds.category.17', 'Sample Data-Newsfeeds', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 25, 1235, 1242, 2, 'com_weblinks.category.18', 'Sample Data-Weblinks', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 39, 118, 249, 3, 'com_content.category.19', 'Joomla!', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 44, 119, 226, 4, 'com_content.category.20', 'Extensions', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 45, 120, 135, 5, 'com_content.category.21', 'Components', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(47, 45, 136, 195, 5, 'com_content.category.22', 'Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(48, 45, 196, 207, 5, 'com_content.category.23', 'Templates', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(49, 45, 208, 209, 5, 'com_content.category.24', 'Languages', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(50, 45, 210, 225, 5, 'com_content.category.25', 'Plugins', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(51, 39, 250, 281, 3, 'com_content.category.26', 'Park Site', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(52, 51, 251, 256, 4, 'com_content.category.27', 'Park Blog', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(53, 51, 257, 278, 4, 'com_content.category.28', 'Photo Gallery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(54, 39, 282, 295, 3, 'com_content.category.29', 'Fruit Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(55, 54, 283, 288, 4, 'com_content.category.30', 'Growers', '{"core.create":{"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"10":1}}'),
(56, 43, 1236, 1237, 3, 'com_weblinks.category.31', 'Park Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(57, 43, 1238, 1241, 3, 'com_weblinks.category.32', 'Joomla! Specific Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(58, 57, 1239, 1240, 4, 'com_weblinks.category.33', 'Other Resources', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(59, 41, 32, 33, 3, 'com_contact.category.34', 'Park Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(60, 41, 34, 91, 3, 'com_contact.category.35', 'Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(61, 60, 35, 36, 4, 'com_contact.category.36', 'Staff', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(62, 60, 37, 90, 4, 'com_contact.category.37', 'Fruit Encyclopedia', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(63, 62, 38, 39, 5, 'com_contact.category.38', 'A', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(64, 62, 40, 41, 5, 'com_contact.category.39', 'B', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(65, 62, 42, 43, 5, 'com_contact.category.40', 'C', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(66, 62, 44, 45, 5, 'com_contact.category.41', 'D', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(67, 62, 46, 47, 5, 'com_contact.category.42', 'E', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(68, 62, 48, 49, 5, 'com_contact.category.43', 'F', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(69, 62, 50, 51, 5, 'com_contact.category.44', 'G', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(70, 62, 52, 53, 5, 'com_contact.category.45', 'H', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(71, 62, 54, 55, 5, 'com_contact.category.46', 'I', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(72, 62, 56, 57, 5, 'com_contact.category.47', 'J', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(73, 62, 58, 59, 5, 'com_contact.category.48', 'K', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(74, 62, 60, 61, 5, 'com_contact.category.49', 'L', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(75, 62, 62, 63, 5, 'com_contact.category.50', 'M', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(76, 62, 64, 65, 5, 'com_contact.category.51', 'N', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(77, 62, 66, 67, 5, 'com_contact.category.52', 'O', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(78, 62, 68, 69, 5, 'com_contact.category.53', 'P', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(79, 62, 70, 71, 5, 'com_contact.category.54', 'Q', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(80, 62, 72, 73, 5, 'com_contact.category.55', 'R', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(81, 62, 74, 75, 5, 'com_contact.category.56', 'S', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(82, 62, 76, 77, 5, 'com_contact.category.57', 'T', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(83, 62, 78, 79, 5, 'com_contact.category.58', 'U', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(84, 62, 80, 81, 5, 'com_contact.category.59', 'V', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(85, 62, 82, 83, 5, 'com_contact.category.60', 'W', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(86, 62, 84, 85, 5, 'com_contact.category.61', 'X', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(87, 62, 86, 87, 5, 'com_contact.category.62', 'Y', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(88, 62, 88, 89, 5, 'com_contact.category.63', 'Z', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(89, 46, 121, 122, 6, 'com_content.article.1', 'Administrator Components', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(90, 93, 138, 139, 7, 'com_content.article.2', 'Archive Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(91, 93, 140, 141, 7, 'com_content.article.3', 'Article Categories Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(92, 93, 142, 143, 7, 'com_content.article.4', 'Articles Category Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(93, 47, 137, 152, 6, 'com_content.category.64', 'Content Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(94, 47, 153, 160, 6, 'com_content.category.65', 'User Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(95, 47, 161, 174, 6, 'com_content.category.66', 'Display Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(96, 47, 175, 186, 6, 'com_content.category.67', 'Utility Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(97, 48, 197, 198, 6, 'com_content.category.68', 'Atomic', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(98, 48, 199, 200, 6, 'com_content.category.69', 'Beez 20', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(99, 48, 201, 202, 6, 'com_content.category.70', 'Beez5', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(100, 48, 203, 204, 6, 'com_content.category.71', 'Milky Way', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(101, 50, 211, 212, 6, 'com_content.article.5', 'Authentication', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(102, 51, 279, 280, 4, 'com_content.article.6', 'Australian Parks ', '{"core.delete":[],"core.edit":{"2":1},"core.edit.state":[]}'),
(103, 95, 162, 163, 7, 'com_content.article.7', 'Banner Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(104, 44, 227, 228, 4, 'com_content.article.8', 'Beginners', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(105, 46, 123, 124, 6, 'com_content.article.9', 'Contact', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(106, 46, 125, 126, 6, 'com_content.article.10', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(107, 109, 269, 270, 6, 'com_content.article.11', 'Cradle Mountain', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(108, 53, 258, 267, 5, 'com_content.category.72', 'Animals', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(109, 53, 268, 277, 5, 'com_content.category.73', 'Scenery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(110, 95, 164, 165, 7, 'com_content.article.12', 'Custom HTML Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(111, 54, 289, 290, 4, 'com_content.article.13', 'Directions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(112, 50, 213, 214, 6, 'com_content.article.14', 'Editors', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(113, 50, 215, 216, 6, 'com_content.article.15', 'Editors-xtd', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(114, 95, 166, 167, 7, 'com_content.article.16', 'Feed Display', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(115, 52, 252, 253, 5, 'com_content.article.17', 'First Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(116, 52, 254, 255, 5, 'com_content.article.18', 'Second Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(117, 95, 168, 169, 7, 'com_content.article.19', 'Footer Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(118, 54, 291, 292, 4, 'com_content.article.20', 'Fruit Shop', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(119, 44, 229, 230, 4, 'com_content.article.21', 'Getting Help', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(120, 44, 231, 232, 4, 'com_content.article.22', 'Getting Started', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(121, 55, 284, 285, 5, 'com_content.article.23', 'Happy Orange Orchard', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(122, 44, 233, 234, 4, 'com_content.article.24', 'Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(123, 108, 259, 260, 6, 'com_content.article.25', 'Koala', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(124, 96, 176, 177, 7, 'com_content.article.26', 'Language Switcher', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(125, 93, 144, 145, 7, 'com_content.article.27', 'Latest Articles Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(126, 94, 154, 155, 7, 'com_content.article.28', 'Login Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(127, 166, 190, 191, 7, 'com_content.article.29', 'Menu Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(128, 93, 146, 147, 7, 'com_content.article.30', 'Most Read Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(129, 93, 148, 149, 7, 'com_content.article.31', 'News Flash', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(130, 44, 235, 236, 4, 'com_content.article.32', 'Parameters', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(131, 108, 261, 262, 6, 'com_content.article.33', 'Phyllopteryx', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(132, 109, 271, 272, 6, 'com_content.article.34', 'Pinnacles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(133, 44, 237, 238, 4, 'com_content.article.35', 'Professionals', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(134, 95, 170, 171, 7, 'com_content.article.36', 'Random Image Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(135, 93, 150, 151, 7, 'com_content.article.37', 'Related Items Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(136, 44, 239, 240, 4, 'com_content.article.38', 'Sample Sites', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(137, 46, 127, 128, 6, 'com_content.article.39', 'Search', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(138, 96, 178, 179, 7, 'com_content.article.40', 'Search Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(139, 50, 217, 218, 6, 'com_content.article.41', 'Search ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(140, 39, 296, 297, 3, 'com_content.article.42', 'Site Map', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(141, 108, 263, 264, 6, 'com_content.article.43', 'Spotted Quoll', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(142, 96, 180, 181, 7, 'com_content.article.44', 'Statistics Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(143, 96, 182, 183, 7, 'com_content.article.45', 'Syndicate Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(144, 50, 219, 220, 6, 'com_content.article.46', 'System', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(145, 44, 241, 242, 4, 'com_content.article.47', 'The Joomla! Community', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(146, 44, 243, 244, 4, 'com_content.article.48', 'The Joomla! Project', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(147, 48, 205, 206, 6, 'com_content.article.49', 'Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(148, 44, 245, 246, 4, 'com_content.article.50', 'Upgraders', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(149, 50, 221, 222, 6, 'com_content.article.51', 'User', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(150, 46, 129, 130, 6, 'com_content.article.52', 'Users', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(151, 44, 247, 248, 4, 'com_content.article.53', 'Using Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(152, 46, 131, 132, 6, 'com_content.article.54', 'Weblinks', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(153, 95, 172, 173, 7, 'com_content.article.55', 'Weblinks Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(154, 94, 156, 157, 7, 'com_content.article.56', 'Who\'s Online', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(155, 108, 265, 266, 6, 'com_content.article.57', 'Wobbegone', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(156, 55, 286, 287, 5, 'com_content.article.58', 'Wonderful Watermelon', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(157, 96, 184, 185, 7, 'com_content.article.59', 'Wrapper Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(158, 46, 133, 134, 6, 'com_content.article.60', 'News Feeds', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(159, 166, 192, 193, 7, 'com_content.article.61', 'Breadcrumbs Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(160, 50, 223, 224, 6, 'com_content.article.62', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(162, 109, 273, 274, 6, 'com_content.article.64', 'Blue Mountain Rain Forest', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(163, 109, 275, 276, 6, 'com_content.article.65', 'Ormiston Pound', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(165, 94, 158, 159, 7, 'com_content.article.66', 'Latest Users Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(166, 47, 189, 194, 6, 'com_content.category.75', 'Navigation Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(167, 54, 293, 294, 4, 'com_content.category.76', 'Recipes', '{"core.create":{"12":1,"10":1},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"12":1,"10":1}}'),
(168, 34, 112, 113, 3, 'com_content.article.67', 'What\'s New in 1.5?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(169, 8, 307, 344, 2, 'com_content.category.77', 'News', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(170, 169, 308, 319, 3, 'com_content.category.78', 'Latest', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(171, 170, 309, 310, 4, 'com_content.article.68', 'Welcome to Joomla!', ''),
(172, 170, 311, 312, 4, 'com_content.article.69', 'We are Volunteers', ''),
(173, 170, 313, 314, 4, 'com_content.article.70', 'Stick to the Code!', ''),
(174, 170, 315, 316, 4, 'com_content.article.71', 'The Legend of Buca di Beppo', ''),
(175, 170, 317, 318, 4, 'com_content.article.72', '1 Million Smiles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(176, 169, 320, 331, 3, 'com_content.category.79', 'Newsflash', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(177, 176, 321, 322, 4, 'com_content.article.73', 'Newsflash 1', ''),
(178, 176, 323, 324, 4, 'com_content.article.74', 'Newsflash 2', ''),
(179, 176, 325, 326, 4, 'com_content.article.75', 'Newsflash 3', ''),
(180, 176, 327, 328, 4, 'com_content.article.76', 'Newsflash 5', ''),
(181, 176, 329, 330, 4, 'com_content.article.77', 'Newsflash 4', ''),
(182, 169, 332, 343, 3, 'com_content.category.80', 'Hot topic', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(183, 182, 333, 334, 4, 'com_content.article.78', 'Pretium tempor', ''),
(184, 182, 335, 336, 4, 'com_content.article.79', 'In Sed cursus orci', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(185, 182, 337, 338, 4, 'com_content.article.80', 'Aliquam et dictum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(186, 182, 339, 340, 4, 'com_content.article.81', 'Wisi tincidunt', ''),
(187, 182, 341, 342, 4, 'com_content.article.82', '3 Days in Puerto Rico', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(188, 8, 345, 398, 2, 'com_content.category.81', 'FAQs', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(189, 188, 346, 353, 3, 'com_content.category.82', 'New to Joomla!', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(190, 189, 347, 348, 4, 'com_content.article.83', 'Is it useful to install the sample data?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(191, 189, 349, 350, 4, 'com_content.article.84', 'How do I remove an Article?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(192, 189, 351, 352, 4, 'com_content.article.85', 'What is the difference between Archiving and Trashing an Article? ', ''),
(193, 188, 354, 367, 3, 'com_content.category.83', 'Current Users', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(194, 193, 355, 356, 4, 'com_content.article.86', 'How do I upgrade to Joomla! 1.5 ?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(195, 193, 357, 358, 4, 'com_content.article.87', 'What happened to the locale setting?', ''),
(196, 193, 359, 360, 4, 'com_content.article.88', 'Only one edit window! How do I create "Read more..."?', ''),
(197, 193, 361, 362, 4, 'com_content.article.89', 'Where is the Static Content Item?', ''),
(198, 193, 363, 364, 4, 'com_content.article.90', 'Where did the Installers go?', ''),
(199, 193, 365, 366, 4, 'com_content.article.91', 'Where did the Mambots go?', ''),
(200, 188, 368, 385, 3, 'com_content.category.84', 'General', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(201, 200, 369, 370, 4, 'com_content.article.92', 'Why does Joomla! 1.5 use utf-8 encoding?', ''),
(202, 200, 371, 372, 4, 'com_content.article.93', 'What is the FTP layer for?', ''),
(203, 200, 373, 374, 4, 'com_content.article.94', 'Can Joomla! 1.5 operate with PHP Safe Mode On?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(204, 200, 375, 376, 4, 'com_content.article.95', 'My MySQL  database does not support UTF-8. Do I have a problem?', ''),
(205, 200, 377, 378, 4, 'com_content.article.96', 'What are the requirements to run Joomla! 1.5?', ''),
(206, 200, 379, 380, 4, 'com_content.article.97', 'How do I install Joomla! 1.5?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(207, 200, 381, 382, 4, 'com_content.article.98', 'What is an Uncategorised Article?', ''),
(208, 200, 383, 384, 4, 'com_content.article.99', 'Is it possible to change A Menu Item\'s Type?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(209, 188, 386, 397, 3, 'com_content.category.85', 'Languages', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(210, 209, 387, 388, 4, 'com_content.article.100', 'How do I localise Joomla! to my language?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(211, 209, 389, 390, 4, 'com_content.article.101', 'What is the purpose of the collation selection in the installation screen?', ''),
(212, 209, 391, 392, 4, 'com_content.article.102', 'What languages are supported by Joomla! 1.6?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(213, 209, 393, 394, 4, 'com_content.article.103', 'Does the PDF icon render pictures and special characters?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(214, 209, 395, 396, 4, 'com_content.article.104', 'I installed with my own language, but the Back-end is still in English', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(215, 8, 399, 426, 2, 'com_content.category.86', 'About Joomla!', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(216, 215, 400, 407, 3, 'com_content.category.87', 'The Project', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(217, 216, 401, 402, 4, 'com_content.article.105', 'Joomla! License Guidelines', ''),
(218, 216, 403, 404, 4, 'com_content.article.106', 'Support and Documentation', ''),
(219, 216, 405, 406, 4, 'com_content.article.107', 'Platforms and Open Standards', ''),
(220, 215, 408, 419, 3, 'com_content.category.88', 'The CMS', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(221, 220, 409, 410, 4, 'com_content.article.108', 'Joomla! Features', ''),
(222, 220, 411, 412, 4, 'com_content.article.109', 'Joomla! Overview', ''),
(223, 220, 413, 414, 4, 'com_content.article.110', 'What\'s New In 1.5?', ''),
(224, 220, 415, 416, 4, 'com_content.article.111', 'Content Layouts', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(225, 220, 417, 418, 4, 'com_content.article.112', 'Extensions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(226, 215, 420, 425, 3, 'com_content.category.89', 'The Community', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(227, 226, 421, 422, 4, 'com_content.article.113', 'Joomla! Facts', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(228, 226, 423, 424, 4, 'com_content.article.114', 'The Joomla! Community', ''),
(229, 8, 427, 540, 2, 'com_content.category.90', 'Sport', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(230, 229, 428, 447, 3, 'com_content.category.91', 'Football', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(231, 230, 429, 430, 4, 'com_content.article.115', 'Premier League summer transfer photos ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(232, 230, 431, 432, 4, 'com_content.article.116', 'Ferguson hails brave Arsenal after \'best game of the year\'', ''),
(233, 230, 433, 434, 4, 'com_content.article.117', 'Wenger\'s recipe for success', ''),
(234, 230, 435, 436, 4, 'com_content.article.118', 'How will the Premier League unfold?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(235, 230, 437, 438, 4, 'com_content.article.119', 'Are England right to be optimistic?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(236, 230, 439, 440, 4, 'com_content.article.120', 'Barcelona 3-0 Sporting Gijon', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(237, 230, 441, 442, 4, 'com_content.article.121', 'Volutpat euismod tincidunt', ''),
(238, 230, 443, 444, 4, 'com_content.article.122', 'Tincidunt vestibulum justo', ''),
(239, 230, 445, 446, 4, 'com_content.article.123', 'Congue mattis justo Fusce sed', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(240, 229, 448, 465, 3, 'com_content.category.92', 'Cricket', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(241, 240, 449, 450, 4, 'com_content.article.124', 'Jonathan Agnew column ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(242, 240, 451, 452, 4, 'com_content.article.125', 'The true Aussie sporting spirit', ''),
(243, 240, 453, 454, 4, 'com_content.article.126', 'Modi dismisses Steyn test reports ', ''),
(244, 240, 455, 456, 4, 'com_content.article.127', 'England stars offer summer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(245, 240, 457, 458, 4, 'com_content.article.128', 'Tortor pretium ipsum Maecenas', ''),
(246, 240, 459, 460, 4, 'com_content.article.129', 'Nibh metus vel diam et consectetuer est', ''),
(247, 240, 461, 462, 4, 'com_content.article.130', 'Habitant lobortis vitae pretium vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(248, 240, 463, 464, 4, 'com_content.article.131', 'Quisque odio adipiscing nullam', ''),
(249, 229, 466, 483, 3, 'com_content.category.93', 'Tennis', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(250, 249, 467, 468, 4, 'com_content.article.132', 'Russians Squeak Through Openers', ''),
(251, 249, 469, 470, 4, 'com_content.article.133', 'Elena Baltacha\'s diary', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(252, 249, 471, 472, 4, 'com_content.article.134', 'Murray eases through in Montreal ', ''),
(253, 249, 473, 474, 4, 'com_content.article.135', 'Consectetuer venenatis nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(254, 249, 475, 476, 4, 'com_content.article.136', 'Fringilla Maecenas libero ut faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(255, 249, 477, 478, 4, 'com_content.article.137', 'Ut id Quisque odio adipiscing', ''),
(256, 249, 479, 480, 4, 'com_content.article.138', 'Donec Curabitur consequat', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(257, 249, 481, 482, 4, 'com_content.article.139', 'Penatibus laoreet consectetuer', ''),
(258, 229, 484, 501, 3, 'com_content.category.94', 'Motorsport', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(259, 258, 485, 486, 4, 'com_content.article.140', 'Crash ends Raikkonen\'s WRC debut ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(260, 258, 487, 488, 4, 'com_content.article.141', 'Matt Roberts\' MotoGP column ', ''),
(261, 258, 489, 490, 4, 'com_content.article.142', 'Vestibulum Nullam pellentesque', ''),
(262, 258, 491, 492, 4, 'com_content.article.143', 'Vestibulum Nullam pellentesque', ''),
(263, 258, 493, 494, 4, 'com_content.article.144', 'Matt Roberts\' MotoGP column ', ''),
(264, 258, 495, 496, 4, 'com_content.article.145', 'Pellentesque Morbi vel metus Vestibulum ', ''),
(265, 258, 497, 498, 4, 'com_content.article.146', 'Dignissim Nam Nam ligula amet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(266, 258, 499, 500, 4, 'com_content.article.147', 'In nec suscipit metus eros mauris eu ipsum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(267, 229, 502, 521, 3, 'com_content.category.95', 'Horse racing', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(268, 267, 503, 504, 4, 'com_content.article.148', 'Glorious Goodwood photos ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(269, 267, 505, 506, 4, 'com_content.article.149', 'Racing - live!', ''),
(270, 267, 507, 508, 4, 'com_content.article.150', 'India Closes Torch Relay to Spectators', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(271, 267, 509, 510, 4, 'com_content.article.151', 'Enim sollicitudin habitasse', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(272, 267, 511, 512, 4, 'com_content.article.152', ' Morbi faucibus Sed Vivamus odio semper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(273, 267, 513, 514, 4, 'com_content.article.153', 'Dignissim sagittis tristique', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(274, 267, 515, 516, 4, 'com_content.article.154', 'Tortor est Aenean porttitor', ''),
(275, 267, 517, 518, 4, 'com_content.article.155', 'Phasellus Curabitur euismod tincidunt', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(276, 267, 519, 520, 4, 'com_content.article.156', 'Interdum gravida massa quis ac', ''),
(277, 229, 522, 539, 3, 'com_content.category.96', 'Boxing', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(278, 277, 523, 524, 4, 'com_content.article.157', 'In id metus laoreet dignissim vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(279, 277, 525, 526, 4, 'com_content.article.158', 'Vivamus lacinia velit velit amet', ''),
(280, 277, 527, 528, 4, 'com_content.article.159', 'A elit consequat interdum libero', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(281, 277, 529, 530, 4, 'com_content.article.160', 'Justo ligula nonummy ante nibh', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(282, 277, 531, 532, 4, 'com_content.article.161', 'Muscular African American Boxer', ''),
(283, 277, 533, 534, 4, 'com_content.article.162', 'Metus purus Vestibulum ac ut', ''),
(284, 277, 535, 536, 4, 'com_content.article.163', 'Platea fringilla volutpat', ''),
(285, 277, 537, 538, 4, 'com_content.article.164', 'Tincidunt vestibulum justo pulvinar', ''),
(286, 8, 541, 650, 2, 'com_content.category.97', 'Artist', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(287, 286, 542, 559, 3, 'com_content.category.98', 'Art', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(288, 287, 543, 544, 4, 'com_content.article.165', 'Sed id leo et vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(289, 287, 545, 546, 4, 'com_content.article.166', 'Spoken word  ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(290, 287, 547, 548, 4, 'com_content.article.167', 'Plinth moment for Booker authors', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(291, 287, 549, 550, 4, 'com_content.article.168', 'Consectetuer consequat pretium ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(292, 287, 551, 552, 4, 'com_content.article.169', 'Egestas Phasellus leo porttitor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(293, 287, 553, 554, 4, 'com_content.article.170', 'Ultrices semper sapien odio', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(294, 287, 555, 556, 4, 'com_content.article.171', 'Dolor dapibus Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(295, 287, 557, 558, 4, 'com_content.article.172', 'Sed tempus pretium pretium', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(296, 286, 560, 577, 3, 'com_content.category.99', 'Architecture', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(297, 296, 561, 562, 4, 'com_content.article.173', 'Egestas Phasellus leo porttitor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(298, 296, 563, 564, 4, 'com_content.article.174', 'Nec justo Ut et at risus Nam', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(299, 296, 565, 566, 4, 'com_content.article.175', 'Quam ligula Mauris ac a et morbi eu Vestibulum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(300, 296, 567, 568, 4, 'com_content.article.176', 'Pellentesque felis mollis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(301, 296, 569, 570, 4, 'com_content.article.177', 'Nec justo Ut et at risus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(302, 296, 571, 572, 4, 'com_content.article.178', 'Latest Joomla 3.0 template release', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(303, 296, 573, 574, 4, 'com_content.article.179', 'Feugiat auctor et eros Integer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(304, 296, 575, 576, 4, 'com_content.article.180', 'Sapien Nam eleifend sed pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(305, 286, 578, 595, 3, 'com_content.category.100', 'Design', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(306, 305, 579, 580, 4, 'com_content.article.181', 'Curabitur est at id ut Sed urna', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(307, 305, 581, 582, 4, 'com_content.article.182', 'Curabitur convallis laoreet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(308, 305, 583, 584, 4, 'com_content.article.183', 'Praesent Aenean Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(309, 305, 585, 586, 4, 'com_content.article.184', 'Cum mauris justo eros Donec Nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(310, 305, 587, 588, 4, 'com_content.article.185', 'Enim montes parturient', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(311, 305, 589, 590, 4, 'com_content.article.186', 'Aenean pharetra faucibus eu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(312, 305, 591, 592, 4, 'com_content.article.187', 'Aliquet egestas aliquam vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(313, 305, 593, 594, 4, 'com_content.article.188', 'Nunc Cras tincidunt mi vestibulum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(314, 286, 596, 613, 3, 'com_content.category.101', 'Photography', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(315, 314, 597, 598, 4, 'com_content.article.189', 'Vitae tempus eget at lorem sapien', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(316, 314, 599, 600, 4, 'com_content.article.190', 'Integer nisl Pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(317, 314, 601, 602, 4, 'com_content.article.191', 'Semper accumsan Integer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(318, 314, 603, 604, 4, 'com_content.article.192', 'Aliquam augue condimentum urna tortor id', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(319, 314, 605, 606, 4, 'com_content.article.193', 'Vivamus hac iaculis neque Morbi', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(320, 314, 607, 608, 4, 'com_content.article.194', 'Leo ornare egestas pretium odio', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(321, 314, 609, 610, 4, 'com_content.article.195', 'Nibh nibh consectetuer semper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(322, 314, 611, 612, 4, 'com_content.article.196', 'Joomla 3.0 are now live on Magazine Template', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(323, 286, 614, 631, 3, 'com_content.category.102', 'Graphics', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(324, 323, 615, 616, 4, 'com_content.article.197', 'Porta sed nec feugiat Vivamus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(325, 323, 617, 618, 4, 'com_content.article.198', 'Hendrerit velit orci sagittis eu Aenean', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(326, 323, 619, 620, 4, 'com_content.article.199', 'Curabitur auctor risus sem', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(327, 323, 621, 622, 4, 'com_content.article.200', 'Nam id Sed Donec pretium', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(328, 323, 623, 624, 4, 'com_content.article.201', 'Switching to Joomla 3.0 template', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(329, 323, 625, 626, 4, 'com_content.article.202', 'Praesent nibh leo eu justo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(330, 323, 627, 628, 4, 'com_content.article.203', ' Et Aenean id velit risus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(331, 323, 629, 630, 4, 'com_content.article.204', 'Tortor facilisi et interdum Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(332, 286, 632, 649, 3, 'com_content.category.103', '3D Computer Graphics', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(333, 332, 633, 634, 4, 'com_content.article.205', 'England stars offer summer coaching', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(334, 332, 635, 636, 4, 'com_content.article.206', 'Vel dolor ligula tristique magnis sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(335, 332, 637, 638, 4, 'com_content.article.207', 'Wenger\'s recipe for success', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(336, 332, 639, 640, 4, 'com_content.article.208', 'Suspendisse ligula feugiat', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(337, 332, 641, 642, 4, 'com_content.article.209', 'Maecenas nibh sed faucibus ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(338, 332, 643, 644, 4, 'com_content.article.210', 'Condimentum nibh venenatis vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(339, 332, 645, 646, 4, 'com_content.article.211', 'Nulla semper quis sapien', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(340, 332, 647, 648, 4, 'com_content.article.212', 'Id Vestibulum Donec Pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(341, 8, 651, 702, 2, 'com_content.category.104', 'Travel', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(342, 341, 652, 669, 3, 'com_content.category.105', 'Getaways', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(343, 342, 653, 654, 4, 'com_content.article.213', 'Hawaii-style fun on the mainland', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(344, 342, 655, 656, 4, 'com_content.article.214', 'Five festivals for last bit of summer fun', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(345, 342, 657, 658, 4, 'com_content.article.215', 'Are travel agents making a comeback?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(346, 342, 659, 660, 4, 'com_content.article.216', 'Ut Mauris elit ipsum Pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(347, 342, 661, 662, 4, 'com_content.article.217', 'Tortor pretium orci semper platea', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(348, 342, 663, 664, 4, 'com_content.article.218', 'Libero euismod ac orci condimentum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(349, 342, 665, 666, 4, 'com_content.article.219', 'Lacinia vitae In ante ipsum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(350, 342, 667, 668, 4, 'com_content.article.220', 'Feugiat convallis turpis massa', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(351, 341, 670, 683, 3, 'com_content.category.106', 'Travel Tips', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(352, 351, 671, 672, 4, 'com_content.article.221', 'How to slide on airline luggage fees', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(353, 351, 673, 674, 4, 'com_content.article.222', 'How flight attendants deal with life on board', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(354, 351, 675, 676, 4, 'com_content.article.223', 'How to avoid the hazards of booking online', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(355, 351, 677, 678, 4, 'com_content.article.224', 'Trapped on the tarmac? Try these escape tips', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(356, 351, 679, 680, 4, 'com_content.article.225', 'Semper Sed eros dolor condimentum congue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(357, 351, 681, 682, 4, 'com_content.article.226', 'Lobortis rhoncus porttitor Nunc Cum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(358, 341, 684, 701, 3, 'com_content.category.107', 'Business Travel', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(359, 358, 685, 686, 4, 'com_content.article.227', 'September\'s show: traveling with a conscience', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(360, 358, 687, 688, 4, 'com_content.article.228', 'Taking the ethical high road', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(361, 358, 689, 690, 4, 'com_content.article.229', '3 biggest mistakes business travelers make', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(362, 358, 691, 692, 4, 'com_content.article.230', 'Giving something back', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(363, 358, 693, 694, 4, 'com_content.article.231', '9 essential travel strategies for 2009', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(364, 358, 695, 696, 4, 'com_content.article.232', 'Vestibulum orci Quisque hendrerit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(365, 358, 697, 698, 4, 'com_content.article.233', 'Magazine Joomla 3.0 template is now available', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(366, 358, 699, 700, 4, 'com_content.article.234', 'Porttitor fringilla sed natoque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(367, 8, 703, 812, 2, 'com_content.category.108', 'Life and Style', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(368, 367, 704, 721, 3, 'com_content.category.109', 'Fashion and Beauty', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(369, 368, 705, 706, 4, 'com_content.article.235', 'The Fall of Christian Lacroix', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(370, 368, 707, 708, 4, 'com_content.article.236', 'Tips to Soothe Your Skin ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(371, 368, 709, 710, 4, 'com_content.article.237', '\'How to\' with Joomla 3.0 template!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(372, 368, 711, 712, 4, 'com_content.article.238', 'Maecenas augue enim felis Nam', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(373, 368, 713, 714, 4, 'com_content.article.239', 'In condimentum mauris Integer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(374, 368, 715, 716, 4, 'com_content.article.240', 'Lobortis rhoncus porttitor Nunc Cum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(375, 368, 717, 718, 4, 'com_content.article.241', 'Enim sollicitudin habitasse Nam', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(376, 368, 719, 720, 4, 'com_content.article.242', 'Rhoncus tellus eros enim netus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(377, 367, 722, 739, 3, 'com_content.category.110', 'Food and Drink', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(378, 377, 723, 724, 4, 'com_content.article.243', 'Quisque Suspendisse consequat', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(379, 377, 725, 726, 4, 'com_content.article.244', 'Podcast: the awards ceremony', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(380, 377, 727, 728, 4, 'com_content.article.245', 'Best restaurant', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(381, 377, 729, 730, 4, 'com_content.article.246', 'Vestibulum sem wisi eu at et Morbi congue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(382, 377, 731, 732, 4, 'com_content.article.247', 'Vestibulum sem wisi eu at et ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(383, 377, 733, 734, 4, 'com_content.article.248', 'Morbi congue ac sapien sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(384, 377, 735, 736, 4, 'com_content.article.249', 'Migrating to Joomla 3.0 - The path!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(385, 377, 737, 738, 4, 'com_content.article.250', 'Vestibulum sem wisi congue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(386, 367, 740, 757, 3, 'com_content.category.111', 'Homes and Gardens', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(387, 386, 741, 742, 4, 'com_content.article.251', 'Snooping around', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(388, 386, 743, 744, 4, 'com_content.article.252', 'Cause for alarm', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(389, 386, 745, 746, 4, 'com_content.article.253', 'Fit for a Bond baddy', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(390, 386, 747, 748, 4, 'com_content.article.254', 'Proin nisl urna pretium Aenean', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}');
INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(391, 386, 749, 750, 4, 'com_content.article.255', 'At et ac pretium Sed senectus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(392, 386, 751, 752, 4, 'com_content.article.256', 'Auctor et Sed at sodales', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(393, 386, 753, 754, 4, 'com_content.article.257', 'Ipsum sagittis venenatis Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(394, 386, 755, 756, 4, 'com_content.article.258', 'Curabitur euismod tincidunt Aenean ante', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(395, 367, 758, 775, 3, 'com_content.category.112', 'Shop', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(396, 395, 759, 760, 4, 'com_content.article.259', 'Karcher K2900M pressure washer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(397, 395, 761, 762, 4, 'com_content.article.260', 'Plug multiplier', ''),
(398, 395, 763, 764, 4, 'com_content.article.261', 'Multi-purpose oval roaster', ''),
(399, 395, 765, 766, 4, 'com_content.article.262', 'Enim sollicitudin habitasse', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(400, 395, 767, 768, 4, 'com_content.article.263', 'Rhoncus tellus eros enim netus', ''),
(401, 395, 769, 770, 4, 'com_content.article.264', 'Vestibulum sem wisi', ''),
(402, 395, 771, 772, 4, 'com_content.article.265', 'Morbi congue ac sapien sit', ''),
(403, 395, 773, 774, 4, 'com_content.article.266', 'Ipsum sagittis venenatis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(404, 367, 776, 793, 3, 'com_content.category.113', 'Mother and Children', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(405, 404, 777, 778, 4, 'com_content.article.267', 'Eu congue orci nascetur tellus Lorem', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(406, 404, 779, 780, 4, 'com_content.article.268', 'Est Cum elit consectetuer consectetuer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(407, 404, 781, 782, 4, 'com_content.article.269', 'Nibh vitae metus eget ut condimentum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(408, 404, 783, 784, 4, 'com_content.article.270', 'Augue turpis eget In elit pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(409, 404, 785, 786, 4, 'com_content.article.271', 'Montes nibh justo faucibus sit orci sed', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(410, 404, 787, 788, 4, 'com_content.article.272', 'Morbi faucibus Sed Vivamus odio', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(411, 404, 789, 790, 4, 'com_content.article.273', 'Rhoncus tellus eros enim netus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(412, 404, 791, 792, 4, 'com_content.article.274', 'Porttitor ipsum mauris non semper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(413, 367, 794, 811, 3, 'com_content.category.114', 'Wife and Husband', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(414, 413, 795, 796, 4, 'com_content.article.275', 'In id metus laoreet dignissim vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(415, 413, 797, 798, 4, 'com_content.article.276', 'Wenger\'s recipe for success', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(416, 413, 799, 800, 4, 'com_content.article.277', 'Glorious Goodwood photos ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(417, 413, 801, 802, 4, 'com_content.article.278', 'Semper senectus elit eu nibh auctor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(418, 413, 803, 804, 4, 'com_content.article.279', 'Vel dolor ligula tristique magnis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(419, 413, 805, 806, 4, 'com_content.article.280', 'Aenean Vestibulum lorem egestas', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(420, 413, 807, 808, 4, 'com_content.article.281', 'Sed nibh dui Vestibulum sed ante fringilla est leo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(421, 413, 809, 810, 4, 'com_content.article.282', 'Habitant lobortis vitae pretium vitae vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(422, 8, 813, 852, 2, 'com_content.category.115', 'Health', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(423, 422, 814, 827, 3, 'com_content.category.116', 'What Ails You', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(424, 423, 815, 816, 4, 'com_content.article.283', 'Who\'s your daddy? A celebrity look-alike', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(425, 423, 817, 818, 4, 'com_content.article.284', 'Mommies who drink: No joking after the Schuler tragedy', ''),
(426, 423, 819, 820, 4, 'com_content.article.285', 'Peanut-free night lets allergic kids enjoy game', ''),
(427, 423, 821, 822, 4, 'com_content.article.286', 'Nam nibh adipiscing turpis', ''),
(428, 423, 823, 824, 4, 'com_content.article.287', 'Phasellus suscipit ante leo', ''),
(429, 423, 825, 826, 4, 'com_content.article.288', 'Aliquam pretium Aenean', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(430, 422, 828, 841, 3, 'com_content.category.117', 'Diet and Fitness', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(431, 430, 829, 830, 4, 'com_content.article.289', 'Sex Therapists: a Few Minutes Is Best', ''),
(432, 430, 831, 832, 4, 'com_content.article.290', 'Troops Suffering Trauma Reaches 320,000', ''),
(433, 430, 833, 834, 4, 'com_content.article.291', 'Three Deaths... by Infected Hamster?', ''),
(434, 430, 835, 836, 4, 'com_content.article.292', 'Nutrition -- It\'s a matter of fact', ''),
(435, 430, 837, 838, 4, 'com_content.article.293', 'Condimentum mauris interdum velit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(436, 430, 839, 840, 4, 'com_content.article.294', 'Turpis nonummy id Cras et', ''),
(437, 422, 842, 851, 3, 'com_content.category.118', 'You and Your Family', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(438, 437, 843, 844, 4, 'com_content.article.295', 'Drinking, Smoking May Hasten Alzheimer\'s', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(439, 437, 845, 846, 4, 'com_content.article.296', 'New Nerve Disorder From Pig Brain Mist', ''),
(440, 437, 847, 848, 4, 'com_content.article.297', 'Help for aging parents is clicks away', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(441, 437, 849, 850, 4, 'com_content.article.298', 'Feds Back Stem Cell Surgery for Vets', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(442, 8, 853, 964, 2, 'com_content.category.119', 'Entertainment', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(443, 442, 854, 871, 3, 'com_content.category.120', 'Movies', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(444, 443, 855, 856, 4, 'com_content.article.299', 'Ut fames Duis nibh arcu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(445, 443, 857, 858, 4, 'com_content.article.300', 'Et Aliquam pretium faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(446, 443, 859, 860, 4, 'com_content.article.301', 'Curabitur nec enim Lorem Morbi', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(447, 443, 861, 862, 4, 'com_content.article.302', 'Nam feugiat mi id In urna', ''),
(448, 443, 863, 864, 4, 'com_content.article.303', 'Quis eros nisl leo Duis pede', ''),
(449, 443, 865, 866, 4, 'com_content.article.304', 'Vestibulum nec Phasellus facilisi', ''),
(450, 443, 867, 868, 4, 'com_content.article.305', 'Magnis nibh fringilla Vivamus', ''),
(451, 443, 869, 870, 4, 'com_content.article.306', 'Sed Phasellus laoreet condimentum', ''),
(452, 442, 872, 889, 3, 'com_content.category.121', 'TV', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(453, 452, 873, 874, 4, 'com_content.article.307', 'Curabitur nec enim id', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(454, 452, 875, 876, 4, 'com_content.article.308', 'Orci rutrum lacus feugiat', ''),
(455, 452, 877, 878, 4, 'com_content.article.309', 'Orci rutrum lacus feugiat', ''),
(456, 452, 879, 880, 4, 'com_content.article.310', 'Sed interdum sed dapibus quis', ''),
(457, 452, 881, 882, 4, 'com_content.article.311', 'Fames Ut lorem at est tincidunt', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(458, 452, 883, 884, 4, 'com_content.article.312', 'Congue condimentum orci id et', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(459, 452, 885, 886, 4, 'com_content.article.313', 'Interdum quis Nam et id nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(460, 452, 887, 888, 4, 'com_content.article.314', 'Ultrices Phasellus', ''),
(461, 442, 890, 907, 3, 'com_content.category.122', 'Music', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(462, 461, 891, 892, 4, 'com_content.article.315', 'Curabitur convallis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(463, 461, 893, 894, 4, 'com_content.article.316', 'Semper accumsan Integer', ''),
(464, 461, 895, 896, 4, 'com_content.article.317', 'Dolor ut id enim dolor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(465, 461, 897, 898, 4, 'com_content.article.318', 'Ac adipiscing et urna nibh', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(466, 461, 899, 900, 4, 'com_content.article.319', 'Nam feugiat est dolor leo', ''),
(467, 461, 901, 902, 4, 'com_content.article.320', 'Tempor magnis tincidunt euismod', ''),
(468, 461, 903, 904, 4, 'com_content.article.321', 'Vestibulum et eu', ''),
(469, 461, 905, 906, 4, 'com_content.article.322', 'Nulla molestie congue', ''),
(470, 442, 908, 925, 3, 'com_content.category.123', 'Books', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(471, 470, 909, 910, 4, 'com_content.article.323', 'Vel arcu in Curabitur', ''),
(472, 470, 911, 912, 4, 'com_content.article.324', 'Dolor ut id enim dolor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(473, 470, 913, 914, 4, 'com_content.article.325', ' Paris\' Red-Hot London Jaunt', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(474, 470, 915, 916, 4, 'com_content.article.326', 'Tincidunt nulla a Nulla eu', ''),
(475, 470, 917, 918, 4, 'com_content.article.327', 'Justo quam orci ipsum enim', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(476, 470, 919, 920, 4, 'com_content.article.328', 'Vestibulum ac pede id Cum', ''),
(477, 470, 921, 922, 4, 'com_content.article.329', 'Sem laoreet congue Sed', ''),
(478, 470, 923, 924, 4, 'com_content.article.330', 'Nulla Vivamus convallis nibh', ''),
(479, 442, 926, 945, 3, 'com_content.category.124', 'Games', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(480, 479, 927, 928, 4, 'com_content.article.331', 'Vel lorem fringilla ante nunc', ''),
(481, 479, 929, 930, 4, 'com_content.article.332', 'Dui Phasellus Nam pretium', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(482, 479, 931, 932, 4, 'com_content.article.333', 'Congue non est velit Vivamus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(483, 479, 933, 934, 4, 'com_content.article.334', 'Vestibulum at Vestibulum condimentum', ''),
(484, 479, 935, 936, 4, 'com_content.article.335', 'Convallis est urna tortor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(485, 479, 937, 938, 4, 'com_content.article.336', 'Vitae nibh Vestibulum', ''),
(486, 479, 939, 940, 4, 'com_content.article.337', 'Velit Fusce accumsan elit', ''),
(487, 479, 941, 942, 4, 'com_content.article.338', 'Ante ultrices vel adipiscing', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(488, 479, 943, 944, 4, 'com_content.article.339', 'Velit Fusce accumsan elit', ''),
(489, 442, 946, 963, 3, 'com_content.category.125', 'Theatre', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(490, 489, 947, 948, 4, 'com_content.article.340', 'Congue non est velit Vivamus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(491, 489, 949, 950, 4, 'com_content.article.341', 'Et Aliquam pretium faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(492, 489, 951, 952, 4, 'com_content.article.342', 'Orci rutrum lacus feugiat', ''),
(493, 489, 953, 954, 4, 'com_content.article.343', 'Cum habitasse molestie rhoncus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(494, 489, 955, 956, 4, 'com_content.article.344', 'Malesuada consectetuer hendrerit', ''),
(495, 489, 957, 958, 4, 'com_content.article.345', 'Ut nunc fames dui quis', ''),
(496, 489, 959, 960, 4, 'com_content.article.346', 'Phasellus molestie quis', ''),
(497, 489, 961, 962, 4, 'com_content.article.347', 'Nulla vel in Nam id Phasellus', ''),
(498, 8, 965, 1076, 2, 'com_content.category.126', 'World', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(499, 498, 966, 985, 3, 'com_content.category.127', 'Europe', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(500, 499, 967, 968, 4, 'com_content.article.348', 'UAE\'s Aabar to Build Trucks in Algeria ', ''),
(501, 499, 969, 970, 4, 'com_content.article.349', 'Anheuser Refreshes Bud Light Ads', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(502, 499, 971, 972, 4, 'com_content.article.350', 'U.K. Taxpayers Face Less of a Bill', ''),
(503, 499, 973, 974, 4, 'com_content.article.351', 'Friends Agrees to Resolution Takeover ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(504, 499, 975, 976, 4, 'com_content.article.352', 'Augue et montes montes ut', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(505, 499, 977, 978, 4, 'com_content.article.353', 'Ornare nisl nibh leo a nulla', ''),
(506, 499, 979, 980, 4, 'com_content.article.354', 'Congue eget tempus lacus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(507, 499, 981, 982, 4, 'com_content.article.355', 'Lobortis Nunc hac quis', ''),
(508, 499, 983, 984, 4, 'com_content.article.356', 'Consequat id Nam augue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(509, 498, 986, 1003, 3, 'com_content.category.128', 'U.S. Politics', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(510, 509, 987, 988, 4, 'com_content.article.357', 'Lawmakers Urged to Raise Debt Limit ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(511, 509, 989, 990, 4, 'com_content.article.358', 'Clinton Addresses War Crimes in Congo ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(512, 509, 991, 992, 4, 'com_content.article.359', 'U.S., Mexico, Canada Vow Cooperation ', ''),
(513, 509, 993, 994, 4, 'com_content.article.360', 'Obama and the Practice of Medicine ', ''),
(514, 509, 995, 996, 4, 'com_content.article.361', 'In Maecenas quis ligula', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(515, 509, 997, 998, 4, 'com_content.article.362', 'Pellentesque odio dapibus', ''),
(516, 509, 999, 1000, 4, 'com_content.article.363', 'Ante semper sapien lorem', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(517, 509, 1001, 1002, 4, 'com_content.article.364', 'Senectus Aliquam orci In sed', ''),
(518, 498, 1004, 1021, 3, 'com_content.category.129', 'Middle East', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(519, 518, 1005, 1006, 4, 'com_content.article.365', 'Attacks kill at least 42 in Iraq on Shiite religious holiday', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(520, 518, 1007, 1008, 4, 'com_content.article.366', 'Ex-homeless woman leaves $150,000 to Hebrew University', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(521, 518, 1009, 1010, 4, 'com_content.article.367', 'Al Qaeda blamed for Iraq violence wave', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(522, 518, 1011, 1012, 4, 'com_content.article.368', 'Hac Morbi ac leo at felis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(523, 518, 1013, 1014, 4, 'com_content.article.369', 'Tincidunt cursus quam ', ''),
(524, 518, 1015, 1016, 4, 'com_content.article.370', 'Et Nunc mus sem Nunc Cras', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(525, 518, 1017, 1018, 4, 'com_content.article.371', 'Sed et elit condimentum', ''),
(526, 518, 1019, 1020, 4, 'com_content.article.372', 'Elit risus In justo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(527, 498, 1022, 1039, 3, 'com_content.category.130', 'Africa', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(528, 527, 1023, 1024, 4, 'com_content.article.373', 'Protests as Sudan \'tight pants\' trial delayed', ''),
(529, 527, 1025, 1026, 4, 'com_content.article.374', 'Hillary Clinton: We\'re committed to Africa\'s future', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(530, 527, 1027, 1028, 4, 'com_content.article.375', 'Zimbabwe\'s writers connected to their country', ''),
(531, 527, 1029, 1030, 4, 'com_content.article.376', 'Nunc egestas ut tempus', ''),
(532, 527, 1031, 1032, 4, 'com_content.article.377', 'Aenean at vel interdum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(533, 527, 1033, 1034, 4, 'com_content.article.378', 'Aenean Donec gravida hendrerit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(534, 527, 1035, 1036, 4, 'com_content.article.379', 'Nam cursus odio et quis convallis', ''),
(535, 527, 1037, 1038, 4, 'com_content.article.380', 'Felis tempor felis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(536, 498, 1040, 1057, 3, 'com_content.category.131', 'Science', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(537, 536, 1041, 1042, 4, 'com_content.article.381', 'Dolor ut id enim dolor auctor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(538, 536, 1043, 1044, 4, 'com_content.article.382', 'Tellus laoreet pretium non auctor tincidunt', ''),
(539, 536, 1045, 1046, 4, 'com_content.article.383', 'Lacinia Sed convallis urna lacus interdum', ''),
(540, 536, 1047, 1048, 4, 'com_content.article.384', 'Metus felis faucibus sem', ''),
(541, 536, 1049, 1050, 4, 'com_content.article.385', 'Porttitor ut vitae pretium ut', ''),
(542, 536, 1051, 1052, 4, 'com_content.article.386', 'Nam leo consectetuer velit mauris', ''),
(543, 536, 1053, 1054, 4, 'com_content.article.387', 'A eget Vivamus Quisque senectus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(544, 536, 1055, 1056, 4, 'com_content.article.388', 'Tellus convallis et Nam enim', ''),
(545, 498, 1058, 1075, 3, 'com_content.category.132', 'Pacific', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(546, 545, 1059, 1060, 4, 'com_content.article.389', 'Nibh volutpat tortor augue convallis', ''),
(547, 545, 1061, 1062, 4, 'com_content.article.390', 'Semper accumsan Integer nisl Pellentesque', ''),
(548, 545, 1063, 1064, 4, 'com_content.article.391', 'Aenean Vestibulum lorem egestas', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(549, 545, 1065, 1066, 4, 'com_content.article.392', 'TIME', ''),
(550, 545, 1067, 1068, 4, 'com_content.article.393', 'Rhoncus Donec Curabitur in', ''),
(551, 545, 1069, 1070, 4, 'com_content.article.394', 'Enim sodales ligula Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(552, 545, 1071, 1072, 4, 'com_content.article.395', 'Convallis eget justo justo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(553, 545, 1073, 1074, 4, 'com_content.article.396', 'Vestibulum quam nec magna', ''),
(554, 8, 1077, 1186, 2, 'com_content.category.133', 'Technology', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(555, 554, 1078, 1095, 3, 'com_content.category.134', 'Personal Tech', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(556, 555, 1079, 1080, 4, 'com_content.article.397', 'Nibh volutpat tortor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(557, 555, 1081, 1082, 4, 'com_content.article.398', 'Praesent Aenean Phasellus', ''),
(558, 555, 1083, 1084, 4, 'com_content.article.399', 'An Apple for Your Teacher', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(559, 555, 1085, 1086, 4, 'com_content.article.400', 'Urna dis dictumst tempor', ''),
(560, 555, 1087, 1088, 4, 'com_content.article.401', 'Vestibulum tincidunt Vivamus et aliquam', ''),
(561, 555, 1089, 1090, 4, 'com_content.article.402', 'Magna elit tempus neque Phasellus', ''),
(562, 555, 1091, 1092, 4, 'com_content.article.403', 'Hac fames nunc et magna tempor gravida', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(563, 555, 1093, 1094, 4, 'com_content.article.404', 'Tempus pretium ullamcorper eget', ''),
(564, 554, 1096, 1113, 3, 'com_content.category.135', 'Business Tech', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(565, 564, 1097, 1098, 4, 'com_content.article.405', 'Semper accumsan Integer', ''),
(566, 564, 1099, 1100, 4, 'com_content.article.406', 'Nullam et nascetur vel', ''),
(567, 564, 1101, 1102, 4, 'com_content.article.407', 'Sony, Stung by Losses, Delays Thin TV', ''),
(568, 564, 1103, 1104, 4, 'com_content.article.408', 'Pellentesque In id metus', ''),
(569, 564, 1105, 1106, 4, 'com_content.article.409', 'Morbi faucibus et', ''),
(570, 564, 1107, 1108, 4, 'com_content.article.410', 'Nunc lacus quis dui adipiscing', ''),
(571, 564, 1109, 1110, 4, 'com_content.article.411', 'Interdum sagittis velit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(572, 564, 1111, 1112, 4, 'com_content.article.412', 'Magna convallis egestas', ''),
(573, 554, 1114, 1131, 3, 'com_content.category.136', 'Space', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(574, 573, 1115, 1116, 4, 'com_content.article.413', 'Adipiscing leo quis wisi justo dui', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(575, 573, 1117, 1118, 4, 'com_content.article.414', 'Curabitur convallis laoreet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(576, 573, 1119, 1120, 4, 'com_content.article.415', 'Telescopes to show universe soon after Big Bang', ''),
(577, 573, 1121, 1122, 4, 'com_content.article.416', 'Vivamus et aliquam Phasellus fames', ''),
(578, 573, 1123, 1124, 4, 'com_content.article.417', 'In et et justo Donec amet velit sem cursus velit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(579, 573, 1125, 1126, 4, 'com_content.article.418', 'Augue nunc at neque vitae metus vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(580, 573, 1127, 1128, 4, 'com_content.article.419', 'At laoreet eu lacus non Curabitur leo dui ut nibh', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(581, 573, 1129, 1130, 4, 'com_content.article.420', 'Morbi nibh Vestibulum venenatis nunc', ''),
(582, 554, 1132, 1149, 3, 'com_content.category.137', 'Science', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(583, 582, 1133, 1134, 4, 'com_content.article.421', 'Urna id in nibh sodales', ''),
(584, 582, 1135, 1136, 4, 'com_content.article.422', 'Vivamus arcu lorem sem urna', ''),
(585, 582, 1137, 1138, 4, 'com_content.article.423', 'Hac Morbi ac leo at felis at convallis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(586, 582, 1139, 1140, 4, 'com_content.article.424', 'Aliquet eu lacinia vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(587, 582, 1141, 1142, 4, 'com_content.article.425', 'Lorem pede at quis Nulla', ''),
(588, 582, 1143, 1144, 4, 'com_content.article.426', 'In Curabitur id risus sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(589, 582, 1145, 1146, 4, 'com_content.article.427', 'Porttitor ipsum dolor fermentum', ''),
(590, 582, 1147, 1148, 4, 'com_content.article.428', 'Vel arcu in Curabitur est at', ''),
(591, 554, 1150, 1167, 3, 'com_content.category.138', 'Green Tech', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(592, 591, 1151, 1152, 4, 'com_content.article.429', 'Pellentesque nec orci molestie', ''),
(593, 591, 1153, 1154, 4, 'com_content.article.430', 'Nam auctor suscipit interdum laoreet', ''),
(594, 591, 1155, 1156, 4, 'com_content.article.431', 'Ligula Nunc lacus quis dui adipiscing', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(595, 591, 1157, 1158, 4, 'com_content.article.432', 'Morbi nibh Vestibulum venenatis nunc libero', ''),
(596, 591, 1159, 1160, 4, 'com_content.article.433', 'Vivamus et aliquam Phasellus fames', ''),
(597, 591, 1161, 1162, 4, 'com_content.article.434', 'Proin feugiat id enim nibh nulla auctor', ''),
(598, 591, 1163, 1164, 4, 'com_content.article.435', 'Eget consequat hendrerit tempus porttitor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(599, 591, 1165, 1166, 4, 'com_content.article.436', 'Curabitur urna Suspendisse nibh laoreet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(600, 554, 1168, 1185, 3, 'com_content.category.139', 'Security', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(601, 600, 1169, 1170, 4, 'com_content.article.437', 'Ut fames Duis nibh arcu', ''),
(602, 600, 1171, 1172, 4, 'com_content.article.438', 'Semper accumsan Integer nisl Pellentesque', ''),
(603, 600, 1173, 1174, 4, 'com_content.article.439', 'Vestibulum sodales quis sed lorem quis Curabitur eros', ''),
(604, 600, 1175, 1176, 4, 'com_content.article.440', 'At Pellentesque id quis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(605, 600, 1177, 1178, 4, 'com_content.article.441', 'Integer justo lorem sagittis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(606, 600, 1179, 1180, 4, 'com_content.article.442', 'Neque justo laoreet', ''),
(607, 600, 1181, 1182, 4, 'com_content.article.443', 'Sed dolor condimentum', ''),
(608, 600, 1183, 1184, 4, 'com_content.article.444', 'Quisque leo non malesuada', ''),
(609, 3, 11, 12, 2, 'com_banners.category.140', 'Text Ads', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(610, 3, 13, 14, 2, 'com_banners.category.141', 'Fashion', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(611, 3, 15, 16, 2, 'com_banners.category.142', 'Sport ', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(612, 34, 114, 115, 3, 'com_content.article.445', '10 Things you MUST know about Teline III ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(617, 1, 1308, 1309, 1, 'com_jaextmanager', 'com_jaextmanager', '{}'),
(614, 39, 300, 301, 3, 'com_content.article.446', 'Content + Right laylout', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(615, 39, 302, 303, 3, 'com_content.article.447', '3 Columns', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(616, 39, 304, 305, 3, 'com_content.article.448', 'Full width', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(618, 1, 1310, 1311, 1, 'com_finder', 'com_finder', '{"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(619, 1, 1312, 1313, 1, '#__ucm_content.1', '#__ucm_content.1', '[]'),
(620, 1, 1314, 1315, 1, '#__ucm_content.2', '#__ucm_content.2', '[]'),
(621, 1, 1316, 1317, 1, '#__ucm_content.3', '#__ucm_content.3', '[]'),
(622, 1, 1318, 1319, 1, '#__ucm_content.4', '#__ucm_content.4', '[]'),
(623, 1, 1320, 1321, 1, '#__ucm_content.5', '#__ucm_content.5', '[]'),
(624, 1, 1322, 1323, 1, '#__ucm_content.6', '#__ucm_content.6', '[]'),
(625, 1, 1324, 1325, 1, '#__ucm_content.7', '#__ucm_content.7', '[]'),
(626, 1, 1326, 1327, 1, '#__ucm_content.8', '#__ucm_content.8', '[]');

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE `#__associations` (
  `id` int(11) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned DEFAULT NULL,
  `params` text,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`) VALUES
(1, 0, 0, 0, 267, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 42, '2009-10-18 16:07:09', 0, '0000-00-00 00:00:00', 0, '*', 1),
(9, 34, 1, 133, 134, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:52:03', 42, '2010-07-12 16:09:07', 0, '*', 1),
(10, 35, 1, 131, 132, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:52:16', 0, '0000-00-00 00:00:00', 0, '*', 1),
(11, 36, 1, 127, 128, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:00', 0, '0000-00-00 00:00:00', 0, '*', 1),
(12, 37, 1, 63, 64, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:28', 0, '0000-00-00 00:00:00', 0, '*', 1),
(13, 38, 1, 59, 60, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:59', 0, '0000-00-00 00:00:00', 0, '*', 1);

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__content_types`;
CREATE TABLE `#__content_types` (
  `type_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_title` varchar(255) NOT NULL DEFAULT '',
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `table` varchar(255) NOT NULL DEFAULT '',
  `rules` text NOT NULL,
  `field_mappings` text NOT NULL,
  `router` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`type_id`),
  KEY `idx_alias` (`type_alias`)
) ENGINE=InnoDB ;

INSERT INTO `#__content_types` (`type_id`, `type_title`, `type_alias`, `table`, `rules`, `field_mappings`, `router`) VALUES
(1, 'Article', 'com_content.article', '{"special":{"dbtable":"#__content","key":"id","type":"Content","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"introtext", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"attribs", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"asset_id"}], "special": [{"fulltext":"fulltext"}]}', 'ContentHelperRoute::getArticleRoute'),
(2, 'Weblink', 'com_weblinks.weblink', '{"special":{"dbtable":"#__weblinks","key":"id","type":"Weblink","prefix":"WeblinksTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}], "special": []}', 'WeblinksHelperRoute::getWeblinkRoute'),
(3, 'Contact', 'com_contact.contact', '{"special":{"dbtable":"#__contact_details","key":"id","type":"Contact","prefix":"ContactTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"address", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"image", "core_urls":"webpage", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}], "special": [{"con_position":"con_position","suburb":"suburb","state":"state","country":"country","postcode":"postcode","telephone":"telephone","fax":"fax","misc":"misc","email_to":"email_to","default_con":"default_con","user_id":"user_id","mobile":"mobile","sortname1":"sortname1","sortname2":"sortname2","sortname3":"sortname3"}]}', 'ContactHelperRoute::getContactRoute'),
(4, 'Newsfeed', 'com_newsfeeds.newsfeed', '{"special":{"dbtable":"#__newsfeeds","key":"id","type":"Newsfeed","prefix":"NewsfeedsTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"link", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}], "special": [{"numarticles":"numarticles","cache_time":"cache_time","rtl":"rtl"}]}', 'NewsfeedsHelperRoute::getNewsfeedRoute'),
(5, 'User', 'com_users.user', '{"special":{"dbtable":"#__users","key":"id","type":"User","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"name","core_state":"null","core_alias":"username","core_created_time":"registerdate","core_modified_time":"lastvisitDate","core_body":"null", "core_hits":"null","core_publish_up":"null","core_publish_down":"null","access":"null", "core_params":"params", "core_featured":"null", "core_metadata":"null", "core_language":"null", "core_images":"null", "core_urls":"null", "core_version":"null", "core_ordering":"null", "core_metakey":"null", "core_metadesc":"null", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}], "special": [{}]}', 'UsersHelperRoute::getUserRoute'),
(6, 'Article Category', 'com_content.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'ContentHelperRoute::getCategoryRoute'),
(7, 'Contact Category', 'com_contact.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'ContactHelperRoute::getCategoryRoute'),
(8, 'Newsfeeds Category', 'com_newsfeeds.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'NewsfeedsHelperRoute::getCategoryRoute'),
(9, 'Weblinks Category', 'com_weblinks.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'WeblinksHelperRoute::getCategoryRoute'),
(10, 'Tag', 'com_tags.tag', '{"special":{"dbtable":"#__tags","key":"tag_id","type":"Tag","prefix":"TagsTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path"}]}', 'TagsHelperRoute::getTagRoute');

DROP TABLE IF EXISTS `#__contentitem_tag_map`;
CREATE TABLE `#__contentitem_tag_map` (
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `core_content_id` int(10) unsigned NOT NULL COMMENT 'PK from the core content table',
  `content_item_id` int(11) NOT NULL COMMENT 'PK from the content type table',
  `tag_id` int(10) unsigned NOT NULL COMMENT 'PK from the tag table',
  `tag_date` timestamp NOT NULL COMMENT 'Date of most recent save for this tag-item',
  `type_id` mediumint(8) NOT NULL COMMENT 'PK from the content_type table',
  UNIQUE KEY `uc_ItemnameTagid` (`type_id`,`content_item_id`,`tag_id`),
  KEY `idx_tag_type` (`tag_id`,`type_id`),
  KEY `idx_date_id` (`tag_date`,`tag_id`),
  KEY `idx_tag` (`tag_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_core_content_id` (`core_content_id`)
) ENGINE=InnoDB COMMENT='Maps items from content tables to tags';

DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned DEFAULT NULL,
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MAILTO_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_BANNERS_XML_DESCRIPTION","group":""}', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{"name":"com_checkin","type":"component","creationDate":"Unknown","author":"Joomla! Project","copyright":"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTACT_XML_DESCRIPTION","group":""}', '{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","allow_vcard_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_category_crumb":"0","metakey":"","metadesc":"","robots":"","author":"","rights":"","xreference":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{"name":"com_languages","type":"component","creationDate":"2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MEDIA_XML_DESCRIPTION","group":""}', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html","enable_flash":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_word_count":"0","show_headings":"1","show_name":"1","show_articles":"0","show_link":"1","show_description":"1","show_description_image":"1","display_num":"","show_pagination_limit":"1","show_pagination":"1","show_pagination_results":"1","show_cat_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 1, '{"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_SEARCH_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}', '{"template_positions_display":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{"name":"com_weblinks","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_WEBLINKS_XML_DESCRIPTION","group":""}', '{"show_comp_description":"1","comp_description":"","show_link_hits":"1","show_link_description":"1","show_other_cats":"0","show_headings":"0","show_numbers":"0","show_report":"1","count_clicks":"1","target":"0","link_icons":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTENT_XML_DESCRIPTION","group":""}', '{"article_layout":"_:default","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"1","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"1","readmore_limit":"100","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","category_layout":"_:blog","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","filters":{"1":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"NONE","filter_tags":"","filter_attributes":""},"2":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}', '{"filters":{"1":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"6":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"7":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"},"2":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"3":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"4":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"5":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"8":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_USERS_XML_DESCRIPTION","group":""}', '{"allowUserRegistration":"1","new_usertype":"2","useractivation":"1","frontend_userparams":"1","mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, '{"name":"PHPMailer","type":"library","creationDate":"2001","author":"PHPMailer","copyright":"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2013, Jim Jagielski. All Rights Reserved.","authorEmail":"jimjag@gmail.com","authorUrl":"https:\\/\\/github.com\\/PHPMailer\\/PHPMailer","version":"5.2.6","description":"LIB_PHPMAILER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{"name":"SimplePie","type":"library","creationDate":"2004","author":"SimplePie","copyright":"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon","authorEmail":"","authorUrl":"http:\\/\\/simplepie.org\\/","version":"1.2","description":"LIB_SIMPLEPIE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '{"name":"phputf8","type":"library","creationDate":"2006","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"hfuecks@gmail.com","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"0.5","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Platform', 'library', 'joomla', '', 0, 1, 1, 1, '{"name":"Joomla! Platform","type":"library","creationDate":"2008","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"12.2","description":"LIB_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 1, '{"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters.\\n\\t\\tAll rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 1, '{"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 1, '{"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 1, '{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 1, '{"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RELATED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 1, '{"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{"name":"mod_weblinks","type":"module","creationDate":"July 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 1, '{"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 1, '{"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATUS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TITLE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":""}', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LDAP_XML_DESCRIPTION","group":""}', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '{"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":""}', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":""}', '{"style":"rounded"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 1, '{"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":""}', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 1, '{"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":""}', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 1, '{"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_VOTE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"1.0","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":""}', '{"linenumbers":"0","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_none","type":"plugin","creationDate":"August 2004","author":"Unknown","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"3.0.0","description":"PLG_NONE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2012","author":"Moxiecode Systems AB","copyright":"Moxiecode Systems AB","authorEmail":"N\\/A","authorUrl":"tinymce.moxiecode.com\\/","version":"3.5.6","description":"PLG_TINY_XML_DESCRIPTION","group":""}', '{"mode":"1","skin":"0","compressed":"0","cleanup_startup":"0","cleanup_save":"2","entity_encoding":"raw","lang_mode":"0","lang_code":"en","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","extended_elements":"","toolbar":"top","toolbar_align":"left","html_height":"550","html_width":"750","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","format_date":"%Y-%m-%d","inserttime":"1","format_time":"%H:%M:%S","colors":"1","table":"1","smilies":"1","media":"1","hr":"1","directionality":"1","fullscreen":"1","style":"1","layer":"1","xhtmlxtras":"1","visualchars":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","advimage":"1","advlink":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","safari":"0","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '{"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_READMORE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{"name":"plg_search_weblinks","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 1, '{"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_P3P_XML_DESCRIPTION","group":""}', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CACHE_XML_DESCRIPTION","group":""}', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":""}', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOG_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 1, 1, 1, '{"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEF_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 11, 0),
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 1, '{"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":""}', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2009 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":""}', '{"autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 1, '{"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":""}', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"hathor@tarrconsulting.com","authorUrl":"http:\\/\\/www.tarrconsulting.com","version":"3.0.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":""}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 'English (United Kingdom)', 'language', 'en-GB', '', 0, 1, 1, 1, '{"name":"English (United Kingdom)","type":"language","creationDate":"2013-03-07","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.2","description":"en-GB site language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 'English (United Kingdom)', 'language', 'en-GB', '', 1, 1, 1, 1, '{"name":"English (United Kingdom)","type":"language","creationDate":"2013-03-07","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.2","description":"en-GB administrator language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{"name":"files_joomla","type":"file","creationDate":"July 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.4","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10014, 'ja_teline_iii', 'template', 'ja_teline_iii', '', 0, 1, 1, 0, '{"name":"ja_teline_iii","type":"template","creationDate":"Sep 2012","author":"JoomlArt.com","copyright":"JoomlArt Design Team","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.2","description":"<p>JA Teline III has been updated for use with Joomla 2.5!<\\/p>\\n\\n<p>All time hit, best selling News template in the JA Teline Series of templates. If you find yourself confused about this template, please refer to userguide and install quickstart in your localhost for reference. It can be intimidating for new users.<\\/p>\\n\\n<p><strong>Resources :<\\/strong><\\/p>\\n<p>| \\n<a href=\'http:\\/\\/www.joomlart.com\\/joomla\\/templates\\/ja-teline-iii-v2\' title=\'Home\' target=\'_blank\' > Template Home Page<\\/a> | \\n<a href=\'http:\\/\\/www.joomlart.com\\/demo\\/#joomla25-templates.joomlart.com\\/ja_teline_iii\' title=\'Demo\' target=\'_blank\' > Demo<\\/a> | \\n<a href=\'http:\\/\\/www.joomlart.com\\/forums\\/forumdisplay.php?244\' title=\'forum\' target=\'_blank\' >Forum<\\/a> | <\\/p>\\n<p>|\\n<a href=\'http:\\/\\/wiki.joomlart.com\\/wiki\\/JA_T3_Framework_2\\/Overview\' title=\'T3 wiki\' target=\'_blank\' >T3 Framework Wiki<\\/a> | \\n<a href=\'http:\\/\\/update.joomlart.com\' title=\'Updates\' target=\'_blank\' >Updates<\\/a> | \\n<a href=\'http:\\/\\/pm.joomlart.com\\/browse\\/JATCTELINEIIIJ16\' title=\'Changelog\' target=\'_blank\' >JIRA<\\/a> | \\n<a href=\'http:\\/\\/www.joomlart.com\\/forums\\/downloads.php?do=cat&id=369\' title=\'Downloads\' target=\'_blank\' >Downloads<\\/a> | \\n<\\/p>","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10001, 'JA T3 Framework', 'plugin', 'jat3', 'system', 0, 1, 1, 0, '{"name":"JA T3 Framework","type":"plugin","creationDate":"24 Jul 2013","author":"www.JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.6.6","description":"\\n\\t\\n\\t\\t<h1>T3 Framework - JoomlArt Template Framework for Joomla 2.5 and Joomla 3.0<\\/h1>\\n\\t\\t<div style=\'font-weight: normal\'>\\n\\t\\t<p><span style=\'color: #ff6600;\'>\\n\\t\\t<strong>Features:<\\/strong><\\/span>\\n\\t\\tThis plugin is required for JA T3 Framework based templates to work.<\\/p>\\n\\t\\t\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Usage Instruction:<\\/span><\\/strong><br \\/>\\n\\t\\t<ul>\\n\\t\\t<li>Enable the JA T3 plugin in Plugin manager<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Upgrade Method:<\\/span><br \\/><\\/strong>\\n\\t\\t<ul>\\n\\t\\t  <li>You can install new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t  <li>Follow upgrade instructions and backup site \\/ plugin before upgrading<\\/li>\\n\\t\\t  <\\/ul>\\n\\t\\n\\t\\t<span style=\'color: #008000;\'><strong>Links:<\\/strong><\\/span><br \\/>\\n\\t\\t<ul>\\n\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/wiki.joomlart.com\\/wiki\\/JA_T3_Framework_2\\/Overview\\">Wiki Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/forumdisplay.php?241\'>JA T3 Framework Forum<\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t\\n\\t\\t","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 12, 0),
(10002, 'JA News Featured', 'module', 'mod_janews_featured', '', 0, 1, 0, 0, '{"name":"JA News Featured","type":"module","creationDate":"May 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t \\n\\t\\t<div style=\'text-align: left;\'>\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA News Featured Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA News Featured Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_newsfp_mod.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tJA News Featured provides you a lightweight but powerful news headline style of your most recent contents. Please refer to the template userguide for optimum backend settings\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Important Instruction:<\\/strong><\\/span><\\/p>\\n\\t \\t<ol><li>Please refer to Template userguide or install the template Quickstart to view the optimum settings for this module.<\\/li>\\n\\t\\t<li>The module display can be enhanced by CSS overrides in the demo templates. Thus when using this module in different templates, the results may vary and you may have to customize CSS again to get your desired effects.<\\/li>\\n\\t\\t<li>For Userguide, please visit <a href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?t=52039\' target=\'_blank\'>Here<\\/a><\\/li><\\/ol>\\n\\t \\t\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li><li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li><\\/ol>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul> <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51825\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li><\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","catsid":"","featured":"hide","ordering":"ordering","sort_order":"DESC","settingprofile":"","profile":"default","JPlugins":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10003, 'JA Bulletin', 'module', 'mod_jabulletin', '', 0, 1, 0, 0, '{"name":"JA Bulletin","type":"module","creationDate":"May 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t\\n\\t\\t<div style=\'text-align: left;\'>\\n\\t   <span style=\\"color: #008000;\\">\\n\\t   \\t<strong>JA Bulletin Module<\\/strong>\\n\\t   <\\/span>\\n\\t   <br \\/>\\n\\t   <div style=\'font-weight: normal\'>\\n\\t   <p><img alt=\\"JA Bulletin Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/ja_bulletin.png\\" \\/><\\/p>\\n\\t   This module mimicks default Joomla most read and latest modules, with added support to show date and thumbnail images.\\n\\t   \\n\\t   <p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t   <ol><li>Show \\/ hide Images in the list<\\/li><li>Show or hide Date of the article.<\\/li><li>Easy thumbnail generation. For more details on Thumbnail mode read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a>.<\\/li><\\/ol>\\n\\t   \\n\\t   <p><strong><span style=\\"color: #ff0000;\\">Important Instruction:<\\/span><\\/strong><\\/p>\\n\\t   <ol><li><strong>The module display can be enhanced by CSS overrides in the demo templates (used in over 20+ JA templates). Thus, when you used Bulletin in different templates, the results may vary and you may have to customize CSS to get desired effects.<\\/strong><\\/li><\\/ol>\\n\\t   <p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t   <ol>\\n\\t   <li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t   \\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video.<\\/a><\\/strong><\\/li>\\n\\t   <\\/ol>\\n\\t   <p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t   <ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?49878\\">JA Bulletin - General User guide<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/pm.joomlart.com\\/browse\\/JAECMODBULLETINJIVI\\">Report Bug<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/update.joomlart.com\\/#products.list\\/\\/JA%20Bulletin%20Module%20for%20Joomla%202.5\\/\\">Updates &amp; Versions<\\/a><\\/li><\\/ul>\\n\\t   <p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t   <\\/div>\\n\\t   <\\/div>\\n\\t\\n\\t","group":""}', '{"moduleclass_sfx":"","content_setting":"","type":"latest","category":"","count":"5","show_featured":"1","show_date":"1","image_setting":"","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"40","height":"40","cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10004, 'JA News Ticker', 'module', 'mod_janewsticker', '', 0, 1, 0, 0, '{"name":"JA News Ticker","type":"module","creationDate":"15 July 2013","author":"Joomlart.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.6","description":"\\n\\t \\n\\t <div align=\\"left\\">\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA Newsticker Module for Joomla! 2.5 and Joomla! 3.x<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA Newsticker Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_janews.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tDisplay latest articles with cool animation effects as News Ticker, select categories to include, length of titles, sorting or even control buttons. Decent way to scroll out your latest information in limited space...\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>The module supports a lot of animations display<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ul>\\n\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t\\t\\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul>\\n\\t\\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51825\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","using_mode":"","rss_link":"","category":"","sort_order_field":"created","sort_order":"DESC","max_items":"10","title_max_chars":"200","settingdisplay":"","animation_type":"horizontal","animation_speed":"500","animation_interval":"3000","animation_transition":"Fx.Transitions.linear","show_headtext":"1","headtext":"Headlines:","show_buttons_control":"0","enable_cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10005, 'JA Twitter Module', 'module', 'mod_jatwitter', '', 0, 1, 0, 0, '{"name":"JA Twitter Module","type":"module","creationDate":"Jun 2013","author":"Joomlart.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.7","description":"\\n\\t\\n\\t<div align=\\"left\\">\\n\\t\\t<h1><img border=\'0\' alt=\'JA Twitter Module\' src=\'http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/drupal\\/jdec_twitter.png?javer=1110040930\' style=\'float: left\'\\/>JA Twitter Module for Joomla! 2.5<\\/h1>\\n\\t\\t<div style=\\"font-weight:normal\\">\\n\\t\\tThis module provides API integration with the Twitter microblogging service to drive more traffic to your site. Tweets from your Twitter account and Friends are displayed neatly.\\n\\t\\t<br\\/><br\\/><br\\/><br\\/>\\n\\t\\t\\n\\t\\t<p style=\\"border:1px solid #F29A3C; padding: 10px 15px; background:#F7E6D4;\\">\\n\\t\\t<strong><span style=\'color: #ff0000;\'>NOTE: update OAuth information to get new version worked!<\\/span><\\/strong><br \\/><br \\/>\\n\\t\\tSince 2013-06-11, Twitter has stopped supporting API v1 and fully moved to API v1.1<br \\/>In API v1.1, Twitter deny non-Authorized request, that means you need to provide the information below to authorize your request.<br \\/>\\n\\t\\t<a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50154-Joomla-1.6-JA-Twitter-Module-Installation-Guide\\">Check how to get OAuth information now<\\/a>\\n\\t\\t<\\/p>\\n\\t\\t\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Usage Ideas:<\\/span><br \\/><\\/strong>\\n\\t\\t<ol>\\n\\t\\t  <li>Easily configure Twitter account, show or hide Friends list, account infomation, and Twitter updates.<\\/li>\\n\\t\\t  <li>Show Twitter account infomation.<\\/li>\\n\\t\\t  <li>Show Twitter friends list.<\\/li>\\n\\t\\t  <li>Display Twitter updates.<\\/li>\\n\\t\\t<\\/ol>\\n\\t\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Upgrade Methods:<\\/span><\\/strong><br\\/>\\n\\t\\t<ol>\\n\\t\\t  <li>You can install new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t  <li>Backup any customized files (i.e. CSS files) before upgrading.<\\/li>\\n\\t\\t<\\/ol>\\n\\t\\n\\t\\t<span style=\'color: #008000;\'><strong>Links:<\\/strong><\\/span><br\\/>\\n\\t\\t<ul>\\n\\t\\t  <li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50154-Joomla-1.6-JA-Twitter-Module-Installation-Guide\\">General Userguide<\\/a><\\/li>\\n\\t\\t  <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/#products.list\\/\\/JA%20Twitter%20Module%20for%20Joomla%202.5\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2013 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t\\n\\t","group":""}', '{"moduleclass_sfx":"","content_setting":"","taccount":"JoomlartDemo","use_display_taccount":"0","size_iconaccount":"48","settingcontent":"","show_tweet":"1","show_limit":"5","show_icon":"1","icon_size":"30","show_username":"1","show_source":"1","showtextheading":"1","headingtext":"My Twitter Updates","friend_setting":"","use_friends":"0","size_iconfriend":"24","max_friends":"10","settingfollowbutton":"","showfollowlink":"1","typefollowbutton":"apiconnect","style_of_follow_button":"follow_me-a.png","apikey":"","enable_cache":"1","cache_time":"5"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10007, 'Content - JA Bookmark', 'plugin', 'jabookmark', 'content', 0, 1, 1, 0, '{"name":"Content - JA Bookmark","type":"plugin","creationDate":"07 June 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t<span style=\\"color: #008000;\\"><strong>JA Bookmark Plugin for Joomla 2.5 and Joomla 3.x<\\/strong><\\/span><br \\/><p><img alt=\\"JA Bookmark Logo\\" src=\\"http:\\/\\/joomlart.s3.amazonaws.com\\/images\\/mis\\/JA_Bookmark_logo.jpg\\" \\/><\\/p><p>JA Bookmark Plugin for Joomla! 2.5. Help your visitors to promote your site and allows visitors to bookmark your pages easily with many popular services.<\\/p>\\n\\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t\\t<li>Allows the integration of <a target=\\"_blank\\" href=\\"http:\\/\\/www.addthis.com\\/\\">Addthis<\\/a> and <a target=\\"_blank\\" href=\\"http:\\/\\/www.disqus.com\\/\\">AddToAny<\\/a> online Bookmark Services. <\\/li>\\n\\t\\t<li>Easy to use. Install and configure.<\\/li>\\n\\t\\t<li>Option to enable JA Bookmark Plugin for all. \\n\\t\\tEnable for limited categories or individual articles OR disable for individual articles too.<\\/li>\\n\\t<\\/ul>\\n\\t<strong><span>Links:<\\/span><\\/strong><br \\/>\\n\\t<ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51733\\">JA Bookmark  - General Userguide<\\/a><\\/li>\\n\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/update.joomlart.com\\/\\">Updates &amp; Versions<\\/a><\\/li><\\/ul>\\n\\t   <p>Copyright 2004 - 2013 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\n\\t","group":""}', '{"system":"addthis","system-addthis-brand_name":"joomlart.com","system-addthis-account":"joomlart","system-addthis-language_code":"en","system-addthis-custom_apps":"","system-addthis-button":"lg-share","system-addtoany-language":"en-US","system-addtoany-button":"share_save_106_16.gif","system-addtoany-showpagetitle":"1","system-addtoany-orientation":"automatic","mode":"auto","mode-auto-category":[""],"location":"onContentAfterDisplay","used_custom_button":"0","custom_button":"","class_sfx":"","widget_text":"","header_color":"47AA0E","system-addthis-header_background":"999999","system-addthis-vertical_offset":"","system-addthis-horizontal_offset":"","system-addtoany-maincolor":"D7E5ED","system-addtoany-border":"414C53","system-addtoany-linktext":"333333","system-addtoany-linktext_hover":"333333","system-addtoany-background":"FFFFFF"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10009, 'System - JA Popup', 'plugin', 'japopup', 'system', 0, 1, 1, 0, '{"name":"System - JA Popup","type":"plugin","creationDate":"Jul 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.6.0","description":"\\n\\t\\t\\n\\t\\t<div style=\\"text-align:left;\\">\\n\\t\\t\\t<h1>JA Popup Plugin for Joomla! 2.5<\\/h1>\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>JA Popup plugin supports many types of content to display using Framework like AJAX, iFrame, Youtube video, image, slideshow, Inline.<\\/strong><\\/span>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t\\t<img border=\\"0\\" alt=\\"JA Popup plugin\\" src=\\"http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec-popup_plg.png\\">Depending on each type of Popup that you select, you declare JA Popup tab in your content (i.e. module, article) to <code>{japopup type=\\"<span style=\\"color:#FF0000\\">iframe<\\/span>\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\" }Load a sample iFrame{\\/japopup}<\\/code>\\n\\t\\t\\t\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Usage Instructions:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<ol>   \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>ajax<\\/strong>: <em>loading external page or HTML content via AJAX method <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"ajax\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\"}Load an Url using AJAX{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li> \\n\\t\\t\\t\\t\\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>iFrame<\\/strong>: <em>loading external page or HTML content via iFrame method  <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"iframe\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\"}Load a sample iFrame{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>youtube<\\/strong>: <em>loading Youtube video. Note: use embeded link <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"youtube\\" content=\\"http:\\/\\/www.youtube.com\\/v\\/cdphzxz64BY?hl=en&fs=1\\" width=\\"640\\" height=\\"380\\" title=\\"Political Roast: Obama Emanuel 2005\\"}Political Roast: Obama Emanuel 2005{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>image<\\/strong>:<em> loading a specified image <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"image\\" content=\\"images\\/sampledata\\/fruitshop\\/apple.jpg\\" width=\\"400\\" height=\\"300\\" title=\\"Sample image\\"}Sample image{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>slideshow<\\/strong>:<em> loading a group of images via a slideshow<\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"slideshow\\" content=\\"images\\/sampledata\\/fruitshop\\/apple.jpg,images\\/sampledata\\/fruitshop\\/bananas_2.jpg\\" width=\\"400\\" height=\\"300\\" title=\\"Sample image\\"} Sample image {\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>  \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>Inline<\\/strong>:<em> To display full HTML content in the expander<\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/>\\n\\t\\t\\t\\t\\t\\t<code>\\n\\t\\t\\t\\t\\t\\t\\t{japopup type=\\"inline\\" content=\\"inline1\\" width=\\"500\\" height=\\"400\\" }Inline{\\/japopup}\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t<\\/code>\\n\\t\\t\\t\\t\\t<br \\/>\\n\\t\\t\\t\\t\\t<strong>inline1<\\/strong>:<em> The ID of block content<\\/em><br>\\t\\n\\t\\t\\t\\t<\\/li> \\n\\t\\t\\t<\\/ol> \\n\\t\\t\\t<p>The best showcase of JA Popup is used in JA Teline III.<\\/p> \\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t\\t<ol>\\n\\t\\t\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading.<\\/li>\\t\\t\\n\\t\\t\\t\\t<\\/ol>\\n\\t\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t\\t<ul>\\t\\t\\n\\t\\t\\t\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51150\\">General Userguide<\\/a><\\/li>\\n\\t\\t\\t\\t\\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t\\t\\t<\\/ul>\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p> \\n\\t\\t<\\/div>\\n\\t\\t\\n\\t","group":""}', '{"group1":"fancybox","group1-fancybox-centerOnScroll":"1","group1-fancybox-image_scale":"1","group1-fancybox-speed_in":"500","group1-fancybox-speed_out":"500","group1-greybox-behavior":"","group1-highslide-outline":"drop-shadow","group1-highslide-speed_in":"250","group1-highslide-speed_out":"250","group1-shadowbox-animateFade":"1","group1-shadowbox-animate":"1","group1-shadowbox-animSequence":"wh","group1-shadowbox-overlayColor":"FFFFFF","group1-shadowbox-viewportPadding":"20","group1-multibox-contentColor":"FFFFFF","group1-multibox-showControls":"1","width":"600","height":"400","overlay":"1","overlay_opacity":"0.7","add_title":"1","add_desc":"1","image_slideshow":"one"}', '', '', 42, '2013-07-30 07:44:21', 5, 0),
(10010, 'Content - JA Thumbnail', 'plugin', 'plg_jathumbnail', 'content', 0, 1, 1, 0, '{"name":"Content - JA Thumbnail","type":"plugin","creationDate":"March 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t\\n\\t<h1>JA Thumbnail Plugin for Joomla! 2.5<\\/h1>\\n\\tThis plugin helps to generate thumbnails automatically in Joomla Articles. This must be properly configured to get the best usage. Below are some important notes.\\n\\t<p><span style=\'color: #ff6600;\'><strong>Details:<\\/strong><\\/span><\\/p>\\n\\t<img border=\'0\' alt=\'JA Thumbnail Plugin\' src=\'http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_highslide.png?javer=1109130907\' style=\'float: left\'>\\n\\tThe Manual mode is recommended for sites with only a few images, the Auto mode is for sites with a massive volume of images\\n\\t<p><strong><span style=\'color: #ff0000;\'>Important Instructions :<\\/span><\\/strong><\\/p>\\n\\tNote: Add the following to disable the slideshow feature in the selected images in an article <code>{jathumbnail off images=\\"images\\/stories\\/demo\\/world\\/rs-3.jpg,images\\/stories\\/demo\\/world\\/rs-2.jpg\\"}<\\/code>\\n\\t<p><strong><span style=\'color: #ff0000;\'>Usage Instruction:<\\/span><br \\/><\\/strong><\\/p>\\n\\tIn the <strong>\\"Integration Mode\\"<\\/strong>  on the parameter list on the right: <br \\/>\\n\\t\\t<ul>\\n\\t\\t\\t<li>\\"<strong>Auto<\\/strong>\\" mode: JA Thumbnail Plugin is enabled automatically in all Joomla articles. To turn off this feature for specific articles, use the <font color=\\"red\\"><strong><em>{jathumbnail off}<\\/em><\\/strong><\\/font>tag in that article.<\\/li>   \\n\\t\\t\\t<li>\\"<strong>Manual<\\/strong>\\" mode: To enable JA thumbnail plugin for an article, you must place {jathumbnail} somewhere in your articles content.<\\/li>   \\n\\t\\t\\t<li> \\"<strong>Disable<\\/strong>\\" mode: Disable the Thumbnail generation (DO NOT use the Disable feature of Joomla if you have used the tag <em><strong>{jathumbnail}<\\/strong><\\/em> or <em><strong>{jathumbnail off}<\\/strong><\\/em> already. It will be parsed as normal text.<\\/li> \\n\\t\\t<\\/ul>\\n\\t<p><strong><span style=\'color: #ff0000;\'>Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install the new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t<li>Backup any customized files before upgrading.<\\/li><\\/ol>\\n\\t<p><span style=\'color: #008000;\'><strong>Links :<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50783\\">General Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\n\\t","group":""}', '{"content_mode":"auto","content_mode-auto-content_position":"0","content_mode-auto-manual-content_width":"200","content_mode-auto-manual-content_height":"200","content_mode-auto-manual-crop_image":"1","content_mode-auto-manual-content_align":"left","view_on_page":"all","blog_mode-1-apply_catetories":["14","19","20","21","22","64","65","66","67","75","23","69","70","68","71","24","25","26","27","28","72","73","29","30","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"blog_mode-1-blog_leading_width":"300","blog_mode-1-blog_leading_height":"300","blog_mode-1-blog_intro_width":"100","blog_mode-1-blog_intro_height":"100","blog_mode-1-crop_image":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10012, 'JA News Pro Module', 'module', 'mod_janewspro', '', 0, 1, 0, 0, '{"name":"JA News Pro Module","type":"module","creationDate":"25 May 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.7","description":"\\n\\t \\n\\t\\t<div style=\'text-align: left;\'>\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA News Pro Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA News Pro Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_newsfp_mod.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tJA NEWS PRO Module comes with rich backend and advanced features for easy configuration. \\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Important Instructions:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>Please refer to Template userguide or install the template Quickstart to view the optimum settings for this module.<\\/li>\\n\\t\\t\\t<li>The module display can be enhanced by CSS overrides in the demo templates. Thus, when you use this module in different templates, the results may vary and you may have to customize CSS to get your desired effects.<\\/li>\\n\\t\\t<\\/ul>\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Usage Instruction:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>JA News Pro module configure easily with K2 component and Joomla Content<\\/li>\\n\\t\\t\\t<li>JA News Pro module support 4 themes and allow user config content in the front end which is displayed in module (User Setting Tool).<\\/li>\\n\\t\\t\\t<li>JA News Pro module is best used with JA Teline IV template.<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ul>\\n\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t\\t\\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul> <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51887\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li><\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","catsid":"","groupbysubcat":"0","maxSubCats":"-1","featured":"hide","ordering":"ordering","sort_order":"DESC","settingprofile":"","profile":"default","JPlugins":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10013, 'System - JA Tabs', 'plugin', 'jatabs', 'system', 0, 1, 1, 0, '{"name":"System - JA Tabs","type":"plugin","creationDate":"04 May 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.6.0","description":"\\n\\t\\t\\n\\t\\t<div style=\\"text-align:left\\">\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>JA Tabs Plugin for Joomla! 2.5<\\/strong><\\/span>\\n\\t\\t\\t<div style=\\"font-weight: normal\\">\\n\\t\\t\\t<p><strong><img src=\'..\\/plugins\\/system\\/jatabs\\/jatabs\\/tabs.png\' \\/>\\n\\t\\t\\t<span style=\'margin-top:10px;\'>JA Tabs plugin is a plugin which helps you to create tabs in any positions in Joomla contents<\\/span><\\/strong><\\/p>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<ol class=\\"checklist\\" style=\'clear:both\'>\\n\\t\\t\\t<li>Support multiple types of content: Module Position, Module name, HTML Content, Article IDs, Category ID<\\/li>\\n\\t\\t\\t<li>Configurable animations: Left\\/right, up\\/down, fading...<\\/li>\\n\\t\\t\\t<li>Multiple themes support<\\/li>\\n\\t\\t\\t<li>Extensive configuration options<\\/li>\\n\\t\\t\\t<\\/ol>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Usage Instructions:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>General Parameter Options:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<h3 style=\\"color: blue\\">All available parameter options for JA Tabs Plugin.<\\/h3>\\n\\t\\t\\t<div  style=\\"font-weight: normal\\">\\n\\t\\t\\t<ol>\\n\\t\\t\\t<li><strong>type:<\\/strong> <br \\/> (modules, module, content, articles). JA Tabs type.<\\/li>\\n\\t\\t\\t<li><strong>position:<\\/strong> <br \\/> (top, left, right, bottom). Position of the tabs. Default value is top.<\\/li>\\n\\t\\t\\t<li><strong>style:<\\/strong><br \\/> JA Tabs styling (basic). The default setting is basic. <\\/li>\\n\\t\\t\\t<li><strong>width:<\\/strong><br \\/> Width of the tabs. It can be fixed or automatic. Example: empty or \'100%\' or \'600\'<\\/li>\\n\\t\\t\\t<li><strong>height:<\\/strong><br \\/> Height of the tabs. It can be fixed or automatic. Example: empty or \'auto\' or \'400\'.<\\/li>\\n\\t\\t\\t<li><strong>widthTabs:<\\/strong><br \\/> Width of the tabs. It should be \'empty\' for the \'Top\\/Bottom\' position of tabs title and fixed (such as \'150\') for the \'Left\\/Right\' position of tabs title.<\\/li>\\n\\t\\t\\t<li><strong>heightTabs:<\\/strong><br \\/> Height of the tabs. It should be \'empty\' for \'Left\\/Right\' position of tabs title and fixed (such as \'30\') for \'Top\\/Bottom\' position of tabs title.<\\/li>\\n\\t\\t\\t<li><strong>duration (ms):<\\/strong><br \\/> Time interval of effect transition (in milliseconds). The default setting is 1000. <\\/li>\\n\\t\\t\\t<li><strong>animType:<\\/strong><br \\/> (animFade, animMoveHor, animMoveVir, none). Define type of effect transition. The default setting is animMoveVir.<\\/li>\\n\\t\\t\\t<li><strong>mouseType:<\\/strong><br \\/> (click, mouseover, none). Action behavior of Control Panel. Default value is click. <\\/li>\\n\\t\\t\\t<li><strong>skipAnim:<\\/strong> <br \\/> (true, false). Skip animation. The default setting is false.<\\/li>\\n\\t\\t\\t<li><strong>ajax:<\\/strong> <br \\/> (true, false). Set to \\"True\\" if you want to use AJAX to load content in tabs (Does not apply for HTML Content type). The default setting is False.<\\/li>\\n\\t\\t\\t<li><strong>view:<\\/strong> <br \\/> (introtext, fulltext). Apply for Articles.<\\/li>\\n\\t\\t\\t<li><strong>jaclass:<\\/strong> <br \\/> Input the class for each tab in format: 1:class1,2:class2. The supported class depend on the tab style.<\\/li>\\n\\t\\t\\t<li><strong>module:<\\/strong> <br \\/> Apply for type=\\"modules\\". Input module position which will display in tabs. For example: articleslatestload<\\/li>\\n\\t\\t\\t<li><strong>modulename:<\\/strong> <br \\/> Apply for type=\\"module\\". Input one or more module names which are separated by commas. For example: mod_articles_news, mod_articles_latest<\\/li>\\n\\t\\t\\t<li><strong>ids:<\\/strong> <br \\/> Apply for type=\\"articles\\". Input one or more article IDs which are separated by commas. For example: 1, 2, 3, 4<\\/li>\\n\\t\\t\\t<li><strong>catid:<\\/strong> <br \\/> Apply for type=\\"articles\\". Input one catergory from which you want to display its articles in tabs. For example: 1<\\/li>\\n\\t\\t\\t<li><strong>maxitems:<\\/strong> <br \\/> Maximum number of articles to display<\\/li>\\n\\t\\t\\t<\\/div>\\t\\t\\t\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>For Example tags:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<div  style=\\"font-weight: normal\\">\\n\\t\\t\\t<b>1. Type = modules<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"modules\\" module=\\"position-7\\" position=\\"top\\" \\n\\t\\t\\t\\tmouseType=\\"click\\" animType=\\"animFade\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<b>2. Type = module<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"module\\" modulename=\\"mod_menu, mod_login\\" \\n\\t\\t\\tposition=\\"left\\" widthTabs=\\"150\\" animType=\\"animMoveVir\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\n\\t\\t\\t<b>3. Type = content<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs  type=\\"content\\" position=\\"top\\" height=\\"240\\" mouseType=\\"mouseover\\" \\n\\t\\t\\t\\tanimType=\\"animMoveHor\\"}\\n\\t\\t\\t  [tab title=\\"Entertainment\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/apple.jpg\\" \\n\\t\\t\\t    alt=\\"Sample image\\" align=\\"left\\" class=\\"caption\\" \\/&gt;...\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t  [tab title=\\"Travel\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/bananas_2.jpg\\" \\/&gt;\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t  [tab title=\\"Artist\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/tamarind.jpg\\" \\/&gt;\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<b>4. Type = articles<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"articles\\" ids=\\"25, 26, 27\\" ajax=true view=\\"introtext\\" position=\\"right\\" \\n\\t\\t\\t\\twidthTabs=150 width=530 animType=\\"animMoveVir\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\n\\t\\t\\t<b>5. Type = articles<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"articles\\" catid=\\"55\\" view=\\"introtext\\" ajax=true position=\\"bottom\\"\\n\\t\\t\\t\\tanimType=\\"animMoveHor\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<ol>\\n\\t\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading.<\\/li>\\t\\t\\n\\t\\t\\t<\\/ol>\\n\\t\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links :<\\/strong><\\/span><\\/p>\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t<ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50267\\">General Userguide<\\/a><\\/li>\\n\\t\\t \\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><\\/ul>\\t\\t\\t\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p> \\n\\t\\t<\\/div>\\n\\t\\t\\n\\t","group":""}', '{"disable_tab":"0","style":"default","position":"top","width":"100%","height":"auto","widthTabs":"100%","heightTabs":"30","duration":"1000","animType":"animMoveVir","skipAnim":"false","mouseType":"click","view":"introtext","colors":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10031, 'Content - JA Disqus Debate Echo', 'plugin', 'jadisqus_debate_echo', 'content', 0, 1, 1, 0, '{"name":"Content - JA Disqus Debate Echo","type":"plugin","creationDate":"14 June 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.8","description":"\\n\\t\\n\\t<div style=\\"font-weight: normal;text-align:left;\\">\\n\\t<span style=\\"color: #008000;\\"><strong>JA Disqus Debate Echo Plugin for Joomla 2.5 and Joomla 3.0<\\/strong><\\/span><br \\/><p><img alt=\\"JA Disqus Debate Echo Plugin\\" src=\\"http:\\/\\/joomlart.s3.amazonaws.com\\/images\\/mis\\/logo-JA-Disqus-Debate-Echo-Plugin.jpg\\" \\/><\\/p><p>JA Disqus Debate Echo plugin allows you to integrate popular external commenting systems into your Joomla! articles.<\\/p>\\n\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t\\t<li>Allows integration of <a target=\\"_blank\\" href=\\"http:\\/\\/www.intensedebate.com\\/\\">IntenseDebate<\\/a>, <a target=\\"_blank\\" href=\\"http:\\/\\/www.disqus.com\\/\\">Disqus<\\/a>. <\\/li>\\n\\t\\t<li>Easy to use. Install, configure and multiple options.<\\/li>\\n\\t\\t<li>Option to enable it for all, enable for limited categories or individual articles OR disable for individual articles too.<\\/li>\\n\\t<\\/ul>\\n\\t<strong><span style=\\"color: #ff0000;\\">Links:<\\/span><br \\/><\\/strong> \\n\\t<ul>\\n\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51776\\">General Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t<\\/ul>\\n\\t<p>Copyright 2004 - 2013 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t<\\/div>\\n\\t\\n\\t","group":""}', '{"mode":"automatic","source":"com_content","mode-automatic-catsid":["77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"mode-automatic-k2catsid":[""],"provider":"disqus","provider-intensdebate-account":"","provider-disqus-subdomain":"joomlart","provider-disqus-devmode":"1","provider-jskit-domain":"","display_comment_count":"1","display_on_list":"1","display_on_home":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10034, 'com_jaextmanager', 'component', 'com_jaextmanager', '', 1, 1, 0, 0, '{"name":"com_jaextmanager","type":"component","creationDate":"May 2013","author":"JoomlArt","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.7","description":"JA Extension Manager Component","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10017, 'com_finder', 'component', 'com_finder', '', 1, 1, 1, 0, '{"name":"com_finder","type":"component","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_FINDER_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_description":"1","description_length":255,"allow_empty_query":"0","show_url":"1","show_autosuggest":"0","show_advanced":"1","show_advanced_tips":"0","expand_advanced":"0","show_date_filters":"0","sort_order":"relevance","sort_direction":"desc","highlight_terms":"1","opensearch_name":"","opensearch_description":"","batch_size":"50","memory_table_limit":30000,"title_multiplier":"1.7","text_multiplier":"0.7","meta_multiplier":"1.2","path_multiplier":"2.0","misc_multiplier":"0.3","stem":"1","stemmer":"snowball","enable_logging":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10018, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 1, 0, '{"name":"mod_finder","type":"module","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FINDER_XML_DESCRIPTION","group":""}', '{"searchfilter":"","show_autosuggest":"1","show_advanced":"0","moduleclass_sfx":"","field_size":"25","show_label":"1","label_pos":"top","show_button":"0","button_pos":"right","opensearch":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10019, 'mod_version', 'module', 'mod_version', '', 1, 1, 1, 0, '{"name":"mod_version","type":"module","creationDate":"January 2012","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_VERSION_XML_DESCRIPTION","group":""}', '{"format":"short","product":"1","cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10020, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 1, 1, 0, '{"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":""}', '{"public_key":"","private_key":"","theme":"clean"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10021, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 0, 1, 0, '{"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10022, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_categories","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CATEGORIES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(10023, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_contacts","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTACTS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10024, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_content","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTENT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10025, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_newsfeeds","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10026, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_weblinks","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_WEBLINKS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10027, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 0, '{"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10028, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 0, '{"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10029, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '{"name":"plg_system_highlight","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10030, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10032, 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', 1, 1, 1, 0, '{"name":"com_joomlaupdate","type":"component","creationDate":"February 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10035, 'beez3', 'template', 'beez3', '', 0, 1, 1, 0, '{"name":"beez3","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"3.1.0","description":"TPL_BEEZ3_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature","backgroundcolor":"#eee"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10036, 'protostar', 'template', 'protostar', '', 0, 1, 1, 0, '{"name":"protostar","type":"template","creationDate":"4\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_PROTOSTAR_XML_DESCRIPTION","group":""}', '{"templateColor":"#08C","templateBackgroundColor":"#F4F6F7","logoFile":"","sitetitle":"","sitedescription":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10037, 'isis', 'template', 'isis', '', 1, 1, 1, 0, '{"name":"isis","type":"template","creationDate":"3\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_ISIS_XML_DESCRIPTION","group":""}', '{"templateColor":"#13294A","headerColor":"#184A7D","logoFile":"","admin_menus":"1","displayHeader":"1","statusFixed":"1","stickyToolbar":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10038, 'mod_stats_admin', 'module', 'mod_stats_admin', '', 1, 1, 1, 0, '{"name":"mod_stats_admin","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '{"serverinfo":"0","siteinfo":"0","counter":"0","increase":"0","cache":"1","cache_time":"900","cachemode":"static"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(29, 'com_tags', 'component', 'com_tags', '', 1, 1, 1, 1, '{"name":"com_tags","type":"component","creationDate":"December 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"COM_TAGS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(316, 'mod_tags_popular', 'module', 'mod_tags_popular', '', 0, 1, 1, 0, '{"name":"mod_tags_popular","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_POPULAR_XML_DESCRIPTION","group":""}', '{"maximum":"5","timeframe":"alltime","owncache":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(317, 'mod_tags_similar', 'module', 'mod_tags_similar', '', 0, 1, 1, 0, '{"name":"mod_tags_similar","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_SIMILAR_XML_DESCRIPTION","group":""}', '{"maximum":"5","matchtype":"any","owncache":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(447, 'plg_finder_tags', 'plugin', 'tags', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_tags","type":"plugin","creationDate":"February 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_TAGS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

DROP TABLE IF EXISTS `#__finder_filters`;
CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links`;
CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms0`;
CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms1`;
CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms2`;
CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms3`;
CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms4`;
CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms5`;
CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms6`;
CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms7`;
CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms8`;
CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms9`;
CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsa`;
CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsb`;
CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsc`;
CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsd`;
CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termse`;
CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsf`;
CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_taxonomy`;
CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_taxonomy_map`;
CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_terms`;
CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  `language` char(3) NOT NULL DEFAULT '',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_terms_common`;
CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_tokens`;
CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `language` char(3) NOT NULL DEFAULT '',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY;

DROP TABLE IF EXISTS `#__finder_tokens_aggregate`;
CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  `language` char(3) NOT NULL DEFAULT '',
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY;

DROP TABLE IF EXISTS `#__finder_types`;
CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__jaem_log`;
CREATE TABLE `#__jaem_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ext_id` varchar(50) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `check_date` datetime DEFAULT NULL,
  `check_info` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ext_id` (`ext_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__jaem_services`;
CREATE TABLE `#__jaem_services` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ws_name` varchar(255) NOT NULL,
  `ws_mode` varchar(50) NOT NULL DEFAULT 'local',
  `ws_uri` varchar(255) NOT NULL,
  `ws_user` varchar(100) NOT NULL,
  `ws_pass` varchar(100) NOT NULL,
  `ws_default` tinyint(1) NOT NULL DEFAULT '0',
  `ws_core` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__jaem_services` (`id`, `ws_name`, `ws_mode`, `ws_uri`, `ws_user`, `ws_pass`, `ws_default`, `ws_core`) VALUES
(1, 'Local Service', 'local', '', '', '', 1, 1),
(2, 'JoomlArt Updates', 'remote', 'http://update.joomlart.com/service/', '', '', 0, 1);

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM ;

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 0, 0),
(3, 'xx-XX', 'xx (Test)', 'xx (Test)', 'xx', 'br', '', '', '', '', -2, 0, 0);

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) binary NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned DEFAULT NULL,
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 19, 28, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 29, 34, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 35, 40, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 43, 48, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 59, 60, 0, '*', 1),
(17, 'menu', 'com_search', 'Search', '', 'Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 49, 50, 0, '*', 1),
(570, 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 41, 42, 0, '*', 1),
(23, 'main', 'com_tags', 'Tags', '', 'Tags', 'index.php?option=com_tags', 'component', 0, 1, 1, 29, 0, '0000-00-00 00:00:00', 0, 1, 'class:tags', 0, '', 45, 46, 0, '', 1),
(18, 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 53, 58, 0, '*', 1),
(569, 'main', 'COM_FINDER', 'com-finder', '', 'com-finder', 'index.php?option=com_finder', 'component', 0, 1, 1, 10017, 0, '0000-00-00 00:00:00', 0, 1, 'class:finder', 0, NULL, 301, 302, 0, '', 1),
(583, 'main', 'COM_JAEXTMANAGER', 'com-jaextmanager', '', 'com-jaextmanager', 'index.php?option=com_jaextmanager', 'component', 0, 1, 1, 10034, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_jaextmanager/assets/images/jauc.png', 0, NULL, 503, 504, 0, '', 1),
(581, 'main', 'com_joomlaupdate', 'com-joomlaupdate', '', 'com-joomlaupdate', 'index.php?option=com_joomlaupdate', 'component', 0, 1, 1, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, NULL, 323, 324, 0, '', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 20, 21, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 22, 23, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 24, 25, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 26, 27, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 32, 33, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 30, 31, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 36, 37, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 38, 39, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 46, 47, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 44, 45, 0, '*', 1),
(20, 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 56, 57, 0, '*', 1),
(19, 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 54, 55, 0, '*', 1);
INSERT IGNORE INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 283, 0, '*', 0),
(101, 'mainmenu', 'Home', 'home', '', 'home', 'index.php?option=com_content&view=featured', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","orderby_pri":"","orderby_sec":"front","order_date":"","multi_column_order":"1","show_pagination":"2","show_pagination_results":"1","show_noauth":"","article-allow_ratings":"","article-allow_comments":"","show_feed_link":"1","feed_summary":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 39, 40, 1, '*', 0);

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(2, 'usermenu', 'User Menu', 'A Menu for logged in Users'),
(3, 'top', 'Top', 'Links for major types of users'),
(4, 'aboutjoomla', 'About Joomla', 'All about Joomla!'),
(5, 'parks', 'Australian Parks', 'Main menu for a site about Australian  parks'),
(6, 'mainmenu', 'Main Menu', 'Simple Home Menu'),
(7, 'fruitshop', 'Fruit Shop', 'Menu for the sample shop site.'),
(8, 'topmenu', 'Top Menu', 'Top level navigation'),
(9, 'othermenu', 'Resources', 'Additional links'),
(10, 'ExamplePages', 'Example Pages', 'Example Pages'),
(11, 'keyconcepts', 'Key Concepts', 'This describes some critical information for new Users.'),
(12, 'magazine', 'magazine', ''),
(13, 'topmega', 'topmega', 'topmega');

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned DEFAULT NULL,
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(1, 'Main Menu', '', '', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","base":"","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(2, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(4, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(6, 'Unread Messages', '', '', 1, 'header', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_unread', 3, 1, '', 1, '*'),
(8, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '', 1, '*'),
(12, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(16, 'member', '', '', 1, 'mega-item ', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 0, '{"pretext":"","posttext":"","login":"491","logout":"491","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(17, 'Breadcrumbs', '', '', 1, 'position-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_breadcrumbs', 1, 1, '{"moduleclass_sfx":"","showHome":"1","homeText":"Home","showComponent":"1","separator":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(18, 'Banners', '', '', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_banners', 1, 1, '{"target":"1","count":"1","cid":"1","catid":["27"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(19, 'User Menu', '', '', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 2, 1, '{"menutype":"usermenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(20, 'Top', '', '', 1, 'footnav', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"top","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(22, 'Australian Parks ', '', '', 2, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"parks","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, 'en-GB'),
(23, 'About Joomla!', '', '', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","base":"","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"0","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(68, 'About Parks', '', '<p>The Parks sample site is designed as a simple site that can be routinely updated from the front end of Joomla!.</p><p>As a site, it is largely focused on a blog which can be updated using the front end article submission.</p><p>New weblinks can also be added through the front end.</p><p>A simple image gallery uses com_content with thumbnails displayed in a blog layout and full size images shown in article layout.</p><p>The Parks site features the language switch module. All of the content and modules are tagged as English (en-GB). If a second language pack is added with sample data this can be filtered using the language switch.</p><p>Parks uses HTML5 which is a major web standard (along with XHTML which is used in other areas of sample data).</p>', 2, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(67, 'Extensions', '', '', 2, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"6","showAllChildren":"0","tag_id":"","class_sfx":"-menu","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(25, 'Site Map', '', '', 1, 'sitemapload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 0, '{"menutype":"mainmenu","startLevel":"2","endLevel":"3","showAllChildren":"1","tag_id":"","class_sfx":"sitemap","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(26, 'This Site', '', '', 5, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"_menu","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(27, 'Archived Articles', '', '', 1, 'archiveload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_archive', 1, 1, '{"count":"10","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(28, 'Latest News', '', '', 1, 'articleslatestload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_latest', 1, 1, '{"catid":["19"],"count":"5","ordering":"c_dsc","user_id":"0","show_featured":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(29, 'Articles Most Read', '', '', 1, 'articlespopularload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_popular', 1, 1, '{"show_front":"1","count":"5","catid":["26","29"],"layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(30, 'Feed Display', '', '', 1, 'feeddisplayload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_feed', 1, 1, '{"rssurl":"http:\\/\\/community.joomla.org\\/blogs\\/community.feed?type=rss","rssrtl":"0","rsstitle":"1","rssdesc":"1","rssimage":"1","rssitems":"3","rssitemdesc":"1","word_count":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(31, 'News Flash: Latest', '', '', 1, 'newsflashload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_news', 1, 1, '{"catid":["20"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"1","count":"1","ordering":"a.publish_up","layout":"horizontal","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(32, 'News Flash: Random', '', '', 1, 'newsflashload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_news', 1, 1, '{"catid":["19"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"0","count":"1","ordering":"rand()","layout":"vertical","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(33, 'Random Image', '', '', 1, 'randomimageload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_random_image', 1, 1, '{"type":"jpg","folder":"images\\/sampledata\\/parks\\/animals","link":"","width":"180","height":"","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(34, 'Articles Related Items', '', '', 1, 'relateditemsload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_related_items', 1, 1, '{"showDate":"0","layout":"","moduleclass_sfx":"","owncache":"1"}', 0, '*'),
(35, 'Search', '', '', 1, 'searchload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_search', 1, 1, '{"width":"20","text":"","button":"","button_pos":"right","imagebutton":"","button_text":"","set_itemid":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(36, 'Statistics', '', '', 1, 'statisticsload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_stats', 1, 1, '{"serverinfo":"1","siteinfo":"1","counter":"1","increase":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(37, 'Syndicate Feeds', '', '', 1, 'syndicateload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_syndicate', 1, 1, '{"text":"Feed Entries","format":"rss","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(38, 'Users Latest', '', '', 1, 'userslatestload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_users_latest', 1, 1, '{"shownumber":"5","linknames":"0","linktowhat":"0","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"static"}', 0, '*'),
(39, 'Who\'s Online', '', '', 3, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_whosonline', 1, 1, '{"showmode":"2","linknames":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(40, 'Wrapper', '', '', 1, 'wrapperload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_wrapper', 1, 1, '{"url":"http:\\/\\/fsf.org","add":"1","scrolling":"auto","width":"100%","height":"200","height_auto":"1","target":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(41, 'Footer', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_footer', 1, 0, '{"layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(44, 'Login', '', '', 1, 'loginload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"280","logout":"280","greeting":"1","name":"0","usesecure":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(45, 'Menu', '', '', 1, 'menuload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(47, 'Latest Park Blogs', '', '', 6, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_latest', 1, 1, '{"count":"5","ordering":"c_dsc","user_id":"0","show_front":"1","catid":"35","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, 'en-GB'),
(48, 'Custom HTML', '', '<p>This is a custom html module. That means you can enter whatever content you want.</p>', 1, 'customload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(49, 'Weblinks', '', '', 1, 'weblinksload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_weblinks', 1, 1, '{"catid":"32","count":"5","ordering":"title","direction":"asc","target":"3","description":"0","hits":"0","count_clicks":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(52, 'Breadcrumbs', '', '', 1, 'breadcrumbs ', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHere":"1","showHome":"1","homeText":"Home","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(61, 'Articles Categories', '', '', 1, 'articlescategoriesload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_categories', 1, 1, '{"parent":"29","show_description":"0","show_children":"0","maxlevel":"0","count":"0","layout":"","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(56, 'Advertisement', '', '', 1, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 1, '{"target":"1","count":"4","cid":"0","catid":["140"],"tag_search":"0","ordering":"0","header_text":"Featured Links:","footer_text":"<a href=\\"http:\\/\\/www.joomla.org\\">Ads by Joomla!<\\/a>","layout":"_:default","moduleclass_sfx":"_text","cache":"0","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(57, 'Fruit Shop', '', '', 3, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"fruitshop","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(58, 'Special!', '', '<h1>This week we have a special, half price on delicious oranges!</h1><div>Only for our special customers!</div><div>Use the code: Joomla! when ordering</div><p><em>This module can only be seen by people in the customers group or higher.</em></p>', 1, 'position-12', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 4, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(62, 'Language Switcher', '', '', 3, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(63, 'Search', '', '', 1, 'search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 0, '{"label":"","width":"20","text":"","button":"","button_pos":"right","imagebutton":"1","button_text":"","set_itemid":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(64, 'Language Switcher', '', '', 1, 'languageswitcherload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(65, 'About Fruit Shop', '', '<p>The Fruit Shop site shows a number of Joomla! features.</p><p>The template uses classes in cascading style sheets to change the layout of items, such as creating the horizontal alphabetical list in the Fruit Encyclopedia.</p><p> </p>', 1, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(69, 'Articles Category', '', '', 1, 'articlescategoryload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_category', 1, 1, '{"mode":"normal","show_on_article_page":"1","show_front":"show","count":"0","category_filtering_type":"1","catid":["72"],"show_child_category_articles":"0","levels":"1","author_filtering_type":"1","created_by":[""],"author_alias_filtering_type":"1","created_by_alias":[""],"excluded_articles":"","date_filtering":"off","date_field":"a.created","start_date_range":"","end_date_range":"","relative_date":"30","article_ordering":"a.title","article_ordering_direction":"ASC","article_grouping":"none","article_grouping_direction":"ksort","month_year_format":"F Y","item_heading":"4","show_date":"0","show_date_field":"created","show_date_format":"Y-m-d H:i:s","show_category":"0","show_hits":"0","show_author":"0","show_introtext":"0","introtext_limit":"100","layout":"","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(70, 'Search (Atomic Template)', '', '', 1, 'atomic-search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_search', 1, 0, '{"width":"20","text":"","button":"","button_pos":"right","imagebutton":"","button_text":"","set_itemid":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(71, 'Top Menu (Atomic Template)', '', '', 1, 'atomic-topmenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 0, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(72, 'Top Quote (Atomic Template)', '', '<hr />\r\n<h2 class="alt">Powerful Content Management and a Simple Extensible Framework.</h2>\r\n<hr />', 1, 'atomic-topquote', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(73, 'Bottom Left Column (Atomic Template)', '', '<h6>This is a nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', 1, 'atomic-bottomleft', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(74, 'Bottom Middle Column (Atomic Template)', '', '<h6>This is another nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', 1, 'atomic-bottommiddle', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(75, 'Sidebar (Atomic Template)', '', '<h3>A <span class="alt">Simple</span> Sidebar</h3>\r\n<p>Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<p class="quiet">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<h5>Incremental leading</h5>\r\n<p class="incr">Vestibulum ante ipsum primis in faucibus orci luctus vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus.</p>\r\n<p class="incr">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>', 1, 'atomic-sidebar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(76, 'Login (Atomic Template)', '', '', 2, 'atomic-sidebar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_login', 1, 0, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(77, 'JA News Featured Module', '', '', 1, 'content-top', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janews_featured', 1, 0, '{"moduleclass_sfx":"","source":"JANewsHelper","catsid":["90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"k2catsid":[""],"getChildren":"1","featured":"only","ordering":"ordering","sort_order":"DESC","profile":"telineiii","JPlugins":"1","K2Plugins":"1","cache":"0","cache_time":"0"}', 0, '*'),
(78, 'Most Read', '', '', 1, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 0, '{"moduleclass_sfx":"","type":"mostread","category":[""],"count":"5","show_featured":"1","show_date":"1","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"25","height":"25","cache":"1","cache_time":"900"}', 0, '*'),
(79, 'JA News Sticker Module', '', '', 1, 'headlines', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewsticker', 1, 1, '{"moduleclass_sfx":"","using_mode":"rss","external_link":"","k2catsid":[""],"rss_link":"http:\\/\\/feeds.joomla.org\\/JoomlaAnnouncements","category":[""],"sort_order_field":"created","sort_order":"DESC","max_items":5,"title_max_chars":50,"animation_type":"opacity","animation_speed":400,"animation_interval":2500,"animation_transition":"Fx.Transitions.linear","show_headtext":"1","headtext":"Headlines:","show_buttons_control":"0","enable_cache":"0","cache_time":900}', 0, '*'),
(80, 'JA Twitter Module', '', '', 1, 'mega-item', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jatwitter', 1, 0, '{"moduleclass_sfx":"","taccount":"JoomlartDemo","use_display_taccount":"0","size_iconaccount":"32","show_tweet":"1","show_limit":"2","show_icon":"0","icon_size":"30","show_username":"0","show_source":"0","showtextheading":"0","headingtext":"My Twitter Updates","use_friends":"0","size_iconfriend":"24","max_friends":"18","showfollowlink":"1","typefollowbutton":"apiconnect","style_of_follow_button":"follow_me-a.png","apikey":"wMOXZUmWegMztLtrPB9I1Q","enable_cache":"1","cache_time":"900"}', 0, '*'),
(81, 'Welcome to Joomla!', '', '<div style="padding: 5px"><p>Congratulations on choosing Joomla! as your content management system. We hope you are able to create a successful Web site with our program and maybe you will be able to give something back to the community later.</p><p>To make your start with Joomla! as smooth as possible, we want to give you some pointers to documentation, common questions and help on securing your server. A good place to start is the &quot;<a href="http://docs.joomla.org/beginners" target="_blank">Absolute Beginners Guide to Joomla!</a>&quot;.</p><p>For your most common questions the best place to start looking for answers is the <a href="http://help.joomla.org/component/option,com_easyfaq/Itemid,268/" target="_blank">Frequently Asked Questions (FAQ)</a> area.  If you are stuck on a particular screen in the Administration area of Joomla! (which is where you are now), then try clicking on the Help toolbar button which you will find on almost all screens.  This will take you to a page about that screen on our <a href="http://help.joomla.org" target="_blank">Help Site</a>.  If you still have questions then take a look on our <a href="http://forum.joomla.org" target="_blank">forum</a> which is most likely the biggest resource on Joomla! there is and you will find almost every question answered at least once, so please try using the search function before asking your question.</p><p>Security is a big concern for us, which is why we would like you to subscribe to the <a href="http://forum.joomla.org/index.php/board,8.0.html" target="_blank">announcement forum</a> (by clicking on the Notify button) to always get the latest information on new releases for Joomla! You should also read the <a href="http://help.joomla.org/component/option,com_easyfaq/task,view/id,167/Itemid,268/" target="_blank">Joomla! Administrator\'s Security Checklist</a> and regularly check the <a href="http://forum.joomla.org/index.php/board,267.0.html" target="_blank">security forum</a>.</p><p>We hope you have much fun and success with Joomla! and hope to see you in the forum among the hundreds and thousands of contributors.</p><p>Your Joomla! team.<img alt="Smile" border="0" src="../plugins/editors/tinymce/jscripts/tiny_mce/plugins/emotions/images/smiley-smile.gif" title="Smile" /></p><p>P.S.: To remove this message, delete the &quot;Welcome to Joomla!&quot; Module in the Administrator screen of the Module Manager (on the Extensions menu).  Here is a <a href="index.php?option=com_modules&amp;client=1">quick link</a> to this screen.</p></div>', 1, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 1, '*'),
(82, 'Sport', '', '<img src="images/stories/demo/sport/sport-1.jpg" alt="Sport" />\r\n\r\nNulla tincidunt tincidunt <a href="#" title="Sport">velit tristique leo.</a>', 0, 'user9', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(83, 'Fashion', '', '<img src="images/stories/demo/style/fashion-1.jpg" alt="Fashion" />\r\n\r\nPellentesque porttitor Vestibulum Mauris', 0, 'user8', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(84, 'Art and Design', '', '<ul>\r\n<li><a target="_blank" href="#">Praesent ac libero ornare venenatis</a></li>\r\n\r\n<li><a target="_blank" href="#">Nunc auctor vel Aenean neque montes</a></li>\r\n\r\n<li><a target="_blank" href="#">Et id tortor Cras id nunc montes lobortis lacus et fringilla</a></li>\r\n\r\n<li><a target="_blank" href="#">Hendrerit semper eget convallis neque eleifend orci iaculis</a></li>\r\n\r\n<li><a target="_blank" href="#">Tortor et laoreet quis Nullam augue justo</a></li>\r\n</ul>', 0, 'user7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(85, 'MarketWatch', '', '<ul>\r\n<li><a target="_blank" href="#">Currencies: U.S. dollar, yen reverse gains in Asia</a></li>\r\n\r\n<li><a target="_blank" href="#">Amcor buys most of Rio Tinto\'s Alcan Packaging</a></li>\r\n\r\n<li><a target="_blank" href="#">Mark Hulbert: Gold, stocks are more allies than enemies</a></li>\r\n\r\n<li><a target="_blank" href="#">Stocks to Watch: Stocks in focus for Tuesday</a></li>\r\n\r\n<li><a target="_blank" href="#">Steelmakers rise in volatile Shanghai market</a></li>\r\n</ul>', 0, 'user6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(86, 'Feature news', '', '<div class="ja-innerdiv">\r\n<h4>World</h4>\r\n<img src="images/stories/demo/other/cat-1.jpg" border="0" alt="Obama" /> Ut justo id nibh pulvinar mauris pede Phasellus metus. <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Sport</h4>\r\n<img src="images/stories/demo/other/cat-2.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Food and Drink</h4>\r\n<img src="images/stories/demo/other/cat-3.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Art</h4>\r\n<img src="images/stories/demo/other/cat-4.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Entertaiment</h4>\r\n<img src="images/stories/demo/other/cat-5.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Technology</h4>\r\n<img src="images/stories/demo/other/cat-6.jpg" border="0" alt="Technology" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>', 4, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(87, 'Adv', '', '<img src="images/stories/demo/other/bmw-x5.jpg" alt="BMW-X5" />', 4, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(88, 'Discussion', '', '<div class="discussion-wrap clearfix"><div class="discussion-content">\r\n<img src="images/stories/demo/other/discussion.jpg" alt="alt" align="left" />\r\n<h4><a href="#" title="Discussion">Iran appoints new judiciary head</a></h4>\r\nAc Nunc tempor a eget et morbi Vivamus vitae nunc metus. Morbi feugiat neque tellus justo commodo hac lacinia gravida Curabitur Curabitur. Risus ut Phasellus eget Vivamus dis justo cursus semper <a class="comment" title="Comment" href="#">Comment</a>&nbsp;&nbsp;<a class="video" title="Video" href="#">Video</a>&nbsp;&nbsp;<a class="photo" title="Slideshow" href="#">Slideshow</a>\r\n\r\n</div></div>\r\n\r\n<span class="author"><strong>Author:</strong> Mr Truly</span>', 1, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(89, 'Book reviews', '', '<div class="clearfix"><img src="images/stories/demo/other/book-review.jpg" border="0" alt="The Battle for America 2008" align="left" style="margin-right: 10px; padding: 5px; border: 5px solid #CCCCCC;" />\r\n<h4>The Battle for America 2008: The Story of an Extraordinary Election</h4>\r\n<p>Fringilla justo vel pretium dui tellus wisi congue auctor. Augue Nullam amet Phasellus Ut eu sociis libero id libero est. In interdum ac nibh habitasse malesuada nibh justo at orci Maecenas. Massa sociis quis et odio massa id id Pellentesque vestibulum interdum.</p>\r\n<a class="comment" href="#" title="Comment">Discuss: Do you think about this book?</a></div>', 1, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"_hilite badge-top","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(90, 'Banner 1', '', '<a href="index.php/10-things-you-must-know-about-teline-iii" title="What\'s new in JA Teline iii?"><img src="images/stories/demo/other/what-new.jpg" alt="What\'s new in teline iii" /></a>', 5, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(91, 'Videos of the day', '', '<div class="ja-video-thumb">{japopup type="youtube" content="http://www.youtube.com/v/cdphzxz64BY" width="640" height="380" title="Political Roast : Obama Emanuel 2005"}<img src="http://img.youtube.com/vi/cdphzxz64BY/2.jpg" border="0" alt="Political Roast : Obama Emanuel 2005" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/i18_4jZbrQ4" width="640" height="380" title="Beardyman and Reggie Watts on Channel 4 Headspace"}<img src="http://img.youtube.com/vi/i18_4jZbrQ4/2.jpg" border="0" alt="Beardyman and Reggie Watts on Channel 4 Headspace" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/YgW7or1TuFk" width="640" height="380" title="A Closer Look At The iPhone"}<img src="http://img.youtube.com/vi/YgW7or1TuFk/2.jpg" border="0" alt="A Closer Look At The iPhone" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/DOvbv-LkK6w" width="640" height="380" title="Star Wars: The Old Republic E3 2009 Jedi vs. Sith Trailer [HQ]" }<img src="http://img.youtube.com/vi/DOvbv-LkK6w/2.jpg" border="0" alt="Star Wars: The Old Republic E3 2009 Jedi vs. Sith Trailer [HQ]" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/ezdfVbOqzRc" width="640" height="380" title="Bare-Knuckle Brawling : KICK ASS ! | 2009"}<img src="http://img.youtube.com/vi/ezdfVbOqzRc/2.jpg" border="0" alt="Bare-Knuckle Brawling : KICK ASS ! | 2009" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/XOZw7sBUI7s" width="640" height="380" title="Bernard the bear:The desert island"}<img src="http://img.youtube.com/vi/XOZw7sBUI7s/2.jpg" border="0" alt="Bernard the bear:The desert island" />{/japopup}</div>', 1, 'ja-tabs2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(92, 'Tech banner', '', '<p><img src="images/stories/demo/other/imgad-2.jpg" border="0" alt="iPhone 3GS" /></p>', 4, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(93, 'Tech highlight', '', '<div class="ja-innerdiv">\r\n<h4>Business Tech</h4>\r\n<img src="images/stories/demo/other/tech-1.jpg" alt="Business Tech" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Science</h4>\r\n<img src="images/stories/demo/other/tech-2.jpg" alt="Science" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Personal Tech</h4>\r\n<img src="images/stories/demo/other/tech-3.jpg" alt="Personal Tech" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Space</h4>\r\n<img src="images/stories/demo/other/tech-4.jpg" alt="Space" />\r\nDolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Green Tech</h4>\r\n<img src="images/stories/demo/other/tech-5.jpg" alt="Green Tech" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 6, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(94, 'Entertainment highlight', '', '<div class="ja-innerdiv">\r\n<h4>Television</h4>\r\n<img src="images/stories/demo/other/enter-1.jpg" alt="Television" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Movies</h4>\r\n<img src="images/stories/demo/other/enter-2.jpg" alt="Movies" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Books</h4>\r\n<img src="images/stories/demo/other/enter-3.jpg" alt="Books" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Music</h4>\r\n<img src="images/stories/demo/other/enter-4.jpg" alt="Music" />\r\nDolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Games</h4>\r\n<img src="images/stories/demo/other/enter-5.jpg" alt="Movies" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Theatre</h4>\r\n<img src="images/stories/demo/other/enter-6.jpg" alt="Television" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 7, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(95, 'Health highlight', '', '<div class="ja-innerdiv">\r\n<h4>You &amp; Your Family</h4>\r\n<img src="images/stories/demo/other/hel-1.jpg" alt="You &amp; Your Family" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>What Ails You</h4>\r\n<img src="images/stories/demo/other/hel-2.jpg" alt="What Ails You" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Diet &amp; Fitness</h4>\r\n<img src="images/stories/demo/other/hel-3.jpg" alt="Diet &amp; Fitness" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 10, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(96, 'World highlight', '', '<div class="ja-innerdiv">\r\n<h4>Africa</h4>\r\n<img src="images/stories/demo/other/wor-1.jpg" alt="Africa" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Middle East</h4>\r\n<img src="images/stories/demo/other/wor-2.jpg" alt="Middle East" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>U.S Politics</h4>\r\n<img src="images/stories/demo/other/wor-3.jpg" alt="U.S Politics" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Europe</h4>\r\n<img src="images/stories/demo/other/wor-4.jpg" alt="Europe" />\r\nDolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 5, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(97, 'Life and Style', '', '<div class="ja-innerdiv">\r\n<h4>Fashion &amp; Beauty</h4>\r\n<img src="images/stories/demo/other/life-1.jpg" border="0" alt="Fashion &amp; Beauty" /> Ut justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Food &amp; Drink</h4>\r\n<img src="images/stories/demo/other/life-2.jpg" border="0" alt="Food &amp; Drink" /> Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Wife &amp; Husband</h4>\r\n<img src="images/stories/demo/other/life-3.jpg" border="0" alt="Wife &amp; Husband" /> Non ante gravida eros quis justo sed nonummy et Donec et.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Shop</h4>\r\n<img src="images/stories/demo/other/life-4.jpg" border="0" alt="Shop" /> Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Mother &amp; Children</h4>\r\n<img src="images/stories/demo/other/life-5.jpg" border="0" alt="Mother &amp; Children" /> Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Home &amp; Gardens</h4>\r\n<img src="images/stories/demo/other/life-6.jpg" border="0" alt="Home &amp; Gardens" /> Ut justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>', 9, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(98, 'Photo gallery', '', '<div class="ja-video-thumb">\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-1.png" width="700" height="380" title="Sample image" }<img src="images/stories/demo/gallery/gl-1.png"  width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-2.png" width="700" height="380" title="Sample image" }<img src="images/stories/demo/gallery/gl-2.png" width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-3.png" width="700" height="380" title="Sample image"}<img src="images/stories/demo/gallery/gl-3.png" width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-4.jpg" width="700" height="380" title="Sample image" }<img src="images/stories/demo/gallery/gl-4.jpg"  width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-5.jpg" width="700" height="380" title="Sample image"}<img src="images/stories/demo/gallery/gl-5.jpg"  width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-6.jpg" width="700" height="380" title="Sample image"}<img src="images/stories/demo/gallery/gl-6.jpg"  width="100" alt="Sample image" />{/japopup}\r\n\r\n</div>', 2, 'ja-tabs2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(99, 'Travel highlight', '', '<div class="ja-innerdiv">\r\n<h4>Getaway</h4>\r\n<img src="images/stories/demo/other/travel-1.jpg" alt="Getaway" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Travel Tips</h4>\r\n<img src="images/stories/demo/other/travel-2.jpg" alt="Travel Tips" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Business Travel</h4>\r\n<img src="images/stories/demo/other/travel-3.jpg" alt="Business Travel" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 8, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(100, 'Bookmark pages', '', '<ul class="bookmark-links">\r\n<li><a href="http://www.facebook.com" title="www.facebook.com" target="_blank"> Facebook </a></li>\r\n<li><a href="http://www.joomlart.com" target="_blank">Joomla Templates Club - Professional - High quality Joomla template</a></li>\r\n<li><a href="http://www.magentocommerce.com" target="_blank">Magento - Home  - eCommerce Software for Growth</a></li>\r\n<li><a href="http://www.joomlancers.com" target="_blank">JoomLancers - Freelance Marketplace for Opensource Development</a></li>\r\n<li><a href="http://www.iconfinder.net/" target="_blank"><strong>Icon Finder</strong><br />Tool icons | Free icons | Search through more than 100,000 icons</a></li>\r\n</ul>', 3, 'ja-tabs2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*');
INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(101, 'Artist highlight', '', '<div class="ja-innerdiv">\r\n<h4>Photography</h4>\r\n<img src="images/stories/demo/other/artist-1.jpg" alt="Photography" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Design</h4>\r\n<img src="images/stories/demo/other/artist-2.jpg" alt="Design" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Architecture</h4>\r\n<img src="images/stories/demo/other/artist-3.jpg" alt="Architecture" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Art</h4>\r\n<img src="images/stories/demo/other/artist-4.jpg" alt="Art" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>3D Graphics</h4>\r\n<img src="images/stories/demo/other/artist-5.jpg" alt="3D Graphics" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Graphics</h4>\r\n<img src="images/stories/demo/other/artist-6.jpg" alt="Graphics" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 2, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(102, 'Sport highlight', '', '<div class="ja-innerdiv">\r\n<h4>Tennis</h4>\r\n<img src="images/stories/demo/other/sport-1.jpg" alt="Tennis" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Cricket</h4>\r\n<img src="images/stories/demo/other/sport-2.jpg" alt="Cricket" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Motosport</h4>\r\n<img src="images/stories/demo/other/sport-3.jpg" alt="Motosport" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Horse racing</h4>\r\n<img src="images/stories/demo/other/sport-4.jpg" alt="Horse racing" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Boxing</h4>\r\n<img src="images/stories/demo/other/sport-5.jpg" alt="Boxing" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Football</h4>\r\n<img src="images/stories/demo/other/sport-6.jpg" alt="Football" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 3, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(103, 'Features', '', '<div>\r\n<p style="text-align: center"><img src="images/stories/demo/other/icon_feature.png" border="0" alt="Feature" title="Feature" /> <span style="color: #cc0000; font-size: 150%">10</span> Things you <span style="color: #cc0000">MUST</span> know about Teline III</p>\r\n<h4 style="text-align: center; padding-top: 5px;"><a href="index.php?option=com_content&amp;view=article&amp;id=389&amp;Itemid=467">Find out more... </a></h4>\r\n</div>', 0, 'mega-item', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"moduleclass_sfx":""}', 0, '*'),
(104, 'Follow us', '', '<img src="images/stories/demo/other/follow.jpg" alt="Follow us" />', 0, 'user10', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(105, 'JA News Pro Module', '', '', 1, 'content-bot', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewspro', 1, 0, '{"moduleclass_sfx":"","catsid":["90","97","104","108","115","119","126","133"],"getChildren":"1","groupbysubcat":"1","maxSubCats":"3","featured":"show","ordering":"ordering","sort_order":"DESC","timerange":"","profile":"telineiii","JPlugins":"0","colors":"90:green\\r\\n108:pink\\r\\n104:deepblue\\r\\n119:cyan\\r\\n5:green\\r\\n9:pink\\r\\n115:lime\\r\\n133:orange\\r\\n126:red","jacache":"0","jacache_time":"900"}', 0, '*'),
(106, 'Banner right 1', '', '', 2, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 0, '{"target":"1","count":"5","cid":"0","catid":["141"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(107, 'JA Tabs', '', '<div>{jatabs type="modules" animType="animNone" style="teline_iii" position="top" widthTabs="auto" heightTabs="auto" width="auto" height="auto" mouseType="click" duration="1000" colors="10" module="ja-tabs" }{/jatabs}</div>', 4, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"_tabs","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(108, 'Latest News', '', '', 1, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 0, '{"moduleclass_sfx":"","type":"latest","category":["","90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"count":"5","show_featured":"0","show_date":"1","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"25","height":"25","cache":"0","cache_time":"30"}', 0, '*'),
(109, 'JA Tabs 2', '', '<div>{jatabs type="modules" animType="animNone" style="teline_iii" position="top" widthTabs="120" heightTabs="auto" width="100%" height="auto" mouseType="click" duration="1000" colors="10" module="ja-tabs2" }{/jatabs}</div>', 3, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"_tabs","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(110, 'JA News Pro Mobile', '', '', 1, 'ja-news-mobile', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewspro', 1, 0, '{"moduleclass_sfx":"","catsid":["90","97","104","108","115","119","126"],"getChildren":"1","groupbysubcat":"1","maxSubCats":"3","featured":"show","ordering":"ordering","sort_order":"DESC","timerange":"","profile":"mobile","JPlugins":"1","colors":"90:green\\r\\n108:pink\\r\\n104:deepblue\\r\\n119:cyan\\r\\n5:green\\r\\n9:pink\\r\\n115:lime\\r\\n133:orange\\r\\n126:red","jacache":"0","jacache_time":"900"}', 0, '*'),
(111, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(112, 'Joomla Version', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_version', 3, 1, '{"format":"short","product":"1","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(113, 'Popular Tags', '', '', 1, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tags_popular', 1, 1, '{"maximum":"10","timeframe":"alltime","layout":"_:default","moduleclass_sfx":"","owncache":"1","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(114, 'Similar Tags', '', '', 2, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tags_similar', 1, 1, '{"maximum":"10","matchtype":"any","layout":"_:default","moduleclass_sfx":"","owncache":"1","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*');

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(1, 207),
(1, 234),
(1, 242),
(1, 243),
(1, 244),
(1, 296),
(1, 399),
(1, 400),
(1, 427),
(1, 429),
(1, 430),
(1, 431),
(1, 432),
(1, 433),
(1, 462),
(1, 463),
(1, 464),
(1, 467),
(1, 468),
(1, 469),
(1, 470),
(1, 471),
(1, 472),
(1, 473),
(1, 476),
(1, 477),
(1, 478),
(1, 479),
(1, 480),
(1, 481),
(1, 482),
(1, 483),
(1, 484),
(1, 485),
(1, 486),
(1, 487),
(1, 490),
(1, 491),
(1, 492),
(1, 493),
(1, 494),
(1, 495),
(1, 496),
(1, 497),
(1, 498),
(1, 499),
(1, 500),
(1, 501),
(1, 502),
(1, 503),
(1, 504),
(1, 505),
(1, 506),
(1, 507),
(1, 508),
(1, 509),
(1, 510),
(1, 511),
(1, 512),
(1, 513),
(1, 514),
(1, 515),
(1, 516),
(1, 517),
(1, 518),
(1, 519),
(1, 520),
(1, 521),
(1, 522),
(1, 523),
(1, 524),
(1, 525),
(1, 526),
(1, 527),
(1, 528),
(1, 529),
(1, 530),
(1, 531),
(1, 532),
(1, 533),
(1, 534),
(1, 535),
(1, 536),
(1, 537),
(1, 538),
(1, 539),
(1, 540),
(1, 541),
(1, 542),
(1, 543),
(1, 544),
(1, 545),
(1, 546),
(1, 547),
(1, 548),
(1, 549),
(1, 550),
(1, 551),
(1, 552),
(1, 553),
(1, 554),
(1, 559),
(1, 560),
(1, 561),
(1, 563),
(1, 564),
(1, 565),
(1, 566),
(1, 567),
(1, 568),
(1, 578),
(1, 580),
(1, 584),
(1, 585),
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(16, 0),
(17, 0),
(18, 0),
(19, 464),
(19, 491),
(19, 578),
(20, 0),
(22, 231),
(22, 234),
(22, 238),
(22, 242),
(22, 243),
(22, 244),
(22, 296),
(22, 519),
(22, 520),
(23, 207),
(23, 234),
(23, 242),
(23, 243),
(23, 244),
(23, 296),
(23, 399),
(23, 400),
(23, 427),
(23, 429),
(23, 430),
(23, 431),
(23, 432),
(23, 433),
(23, 462),
(23, 463),
(23, 464),
(23, 467),
(23, 468),
(23, 469),
(23, 470),
(23, 471),
(23, 472),
(23, 473),
(23, 476),
(23, 477),
(23, 478),
(23, 479),
(23, 480),
(23, 481),
(23, 482),
(23, 483),
(23, 484),
(23, 485),
(23, 486),
(23, 487),
(23, 490),
(23, 491),
(23, 492),
(23, 493),
(23, 494),
(23, 495),
(23, 496),
(23, 497),
(23, 498),
(23, 499),
(23, 500),
(23, 501),
(23, 502),
(23, 503),
(23, 504),
(23, 505),
(23, 506),
(23, 507),
(23, 508),
(23, 509),
(23, 510),
(23, 511),
(23, 512),
(23, 513),
(23, 514),
(23, 515),
(23, 516),
(23, 517),
(23, 518),
(23, 519),
(23, 520),
(23, 521),
(23, 522),
(23, 523),
(23, 524),
(23, 525),
(23, 526),
(23, 527),
(23, 528),
(23, 529),
(23, 530),
(23, 531),
(23, 532),
(23, 533),
(23, 534),
(23, 535),
(23, 536),
(23, 537),
(23, 538),
(23, 539),
(23, 540),
(23, 541),
(23, 542),
(23, 543),
(23, 544),
(23, 545),
(23, 546),
(23, 547),
(23, 548),
(23, 549),
(23, 550),
(23, 551),
(23, 552),
(23, 553),
(23, 554),
(23, 559),
(23, 560),
(23, 561),
(23, 563),
(23, 564),
(23, 565),
(23, 566),
(23, 567),
(23, 568),
(23, 580),
(23, 584),
(23, 585),
(25, 294),
(26, -463),
(26, -462),
(26, -433),
(26, -432),
(26, -431),
(26, -430),
(26, -429),
(26, -427),
(26, -400),
(26, -399),
(26, -296),
(26, -244),
(26, -243),
(26, -242),
(26, -238),
(26, -234),
(27, 325),
(28, 310),
(29, 302),
(30, 527),
(31, 309),
(32, 309),
(33, 307),
(34, 326),
(35, 306),
(36, 304),
(37, 311),
(38, 300),
(39, 491),
(40, 313),
(41, 0),
(44, 312),
(45, 303),
(47, 231),
(47, 234),
(47, 242),
(47, 243),
(47, 244),
(47, 296),
(47, 519),
(47, 520),
(48, 535),
(49, 534),
(52, 0),
(56, 201),
(56, 207),
(56, 227),
(56, 229),
(56, 234),
(56, 242),
(56, 243),
(56, 244),
(56, 249),
(56, 251),
(56, 252),
(56, 253),
(56, 254),
(56, 255),
(56, 256),
(56, 257),
(56, 259),
(56, 260),
(56, 262),
(56, 263),
(56, 265),
(56, 266),
(56, 267),
(56, 268),
(56, 270),
(56, 271),
(56, 272),
(56, 273),
(56, 274),
(56, 275),
(56, 276),
(56, 277),
(56, 278),
(56, 279),
(56, 280),
(56, 281),
(56, 282),
(56, 283),
(56, 284),
(56, 285),
(56, 286),
(56, 296),
(56, 300),
(56, 301),
(56, 302),
(56, 303),
(56, 304),
(56, 305),
(56, 306),
(56, 307),
(56, 309),
(56, 310),
(56, 311),
(56, 312),
(56, 313),
(56, 316),
(56, 317),
(56, 318),
(56, 319),
(56, 320),
(56, 321),
(56, 322),
(56, 323),
(56, 324),
(56, 325),
(56, 326),
(56, 399),
(56, 400),
(56, 402),
(56, 403),
(56, 404),
(56, 405),
(56, 406),
(56, 409),
(56, 410),
(56, 411),
(56, 412),
(56, 413),
(56, 414),
(56, 415),
(56, 416),
(56, 417),
(56, 418),
(56, 419),
(56, 421),
(56, 422),
(56, 423),
(56, 424),
(56, 427),
(56, 429),
(56, 430),
(56, 431),
(56, 432),
(56, 433),
(56, 436),
(56, 437),
(56, 443),
(56, 447),
(56, 449),
(56, 450),
(56, 451),
(56, 452),
(56, 453),
(56, 456),
(56, 457),
(56, 458),
(56, 459),
(56, 462),
(56, 463),
(56, 464),
(56, 467),
(56, 468),
(56, 469),
(56, 470),
(56, 471),
(56, 472),
(56, 473),
(56, 476),
(56, 477),
(56, 478),
(56, 479),
(56, 480),
(56, 481),
(56, 482),
(56, 483),
(56, 484),
(56, 485),
(56, 486),
(56, 487),
(56, 491),
(56, 492),
(56, 493),
(56, 494),
(56, 495),
(56, 496),
(56, 497),
(56, 498),
(56, 499),
(56, 500),
(56, 501),
(56, 502),
(56, 503),
(56, 504),
(56, 505),
(56, 506),
(56, 507),
(56, 508),
(56, 509),
(56, 510),
(56, 511),
(56, 512),
(56, 513),
(56, 514),
(56, 515),
(56, 516),
(56, 517),
(56, 518),
(56, 519),
(56, 520),
(56, 521),
(56, 522),
(56, 523),
(56, 524),
(56, 525),
(56, 526),
(56, 527),
(56, 528),
(56, 529),
(56, 530),
(56, 531),
(56, 532),
(56, 533),
(56, 534),
(56, 535),
(56, 536),
(56, 537),
(56, 538),
(56, 539),
(56, 540),
(56, 541),
(56, 542),
(56, 543),
(56, 544),
(56, 545),
(56, 546),
(56, 547),
(56, 548),
(56, 549),
(56, 550),
(56, 551),
(56, 552),
(56, 553),
(56, 559),
(56, 560),
(56, 561),
(56, 584),
(56, 585),
(57, 238),
(57, 494),
(57, 496),
(57, 497),
(57, 498),
(57, 499),
(57, 500),
(57, 552),
(57, 553),
(58, 494),
(58, 496),
(58, 497),
(58, 498),
(58, 499),
(58, 500),
(58, 552),
(58, 553),
(60, 227),
(60, 229),
(60, 249),
(60, 251),
(60, 252),
(60, 253),
(60, 254),
(60, 255),
(60, 256),
(60, 257),
(60, 259),
(60, 260),
(60, 262),
(60, 263),
(60, 265),
(60, 266),
(60, 267),
(60, 270),
(60, 271),
(60, 272),
(60, 273),
(60, 274),
(60, 275),
(60, 276),
(60, 281),
(60, 282),
(60, 283),
(60, 284),
(60, 285),
(60, 286),
(60, 300),
(60, 301),
(60, 302),
(60, 303),
(60, 304),
(60, 305),
(60, 306),
(60, 307),
(60, 309),
(60, 310),
(60, 311),
(60, 312),
(60, 313),
(60, 314),
(60, 316),
(60, 317),
(60, 318),
(60, 319),
(60, 320),
(60, 321),
(60, 322),
(60, 323),
(60, 324),
(60, 325),
(60, 326),
(60, 405),
(60, 406),
(60, 409),
(60, 424),
(60, 492),
(60, 493),
(60, 522),
(60, 523),
(60, 524),
(60, 527),
(60, 528),
(60, 529),
(60, 530),
(60, 531),
(60, 532),
(60, 533),
(60, 534),
(60, 535),
(60, 538),
(60, 539),
(60, 540),
(60, 541),
(60, 542),
(61, 546),
(62, 231),
(62, 234),
(62, 242),
(62, 243),
(62, 244),
(62, 296),
(62, 519),
(62, 520),
(63, 0),
(64, 447),
(65, 494),
(65, 496),
(65, 497),
(65, 498),
(65, 499),
(65, 500),
(65, 552),
(65, 553),
(68, 243),
(69, 549),
(70, 285),
(70, 316),
(71, 285),
(71, 316),
(72, 285),
(72, 316),
(73, 285),
(73, 316),
(74, 285),
(74, 316),
(75, 285),
(75, 316),
(76, 285),
(76, 316),
(77, 491),
(78, 0),
(79, 0),
(80, 0),
(81, 435),
(82, 435),
(82, 491),
(82, 492),
(82, 493),
(82, 494),
(82, 495),
(82, 496),
(82, 497),
(82, 498),
(82, 499),
(82, 500),
(82, 501),
(82, 502),
(82, 503),
(82, 504),
(82, 505),
(82, 506),
(82, 507),
(82, 508),
(82, 509),
(82, 510),
(82, 511),
(82, 512),
(82, 513),
(82, 514),
(82, 515),
(82, 516),
(82, 517),
(82, 518),
(82, 519),
(82, 520),
(82, 521),
(82, 522),
(82, 523),
(82, 524),
(82, 525),
(82, 526),
(82, 527),
(82, 528),
(82, 529),
(82, 530),
(82, 531),
(82, 532),
(82, 533),
(82, 534),
(82, 535),
(82, 536),
(82, 537),
(82, 538),
(82, 539),
(82, 540),
(82, 541),
(82, 542),
(82, 543),
(82, 544),
(82, 547),
(82, 548),
(82, 549),
(82, 550),
(82, 551),
(82, 552),
(82, 553),
(83, 435),
(83, 491),
(83, 492),
(83, 493),
(83, 494),
(83, 495),
(83, 496),
(83, 497),
(83, 498),
(83, 499),
(83, 500),
(83, 501),
(83, 502),
(83, 503),
(83, 504),
(83, 505),
(83, 506),
(83, 507),
(83, 508),
(83, 509),
(83, 510),
(83, 511),
(83, 512),
(83, 513),
(83, 514),
(83, 515),
(83, 516),
(83, 517),
(83, 518),
(83, 519),
(83, 520),
(83, 521),
(83, 522),
(83, 523),
(83, 524),
(83, 525),
(83, 526),
(83, 527),
(83, 528),
(83, 529),
(83, 530),
(83, 531),
(83, 532),
(83, 533),
(83, 534),
(83, 535),
(83, 536),
(83, 537),
(83, 538),
(83, 539),
(83, 540),
(83, 541),
(83, 542),
(83, 543),
(83, 544),
(83, 547),
(83, 548),
(83, 549),
(83, 550),
(83, 551),
(83, 552),
(83, 553),
(84, 435),
(84, 491),
(84, 492),
(84, 493),
(84, 494),
(84, 495),
(84, 496),
(84, 497),
(84, 498),
(84, 499),
(84, 500),
(84, 501),
(84, 502),
(84, 503),
(84, 504),
(84, 505),
(84, 506),
(84, 507),
(84, 508),
(84, 509),
(84, 510),
(84, 511),
(84, 512),
(84, 513),
(84, 514),
(84, 515),
(84, 516),
(84, 517),
(84, 518),
(84, 519),
(84, 520),
(84, 521),
(84, 522),
(84, 523),
(84, 524),
(84, 525),
(84, 526),
(84, 527),
(84, 528),
(84, 529),
(84, 530),
(84, 531),
(84, 532),
(84, 533),
(84, 534),
(84, 535),
(84, 536),
(84, 537),
(84, 538),
(84, 539),
(84, 540),
(84, 541),
(84, 542),
(84, 543),
(84, 544),
(84, 547),
(84, 548),
(84, 549),
(84, 550),
(84, 551),
(84, 552),
(84, 553),
(85, 435),
(85, 491),
(85, 492),
(85, 493),
(85, 494),
(85, 495),
(85, 496),
(85, 497),
(85, 498),
(85, 499),
(85, 500),
(85, 501),
(85, 502),
(85, 503),
(85, 504),
(85, 505),
(85, 506),
(85, 507),
(85, 508),
(85, 509),
(85, 510),
(85, 511),
(85, 512),
(85, 513),
(85, 514),
(85, 515),
(85, 516),
(85, 517),
(85, 518),
(85, 519),
(85, 520),
(85, 521),
(85, 522),
(85, 523),
(85, 524),
(85, 525),
(85, 526),
(85, 527),
(85, 528),
(85, 529),
(85, 530),
(85, 531),
(85, 532),
(85, 533),
(85, 534),
(85, 535),
(85, 536),
(85, 537),
(85, 538),
(85, 539),
(85, 540),
(85, 541),
(85, 542),
(85, 543),
(85, 544),
(85, 547),
(85, 548),
(85, 549),
(85, 550),
(85, 551),
(85, 552),
(85, 553),
(86, 467),
(86, 472),
(86, 473),
(86, 476),
(86, 477),
(86, 478),
(86, 479),
(86, 480),
(86, 481),
(86, 482),
(86, 483),
(86, 484),
(86, 485),
(86, 486),
(86, 487),
(86, 491),
(86, 492),
(86, 493),
(86, 494),
(86, 495),
(86, 496),
(86, 497),
(86, 498),
(86, 499),
(86, 500),
(86, 501),
(86, 545),
(86, 546),
(87, 472),
(87, 473),
(87, 474),
(87, 475),
(87, 476),
(87, 477),
(87, 478),
(87, 479),
(87, 480),
(87, 481),
(87, 482),
(87, 483),
(87, 484),
(87, 485),
(87, 486),
(87, 487),
(87, 488),
(87, 489),
(87, 491),
(87, 492),
(87, 493),
(87, 494),
(87, 495),
(87, 496),
(87, 497),
(87, 498),
(87, 499),
(87, 500),
(87, 501),
(87, 516),
(87, 517),
(87, 518),
(87, 519),
(87, 520),
(87, 528),
(87, 529),
(87, 530),
(87, 545),
(87, 546),
(88, 491),
(89, 491),
(90, 472),
(90, 473),
(90, 474),
(90, 475),
(90, 476),
(90, 477),
(90, 478),
(90, 479),
(90, 480),
(90, 481),
(90, 482),
(90, 483),
(90, 484),
(90, 485),
(90, 486),
(90, 487),
(90, 488),
(90, 489),
(90, 491),
(90, 492),
(90, 493),
(90, 494),
(90, 495),
(90, 496),
(90, 497),
(90, 498),
(90, 499),
(90, 500),
(90, 501),
(90, 502),
(90, 503),
(90, 504),
(90, 505),
(90, 506),
(90, 507),
(90, 508),
(90, 509),
(90, 510),
(90, 511),
(90, 512),
(90, 513),
(90, 514),
(90, 515),
(90, 516),
(90, 517),
(90, 518),
(90, 519),
(90, 520),
(90, 521),
(90, 522),
(90, 523),
(90, 524),
(90, 525),
(90, 526),
(90, 527),
(90, 528),
(90, 529),
(90, 530),
(90, 531),
(90, 532),
(90, 533),
(90, 534),
(90, 535),
(90, 536),
(90, 537),
(90, 538),
(90, 539),
(90, 540),
(90, 541),
(90, 542),
(90, 543),
(90, 544),
(90, 545),
(90, 546),
(91, 0),
(92, 538),
(92, 539),
(92, 540),
(92, 541),
(92, 542),
(92, 578),
(93, 435),
(93, 538),
(93, 539),
(93, 540),
(93, 541),
(93, 542),
(93, 543),
(93, 544),
(94, 435),
(94, 531),
(94, 532),
(94, 533),
(94, 534),
(94, 535),
(95, 435),
(95, 527),
(95, 528),
(95, 529),
(95, 530),
(96, 435),
(96, 547),
(96, 548),
(96, 549),
(96, 550),
(96, 551),
(96, 552),
(96, 553),
(97, 520),
(97, 521),
(97, 522),
(97, 523),
(97, 524),
(97, 525),
(97, 526),
(97, 580),
(98, 0),
(99, 435),
(99, 516),
(100, 0),
(101, 435),
(101, 509),
(101, 510),
(101, 511),
(101, 512),
(101, 513),
(101, 514),
(101, 515),
(102, 502),
(102, 503),
(102, 504),
(102, 505),
(102, 506),
(102, 507),
(102, 508),
(102, 584),
(102, 585),
(103, 0),
(103, 435),
(104, 435),
(104, 491),
(104, 492),
(104, 493),
(104, 494),
(104, 495),
(104, 496),
(104, 497),
(104, 498),
(104, 499),
(104, 500),
(104, 501),
(104, 502),
(104, 503),
(104, 504),
(104, 505),
(104, 506),
(104, 507),
(104, 508),
(104, 509),
(104, 510),
(104, 511),
(104, 512),
(104, 513),
(104, 514),
(104, 515),
(104, 516),
(104, 517),
(104, 518),
(104, 519),
(104, 520),
(104, 521),
(104, 522),
(104, 523),
(104, 524),
(104, 525),
(104, 526),
(104, 527),
(104, 528),
(104, 529),
(104, 530),
(104, 531),
(104, 532),
(104, 533),
(104, 534),
(104, 535),
(104, 536),
(104, 537),
(104, 538),
(104, 539),
(104, 540),
(104, 541),
(104, 542),
(104, 543),
(104, 544),
(104, 547),
(104, 548),
(104, 549),
(104, 550),
(104, 551),
(104, 552),
(104, 553),
(105, 491),
(106, 491),
(106, 516),
(106, 531),
(106, 578),
(107, 201),
(107, 207),
(107, 227),
(107, 229),
(107, 234),
(107, 242),
(107, 243),
(107, 244),
(107, 249),
(107, 251),
(107, 252),
(107, 253),
(107, 254),
(107, 255),
(107, 256),
(107, 257),
(107, 259),
(107, 260),
(107, 262),
(107, 263),
(107, 265),
(107, 266),
(107, 267),
(107, 268),
(107, 270),
(107, 271),
(107, 272),
(107, 273),
(107, 274),
(107, 275),
(107, 276),
(107, 277),
(107, 278),
(107, 279),
(107, 280),
(107, 281),
(107, 282),
(107, 283),
(107, 284),
(107, 285),
(107, 286),
(107, 296),
(107, 300),
(107, 301),
(107, 302),
(107, 303),
(107, 304),
(107, 305),
(107, 306),
(107, 307),
(107, 309),
(107, 310),
(107, 311),
(107, 312),
(107, 313),
(107, 316),
(107, 317),
(107, 318),
(107, 319),
(107, 320),
(107, 321),
(107, 322),
(107, 323),
(107, 324),
(107, 325),
(107, 326),
(107, 399),
(107, 400),
(107, 402),
(107, 403),
(107, 404),
(107, 405),
(107, 406),
(107, 409),
(107, 410),
(107, 411),
(107, 412),
(107, 413),
(107, 414),
(107, 415),
(107, 416),
(107, 417),
(107, 418),
(107, 419),
(107, 421),
(107, 422),
(107, 423),
(107, 424),
(107, 427),
(107, 429),
(107, 430),
(107, 431),
(107, 432),
(107, 433),
(107, 436),
(107, 437),
(107, 443),
(107, 447),
(107, 449),
(107, 450),
(107, 451),
(107, 452),
(107, 453),
(107, 456),
(107, 457),
(107, 458),
(107, 459),
(107, 462),
(107, 463),
(107, 464),
(107, 467),
(107, 468),
(107, 469),
(107, 470),
(107, 471),
(107, 472),
(107, 473),
(107, 476),
(107, 477),
(107, 478),
(107, 479),
(107, 480),
(107, 481),
(107, 482),
(107, 483),
(107, 484),
(107, 485),
(107, 486),
(107, 487),
(107, 491),
(107, 492),
(107, 493),
(107, 494),
(107, 495),
(107, 496),
(107, 497),
(107, 498),
(107, 499),
(107, 500),
(107, 501),
(107, 502),
(107, 503),
(107, 504),
(107, 505),
(107, 506),
(107, 507),
(107, 508),
(107, 509),
(107, 510),
(107, 511),
(107, 512),
(107, 513),
(107, 514),
(107, 515),
(107, 516),
(107, 517),
(107, 518),
(107, 519),
(107, 520),
(107, 521),
(107, 522),
(107, 523),
(107, 524),
(107, 525),
(107, 526),
(107, 527),
(107, 528),
(107, 529),
(107, 530),
(107, 531),
(107, 532),
(107, 533),
(107, 534),
(107, 535),
(107, 536),
(107, 537),
(107, 538),
(107, 539),
(107, 540),
(107, 541),
(107, 542),
(107, 543),
(107, 544),
(107, 545),
(107, 546),
(107, 547),
(107, 548),
(107, 549),
(107, 550),
(107, 551),
(107, 552),
(107, 553),
(107, 559),
(107, 560),
(107, 561),
(107, 584),
(107, 585),
(108, 0),
(109, 201),
(109, 207),
(109, 227),
(109, 229),
(109, 234),
(109, 242),
(109, 243),
(109, 244),
(109, 249),
(109, 251),
(109, 252),
(109, 253),
(109, 254),
(109, 255),
(109, 256),
(109, 257),
(109, 259),
(109, 260),
(109, 262),
(109, 263),
(109, 265),
(109, 266),
(109, 267),
(109, 268),
(109, 270),
(109, 271),
(109, 272),
(109, 273),
(109, 274),
(109, 275),
(109, 276),
(109, 277),
(109, 278),
(109, 279),
(109, 280),
(109, 281),
(109, 282),
(109, 283),
(109, 284),
(109, 285),
(109, 286),
(109, 296),
(109, 300),
(109, 301),
(109, 302),
(109, 303),
(109, 304),
(109, 305),
(109, 306),
(109, 307),
(109, 309),
(109, 310),
(109, 311),
(109, 312),
(109, 313),
(109, 316),
(109, 317),
(109, 318),
(109, 319),
(109, 320),
(109, 321),
(109, 322),
(109, 323),
(109, 324),
(109, 325),
(109, 326),
(109, 399),
(109, 400),
(109, 402),
(109, 403),
(109, 404),
(109, 405),
(109, 406),
(109, 409),
(109, 410),
(109, 411),
(109, 412),
(109, 413),
(109, 414),
(109, 415),
(109, 416),
(109, 417),
(109, 418),
(109, 419),
(109, 421),
(109, 422),
(109, 423),
(109, 424),
(109, 427),
(109, 429),
(109, 430),
(109, 431),
(109, 432),
(109, 433),
(109, 436),
(109, 437),
(109, 443),
(109, 447),
(109, 449),
(109, 450),
(109, 451),
(109, 452),
(109, 453),
(109, 456),
(109, 457),
(109, 458),
(109, 459),
(109, 462),
(109, 463),
(109, 464),
(109, 467),
(109, 468),
(109, 469),
(109, 470),
(109, 471),
(109, 472),
(109, 473),
(109, 476),
(109, 477),
(109, 478),
(109, 479),
(109, 480),
(109, 481),
(109, 482),
(109, 483),
(109, 484),
(109, 485),
(109, 486),
(109, 487),
(109, 491),
(109, 492),
(109, 493),
(109, 494),
(109, 495),
(109, 496),
(109, 497),
(109, 498),
(109, 499),
(109, 500),
(109, 501),
(109, 502),
(109, 503),
(109, 504),
(109, 505),
(109, 506),
(109, 507),
(109, 508),
(109, 509),
(109, 510),
(109, 511),
(109, 512),
(109, 513),
(109, 514),
(109, 515),
(109, 516),
(109, 517),
(109, 518),
(109, 519),
(109, 520),
(109, 521),
(109, 522),
(109, 523),
(109, 524),
(109, 525),
(109, 526),
(109, 527),
(109, 528),
(109, 529),
(109, 530),
(109, 531),
(109, 532),
(109, 533),
(109, 534),
(109, 535),
(109, 536),
(109, 537),
(109, 538),
(109, 539),
(109, 540),
(109, 541),
(109, 542),
(109, 543),
(109, 544),
(109, 545),
(109, 546),
(109, 547),
(109, 548),
(109, 549),
(109, 550),
(109, 551),
(109, 552),
(109, 553),
(109, 559),
(109, 560),
(109, 561),
(109, 584),
(109, 585),
(110, 491),
(111, 0),
(112, 0),
(113, 584),
(113, 585),
(114, 585);

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__redirect_links`;
CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) DEFAULT NULL,
  `new_url` varchar(255) DEFAULT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__session`;
CREATE TABLE `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__tags`;
CREATE TABLE `#__tags` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `tag_idx` (`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB ;

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM ;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","highContrast":"0","boldText":"0","altMenu":"0"}'),
(116, 'ja_teline_iii', 0, '1', 'JA_Teline_III - Default', '{}'),
(117, 'beez3', 0, '0', 'beez3 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature","backgroundcolor":"#eee"}'),
(118, 'isis', 1, '1', 'isis - Default', '{"templateColor":"#13294A","headerColor":"#184A7D","logoFile":"","admin_menus":"1","displayHeader":"1","statusFixed":"1","stickyToolbar":"1"}'),
(119, 'protostar', 0, '0', 'protostar - Default', '{"templateColor":"#08C","templateBackgroundColor":"#F4F6F7","logoFile":"","sitetitle":"","sitedescription":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}');

DROP TABLE IF EXISTS `#__ucm_base`;
CREATE TABLE `#__ucm_base` (
  `ucm_id` int(10) unsigned NOT NULL,
  `ucm_item_id` int(10) NOT NULL,
  `ucm_type_id` int(11) NOT NULL,
  `ucm_language_id` int(11) NOT NULL,
  PRIMARY KEY (`ucm_id`),
  KEY `idx_ucm_item_id` (`ucm_item_id`),
  KEY `idx_ucm_type_id` (`ucm_type_id`),
  KEY `idx_ucm_language_id` (`ucm_language_id`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `#__ucm_content`;
CREATE TABLE `#__ucm_content` (
  `core_content_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `core_type_alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'FK to the content types table',
  `core_title` varchar(255) NOT NULL,
  `core_alias` varchar(255) binary NOT NULL DEFAULT '',
  `core_body` mediumtext NOT NULL,
  `core_state` tinyint(1) NOT NULL DEFAULT '0',
  `core_checked_out_time` varchar(255) NOT NULL DEFAULT '',
  `core_checked_out_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_access` int(10) unsigned NOT NULL DEFAULT '0',
  `core_params` text NOT NULL,
  `core_featured` tinyint(4) unsigned NOT NULL DEFAULT '0',
  `core_metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `core_created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `core_created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_modified_user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Most recent user that modified',
  `core_modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_language` char(7) NOT NULL,
  `core_publish_up` datetime NOT NULL,
  `core_publish_down` datetime NOT NULL,
  `core_content_item_id` int(10) unsigned DEFAULT NULL COMMENT 'ID from the individual type table',
  `asset_id` int(10) unsigned DEFAULT NULL COMMENT 'FK to the #__assets table.',
  `core_images` text NOT NULL,
  `core_urls` text NOT NULL,
  `core_hits` int(10) unsigned NOT NULL DEFAULT '0',
  `core_version` int(10) unsigned NOT NULL DEFAULT '1',
  `core_ordering` int(11) NOT NULL DEFAULT '0',
  `core_metakey` text NOT NULL,
  `core_metadesc` text NOT NULL,
  `core_catid` int(10) unsigned NOT NULL DEFAULT '0',
  `core_xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `core_type_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`core_content_id`),
  KEY `tag_idx` (`core_state`,`core_access`),
  KEY `idx_access` (`core_access`),
  KEY `idx_alias` (`core_alias`),
  KEY `idx_language` (`core_language`),
  KEY `idx_title` (`core_title`),
  KEY `idx_modified_time` (`core_modified_time`),
  KEY `idx_created_time` (`core_created_time`),
  KEY `idx_content_type` (`core_type_alias`),
  KEY `idx_core_modified_user_id` (`core_modified_user_id`),
  KEY `idx_core_checked_out_user_id` (`core_checked_out_user_id`),
  KEY `idx_core_created_user_id` (`core_created_user_id`),
  KEY `idx_core_type_id` (`core_type_id`)
) ENGINE=InnoDB  COMMENT='Contains core content data in name spaced fields';

DROP TABLE IF EXISTS `#__update_categories`;
CREATE TABLE `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM COMMENT='Update Categories';

DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM  COMMENT='Update Sites';

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES
(5, '', 'collection', 'http://update.joomlart.com/service/tracking/list.xml', 1, 1375669121),
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 1375669121),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 0, 0),
(3, 'Accredited Joomla! Translations', 'collection', 'http://update.joomla.org/language/translationlist_3.xml', 1, 1375669121);
INSERT IGNORE INTO `#__update_sites` VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 0),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 0),
(3,'Accredited Joomla! Translations','collection','http://update.joomla.org/language/translationlist_3.xml', 1 ,0);
DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM COMMENT='Links extensions to update sites';
INSERT IGNORE INTO `#__update_sites_extensions` VALUES
(1, 700),
(2, 700),
(3, 600);
UPDATE `#__update_sites`
SET location = 'http://update.joomla.org/language/translationlist_3.xml'
WHERE location = 'http://update.joomla.org/language/translationlist.xml'
AND name = 'Accredited Joomla! Translations';
DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM  COMMENT='Available Updates';

DROP TABLE IF EXISTS `#__user_notes`;
CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__user_profiles`;
CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=MyISAM COMMENT='Simple user profile storage table';

DROP TABLE IF EXISTS `#__user_usergroup_map`;
CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__usergroups`;
CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`)
) ENGINE=MyISAM ;

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES
(1, 0, 1, 20, 'Public'),
(2, 1, 6, 17, 'Registered'),
(3, 2, 7, 14, 'Author'),
(4, 3, 8, 11, 'Editor'),
(5, 4, 9, 10, 'Publisher'),
(6, 1, 2, 5, 'Manager'),
(7, 6, 3, 4, 'Administrator'),
(8, 1, 18, 19, 'Super Users');

DROP TABLE IF EXISTS `#__users`;
CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM ;

DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM ;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]'),
(4, 'Customer Access Level', 3, '[6,3,12]');

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

