
DROP TABLE IF EXISTS `#__assets`;
CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(1, 0, 1, 1328, 0, 'root.1', 'Root Asset', '{"core.login.site":{"6":1,"2":1},"core.login.admin":{"6":1},"core.login.offline":[],"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1},"core.edit.own":{"6":1,"3":1}}'),
(2, 1, 2, 3, 1, 'com_admin', 'com_admin', '{}'),
(3, 1, 4, 17, 1, 'com_banners', 'com_banners', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(4, 1, 18, 19, 1, 'com_cache', 'com_cache', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(5, 1, 20, 21, 1, 'com_checkin', 'com_checkin', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(6, 1, 22, 23, 1, 'com_config', 'com_config', '{}'),
(7, 1, 24, 93, 1, 'com_contact', 'com_contact', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(8, 1, 94, 1187, 1, 'com_content', 'com_content', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1},"core.edit.own":[]}'),
(9, 1, 1188, 1189, 1, 'com_cpanel', 'com_cpanel', '{}'),
(10, 1, 1190, 1191, 1, 'com_installer', 'com_installer', '{"core.admin":{"7":1},"core.manage":{"7":1},"core.create":[],"core.delete":[],"core.edit.state":[]}'),
(11, 1, 1192, 1193, 1, 'com_languages', 'com_languages', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(12, 1, 1194, 1195, 1, 'com_login', 'com_login', '{}'),
(13, 1, 1196, 1197, 1, 'com_mailto', 'com_mailto', '{}'),
(14, 1, 1198, 1199, 1, 'com_massmail', 'com_massmail', '{}'),
(15, 1, 1200, 1201, 1, 'com_media', 'com_media', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1},"core.delete":{"5":1},"core.edit":[],"core.edit.state":[]}'),
(16, 1, 1202, 1203, 1, 'com_menus', 'com_menus', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(17, 1, 43, 44, 1, 'com_messages', 'com_messages', '{"core.admin":{"7":1},"core.manage":{"7":1}}'),
(18, 1, 1206, 1207, 1, 'com_modules', 'com_modules', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(19, 1, 1208, 1215, 1, 'com_newsfeeds', 'com_newsfeeds', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(20, 1, 1216, 1217, 1, 'com_plugins', 'com_plugins', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(21, 1, 1218, 1219, 1, 'com_redirect', 'com_redirect', '{"core.admin":{"7":1},"core.manage":[]}'),
(22, 1, 1220, 1221, 1, 'com_search', 'com_search', '{"core.admin":{"7":1},"core.manage":{"6":1}}'),
(23, 1, 1222, 1223, 1, 'com_templates', 'com_templates', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(24, 1, 1224, 1225, 1, 'com_users', 'com_users', '{"core.admin":{"7":1},"core.manage":[],"core.create":[],"core.delete":[],"core.edit":[],"core.edit.own":{"6":1},"core.edit.state":[]}'),
(25, 1, 1226, 1243, 1, 'com_weblinks', 'com_weblinks', '{"core.admin":{"7":1},"core.manage":{"6":1},"core.create":{"3":1,"10":0,"12":0},"core.delete":[],"core.edit":{"4":1},"core.edit.state":{"5":1}}'),
(26, 1, 1244, 1245, 1, 'com_wrapper', 'com_wrapper', '{}'),
(39, 8, 117, 306, 2, 'com_content.category.14', 'Sample Data-Articles', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(38, 25, 1233, 1234, 2, 'com_weblinks.category.13', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(37, 19, 1211, 1212, 2, 'com_newsfeeds.category.12', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(36, 7, 29, 30, 2, 'com_contact.category.11', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(35, 3, 7, 8, 2, 'com_banners.category.10', 'Uncategorised', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(34, 8, 111, 116, 2, 'com_content.category.9', 'Uncategorised', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(40, 3, 9, 10, 2, 'com_banners.category.15', 'Sample Data-Banners', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(41, 7, 31, 92, 2, 'com_contact.category.16', 'Sample Data-Contact', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(42, 19, 1213, 1214, 2, 'com_newsfeeds.category.17', 'Sample Data-Newsfeeds', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(43, 25, 1235, 1242, 2, 'com_weblinks.category.18', 'Sample Data-Weblinks', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(44, 39, 118, 249, 3, 'com_content.category.19', 'Joomla!', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(45, 44, 119, 226, 4, 'com_content.category.20', 'Extensions', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(46, 45, 120, 135, 5, 'com_content.category.21', 'Components', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(47, 45, 136, 195, 5, 'com_content.category.22', 'Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(48, 45, 196, 207, 5, 'com_content.category.23', 'Templates', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(49, 45, 208, 209, 5, 'com_content.category.24', 'Languages', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(50, 45, 210, 225, 5, 'com_content.category.25', 'Plugins', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(51, 39, 250, 281, 3, 'com_content.category.26', 'Park Site', '{"core.create":{"10":0,"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(52, 51, 251, 256, 4, 'com_content.category.27', 'Park Blog', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(53, 51, 257, 278, 4, 'com_content.category.28', 'Photo Gallery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(54, 39, 282, 295, 3, 'com_content.category.29', 'Fruit Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(55, 54, 283, 288, 4, 'com_content.category.30', 'Growers', '{"core.create":{"12":0},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"10":1}}'),
(56, 43, 1236, 1237, 3, 'com_weblinks.category.31', 'Park Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(57, 43, 1238, 1241, 3, 'com_weblinks.category.32', 'Joomla! Specific Links', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(58, 57, 1239, 1240, 4, 'com_weblinks.category.33', 'Other Resources', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(59, 41, 32, 33, 3, 'com_contact.category.34', 'Park Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(60, 41, 34, 91, 3, 'com_contact.category.35', 'Shop Site', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(61, 60, 35, 36, 4, 'com_contact.category.36', 'Staff', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(62, 60, 37, 90, 4, 'com_contact.category.37', 'Fruit Encyclopedia', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(63, 62, 38, 39, 5, 'com_contact.category.38', 'A', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(64, 62, 40, 41, 5, 'com_contact.category.39', 'B', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(65, 62, 42, 43, 5, 'com_contact.category.40', 'C', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(66, 62, 44, 45, 5, 'com_contact.category.41', 'D', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(67, 62, 46, 47, 5, 'com_contact.category.42', 'E', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(68, 62, 48, 49, 5, 'com_contact.category.43', 'F', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(69, 62, 50, 51, 5, 'com_contact.category.44', 'G', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(70, 62, 52, 53, 5, 'com_contact.category.45', 'H', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(71, 62, 54, 55, 5, 'com_contact.category.46', 'I', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(72, 62, 56, 57, 5, 'com_contact.category.47', 'J', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(73, 62, 58, 59, 5, 'com_contact.category.48', 'K', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(74, 62, 60, 61, 5, 'com_contact.category.49', 'L', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(75, 62, 62, 63, 5, 'com_contact.category.50', 'M', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(76, 62, 64, 65, 5, 'com_contact.category.51', 'N', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(77, 62, 66, 67, 5, 'com_contact.category.52', 'O', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(78, 62, 68, 69, 5, 'com_contact.category.53', 'P', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(79, 62, 70, 71, 5, 'com_contact.category.54', 'Q', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(80, 62, 72, 73, 5, 'com_contact.category.55', 'R', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(81, 62, 74, 75, 5, 'com_contact.category.56', 'S', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(82, 62, 76, 77, 5, 'com_contact.category.57', 'T', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(83, 62, 78, 79, 5, 'com_contact.category.58', 'U', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(84, 62, 80, 81, 5, 'com_contact.category.59', 'V', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(85, 62, 82, 83, 5, 'com_contact.category.60', 'W', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(86, 62, 84, 85, 5, 'com_contact.category.61', 'X', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(87, 62, 86, 87, 5, 'com_contact.category.62', 'Y', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(88, 62, 88, 89, 5, 'com_contact.category.63', 'Z', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(89, 46, 121, 122, 6, 'com_content.article.1', 'Administrator Components', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(90, 93, 138, 139, 7, 'com_content.article.2', 'Archive Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(91, 93, 140, 141, 7, 'com_content.article.3', 'Article Categories Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(92, 93, 142, 143, 7, 'com_content.article.4', 'Articles Category Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(93, 47, 137, 152, 6, 'com_content.category.64', 'Content Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(94, 47, 153, 160, 6, 'com_content.category.65', 'User Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(95, 47, 161, 174, 6, 'com_content.category.66', 'Display Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(96, 47, 175, 186, 6, 'com_content.category.67', 'Utility Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(97, 48, 197, 198, 6, 'com_content.category.68', 'Atomic', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(98, 48, 199, 200, 6, 'com_content.category.69', 'Beez 20', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(99, 48, 201, 202, 6, 'com_content.category.70', 'Beez5', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(100, 48, 203, 204, 6, 'com_content.category.71', 'Milky Way', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(101, 50, 211, 212, 6, 'com_content.article.5', 'Authentication', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(102, 51, 279, 280, 4, 'com_content.article.6', 'Australian Parks ', '{"core.delete":[],"core.edit":{"2":1},"core.edit.state":[]}'),
(103, 95, 162, 163, 7, 'com_content.article.7', 'Banner Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(104, 44, 227, 228, 4, 'com_content.article.8', 'Beginners', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(105, 46, 123, 124, 6, 'com_content.article.9', 'Contact', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(106, 46, 125, 126, 6, 'com_content.article.10', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(107, 109, 269, 270, 6, 'com_content.article.11', 'Cradle Mountain', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(108, 53, 258, 267, 5, 'com_content.category.72', 'Animals', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(109, 53, 268, 277, 5, 'com_content.category.73', 'Scenery', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(110, 95, 164, 165, 7, 'com_content.article.12', 'Custom HTML Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(111, 54, 289, 290, 4, 'com_content.article.13', 'Directions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(112, 50, 213, 214, 6, 'com_content.article.14', 'Editors', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(113, 50, 215, 216, 6, 'com_content.article.15', 'Editors-xtd', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(114, 95, 166, 167, 7, 'com_content.article.16', 'Feed Display', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(115, 52, 252, 253, 5, 'com_content.article.17', 'First Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(116, 52, 254, 255, 5, 'com_content.article.18', 'Second Blog Post', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(117, 95, 168, 169, 7, 'com_content.article.19', 'Footer Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(118, 54, 291, 292, 4, 'com_content.article.20', 'Fruit Shop', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(119, 44, 229, 230, 4, 'com_content.article.21', 'Getting Help', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(120, 44, 231, 232, 4, 'com_content.article.22', 'Getting Started', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(121, 55, 284, 285, 5, 'com_content.article.23', 'Happy Orange Orchard', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(122, 44, 233, 234, 4, 'com_content.article.24', 'Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(123, 108, 259, 260, 6, 'com_content.article.25', 'Koala', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(124, 96, 176, 177, 7, 'com_content.article.26', 'Language Switcher', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(125, 93, 144, 145, 7, 'com_content.article.27', 'Latest Articles Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(126, 94, 154, 155, 7, 'com_content.article.28', 'Login Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(127, 166, 190, 191, 7, 'com_content.article.29', 'Menu Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(128, 93, 146, 147, 7, 'com_content.article.30', 'Most Read Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(129, 93, 148, 149, 7, 'com_content.article.31', 'News Flash', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(130, 44, 235, 236, 4, 'com_content.article.32', 'Parameters', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(131, 108, 261, 262, 6, 'com_content.article.33', 'Phyllopteryx', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(132, 109, 271, 272, 6, 'com_content.article.34', 'Pinnacles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(133, 44, 237, 238, 4, 'com_content.article.35', 'Professionals', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(134, 95, 170, 171, 7, 'com_content.article.36', 'Random Image Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(135, 93, 150, 151, 7, 'com_content.article.37', 'Related Items Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(136, 44, 239, 240, 4, 'com_content.article.38', 'Sample Sites', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(137, 46, 127, 128, 6, 'com_content.article.39', 'Search', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(138, 96, 178, 179, 7, 'com_content.article.40', 'Search Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(139, 50, 217, 218, 6, 'com_content.article.41', 'Search ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(140, 39, 296, 297, 3, 'com_content.article.42', 'Site Map', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(141, 108, 263, 264, 6, 'com_content.article.43', 'Spotted Quoll', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(142, 96, 180, 181, 7, 'com_content.article.44', 'Statistics Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(143, 96, 182, 183, 7, 'com_content.article.45', 'Syndicate Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(144, 50, 219, 220, 6, 'com_content.article.46', 'System', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(145, 44, 241, 242, 4, 'com_content.article.47', 'The Joomla! Community', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(146, 44, 243, 244, 4, 'com_content.article.48', 'The Joomla! Project', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(147, 48, 205, 206, 6, 'com_content.article.49', 'Typography', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(148, 44, 245, 246, 4, 'com_content.article.50', 'Upgraders', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(149, 50, 221, 222, 6, 'com_content.article.51', 'User', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(150, 46, 129, 130, 6, 'com_content.article.52', 'Users', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(151, 44, 247, 248, 4, 'com_content.article.53', 'Using Joomla!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(152, 46, 131, 132, 6, 'com_content.article.54', 'Weblinks', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(153, 95, 172, 173, 7, 'com_content.article.55', 'Weblinks Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(154, 94, 156, 157, 7, 'com_content.article.56', 'Who\'s Online', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(155, 108, 265, 266, 6, 'com_content.article.57', 'Wobbegone', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(156, 55, 286, 287, 5, 'com_content.article.58', 'Wonderful Watermelon', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(157, 96, 184, 185, 7, 'com_content.article.59', 'Wrapper Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(158, 46, 133, 134, 6, 'com_content.article.60', 'News Feeds', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(159, 166, 192, 193, 7, 'com_content.article.61', 'Breadcrumbs Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(160, 50, 223, 224, 6, 'com_content.article.62', 'Content', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(162, 109, 273, 274, 6, 'com_content.article.64', 'Blue Mountain Rain Forest', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(163, 109, 275, 276, 6, 'com_content.article.65', 'Ormiston Pound', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(165, 94, 158, 159, 7, 'com_content.article.66', 'Latest Users Module', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(166, 47, 189, 194, 6, 'com_content.category.75', 'Navigation Modules', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(167, 54, 293, 294, 4, 'com_content.category.76', 'Recipes', '{"core.create":{"12":1,"10":1},"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":{"12":1,"10":1}}'),
(168, 34, 112, 113, 3, 'com_content.article.67', 'What\'s New in 1.5?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(169, 8, 307, 344, 2, 'com_content.category.77', 'News', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(170, 169, 308, 319, 3, 'com_content.category.78', 'Latest', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(171, 170, 309, 310, 4, 'com_content.article.68', 'Welcome to Joomla!', ''),
(172, 170, 311, 312, 4, 'com_content.article.69', 'We are Volunteers', ''),
(173, 170, 313, 314, 4, 'com_content.article.70', 'Stick to the Code!', ''),
(174, 170, 315, 316, 4, 'com_content.article.71', 'The Legend of Buca di Beppo', ''),
(175, 170, 317, 318, 4, 'com_content.article.72', '1 Million Smiles', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(176, 169, 320, 331, 3, 'com_content.category.79', 'Newsflash', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(177, 176, 321, 322, 4, 'com_content.article.73', 'Newsflash 1', ''),
(178, 176, 323, 324, 4, 'com_content.article.74', 'Newsflash 2', ''),
(179, 176, 325, 326, 4, 'com_content.article.75', 'Newsflash 3', ''),
(180, 176, 327, 328, 4, 'com_content.article.76', 'Newsflash 5', ''),
(181, 176, 329, 330, 4, 'com_content.article.77', 'Newsflash 4', ''),
(182, 169, 332, 343, 3, 'com_content.category.80', 'Hot topic', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(183, 182, 333, 334, 4, 'com_content.article.78', 'Pretium tempor', ''),
(184, 182, 335, 336, 4, 'com_content.article.79', 'In Sed cursus orci', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(185, 182, 337, 338, 4, 'com_content.article.80', 'Aliquam et dictum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(186, 182, 339, 340, 4, 'com_content.article.81', 'Wisi tincidunt', ''),
(187, 182, 341, 342, 4, 'com_content.article.82', '3 Days in Puerto Rico', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(188, 8, 345, 398, 2, 'com_content.category.81', 'FAQs', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(189, 188, 346, 353, 3, 'com_content.category.82', 'New to Joomla!', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(190, 189, 347, 348, 4, 'com_content.article.83', 'Is it useful to install the sample data?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(191, 189, 349, 350, 4, 'com_content.article.84', 'How do I remove an Article?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(192, 189, 351, 352, 4, 'com_content.article.85', 'What is the difference between Archiving and Trashing an Article? ', ''),
(193, 188, 354, 367, 3, 'com_content.category.83', 'Current Users', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(194, 193, 355, 356, 4, 'com_content.article.86', 'How do I upgrade to Joomla! 1.5 ?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(195, 193, 357, 358, 4, 'com_content.article.87', 'What happened to the locale setting?', ''),
(196, 193, 359, 360, 4, 'com_content.article.88', 'Only one edit window! How do I create "Read more..."?', ''),
(197, 193, 361, 362, 4, 'com_content.article.89', 'Where is the Static Content Item?', ''),
(198, 193, 363, 364, 4, 'com_content.article.90', 'Where did the Installers go?', ''),
(199, 193, 365, 366, 4, 'com_content.article.91', 'Where did the Mambots go?', ''),
(200, 188, 368, 385, 3, 'com_content.category.84', 'General', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(201, 200, 369, 370, 4, 'com_content.article.92', 'Why does Joomla! 1.5 use utf-8 encoding?', ''),
(202, 200, 371, 372, 4, 'com_content.article.93', 'What is the FTP layer for?', ''),
(203, 200, 373, 374, 4, 'com_content.article.94', 'Can Joomla! 1.5 operate with PHP Safe Mode On?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(204, 200, 375, 376, 4, 'com_content.article.95', 'My MySQL  database does not support UTF-8. Do I have a problem?', ''),
(205, 200, 377, 378, 4, 'com_content.article.96', 'What are the requirements to run Joomla! 1.5?', ''),
(206, 200, 379, 380, 4, 'com_content.article.97', 'How do I install Joomla! 1.5?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(207, 200, 381, 382, 4, 'com_content.article.98', 'What is an Uncategorised Article?', ''),
(208, 200, 383, 384, 4, 'com_content.article.99', 'Is it possible to change A Menu Item\'s Type?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(209, 188, 386, 397, 3, 'com_content.category.85', 'Languages', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(210, 209, 387, 388, 4, 'com_content.article.100', 'How do I localise Joomla! to my language?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(211, 209, 389, 390, 4, 'com_content.article.101', 'What is the purpose of the collation selection in the installation screen?', ''),
(212, 209, 391, 392, 4, 'com_content.article.102', 'What languages are supported by Joomla! 1.6?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(213, 209, 393, 394, 4, 'com_content.article.103', 'Does the PDF icon render pictures and special characters?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(214, 209, 395, 396, 4, 'com_content.article.104', 'I installed with my own language, but the Back-end is still in English', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(215, 8, 399, 426, 2, 'com_content.category.86', 'About Joomla!', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(216, 215, 400, 407, 3, 'com_content.category.87', 'The Project', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(217, 216, 401, 402, 4, 'com_content.article.105', 'Joomla! License Guidelines', ''),
(218, 216, 403, 404, 4, 'com_content.article.106', 'Support and Documentation', ''),
(219, 216, 405, 406, 4, 'com_content.article.107', 'Platforms and Open Standards', ''),
(220, 215, 408, 419, 3, 'com_content.category.88', 'The CMS', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(221, 220, 409, 410, 4, 'com_content.article.108', 'Joomla! Features', ''),
(222, 220, 411, 412, 4, 'com_content.article.109', 'Joomla! Overview', ''),
(223, 220, 413, 414, 4, 'com_content.article.110', 'What\'s New In 1.5?', ''),
(224, 220, 415, 416, 4, 'com_content.article.111', 'Content Layouts', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(225, 220, 417, 418, 4, 'com_content.article.112', 'Extensions', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(226, 215, 420, 425, 3, 'com_content.category.89', 'The Community', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(227, 226, 421, 422, 4, 'com_content.article.113', 'Joomla! Facts', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(228, 226, 423, 424, 4, 'com_content.article.114', 'The Joomla! Community', ''),
(229, 8, 427, 540, 2, 'com_content.category.90', 'Sport', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(230, 229, 428, 447, 3, 'com_content.category.91', 'Football', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(231, 230, 429, 430, 4, 'com_content.article.115', 'Premier League summer transfer photos ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(232, 230, 431, 432, 4, 'com_content.article.116', 'Ferguson hails brave Arsenal after \'best game of the year\'', ''),
(233, 230, 433, 434, 4, 'com_content.article.117', 'Wenger\'s recipe for success', ''),
(234, 230, 435, 436, 4, 'com_content.article.118', 'How will the Premier League unfold?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(235, 230, 437, 438, 4, 'com_content.article.119', 'Are England right to be optimistic?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(236, 230, 439, 440, 4, 'com_content.article.120', 'Barcelona 3-0 Sporting Gijon', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(237, 230, 441, 442, 4, 'com_content.article.121', 'Volutpat euismod tincidunt', ''),
(238, 230, 443, 444, 4, 'com_content.article.122', 'Tincidunt vestibulum justo', ''),
(239, 230, 445, 446, 4, 'com_content.article.123', 'Congue mattis justo Fusce sed', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(240, 229, 448, 465, 3, 'com_content.category.92', 'Cricket', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(241, 240, 449, 450, 4, 'com_content.article.124', 'Jonathan Agnew column ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(242, 240, 451, 452, 4, 'com_content.article.125', 'The true Aussie sporting spirit', ''),
(243, 240, 453, 454, 4, 'com_content.article.126', 'Modi dismisses Steyn test reports ', ''),
(244, 240, 455, 456, 4, 'com_content.article.127', 'England stars offer summer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(245, 240, 457, 458, 4, 'com_content.article.128', 'Tortor pretium ipsum Maecenas', ''),
(246, 240, 459, 460, 4, 'com_content.article.129', 'Nibh metus vel diam et consectetuer est', ''),
(247, 240, 461, 462, 4, 'com_content.article.130', 'Habitant lobortis vitae pretium vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(248, 240, 463, 464, 4, 'com_content.article.131', 'Quisque odio adipiscing nullam', ''),
(249, 229, 466, 483, 3, 'com_content.category.93', 'Tennis', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(250, 249, 467, 468, 4, 'com_content.article.132', 'Russians Squeak Through Openers', ''),
(251, 249, 469, 470, 4, 'com_content.article.133', 'Elena Baltacha\'s diary', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(252, 249, 471, 472, 4, 'com_content.article.134', 'Murray eases through in Montreal ', ''),
(253, 249, 473, 474, 4, 'com_content.article.135', 'Consectetuer venenatis nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(254, 249, 475, 476, 4, 'com_content.article.136', 'Fringilla Maecenas libero ut faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(255, 249, 477, 478, 4, 'com_content.article.137', 'Ut id Quisque odio adipiscing', ''),
(256, 249, 479, 480, 4, 'com_content.article.138', 'Donec Curabitur consequat', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(257, 249, 481, 482, 4, 'com_content.article.139', 'Penatibus laoreet consectetuer', ''),
(258, 229, 484, 501, 3, 'com_content.category.94', 'Motorsport', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(259, 258, 485, 486, 4, 'com_content.article.140', 'Crash ends Raikkonen\'s WRC debut ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(260, 258, 487, 488, 4, 'com_content.article.141', 'Matt Roberts\' MotoGP column ', ''),
(261, 258, 489, 490, 4, 'com_content.article.142', 'Vestibulum Nullam pellentesque', ''),
(262, 258, 491, 492, 4, 'com_content.article.143', 'Vestibulum Nullam pellentesque', ''),
(263, 258, 493, 494, 4, 'com_content.article.144', 'Matt Roberts\' MotoGP column ', ''),
(264, 258, 495, 496, 4, 'com_content.article.145', 'Pellentesque Morbi vel metus Vestibulum ', ''),
(265, 258, 497, 498, 4, 'com_content.article.146', 'Dignissim Nam Nam ligula amet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(266, 258, 499, 500, 4, 'com_content.article.147', 'In nec suscipit metus eros mauris eu ipsum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(267, 229, 502, 521, 3, 'com_content.category.95', 'Horse racing', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(268, 267, 503, 504, 4, 'com_content.article.148', 'Glorious Goodwood photos ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(269, 267, 505, 506, 4, 'com_content.article.149', 'Racing - live!', ''),
(270, 267, 507, 508, 4, 'com_content.article.150', 'India Closes Torch Relay to Spectators', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(271, 267, 509, 510, 4, 'com_content.article.151', 'Enim sollicitudin habitasse', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(272, 267, 511, 512, 4, 'com_content.article.152', ' Morbi faucibus Sed Vivamus odio semper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(273, 267, 513, 514, 4, 'com_content.article.153', 'Dignissim sagittis tristique', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(274, 267, 515, 516, 4, 'com_content.article.154', 'Tortor est Aenean porttitor', ''),
(275, 267, 517, 518, 4, 'com_content.article.155', 'Phasellus Curabitur euismod tincidunt', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(276, 267, 519, 520, 4, 'com_content.article.156', 'Interdum gravida massa quis ac', ''),
(277, 229, 522, 539, 3, 'com_content.category.96', 'Boxing', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(278, 277, 523, 524, 4, 'com_content.article.157', 'In id metus laoreet dignissim vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(279, 277, 525, 526, 4, 'com_content.article.158', 'Vivamus lacinia velit velit amet', ''),
(280, 277, 527, 528, 4, 'com_content.article.159', 'A elit consequat interdum libero', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(281, 277, 529, 530, 4, 'com_content.article.160', 'Justo ligula nonummy ante nibh', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(282, 277, 531, 532, 4, 'com_content.article.161', 'Muscular African American Boxer', ''),
(283, 277, 533, 534, 4, 'com_content.article.162', 'Metus purus Vestibulum ac ut', ''),
(284, 277, 535, 536, 4, 'com_content.article.163', 'Platea fringilla volutpat', ''),
(285, 277, 537, 538, 4, 'com_content.article.164', 'Tincidunt vestibulum justo pulvinar', ''),
(286, 8, 541, 650, 2, 'com_content.category.97', 'Artist', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(287, 286, 542, 559, 3, 'com_content.category.98', 'Art', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(288, 287, 543, 544, 4, 'com_content.article.165', 'Sed id leo et vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(289, 287, 545, 546, 4, 'com_content.article.166', 'Spoken word  ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(290, 287, 547, 548, 4, 'com_content.article.167', 'Plinth moment for Booker authors', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(291, 287, 549, 550, 4, 'com_content.article.168', 'Consectetuer consequat pretium ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(292, 287, 551, 552, 4, 'com_content.article.169', 'Egestas Phasellus leo porttitor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(293, 287, 553, 554, 4, 'com_content.article.170', 'Ultrices semper sapien odio', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(294, 287, 555, 556, 4, 'com_content.article.171', 'Dolor dapibus Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(295, 287, 557, 558, 4, 'com_content.article.172', 'Sed tempus pretium pretium', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(296, 286, 560, 577, 3, 'com_content.category.99', 'Architecture', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(297, 296, 561, 562, 4, 'com_content.article.173', 'Egestas Phasellus leo porttitor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(298, 296, 563, 564, 4, 'com_content.article.174', 'Nec justo Ut et at risus Nam', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(299, 296, 565, 566, 4, 'com_content.article.175', 'Quam ligula Mauris ac a et morbi eu Vestibulum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(300, 296, 567, 568, 4, 'com_content.article.176', 'Pellentesque felis mollis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(301, 296, 569, 570, 4, 'com_content.article.177', 'Nec justo Ut et at risus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(302, 296, 571, 572, 4, 'com_content.article.178', 'Latest Joomla 3.0 template release', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(303, 296, 573, 574, 4, 'com_content.article.179', 'Feugiat auctor et eros Integer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(304, 296, 575, 576, 4, 'com_content.article.180', 'Sapien Nam eleifend sed pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(305, 286, 578, 595, 3, 'com_content.category.100', 'Design', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(306, 305, 579, 580, 4, 'com_content.article.181', 'Curabitur est at id ut Sed urna', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(307, 305, 581, 582, 4, 'com_content.article.182', 'Curabitur convallis laoreet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(308, 305, 583, 584, 4, 'com_content.article.183', 'Praesent Aenean Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(309, 305, 585, 586, 4, 'com_content.article.184', 'Cum mauris justo eros Donec Nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(310, 305, 587, 588, 4, 'com_content.article.185', 'Enim montes parturient', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(311, 305, 589, 590, 4, 'com_content.article.186', 'Aenean pharetra faucibus eu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(312, 305, 591, 592, 4, 'com_content.article.187', 'Aliquet egestas aliquam vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(313, 305, 593, 594, 4, 'com_content.article.188', 'Nunc Cras tincidunt mi vestibulum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(314, 286, 596, 613, 3, 'com_content.category.101', 'Photography', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(315, 314, 597, 598, 4, 'com_content.article.189', 'Vitae tempus eget at lorem sapien', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(316, 314, 599, 600, 4, 'com_content.article.190', 'Integer nisl Pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(317, 314, 601, 602, 4, 'com_content.article.191', 'Semper accumsan Integer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(318, 314, 603, 604, 4, 'com_content.article.192', 'Aliquam augue condimentum urna tortor id', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(319, 314, 605, 606, 4, 'com_content.article.193', 'Vivamus hac iaculis neque Morbi', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(320, 314, 607, 608, 4, 'com_content.article.194', 'Leo ornare egestas pretium odio', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(321, 314, 609, 610, 4, 'com_content.article.195', 'Nibh nibh consectetuer semper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(322, 314, 611, 612, 4, 'com_content.article.196', 'Joomla 3.0 are now live on Magazine Template', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(323, 286, 614, 631, 3, 'com_content.category.102', 'Graphics', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(324, 323, 615, 616, 4, 'com_content.article.197', 'Porta sed nec feugiat Vivamus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(325, 323, 617, 618, 4, 'com_content.article.198', 'Hendrerit velit orci sagittis eu Aenean', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(326, 323, 619, 620, 4, 'com_content.article.199', 'Curabitur auctor risus sem', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(327, 323, 621, 622, 4, 'com_content.article.200', 'Nam id Sed Donec pretium', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(328, 323, 623, 624, 4, 'com_content.article.201', 'Switching to Joomla 3.0 template', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(329, 323, 625, 626, 4, 'com_content.article.202', 'Praesent nibh leo eu justo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(330, 323, 627, 628, 4, 'com_content.article.203', ' Et Aenean id velit risus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(331, 323, 629, 630, 4, 'com_content.article.204', 'Tortor facilisi et interdum Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(332, 286, 632, 649, 3, 'com_content.category.103', '3D Computer Graphics', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(333, 332, 633, 634, 4, 'com_content.article.205', 'England stars offer summer coaching', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(334, 332, 635, 636, 4, 'com_content.article.206', 'Vel dolor ligula tristique magnis sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(335, 332, 637, 638, 4, 'com_content.article.207', 'Wenger\'s recipe for success', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(336, 332, 639, 640, 4, 'com_content.article.208', 'Suspendisse ligula feugiat', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(337, 332, 641, 642, 4, 'com_content.article.209', 'Maecenas nibh sed faucibus ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(338, 332, 643, 644, 4, 'com_content.article.210', 'Condimentum nibh venenatis vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(339, 332, 645, 646, 4, 'com_content.article.211', 'Nulla semper quis sapien', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(340, 332, 647, 648, 4, 'com_content.article.212', 'Id Vestibulum Donec Pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(341, 8, 651, 702, 2, 'com_content.category.104', 'Travel', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(342, 341, 652, 669, 3, 'com_content.category.105', 'Getaways', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(343, 342, 653, 654, 4, 'com_content.article.213', 'Hawaii-style fun on the mainland', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(344, 342, 655, 656, 4, 'com_content.article.214', 'Five festivals for last bit of summer fun', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(345, 342, 657, 658, 4, 'com_content.article.215', 'Are travel agents making a comeback?', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(346, 342, 659, 660, 4, 'com_content.article.216', 'Ut Mauris elit ipsum Pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(347, 342, 661, 662, 4, 'com_content.article.217', 'Tortor pretium orci semper platea', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(348, 342, 663, 664, 4, 'com_content.article.218', 'Libero euismod ac orci condimentum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(349, 342, 665, 666, 4, 'com_content.article.219', 'Lacinia vitae In ante ipsum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(350, 342, 667, 668, 4, 'com_content.article.220', 'Feugiat convallis turpis massa', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(351, 341, 670, 683, 3, 'com_content.category.106', 'Travel Tips', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(352, 351, 671, 672, 4, 'com_content.article.221', 'How to slide on airline luggage fees', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(353, 351, 673, 674, 4, 'com_content.article.222', 'How flight attendants deal with life on board', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(354, 351, 675, 676, 4, 'com_content.article.223', 'How to avoid the hazards of booking online', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(355, 351, 677, 678, 4, 'com_content.article.224', 'Trapped on the tarmac? Try these escape tips', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(356, 351, 679, 680, 4, 'com_content.article.225', 'Semper Sed eros dolor condimentum congue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(357, 351, 681, 682, 4, 'com_content.article.226', 'Lobortis rhoncus porttitor Nunc Cum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(358, 341, 684, 701, 3, 'com_content.category.107', 'Business Travel', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(359, 358, 685, 686, 4, 'com_content.article.227', 'September\'s show: traveling with a conscience', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(360, 358, 687, 688, 4, 'com_content.article.228', 'Taking the ethical high road', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(361, 358, 689, 690, 4, 'com_content.article.229', '3 biggest mistakes business travelers make', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(362, 358, 691, 692, 4, 'com_content.article.230', 'Giving something back', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(363, 358, 693, 694, 4, 'com_content.article.231', '9 essential travel strategies for 2009', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(364, 358, 695, 696, 4, 'com_content.article.232', 'Vestibulum orci Quisque hendrerit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(365, 358, 697, 698, 4, 'com_content.article.233', 'Magazine Joomla 3.0 template is now available', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(366, 358, 699, 700, 4, 'com_content.article.234', 'Porttitor fringilla sed natoque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(367, 8, 703, 812, 2, 'com_content.category.108', 'Life and Style', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(368, 367, 704, 721, 3, 'com_content.category.109', 'Fashion and Beauty', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(369, 368, 705, 706, 4, 'com_content.article.235', 'The Fall of Christian Lacroix', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(370, 368, 707, 708, 4, 'com_content.article.236', 'Tips to Soothe Your Skin ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(371, 368, 709, 710, 4, 'com_content.article.237', '\'How to\' with Joomla 3.0 template!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(372, 368, 711, 712, 4, 'com_content.article.238', 'Maecenas augue enim felis Nam', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(373, 368, 713, 714, 4, 'com_content.article.239', 'In condimentum mauris Integer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(374, 368, 715, 716, 4, 'com_content.article.240', 'Lobortis rhoncus porttitor Nunc Cum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(375, 368, 717, 718, 4, 'com_content.article.241', 'Enim sollicitudin habitasse Nam', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(376, 368, 719, 720, 4, 'com_content.article.242', 'Rhoncus tellus eros enim netus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(377, 367, 722, 739, 3, 'com_content.category.110', 'Food and Drink', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(378, 377, 723, 724, 4, 'com_content.article.243', 'Quisque Suspendisse consequat', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(379, 377, 725, 726, 4, 'com_content.article.244', 'Podcast: the awards ceremony', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(380, 377, 727, 728, 4, 'com_content.article.245', 'Best restaurant', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(381, 377, 729, 730, 4, 'com_content.article.246', 'Vestibulum sem wisi eu at et Morbi congue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(382, 377, 731, 732, 4, 'com_content.article.247', 'Vestibulum sem wisi eu at et ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(383, 377, 733, 734, 4, 'com_content.article.248', 'Morbi congue ac sapien sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(384, 377, 735, 736, 4, 'com_content.article.249', 'Migrating to Joomla 3.0 - The path!', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(385, 377, 737, 738, 4, 'com_content.article.250', 'Vestibulum sem wisi congue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(386, 367, 740, 757, 3, 'com_content.category.111', 'Homes and Gardens', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(387, 386, 741, 742, 4, 'com_content.article.251', 'Snooping around', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(388, 386, 743, 744, 4, 'com_content.article.252', 'Cause for alarm', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(389, 386, 745, 746, 4, 'com_content.article.253', 'Fit for a Bond baddy', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(390, 386, 747, 748, 4, 'com_content.article.254', 'Proin nisl urna pretium Aenean', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}');
INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`) VALUES
(391, 386, 749, 750, 4, 'com_content.article.255', 'At et ac pretium Sed senectus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(392, 386, 751, 752, 4, 'com_content.article.256', 'Auctor et Sed at sodales', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(393, 386, 753, 754, 4, 'com_content.article.257', 'Ipsum sagittis venenatis Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(394, 386, 755, 756, 4, 'com_content.article.258', 'Curabitur euismod tincidunt Aenean ante', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(395, 367, 758, 775, 3, 'com_content.category.112', 'Shop', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(396, 395, 759, 760, 4, 'com_content.article.259', 'Karcher K2900M pressure washer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(397, 395, 761, 762, 4, 'com_content.article.260', 'Plug multiplier', ''),
(398, 395, 763, 764, 4, 'com_content.article.261', 'Multi-purpose oval roaster', ''),
(399, 395, 765, 766, 4, 'com_content.article.262', 'Enim sollicitudin habitasse', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(400, 395, 767, 768, 4, 'com_content.article.263', 'Rhoncus tellus eros enim netus', ''),
(401, 395, 769, 770, 4, 'com_content.article.264', 'Vestibulum sem wisi', ''),
(402, 395, 771, 772, 4, 'com_content.article.265', 'Morbi congue ac sapien sit', ''),
(403, 395, 773, 774, 4, 'com_content.article.266', 'Ipsum sagittis venenatis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(404, 367, 776, 793, 3, 'com_content.category.113', 'Mother and Children', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(405, 404, 777, 778, 4, 'com_content.article.267', 'Eu congue orci nascetur tellus Lorem', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(406, 404, 779, 780, 4, 'com_content.article.268', 'Est Cum elit consectetuer consectetuer', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(407, 404, 781, 782, 4, 'com_content.article.269', 'Nibh vitae metus eget ut condimentum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(408, 404, 783, 784, 4, 'com_content.article.270', 'Augue turpis eget In elit pellentesque', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(409, 404, 785, 786, 4, 'com_content.article.271', 'Montes nibh justo faucibus sit orci sed', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(410, 404, 787, 788, 4, 'com_content.article.272', 'Morbi faucibus Sed Vivamus odio', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(411, 404, 789, 790, 4, 'com_content.article.273', 'Rhoncus tellus eros enim netus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(412, 404, 791, 792, 4, 'com_content.article.274', 'Porttitor ipsum mauris non semper', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(413, 367, 794, 811, 3, 'com_content.category.114', 'Wife and Husband', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(414, 413, 795, 796, 4, 'com_content.article.275', 'In id metus laoreet dignissim vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(415, 413, 797, 798, 4, 'com_content.article.276', 'Wenger\'s recipe for success', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(416, 413, 799, 800, 4, 'com_content.article.277', 'Glorious Goodwood photos ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(417, 413, 801, 802, 4, 'com_content.article.278', 'Semper senectus elit eu nibh auctor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(418, 413, 803, 804, 4, 'com_content.article.279', 'Vel dolor ligula tristique magnis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(419, 413, 805, 806, 4, 'com_content.article.280', 'Aenean Vestibulum lorem egestas', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(420, 413, 807, 808, 4, 'com_content.article.281', 'Sed nibh dui Vestibulum sed ante fringilla est leo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(421, 413, 809, 810, 4, 'com_content.article.282', 'Habitant lobortis vitae pretium vitae vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(422, 8, 813, 852, 2, 'com_content.category.115', 'Health', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(423, 422, 814, 827, 3, 'com_content.category.116', 'What Ails You', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(424, 423, 815, 816, 4, 'com_content.article.283', 'Who\'s your daddy? A celebrity look-alike', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(425, 423, 817, 818, 4, 'com_content.article.284', 'Mommies who drink: No joking after the Schuler tragedy', ''),
(426, 423, 819, 820, 4, 'com_content.article.285', 'Peanut-free night lets allergic kids enjoy game', ''),
(427, 423, 821, 822, 4, 'com_content.article.286', 'Nam nibh adipiscing turpis', ''),
(428, 423, 823, 824, 4, 'com_content.article.287', 'Phasellus suscipit ante leo', ''),
(429, 423, 825, 826, 4, 'com_content.article.288', 'Aliquam pretium Aenean', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(430, 422, 828, 841, 3, 'com_content.category.117', 'Diet and Fitness', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(431, 430, 829, 830, 4, 'com_content.article.289', 'Sex Therapists: a Few Minutes Is Best', ''),
(432, 430, 831, 832, 4, 'com_content.article.290', 'Troops Suffering Trauma Reaches 320,000', ''),
(433, 430, 833, 834, 4, 'com_content.article.291', 'Three Deaths... by Infected Hamster?', ''),
(434, 430, 835, 836, 4, 'com_content.article.292', 'Nutrition -- It\'s a matter of fact', ''),
(435, 430, 837, 838, 4, 'com_content.article.293', 'Condimentum mauris interdum velit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(436, 430, 839, 840, 4, 'com_content.article.294', 'Turpis nonummy id Cras et', ''),
(437, 422, 842, 851, 3, 'com_content.category.118', 'You and Your Family', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(438, 437, 843, 844, 4, 'com_content.article.295', 'Drinking, Smoking May Hasten Alzheimer\'s', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(439, 437, 845, 846, 4, 'com_content.article.296', 'New Nerve Disorder From Pig Brain Mist', ''),
(440, 437, 847, 848, 4, 'com_content.article.297', 'Help for aging parents is clicks away', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(441, 437, 849, 850, 4, 'com_content.article.298', 'Feds Back Stem Cell Surgery for Vets', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(442, 8, 853, 964, 2, 'com_content.category.119', 'Entertainment', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(443, 442, 854, 871, 3, 'com_content.category.120', 'Movies', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(444, 443, 855, 856, 4, 'com_content.article.299', 'Ut fames Duis nibh arcu', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(445, 443, 857, 858, 4, 'com_content.article.300', 'Et Aliquam pretium faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(446, 443, 859, 860, 4, 'com_content.article.301', 'Curabitur nec enim Lorem Morbi', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(447, 443, 861, 862, 4, 'com_content.article.302', 'Nam feugiat mi id In urna', ''),
(448, 443, 863, 864, 4, 'com_content.article.303', 'Quis eros nisl leo Duis pede', ''),
(449, 443, 865, 866, 4, 'com_content.article.304', 'Vestibulum nec Phasellus facilisi', ''),
(450, 443, 867, 868, 4, 'com_content.article.305', 'Magnis nibh fringilla Vivamus', ''),
(451, 443, 869, 870, 4, 'com_content.article.306', 'Sed Phasellus laoreet condimentum', ''),
(452, 442, 872, 889, 3, 'com_content.category.121', 'TV', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(453, 452, 873, 874, 4, 'com_content.article.307', 'Curabitur nec enim id', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(454, 452, 875, 876, 4, 'com_content.article.308', 'Orci rutrum lacus feugiat', ''),
(455, 452, 877, 878, 4, 'com_content.article.309', 'Orci rutrum lacus feugiat', ''),
(456, 452, 879, 880, 4, 'com_content.article.310', 'Sed interdum sed dapibus quis', ''),
(457, 452, 881, 882, 4, 'com_content.article.311', 'Fames Ut lorem at est tincidunt', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(458, 452, 883, 884, 4, 'com_content.article.312', 'Congue condimentum orci id et', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(459, 452, 885, 886, 4, 'com_content.article.313', 'Interdum quis Nam et id nulla', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(460, 452, 887, 888, 4, 'com_content.article.314', 'Ultrices Phasellus', ''),
(461, 442, 890, 907, 3, 'com_content.category.122', 'Music', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(462, 461, 891, 892, 4, 'com_content.article.315', 'Curabitur convallis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(463, 461, 893, 894, 4, 'com_content.article.316', 'Semper accumsan Integer', ''),
(464, 461, 895, 896, 4, 'com_content.article.317', 'Dolor ut id enim dolor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(465, 461, 897, 898, 4, 'com_content.article.318', 'Ac adipiscing et urna nibh', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(466, 461, 899, 900, 4, 'com_content.article.319', 'Nam feugiat est dolor leo', ''),
(467, 461, 901, 902, 4, 'com_content.article.320', 'Tempor magnis tincidunt euismod', ''),
(468, 461, 903, 904, 4, 'com_content.article.321', 'Vestibulum et eu', ''),
(469, 461, 905, 906, 4, 'com_content.article.322', 'Nulla molestie congue', ''),
(470, 442, 908, 925, 3, 'com_content.category.123', 'Books', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(471, 470, 909, 910, 4, 'com_content.article.323', 'Vel arcu in Curabitur', ''),
(472, 470, 911, 912, 4, 'com_content.article.324', 'Dolor ut id enim dolor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(473, 470, 913, 914, 4, 'com_content.article.325', ' Paris\' Red-Hot London Jaunt', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(474, 470, 915, 916, 4, 'com_content.article.326', 'Tincidunt nulla a Nulla eu', ''),
(475, 470, 917, 918, 4, 'com_content.article.327', 'Justo quam orci ipsum enim', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(476, 470, 919, 920, 4, 'com_content.article.328', 'Vestibulum ac pede id Cum', ''),
(477, 470, 921, 922, 4, 'com_content.article.329', 'Sem laoreet congue Sed', ''),
(478, 470, 923, 924, 4, 'com_content.article.330', 'Nulla Vivamus convallis nibh', ''),
(479, 442, 926, 945, 3, 'com_content.category.124', 'Games', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(480, 479, 927, 928, 4, 'com_content.article.331', 'Vel lorem fringilla ante nunc', ''),
(481, 479, 929, 930, 4, 'com_content.article.332', 'Dui Phasellus Nam pretium', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(482, 479, 931, 932, 4, 'com_content.article.333', 'Congue non est velit Vivamus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(483, 479, 933, 934, 4, 'com_content.article.334', 'Vestibulum at Vestibulum condimentum', ''),
(484, 479, 935, 936, 4, 'com_content.article.335', 'Convallis est urna tortor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(485, 479, 937, 938, 4, 'com_content.article.336', 'Vitae nibh Vestibulum', ''),
(486, 479, 939, 940, 4, 'com_content.article.337', 'Velit Fusce accumsan elit', ''),
(487, 479, 941, 942, 4, 'com_content.article.338', 'Ante ultrices vel adipiscing', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(488, 479, 943, 944, 4, 'com_content.article.339', 'Velit Fusce accumsan elit', ''),
(489, 442, 946, 963, 3, 'com_content.category.125', 'Theatre', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(490, 489, 947, 948, 4, 'com_content.article.340', 'Congue non est velit Vivamus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(491, 489, 949, 950, 4, 'com_content.article.341', 'Et Aliquam pretium faucibus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(492, 489, 951, 952, 4, 'com_content.article.342', 'Orci rutrum lacus feugiat', ''),
(493, 489, 953, 954, 4, 'com_content.article.343', 'Cum habitasse molestie rhoncus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(494, 489, 955, 956, 4, 'com_content.article.344', 'Malesuada consectetuer hendrerit', ''),
(495, 489, 957, 958, 4, 'com_content.article.345', 'Ut nunc fames dui quis', ''),
(496, 489, 959, 960, 4, 'com_content.article.346', 'Phasellus molestie quis', ''),
(497, 489, 961, 962, 4, 'com_content.article.347', 'Nulla vel in Nam id Phasellus', ''),
(498, 8, 965, 1076, 2, 'com_content.category.126', 'World', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(499, 498, 966, 985, 3, 'com_content.category.127', 'Europe', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(500, 499, 967, 968, 4, 'com_content.article.348', 'UAE\'s Aabar to Build Trucks in Algeria ', ''),
(501, 499, 969, 970, 4, 'com_content.article.349', 'Anheuser Refreshes Bud Light Ads', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(502, 499, 971, 972, 4, 'com_content.article.350', 'U.K. Taxpayers Face Less of a Bill', ''),
(503, 499, 973, 974, 4, 'com_content.article.351', 'Friends Agrees to Resolution Takeover ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(504, 499, 975, 976, 4, 'com_content.article.352', 'Augue et montes montes ut', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(505, 499, 977, 978, 4, 'com_content.article.353', 'Ornare nisl nibh leo a nulla', ''),
(506, 499, 979, 980, 4, 'com_content.article.354', 'Congue eget tempus lacus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(507, 499, 981, 982, 4, 'com_content.article.355', 'Lobortis Nunc hac quis', ''),
(508, 499, 983, 984, 4, 'com_content.article.356', 'Consequat id Nam augue', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(509, 498, 986, 1003, 3, 'com_content.category.128', 'U.S. Politics', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(510, 509, 987, 988, 4, 'com_content.article.357', 'Lawmakers Urged to Raise Debt Limit ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(511, 509, 989, 990, 4, 'com_content.article.358', 'Clinton Addresses War Crimes in Congo ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(512, 509, 991, 992, 4, 'com_content.article.359', 'U.S., Mexico, Canada Vow Cooperation ', ''),
(513, 509, 993, 994, 4, 'com_content.article.360', 'Obama and the Practice of Medicine ', ''),
(514, 509, 995, 996, 4, 'com_content.article.361', 'In Maecenas quis ligula', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(515, 509, 997, 998, 4, 'com_content.article.362', 'Pellentesque odio dapibus', ''),
(516, 509, 999, 1000, 4, 'com_content.article.363', 'Ante semper sapien lorem', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(517, 509, 1001, 1002, 4, 'com_content.article.364', 'Senectus Aliquam orci In sed', ''),
(518, 498, 1004, 1021, 3, 'com_content.category.129', 'Middle East', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(519, 518, 1005, 1006, 4, 'com_content.article.365', 'Attacks kill at least 42 in Iraq on Shiite religious holiday', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(520, 518, 1007, 1008, 4, 'com_content.article.366', 'Ex-homeless woman leaves $150,000 to Hebrew University', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(521, 518, 1009, 1010, 4, 'com_content.article.367', 'Al Qaeda blamed for Iraq violence wave', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(522, 518, 1011, 1012, 4, 'com_content.article.368', 'Hac Morbi ac leo at felis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(523, 518, 1013, 1014, 4, 'com_content.article.369', 'Tincidunt cursus quam ', ''),
(524, 518, 1015, 1016, 4, 'com_content.article.370', 'Et Nunc mus sem Nunc Cras', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(525, 518, 1017, 1018, 4, 'com_content.article.371', 'Sed et elit condimentum', ''),
(526, 518, 1019, 1020, 4, 'com_content.article.372', 'Elit risus In justo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(527, 498, 1022, 1039, 3, 'com_content.category.130', 'Africa', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(528, 527, 1023, 1024, 4, 'com_content.article.373', 'Protests as Sudan \'tight pants\' trial delayed', ''),
(529, 527, 1025, 1026, 4, 'com_content.article.374', 'Hillary Clinton: We\'re committed to Africa\'s future', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(530, 527, 1027, 1028, 4, 'com_content.article.375', 'Zimbabwe\'s writers connected to their country', ''),
(531, 527, 1029, 1030, 4, 'com_content.article.376', 'Nunc egestas ut tempus', ''),
(532, 527, 1031, 1032, 4, 'com_content.article.377', 'Aenean at vel interdum', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(533, 527, 1033, 1034, 4, 'com_content.article.378', 'Aenean Donec gravida hendrerit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(534, 527, 1035, 1036, 4, 'com_content.article.379', 'Nam cursus odio et quis convallis', ''),
(535, 527, 1037, 1038, 4, 'com_content.article.380', 'Felis tempor felis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(536, 498, 1040, 1057, 3, 'com_content.category.131', 'Science', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(537, 536, 1041, 1042, 4, 'com_content.article.381', 'Dolor ut id enim dolor auctor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(538, 536, 1043, 1044, 4, 'com_content.article.382', 'Tellus laoreet pretium non auctor tincidunt', ''),
(539, 536, 1045, 1046, 4, 'com_content.article.383', 'Lacinia Sed convallis urna lacus interdum', ''),
(540, 536, 1047, 1048, 4, 'com_content.article.384', 'Metus felis faucibus sem', ''),
(541, 536, 1049, 1050, 4, 'com_content.article.385', 'Porttitor ut vitae pretium ut', ''),
(542, 536, 1051, 1052, 4, 'com_content.article.386', 'Nam leo consectetuer velit mauris', ''),
(543, 536, 1053, 1054, 4, 'com_content.article.387', 'A eget Vivamus Quisque senectus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(544, 536, 1055, 1056, 4, 'com_content.article.388', 'Tellus convallis et Nam enim', ''),
(545, 498, 1058, 1075, 3, 'com_content.category.132', 'Pacific', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(546, 545, 1059, 1060, 4, 'com_content.article.389', 'Nibh volutpat tortor augue convallis', ''),
(547, 545, 1061, 1062, 4, 'com_content.article.390', 'Semper accumsan Integer nisl Pellentesque', ''),
(548, 545, 1063, 1064, 4, 'com_content.article.391', 'Aenean Vestibulum lorem egestas', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(549, 545, 1065, 1066, 4, 'com_content.article.392', 'TIME', ''),
(550, 545, 1067, 1068, 4, 'com_content.article.393', 'Rhoncus Donec Curabitur in', ''),
(551, 545, 1069, 1070, 4, 'com_content.article.394', 'Enim sodales ligula Phasellus', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(552, 545, 1071, 1072, 4, 'com_content.article.395', 'Convallis eget justo justo', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(553, 545, 1073, 1074, 4, 'com_content.article.396', 'Vestibulum quam nec magna', ''),
(554, 8, 1077, 1186, 2, 'com_content.category.133', 'Technology', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(555, 554, 1078, 1095, 3, 'com_content.category.134', 'Personal Tech', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(556, 555, 1079, 1080, 4, 'com_content.article.397', 'Nibh volutpat tortor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(557, 555, 1081, 1082, 4, 'com_content.article.398', 'Praesent Aenean Phasellus', ''),
(558, 555, 1083, 1084, 4, 'com_content.article.399', 'An Apple for Your Teacher', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(559, 555, 1085, 1086, 4, 'com_content.article.400', 'Urna dis dictumst tempor', ''),
(560, 555, 1087, 1088, 4, 'com_content.article.401', 'Vestibulum tincidunt Vivamus et aliquam', ''),
(561, 555, 1089, 1090, 4, 'com_content.article.402', 'Magna elit tempus neque Phasellus', ''),
(562, 555, 1091, 1092, 4, 'com_content.article.403', 'Hac fames nunc et magna tempor gravida', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(563, 555, 1093, 1094, 4, 'com_content.article.404', 'Tempus pretium ullamcorper eget', ''),
(564, 554, 1096, 1113, 3, 'com_content.category.135', 'Business Tech', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(565, 564, 1097, 1098, 4, 'com_content.article.405', 'Semper accumsan Integer', ''),
(566, 564, 1099, 1100, 4, 'com_content.article.406', 'Nullam et nascetur vel', ''),
(567, 564, 1101, 1102, 4, 'com_content.article.407', 'Sony, Stung by Losses, Delays Thin TV', ''),
(568, 564, 1103, 1104, 4, 'com_content.article.408', 'Pellentesque In id metus', ''),
(569, 564, 1105, 1106, 4, 'com_content.article.409', 'Morbi faucibus et', ''),
(570, 564, 1107, 1108, 4, 'com_content.article.410', 'Nunc lacus quis dui adipiscing', ''),
(571, 564, 1109, 1110, 4, 'com_content.article.411', 'Interdum sagittis velit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(572, 564, 1111, 1112, 4, 'com_content.article.412', 'Magna convallis egestas', ''),
(573, 554, 1114, 1131, 3, 'com_content.category.136', 'Space', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(574, 573, 1115, 1116, 4, 'com_content.article.413', 'Adipiscing leo quis wisi justo dui', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(575, 573, 1117, 1118, 4, 'com_content.article.414', 'Curabitur convallis laoreet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(576, 573, 1119, 1120, 4, 'com_content.article.415', 'Telescopes to show universe soon after Big Bang', ''),
(577, 573, 1121, 1122, 4, 'com_content.article.416', 'Vivamus et aliquam Phasellus fames', ''),
(578, 573, 1123, 1124, 4, 'com_content.article.417', 'In et et justo Donec amet velit sem cursus velit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(579, 573, 1125, 1126, 4, 'com_content.article.418', 'Augue nunc at neque vitae metus vel', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(580, 573, 1127, 1128, 4, 'com_content.article.419', 'At laoreet eu lacus non Curabitur leo dui ut nibh', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(581, 573, 1129, 1130, 4, 'com_content.article.420', 'Morbi nibh Vestibulum venenatis nunc', ''),
(582, 554, 1132, 1149, 3, 'com_content.category.137', 'Science', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(583, 582, 1133, 1134, 4, 'com_content.article.421', 'Urna id in nibh sodales', ''),
(584, 582, 1135, 1136, 4, 'com_content.article.422', 'Vivamus arcu lorem sem urna', ''),
(585, 582, 1137, 1138, 4, 'com_content.article.423', 'Hac Morbi ac leo at felis at convallis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(586, 582, 1139, 1140, 4, 'com_content.article.424', 'Aliquet eu lacinia vitae', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(587, 582, 1141, 1142, 4, 'com_content.article.425', 'Lorem pede at quis Nulla', ''),
(588, 582, 1143, 1144, 4, 'com_content.article.426', 'In Curabitur id risus sit', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(589, 582, 1145, 1146, 4, 'com_content.article.427', 'Porttitor ipsum dolor fermentum', ''),
(590, 582, 1147, 1148, 4, 'com_content.article.428', 'Vel arcu in Curabitur est at', ''),
(591, 554, 1150, 1167, 3, 'com_content.category.138', 'Green Tech', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(592, 591, 1151, 1152, 4, 'com_content.article.429', 'Pellentesque nec orci molestie', ''),
(593, 591, 1153, 1154, 4, 'com_content.article.430', 'Nam auctor suscipit interdum laoreet', ''),
(594, 591, 1155, 1156, 4, 'com_content.article.431', 'Ligula Nunc lacus quis dui adipiscing', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(595, 591, 1157, 1158, 4, 'com_content.article.432', 'Morbi nibh Vestibulum venenatis nunc libero', ''),
(596, 591, 1159, 1160, 4, 'com_content.article.433', 'Vivamus et aliquam Phasellus fames', ''),
(597, 591, 1161, 1162, 4, 'com_content.article.434', 'Proin feugiat id enim nibh nulla auctor', ''),
(598, 591, 1163, 1164, 4, 'com_content.article.435', 'Eget consequat hendrerit tempus porttitor', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(599, 591, 1165, 1166, 4, 'com_content.article.436', 'Curabitur urna Suspendisse nibh laoreet', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(600, 554, 1168, 1185, 3, 'com_content.category.139', 'Security', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[],"core.edit.own":[]}'),
(601, 600, 1169, 1170, 4, 'com_content.article.437', 'Ut fames Duis nibh arcu', ''),
(602, 600, 1171, 1172, 4, 'com_content.article.438', 'Semper accumsan Integer nisl Pellentesque', ''),
(603, 600, 1173, 1174, 4, 'com_content.article.439', 'Vestibulum sodales quis sed lorem quis Curabitur eros', ''),
(604, 600, 1175, 1176, 4, 'com_content.article.440', 'At Pellentesque id quis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(605, 600, 1177, 1178, 4, 'com_content.article.441', 'Integer justo lorem sagittis', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(606, 600, 1179, 1180, 4, 'com_content.article.442', 'Neque justo laoreet', ''),
(607, 600, 1181, 1182, 4, 'com_content.article.443', 'Sed dolor condimentum', ''),
(608, 600, 1183, 1184, 4, 'com_content.article.444', 'Quisque leo non malesuada', ''),
(609, 3, 11, 12, 2, 'com_banners.category.140', 'Text Ads', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(610, 3, 13, 14, 2, 'com_banners.category.141', 'Fashion', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(611, 3, 15, 16, 2, 'com_banners.category.142', 'Sport ', '{"core.create":[],"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(612, 34, 114, 115, 3, 'com_content.article.445', '10 Things you MUST know about Teline III ', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(617, 1, 1308, 1309, 1, 'com_jaextmanager', 'com_jaextmanager', '{}'),
(614, 39, 300, 301, 3, 'com_content.article.446', 'Content + Right laylout', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(615, 39, 302, 303, 3, 'com_content.article.447', '3 Columns', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(616, 39, 304, 305, 3, 'com_content.article.448', 'Full width', '{"core.delete":[],"core.edit":[],"core.edit.state":[]}'),
(618, 1, 1310, 1311, 1, 'com_finder', 'com_finder', '{"core.admin":{"8":1},"core.manage":{"7":1},"core.create":{"6":1,"3":1},"core.delete":{"6":1},"core.edit":{"6":1,"4":1},"core.edit.state":{"6":1,"5":1}}'),
(619, 1, 1312, 1313, 1, '#__ucm_content.1', '#__ucm_content.1', '[]'),
(620, 1, 1314, 1315, 1, '#__ucm_content.2', '#__ucm_content.2', '[]'),
(621, 1, 1316, 1317, 1, '#__ucm_content.3', '#__ucm_content.3', '[]'),
(622, 1, 1318, 1319, 1, '#__ucm_content.4', '#__ucm_content.4', '[]'),
(623, 1, 1320, 1321, 1, '#__ucm_content.5', '#__ucm_content.5', '[]'),
(624, 1, 1322, 1323, 1, '#__ucm_content.6', '#__ucm_content.6', '[]'),
(625, 1, 1324, 1325, 1, '#__ucm_content.7', '#__ucm_content.7', '[]'),
(626, 1, 1326, 1327, 1, '#__ucm_content.8', '#__ucm_content.8', '[]');

DROP TABLE IF EXISTS `#__associations`;
CREATE TABLE `#__associations` (
  `id` int(11) NOT NULL COMMENT 'A reference to the associated item.',
  `context` varchar(50) NOT NULL COMMENT 'The context of the associated item.',
  `key` char(32) NOT NULL COMMENT 'The key for the association computed from an md5 on associated ids.',
  PRIMARY KEY (`context`,`id`),
  KEY `idx_key` (`key`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__banner_clients`;
CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM ;

INSERT INTO `#__banner_clients` (`id`, `name`, `contact`, `email`, `extrainfo`, `state`, `checked_out`, `checked_out_time`, `metakey`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`) VALUES
(1, 'Joomla!', 'Administrator', 'email@email.com', '', 1, 0, '0000-00-00 00:00:00', '', 0, '', -1, -1, -1);

DROP TABLE IF EXISTS `#__banner_tracks`;
CREATE TABLE `#__banner_tracks` (
  `track_date` datetime NOT NULL,
  `track_type` int(10) unsigned NOT NULL,
  `banner_id` int(10) unsigned NOT NULL,
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`track_date`,`track_type`,`banner_id`),
  KEY `idx_track_date` (`track_date`),
  KEY `idx_track_type` (`track_type`),
  KEY `idx_banner_id` (`banner_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__banners`;
CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `version`) VALUES
(2, 1, 0, 'Shop 1', 'shop-1', 0, 16, 0, 'http://shop.joomla.org/amazoncom-bookstores.html', 1, 15, 'Get books about Joomla! at the Joomla! book shop.', '', 0, 1, '', '{"imageurl":"images\\/banners\\/shop-ad-books.jpg","width":"","height":"","alt":"Joomla! Books"}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2010-01-12 00:25:24', 'en-GB', 0, '', '0000-00-00 00:00:00', 0, 1),
(3, 1, 0, 'Shop 2', 'shop-2', 0, 22, 0, 'http://shop.joomla.org', 1, 15, 'T Shirts, caps and more from the Joomla! Shop.', '', 0, 2, '', '{"imageurl":"images\\/banners\\/shop-ad.jpg","width":"","height":"","alt":"Joomla! Shop"}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2010-01-12 00:35:30', 'en-GB', 0, '', '0000-00-00 00:00:00', 0, 1),
(4, 1, 0, 'Support Joomla!', 'support-joomla', 0, 19, 0, 'http://contribute.joomla.org', 1, 15, 'Your contributions of time, talent and money make Joomla! possible.', '', 0, 3, '', '{"imageurl":"images\\/banners\\/white.png","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2010-01-12 00:55:54', 'en-GB', 0, '', '0000-00-00 00:00:00', 0, 1),
(5, 1, 0, 'Fashion', 'fashion', 0, 1104, 0, 'http://www.joomlart.com', 1, 141, '', '', 0, 1, '', '{"imageurl":"images\\/banners\\/imgad-1.jpg","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-29 00:00:00', '2010-12-29 17:30:44', '*', 0, '', '0000-00-00 00:00:00', 0, 1),
(6, 1, 0, 'Play F1 fantasy', 'play-f1-fantasy', 0, 0, 0, '', 1, 142, '', '', 0, 1, '', '{"imageurl":"images\\/banners\\/sport.jpg","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-29 00:00:00', '2010-12-29 17:33:16', '*', 0, '', '0000-00-00 00:00:00', 0, 1),
(7, 0, 1, 'Joomla!', 'joomla', 0, 1396, 0, '', 1, 140, '', '<a href="http://www.joomla.org" target="_blank">Joomla!</a>\r\n<br/>\r\nJoomla! The most popular and widely used Open Source CMS Project in the world.', 0, 4, '', '{"imageurl":"","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-29 00:00:00', '2010-12-29 17:35:23', '*', 0, '', '0000-00-00 00:00:00', 0, 1),
(8, 0, 1, 'JoomlaCode', 'joomlacode', 0, 1676, 0, '', 1, 140, '', '<a href="http://joomlacode.org" target="_blank">JoomlaCode</a>\r\n<br/>\r\nJoomlaCode, development and distribution made easy.', 0, 1, '', '{"imageurl":"","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-29 00:00:00', '2010-12-29 17:37:18', '*', 0, '', '0000-00-00 00:00:00', 0, 1),
(9, 0, 1, 'Joomla! Extensions', 'joomla-extensions', 0, 1676, 0, '', 1, 140, '', '<a href="http://extensions.joomla.org" target="_blank">Joomla! Extensions</a>\r\n<br/>\r\nJoomla! Components, Modules, Plugins and Languages by the bucket load.', 0, 2, '', '{"imageurl":"","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-29 00:00:00', '2010-12-29 17:38:29', '*', 0, '', '0000-00-00 00:00:00', 0, 1),
(10, 0, 1, 'Joomla! Shop', 'joomla-shop', 0, 1676, 0, '', 1, 140, '', '<a href="http://shop.joomla.org" target="_blank">Joomla! Shop</a>\r\n<br/>\r\nFor all your Joomla! merchandise.', 0, 3, '', '{"imageurl":"","width":"","height":"","alt":""}', 0, '', -1, 0, 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '2011-01-29 00:00:00', '2010-12-29 17:39:19', '*', 0, '', '0000-00-00 00:00:00', 0, 1);

DROP TABLE IF EXISTS `#__categories`;
CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned DEFAULT NULL,
  `params` text,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`) VALUES
(1, 0, 0, 0, 267, 0, '', 'system', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 42, '2009-10-18 16:07:09', 0, '0000-00-00 00:00:00', 0, '*', 1),
(9, 34, 1, 133, 134, 1, 'uncategorised', 'com_content', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:52:03', 42, '2010-07-12 16:09:07', 0, '*', 1),
(10, 35, 1, 131, 132, 1, 'uncategorised', 'com_banners', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:52:16', 0, '0000-00-00 00:00:00', 0, '*', 1),
(11, 36, 1, 127, 128, 1, 'uncategorised', 'com_contact', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:00', 0, '0000-00-00 00:00:00', 0, '*', 1),
(12, 37, 1, 63, 64, 1, 'uncategorised', 'com_newsfeeds', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:28', 0, '0000-00-00 00:00:00', 0, '*', 1),
(13, 38, 1, 59, 60, 1, 'uncategorised', 'com_weblinks', 'Uncategorised', 'uncategorised', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 13:53:59', 0, '0000-00-00 00:00:00', 0, '*', 1),
(14, 39, 1, 9, 58, 1, 'sample-data-articles', 'com_content', 'Sample Data-Articles', 'sample-data-articles', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:21:35', 0, '0000-00-00 00:00:00', 0, '*', 1),
(15, 40, 1, 129, 130, 1, 'sample-data-banners', 'com_banners', 'Sample Data-Banners', 'sample-data-banners', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":"","foobar":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:22:27', 0, '0000-00-00 00:00:00', 0, '*', 1),
(16, 41, 1, 65, 126, 1, 'sample-data-contact', 'com_contact', 'Sample Data-Contact', 'sample-data-contact', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:23:15', 0, '0000-00-00 00:00:00', 0, '*', 1),
(17, 42, 1, 61, 62, 1, 'sample-data-newsfeeds', 'com_newsfeeds', 'Sample Data-Newsfeeds', 'sample-data-newsfeeds', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:24:14', 0, '0000-00-00 00:00:00', 0, '*', 1),
(18, 43, 1, 1, 8, 1, 'sample-data-weblinks', 'com_weblinks', 'Sample Data-Weblinks', 'sample-data-weblinks', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 14:26:42', 0, '0000-00-00 00:00:00', 0, '*', 1),
(19, 44, 14, 10, 41, 2, 'sample-data-articles/joomla', 'com_content', 'Joomla!', 'joomla', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:19:05', 42, '2010-07-12 18:08:51', 2, '*', 1),
(20, 45, 19, 11, 40, 3, 'sample-data-articles/joomla/extensions', 'com_content', 'Extensions', 'extensions', '', '<p>The Joomla! content management system lets you create webpages of various types using extensions. There are 5 basic types of extensions: components, modules, templates, languages, and plugins. Your website includes the extensions you need to create a basic website in English, but thousands of additional extensions of all types are available. The <a href="http://extensions.joomla.org" style="color: #1b57b1; text-decoration: none; font-weight: normal;">Joomla! Extensions Directory</a> is the largest directory of Joomla! extensions.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:19:42', 42, '2010-07-11 12:21:46', 0, '*', 1),
(21, 46, 20, 12, 13, 4, 'sample-data-articles/joomla/extensions/components', 'com_content', 'Components', 'components', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-component.png" class="image-left" alt="Component Image" ="==" /"="/"" ="" />Components are larger extensions that produce the major content for your site. Each component has one or more "views" that control how content is displayed.In the Joomla! administrator there are additional extensions suce as Menus, Redirection, and the extension managers.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:20:18', 42, '2010-09-14 00:29:05', 0, '*', 1),
(22, 47, 20, 14, 25, 4, 'sample-data-articles/joomla/extensions/modules', 'com_content', 'Modules', 'modules', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-module.png" alt="Media Image" class="image-left" />Modules are small blocks of content that can be displayed in positions on a web page. The menus on this site are displayed in modules. The core of Joomla! includes 17 separate modules ranging from login to search to random images. Each module has a name that starts mod_ but when it displays it has a title. In the descriptions in this section, the titles are the same as the names.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:20:49', 42, '2010-09-14 00:29:37', 0, '*', 1),
(23, 48, 20, 26, 35, 4, 'sample-data-articles/joomla/extensions/templates', 'com_content', 'Templates', 'templates', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-themes.png" border="0" alt="Media Image" align="left" />Templates give your site its look and feel. They determine layout, colors, type faces, graphics and other aspects of design that make your site unique. Your installation of Joomla comes prepackaged with four templates.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:21:27', 42, '2010-07-12 01:02:27', 0, '*', 1),
(75, 166, 22, 23, 24, 5, 'sample-data-articles/joomla/extensions/modules/navigation-modules', 'com_content', 'Navigation Modules', 'navigation-modules', '', '<p>Navigation modules help your visitors move through your site and find what they need.</p>\r\n<p>Menus provide your site with structure and help your visitors navigate your site.  Although they are all based on the same menu module, the variety of ways menus are used in the sample data show how flexible this module is.</p>\r\n<p>A menu can range from extremely simple (for example the top menu or the menu for the Australian Parks sample site) to extremely complex (for example the About Joomla! menu with its many levels). They can also be used for other types of presentation such as the site map linked from the "This Site" menu.</p>\r\n<p>Breadcrumbs provide users with information about where they are in a site.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-11 14:52:30', 42, '2010-11-15 09:14:34', 0, '*', 1),
(24, 49, 20, 36, 37, 4, 'sample-data-articles/joomla/extensions/languages', 'com_content', 'Languages', 'languages', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-language.png" border="0" alt="Languages Image" align="left" />Joomla! installs in English, but translations of the interfaces, sample data and help screens are available in dozens of languages.</p>\r\n<p><a href="http://community.joomla.org/translations.html">Translation information</a></p>\r\n<p>If there is no language pack available for your language, instructions are available for creating your own translation, which you can also contribute to the community by starting a translation team to create an accredited translation.</p>\r\n<p>Translations of the interfaces are installed using the extensions manager in the site administrator and then managed using the language manager.</p>\r\n<p>If you have two or more languages installed you may enable the language switcher plugin and module. They should always be used together. If you create multilingual content and mark your content, menu items or modules as in specific languages and follow <a href="http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6">the complete instructions</a> your users will be able to select a specific content language using the module. By default both the plugin and module are disabled.</p>\r\n<p>There are a number of extensions that can help you manage translations of content available in the<a href="http://extensions.joomla.org"> Joomla! Extensions Directory</a>.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:22:27', 42, '2010-07-12 01:08:26', 0, '*', 1),
(25, 50, 20, 38, 39, 4, 'sample-data-articles/joomla/extensions/plugins', 'com_content', 'Plugins', 'plugins', '', '<p><img src="administrator/templates/bluestork/images/header/icon-48-plugin.png" border="0" alt="Plugin Image" align="left" />Plugins are small task oriented extensions that enhance the Joomla! framework. Some are associated with particular extensions and others, such as editors, are used across all of Joomla!. Most beginning users do not need to change any of the plugins that install with Joomla!.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:23:22', 42, '2010-07-12 01:07:01', 0, '*', 1),
(26, 51, 14, 42, 51, 2, 'sample-data-articles/park-site', 'com_content', 'Park Site', 'park-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:26:53', 42, '2010-07-12 16:50:51', 0, 'en-GB', 1),
(27, 52, 26, 43, 44, 3, 'sample-data-articles/park-site/park-blog', 'com_content', 'Park Blog', 'park-blog', '', '<p><span style="font-size: 12px;">Here is where I will blog all about the parks of Australia.</span></p>\r\n<p><em>You can make a blog on your website by creating a category to write you blog posts in (this one is called Park Blog). Each blog post will be an article in that category. If you make a category blog menu link with 1 column it will look like this page, if you display the category description (this part) displayed. </em></p>\r\n<p><em>To enhance your blog you may want to add  extensions for <a href="http://extensions.joomla.org/extensions/contacts-and-feedback/articles-comments" style="color: #1b57b1; text-decoration: none; font-weight: normal;">comments</a>,<a href="http://extensions.joomla.org/extensions/social-web" style="color: #1b57b1; text-decoration: none; font-weight: normal;"> interacting with social network sites</a>, <a href="http://extensions.joomla.org/extensions/content-sharing" style="color: #1b57b1; text-decoration: none; font-weight: normal;">tagging</a>, and <a href="http://extensions.joomla.org/extensions/content-sharing" style="color: #1b57b1; text-decoration: none; font-weight: normal;">keeping in contact with your readers</a>.   You will also enable the syndication that is included in Joomla! (in the Integration Options set Show Feed Link to Show an make sure to display the syndication module on the page).</em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/sampledata\\/parks\\/banner_cradle.jpg"}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 15:29:34', 42, '2010-11-15 09:38:57', 0, 'en-GB', 1),
(28, 53, 26, 45, 50, 3, 'sample-data-articles/park-site/photo-gallery', 'com_content', 'Photo Gallery', 'photo-gallery', '', '<p><img src="images/sampledata/parks/banner_cradle.jpg" border="0" /></p>\r\n<p>These are my photos from parks I have visited (I didn\'t take them, they are all from <a href="http://commons.wikimedia.org/wiki/Main_Page">Wikimedia Commons</a>).</p>\r\n<p><em>This shows you how to make a simple image gallery using articles in com_content. </em></p>\r\n<p><em>In each article put a thumbnail image before a "readmore" and the fiull size image after it. Set the article to Show Intro Text: Hide. </em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 15:36:24', 42, '2010-07-11 22:39:39', 0, 'en-GB', 1),
(29, 54, 14, 52, 57, 2, 'sample-data-articles/fruit-shop-site', 'com_content', 'Fruit Shop Site', 'fruit-shop-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:07:22', 42, '2010-07-12 19:39:19', 0, '*', 1),
(30, 55, 29, 53, 54, 3, 'sample-data-articles/fruit-shop-site/growers', 'com_content', 'Growers', 'growers', '', '<p>We search the whole countryside for the best fruit growers.</p>\r\n<p><em>You can let each supplier have a page that he or she can edit. To see this in action you will need to create a users who is in the suppliers group.  <br />Create one page in the growers category for that user and make that supplier the author of the page.  That user will be able to edit his or her page. </em></p>\r\n<p><em>This illustrates the use of the Edit Own permission. </em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 16:15:26', 42, '2010-11-15 08:42:33', 0, '*', 1),
(31, 56, 18, 2, 3, 2, 'sample-data-weblinks/park-links', 'com_weblinks', 'Park Links', 'park-links', '', '<p>Here are links to some of my favorite parks.</p>\r\n<p><em>The weblinks component provides an easy way to make links to external sites that are consistently formatted and categorised. You can create weblinks from the front end of your site.</em></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":"images\\/sampledata\\/parks\\/banner_cradle.jpg"}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 16:21:00', 42, '2010-11-15 09:39:35', 0, 'en-GB', 1),
(32, 57, 18, 4, 7, 2, 'sample-data-weblinks/joomla-specific-links', 'com_weblinks', 'Joomla! Specific Links', 'joomla-specific-links', '', '<p><div style="font-family: Tahoma, Helvetica, Arial, sans-serif; font-size: 76%; background-color: #ffffff; background-image: initial; background-attachment: initial; background-origin: initial; background-clip: initial; line-height: 1.3em; color: #333333;"><p>A selection of links that are all related to the Joomla! Project.</p></div></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:22:39', 0, '0000-00-00 00:00:00', 0, '*', 1),
(33, 58, 32, 5, 6, 3, 'sample-data-weblinks/joomla-specific-links/other-resources', 'com_weblinks', 'Other Resources', 'other-resources', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:24:17', 0, '0000-00-00 00:00:00', 0, '*', 1),
(34, 59, 16, 66, 67, 2, 'sample-data-contact/park-site', 'com_contact', 'Park Site', 'park-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:28:06', 42, '2010-07-11 22:35:55', 0, 'en-GB', 1),
(35, 60, 16, 68, 125, 2, 'sample-data-contact/shop-site', 'com_contact', 'Shop Site', 'shop-site', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:28:20', 0, '0000-00-00 00:00:00', 0, '*', 1),
(36, 61, 35, 69, 70, 3, 'sample-data-contact/shop-site/staff', 'com_contact', 'Staff', 'staff', '', '<p>Please feel free to contact our staff at any time should you need assistance.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:29:22', 0, '0000-00-00 00:00:00', 0, '*', 1),
(37, 62, 35, 71, 124, 3, 'sample-data-contact/shop-site/fruit-encyclopedia', 'com_contact', 'Fruit Encyclopedia', 'fruit-encyclopedia', '', '<p> </p><p>Our directory of information about different kinds of fruit.</p><p>We love fruit and want the world to know more about all of its many varieties.</p><p>Although it is small now, we work on it whenever we have a chance.</p><p>All of the images can be found in <a href="http://commons.wikimedia.org/wiki/Main_Page">Wikimedia Commons</a>.</p><p><img src="images/sampledata/fruitshop/apple.jpg" border="0" alt="Apples" title="Apples" /></p><p><em>This encyclopedia is implemented using the contact component, each fruit a separate contact and a category for each letter. A CSS style is used to create the horizontal layout of the alphabet headings. </em></p><p><em>If you wanted to, you could allow some users (such as your growers) to have access to just this category in the contact component and let them help you to create new content for the encyclopedia.</em></p><p> </p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:41:12', 0, '0000-00-00 00:00:00', 0, '*', 1),
(38, 63, 37, 72, 73, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/a', 'com_contact', 'A', 'a', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:43:24', 0, '0000-00-00 00:00:00', 0, '*', 1),
(39, 64, 37, 74, 75, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/b', 'com_contact', 'B', 'b', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:44:46', 0, '0000-00-00 00:00:00', 0, '*', 1),
(40, 65, 37, 76, 77, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/c', 'com_contact', 'C', 'c', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:10', 0, '0000-00-00 00:00:00', 0, '*', 1),
(41, 66, 37, 78, 79, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/d', 'com_contact', 'D', 'd', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:23', 0, '0000-00-00 00:00:00', 0, '*', 1),
(42, 67, 37, 80, 81, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/e', 'com_contact', 'E', 'e', '', '', 0, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:32', 0, '0000-00-00 00:00:00', 0, '*', 1),
(43, 68, 37, 82, 83, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/f', 'com_contact', 'F', 'f', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:42', 0, '0000-00-00 00:00:00', 0, '*', 1),
(44, 69, 37, 84, 85, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/g', 'com_contact', 'G', 'g', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:45:58', 0, '0000-00-00 00:00:00', 0, '*', 1),
(45, 70, 37, 86, 87, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/h', 'com_contact', 'H', 'h', '', '', 0, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:08', 0, '0000-00-00 00:00:00', 0, '*', 1),
(46, 71, 37, 88, 89, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/i', 'com_contact', 'I', 'i', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:21', 0, '0000-00-00 00:00:00', 0, '*', 1),
(47, 72, 37, 90, 91, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/j', 'com_contact', 'J', 'j', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:34', 0, '0000-00-00 00:00:00', 0, '*', 1),
(48, 73, 37, 92, 93, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/k', 'com_contact', 'K', 'k', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:45', 0, '0000-00-00 00:00:00', 0, '*', 1),
(49, 74, 37, 94, 95, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/l', 'com_contact', 'L', 'l', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:46:57', 0, '0000-00-00 00:00:00', 0, '*', 1),
(50, 75, 37, 96, 97, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/m', 'com_contact', 'M', 'm', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:11', 0, '0000-00-00 00:00:00', 0, '*', 1),
(51, 76, 37, 98, 99, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/n', 'com_contact', 'N', 'n', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:22', 0, '0000-00-00 00:00:00', 0, '*', 1),
(52, 77, 37, 100, 101, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/o', 'com_contact', 'O', 'o', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:33', 0, '0000-00-00 00:00:00', 0, '*', 1),
(53, 78, 37, 102, 103, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/p', 'com_contact', 'P', 'p', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:44', 0, '0000-00-00 00:00:00', 0, '*', 1),
(54, 79, 37, 104, 105, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/q', 'com_contact', 'Q', 'q', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:47:54', 0, '0000-00-00 00:00:00', 0, '*', 1),
(55, 80, 37, 106, 107, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/r', 'com_contact', 'R', 'r', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:48:34', 0, '0000-00-00 00:00:00', 0, '*', 1),
(56, 81, 37, 108, 109, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/s', 'com_contact', 'S', 's', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:48:45', 0, '0000-00-00 00:00:00', 0, '*', 1),
(57, 82, 37, 110, 111, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/t', 'com_contact', 'T', 't', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:48:56', 0, '0000-00-00 00:00:00', 0, '*', 1),
(58, 83, 37, 112, 113, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/u', 'com_contact', 'U', 'u', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:49:08', 0, '0000-00-00 00:00:00', 0, '*', 1),
(59, 84, 37, 114, 115, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/v', 'com_contact', 'V', 'v', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:49:33', 0, '0000-00-00 00:00:00', 0, '*', 1),
(60, 85, 37, 116, 117, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/w', 'com_contact', 'W', 'w', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:49:52', 0, '0000-00-00 00:00:00', 0, '*', 1),
(61, 86, 37, 118, 119, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/x', 'com_contact', 'X', 'x', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:50:08', 0, '0000-00-00 00:00:00', 0, '*', 1),
(62, 87, 37, 120, 121, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/y', 'com_contact', 'Y', 'y', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:50:22', 0, '0000-00-00 00:00:00', 0, '*', 1),
(63, 88, 37, 122, 123, 4, 'sample-data-contact/shop-site/fruit-encyclopedia/z', 'com_contact', 'Z', 'z', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 16:51:09', 0, '0000-00-00 00:00:00', 0, '*', 1),
(64, 93, 22, 15, 16, 5, 'sample-data-articles/joomla/extensions/modules/articles-modules', 'com_content', 'Content Modules', 'articles-modules', '', '<p>Content modules display article and other information from the content component.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:32:13', 42, '2010-07-11 13:34:00', 0, '*', 1),
(65, 94, 22, 17, 18, 5, 'sample-data-articles/joomla/extensions/modules/user-modules', 'com_content', 'User Modules', 'user-modules', '', '<p>User modules interact with the user system, allowing users to login, showing who is logged in, and showing the most recently registered users.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:33:19', 0, '0000-00-00 00:00:00', 0, '*', 1),
(66, 95, 22, 19, 20, 5, 'sample-data-articles/joomla/extensions/modules/display-modules', 'com_content', 'Display Modules', 'display-modules', '', '<p>These modules display information from components other than content and user. These include weblinks, news feeds and the media manager.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:34:49', 0, '0000-00-00 00:00:00', 0, '*', 1),
(67, 96, 22, 21, 22, 5, 'sample-data-articles/joomla/extensions/modules/utility-modules', 'com_content', 'Utility Modules', 'utility-modules', '', '<p>Utility modules provide useful functionality such as search, syndication, and statistics.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 18:36:18', 0, '0000-00-00 00:00:00', 0, '*', 1),
(68, 97, 23, 31, 32, 5, 'sample-data-articles/joomla/extensions/templates/atomic', 'com_content', 'Atomic', 'atomic', '', '<p>Atomic is a minimal template designed to be a skeleton for making your own template and to learn about Joomla! templating.</p>\r\n<p><img src="templates/atomic/template_thumbnail.png" border="0" alt="The Atomic Template" style="border: 0; float: right;" /></p>\r\n<p> </p>\r\n<ul>\r\n<li><a href="index.php?Itemid=285">Home Page</a></li>\r\n<li><a href="index.php?Itemid=316">Typography</a></li>\r\n</ul>\r\n<p> </p>\r\n<p> </p>\r\n<p><br /><br /></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:03:11', 42, '2010-11-21 19:24:25', 0, '*', 1),
(69, 98, 23, 27, 28, 5, 'sample-data-articles/joomla/extensions/templates/beez-20', 'com_content', 'Beez 20', 'beez-20', '', '<p><img src="templates/beez_20/template_thumbnail.png" border="0" alt="Beez_20 thumbnail" align="right" style="float: right; margin: 5px,80px,5px,25px;" /></p>\r\n<p>Beez 2.0 is a versatile, easy to customize template that works for a variety of sites. It meets major accessibility standards and demonstrates a range of css and javascript techniques. It is the default template that installs with Joomla!</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=424">Home Page</a></li>\r\n<li><a href="index.php?Itemid=423">Typography</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:06:19', 42, '2010-11-15 10:02:37', 0, '*', 1),
(70, 99, 23, 29, 30, 5, 'sample-data-articles/joomla/extensions/templates/beez5', 'com_content', 'Beez5', 'beez5', '', '<p><img src="templates/beez5/template_thumbnail.png" border="0" alt="Beez5 Thumbnail" align="right" style="float: right;" /></p>\r\n<p> </p>\r\n<p>Beez 5 is an html5 implementation of a Joomla! template. It uses a number of html5 techniques to enhance the presentation of a site. It is used as the template for the Fruit Shop sample site.</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=458">Home Page</a></li>\r\n<li><a href="index.php?Itemid=457">Typography</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:10:16', 42, '2010-11-15 10:06:07', 0, '*', 1),
(71, 100, 23, 33, 34, 5, 'sample-data-articles/joomla/extensions/templates/milky-way', 'com_content', 'Milky Way', 'milky-way', '', '<p><img src="templates/rhuk_milkyway/template_thumbnail.png" border="0" alt="Milky Way Image" width="206" height="150" align="right" style="float: right;" /></p>\r\n<p>Milky Way is the default template for Joomla! 1.5. You can find all of the 1.5 component layouts in the _html folder if you need them for your upgraded sites.</p>\r\n<ul>\r\n<li><a href="index.php?Itemid=286">Typography</a></li>\r\n<li><a href="index.php?Itemid=451">Home Page</a></li>\r\n</ul>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-10 19:15:13', 42, '2010-11-15 10:13:28', 0, '*', 1),
(72, 108, 28, 46, 47, 4, 'sample-data-articles/park-site/photo-gallery/animals', 'com_content', 'Animals', 'animals', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 20:04:21', 42, '2010-07-11 22:31:53', 0, 'en-GB', 1),
(73, 109, 28, 48, 49, 4, 'sample-data-articles/park-site/photo-gallery/scenery', 'com_content', 'Scenery', 'scenery', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"target":"","image":""}', '', '', '{"page_title":"","author":"","robots":""}', 42, '2010-07-10 20:04:44', 42, '2010-07-11 22:32:00', 0, 'en-GB', 1),
(76, 167, 29, 55, 56, 3, 'sample-data-articles/fruit-shop-site/recipes', 'com_content', 'Recipes', 'recipes', '', '<p>Customers and suppliers can post their favorite recipes for fruit here.</p>\r\n<p>A good idea is to promote the use of metadata keywords to make finding other recipes for the same fruit easier.</p>\r\n<p><em>To see this in action, create a user assigned to the customer group and a user assigned to the suppliers group. These users will be able to create their own recipe pages and edit those pages. The will not be able to edit other users\' pages.</em><br /><br /></p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-07-12 14:52:59', 42, '2010-11-15 08:44:11', 0, '*', 1),
(77, 169, 1, 135, 142, 1, 'news', 'com_content', 'News', 'news', '', 'Select a news topic from the list below, then select a news article to read.', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:26:57', 0, '*', 1),
(78, 170, 77, 136, 137, 2, 'news1179438490/latest-news', 'com_content', 'Latest', 'latest-news', '', 'The latest news from the Joomla! Team', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:26:46', 0, '*', 1),
(79, 176, 77, 138, 139, 2, 'news/newsflash', 'com_content', 'Newsflash', 'newsflash', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:30:41', 0, '*', 1),
(80, 182, 77, 140, 141, 2, 'news/hot-topic', 'com_content', 'Hot topic', 'hot-topic', '', '<p>Consequat Nullam laoreet mi aliquet sodales tellus amet ac nibh convallis. Tincidunt leo elit eu velit felis libero Vestibulum Nam justo hendrerit. Tristique quis nibh pede mauris nulla tincidunt egestas Nullam mus urna. Ligula Curabitur eget Sed aliquam dignissim dui elit ipsum dictumst adipiscing. Velit hendrerit et sed dui est nascetur turpis orci nisl.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:30:52', 0, '*', 1),
(81, 188, 1, 143, 152, 1, 'faqs', 'com_content', 'FAQs', 'faqs', '', 'From the list below choose one of our FAQs topics, then select an FAQ to read. If you have a question which is not in this section, please contact us.', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:31:02', 0, '*', 1),
(82, 189, 81, 144, 145, 2, 'faqs/new-to-joomla', 'com_content', 'New to Joomla!', 'new-to-joomla', '', 'Questions for new users of Joomla!', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:31:12', 1, '*', 1),
(83, 193, 81, 146, 147, 2, 'faqs/current-users', 'com_content', 'Current Users', 'current-users', '', 'Questions that users migrating to Joomla! 1.5 are likely to raise<br />', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:31:23', 0, '*', 1),
(84, 200, 81, 148, 149, 2, 'faqs/general', 'com_content', 'General', 'general', '', 'General questions about the Joomla! CMS', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:31:32', 0, '*', 1),
(85, 209, 81, 150, 151, 2, 'faqs/languages', 'com_content', 'Languages', 'languages', '', 'Questions related to localisation and languages', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:31:41', 0, '*', 1),
(86, 215, 1, 153, 160, 1, 'about-joomla', 'com_content', 'About Joomla!', 'about-joomla', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:31:51', 0, '*', 1),
(87, 216, 86, 154, 155, 2, 'about-joomla/the-project', 'com_content', 'The Project', 'the-project', '', 'General facts about Joomla!<br />', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:32:00', 0, '*', 1),
(88, 220, 86, 156, 157, 2, 'about-joomla/the-cms', 'com_content', 'The CMS', 'the-cms', '', 'Information about the software behind Joomla!<br />', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:32:11', 0, '*', 1),
(89, 226, 86, 158, 159, 2, 'about-joomla/the-community', 'com_content', 'The Community', 'the-community', '', 'About the millions of Joomla! users and Web sites<br />', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:32:23', 0, '*', 1),
(90, 229, 1, 161, 174, 1, 'sport', 'com_content', 'Sport', 'sport', '', '<p>Nibh pulvinar rhoncus Curabitur volutpat nibh sed ac Vestibulum laoreet consectetuer. Morbi eu ullamcorper dapibus sagittis a Curabitur laoreet Pellentesque pretium Quisque. Pellentesque Phasellus Cras Sed elit dis eget tincidunt purus lacus pellentesque.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 09:16:26', 0, '*', 1),
(91, 230, 90, 162, 163, 2, 'sport/football', 'com_content', 'Football', 'football', '', '<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:32:31', 1, '*', 1),
(92, 240, 90, 164, 165, 2, 'sport/cricket', 'com_content', 'Cricket', 'cricket', '', '<p>Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:50', 42, '2011-01-28 11:32:45', 1, '*', 1),
(93, 249, 90, 166, 167, 2, 'sport/tennis', 'com_content', 'Tennis', 'tennis', '', '<p>Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:26:25', 0, '*', 1),
(94, 258, 90, 168, 169, 2, 'sport/motorsport', 'com_content', 'Motorsport', 'motorsport', '', '<p>Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:33:01', 0, '*', 1),
(95, 267, 90, 170, 171, 2, 'sport/horse-racing', 'com_content', 'Horse racing', 'horse-racing', '', '<p>Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:33:11', 0, '*', 1),
(96, 277, 90, 172, 173, 2, 'sport1851642622/boxing', 'com_content', 'Boxing', 'boxing', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 09:16:07', 0, '*', 1),
(97, 286, 1, 175, 188, 1, 'artist', 'com_content', 'Artist', 'artist', '', '<p>Morbi ante Curabitur in libero Donec eros laoreet laoreet Donec tincidunt. Nonummy Sed dui mus mus eget natoque leo eleifend augue consequat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:33:21', 0, '*', 1),
(98, 287, 97, 176, 177, 2, 'artist/art', 'com_content', 'Art', 'art', '', '<p>Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:33:31', 0, '*', 1),
(99, 296, 97, 178, 179, 2, 'artist/architecture', 'com_content', 'Architecture', 'architecture', '', '<p>Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:33:40', 0, '*', 1),
(100, 305, 97, 180, 181, 2, 'artist/design', 'com_content', 'Design', 'design', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:34:20', 0, '*', 1),
(101, 314, 97, 182, 183, 2, 'artist/photography', 'com_content', 'Photography', 'photography', '', '<p>Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:34:29', 0, '*', 1),
(102, 323, 97, 184, 185, 2, 'artist/graphics', 'com_content', 'Graphics', 'graphics', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:51', 42, '2011-01-28 11:34:38', 0, '*', 1),
(103, 332, 97, 186, 187, 2, 'artist/3d-computer-graphics', 'com_content', '3D Computer Graphics', '3d-computer-graphics', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:34:47', 0, '*', 1),
(104, 341, 1, 189, 196, 1, 'travel', 'com_content', 'Travel', 'travel', '', '<p>Aliquam nec cursus pretium Sed adipiscing orci convallis vel dignissim amet. Auctor Ut mus metus lacinia ipsum pretium dolor nascetur odio Phasellus. Quis feugiat Cras habitant Proin molestie Ut Ut auctor ipsum ornare.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:35:06', 0, '*', 1),
(105, 342, 104, 190, 191, 2, 'travel81551005/getaways', 'com_content', 'Getaways', 'getaways', '', '<p>Ut leo condimentum Donec felis vitae Nullam et volutpat tortor Cras. Nec ornare id pellentesque adipiscing dui Nam nonummy Vestibulum id quis. Et semper Nam ipsum Sed hendrerit Nunc justo Nulla mus laoreet.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:34:56', 0, '*', 1),
(106, 351, 104, 192, 193, 2, 'travel/travel-tips', 'com_content', 'Travel Tips', 'travel-tips', '', '<p>Faucibus eget ut et habitasse tristique Nulla hac augue Sed Vestibulum. Semper libero semper vitae sed Quisque orci turpis dis tincidunt nulla. Semper Nulla nibh sociis convallis leo vel sagittis turpis Curabitur justo.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:35:15', 0, '*', 1),
(107, 358, 104, 194, 195, 2, 'travel/business-travel', 'com_content', 'Business Travel', 'business-travel', '', '<p>Augue Donec sem et vestibulum Vivamus mus pretium at elit nulla. Lorem ante vitae id Suspendisse sem orci ac sodales non consequat. Augue vel orci at feugiat suscipit ut ornare porttitor tincidunt lacinia.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:35:25', 0, '*', 1),
(108, 367, 1, 197, 210, 1, 'life-style', 'com_content', 'Life and Style', 'life-style', '', '<p>Magna velit urna Aenean laoreet tellus orci Suspendisse Integer lacus urna. Vivamus mus vitae Integer Nulla turpis tortor mauris montes sem et. Orci convallis vitae mattis Sed Morbi porttitor justo convallis urna feugiat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:35:37', 0, '*', 1),
(109, 368, 108, 198, 199, 2, 'life-style/fashion-beauty', 'com_content', 'Fashion and Beauty', 'fashion-beauty', '', '<p>Ut leo condimentum Donec felis vitae Nullam et volutpat tortor Cras. Nec ornare id pellentesque adipiscing dui Nam nonummy Vestibulum id quis. Et semper Nam ipsum Sed hendrerit Nunc justo Nulla mus laoreet. Morbi leo Morbi quis vitae quis et Quisque auctor Nunc tempus.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:35:47', 0, '*', 1),
(110, 377, 108, 200, 201, 2, 'life-style/foot-drink', 'com_content', 'Food and Drink', 'foot-drink', '', '<p>Magna velit urna Aenean laoreet tellus orci Suspendisse Integer lacus urna. Vivamus mus vitae Integer Nulla turpis tortor mauris montes sem et. Orci convallis vitae mattis Sed Morbi porttitor justo convallis urna feugiat.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:35:57', 0, '*', 1),
(111, 386, 108, 202, 203, 2, 'life-style/homes-gardens', 'com_content', 'Homes and Gardens', 'homes-gardens', '', '<p>Ut leo condimentum Donec felis vitae Nullam et volutpat tortor Cras. Nec ornare id pellentesque adipiscing dui Nam nonummy Vestibulum id quis. Et semper Nam ipsum Sed hendrerit Nunc justo Nulla mus laoreet.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:36:06', 0, '*', 1),
(112, 395, 108, 204, 205, 2, 'life-style/shop', 'com_content', 'Shop', 'shop', '', '<p>Tristique Vestibulum Phasellus vitae ut Aliquam Phasellus consequat sem libero turpis. Purus Suspendisse sociis vitae consectetuer ultrices et justo nibh semper penatibus. Semper malesuada ullamcorper elit Suspendisse fermentum mauris pretium nonummy orci.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:36:27', 0, '*', 1),
(113, 404, 108, 206, 207, 2, 'life-style/mother-children', 'com_content', 'Mother and Children', 'mother-children', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:52', 42, '2011-01-28 11:36:15', 0, '*', 1),
(114, 413, 108, 208, 209, 2, 'life-style/wife-husband', 'com_content', 'Wife and Husband', 'wife-husband', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:36:38', 0, '*', 1),
(115, 422, 1, 211, 218, 1, 'health', 'com_content', 'Health', 'health', '', '<p>Semper nulla Nunc libero dictumst magna iaculis In mattis at quis. Nulla suscipit risus mauris et nulla et sit id dapibus Quisque. Vitae sapien Curabitur interdum et magnis Donec felis consequat tellus et.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:37:22', 0, '*', 1),
(116, 423, 115, 212, 213, 2, 'health1765112031/what-ails-you', 'com_content', 'What Ails You', 'what-ails-you', '', '<p>Velit consectetuer Phasellus dis nunc eget hac vestibulum mollis fames a. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et. </p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:36:52', 0, '*', 1),
(117, 430, 115, 214, 215, 2, 'health/diet-fitness', 'com_content', 'Diet and Fitness', 'diet-fitness', '', '<p>Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:37:34', 0, '*', 1);
INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`, `version`) VALUES
(118, 437, 115, 216, 217, 2, 'health/you-your-family', 'com_content', 'You and Your Family', 'you-your-family', '', '<p>Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:37:47', 0, '*', 1),
(119, 442, 1, 219, 232, 1, 'entertainment', 'com_content', 'Entertainment', 'entertainment', '', '<p>Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:38:34', 0, '*', 1),
(120, 443, 119, 220, 221, 2, 'entertainment/movies', 'com_content', 'Movies', 'movies', '', '<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:38:43', 0, '*', 1),
(121, 452, 119, 222, 223, 2, 'entertainment/tv', 'com_content', 'TV', 'tv', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:38:54', 0, '*', 1),
(122, 461, 119, 224, 225, 2, 'entertainment/music', 'com_content', 'Music', 'music', '', '<p>Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:39:02', 0, '*', 1),
(123, 470, 119, 226, 227, 2, 'entertainment/books', 'com_content', 'Books', 'books', '', '<p>Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:39:12', 0, '*', 1),
(124, 479, 119, 228, 229, 2, 'entertainment/games', 'com_content', 'Games', 'games', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:53', 42, '2011-01-28 11:39:21', 0, '*', 1),
(125, 489, 119, 230, 231, 2, 'entertainment/theatre', 'com_content', 'Theatre', 'theatre', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:54', 42, '2011-01-28 11:39:32', 0, '*', 1),
(126, 498, 1, 233, 246, 1, 'world', 'com_content', 'World', 'world', '', '<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:54', 42, '2011-01-28 11:39:45', 1, '*', 1),
(127, 499, 126, 234, 235, 2, 'world/europe', 'com_content', 'Europe', 'europe', '', '<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:54', 42, '2011-01-28 11:39:54', 2, '*', 1),
(128, 509, 126, 236, 237, 2, 'world/us-politics', 'com_content', 'U.S. Politics', 'us-politics', '', '<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:54', 42, '2011-01-28 11:40:28', 0, '*', 1),
(129, 518, 126, 238, 239, 2, 'world/middle-east', 'com_content', 'Middle East', 'middle-east', '', '<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:54', 42, '2011-01-28 11:40:34', 0, '*', 1),
(130, 527, 126, 240, 241, 2, 'world/africa', 'com_content', 'Africa', 'africa', '', '<p>Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:54', 42, '2011-01-28 11:40:38', 0, '*', 1),
(131, 536, 126, 242, 243, 2, 'world/science', 'com_content', 'Science', 'science', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:54', 42, '2011-01-28 11:40:42', 0, '*', 1),
(132, 545, 126, 244, 245, 2, 'world/pacific', 'com_content', 'Pacific', 'pacific', '', '<p>Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:40:45', 0, '*', 1),
(133, 554, 1, 247, 260, 1, 'technology', 'com_content', 'Technology', 'technology', '', '<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:40:50', 0, '*', 1),
(134, 555, 133, 248, 249, 2, 'technology/personal-tech', 'com_content', 'Personal Tech', 'personal-tech', '', '<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:40:53', 0, '*', 1),
(135, 564, 133, 250, 251, 2, 'technology/business-tech', 'com_content', 'Business Tech', 'business-tech', '', '<p>Elit Nullam pellentesque vitae Nulla eget Sed eget sed adipiscing accumsan. Tincidunt felis non amet et eu Nulla egestas cursus accumsan condimentum. Tincidunt accumsan tincidunt dolor pellentesque accumsan Nullam convallis egestas nunc quis. Mauris Suspendisse at pretium ac Aenean faucibus Morbi convallis pharetra et. Sed ut sed Vestibulum ut elit congue convallis massa ante consectetuer. Curabitur non Phasellus cursus et Vestibulum enim lorem.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:40:57', 0, '*', 1),
(136, 573, 133, 252, 253, 2, 'technology/space', 'com_content', 'Space', 'space', '', '<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:41:01', 0, '*', 1),
(137, 582, 133, 254, 255, 2, 'technology/science', 'com_content', 'Science', 'science', '', '<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:41:05', 1, '*', 1),
(138, 591, 133, 256, 257, 2, 'technology/green-tech', 'com_content', 'Green Tech', 'green-tech', '', '<p>Ut leo condimentum Donec felis vitae Nullam et volutpat tortor Cras. Nec ornare id pellentesque adipiscing dui Nam nonummy Vestibulum id quis. Et semper Nam ipsum Sed hendrerit Nunc justo Nulla mus laoreet. Morbi leo Morbi quis vitae quis et Quisque auctor Nunc tempus.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:41:09', 0, '*', 1),
(139, 600, 133, 258, 259, 2, 'technology/security', 'com_content', 'Security', 'security', '', '<p>Ut leo condimentum Donec felis vitae Nullam et volutpat tortor Cras. Nec ornare id pellentesque adipiscing dui Nam nonummy Vestibulum id quis. Et semper Nam ipsum Sed hendrerit Nunc justo Nulla mus laoreet. Morbi leo Morbi quis vitae quis et Quisque auctor Nunc tempus.</p>', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 00:47:55', 42, '2011-01-28 11:41:12', 0, '*', 1),
(140, 609, 1, 261, 262, 1, 'text-ads', 'com_banners', 'Text Ads', 'text-ads', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 01:05:39', 0, '0000-00-00 00:00:00', 0, '*', 1),
(141, 610, 1, 263, 264, 1, 'fashion', 'com_banners', 'Fashion', 'fashion', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 17:30:15', 0, '0000-00-00 00:00:00', 0, '*', 1),
(142, 611, 1, 265, 266, 1, 'sport', 'com_banners', 'Sport ', 'sport', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{"category_layout":"","image":""}', '', '', '{"author":"","robots":""}', 42, '2010-12-29 17:30:32', 0, '0000-00-00 00:00:00', 0, '*', 1);

DROP TABLE IF EXISTS `#__contact_details`;
CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `hits`) VALUES
(1, 'Contact Name Here', 'name', 'Position', 'Street Address', 'Suburb', 'State', 'Country', 'Zip Code', 'Telephone', 'Fax', '<p>Information about or by the contact.</p>', 'images/powered_by.png', 'top', 'email@email.com', 1, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"tabs","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"Twitter","linka":"http:\\/\\/twitter.com\\/joomla","linkb_name":"YouTube","linkb":"http:\\/\\/www.youtube.com\\/user\\/joomla","linkc_name":"Ustream","linkc":"http:\\/\\/www.ustream.tv\\/joomla","linkd_name":"FriendFeed","linkd":"http:\\/\\/friendfeed.com\\/joomla","linke_name":"Scribed","linke":"http:\\/\\/www.scribd.com\\/people\\/view\\/504592-joomla","contact_layout":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 16, 1, '', '', 'last', 'first', 'middle', 'en-GB', '0000-00-00 00:00:00', 42, '', '2011-08-31 04:15:29', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0),
(2, 'Webmaster', 'webmaster', '', '', '', '', '', '', '', '', '', '', NULL, 'webmaster@example.com', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"","redirect":""}', 0, 34, 1, '', '', '', '', '', 'en-GB', '0000-00-00 00:00:00', 42, '', '2010-08-23 03:03:54', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0),
(3, 'Owner', 'owner', '', '', '', '', '', '', '', '', '<p>I\'m the owner of this store.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 2, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 36, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 42, '', '2010-07-11 13:07:22', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0),
(4, 'Buyer', 'buyer', '', '', '', '', '', '', '', '', '<p>I am in charge of buying fruit. If you sell good fruit, contact me.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"0","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 36, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 42, '', '2010-07-10 23:48:49', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0),
(5, 'Bananas', 'bananas', 'Scientific Name: Musa', 'Image Credit: Enzik\r\nRights: Creative Commons Share Alike Unported 3.0\r\nSource: http://commons.wikimedia.org/wiki/File:Bananas_-_Morocco.jpg', '', 'Type: Herbaceous', 'Large Producers: India, China, Brasil', '', '', '', '<p>Bananas are a great source of potassium.</p>\r\n<p> </p>', 'images/sampledata/fruitshop/bananas_2.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"show_with_link","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"1","show_email":"","show_street_address":"","show_suburb":"","show_state":"1","show_postcode":"","show_country":"1","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Banana English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Banana","linkb_name":"Wikipedia:  \\u0939\\u093f\\u0928\\u094d\\u0926\\u0940 \\u0915\\u0947\\u0932\\u093e","linkb":"http:\\/\\/hi.wikipedia.org\\/wiki\\/%E0%A4%95%E0%A5%87%E0%A4%B2%E0%A4%BE","linkc_name":"Wikipedia:Banana Portugu\\u00eas","linkc":"http:\\/\\/pt.wikipedia.org\\/wiki\\/Banana","linkd_name":"Wikipedia: \\u0411\\u0430\\u043d\\u0430\\u043d  \\u0420\\u0443\\u0441\\u0441\\u043a\\u0438\\u0439","linkd":"http:\\/\\/ru.wikipedia.org\\/\\u0411\\u0430\\u043d\\u0430\\u043d","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 39, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 42, '', '2010-11-28 20:35:48', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0),
(6, 'Apples', 'apples', 'Scientific Name: Malus domestica', 'Image Credit: Fievet\r\nRights: Public Domain\r\nSource: http://commons.wikimedia.org/wiki/File:Pommes_vertes.JPG', '', 'Family: Rosaceae', 'Large: Producers: China, United States', '', '', '', '<p>Apples are a versatile fruit, used for eating, cooking, and preserving.</p>\r\n<p>There are more that 7500 different kinds of apples grown around the world.</p>', 'images/sampledata/fruitshop/apple.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Apples English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Apple","linkb_name":"Wikipedia: Manzana Espa\\u00f1ol ","linkb":"http:\\/\\/es.wikipedia.org\\/wiki\\/Manzana","linkc_name":"Wikipedia: \\u82f9\\u679c \\u4e2d\\u6587","linkc":"http:\\/\\/zh.wikipedia.org\\/zh\\/\\u82f9\\u679c","linkd_name":"Wikipedia: Tofaa Kiswahili","linkd":"http:\\/\\/sw.wikipedia.org\\/wiki\\/Tofaa","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 38, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 42, '', '2010-11-28 23:19:39', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0),
(7, 'Tamarind', 'tamarind', 'Scientific Name: Tamarindus indica', 'Image Credit: Franz Eugen K', '', 'Family: Fabaceae', 'Large Producers: India, United States', '', '', '', '<p>Tamarinds are a versatile fruit used around the world. In its young form it is used in hot sauces; ripened it is the basis for many refreshing drinks.</p>\r\n<p> </p>', 'images/sampledata/fruitshop/tamarind.jpg', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"plain","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"1","linka_name":"Wikipedia: Tamarind English","linka":"http:\\/\\/en.wikipedia.org\\/wiki\\/Tamarind","linkb_name":"Wikipedia: \\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2  \\u09ac\\u09be\\u0982\\u09b2\\u09be  ","linkb":"http:\\/\\/bn.wikipedia.org\\/wiki\\/\\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2 ","linkc_name":"Wikipedia: Tamarinier Fran\\u00e7ais","linkc":"http:\\/\\/fr.wikipedia.org\\/wiki\\/Tamarinier","linkd_name":"Wikipedia:Tamaline lea faka-Tonga","linkd":"http:\\/\\/to.wikipedia.org\\/wiki\\/Tamaline","linke_name":"","linke":"","contact_layout":"beez5:encyclopedia"}', 0, 57, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 42, '', '2010-11-28 20:25:34', 42, '', '', '{"robots":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0),
(8, 'Shop Address', 'shop-address', '', '', 'Our City', 'Our Province', 'Our Country', '', '555-555-5555', '', '<p>Here are directions for how to get to our shop.</p>', '', NULL, '', 0, 1, 0, '0000-00-00 00:00:00', 1, '{"show_contact_category":"","show_contact_list":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_profile":"","show_links":"","linka_name":"","linka":"","linkb_name":"","linkb":"","linkc_name":"","linkc":"","linkd_name":"","linkd":"","linke_name":"","linke":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":""}', 0, 35, 1, '', '', '', '', '', '*', '0000-00-00 00:00:00', 42, '', '2010-08-23 03:03:54', 42, '', '', '{"robots":"","rights":""}', 1, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 0);

DROP TABLE IF EXISTS `#__content`;
CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(1, 89, 'Administrator Components', 'administrator-components', '<p>All components also are used in the administrator area of your website. In addition to the ones listed here, there are components in the administrator that do not have direct front end displays, but do help shape your site. The most important ones for most users are</p><ul><li>Media Manager</li><li>Extensions Manager</li><li>Menu Manager</li><li>Configuration</li><li>Banners</li></ul><hr title="Media Manager" alt="Media Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><p> </p><h3>Media Manager</h3><p>The media manager component lets you upload and insert images into content throughout your site. Optionally, you can enable the flash uploader which will allow you to to upload multiple images. Help</p><hr title="Extensions Manager" alt="Extensions Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Extensions Manager</h3><p>The extensions manager lets you install, update, uninstall and manage all of your extensions. The extensions manager has been extensively redesigned for Joomla! 1.6, although the core install and uninstall functionality remains the same as in Joomla 1.5. Help</p><hr title="Menu Manager" alt="Menu Manager" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Menu Manager</h3><p>The menu manager lets you create the menus you see displayed on your site. It also allows you to assign modules and template styles to specific menu links.  Help</p><hr title="Global Configuration" alt="Global Configuration" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Global Configuration</h3><p>The global configuration is where the site administrator configures things such as whether search engine friendly urls are enabled, the site meta data (descriptive text used by search engines an indexers) and other functions. For many beginning users simply leaving the settings on default is a good way to begin, although when your site is ready for the public you will want to change the meta data to match its content. Help</p><hr title="Banners" alt="Banners" class="system-pagebreak" style="color: gray; border: 1px dashed gray;" /><h3>Banners</h3><p>The banners component provides a simple way to display a rotating image in a module and, if you wish to have advertising, a way to track the number of times an image is viewed and clicked. Help</p>', '', 1, 21, '2010-07-10 18:03:52', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:03:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 5, 7, '', '', 1, 8, '', 0, '*', ''),
(8, 104, 'Beginners', 'beginners', '<p>If this is your first Joomla site or your first web site, you have come to the right place. Joomla will help you get your website up and running quickly and easily.</p><p>Start off using your site by logging in using the administrator account you created when you installed Joomla!.</p>', '<p>Explore the articles and other resources right here on your site data to learn more about how Joomla works.(When you\'re done reading, you can delete or archive all of this.) You will also probably want to visit the beginners\' areas of the <a href="http://docs.joomla.org">Joomla documentation</a> and <a href="http://forum.joomla.org">support forums</a>.</p><p>You\'ll also want to sign up for the Joomla Security Mailing list and the Announcements mailing list. For inspiration visit the Joomla Site Showcase to see an amazing array of ways people use Joomla to tell their stories on the web.</p><p>The basic Joomla! installation will let you get a great site up and running, but when you are ready for more features the power of Joomla! is in the creative ways that developers have extended it to do all kinds of things. Visit the Joomla! Extensions Directory to see thousands of extensions that can do almost anything you could want on a website. Can\'t find what you need? You may want to find a Joomla professional on the Joomla! Resources Directory.</p><p>Want to learn more? Consider attending a Joomla! Day or other event or joining a local Joomla! Users Group. Can\'t find one near you? Start one yourself.</p>', 1, 19, '2010-07-10 19:50:02', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:50:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 3, '', '', 1, 1, '', 1, '*', ''),
(2, 90, 'Archive Module', 'archive-module', '<p>This module shows a list of the calendar months containing archived articles. After you have changed the status of an article to archived, this list will be automatically generated. <a href="http://docs.joomla.org/Screen.modulessite.edit.15#Archived_Content" title="Archive Module">Help</a></p>\r\n<p>{loadposition archiveload}</p>', '', 1, 64, '2010-07-10 18:05:32', 42, 'Joomla!', '2010-09-14 11:22:24', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:37:13', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 7, 5, 'modules, content', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(7, 103, 'Banner Module', 'banner-module', '<p>The banner module is used to display the banners that are managed by the banners component in the site administrator.</p><p>{loadposition bannersload}</p>', '', 1, 66, '2010-07-10 19:47:47', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:47:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 6, '', '', 1, 4, '', 0, '*', ''),
(3, 91, 'Article Categories Module', 'article-categories-module', '<p>This module displays a list of categories from one parent category. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Categories" title="Categories Module">Help</a></p>\r\n<p>{loadposition articlescategoriesload}</p>\r\n<p> </p>', '', 1, 64, '2010-07-10 18:12:46', 42, '', '2010-09-14 11:22:06', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:14:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 7, 6, 'modules, content', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(4, 92, 'Articles Category Module', 'articles-category-module', '<p>This module allows you to display the articles in a specific category. Help.</p>\r\n<p>{loadposition articlescategoryload}</p>', '', 1, 64, '2010-07-10 18:14:09', 42, 'Joomla!', '2010-09-14 11:20:05', 42, 0, '0000-00-00 00:00:00', '2010-07-10 18:14:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 6, 7, '', 'articles,content', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(5, 101, 'Authentication', 'authentication', '<p>The authentication plugins operate when users login to your site or administrator. The Joomla! authentication is in operation by default but you can enable Gmail or LDAP or install a plugin for a different system. An example is included that may be used to create a new authentication plugin.</p><p>Default on:</p><ul><li>Joomla</li></ul><p>Default off:</p><ul><li>Gmail</li><li>LDAP</li></ul>', '', 1, 25, '2010-07-10 19:19:17', 42, 'Joomla!', '2010-07-10 19:51:19', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:39:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 3, '', '', 1, 4, '', 0, '*', ''),
(6, 102, 'Australian Parks ', 'australian-parks', '<p><img src="images/sampledata/parks/banner_cradle.jpg" border="0" alt="Cradle Park Banner" /></p>\r\n<p>Welcome!</p>\r\n<p>This is a basic site about the beautiful and fascinating parks of Australia.</p>\r\n<p>On this site you can read all about my travels to different parks, see photos, and find links to park websites.</p>\r\n<p><em>This sample site is an example of using the core of Joomla! to create a basic website, whether a "brochure site,"  a personal blog, or as a way to present information on a topic you are interested in.</em></p>\r\n<p><em> Read more about the site in the About Parks module.</em></p>\r\n<p> </p>', '', 1, 26, '2010-07-10 19:24:58', 42, 'Parks webmaster', '2010-11-21 20:10:59', 42, 0, '0000-00-00 00:00:00', '2010-07-10 19:39:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 6, 1, '', '', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(9, 105, 'Contact', 'contact', '<p>The contact component provides a way to provide contact forms and information for your site or to create a complex directory that can be used for many different purposes. Help</p>', '', 1, 21, '2010-07-10 19:54:09', 42, 'Joomla!', '2010-09-14 11:42:23', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:13:05', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 2, '', '', 1, 5, '', 0, '*', ''),
(10, 106, 'Content', 'content', '<p>The content component (com_content) is what you use to write articles. It is extremely flexible and has the largest number of built in views. Articles can be created an edited from the front end, making content the easiest component to use to create your site content. Help</p>', '', 1, 21, '2010-07-10 19:56:38', 42, '', '2010-07-10 23:13:20', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:13:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 1, '', '', 1, 14, '', 0, '*', ''),
(11, 107, 'Cradle Mountain', 'cradle-mountain', '<p><img src="images/sampledata/parks/landscape/250px_cradle_mountain_seen_from_barn_bluff.jpg" border="0" alt="Cradle Mountain" style="vertical-align: middle;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_cradle_mountain_seen_from_barn_bluff.jpg" border="0" alt="Cradle Mountain" style="vertical-align: middle;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Rainforest,bluemountainsNSW.jpg</p><p class="caption">Author: Alan J.W.C.</p><p class="caption">License: GNU Free Documentation License v . 1.2 or later</p>', 1, 73, '2010-07-10 20:01:42', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:06:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 1, '', '', 1, 0, '', 0, '*', ''),
(12, 110, 'Custom HTML Module', 'custom-html-module', '<p>This Module allows you to create your own HTML Module using a WYSIWYG editor. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Custom_HTML" title="Custom HTML Module">Help</a></p><p>{loadposition customload}</p>', '', 1, 66, '2010-07-10 20:07:23', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-07-10 20:07:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 1, '', '', 1, 5, '', 0, '*', ''),
(13, 111, 'Directions', 'directions', '<p>Here\'s how to find our shop.</p><p>By car</p><p>Drive along Main Street to the intersection with First Avenue.  Look for our sign.</p><p>By foot</p><p>From the center of town, walk north on Main Street until you see our sign.</p><p>By bus</p><p>Take the #73 Bus to the last stop. We are on the north east corner.</p>', '', 1, 29, '2010-07-10 20:12:32', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:12:32', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 2, '', '', 1, 3, '', 0, '*', ''),
(14, 112, 'Editors', 'editors', '<p>Editors are used thoughout Joomla! where content is created. TinyMCE is the default choice in most locations although CodeMirror is used in the template manager. No Editor provides a text box for html content.</p><p>Default on:</p><ul><li>CodeMirror Help</li><li>TinyMCE Help</li><li>No Editor Help</li></ul><p>Default off:</p><ul><li>None</li></ul>', '', 1, 25, '2010-07-10 20:26:06', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:26:06', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 5, '', '', 1, 3, '', 0, '*', ''),
(15, 113, 'Editors-xtd', 'editors-xtd', '<p>These plugins are behind the buttons found beneath your editor. They only run when an editor plugin runs.</p><p>Default on:</p><ul><li>Editor Button: Image</li><li>Editor Button: Readmore</li><li>Editor Button: Page Break</li><li>Editor Button: Article</li></ul><p>Default off:</p><ul><li>None</li></ul>', '', 1, 25, '2010-07-10 20:27:20', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:27:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 6, '', '', 1, 2, '', 0, '*', ''),
(16, 114, 'Feed Display', 'feed-display', '<p>This module allows the displaying of a syndicated feed. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Feed_Display" title="Feed Display Module">Help</a></p><p>{loadposition feeddisplayload}</p>', '', 1, 66, '2010-07-10 20:29:29', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 2, '', '', 1, 5, '', 0, '*', ''),
(17, 115, 'First Blog Post', 'first-blog-post', '<p><em>Lorem Ipsum is filler text that is commonly used by designers before the content for a new site is ready.</em></p><p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed faucibus purus vitae diam posuere nec eleifend elit dictum. Aenean sit amet erat purus, id fermentum lorem. Integer elementum tristique lectus, non posuere quam pretium sed. Quisque scelerisque erat at urna condimentum euismod. Fusce vestibulum facilisis est, a accumsan massa aliquam in. In auctor interdum mauris a luctus. Morbi euismod tempor dapibus. Duis dapibus posuere quam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. In eu est nec erat sollicitudin hendrerit. Pellentesque sed turpis nunc, sit amet laoreet velit. Praesent vulputate semper nulla nec varius. Aenean aliquam, justo at blandit sodales, mauris leo viverra orci, sed sodales mauris orci vitae magna.</p>', '<p>Quisque a massa sed libero tristique suscipit. Morbi tristique molestie metus, vel vehicula nisl ultrices pretium. Sed sit amet est et sapien condimentum viverra. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Phasellus viverra tortor porta orci convallis ac cursus erat sagittis. Vivamus aliquam, purus non luctus adipiscing, orci urna imperdiet eros, sed tincidunt neque sapien et leo. Cras fermentum, dolor id tempor vestibulum, neque lectus luctus mauris, nec congue tellus arcu nec augue. Nulla quis mi arcu, in bibendum quam. Sed placerat laoreet fermentum. In varius lobortis consequat. Proin vulputate felis ac arcu lacinia adipiscing. Morbi molestie, massa id sagittis luctus, sem sapien sollicitudin quam, in vehicula quam lectus quis augue. Integer orci lectus, bibendum in fringilla sit amet, rutrum eget enim. Curabitur at libero vitae lectus gravida luctus. Nam mattis, ligula sit amet vestibulum feugiat, eros sem sodales mi, nec dignissim ante elit quis nisi. Nulla nec magna ut leo convallis sagittis ac non erat. Etiam in augue nulla, sed tristique orci. Vestibulum quis eleifend sapien.</p><p>Nam ut orci vel felis feugiat posuere ut eu lorem. In risus tellus, sodales eu eleifend sed, imperdiet id nulla. Nunc at enim lacus. Etiam dignissim, arcu quis accumsan varius, dui dui faucibus erat, in molestie mauris diam ac lacus. Sed sit amet egestas nunc. Nam sollicitudin lacinia sapien, non gravida eros convallis vitae. Integer vehicula dui a elit placerat venenatis. Nullam tincidunt ligula aliquet dui interdum feugiat. Maecenas ultricies, lacus quis facilisis vehicula, lectus diam consequat nunc, euismod eleifend metus felis eu mauris. Aliquam dapibus, ipsum a dapibus commodo, dolor arcu accumsan neque, et tempor metus arcu ut massa. Curabitur non risus vitae nisl ornare pellentesque. Pellentesque nec ipsum eu dolor sodales aliquet. Vestibulum egestas scelerisque tincidunt. Integer adipiscing ultrices erat vel rhoncus.</p><p>Integer ac lectus ligula. Nam ornare nisl id magna tincidunt ultrices. Phasellus est nisi, condimentum at sollicitudin vel, consequat eu ipsum. In venenatis ipsum in ligula tincidunt bibendum id et leo. Vivamus quis purus massa. Ut enim magna, pharetra ut condimentum malesuada, auctor ut ligula. Proin mollis, urna a aliquam rutrum, risus erat cursus odio, a convallis enim lectus ut lorem. Nullam semper egestas quam non mattis. Vestibulum venenatis aliquet arcu, consectetur pretium erat pulvinar vel. Vestibulum in aliquet arcu. Ut dolor sem, pellentesque sit amet vestibulum nec, tristique in orci. Sed lacinia metus vel purus pretium sit amet commodo neque condimentum.</p><p>Aenean laoreet aliquet ullamcorper. Nunc tincidunt luctus tellus, eu lobortis sapien tincidunt sed. Donec luctus accumsan sem, at porttitor arcu vestibulum in. Sed suscipit malesuada arcu, ac porttitor orci volutpat in. Vestibulum consectetur vulputate eros ut porttitor. Aenean dictum urna quis erat rutrum nec malesuada tellus elementum. Quisque faucibus, turpis nec consectetur vulputate, mi enim semper mi, nec porttitor libero magna ut lacus. Quisque sodales, leo ut fermentum ullamcorper, tellus augue gravida magna, eget ultricies felis dolor vitae justo. Vestibulum blandit placerat neque, imperdiet ornare ipsum malesuada sed. Quisque bibendum quam porta diam molestie luctus. Sed metus lectus, ornare eu vulputate vel, eleifend facilisis augue. Maecenas eget urna velit, ac volutpat velit. Nam id bibendum ligula. Donec pellentesque, velit eu convallis sodales, nisi dui egestas nunc, et scelerisque lectus quam ut ipsum.</p>', 1, 27, '2010-07-10 20:31:31', 42, '', '2011-01-28 11:50:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:33:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 0, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(18, 116, 'Second Blog Post', 'second-blog-post', '<p><em>Lorem Ipsum is text that is traditionally used by designers when working on a site before the content is ready.</em></p><p>Pellentesque bibendum metus ut dolor fermentum ut pulvinar tortor hendrerit. Nam vel odio vel diam tempus iaculis in non urna. Curabitur scelerisque, nunc id interdum vestibulum, felis elit luctus dui, ac dapibus tellus mauris tempus augue. Duis congue facilisis lobortis. Phasellus neque erat, tincidunt non lacinia sit amet, rutrum vitae nunc. Sed placerat lacinia fermentum. Integer justo sem, cursus id tristique eget, accumsan vel sapien. Curabitur ipsum neque, elementum vel vestibulum ut, lobortis a nisl. Fusce malesuada mollis purus consectetur auctor. Morbi tellus nunc, dapibus sit amet rutrum vel, laoreet quis mauris. Aenean nec sem nec purus bibendum venenatis. Mauris auctor commodo libero, in adipiscing dui adipiscing eu. Praesent eget orci ac nunc sodales varius.</p>', '<p>Nam eget venenatis lorem. Vestibulum a interdum sapien. Suspendisse potenti. Quisque auctor purus nec sapien venenatis vehicula malesuada velit vehicula. Fusce vel diam dolor, quis facilisis tortor. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Pellentesque libero nisi, pellentesque quis cursus sit amet, vehicula vitae nisl. Curabitur nec nunc ac sem tincidunt auctor. Phasellus in mattis magna. Donec consequat orci eget tortor ultricies rutrum. Mauris luctus vulputate molestie. Proin tincidunt vehicula euismod. Nam congue leo non erat cursus a adipiscing ipsum congue. Nulla iaculis purus sit amet turpis aliquam sit amet dapibus odio tincidunt. Ut augue diam, congue ut commodo pellentesque, fermentum mattis leo. Sed iaculis urna id enim dignissim sodales at a ipsum. Quisque varius lobortis mollis. Nunc purus magna, pellentesque pellentesque convallis sed, varius id ipsum. Etiam commodo mi mollis erat scelerisque fringilla. Nullam bibendum massa sagittis diam ornare rutrum.</p><p>Praesent convallis metus ut elit faucibus tempus in quis dui. Donec fringilla imperdiet nibh, sit amet fringilla velit congue et. Quisque commodo luctus ligula, vitae porttitor eros venenatis in. Praesent aliquet commodo orci id varius. Nulla nulla nibh, varius id volutpat nec, sagittis nec eros. Cras et dui justo. Curabitur malesuada facilisis neque, sed tempus massa tincidunt ut. Sed suscipit odio in lacus auctor vehicula non ut lacus. In hac habitasse platea dictumst. Sed nulla nisi, lacinia in viverra at, blandit vel tellus. Nulla metus erat, ultrices non pretium vel, varius nec sem. Morbi sollicitudin mattis lacus quis pharetra. Donec tincidunt mollis pretium. Proin non libero justo, vitae mattis diam. Integer vel elit in enim varius posuere sed vitae magna. Duis blandit tempor elementum. Vestibulum molestie dui nisi.</p><p>Curabitur volutpat interdum lorem sed tempus. Sed placerat quam non ligula lacinia sodales. Cras ultrices justo at nisi luctus hendrerit. Quisque sit amet placerat justo. In id sapien eu neque varius pharetra sed in sapien. Etiam nisl nunc, suscipit sed gravida sed, scelerisque ut nisl. Mauris quis massa nisl, aliquet posuere ligula. Etiam eget tortor mauris. Sed pellentesque vestibulum commodo. Mauris vitae est a libero dapibus dictum fringilla vitae magna.</p><p>Nulla facilisi. Praesent eget elit et mauris gravida lobortis ac nec risus. Ut vulputate ullamcorper est, volutpat feugiat lacus convallis non. Maecenas quis sem odio, et aliquam libero. Integer vel tortor eget orci tincidunt pulvinar interdum at erat. Integer ullamcorper consequat eros a pellentesque. Cras sagittis interdum enim in malesuada. Etiam non nunc neque. Fusce non ligula at tellus porta venenatis. Praesent tortor orci, fermentum sed tincidunt vel, varius vel dui. Duis pulvinar luctus odio, eget porta justo vulputate ac. Nulla varius feugiat lorem sed tempor. Phasellus pulvinar dapibus magna eget egestas. In malesuada lectus at justo pellentesque vitae rhoncus nulla ultrices. Proin ut sem sem. Donec eu suscipit ipsum. Cras eu arcu porttitor massa feugiat aliquet at quis nisl.</p>', 1, 27, '2010-07-10 20:33:28', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2010-07-10 20:33:28', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 0, '', '', 1, 0, '', 0, '*', ''),
(19, 117, 'Footer Module', 'footer-module', '<p>This module shows the Joomla! copyright information. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Footer" title="Footer Module">Help</a></p><p>{loadposition footerload}</p>', '', 1, 66, '2010-07-10 20:53:39', 42, 'Joomla!', '2010-07-10 20:56:22', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:56:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 3, '', '', 1, 2, '', 0, '*', ''),
(20, 118, 'Fruit Shop', 'fruit-shop', '<h2>Welcome to the Fruit Shop</h2><p>We sell fruits from around the world. Please use our website to learn more about our business. We hope you will come to our shop and buy some fruit.</p><p ><em>This mini site will show you how you might want to set up a site for a business, in this case one selling fruit. It shows how to use access controls to manage your site content. If you were building a real site, you would might want to extend it with e-commerce, a catalog, mailing lists or other enhancements, many of which are available through the</em><a href="http://extensions.joomla.org"><em> Joomla! Extensions Directory</em></a>.</p><p><em>To understand this site you will probably want to make one user with groups set to customer and one with group set to grower. By logging in with different privileges  you can see how access control works.</em></p>', '', 1, 29, '2010-07-10 20:54:54', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:56:32', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 1, '', '', 1, 4, '', 0, '*', ''),
(21, 119, 'Getting Help', 'getting-help', '<p>There are lots of places you can get help with Joomla!.</p><p>In many places you will see the help icon [image]. Click on this for more information about the options and functions of items on your screen.</p><ul><li><a href="http://forum.joomla.org">Support Forums</a></li><li><a href="http://docs.joomla.org">Documentation</a></li><li><a href="http://resources.joomla.org">Professionals</a></li><li><a href="http://shop.joomla.org/amazoncom-bookstores.html">Books</a></li></ul>', '', 1, 19, '2010-07-10 20:55:56', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:55:56', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 8, '', '', 1, 9, '', 0, '*', ''),
(22, 120, 'Getting Started', 'getting-started', '<p>It\'s easy to get started creating your website. Knowing some of the basics will help.</p><h3>What is a Content Management System?</h3><p>A content management system is software that allows you to create and manage webpages easily by separating the creation of your content from the mechanics required to present it on the web.</p><p>In this site, the content is stored in a <em>database</em>. The look and feel are created by a <em>template</em>. The Joomla! software brings together the template and the content to create web pages.</p><h3>Site and Administrator</h3><p>Your site actually has two separate sites. The site (also called the front end) is what visitors to your site will see.  The administrator (also called the back end) is only used by people managing your site. You can access the administrator by clicking the "Site Administrator" link on the "This Site" menu or by adding /administrator to the end of you domain name.</p><p>Log in to the administrator using the username and password created during the installation of Joomla!.</p><h3>Logging in</h3><p>To login to the front end of your site use the login form or the login menu link on the "This Site" menu. Use the user name an password that were created as part of the installation process. Once logged in you will be able to create and edit articles.</p><p>In managing your site, you will be able to create content that only logged in users are able to see.</p><h3>Creating an article</h3><p>Once you are logged in, a new menu will be visible.  To create a new article, click on the "submit article" link on that menu.</p><p>The new article interface gives you a lot of options, but all you need to do is add a title an put something in the content area. To make it easy to find, set the state to published an put it in the Joomla! category.</p><div>You can edit an existing article by  clicking on the edit icon (if available).</div><h3>Learn more</h3><p>There is much more to learn about how to use Joomla! to create the web site you envision. You can learn much more at the <a href="http://docs.joomla.org">Joomla! documentation site</a> and on the<a href="http://forum.joomla.org"> Joomla! forums</a>.</p>', '', 1, 19, '2010-07-10 20:57:51', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 9, '', '', 1, 9, '', 0, '*', ''),
(23, 121, 'Happy Orange Orchard', 'happy-orange-orchard', '<p>At our orchard we grow the world\'s best oranges as well as other citrus fruit such as lemons and grapefruit. Our family has been tending this orchard for generations.</p>', '', 1, 30, '2010-07-10 20:58:46', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 20:58:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 2, '', '', 1, 1, '', 0, '*', ''),
(24, 122, 'Joomla!', 'joomla', '<p>Congratulations! You have a Joomla! site! Joomla! makes your site easy to build a website just the way you want it and keep it simple to update and maintain.</p>\r\n<p>Joomla! is a flexible and powerful platform, whether you are building a small site for yourself or a huge site with hundreds of thousands of visitors. Joomla is open source, which means you can make it work just the way you want it to.</p>', '', 1, 19, '2010-07-10 21:00:06', 42, 'Joomla!', '2010-09-14 04:49:09', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:00:06', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 2, '', '', 1, 5, '', 1, '*', ''),
(25, 123, 'Koala', 'koala', '<p><img src="images/sampledata/parks/animals/180px_koala_ag1.jpg" border="0" alt="Koala  Thumbnail" width="180" height="123" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/800px_koala_ag1.jpg" border="0" alt="Koala Climbing Tree" width="500" height="341" style="vertical-align: middle; border: 0;" /></p><p> </p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Koala-ag1.jpg</p><p class="caption">Author: Arnaud Gaillard</p><p><span class="caption">License: Creative Commons Share Alike Attribution Generic 1.0</span></p>', 1, 72, '2010-07-10 21:02:10', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:02:28', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 2, '', '', 1, 0, '', 0, '*', ''),
(26, 124, 'Language Switcher', 'language-switcher', '<p>The language switcher module allows you to take advantage of the language tags that are available when content, modules and menu links are created.</p><p>This module displays a list of available Content Languages for switching between them.</p><p>When switching languages, it redirects to the Home page defined for the chosen language. Thereafter, the navigation will be the one defined for that language.</p><p><strong>The language filter plugin must be enabled for this module to work properly.</strong></p><p><strong></strong> <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Language_Switcher" title="Language Switcher Module">Help</a></p><p>To view an example of the language switch moduler module, go to the site administrator and enable the language filter plugin and the language switcher module labellled "language switcher" and visit the fruit shop or park sample sites. Then follow<a href="http://docs.joomla.org/Language_Switcher_Tutorial_for_Joomla_1.6"> the instructions in this tutorial</a>.</p>', '', 1, 67, '2010-07-10 21:07:16', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:07:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 3, '', '', 1, 3, '', 0, '*', ''),
(27, 125, 'Latest Articles Module', 'latest-articles-module', '<p>This Module shows a list of the most recently published and current Articles. Some that are shown may have expired even though they are the most recent. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Latest_News" title="Latest Articles">Help</a></p>\r\n<p>{loadposition articleslatestload}</p>', '', 1, 64, '2010-07-10 21:08:42', 42, '', '2010-09-14 11:21:33', 42, 0, '0000-00-00 00:00:00', '2010-09-14 11:21:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 4, 1, 'modules, content', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(28, 126, 'Login Module', 'login-module', '<p>This module displays a username and password login form. It also displays a link to retrieve a forgotten password. If user registration is enabled (in the Global Configuration settings), another link will be shown to enable self-registration for users. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Login" title="Login">Help</a></p><p>{loadposition loginload}</p>', '', 1, 65, '2010-07-10 21:10:16', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:10:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 2, '', '', 1, 4, '', 0, '*', ''),
(29, 127, 'Menu Module', 'menu-module', '<p>This module displays a menu on the site (frontend).  Menus can be displayed in a wide variety of ways by using the menu options and css menu styles.</p>\r\n<p>{loadposition menuload}</p>', '', 1, 75, '2010-07-10 21:21:52', 42, 'Joomla!', '2010-08-23 03:02:54', 42, 0, '0000-00-00 00:00:00', '2010-07-11 14:59:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 1, '', '', 1, 3, '', 0, '*', ''),
(30, 128, 'Most Read Content', 'most-read-content', '<p>This Module shows a list of the currently published Articles which have the highest number of page views. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Most_Read_Content" title="Most Read Content">Help</a></p>\r\n<p>{loadposition articlespopularload}</p>', '', 1, 64, '2010-07-10 21:25:23', 42, 'Joomla!', '2010-09-14 11:21:05', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:25:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 5, 2, 'modules, content', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(31, 129, 'News Flash', 'news-flash', '<p>Displays a set number of articles from a category based on date or random selection. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#NewsFlash" title="News Flash Module">Help</a></p>\r\n<p>{loadposition newsflashload}</p>', '', 1, 64, '2010-07-10 21:28:50', 42, '', '2010-09-14 11:20:50', 42, 0, '0000-00-00 00:00:00', '2010-09-14 11:20:50', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 3, 3, 'modules, content', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(32, 130, 'Parameters', 'parameters', '<p>As you make your Joomla! site using the extension you will control the details of the display using <em>parameter</em><strong>s</strong>. Parameters control everything from whether the author\'s name is displayed to who can view what to the number of items shown on a list.</p><p>Default parameters for each components are changed using the Options button on the component toolbar.</p><p>Parameters can also be set on an individual item, such as an article or contact and in menu links.</p><p>If you are happy with how your site looks, it is fine to leave all of the parameters set to the defaults that were created when your site was installed. As you become more experienced with Joomla! you will use parameters more.</p><p> </p>', '', 1, 19, '2010-07-10 21:35:48', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 10, '', '', 1, 11, '', 0, '*', ''),
(33, 131, 'Phyllopteryx', 'phyllopteryx', '<p><img src="images/sampledata/parks/animals/200px_phyllopteryx_taeniolatus1.jpg" border="0" style="vertical-align: middle;" /></p><p> </p>', '<p><img src="images/sampledata/parks/animals/800px_phyllopteryx_taeniolatus1.jpg" border="0" style="vertical-align: middle;" /></p><p> </p><p>Source: http://en.wikipedia.org/wiki/File:Phyllopteryx_taeniolatus1.jpg</p><p>Author: Richard Ling</p><p>License: GNU Free Documentation License v 1.2 or later</p>', 1, 72, '2010-07-10 21:37:12', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:37:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 3, '', '', 1, 0, '', 0, '*', ''),
(34, 132, 'Pinnacles', 'pinnacles', '<p><img src="images/sampledata/parks/landscape/120px_pinnacles_western_australia.jpg" border="0" alt="Kings Canyon" width="120" height="90" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_pinnacles_western_australia.jpg" border="0" alt="King\'s Canyon" width="500" height="374" style="vertical-align: middle; border: 0;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Pinnacles_Western_Australia.jpg</p><p class="caption">Author: <a class="new" href="http://commons.wikimedia.org/w/index.php?title=User:Markdoe&action=edit&redlink=1" title="User:Markdoe (page does not exist)"></a>Martin Gloss</p><p class="caption">License: GNU Free Documentation license v 1.2 or later.</p>', 1, 73, '2010-07-10 21:38:36', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 07:21:29', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 4, '', '', 1, 1, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(35, 133, 'Professionals', 'professionals', '<p>Joomla! 1.6 continues development of the Joomla Framework and CMS as a powerful and flexible way to bring your vision of the web to reality. With the administrator now fully MVC, the ability to control its look and the management of extensions is now complete.</p>', '<p>Working with multiple template styles and overrides for the same views, creating the design you want is easier than it has ever been. Limiting support to PHP 5.x and above and ending legacy support for Joomla 1.0 extensions makes Joomla! lighter and faster than ever. Languages files can now be overridden without having your changes lost during an upgrade.  With the proper xml your users update extensions with a single click.</p><p>Access control lists are now incorporated using a new system developed for Joomla!. The ACL system is designed with developers in mind, so it is easy to incorporate into your extensions. The new nested sets libraries allow you to incorporate infinitely deep categories but also to use nested sets in a variety of other ways.</p><p>A new forms library makes creating all kinds of user interaction simple. MooTools 1.2 provides a highly flexible javascript framework that is a major advance over MooTools 1.0.</p><p>New events throughout the core make integration of your plugins where you want them a snap.</p><p>Learn about:</p><ul><li>[Working with ACL] </li><li>[Working with nested categories] </li><li>[Using the forms library] </li><li>[Working with Mootools 1.2] </li><li>[Using the override system] </li><li>[Joomla! API]</li><li>[Using JDatabaseQuery] </li><li>[Triggers] </li><li>[Xmlrpc] </li><li>[Installing and updating extensions]</li><li>[Setting up your development environment]</li></ul>', 1, 19, '2010-07-10 21:47:11', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 6, '', '', 1, 0, '', 1, '*', ''),
(36, 134, 'Random Image Module', 'random-image-module', '<p>This Module displays a random image from your chosen image directory. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Random_Image" title="Random Image Module">Help</a></p><p>{loadposition randomimageload}</p>', '', 1, 66, '2010-07-10 21:51:54', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 4, '', '', 1, 2, '', 0, '*', ''),
(37, 135, 'Related Items Module', 'related-items-module', '<p>This Module displays other Articles that are related to the one currently being viewed. These relations are established by the Meta Keywords.  All the keywords of the current Article are searched against all the keywords of all other published articles. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Related_Articles" title="Related Items Module">Help</a></p>\r\n<p>{loadposition relateditemsload}</p>', '', 1, 64, '2010-07-10 21:53:14', 42, 'Joomla!', '2010-09-14 11:23:07', 42, 0, '0000-00-00 00:00:00', '2010-09-14 11:23:07', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","page_title":"","alternative_readmore":"","layout":""}', 3, 4, 'modules, content', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(38, 136, 'Sample Sites', 'sample-sites', '<p>Your installation includes sample data, designed to show you some of the options you have for building your website. In addition to information about Joomla! there are two sample "sites within a site" designed to help you get started with builidng your own site.</p>\r\n<p>The first site is a simple site about <a href="index.php?Itemid=243">Australian Parks</a>. It shows you you an quickly and easily build a personal site with just the building blocks that are part of Joomla!. It includes a personal blog, weblinks, and a very simple image gallery.</p>\r\n<p>The second site is slightly more complex and represents what you might do if you are building a site for a small business, in this case a <a href="index.php/welcome.html"></a><a href="index.php?Itemid=429">Fruit Shop</a>.</p>\r\n<p>In building either style site, or something completely different, you will probably want to add <a href="http://extensions.joomla.org">extensions</a> and either create or purchase your own template. Many Joomla! users start off by modifying the <a href="http://docs.joomla.org/How_do_you_modify_a_template%3F">templates</a> that come with the core distribution so that they include special images and other design elements that relate to their site\'s focus.</p>', '', 1, 19, '2010-07-10 21:55:29', 42, 'Joomla!', '2011-01-07 00:06:31', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:55:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 5, 11, '', '', 1, 10, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(39, 137, 'Search', 'search-component', '<p>The search component proviedes basic search functionality for the information contained in your core components. Many third part extensions also can be searched by the search component. Help</p>', '', 1, 21, '2010-07-10 21:57:00', 42, 'Joomla!', '2010-07-10 23:14:32', 42, 0, '0000-00-00 00:00:00', '2010-07-10 21:57:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 3, '', '', 1, 5, '', 0, '*', ''),
(40, 138, 'Search Module', 'search-module', '<p>This module will display a search box. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Search" title="Search">Help</a></p><p>{loadposition searchload}</p>', '', 1, 67, '2010-07-10 22:00:58', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:00:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 4, '', '', 1, 2, '', 0, '*', ''),
(41, 139, 'Search ', 'search-plugin', '<p>The search component uses plugins to control which parts of your Joomla! site are searched. You may choose to turn off some areas to improve performance or for other reasons. Many third party Joomla! extensions have search plugins that extend where search takes place.</p><p>Default On:</p><ul><li>Content Help</li><li>Contacts Help</li><li>Weblinks Help</li><li>News Feeds Help</li><li>Categories Help</li></ul>', '', 1, 25, '2010-07-10 22:02:17', 42, 'Joomla!', '2010-07-10 23:15:44', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:15:44', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 1, '', '', 1, 2, '', 0, '*', ''),
(42, 140, 'Site Map', 'site-map', '<p>{loadposition sitemapload}</p><p><em>By putting all of your content into nested categories you can give users and search engines access to everything using a menu.</em></p>', '', 1, 14, '2010-07-10 22:03:35', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:03:35', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 3, '', '', 1, 2, '', 0, '*', ''),
(43, 141, 'Spotted Quoll', 'spotted-quoll', '<p><img src="images/sampledata/parks/animals/220px_spottedquoll_2005_seanmcclean.jpg" border="0" alt="Spotted Quoll" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/789px_spottedquoll_2005_seanmcclean.jpg" border="0" alt="Spotted Quoll" style="vertical-align: middle;" /></p><p> </p><p>Source: http://en.wikipedia.org/wiki/File:SpottedQuoll_2005_SeanMcClean.jpg</p><p>Author: Sean McClean</p><p>License: GNU Free Documentation License v 1.2 or later</p>', 1, 72, '2010-07-10 22:04:40', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:04:40', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 4, '', '', 1, 0, '', 0, '*', ''),
(44, 142, 'Statistics Module', 'statistics', '<p>The Statistics Module shows information about your server installation together with statistics on the Web site users, number of Articles in your database and the number of Web links you provide.</p><p>{loadposition statisticsload}</p>', '', 1, 67, '2010-07-10 22:05:45', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:06:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 5, '', '', 1, 2, '', 0, '*', ''),
(45, 143, 'Syndicate Module', 'syndicate-module', '<p>The syndicate module allows you to display a link that allows users to take a feed from your site. It will only display on pages for which feeds are possible. That means it will not display on single article, contact or weblinks pages, such as this one. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Syndicate" title="Synicate Module">Help</a></p><p>{loadposition syndicateload}</p>', '', 1, 67, '2010-07-10 22:07:51', 42, '', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:07:51', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 6, '', '', 1, 3, '', 0, '*', ''),
(46, 144, 'System', 'system', '<p>System plugins operate every time a page on your site loads. They control such things as your URLS, whether users can check a "remember me" box on the login module, and whether caching is enabled.  New in 1.6 is the redirect plugin that with the redirect component assist you in managing changes in URLs.</p><p>Default on:</p><ul><li>Remember me Help</li><li>SEF Help</li><li>Debug Help</li></ul><p>Default off:</p><ul><li>Cache Help</li><li>Log Help</li><li>Redirect Help</li></ul>', '', 1, 25, '2010-07-10 22:09:41', 42, 'Joomla!', '2010-07-10 23:15:54', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:09:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 2, '', '', 1, 2, '', 0, '*', ''),
(47, 145, 'The Joomla! Community', 'the-joomla-community', '<p>Joomla! means All Together, and it is a community of people all working and having fun together that makes Joomla! possible. Thousands of people each year participate in the Joomla! community, and we hope you will be one of them.<a href="index.php?option=com_content&view=article&catid=40&id=27">Archive Module</a></p><p>People with all kinds of skills, of all skill levels and from around the world are welcome to join in. Participate in the <a href="http://joomla.org">Joomla.org</a> family of websites (the<a href="http://forum.joomla.org"> forum </a>is a great place to start). Come to a <a href="http://community.joomla.org/events.html">Joomla! event</a>. Join or start a <a href="http://community.joomla.org/user-groups.html">Joomla! Users Group</a>. Whether you are a developer, site administrator, designer, end user or fan, there are ways for you to participate and contribute.</p>', '', 1, 19, '2010-07-10 22:11:09', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 4, '', '', 1, 12, '', 0, '*', ''),
(48, 146, 'The Joomla! Project', 'the-joomla-project', '<p>The Joomla! Project consists of all of the people who make and support the Joomla! Web Platform and Content Management System.</p><p>Our mission is to provide a flexible platform for digital publishing and collaboration.</p><p>The core values are:</p><ul><li>Freedom</li><li>Equality</li><li>Trust</li><li>Community</li><li>Collaboration</li><li>Usability</li></ul><p>In our vision, we see:</p><ul><li>People publishing and collaborating in their communities and around the world</li><li>Software that is free, secure, and high-quality</li><li>A community that is enjoyable and rewarding to participate in</li><li>People around the world using their preferred languages</li><li>A project that acts autonomously</li><li>A project that is socially responsible</li><li>A project dedicated to maintaining the trust of its users</li></ul><p>There are millions of users around the world and thousands of people who contribute to the Joomla! Project. They work in three main groups: the Production Working Group, responsible for everything that goes into software and documentation; the Community Working Group, responsible for creating a nurturing the community; and Open Source Matters, the non profit organization responsible for managing legal, financial and organizational issues.</p><p>Joomla! is a free and open source project, which uses the GNU General Public License version 2 or later.</p>', '', 1, 19, '2010-07-10 22:20:16', 42, '', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 1, '', '', 1, 17, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(49, 147, 'Typography', 'typography', '<div id="ja-typo">\r\n<p>This page presents most of typographical aspects of JA T3v2 Framework. <span class="highlight">Make your readers happy</span> with great Typography and User Experience!</p>\r\n\r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Preformatted text</span></h1>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Headings</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<h1>This is a sample Heading 1. Lorem ipsum.</h1>\r\n<h2>This is a sample Heading 2. Lorem ipsum.</h2>\r\n<h3>This is a sample Heading 3. Lorem ipsum.</h3>\r\n<h4>This is a sample Heading 4. Lorem ipsum.</h4>\r\n<h5>This is a sample Heading 5. Lorem ipsum.</h5>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Special Content</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>Below is a sample of <strong>&lt;pre&gt;</strong> tag or <strong>code</strong> class:</p>\r\n<pre>#ja-rightcol {<br />  width: 180px;<br />  float: right;<br />  color: #EEEEEE;<br />}<br /></pre>\r\n<p>This is a <span class="highlight">highlight phrase</span>. Use <strong>&lt;span class="highlight"&gt;Your highlight phrase goes here!&lt;/span&gt;</strong>.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Blockquote</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<blockquote><span class="open">T</span>his is a sample Blockquote. Use <strong>&lt;blockquote&gt;Your quote goes here!&lt;/blockquote&gt;</strong> to form a quote!</blockquote>\r\n<blockquote><span class="open">T</span>his is a sample Blockquote. Use <strong>&lt;blockquote&gt;&lt;span  class="open"&gt;Y&lt;/span&gt;our quote goes her&lt;span  class="close"&gt;e!&lt;/span&gt;&lt;/blockquote&gt;</strong> to form a quote<span class="close">!</span></blockquote>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Dropcaps</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p><span class="dropcap">T</span>his is a Magazine Style Drop Cap. The first  letter in this paragraph is big. JA Templates bring into your Jooomla  template the magazine drop cap technique and CSS2 includes the  first-letter pseudo class. Use <strong>&lt;p&gt;&lt;span class="dropcap"&gt;T&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong> to form a dropcap!</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n \r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Lists Style</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block first clearfix">\r\n<h2 class="ja-typo-title"><span>Ordered List</span></h2>\r\n<div class="ja-typo-blockct clearfix"><ol>\r\n<li>This is a sample <strong>Ordered List</strong>.</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n</ol></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Un-Ordered List</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<ul>\r\n<li>This is a sample <strong>Unordered List</strong>.</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n<li>Lorem ipsum dolor sit amet consectetur</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block last clearfix">\r\n<h2 class="ja-typo-title"><span>Definition List</span></h2>\r\n<div class="ja-typo-blockct clearfix"><dl> <dt>This is a sample <strong>Definition List</strong>.</dt> <dd>Condimentum quis.</dd> <dd>Congue Quisque augue elit dolor.</dd> <dd>Congue Quisque augue elit dolor.</dd> </dl></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Special Unordered Lists</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-arrow">\r\n<li><span class="icon"> </span>This is a sample <strong>Arrow list</strong>.</li>\r\n<li><span class="icon"> </span>Use <strong>&lt;ul class="ja-typo-list list-arrow"&gt;&lt;li&gt;&lt;span class="icon"&gt; &lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class="icon"> </span>This is a sample Arrowlist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-star">\r\n<li><span class="icon"> </span>This is a sample <strong>Star list</strong>.</li>\r\n<li><span class="icon"> </span>Use <strong>&lt;ul class="ja-typo-list list-star"&gt;&lt;li&gt;&lt;span class="icon"&gt; &lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class="icon"> </span>This is a sample Starlist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<ul class="ja-typo-list list-check">\r\n<li><span class="icon"> </span>This is a sample <strong>Check list</strong>.</li>\r\n<li><span class="icon"> </span>Use <strong>&lt;ul class="ja-typo-list list-check"&gt;&lt;li&gt;&lt;span class="icon"&gt; &lt;/span&gt;List\'s content goes here!&lt;/li&gt;&lt;/ul&gt;</strong></li>\r\n<li><span class="icon"> </span>This is a sample Checklist.</li>\r\n</ul>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Block Number</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">01</span>Use <strong>&lt;p class="blocknumber blocknumber-1"&gt;&lt;span class="bignumber"&gt;01&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">02</span>Use <strong>&lt;p class="blocknumber blocknumber-1"&gt;&lt;span class="bignumber"&gt;02&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n<p class="blocknumber blocknumber-1"><span class="bignumber">03</span>Use <strong>&lt;p class="blocknumber blocknumber-1"&gt;&lt;span class="bignumber"&gt;03&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">A</span>Use <strong>&lt;p class="blocknumber blocknumber-2"&gt;&lt;span class="bignumber"&gt;A&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">B</span>Use <strong>&lt;p class="blocknumber blocknumber-2"&gt;&lt;span class="bignumber"&gt;B&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n<p class="blocknumber blocknumber-2"><span class="bignumber">C</span>Use <strong>&lt;p  class="blocknumber blocknumber-2"&gt;&lt;span class="bignumber"&gt;C&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">a</span>Use <strong>&lt;p class="blocknumber blocknumber-3"&gt;&lt;span class="bignumber"&gt;a&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">b</span>Use <strong>&lt;p class="blocknumber blocknumber-3"&gt;&lt;span class="bignumber"&gt;b&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n<p class="blocknumber blocknumber-3"><span class="bignumber">c</span>Use <strong>&lt;p class="blocknumber blocknumber-3"&gt;&lt;span class="bignumber"&gt;c&lt;/span&gt;Your content goes here!&lt;/p&gt;</strong></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n \r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Icons Style</span></h1>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-icon icon-error"><span class="icon"> </span>Use <strong>&lt;p class="error"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-message"><span class="icon"> </span>Use <strong>&lt;p class="message"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-tips"><span class="icon"> </span>Use <strong>&lt;p class="tips"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-key"><span class="icon"> </span>Use <strong>&lt;p class="key"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-tag"><span class="icon"> </span>Use <strong>&lt;p class="tag"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes here!&lt;/p&gt;</strong> to make this.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-icon icon-cart"><span class="icon"> </span>Use <strong>&lt;p class="cart"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes 						here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-doc"><span class="icon"> </span>Use <strong>&lt;p class="doc"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes 						here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-note"><span class="icon"> </span>Use <strong>&lt;p class="note"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes 						here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-photo"><span class="icon"> </span>Use <strong>&lt;p class="photo"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes 						here!&lt;/p&gt;</strong> to make this.</p>\r\n<p class="ja-typo-icon icon-mobi"><span class="icon"> </span>Use <strong>&lt;p class="mobi"&gt;&lt;span 						class="icon"&gt; &lt;/span&gt;Your message goes 						here!&lt;/p&gt;</strong> to make this.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n \r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Bubbles</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Grey Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-1">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-2">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Blue Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-3">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-4">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Black Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-5">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-6">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Grey Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-1">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-2">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Blue Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-3">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-4">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Black Bubbles</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-bubble bubble-rounded bubble-5">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n<div class="ja-typo-bubble bubble-rounded bubble-6">\r\n<div class="ja-typo-bubblect">Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien.</div>\r\n<p class="ja-typo-bubble-meta"><span class="ja-typo-bubble-arrow"> </span> <span class="ja-typo-bubble-author">Author Name</span></p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n \r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Message Boxes &amp; Legend Styles</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes with Icons</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-sticky">This is a sticky. Use <strong>&lt;p class="box-sticky"&gt;Your clip note 						goes here!&lt;/p&gt;</strong> to create a clip note!</p>\r\n<p class="ja-typo-box box-download">This is a download box. Use <strong>&lt;p class="box-download"&gt;Your 						download goes here!&lt;/p&gt;</strong> to create a download box!</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes - Style 1</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-grey-1">This is a grey box. Use <strong>&lt;p class="box-grey"&gt;Your content 						goes here!&lt;/p&gt;</strong> to create a grey box!</p>\r\n<p class="ja-typo-box box-hilite-1">This is a hilite box. Use <strong>&lt;p class="box-hilite"&gt;Your 						content goes here!&lt;/p&gt;</strong> to create a hilite box!</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Message Boxes - Style 2</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-grey-2">This is a grey box. Use <strong>&lt;p class="box-grey"&gt;Your content 						goes here!&lt;/p&gt;</strong> to create a grey box!</p>\r\n<p class="ja-typo-box box-hilite-2">This is a hilite box. Use <strong>&lt;p class="box-hilite"&gt;Your 						content goes here!&lt;/p&gt;</strong> to create a hilite box!</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes with Icons</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-sticky">This is a sticky. Use <strong>&lt;p class="box-sticky"&gt;Your clip note 						goes here!&lt;/p&gt;</strong> to create a clip note!</p>\r\n<p class="ja-typo-box box-rounded box-download">This is a download box. Use <strong>&lt;p class="box-download"&gt;Your 						download goes here!&lt;/p&gt;</strong> to create a download box!</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes - Style 1</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-grey-1">This is a grey box. Use <strong>&lt;p class="box-grey"&gt;Your content 						goes here!&lt;/p&gt;</strong> to create a grey box!</p>\r\n<p class="ja-typo-box box-rounded box-hilite-1">This is a hilite box. Use <strong>&lt;p class="box-hilite"&gt;Your 						content goes here!&lt;/p&gt;</strong> to create a hilite box!</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Message Boxes - Style 2</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p class="ja-typo-box box-rounded box-grey-2">This is a grey box. Use <strong>&lt;p class="box-grey"&gt;Your content 						goes here!&lt;/p&gt;</strong> to create a grey box!</p>\r\n<p class="ja-typo-box box-rounded box-hilite-2">This is a hilite box. Use <strong>&lt;p class="box-hilite"&gt;Your 						content goes here!&lt;/p&gt;</strong> to create a hilite box!</p>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<h2 class="ja-typo-title"><span>Legends</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-1">\r\n<h3 class="legend-title">Legend - Style 1</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-2">\r\n<h3 class="legend-title">Legend - Style 2</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<h2 class="ja-typo-title"><span>Rounded Legends</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-rounded legend-1">\r\n<h3 class="legend-title">Rounded Legend - Style 1</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="ja-typo-legend legend-rounded legend-2">\r\n<h3 class="legend-title">Rounded Legend - Style 2</h3>\r\nLorem ipsum dolor sit amet consectetuer at elit augue In lorem. Quis Donec libero at Vivamus mi fringilla neque commodo at vitae.</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n \r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Buttons &amp; Tags</span></h1>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Big Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-blue ja-typo-btn-big btn-big-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-green ja-typo-btn-big btn-big-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-red ja-typo-btn-big btn-big-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-orange ja-typo-btn-big btn-big-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-black ja-typo-btn-big btn-big-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-grey ja-typo-btn-big btn-big-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Icon Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn ja-typo-btn-icn btn-icn-save" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-tip" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-warning" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-info" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn ja-typo-btn-icn btn-icn-ok" href="#"><span><span>Button Text</span></span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Small Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-blue ja-typo-btn-sm btn-sm-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-green ja-typo-btn-sm btn-sm-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-red ja-typo-btn-sm btn-sm-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-orange ja-typo-btn-sm btn-sm-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-black ja-typo-btn-sm btn-sm-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-grey ja-typo-btn-sm btn-sm-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Big Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-big btn-blue ja-typo-btn-big btn-big-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-green ja-typo-btn-big btn-big-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-red ja-typo-btn-big btn-big-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-orange ja-typo-btn-big btn-big-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-black ja-typo-btn-big btn-big-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-big btn-grey ja-typo-btn-big btn-big-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Icon Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-save" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-tip" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-warning" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-info" href="#"><span><span>Button Text</span></span></a> <a class="ja-typo-btn btn-rounded-icn ja-typo-btn-icn btn-icn-ok" href="#"><span><span>Button Text</span></span></a></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Small Buttons</span></h2>\r\n<div class="ja-typo-blockct clearfix"><a class="ja-typo-btn btn-rounded-sm btn-blue ja-typo-btn-sm btn-sm-blue" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-green ja-typo-btn-sm btn-sm-green" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-red ja-typo-btn-sm btn-sm-red" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-orange ja-typo-btn-sm btn-sm-orange" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-black ja-typo-btn-sm btn-sm-black" href="#"><span>Button Text</span></a> <a class="ja-typo-btn btn-rounded-sm btn-grey ja-typo-btn-sm btn-sm-grey" href="#"><span>Button Text</span></a></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-2 clearfix">\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Squared Tags</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>This is a sample <span class="ja-typo-tag tag-grey">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-blue">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-green">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-red">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-orange">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-black">Inline Tag</span>. Use this to provide useful information.</p>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<h2 class="ja-typo-title"><span>Rounded Tags</span></h2>\r\n<div class="ja-typo-blockct clearfix">\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-grey">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-blue">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-green">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-red">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-orange">Inline Tag</span>. Use this to provide useful information.</p>\r\n<p>This is a sample <span class="ja-typo-tag tag-rounded tag-black">Inline Tag</span>. Use this to provide useful information.</p>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n \r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Special Module Style</span></h1>\r\n<div class="ja-typo-blockrow cols-4 clearfix">\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-top"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-top</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-new"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-new</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-pick"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-pick</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix">\r\n<div class="moduletable moduletable_badge badge-hot" style="margin-right: 0;"><span class="badge"> </span>\r\n<div class="ja-box-ct">Use module suffix: <strong>_badge badge-hot</strong> to put this badge on any module you like!</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n</div>\r\n \r\n<div class="ja-typo-blockswrap clearfix">\r\n<h1 class="ja-typo-title"><span>Forms</span></h1>\r\n<div class="ja-typo-blockrow cols-3 clearfix">\r\n<h2 class="ja-typo-title"><span>Form Fieldset</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset> <legend>Templates Fieldset</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est, eu vulputate sapien suscipit ac. </fieldset></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset class="ja-typo-fieldset fieldset-1"> <legend>Special Fieldset - Style 1</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est. </fieldset></div>\r\n</div>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><fieldset class="ja-typo-fieldset fieldset-2"> <legend>Special Fieldset - Style 2</legend> Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla dapibus sapien vel mauris viverra quis euismod dui tincidunt. Phasellus laoreet mattis est. </fieldset></div>\r\n</div>\r\n</div>\r\n<div class="ja-typo-blockrow cols-1 clearfix">\r\n<h2 class="ja-typo-title"><span>Form Elements</span></h2>\r\n<div class="ja-typo-block">\r\n<div class="ja-typo-blockct clearfix"><form>\r\n<p><label for="input">Sample Input 1</label> <br /> <input class="inputbox" name="input" type="input" /></p>\r\n<p><label for="input">Sample Input 2</label> <br /> <input class="inputbox" name="input" type="input" /></p>\r\n<p><input type="radio" /><label for="radio">Sample Radio Input</label> <input type="checkbox" /><label for="checkbox">Sample CheckBox Input</label></p>\r\n<p><label for="select">Sample Select Field:</label><br /> <select id="select"><option>Option One</option><option>Option Two</option></select></p>\r\n<p><label for="textarea">Sample Textarea Field:</label><br /> <textarea class="inputbox" cols="80" rows="5">Textarea text</textarea></p>\r\n<p><button>Submit Button</button> <button>Reset Button</button></p>\r\n</form></div>\r\n</div>\r\n</div>\r\n</div>\r\n </div>', '', 1, 23, '2010-07-10 22:22:26', 42, 'Joomla!', '2011-01-28 10:48:33', 42, 42, '2011-01-28 10:57:22', '2010-07-10 22:22:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"0","show_print_icon":"0","show_email_icon":"0","show_vote":"0","show_hits":"0","show_noauth":"0","alternative_readmore":"","article_layout":""}', 4, 1, '', '', 1, 71, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(50, 148, 'Upgraders', 'upgraders', '<p>If you are an experienced Joomla! 1.5 user, 1.6 will seem very familiar. There are new templates and improved user interfaces, but most functionality is the same. The biggest changes are improved access control (ACL) and nested categories.</p>', '<p>The new user manager which will let you manage who has access to what in your site. You can leave access groups exactly the way you had them in Joomla 1.5 or make them as complicated as you want. You can learn more about<a href="http://docs.joomla.org/ACL_Tutorial_for_Joomla_1.6"> how access control works</a> in on the <a href="http://docs.joomla.org">Joomla! Documentation sit</a></p><p>In Joomla 1.5 and 1.0 content was organized into sections and categories. In 1.6 sections are gone, and you can create categories within categories, going as deep as you want. The sample data provides many examples of the use of nested categories.</p><p>All layouts have been redesigned to improve accessibility and flexibility. If you would like to keep the 1.5 layouts, you can find them in the html folder of the MilkyWay template. Simply copy the layouts you want to the html folder of your template.</p><p>Updating your site and extensions when needed is easier than ever thanks to installer improvements.</p><p>To learn more about how to<a href="http://docs.joomla.org/Migrating_from_1.5_to_1.6"> move a Joomla! 1.5 site to a Joomla! 1.6 installation read this article</a>.</p>', 1, 19, '2010-07-10 22:38:22', 42, '', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 22:38:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 5, '', '', 1, 1, '', 1, '*', ''),
(51, 149, 'User', 'user-plugins', '<p>Default on:</p><ul><li>Joomla Help</li></ul><p>Default off:</p><p>Two new plugins are available in 1.6 but are disabled by default.</p><ul><li>Contact Creator Help<br />Creates a new linked contact record for each new user created. </li><li>Profile Help<br />This example profile plugin allows you to insert additional fields into user registration and profile display. This is intended as an example of the types of extensions to the profile you might want to create. </li></ul>', '', 1, 25, '2010-07-10 22:43:34', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:16:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 4, '', '', 1, 2, '', 0, '*', ''),
(52, 150, 'Users', 'users-component', '<p>The users extension lets your site visitors register, login and logout, change their passwords and other information, and recover lost passwords. In the administrator it allows you to create, block and manage users and create user groups and access levels. Help</p>\r\n<p>Please note that some of the user views will not display if you are not logged in to the site.</p>', '', 1, 21, '2010-07-10 22:46:05', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:13:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 4, 5, '', '', 1, 3, '', 0, '*', ''),
(53, 151, 'Using Joomla!', 'using-joomla', '<p>With Joomla! You can create anything from a simple personal website to a complex ecommerce or social site with millions of visitors.</p><p>This section of the sample data provides you with a brief introduction to Joomla! concepts and reference material to help you understand how Joomla! works.</p><p><em>When you not longer need the sample data, you can can simply unpublish the sample data category found within each extension in the site administrator or you may completely delete each item and all of the categories. </em></p>', '', 1, 19, '2010-07-10 23:00:59', 42, 'Joomla!', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:00:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 7, '', '', 1, 25, '', 0, '*', ''),
(54, 152, 'Weblinks', 'weblinks', '<p>Weblinks (com_weblinks) is a component that provides a structured way to organize external links and present them in a visually attractive, consistent and informative way. Help</p>', '', 1, 21, '2010-07-10 23:02:42', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:02:42', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 6, '', '', 1, 10, '', 0, '*', ''),
(55, 153, 'Weblinks Module', 'weblinks-module', '<p>This module displays the list of weblinks in a category.  <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Weblinks" title="Weblinks Module">Help</a></p><p>{loadposition weblinksload}</p>', '', 1, 66, '2010-07-10 23:04:41', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:04:41', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 5, '', '', 1, 3, '', 0, '*', ''),
(56, 154, 'Who\'s Online', 'whos-online', '<p>The Who\'s Online Module displays the number of Anonymous Users (e.g. Guests) and Registered Users (ones logged in) that are currently accessing the Web site. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Who.27s_Online" title="Who\'s Online">Help</a></p><p>{loadposition whosonlineload}</p>', '', 1, 65, '2010-07-10 23:06:16', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:06:16', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 1, '', '', 1, 4, '', 0, '*', ''),
(57, 155, 'Wobbegone', 'wobbegone', '<p><img src="images/sampledata/parks/animals/180px_wobbegong.jpg" border="0" alt="Wobbegone" style="vertical-align: middle; border: 0;" /></p>', '<p><img src="images/sampledata/parks/animals/800px_wobbegong.jpg" border="0" style="vertical-align: middle; border: 0;" /></p><p>Source: http://en.wikipedia.org/wiki/File:Wobbegong.jpg</p><p>Author: Richard Ling</p><p>Rights: GNU Free Documentation License v 1.2 or later</p>', 1, 72, '2010-07-10 23:07:30', 42, 'Parks Webmaster', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-10 23:07:29', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 1, '', '', 1, 0, '', 0, '*', ''),
(58, 156, 'Wonderful Watermelon', 'wonderful-watermelon', '<p>Watermelon is a wonderful and healthy treat. We grow the world\'s sweetest watermelon. We have the largest watermelon patch in our country.</p>', '', 1, 30, '2010-07-10 23:09:14', 42, 'Fruit Shop Webmaster', '2010-08-23 03:02:28', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 1, '', '', 1, 0, '', 0, '*', ''),
(59, 157, 'Wrapper Module', 'wrapper-module', '<p>This module shows an iFrame window to specified location. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Wrapper" title="Wrapper Module">Help</a></p><p>{loadposition wrapperload}</p>', '', 1, 67, '2010-07-10 23:10:10', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 1, '', '', 1, 1, '', 0, '*', ''),
(60, 158, 'News Feeds', 'news-feeds', '<p>News Feeds (com_newsfeeds) provides a way to organize and present news feeds. News feeds are a way that you present information from another site on your site. For example, the joomla.org website has numerous feeds that you an incorporate on your site. You an use menus to present a single feed, a list of feeds in a category, or or a list of all feed categories. Help</p>', '', 1, 21, '2010-07-11 00:28:23', 42, 'Joomla!', '2010-08-23 03:00:39', 42, 0, '0000-00-00 00:00:00', '2010-07-11 00:28:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 4, '', '', 1, 3, '', 0, '*', ''),
(61, 159, 'Breadcrumbs Module', 'breadcrumbs-module', '<p>Breadcrumbs provide a pathway for users to navigate through the site. <a href="http://docs.joomla.org/Help15:Screen.modulessite.edit.15#Breadcrumbs" title="Breacrumbs Module">Help</a></p>\r\n<p>{loadposition breadcrumbsload}</p>', '', 1, 75, '2010-07-11 01:30:25', 42, 'Joomla!', '2010-11-15 09:15:41', 42, 0, '0000-00-00 00:00:00', '2010-07-11 01:30:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(62, 160, 'Content', 'content-plugins', '<p>Content plugins run when specific kinds of pages are loaded. They do things ranging from protecting email addresses from harvesters to creating page breaks.</p><p>Default on:</p><ul><li>Email Cloaking Help</li><li>Load Module Help</li><li>Page Break Help</li><li>Page Navigation Help</li><li>Rating Help</li></ul><p>Default off:</p><ul><li>Code Highlighting (Geshi) Help</li></ul>', '', 1, 25, '2010-07-11 06:19:31', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 06:19:31', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 7, '', '', 1, 3, '', 0, '*', ''),
(64, 162, 'Blue Mountain Rain Forest', 'blue-mountain-rain-forest', '<p><img src="images/sampledata/parks/landscape/120px_rainforest_bluemountainsnsw.jpg" border="0" alt="Rain Forest Blue Mountrains" /></p>', '<p><img src="images/sampledata/parks/landscape/727px_rainforest_bluemountainsnsw.jpg" border="0" alt="Rain Forest Blue Mountrains" style="vertical-align: middle;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Rainforest,bluemountainsNSW.jpg</p><p class="caption">Author: Adam J.W.C.</p><p class="caption">License: GNU Free Documentation License</p>', 1, 73, '2010-07-11 07:19:35', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 2, 2, '', '', 1, 0, '', 0, '*', ''),
(65, 163, 'Ormiston Pound', 'ormiston-pound', '<p><img src="images/sampledata/parks/landscape/180px_ormiston_pound.jpg" border="0" alt="Ormiston Pound" style="border: 0;" /></p>', '<p><img src="images/sampledata/parks/landscape/800px_ormiston_pound.jpg" border="0" alt="Ormiston Pound" height="375" style="vertical-align: middle; border: 0;" /></p><p> </p><p class="caption">Source: http://commons.wikimedia.org/wiki/File:Ormiston_Pound.JPG</p><p class="caption">Author:</p><p class="caption">License: GNU Free Public Documentation License</p>', 1, 73, '2010-07-11 07:21:18', 42, 'Parks Webmaster', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 07:21:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 3, '', '', 1, 0, '', 0, '*', ''),
(66, 165, 'Latest Users Module', 'latest-users-module', '<p>This module displays the latest registered users. Help</p>\r\n<p>{loadposition userslatestload}</p>', '', 1, 65, '2010-07-11 13:54:30', 42, 'Joomla!', '2010-08-23 02:58:49', 42, 0, '0000-00-00 00:00:00', '2010-07-11 13:55:19', '0000-00-00 00:00:00', '', '', '{"show_title":"1","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 3, 3, '', '', 1, 4, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(67, 168, 'What\'s New in 1.5?', 'whats-new-in-15', '<p>As with previous releases, Joomla! provides a unified and easy-to-use framework for delivering content for Web sites of all kinds. To support the changing nature of the Internet and emerging Web technologies, Joomla! required substantial restructuring of its core functionality and we also used this effort to simplify many challenges within the current user interface. Joomla! 1.5 has many new features.</p>\r\n<p style="margin-bottom: 0in;">In Joomla! 1.5, you\'\'ll notice:</p>\r\n<ul>\r\n<li>Substantially improved usability, manageability, and scalability far beyond the original Mambo foundations</li>\r\n<li>Expanded accessibility to support internationalisation, double-byte characters and right-to-left support for Arabic, Farsi, and Hebrew languages among others</li>\r\n<li>Extended integration of external applications through Web services</li>\r\n<li>Enhanced content delivery, template and presentation capabilities to support accessibility standards and content delivery to any destination</li>\r\n<li>A more sustainable and flexible framework for Component and Extension developers</li>\r\n<li>Backward compatibility with previous releases of Components, Templates, Modules, and other Extensions</li>\r\n</ul>', '', 2, 9, '2010-08-23 00:35:57', 42, 'Joomla! 1.5', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_readmore":"","show_print_icon":"","show_email_icon":"","show_hits":"","page_title":"","alternative_readmore":"","layout":""}', 1, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(68, 171, 'Welcome to Joomla!', '1037869876', '<div align="left"><strong>Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. <br /></strong></div><p><strong><br /></strong><img src="images/stories/powered_by.png" border="0" alt="Joomla! Logo" title="Example Caption" hspace="6" vspace="0" width="165" height="68" align="left" />Joomla! provides an easy-to-use graphical user interface that simplifies the management and publishing of large volumes of content including HTML, documents, and rich media.  Joomla! is used by organisations of all sizes for Public Web sites, Intranets, and Extranets and is supported by a community of thousands of users. </p>', 'With a fully documented library of developer resources, Joomla! allows the customisation of every aspect of a Web site including presentation, layout, administration, and the rapid integration with third-party applications.<p>Joomla! has a rich heritage and has been crowned CMS king many times over.  Now with more power under the hood, Joomla! is shifting gear and provides developer power while making the user experience all the more friendly.  For those who always wanted increased extensibility, Joomla! 1.5 can make this happen.</p><p>A new framework, ground-up refactoring, and a highly-active development team brings the excitement of \'the next generation CMS\' to your fingertips.  Whether you are a systems architect or a complete \'noob\' Joomla! can take you to the next level of content delivery. \'More than a CMS\' is something we have been playing with as a catchcry because the new Joomla! API has such incredible power and flexibility, you are free to take whatever direction your creative mind takes you and Joomla! can help you get there so much more easily than ever before.</p><p>Thinking Web publishing? Think Joomla!</p>', 1, 78, '2006-10-12 10:00:00', 42, '', '2007-11-08 12:06:35', 62, 0, '0000-00-00 00:00:00', '2006-01-03 01:00:00', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 102, '', 0, '*', ''),
(69, 172, 'We are Volunteers', '544595941', '<p>The Joomla! Core Team consists of volunteer developers, designers, administrators and managers who, together with a large range of Work Groups of dedicated community members have taken Joomla! to new heights in its relatively short life. This well-oiled machine is often copied but never surpassed.  Joomla! has some wonderfully talented people taking Open Source concepts to the forefront of industry standards.  Joomla! 1.5 is a major leap forward and represents the most exciting Joomla! release in the history of the project. </p>', '<p>The project has a nice balance of legacy development from well-known coders such as Andrew Eddie (who pioneered Mambo\'s early success) to some young guns like Johan Janssens and Louis Landry.  This dynamic trio has been further strengthening the project by bringing in new talent.  In open source development people joke about the \'bus\' factor.  Projects which don\'t have coding \'spread\' are considered less sound should their single lead developer get hit by a bus.</p>', 1, 78, '2004-07-07 09:54:06', 42, '', '2007-11-08 12:10:35', 62, 0, '0000-00-00 00:00:00', '2004-07-06 22:00:00', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 56, '', 0, '*', ''),
(70, 173, 'Stick to the Code!', '1697974502', 'To ensure this code release, Wilco Jansen resorted to sending rum to joint lead-developer Johan Janssens.  Johan, who\'s had a penchant for rum ever since the first "Pirate\'s of the Caribbean" movie screened, took the bait, mixed it with Cola, and here we are with our latest 1.5 release.  It looks like pirate talk will figure quite a lot in future Joomla! development! ', '<strong><br />Translation for you real pirates:<br /></strong> <br />First Mate Wilco resorted t\' sendin\' rum t\' joint Capt\'n Johan. Johan, who\'s had a penchant for rum ever since t\' first "Pirate\'s o\' t\' Caribbean" movie screened, took t\' bait, mixed it with molasses, and here we be with our latest 1.5 release. It looks like pirate talk will figure quite a lot in future Joomla! development!', 1, 78, '2004-07-07 12:00:00', 42, '', '2007-11-25 22:37:55', 62, 0, '0000-00-00 00:00:00', '2004-07-07 11:00:00', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 70, '', 0, '*', ''),
(71, 174, 'The Legend of Buca di Beppo', '448609937', '<p>The legend of Buca di Beppo involves a covert meeting of key developers in a Mafia-style restaurant in the United States.  \'Bucas\' has on more than one occasion been the catalyst for key (and in some cases considered insurmountable) development \'humps\' being overcome.</p><p>With copius amounts of food and wine flowing, the creative juices of coders seem to work keener, faster, and problems are solved. Louis Landry famously agreed that living near a Bucas could actually lead to faster development cycles.</p><p>Mmmm. A restaurant with photos of famous Mafia films like <em>The Godfather</em> and violin cases leaning against the booths.  Makes you wonder, doesn\'t it?  </p><p>If Joomla! was a commercial venture, we\'re sure management would actually consider building a Bucas inside the building!</p><p>Masterchief meet Bugsy Landry. </p>', '', 1, 78, '2004-04-12 09:54:06', 42, '', '2007-11-08 12:14:09', 62, 0, '0000-00-00 00:00:00', '2004-07-06 22:00:00', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 13, '', 0, '*', ''),
(72, 175, '1 Million Smiles', '1-million-smiles', '<p>The Joomla! team has about 1 million good reasons to be smiling about the Joomla! 1.5. In its current incarnation, it\'s had more than 1 million downloads, taking it to an unprecedented level of popularity.  The new code base is almost an entire re-factor of the old code base.  The user experience is still extremely slick but for developers the API is a dream.  A proper framework for real PHP architects seeking the best of the best.</p><p>If you\'re a former Mambo User or a 1.0 series Joomla! User, 1.5 is the future of CMSs for a number of reasons.  It\'s more powerful, more flexible, more secure, and intuitive.  Our developers and interface designers have worked countless hours to make this the most exciting release in the content management system sphere.</p><p>Go on ... get your FREE copy of Joomla! today and spread the word about this benchmark project. </p>', '', 1, 78, '2004-07-07 09:54:06', 42, '', '2011-01-28 11:27:23', 42, 0, '0000-00-00 00:00:00', '2004-07-06 22:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 23, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(73, 177, 'Newsflash 1', '449000771', '<p>Joomla! makes it easy to launch a Web site of any kind. Whether you want a brochure site or you are building a large online community, Joomla! allows you to deploy a new site in minutes and add extra functionality as you need it. The hundreds of available Extensions will help to expand your site and allow you to deliver new services that extend your reach into the Internet.</p>', '', 1, 79, '2004-08-10 06:30:34', 42, '', '2007-11-08 12:19:35', 62, 0, '0000-00-00 00:00:00', '2004-08-09 10:00:00', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 1, '', 0, '*', ''),
(74, 178, 'Newsflash 2', '398296458', '<p>The one thing about a Web site, it always changes! Joomla! makes it easy to add Articles, content, images, videos, and more. Site administrators can edit and manage content \'in-context\' by clicking the \'Edit\' link. Webmasters can also edit content through a graphical Control Panel that gives you complete control over your site.</p>', '', 1, 79, '2004-08-09 22:30:34', 42, '', '2007-11-08 12:20:41', 62, 0, '0000-00-00 00:00:00', '2004-08-09 06:00:00', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 1, '', 0, '*', ''),
(75, 179, 'Newsflash 3', '554598292', '<p>With a library of hundreds of free <a href="http://extensions.joomla.org" title="The Joomla! Extensions Directory">Extensions</a>, you can add what you need as your site grows. Don\'t wait, look through the <a href="http://extensions.joomla.org/" target="_blank">Joomla! Extensions</a>  library today. </p>', '', 1, 79, '2004-08-10 06:30:34', 42, '', '2007-11-08 12:21:51', 62, 0, '0000-00-00 00:00:00', '2004-08-09 10:00:00', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 1, '', 0, '*', ''),
(76, 180, 'Newsflash 5', '2083032974', 'Joomla! 1.5 - \'Experience the Freedom\'!. It has never been easier to create your own dynamic Web site. Manage all your content from the best CMS admin interface and in virtually any language you speak.', '', 1, 79, '2006-10-12 00:17:31', 42, '', '2007-11-08 12:17:53', 62, 0, '0000-00-00 00:00:00', '2006-10-11 06:00:00', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 5, '', 0, '*', ''),
(77, 181, 'Newsflash 4', '1137619881', 'Yesterday all servers in the U.S. went out on strike in a bid to get more RAM and better CPUs. A spokes person said that the need for better RAM was due to some fool increasing the front-side bus speed. In future, buses will be told to slow down in residential motherboards.', '', 1, 79, '2006-10-12 00:25:50', 42, '', '2007-11-08 12:17:20', 62, 0, '0000-00-00 00:00:00', '2006-10-11 06:00:00', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 5, '', 0, '*', ''),
(78, 183, 'Pretium tempor', '37218582', '<img src="images/stories/demo/hot_news/hn-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Eget hendrerit vel Integer dictum sapien Nunc congue tempor Sed lacinia. Ut pellentesque volutpat auctor at eleifend id quis Curabitur Sed et. Tincidunt convallis tempus nonummy porta leo tellus orci tincidunt Vestibulum vitae. Dui congue accumsan et mauris orci nibh a sagittis velit volutpat. Nisl Quisque nunc sit tellus mauris Aenean sapien pretium ligula Sed. Nulla laoreet est Suspendisse fringilla augue habitant.</p>\r\n\r\n', '\r\n\r\n<p>Lorem laoreet ligula Ut Cras ut tortor natoque leo ligula faucibus. At urna Pellentesque mauris orci ac mauris felis consectetuer pharetra ligula. Felis ipsum tempus libero Aliquam dolor Mauris magna est Praesent nibh. Ut id sollicitudin id dui malesuada vitae hac Nulla Quisque vel. Proin platea vel elit consectetuer sodales sit Lorem nascetur justo.</p>\r\n\r\n<p>Wisi tincidunt laoreet libero fringilla sodales In nunc Curabitur laoreet Morbi. Tristique dui dolor massa quis id ipsum nibh malesuada pretium tristique. Mauris turpis justo ut lacus elit felis Aenean ante Curabitur interdum. Dolor vitae lorem pharetra Vivamus vitae pede velit egestas egestas id. Quis id enim vel Aenean Cras Cum nonummy Maecenas et ante. Quisque eget rutrum vestibulum urna dapibus leo.</p>\r\n\r\n<p>Condimentum Vestibulum Nullam tellus tempus feugiat nunc Aliquam Curabitur vestibulum et. Turpis Sed Nunc Suspendisse magna mauris In est mus ornare tristique. Risus pede quis diam tincidunt Fusce congue ante et id sodales. Morbi dui consequat ligula massa et elit ut ut sit ut. Justo in hac cursus risus morbi ultrices nascetur vel montes Aliquam. Sem Aenean Nulla dolor amet ante pellentesque aliquam at pretium tempus. Curabitur felis tortor.</p>\r\n\r\n<p>Nam Sed metus Nulla fringilla vitae vitae interdum sagittis wisi convallis. Amet adipiscing Pellentesque quis nibh augue Praesent et Duis senectus Pellentesque. Iaculis Cum nonummy odio lobortis justo enim justo nibh mi sed. Consequat dolor ante augue Nam sollicitudin Nullam nulla pretium sem urna. Tincidunt Vestibulum at nibh amet sem Ut metus et et amet. Vestibulum odio tincidunt nisl mi orci vel Sed hendrerit pharetra.</p>\r\n\r\n<p>Pellentesque Donec netus massa ut vel est mauris et Curabitur condimentum. Enim at cursus orci laoreet Aenean id hendrerit et pellentesque cursus. Ipsum ut elit Vivamus mollis feugiat eget turpis wisi nulla sed. Nunc eget est ut lacinia orci lorem aliquet quam porta id. Justo lorem convallis penatibus vitae tortor eu.</p>', 1, 80, '2008-04-15 07:03:46', 42, '', '2008-04-15 09:43:46', 64, 0, '0000-00-00 00:00:00', '2008-04-15 07:03:46', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 7, '', 0, '*', ''),
(79, 184, 'In Sed cursus orci', 'in-sed-cursus-orci', '<p>In Sed cursus orci urna lacinia malesuada Duis wisi et cursus. Et pede nec ut sem vel et Morbi sapien Curabitur dui. Sed vitae dui ullamcorper pretium risus urna consectetuer sociis dolor Nulla. A leo rutrum at Vestibulum nec facilisi sapien id vitae a. Suspendisse turpis purus dapibus congue pede Suspendisse adipiscing convallis et wisi. Mauris In Vivamus sed interdum elit mus.</p>\r\n', '\r\n<p>Habitasse sagittis In lacus dui tempus hendrerit Integer sed eros Vivamus. Nibh Nam Vestibulum dictumst vestibulum pharetra dui fringilla id pretium justo. Convallis laoreet eleifend Pellentesque penatibus cursus habitasse adipiscing dictum eu ligula. Nunc et parturient justo Morbi id Aenean sit adipiscing eros est. Tellus justo Sed justo sociis massa elit ipsum habitant dis amet. Ut velit elit mus at.</p>\r\n<p>In Sed cursus orci urna lacinia malesuada Duis wisi et cursus. Et pede nec ut sem vel et Morbi sapien Curabitur dui. Sed vitae dui ullamcorper pretium risus urna consectetuer sociis dolor Nulla. A leo rutrum at Vestibulum nec facilisi sapien id vitae a. Suspendisse turpis purus dapibus congue pede Suspendisse adipiscing convallis et wisi. Mauris In Vivamus sed interdum elit mus.</p>\r\n<p>Pellentesque congue condimentum nec vitae id leo dolor Phasellus leo urna. Faucibus magnis Donec orci sit adipiscing a fames Suspendisse montes vel. Et penatibus nulla rhoncus platea nibh volutpat dolor feugiat Nam Vivamus. Donec justo sed iaculis lobortis Curabitur sed gravida Quisque nibh hendrerit. Scelerisque quis lobortis pretium nec tincidunt Sed Sed iaculis nulla interdum. Pretium nunc congue id mauris Phasellus adipiscing sem id Nulla ac.</p>\r\n<p>Pretium eu sociis egestas libero wisi congue semper sollicitudin wisi interdum. Sit Nulla In convallis ac sed congue Morbi ut convallis ac. Semper dui eleifend congue lorem Curabitur eget nascetur nascetur hendrerit Praesent. Nunc ante purus Sed enim id nunc malesuada convallis interdum elit. Congue nunc nisl Vestibulum sagittis id libero ullamcorper congue auctor interdum. Augue venenatis pede convallis hac molestie Phasellus.</p>\r\n<p>Ac Aliquam et dictum id est tempor iaculis pretium et Sed. Nibh dis nascetur elit neque tellus Nulla sed urna semper In. Ante mus et tincidunt nibh enim morbi at nibh scelerisque elit. Sed Lorem nibh tellus et ut enim Vestibulum lacus turpis non. Suspendisse nunc dictumst Curabitur faucibus nisl porttitor felis.</p>', 1, 80, '2008-04-15 07:27:47', 42, '', '2011-09-01 07:32:59', 42, 0, '0000-00-00 00:00:00', '2008-04-15 07:27:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(80, 185, 'Aliquam et dictum', 'aliquam-et-dictum', '<p>Pellentesque congue condimentum nec vitae id leo dolor Phasellus leo urna.</p>\r\n\r\n', '\r\n\r\n<p>Faucibus magnis Donec orci sit adipiscing a fames Suspendisse montes vel. Et penatibus nulla rhoncus platea nibh volutpat dolor feugiat Nam Vivamus. Donec justo sed iaculis lobortis Curabitur sed gravida Quisque nibh hendrerit. Scelerisque quis lobortis pretium nec tincidunt Sed Sed iaculis nulla interdum. Pretium nunc congue id mauris Phasellus adipiscing sem id Nulla ac. </p>\r\n\r\n<p>Pretium eu sociis egestas libero wisi congue semper sollicitudin wisi interdum. Sit Nulla In convallis ac sed congue Morbi ut convallis ac. Semper dui eleifend congue lorem Curabitur eget nascetur nascetur hendrerit Praesent. Nunc ante purus Sed enim id nunc malesuada convallis interdum elit. Congue nunc nisl Vestibulum sagittis id libero ullamcorper congue auctor interdum. Augue venenatis pede convallis hac molestie Phasellus.</p>\r\n\r\n<p>Ac Aliquam et dictum id est tempor iaculis pretium et Sed. Nibh dis nascetur elit neque tellus Nulla sed urna semper In. Ante mus et tincidunt nibh enim morbi at nibh scelerisque elit. Sed Lorem nibh tellus et ut enim Vestibulum lacus turpis non. Suspendisse nunc dictumst Curabitur faucibus nisl porttitor felis.</p>\r\n\r\n<p>Suspendisse ante porttitor dolor dapibus et ante justo nec tempus Vestibulum. Quisque elit nisl metus Nam id a vitae convallis sit Sed. Lacus Nam habitant et orci ante consequat et enim vitae elit. Suscipit sem mauris convallis eleifend et nibh ac in Nam sem. Fringilla malesuada adipiscing tellus leo non Vestibulum laoreet tincidunt at magnis. Urna sed Vestibulum odio Curabitur Nulla fringilla Vestibulum.</p>\r\n\r\n<p>Eget hendrerit vel Integer dictum sapien Nunc congue tempor Sed lacinia. Ut pellentesque volutpat auctor at eleifend id quis Curabitur Sed et. Tincidunt convallis tempus nonummy porta leo tellus orci tincidunt Vestibulum vitae. Dui congue accumsan et mauris orci nibh a sagittis velit volutpat. Nisl Quisque nunc sit tellus mauris Aenean sapien pretium ligula Sed. Nulla laoreet est Suspendisse fringilla augue habitant.</p>\r\n\r\n<p>Lorem laoreet ligula Ut Cras ut tortor natoque leo ligula faucibus. At urna Pellentesque mauris orci ac mauris felis consectetuer pharetra ligula. Felis ipsum tempus libero Aliquam dolor Mauris magna est Praesent nibh. Ut id sollicitudin id dui malesuada vitae hac Nulla Quisque vel. Proin platea vel elit consectetuer sodales sit Lorem nascetur justo.</p>', 1, 80, '2008-04-15 07:31:33', 42, '', '2011-01-28 11:32:20', 42, 0, '0000-00-00 00:00:00', '2008-04-15 07:31:33', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(81, 186, 'Wisi tincidunt', '946167299', '<p>Suspendisse ante porttitor dolor dapibus et ante justo nec tempus Vestibulum. Quisque elit nisl metus Nam id a vitae convallis sit Sed. Lacus Nam habitant et orci ante consequat et enim vitae elit. Suscipit sem mauris convallis eleifend et nibh ac in Nam sem. Fringilla malesuada adipiscing tellus leo non Vestibulum laoreet tincidunt at magnis. Urna sed Vestibulum odio Curabitur Nulla fringilla Vestibulum.</p>\r\n\r\n', '\r\n\r\n<p>Ac Aliquam et dictum id est tempor iaculis pretium et Sed. Nibh dis nascetur elit neque tellus Nulla sed urna semper In. Ante mus et tincidunt nibh enim morbi at nibh scelerisque elit. Sed Lorem nibh tellus et ut enim Vestibulum lacus turpis non. Suspendisse nunc dictumst Curabitur faucibus nisl porttitor felis.</p>\r\n\r\n<p>Suspendisse ante porttitor dolor dapibus et ante justo nec tempus Vestibulum. Quisque elit nisl metus Nam id a vitae convallis sit Sed. Lacus Nam habitant et orci ante consequat et enim vitae elit. Suscipit sem mauris convallis eleifend et nibh ac in Nam sem. Fringilla malesuada adipiscing tellus leo non Vestibulum laoreet tincidunt at magnis. Urna sed Vestibulum odio Curabitur Nulla fringilla Vestibulum.</p>\r\n\r\n<p>Eget hendrerit vel Integer dictum sapien Nunc congue tempor Sed lacinia. Ut pellentesque volutpat auctor at eleifend id quis Curabitur Sed et. Tincidunt convallis tempus nonummy porta leo tellus orci tincidunt Vestibulum vitae. Dui congue accumsan et mauris orci nibh a sagittis velit volutpat. Nisl Quisque nunc sit tellus mauris Aenean sapien pretium ligula Sed. Nulla laoreet est Suspendisse fringilla augue habitant.</p>\r\n\r\n<p>Lorem laoreet ligula Ut Cras ut tortor natoque leo ligula faucibus. At urna Pellentesque mauris orci ac mauris felis consectetuer pharetra ligula. Felis ipsum tempus libero Aliquam dolor Mauris magna est Praesent nibh. Ut id sollicitudin id dui malesuada vitae hac Nulla Quisque vel. Proin platea vel elit consectetuer sodales sit Lorem nascetur justo.</p>\r\n\r\n<p>Wisi tincidunt laoreet libero fringilla sodales In nunc Curabitur laoreet Morbi. Tristique dui dolor massa quis id ipsum nibh malesuada pretium tristique. Mauris turpis justo ut lacus elit felis Aenean ante Curabitur interdum. Dolor vitae lorem pharetra Vivamus vitae pede velit egestas egestas id. Quis id enim vel Aenean Cras Cum nonummy Maecenas et ante. Quisque eget rutrum vestibulum urna dapibus leo.</p>\r\n\r\n<p>Condimentum Vestibulum Nullam tellus tempus feugiat nunc Aliquam Curabitur vestibulum et. Turpis Sed Nunc Suspendisse magna mauris In est mus ornare tristique. Risus pede quis diam tincidunt Fusce congue ante et id sodales. Morbi dui consequat ligula massa et elit ut ut sit ut. Justo in hac cursus risus morbi ultrices nascetur vel montes Aliquam. Sem Aenean Nulla dolor amet ante pellentesque aliquam at pretium tempus. Curabitur felis tortor.</p>', 1, 80, '2008-04-15 07:34:35', 42, '', '2009-08-10 02:39:41', 62, 0, '0000-00-00 00:00:00', '2008-04-15 07:34:35', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 7, '', 0, '*', ''),
(82, 187, '3 Days in Puerto Rico', '3-days-in-puerto-rico', '<p>Eget hendrerit vel Integer dictum sapien Nunc congue tempor Sed lacinia. Ut pellentesque volutpat auctor at eleifend id quis Curabitur Sed et. Tincidunt convallis tempus nonummy porta leo tellus orci tincidunt Vestibulum vitae. Dui congue accumsan et mauris orci nibh a sagittis velit volutpat. Nisl Quisque nunc sit tellus mauris Aenean sapien pretium ligula Sed. Nulla laoreet est Suspendisse fringilla augue habitant.</p>\r\n\r\n', '\r\n\r\n<p>Lorem laoreet ligula Ut Cras ut tortor natoque leo ligula faucibus. At urna Pellentesque mauris orci ac mauris felis consectetuer pharetra ligula. Felis ipsum tempus libero Aliquam dolor Mauris magna est Praesent nibh. Ut id sollicitudin id dui malesuada vitae hac Nulla Quisque vel. Proin platea vel elit consectetuer sodales sit Lorem nascetur justo.</p>\r\n\r\n<p>Wisi tincidunt laoreet libero fringilla sodales In nunc Curabitur laoreet Morbi. Tristique dui dolor massa quis id ipsum nibh malesuada pretium tristique. Mauris turpis justo ut lacus elit felis Aenean ante Curabitur interdum. Dolor vitae lorem pharetra Vivamus vitae pede velit egestas egestas id. Quis id enim vel Aenean Cras Cum nonummy Maecenas et ante. Quisque eget rutrum vestibulum urna dapibus leo.</p>\r\n\r\n<p>Condimentum Vestibulum Nullam tellus tempus feugiat nunc Aliquam Curabitur vestibulum et. Turpis Sed Nunc Suspendisse magna mauris In est mus ornare tristique. Risus pede quis diam tincidunt Fusce congue ante et id sodales. Morbi dui consequat ligula massa et elit ut ut sit ut. Justo in hac cursus risus morbi ultrices nascetur vel montes Aliquam. Sem Aenean Nulla dolor amet ante pellentesque aliquam at pretium tempus. Curabitur felis tortor.</p>\r\n\r\n<p>Nam Sed metus Nulla fringilla vitae vitae interdum sagittis wisi convallis. Amet adipiscing Pellentesque quis nibh augue Praesent et Duis senectus Pellentesque. Iaculis Cum nonummy odio lobortis justo enim justo nibh mi sed. Consequat dolor ante augue Nam sollicitudin Nullam nulla pretium sem urna. Tincidunt Vestibulum at nibh amet sem Ut metus et et amet. Vestibulum odio tincidunt nisl mi orci vel Sed hendrerit pharetra.</p>\r\n\r\n<p>Pellentesque Donec netus massa ut vel est mauris et Curabitur condimentum. Enim at cursus orci laoreet Aenean id hendrerit et pellentesque cursus. Ipsum ut elit Vivamus mollis feugiat eget turpis wisi nulla sed. Nunc eget est ut lacinia orci lorem aliquet quam porta id. Justo lorem convallis penatibus vitae tortor eu.</p>', 1, 80, '2008-04-15 08:03:01', 42, '', '2011-01-28 11:29:55', 42, 0, '0000-00-00 00:00:00', '2008-04-15 08:03:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 28, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(83, 190, 'Is it useful to install the sample data?', 'is-it-useful-to-install-the-sample-data', '<p>Well you are reading it right now! This depends on what you want to achieve. If you are new to Joomla! and have no clue how it all fits together, just install the sample data. If you don\'t like the English sample data because you - for instance - speak Chinese, then leave it out.</p>', '', 1, 82, '2006-10-11 09:12:55', 42, '', '2011-09-01 07:40:04', 42, 0, '0000-00-00 00:00:00', '2006-10-10 10:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(84, 191, 'How do I remove an Article?', 'how-do-i-remove-an-article', '<p>To completely remove an Article, select the Articles that you want to delete and move them to the Trash. Next, open the Article Trash in the Content Menu and select the Articles you want to delete. After deleting an Article, it is no longer available as it has been deleted from the database and it is not possible to undo this operation.</p>', '', 1, 82, '2006-10-11 09:19:01', 42, '', '2011-09-01 07:26:19', 42, 0, '0000-00-00 00:00:00', '2006-10-10 10:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 22, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(85, 192, 'What is the difference between Archiving and Trashing an Article? ', '1410901982', '<p>When you <em>Archive </em>an Article, the content is put into a state which removes it from your site as published content. The Article is still available from within the Control Panel and can be <em>retrieved </em>for editing or republishing purposes. Trashed Articles are just one step from being permanently deleted but are still available until you Remove them from the Trash Manager. You should use Archive if you consider an Article important, but not current. Trash should be used when you want to delete the content entirely from your site and from future search results.</p>', '', 1, 82, '2006-10-11 05:19:43', 42, '', '2008-04-20 04:18:19', 64, 0, '0000-00-00 00:00:00', '2006-10-10 06:00:00', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 8, '', 0, '*', ''),
(86, 194, 'How do I upgrade to Joomla! 1.5 ?', 'how-do-i-upgrade-to-joomla-15-', '<p>Joomla! 1.5 does not provide an upgrade path from earlier versions. Converting an older site to a Joomla! 1.5 site requires creation of a new empty site using Joomla! 1.5 and then populating the new site with the content from the old site. This migration of content is not a one-to-one process and involves conversions and modifications to the content dump.</p>\r\n<p>There are two ways to perform the migration:</p>\r\n', '\r\n<div id="post_content-107">\r\n<ul>\r\n<li>An automated method of migration has been provided which uses a migrator Component to create the migration dump out of the old site (Mambo 4.5.x up to Joomla! 1.0.x) and a smart import facility in the Joomla! 1.5 Installation that performs required conversions and modifications during the installation process.</li>\r\n<li>Migration can be performed manually. This involves exporting the required tables, manually performing required conversions and modifications and then importing the content to the new site after it is installed.</li>\r\n</ul>\r\n<p> </p>\r\n<h2><strong> Automated migration</strong></h2>\r\n<p>This is a two phased process using two tools. The first tool is a migration Component named <span style="font-family: courier new,courier;">com_migrator</span>. This Component has been contributed by Harald Baer and is based on his <strong>eBackup </strong>Component. The migrator needs to be installed on the old site and when activated it prepares the required export dump of the old site\'s data. The second tool is built into the Joomla! 1.5 installation process. The exported content dump is loaded to the new site and all conversions and modification are performed on-the-fly.</p>\r\n<h3><span style="text-decoration: underline;">Step 1 - Using com_migrator to export data from old site:</span></h3>\r\n<ul>\r\n<li>Install the <span style="font-family: courier new,courier;">com_migrator</span> Component on the <span style="text-decoration: underline;"><strong>old</strong></span> site. It can be found at the <a href="http://joomlacode.org/gf/project/pasamioprojects/frs/" target="_blank">JoomlaCode developers forge</a>.</li>\r\n<li>Select the Component in the Component Menu of the Control Panel.</li>\r\n<li>Click on the <strong>Dump it</strong> icon. Three exported <em>gzipped </em>export scripts will be created. The first is a complete backup of the old site. The second is the migration content of all core elements which will be imported to the new site. The third is a backup of all 3PD Component tables.</li>\r\n<li>Click on the download icon of the particular exports files needed and store locally.</li>\r\n<li>Multiple export sets can be created.</li>\r\n<li>The exported data is not modified in anyway and the original encoding is preserved. This makes the <span style="font-family: courier new,courier;">com_migrator</span> tool a recommended tool to use for manual migration as well.</li>\r\n</ul>\r\n<h3><span style="text-decoration: underline;"> Step 2 - Using the migration facility to import and convert data during Joomla! 1.5 installation:</span></h3>\r\n<p>Note: This function requires the use of the <em><span style="font-family: courier new,courier;">iconv </span></em>function in PHP to convert encodings. If <em><span style="font-family: courier new,courier;">iconv </span></em>is not found a warning will be provided.</p>\r\n<ul>\r\n<li>In step 6 - Configuration select the \'Load Migration Script\' option in the \'Load Sample Data, Restore or Migrate Backed Up Content\' section of the page.</li>\r\n<li>Enter the table prefix used in the content dump. For example: \'#__\' or \'site2_\' are acceptable values.</li>\r\n<li>Select the encoding of the dumped content in the dropdown list. This should be the encoding used on the pages of the old site. (As defined in the _ISO variable in the language file or as seen in the browser page info/encoding/source)</li>\r\n<li>Browse the local host and select the migration export and click on <strong>Upload and Execute</strong></li>\r\n<li>A success message should appear or alternately a listing of database errors</li>\r\n<li>Complete the other required fields in the Configuration step such as Site Name and Admin details and advance to the final step of installation. (Admin details will be ignored as the imported data will take priority. Please remember admin name and password from the old site)</li>\r\n</ul>\r\n</div>', 1, 83, '2006-09-30 20:27:52', 42, '', '2011-09-01 07:25:27', 42, 0, '0000-00-00 00:00:00', '2006-09-29 12:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 13, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(87, 195, 'What happened to the locale setting?', '803284841', '<p>This is now defined in the Language [<em>lang</em>].xml file in the Language metadata settings. If you are having locale problems such as dates do not appear in your language for example, you might want to check/edit the entries in the locale tag. Note that multiple locale strings can be set and the host will usually accept the first one recognised.</p>', '', 1, 83, '2006-10-06 16:47:35', 42, '', '2008-04-20 04:19:42', 64, 0, '0000-00-00 00:00:00', '2006-10-05 14:00:00', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 10, '', 0, '*', ''),
(88, 196, 'Only one edit window! How do I create "Read more..."?', '906008742', '<p>This is now implemented by inserting a <strong>Read more...</strong> tag (the button is located below the editor area) a dotted line appears in the edited text showing the split location for the <em>Read more....</em> A new Plugin takes care of the rest.</p>\r\n\r\n<p>It is worth mentioning that this does not have a negative effect on migrated data from older sites. The new implementation is fully backward compatible.</p>', '', 1, 83, '2006-10-06 19:29:28', 42, '', '2008-04-20 03:55:14', 64, 0, '0000-00-00 00:00:00', '2006-10-05 14:00:00', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 19, '', 0, '*', ''),
(89, 197, 'Where is the Static Content Item?', '1763621683', '<p>In Joomla! versions prior to 1.5 there were separate processes for creating a Static Content Item and normal Content Items. The processes have been combined now and whilst both content types are still around they are renamed as Articles for Content Items and Uncategorized Articles for Static Content Items. </p>\r\n\r\n<p>If you want to create a static item, create a new Article in the same way as for standard content and rather than relating this to a particular Section and Category just select <span style="font-style: italic">Uncategorized</span> as the option in the Section and Category drop down lists.</p>', '', 1, 83, '2006-10-10 23:13:33', 42, '', '2008-04-20 03:55:38', 64, 0, '0000-00-00 00:00:00', '2006-10-10 04:00:00', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 10, '', 0, '*', ''),
(90, 198, 'Where did the Installers go?', '1419313533', '<p>The improved Installer can be found under the Extensions Menu. With versions prior to Joomla! 1.5 you needed to select a specific Extension type when you wanted to install it and use the Installer associated with it, with Joomla! 1.5 you just select the Extension you want to upload, and click on install. The Installer will do all the hard work for you.</p>', '', 1, 83, '2006-10-10 23:16:20', 42, '', '2008-04-20 04:19:29', 64, 0, '0000-00-00 00:00:00', '2006-10-10 04:00:00', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 3, '', 0, '*', ''),
(91, 199, 'Where did the Mambots go?', '738227705', '<p>Mambots have been renamed as Plugins. </p>\r\n\r\n<p>Mambots were introduced in Mambo and offered possibilities to add plug-in logic to your site mainly for the purpose of manipulating content. In Joomla! 1.5, Plugins will now have much broader capabilities than Mambots. Plugins are able to extend functionality at the framework layer as well.</p>', '', 1, 83, '2006-10-11 09:17:00', 42, '', '2008-04-20 03:55:23', 64, 0, '0000-00-00 00:00:00', '2006-10-10 10:00:00', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 3, '', 0, '*', ''),
(92, 201, 'Why does Joomla! 1.5 use utf-8 encoding?', '1499270223', '<p>Well... how about never needing to mess with encoding settings again?</p>\r\n\r\n<p>Ever needed to display several languages on one page or site and something always came up in Giberish?</p>\r\n\r\n<p>With utf-8 (a variant of Unicode) glyphs (character forms) of basically all languages can be displayed with one single encoding setting. </p>', '', 1, 84, '2006-10-05 01:11:29', 42, '', '2008-04-20 03:57:24', 64, 0, '0000-00-00 00:00:00', '2006-10-03 10:00:00', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 28, '', 0, '*', ''),
(93, 202, 'What is the FTP layer for?', '256215970', '<p>The FTP Layer allows file operations (such as installing Extensions or updating the main configuration file) without having to make all the folders and files writable. This has been an issue on Linux and other Unix based platforms in respect of file permissions. This makes the site admin\'s life a lot easier and increases security of the site.</p>\r\n\r\n<p>You can check the write status of relevent folders by going to \'\'Help-&gt;System Info" and then in the sub-menu to "Directory Permissions". With the FTP Layer enabled even if all directories are red, Joomla! will operate smoothly.</p>\r\n\r\n<p>NOTE: the FTP layer is not required on a Windows host/server. </p>', '', 1, 84, '2006-10-06 21:27:49', 42, '', '2008-04-20 03:56:49', 64, 0, '0000-00-00 00:00:00', '2006-10-05 16:00:00', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 22, '', 0, '*', ''),
(94, 203, 'Can Joomla! 1.5 operate with PHP Safe Mode On?', 'can-joomla-15-operate-with-php-safe-mode-on', '<p>Yes it can! This is a significant security improvement.</p><p>The <em>safe mode</em> limits PHP to be able to perfom actions only on files/folders who\'s owner is the same as PHP is currently using (this is usually \'apache\'). As files normally are created either by the Joomla! application or by FTP access, the combination of PHP file actions and the FTP Layer allows Joomla! to operate in PHP Safe Mode.</p>', '', 1, 84, '2006-10-06 19:28:35', 42, '', '2011-01-28 11:40:36', 42, 0, '0000-00-00 00:00:00', '2006-10-05 14:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(95, 204, 'My MySQL  database does not support UTF-8. Do I have a problem?', '32247020', '<p>No you don\'t. Versions of MySQL lower than 4.1 do not have built in UTF-8 support. However, Joomla! 1.5 has made provisions for backward compatibility and is able to use UTF-8 on older databases. Let the installer take care of all the settings and there is no need to make any changes to the database (charset, collation, or any other).</p>', '', 1, 84, '2006-10-07 09:30:37', 42, '', '2008-04-20 03:57:04', 64, 0, '0000-00-00 00:00:00', '2006-10-05 20:00:00', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 8, '', 0, '*', ''),
(96, 205, 'What are the requirements to run Joomla! 1.5?', '1282656148', '<p>Joomla! runs on the PHP pre-processor. PHP comes in many flavours, for a lot of operating systems. Beside PHP you will need a Web server. Joomla! is optimized for the Apache Web server, but it can run on different Web servers like Microsoft IIS it just requires additional configuration of PHP and MySQL. Joomla! also depends on a database, for this currently you can only use MySQL. </p>Many people know from their own experience that it\'s not easy to install an Apache Web server and it gets harder if you want to add MySQL, PHP and Perl. XAMPP, WAMP, and MAMP are easy to install distributions containing Apache, MySQL, PHP and Perl for the Windows, Mac OSX and Linux operating systems. These packages are for localhost installations on non-public servers only.<br />The minimum version requirements are:<br /><ul><li>Apache 1.x or 2.x</li><li>PHP 4.3 or up</li><li>MySQL 3.23 or up</li></ul>For the latest minimum requirements details visit the <a href="http://help.joomla.org" title="Joomla! Help Site">Joomla! Help Site</a> and <a href="http://forum.joomla.org" title="The Joomla! Community Forums">Forums</a>', '', 1, 84, '2006-10-11 00:42:31', 42, '', '2007-11-08 11:36:52', 62, 0, '0000-00-00 00:00:00', '2006-10-10 06:00:00', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 28, '', 0, '*', ''),
(97, 206, 'How do I install Joomla! 1.5?', 'how-do-i-install-joomla-15', '<p>Installing of Joomla! 1.5 is pretty easy. We assume you have set-up your Web site, and it is accessible with your browser.</p>\r\n<p>Download Joomla! 1.5, unzip it and upload/copy the files into the directory you Web site points to, fire up your browser and enter your Web site address and the installation will start.</p>\r\n<p>For full details on the installation processes check out the <a href="http://help.joomla.org/content/category/48/268/302" title="Joomla! 1.5 Installation Manual">Installation Manual</a> on the <a href="http://help.joomla.org" title="Joomla! Help Site">Joomla! Help Site</a> where you will also find download instructions for a PDF version too.</p>', '', 1, 84, '2006-10-11 01:10:59', 42, '', '2011-09-01 07:26:41', 42, 0, '0000-00-00 00:00:00', '2006-10-10 06:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(98, 207, 'What is an Uncategorised Article?', '49430680', '<p>Most Articles will be assigned to a Section and Category. In many cases, you might not know where you want it to appear so put the Article in the <em>Uncategorized </em>Section/Category. The Articles marked as <em>Uncategorized </em>are handled as static content.</p>', '', 1, 84, '2006-10-11 15:14:11', 42, '', '2008-04-20 03:56:06', 64, 0, '0000-00-00 00:00:00', '2006-10-10 12:00:00', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 6, '', 0, '*', ''),
(99, 208, 'Is it possible to change A Menu Item\'s Type?', 'is-it-possible-to-change-a-menu-items-type', '<p>You indeed can change the Menu Item\'s Type to whatever you want, even after they have been created.</p>\r\n<p>If, for instance, you want to change the Blog Section of a Menu link, go to the Control Panel-&gt;Menus Menu-&gt;[menuname]-&gt;Menu Item Manager and edit the Menu Item. Select the <strong>Change Type</strong> button and choose the new style of Menu Item Type from the available list. Thereafter, alter the Details and Parameters to reconfigure the display for the new selection as you require it.</p>', '', 1, 84, '2006-10-10 23:15:36', 42, '', '2011-09-01 07:39:33', 42, 0, '0000-00-00 00:00:00', '2006-10-10 04:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 22, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(100, 210, 'How do I localise Joomla! to my language?', 'how-do-i-localise-joomla-to-my-language', '<h4>General</h4>\r\n<p>In Joomla! 1.5 all User interfaces can be localised. This includes the installation, the Back-end Control Panel and the Front-end Site.</p>\r\n<p>The core release of Joomla! 1.5 is shipped with multiple language choices in the installation but, other than English (the default), languages for the Site and Administration interfaces need to be added after installation. Links to such language packs exist below.</p>\r\n', '\r\n<p>Translation Teams for Joomla! 1.5 may have also released fully localised installation packages where site, administrator and sample data are in the local language. These localised releases can be found in the specific team projects on the <a href="http://joomlacode.org" title="The Joomla! Code Repository">JoomlaCode</a>.</p>\r\n<h4>How do I install language packs?</h4>\r\n<ul>\r\n<li>First download both the admin and the site language packs that you require.</li>\r\n<li>Install each pack separately using the Extensions-&gt;Install/Uninstall Menu selection and then the package file upload facility.</li>\r\n<li>Go to the Language Manager and be sure to select Site or Admin in the sub-menu. Then select the appropriate language and make it the default one using the Toolbar button.</li>\r\n</ul>\r\n<h4>How do I select languages?</h4>\r\n<ul>\r\n<li>Default languages can be independently set for Site and for Administrator</li>\r\n<li>In addition, users can define their preferred language for each Site and Administrator. This takes affect after logging in</li>\r\n<li>While logging in to the Administrator Back-end, a language can also be selected for the particular session.</li>\r\n</ul>\r\n<h4>Where can I find Language Packs and Localised Releases?</h4>\r\n<p><em>Please note that Joomla! 1.5 is new and language packs for this version may have not been released at this time.</em></p>\r\n<ul>\r\n<li><a href="http://joomlacode.org/gf/project/jtranslation/" target="_blank" title="Accredited Translations">The Joomla! Accredited Translations Project</a> - This is a joint repository for language packs that were developed by teams that are members of the Joomla! Translations Working Group.</li>\r\n<li><a href="http://extensions.joomla.org/component/option,com_mtree/task,listcats/cat_id,1837/Itemid,35/" target="_blank" title="Translations">The Joomla! Extensions Site - Translations</a></li>\r\n<li><a href="http://dev.joomla.org/content/view/42/66/" target="_blank" title="Translation Work Group Teams">List of Translation Teams and Translation Partner Sites for Joomla! 1.5</a></li>\r\n</ul>', 1, 85, '2006-09-30 14:06:37', 42, '', '2011-09-01 07:32:31', 42, 0, '0000-00-00 00:00:00', '2006-09-29 10:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 9, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(101, 211, 'What is the purpose of the collation selection in the installation screen?', '1700313730', '<p>The collation option determines the way ordering in the database is done. In languages that use special characters, for instance the German umlaut, the database collation determines the sorting order. If you don\'t know which collation you need, select the "utf8_general_ci" as most languages use this. The other collations listed are exceptions in regards to the general collation. If your language is not listed in the list of collations it most likely means that "utf8_general_ci is suitable.</p>', '', 1, 85, '2006-10-11 03:11:38', 42, '', '2008-04-20 03:59:00', 64, 0, '0000-00-00 00:00:00', '2006-10-10 08:00:00', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 6, '', 0, '*', ''),
(102, 212, 'What languages are supported by Joomla! 1.6?', '1733088493', '<p>Within the Installer you will find a wide collection of languages. The installer currently supports the following languages: Arabic, Bulgarian, Bengali, Czech, Danish, German, Greek, English, Spanish, Finnish, French, Hebrew, Devanagari(India), Croatian(Croatia), Magyar (Hungary), Italian, Malay, Norwegian bokmal, Dutch, Portuguese(Brasil), Portugues(Portugal), Romanian, Russian, Serbian, Svenska, Thai and more are being added all the time.</p>\r\n\r\n<p>By default the English language is installed for the Back and Front-ends. You can download additional language files from the <a href="http://extensions.joomla.org" title="Joomla! Extensions Directory">Joomla!Extensions Directory</a>. In addition some translation teams are offering fully localised versions of the entire package. Please check the <a href="http://help.joomla.org/content/view/1651/62/" target="blank_" title="Joomla! help site for links">Joomla! Help Site for links</a>   to locations where languages and localised versions can be found.</p>', '', 1, 85, '2006-10-11 01:12:18', 42, '', '2011-01-28 11:42:31', 42, 0, '0000-00-00 00:00:00', '2006-10-10 06:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(103, 213, 'Does the PDF icon render pictures and special characters?', 'does-the-pdf-icon-render-pictures-and-special-characters', '<p>Yes! Prior to Joomla! 1.5, only the text values of an Article and only for ISO-8859-1 encoding was allowed in the PDF rendition. With the new PDF library in place, the complete Article including images is rendered and applied to the PDF. The PDF generator also handles the UTF-8 texts and can handle any character sets from any language. The appropriate fonts must be installed but this is done automatically during a language pack installation.</p>', '', 1, 85, '2006-10-11 17:14:57', 42, '', '2011-01-28 11:45:28', 42, 0, '0000-00-00 00:00:00', '2006-10-10 14:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(104, 214, 'I installed with my own language, but the Back-end is still in English', 'i-installed-with-my-own-language-but-the-back-end-is-still-in-english', '<p>A lot of different languages are available for the Back-end, but by default this language may not be installed. If you want a translated Back-end, get your language pack and install it using the Extension Installer. After this, go to the Extensions Menu, select Language Manager and make your language the default one. Your Back-end will be translated immediately.</p>\r\n<p>Users who have access rights to the Back-end may choose the language they prefer in their Personal Details parameters. This is of also true for the Front-end language.</p>\r\n<p>A good place to find where to download your languages and localised versions of Joomla! is on our <a href="http://help.joomla.org/content/view/1651/62/" target="blank_" title="Help Site">Help Site</a>.</p>', '', 1, 85, '2006-10-11 17:18:14', 42, '', '2011-09-01 07:27:04', 42, 0, '0000-00-00 00:00:00', '2006-10-10 14:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(105, 217, 'Joomla! License Guidelines', '178509576', '<p>This Web site is powered by <a href="http://www.joomla.org/">Joomla!</a>  The software and default templates on which it runs are Copyright 2005-2007 <a href="http://www.opensourcematters.org/">Open Source Matters</a>.  All other content and data, including data entered into this Web site and templates added after installation, are copyrighted by their respective copyright owners.</p>\r\n\r\n<p>If you want to distribute, copy, or modify Joomla!, you are welcome to do so under the terms of the <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.html#SEC1">GNU General Public License</a>.  If you are unfamiliar with this license, you might want to read <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.html#SEC4">\'How To Apply These Terms To Your Program\'</a> and the <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0-faq.html">\'GNU General Public License FAQ\'</a>.</p><p>Joomla! documentation is released under the terms of the <a href="http://creativecommons.org/licenses/by-nc-sa/2.5/" title="Creative Commons ">Creative Commons Attribution-Non-Commercial-Share-Alike License 2.5</a> or by the specific license of their respective copyright owners.</p><p>The Joomla! licence has always been GPL.</p>', '', 1, 87, '2004-08-20 10:11:07', 42, '', '2008-04-20 03:53:51', 64, 0, '0000-00-00 00:00:00', '2004-08-19 06:00:00', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 147, '', 0, '*', ''),
(106, 218, 'Support and Documentation', '995143307', '<h1>Support </h1>\r\n<p>Support for the Joomla! CMS can be found on several places. The best place to start would be the official <a href="http://help.joomla.org/" target="_blank">Help Site</a>. Here you can help yourself to the information that is regularly published and updated as Joomla! develops. There is much more to come too!</p>\r\n\r\n<p>Of course you should not forget the Help System of the CMS itself. On the <em>topmenu </em>in the Back-end Control panel you find the Help button which will provide you with lots of explanation on features.</p>\r\n\r\n<p>Another great place would of course be the <a href="http://forum.joomla.org/" target="_blank">Forum</a> . On the Joomla! Forum you can find help and support from Community members as well as from Joomla! Core members and Working Group members. The forum contains a lot of information, FAQ\'s, just about anything you are looking for in terms of support.</p>\r\n\r\n<p>Two other resources for Support are the <a href="http://dev.joomla.org/" target="_blank">Joomla! Developer Network</a>  (JDN) and the <a href="http://extensions.joomla.org/" target="_blank">Joomla! Extensions Directory</a> (JED). The Developer Network for example provides lots of technical information for the experienced Developer as well as those new to Joomla! and development work in general. The JED whilst not a support site in the strictest sense has many of the Extensions that you will need as you develop your own Web site.</p>\r\n\r\n<p>The Joomla! Core members are regularly posting their blog reports about several topics such as programming techniques used in Joomla!, Security, Events and more. You can even subscribe to get notified by e-mail when a new blog post is made! </p>\r\n\r\n<h1>Documentation </h1>\r\n<p>Joomla! Documentation can of course be found on the <a href="http://help.joomla.org/" target="_blank">Help Site</a>. You can find information such as an Installation Guide, User and Administrator manuals, Frequently Asked Questions and a lot more. The User Documentation Team are the guardians of the documentation relating to the practical use of Joomla!. The Developer Documentation Team are the stalwarts behind detailing how Joomla! works from the ground up and how you can develop your own Extensions and Templates and much more.</p>\r\n\r\n<p>Other than the documentation provided by the Joomla! Documentation Work Groups there are also books written about Joomla! You can find a listing of these books in the <a href="http://help.joomla.org/content/section/44/254/" target="_blank">Joomla! Bookshelf</a>.</p>\r\n\r\n<h1>Want to help? </h1>\r\n<p>If you want to help in the documentation project for Joomla! then please post your details on the <a href="http://forum.joomla.org/index.php/board,62.0.html" title="The Joomla! User Documentation Forums">User Documentation Forum</a> or the <a href="http://forum.joomla.org/index.php/board,60.0.html" title="The Joomla! Developer Documentation Forum">Developer Documentation Forum</a></p>\r\n\r\n<p><a class="urlextern" href="http://forum.joomla.org/index.php/board,391.0.html" target="_blank" title="http://forum.joomla.org/index.php/board,59.0.html" onclick="return svchk()"></a></p>', '', 1, 87, '2006-10-09 08:33:57', 42, '', '2008-04-20 03:53:12', 64, 0, '0000-00-00 00:00:00', '2006-10-07 10:00:00', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 56, '', 0, '*', ''),
(107, 219, 'Platforms and Open Standards', '1060371905', '<p class="MsoNormal">Joomla! runs on any platform including Windows, most flavours of Linux, several Unix versions, and the Apple OS/X platform.  Joomla! depends on PHP and the MySQL database to deliver dynamic content.  </p>\r\n\r\n<p class="MsoNormal">The minimum requirements are:</p>\r\n\r\n<ul>\r\n<li>Apache 1.x, 2.x and higher</li>\r\n<li>PHP 4.3 and higher</li>\r\n<li>MySQL 3.23 and higher</li>\r\n</ul>\r\n\r\n<p>It will also run on alternative server platforms such as Windows IIS - provided they support PHP and MySQL - but these require additional configuration in order for the Joomla! core package to be successful installed and operated.</p>', '', 1, 87, '2006-10-11 04:22:14', 42, '', '2008-04-20 03:54:38', 64, 0, '0000-00-00 00:00:00', '2006-10-10 08:00:00', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 11, '', 0, '*', ''),
(108, 221, 'Joomla! Features', '1468295479', '<h4><font color="#ff6600">Joomla! features:</font></h4>\r\n\r\n<ul>\r\n<li>Completely database driven site engines </li>\r\n<li>News, products, or services sections fully editable and manageable</li>\r\n<li>Topics sections can be added to by contributing Authors</li>\r\n<li>Fully customisable layouts including <em>left</em>, <em>center</em>, and <em>right </em>Menu boxes </li>\r\n<li>Browser upload of images to your own library for use anywhere in the site </li>\r\n<li>Dynamic Forum/Poll/Voting booth for on-the-spot results </li>\r\n<li>Runs on Linux, FreeBSD, MacOSX server, Solaris, and AIX', '</li>\r\n</ul>\r\n\r\n<h4>Extensive Administration:</h4>\r\n\r\n<ul>\r\n<li>Change order of objects including news, FAQs, Articles etc. </li>\r\n<li>Random Newsflash generator </li>\r\n<li>Remote Author submission Module for News, Articles, FAQs, and Links </li>\r\n<li>Object hierarchy - as many Sections, departments, divisions, and pages as you want </li>\r\n<li>Image library - store all your PNGs, PDFs, DOCs, XLSs, GIFs, and JPEGs online for easy use </li>\r\n<li>Automatic Path-Finder. Place a picture and let Joomla! fix the link </li>\r\n<li>News Feed Manager. Choose from over 360 News Feeds from around the world </li>\r\n<li>E-mail a friend and Print format available for every story and Article</li>\r\n<li>In-line Text editor similar to any basic word processor software</li>\r\n<li>User editable look and feel </li>\r\n<li>Polls/Surveys - Now put a different one on each page </li>\r\n<li>Custom Page Modules. Download custom page Modules to spice up your site </li>\r\n<li>Template Manager. Download Templates and implement them in seconds </li>\r\n<li>Layout preview. See how it looks before going live </li>\r\n<li>Banner Manager. Make money out of your site</li>\r\n</ul>', 1, 88, '2006-10-08 23:32:45', 42, '', '2008-04-20 03:16:56', 64, 62, '2009-09-11 07:54:42', '2006-10-07 06:00:00', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 63, '', 0, '*', ''),
(109, 222, 'Joomla! Overview', '188311684', '<img src="images/stories/demo/other/sam-4.jpg" alt="Because open source matter" align="right" title="Because open source matter" class="caption" />\r\n\r\n<p>If you\'re new to Web publishing systems, you\'ll find that Joomla! delivers sophisticated solutions to your online needs. It can deliver a robust enterprise-level Web site, empowered by endless extensibility for your bespoke publishing needs. Moreover, it is often the system of choice for small business or home users who want a professional looking site that\'s simple to deploy and use. <em>We do content right</em>.</p>\r\n\r\n<p>So what\'s the catch? How much does this system cost?</p>\r\n\r\n<p> Well, there\'s good news ... and more good news! Joomla! 1.5 is free, it is released under an Open Source license - the GNU/General Public License v 2.0. Had you invested in a mainstream, commercial alternative, there\'d be nothing but moths left in your wallet and to add new functionality would probably mean taking out a second mortgage each time you wanted something adding!</p>\r\n\r\n<p>Joomla! changes all that ... <br />Joomla! is different from the normal models for content management software. For a start, it\'s not complicated. Joomla! has been developed for everybody, and anybody can develop it further. It is designed to work (primarily) with other Open Source, free, software such as PHP, MySQL, and Apache.</p>\r\n\r\n<p>It is easy to install and administer, and is reliable. </p>\r\n\r\n<p>Joomla! doesn\'t even require the user or administrator of the system to know HTML to operate it once it\'s up and running.</p>\r\n\r\n<p>To get the perfect Web site with all the functionality that you require for your particular application may take additional time and effort, but with the Joomla! Community support that is available and the many Third Party Developers actively creating and releasing new Extensions for the 1.5 platform on an almost daily basis, there is likely to be something out there to meet your needs. Or you could develop your own Extensions and make these available to the rest of the community.</p>', '', 1, 88, '2006-10-09 07:49:20', 42, '', '2008-04-20 08:47:59', 64, 0, '0000-00-00 00:00:00', '2006-10-07 10:00:00', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 219, '', 0, '*', ''),
(110, 223, 'What\'s New In 1.5?', '1378251143', '<p>As with previous releases, Joomla! provides a unified and easy-to-use framework for delivering content for Web sites of all kinds. To support the changing nature of the Internet and emerging Web technologies, Joomla! required substantial restructuring of its core functionality and we also used this effort to simplify many challenges within the current user interface. Joomla! 1.5 has many new features.</p>', '<p>&nbsp;</p><p style="margin-bottom: 0in">   The goals for the Joomla! 1.5 release are to: </p>    <ul><li>     <p style="margin-bottom: 0in">       Substantially improve usability, manageability, and scalability far beyond the original Mambo foundations.     </p>   </li><li>     <p style="margin-bottom: 0in"> Expand accessibility to support internationalisation, double-byte characters and Right-to-Left support for Arabic, Farsi, and Hebrew languages for example amongst others. </p>   </li><li>     <p style="margin-bottom: 0in"> Extend the integration of external applications through Web Services and remote authentication such as the Lightweight Directory Access Protocol (LDAP). </p>   </li><li>     <p style="margin-bottom: 0in"> Enhance the content delivery, template and presentation capabilities to support accessibility standards and content delivery to any destination. </p>   </li><li>     <p style="margin-bottom: 0in">       Achieve a more sustainable and flexible framework for Component and Extension developers.     </p>   </li><li>     <p style="margin-bottom: 0in">       Deliver backward compatibility with previous releases of Components, Templates, Modules and other Extensions.</p></li></ul><p>&nbsp;</p>', 1, 88, '2006-10-11 22:13:58', 42, '', '2007-11-04 15:39:15', 62, 0, '0000-00-00 00:00:00', '2006-10-10 18:00:00', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 110, '', 0, '*', ''),
(111, 224, 'Content Layouts', 'content-layouts', '<p>Joomla! provides plenty of flexibility when displaying your Web content. Whether you are using Joomla! for a blog site, news or a Web site for a company, you\'ll find one or more content styles to showcase your information. You can also change the style of content dynamically depending on your preferences. Joomla! calls how a page is laid out a <strong>layout</strong>. Use the guide below to understand which layouts are available and how you might use them. </p> \r\n\r\n<h2>Content </h2>\r\n<p>Joomla! makes it extremely easy to add and display content. All content  is placed where your mainbody tag in your template is located. There are three main types of layouts available in Joomla! and all of them can be customised via parameters. The display and parameters are set in the Menu Item used to display the content your working on. You create these layouts by creating a Menu Item and choosing how you want the content to display.</p>\r\n\r\n<h3>Blog Layout</h3>\r\n<p>Blog layout will show a listing of all Articles of the selected blog type (Section or Category) in the mainbody position of your template. It will give you the standard title, and Intro of each Article in that particular Category and/or Section. You can customise this layout via the use of the Preferences and Parameters, (See Article Parameters) this is done from the Menu not the Section Manager!</p>\r\n\r\n<h3>Blog Archive Layout</h3>\r\n<p>A Blog Archive layout will give you a similar output of Articles as the normal Blog Display but will add, at the top, two drop down lists for month and year plus a search button to allow Users to search for all Archived Articles from a specific month and year.</p>\r\n\r\n<h3>List Layout</h3>\r\n<p>Table layout will simply give you a <em>tabular </em>list<em> </em>of all the titles in that particular Section or Category. No Intro text will be displayed just the titles. You can set how many titles will be displayed in this table by Parameters. The table layout will also provide a filter Section so that Users can reorder, filter, and set how many titles are listed on a single page (up to 50)</p>\r\n\r\n<h2>Wrapper</h2>\r\n<p>Wrappers allow you to place stand alone applications and Third Party Web sites inside your Joomla! site. The content within a Wrapper appears within the primary content area defined by the "mainbody" tag and allows you to display their content as a part of your own site. A Wrapper will place an IFRAME into the content Section of your Web site and wrap your standard template navigation around it so it appears in the same way an Article would.</p>\r\n\r\n<h2>Content Parameters</h2>\r\n<p>The parameters for each layout type can be found on the right hand side of the editor boxes in the Menu Item configuration screen. The parameters available depend largely on what kind of layout you are configuring.</p>', '', 1, 88, '2006-10-12 22:33:10', 42, '', '2011-01-28 11:43:17', 42, 0, '0000-00-00 00:00:00', '2006-10-11 06:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 76, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(112, 225, 'Extensions', 'extensions', '<p>Out of the box, Joomla! does a great job of managing the content needed to make your Web site sing. But for many people, the true power of Joomla! lies in the application framework that makes it possible for developers all around the world to create powerful add-ons that are called <strong>Extensions</strong>. An Extension is used to add capabilities to Joomla! that do not exist in the base core code. Here are just some examples of the hundreds of available Extensions:</p> <ul>   <li>Dynamic form builders</li>   <li>Business or organisational directories</li>   <li>Document management</li>   <li>Image and multimedia galleries</li>   <li>E-commerce and shopping cart engines</li>   <li>Forums and chat software</li>   <li>Calendars</li>   <li>E-mail newsletters</li>   <li>Data collection and reporting tools</li>   <li>Banner advertising systems</li>   <li>Paid subscription services</li>   <li>and many, many, more</li> </ul> <p>You can find more examples over at our ever growing <a href="http://extensions.joomla.org" target="_blank" title="Joomla! Extensions Directory">Joomla! Extensions Directory</a>. Prepare to be amazed at the amount of exciting work produced by our active developer community!</p><p>A useful guide to the Extension site can be found at:<br /><a href="http://extensions.joomla.org/content/view/15/63/" target="_blank" title="Guide to the Joomla! Extension site">http://extensions.joomla.org/content/view/15/63/</a> </p> <h3>Types of Extensions </h3><p>There are five types of extensions:</p> <ul>   <li>Components</li>   <li>Modules</li>   <li>Templates</li>   <li>Plugins</li>   <li>Languages</li> </ul> <p>You can read more about the specifics of these using the links in the Article Index - a Table of Contents (yet another useful feature of Joomla!) - at the top right or by clicking on the <strong>Next </strong>link below.<br /> </p> <hr title="Components" class="system-pagebreak" /> <h3><img src="images/stories/ext_com.png" border="0" alt="Component - Joomla! Extension Directory" title="Component - Joomla! Extension Directory" width="17" height="17" /> Components</h3> <p>A Component is the largest and most complex of the Extension types.  Components are like mini-applications that render the main body of the  page. An analogy that might make the relationship easier to understand  would be that Joomla! is a book and all the Components are chapters in  the book. The core Article Component (<font face="courier new,courier">com_content</font>), for example, is the  mini-application that handles all core Article rendering just as the  core registration Component (<font face="courier new,courier">com_user</font>) is the mini-application  that handles User registration.</p> <p>Many of Joomla!\'s core features are provided by the use of default Components such as:</p> <ul>   <li>Contacts</li>   <li>Front Page</li>   <li>News Feeds</li>   <li>Banners</li>   <li>Mass Mail</li>   <li>Polls</li></ul><p>A Component will manage data, set displays, provide functions, and in general can perform any operation that does not fall under the general functions of the core code.</p> <p>Components work hand in hand with Modules and Plugins to provide a rich variety of content display and functionality aside from the standard Article and content display. They make it possible to completely transform Joomla! and greatly expand its capabilities.</p>  <hr title="Modules" class="system-pagebreak" /> <h3><img src="images/stories/ext_mod.png" border="0" alt="Module - Joomla! Extension Directory" title="Module - Joomla! Extension Directory" width="17" height="17" /> Modules</h3> <p>A more lightweight and flexible Extension used for page rendering is a Module. Modules are used for small bits of the page that are generally  less complex and able to be seen across different Components. To  continue in our book analogy, a Module can be looked at as a footnote  or header block, or perhaps an image/caption block that can be rendered  on a particular page. Obviously you can have a footnote on any page but  not all pages will have them. Footnotes also might appear regardless of  which chapter you are reading. Simlarly Modules can be rendered  regardless of which Component you have loaded.</p> <p>Modules are like little mini-applets that can be placed anywhere on your site. They work in conjunction with Components in some cases and in others are complete stand alone snippets of code used to display some data from the database such as Articles (Newsflash) Modules are usually used to output data but they can also be interactive form items to input data for example the Login Module or Polls.</p> <p>Modules can be assigned to Module positions which are defined in your Template and in the back-end using the Module Manager and editing the Module Position settings. For example, "left" and "right" are common for a 3 column layout. </p> <h4>Displaying Modules</h4> <p>Each Module is assigned to a Module position on your site. If you wish it to display in two different locations you must copy the Module and assign the copy to display at the new location. You can also set which Menu Items (and thus pages) a Module will display on, you can select all Menu Items or you can pick and choose by holding down the control key and selecting multiple locations one by one in the Modules [Edit] screen</p> <p>Note: Your Main Menu is a Module! When you create a new Menu in the Menu Manager you are actually copying the Main Menu Module (<font face="courier new,courier">mod_mainmenu</font>) code and giving it the name of your new Menu. When you copy a Module you do not copy all of its parameters, you simply allow Joomla! to use the same code with two separate settings.</p> <h4>Newsflash Example</h4> <p>Newsflash is a Module which will display Articles from your site in an assignable Module position. It can be used and configured to display one Category, all Categories, or to randomly choose Articles to highlight to Users. It will display as much of an Article as you set, and will show a <em>Read more...</em> link to take the User to the full Article.</p> <p>The Newsflash Component is particularly useful for things like Site News or to show the latest Article added to your Web site.</p>  <hr title="Plugins" class="system-pagebreak" /> <h3><img src="images/stories/ext_plugin.png" border="0" alt="Plugin - Joomla! Extension Directory" title="Plugin - Joomla! Extension Directory" width="17" height="17" /> Plugins</h3> <p>One  of the more advanced Extensions for Joomla! is the Plugin. In previous  versions of Joomla! Plugins were known as Mambots. Aside from changing their name their  functionality has been expanded. A Plugin is a section of code that  runs when a pre-defined event happens within Joomla!. Editors are Plugins, for example, that execute when the Joomla! event <font face="courier new,courier">onGetEditorArea</font> occurs. Using a Plugin allows a developer to change  the way their code behaves depending upon which Plugins are installed  to react to an event.</p>  <hr title="Languages" class="system-pagebreak" /> <h3><img src="images/stories/ext_lang.png" border="0" alt="Language - Joomla! Extensions Directory" title="Language - Joomla! Extensions Directory" width="17" height="17" /> Languages</h3> <p>New  to Joomla! 1.5 and perhaps the most basic and critical Extension is a Language. Joomla! is released with multiple Installation Languages but the base Site and Administrator are packaged in just the one Language <strong>en-GB</strong> - being English with GB spelling for example. To include all the translations currently available would bloat the core package and make it unmanageable for uploading purposes. The Language files enable all the User interfaces both Front-end and Back-end to be presented in the local preferred language. Note these packs do not have any impact on the actual content such as Articles. </p> <p>More information on languages is available from the Joomla! help site: Language Packs and Localised Releases<br />   <a href="http://help.joomla.org/content/view/1651/243/" target="_blank" title="Joomla! help site: Language Packs and Localised Releases">http://help.joomla.org/content/view/1651/243/</a></p>', '', 1, 88, '2006-10-11 06:00:00', 42, '', '2011-01-28 11:49:37', 42, 0, '0000-00-00 00:00:00', '2006-10-10 22:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, 'About Joomla!, General, Extensions', '', 1, 118, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(113, 227, 'Joomla! Facts', 'joomla-facts', '<p>Here are some interesting facts about Joomla!</p>\r\n<ul>\r\n<li><span>Over 140,000 active registered Users on the <a href="http://forums.joomla.org">Official Joomla! community forum</a> and more on the many international community sites.</span>\r\n<ul>\r\n<li><span>over 1,000,000 posts in over 200,000 topics</span></li>\r\n<li>over 1,200 posts per day</li>\r\n<li>growing at 150 new participants each day!</li>\r\n</ul>\r\n</li>\r\n<li><span>1168 Projects on the JoomlaCode (<a href="http://joomlacode.org/">joomlacode.org</a> ). All for open source addons by third party developers.</span>\r\n<ul>\r\n<li><span>Nearly 1,900,000 downloads of Joomla! since the migration to JoomlaCode in March 2007.<br /></span></li>\r\n</ul>\r\n</li>\r\n<li><span>2200+ Extensions for Joomla! have been registered on the <a href="http://extensions.joomla.org" title="http://extensions.joomla.org">Joomla! Extension Directory</a></span></li>\r\n<li><span>Joomla.org exceeds 2 TB of traffic per month!</span></li>\r\n<li><span>Alexa report [November 2007]: Joomla.org at #690 of the busiest Web sites in the world.</span></li>\r\n</ul>', '', 1, 89, '2006-10-09 16:46:37', 42, '', '2011-09-01 07:48:21', 42, 0, '0000-00-00 00:00:00', '2006-10-07 14:00:00', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 52, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(114, 228, 'The Joomla! Community', '2080230946', '<p><strong>Got a question? </strong>With more than 140,000 members, the online forums at <a href="http://forum.joomla.org/" target="_blank">forum.joomla.org</a>  are a great resource for both new and experienced users. Go ahead, ask your toughest questions, the community is waiting to see what you\'re going to do with your Joomla! site.</p>\r\n\r\n<p><strong>Do you want to show off your new Joomla! Web site?</strong> Go ahead, we have a section dedicated to that on our forum. </p><p><strong>Do you want to join in?</strong></p>\r\n\r\n<p>If you think working with Joomla! is fun, wait until you start working on it. We\'re passionate about helping Joomla! Users make the jump to becoming contributing members of the community, so there are many ways you can help Joomla!\'s development:</p>\r\n\r\n<ul>\r\n<li>Submit news about Joomla!. We syndicate all Joomla! related news on our <a href="http://news.joomla.org" title="Joomla! News Portal">news portal</a>. If you have some Joomla! news that you would like to share with the community, please submit your short story, article, announcement or review <a href="http://www.joomla.org/component/option,com_submissions/Itemid,75" title="Submit News">here</a>.</li>\r\n<li>Report bugs and request features in our <a href="http://joomlacode.org/gf/project/joomla/tracker/" title="Joomla! developement trackers">trackers</a>. Please read <a href="http://dev.joomla.org/content/view/1450/89/">Reporting Bugs</a>, for details on how we like our bug reports served up</li>\r\n<li>Submit patches for new and/or fixed behaviour. Please read <a ref="http://dev.joomla.org/content/view/14/55/">Submitting Patches</a>, for details on how to submit a patch.</li>\r\n<li>Join the <a href="http://forum.joomla.org/index.php/board,126.0.html" title="Joomla! development forums">developer forums</a> and share your ideas for how to improve Joomla!. We\'re always open to suggestions, although we\'re likely to be sceptical of large-scale suggestions without some code to back it up.</li>\r\n<li>Join any of the <a href="http://dev.joomla.org/content/view/13/53/" title="Joomla! working groups">Joomla!  Working Groups</a>  and bring your personal expertise to  the Joomla! community. More info about the different working groups can be found <a href="http://dev.joomla.org/content/view/13/53/" title="Joomla! working groups">on the Working Group Roll Call</a>.      </li>\r\n</ul>\r\n\r\n<p> That\'s all you need to know if you\'d like to join the Joomla! development community.</p>', '', 1, 89, '2006-10-12 16:50:48', 42, '', '2008-04-20 03:51:39', 64, 0, '0000-00-00 00:00:00', '2006-10-11 02:00:00', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 59, '', 0, '*', ''),
(115, 231, 'Premier League summer transfer photos ', '1219606112', '<img src="images/stories/demo/sport/football-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. </p>\r\n\r\n', '\r\n\r\n<p>Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper. Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>\r\n\r\n<p>Aenean tempus consequat euismod Pellentesque Aenean nec dictumst urna egestas tellus. Leo egestas pretium mattis quam Vestibulum enim natoque Maecenas dolor tempor. Orci Morbi nibh Vivamus at nunc enim consequat pellentesque orci elit. Amet porttitor et mauris Vestibulum semper metus tellus ipsum rhoncus dolor. Sem magnis id sed dictum pellentesque vel ante vitae purus netus. Eros volutpat sapien consequat Curabitur Vestibulum mus Vestibulum interdum dictum laoreet. Porttitor.</p>\r\n\r\n<p>Tempor ipsum et et nec in laoreet ornare convallis Curabitur Nam. Consectetuer ut nulla ullamcorper condimentum Duis tincidunt leo condimentum mauris elit. Et laoreet auctor nibh est Curabitur sodales sodales consectetuer mauris Fusce. Nulla Vivamus id Integer rhoncus enim Aliquam volutpat et leo nunc. Donec eros nulla molestie dui neque elit suscipit libero ut eleifend. Molestie.</p>', 1, 91, '2008-04-14 07:57:43', 42, '', '2013-07-30 08:57:51', 42, 0, '0000-00-00 00:00:00', '2008-04-14 07:57:43', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 8, '', '', 1, 12, '{"tags":[2,3,4],"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(116, 232, 'Ferguson hails brave Arsenal after \'best game of the year\'', '585591492', '<p>Lorem ipsum dolor sit amet consectetuer vel nibh Suspendisse sodales Quisque. Mauris quis lacus magna commodo lacinia nunc Curabitur et consequat elit. Ut nulla ut Donec tellus id Pellentesque convallis facilisis pellentesque nisl. In lacinia non urna et eu consectetuer hendrerit dis justo non. Eget Morbi Nulla et orci ipsum Nunc enim cursus Curabitur ac. Porttitor tristique eget condimentum Curabitur nulla leo nec.</p>\r\n\r\n', '\r\n\r\n<p>Fringilla ut Aenean suscipit ut lorem ac dui Nulla senectus eget. Et et Curabitur iaculis leo ullamcorper ut leo interdum enim elit. Faucibus quis eget felis Maecenas Fusce ornare pretium Vestibulum Pellentesque sagittis. Senectus consequat Nulla tempus elit nulla neque wisi consectetuer a Phasellus. Lacinia eros nibh malesuada ante In tellus ornare Vestibulum risus et. Tempus eget at Pellentesque et lacus Morbi tempus nec.</p>\r\n\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at. </p>\r\n\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>', -2, 91, '2008-04-14 08:08:52', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2008-04-14 08:08:52', '0000-00-00 00:00:00', '', '', '', 1, 0, '', '', 1, 1, '', 0, '*', ''),
(117, 233, 'Wenger\'s recipe for success', '548290215', '<img src="images/stories/demo/sport/football-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Fringilla ut Aenean suscipit ut lorem ac dui Nulla senectus eget. Et et Curabitur iaculis leo ullamcorper ut leo interdum enim elit. </p>\r\n\r\n', '\r\n<p>Faucibus quis eget felis Maecenas Fusce ornare pretium Vestibulum Pellentesque sagittis. Senectus consequat Nulla tempus elit nulla neque wisi consectetuer a Phasellus. Lacinia eros nibh malesuada ante In tellus ornare Vestibulum risus et. Tempus eget at Pellentesque et lacus Morbi tempus nec.</p>\r\n\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at. </p>\r\n\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt. </p>\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer ut mauris at Nam id. Nam nec semper quis congue Donec netus odio eu id consequat. Massa enim semper pellentesque Cras Sed neque congue dolor habitasse dui. Tempus In cursus Vestibulum Quisque at at ut dolor ut a. Tincidunt elit Integer venenatis Vestibulum libero at id orci dolor justo. Ornare dictum non orci ligula odio tempor orci neque urna Nam. Ornare vitae vitae.</p>\r\n\r\n<p class="box-grey">Vestibulum libero habitant sapien aliquet tortor Aenean lacinia laoreet justo sapien. Enim Pellentesque augue leo et montes consequat enim justo elit Nam. Feugiat cursus malesuada dui mollis fermentum justo congue nec nibh feugiat. Gravida justo nec risus ligula pede metus senectus tempor Maecenas massa. Laoreet nulla eros id congue ante purus scelerisque mauris semper elit. Duis Vestibulum cursus.</p>\r\n\r\n<p>Semper augue dolor tellus at vel magna vitae et Aliquam Vestibulum. Ut Sed eu orci auctor tellus interdum ac tincidunt id est. In rhoncus nibh Curabitur Curabitur quis massa mattis eget tincidunt cursus. Tortor ipsum nec cursus laoreet vitae feugiat id pellentesque Aenean Sed. Natoque Nulla risus magna justo Sed Phasellus leo.</p>\r\n\r\n<p>Scelerisque velit semper Suspendisse sociis consectetuer consequat Vestibulum semper vel interdum. Sed faucibus adipiscing augue justo nec cursus eget commodo semper lacinia. Donec tellus Sed porttitor Nullam natoque urna ac ut odio ut. Pellentesque enim Suspendisse natoque tellus risus Nam convallis dui ac massa. Urna id Nulla Nullam Sed mauris et ac sagittis Cum nunc. Vitae.</p>', 1, 91, '2008-04-14 08:10:21', 42, '', '2009-09-04 12:13:27', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:10:21', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 36, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(118, 234, 'How will the Premier League unfold?', 'how-will-the-premier-league-unfold', '<p><img class="caption left" src="images/stories/demo/sport/football-2.jpg" border="0" title="Image sample" /></p>\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla.</p>\r\n', '\r\n<p>At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat. Est risus dui consequat commodo nibh Donec at risus condimentum Quisque. Rutrum tincidunt tincidunt porttitor ridiculus Vestibulum et semper vitae Vestibulum urna.</p>\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>', 1, 91, '2008-04-14 08:26:46', 42, '', '2011-01-27 10:40:47', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:26:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 7, '', '', 1, 11, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(119, 235, 'Are England right to be optimistic?', 'are-england-right-to-be-optimistic', '<img src="images/stories/demo/sport/football-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer nibh nisl ante faucibus eget. Pellentesque Phasellus arcu tristique Vestibulum laoreet eu Quisque libero libero id. </p>\r\n\r\n', '\r\n<p>Pretium nisl id eu Suspendisse in quis pellentesque Nulla hendrerit Vivamus. Vitae eget pellentesque sed velit tempus Vestibulum eu libero diam semper. Dolor Morbi nec quis est commodo sollicitudin a sem sed wisi. Lorem orci leo vel enim Sed.</p>\r\n\r\n<p>Sit laoreet sagittis pellentesque dui fringilla vestibulum Nunc sed consectetuer Nullam. Sapien pede interdum auctor pellentesque Aenean et lobortis et Pellentesque justo. Pede Cum Duis nec mauris semper id nec Lorem enim ullamcorper. Augue Vestibulum tellus Suspendisse tortor Vestibulum laoreet Nam tellus cursus interdum. Feugiat eu porttitor justo congue Integer dolor Curabitur nulla Vestibulum amet. Nibh cursus turpis fringilla hendrerit adipiscing Maecenas sit ipsum.</p>\r\n\r\n<p>Cursus et ipsum molestie In vel wisi purus dui quis ut. Nam Cras Duis et orci tincidunt feugiat non pede Vestibulum Sed. Mauris pellentesque enim Nam ut et semper elit nibh tortor orci. Tellus congue Curabitur sem diam dignissim pretium sed Aenean fringilla habitasse. Sed sem felis sagittis sodales ac congue Maecenas Vivamus a sem. Mauris ut Vestibulum dictum porttitor at morbi turpis Sed.</p>\r\n\r\n<p>Tortor ullamcorper tellus adipiscing nulla lacinia semper augue ut Vivamus felis. Nonummy amet Vestibulum ut laoreet lorem habitant tellus ac tincidunt et. Morbi senectus nascetur pede dictumst tincidunt dignissim et id tellus Nam. Nam quis nisl et pede wisi ut ipsum lorem Vivamus morbi. Tincidunt malesuada urna aliquet Donec vel consequat tristique mauris enim Sed. Elit non.</p>', 1, 91, '2009-08-12 07:49:04', 42, '', '2011-01-28 11:38:45', 42, 0, '0000-00-00 00:00:00', '2009-08-12 07:49:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 1008, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(120, 236, 'Barcelona 3-0 Sporting Gijon', 'barcelona-3-0-sporting-gijon', '<img src="images/stories/demo/sport/football-5.jpg" alt="Barcelona" align="left" title="Barcelona" class="caption" />\r\n\r\n<p>Consectetuer venenatis nulla Nunc Morbi pretium penatibus Aenean velit malesuada pharetra. Curabitur interdum senectus semper cursus adipiscing eros et ac porttitor tincidunt.</p>\r\n\r\n', '\r\n\r\n<p>Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet.</p>\r\n\r\n<p>Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>', 1, 91, '2009-09-01 08:53:39', 42, '', '2011-01-28 11:40:20', 42, 0, '0000-00-00 00:00:00', '2009-09-01 08:53:39', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(121, 237, 'Volutpat euismod tincidunt', '659167855', '<img src="images/stories/demo/sport/football-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis.</p>\r\n\r\n', '\r\n\r\n<p>Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nis.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>\r\n\r\n<p>Et Fusce ut Fusce a Pellentesque Curabitur arcu hendrerit lobortis quis. Et a convallis sed Morbi euismod elit in tincidunt elit penatibus. Urna dolor pede interdum malesuada Sed id Vestibulum hendrerit aliquam Vestibulum. Sem adipiscing tellus neque at fames Vivamus ullamcorper tellus adipiscing ligula. Tempus turpis pede Phasellus et massa pede habitasse vel Curabitur et. Vivamus fringilla laoreet sit eu nisl Mauris ipsum congue neque.</p>', 1, 91, '2009-09-01 09:01:21', 42, '', '2009-09-04 12:16:52', 62, 0, '0000-00-00 00:00:00', '2009-09-01 09:01:21', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 8, '', 0, '*', ''),
(122, 238, 'Tincidunt vestibulum justo', '1231912225', '<img src="images/stories/demo/sport/football-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nis.</p>\r\n\r\n', '\r\n\r\n<p>Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nis.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>\r\n\r\n<p>Et Fusce ut Fusce a Pellentesque Curabitur arcu hendrerit lobortis quis. Et a convallis sed Morbi euismod elit in tincidunt elit penatibus. Urna dolor pede interdum malesuada Sed id Vestibulum hendrerit aliquam Vestibulum. Sem adipiscing tellus neque at fames Vivamus ullamcorper tellus adipiscing ligula. Tempus turpis pede Phasellus et massa pede habitasse vel Curabitur et. Vivamus fringilla laoreet sit eu nisl Mauris ipsum congue neque.</p>', 1, 91, '2009-09-01 09:01:21', 42, '', '2009-09-04 12:17:55', 62, 0, '0000-00-00 00:00:00', '2009-09-01 09:01:21', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 1, '', 0, '*', ''),
(123, 239, 'Congue mattis justo Fusce sed', 'congue-mattis-justo-fusce-sed', '<img src="images/stories/demo/sport/football-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut.</p>\r\n\r\n', '\r\n\r\n<p>Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nis.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>\r\n\r\n<p>Et Fusce ut Fusce a Pellentesque Curabitur arcu hendrerit lobortis quis. Et a convallis sed Morbi euismod elit in tincidunt elit penatibus. Urna dolor pede interdum malesuada Sed id Vestibulum hendrerit aliquam Vestibulum. Sem adipiscing tellus neque at fames Vivamus ullamcorper tellus adipiscing ligula. Tempus turpis pede Phasellus et massa pede habitasse vel Curabitur et. Vivamus fringilla laoreet sit eu nisl Mauris ipsum congue neque.</p>', 1, 91, '2009-09-01 09:01:21', 42, '', '2011-01-28 11:42:01', 42, 0, '0000-00-00 00:00:00', '2009-09-01 09:01:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(124, 241, 'Jonathan Agnew column ', 'jonathan-agnew-column', '<p><img class="caption" src="images/stories/demo/sport/cricket-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at.</p>\r\n', '\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt.</p>\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>', 1, 92, '2008-04-14 08:14:01', 42, '', '2011-09-01 07:40:27', 42, 42, '2013-08-05 01:53:59', '2008-04-14 08:14:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(125, 242, 'The true Aussie sporting spirit', '1214727741', '<img src="images/stories/demo/sport/cricket-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce.</p>\r\n\r\n', '\r\n\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt. </p>\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n\r\n<p>Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>', 1, 92, '2008-04-14 08:15:52', 42, '', '2009-09-04 12:50:33', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:15:52', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 0, '', 0, '*', ''),
(126, 243, 'Modi dismisses Steyn test reports ', '220229616', '<img src="images/stories/demo/sport/cricket-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus</p>\r\n\r\n', '\r\n\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt. </p>\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n\r\n<p>Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>\r\n\r\n<p>A quis felis dictumst justo eleifend laoreet vel pellentesque eros ante. Nibh metus vel diam et consectetuer est condimentum volutpat pulvinar fermentum. Pellentesque congue justo tincidunt nibh Lorem Aliquam Vestibulum laoreet sed quis. Malesuada interdum amet parturient cursus et et dui justo vel Aenean. Vitae consectetuer adipiscing nibh pede sollicitudin sed interdum risus Aliquam interdum. Risus vel sociis ut consequat in tempor tempus nunc.</p>', 1, 92, '2008-04-14 08:16:30', 42, '', '2009-09-04 12:48:59', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:16:30', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 2, '', 1, '*', ''),
(127, 244, 'England stars offer summer', 'england-stars-offer-summer', '<img src="images/stories/demo/sport/cricket-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Et libero pretium accumsan convallis sapien elit orci tempus sed In. Nibh Praesent et eleifend Vivamus laoreet tortor metus habitant fames gravida.</p>\r\n\r\n', '\r\n\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla. </p>\r\n\r\n<p>Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 92, '2009-08-12 08:06:15', 42, '', '2011-01-28 11:47:28', 42, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 36, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(128, 245, 'Tortor pretium ipsum Maecenas', '2031285795', '<img src="images/stories/demo/sport/cricket-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Et libero pretium accumsan convallis sapien elit orci tempus sed In. Nibh Praesent et eleifend Vivamus laoreet tortor metus habitant fames gravida.</p>\r\n\r\n', '\r\n\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla. </p>\r\n\r\n<p>Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 92, '2009-08-12 08:06:15', 42, '', '2009-09-04 12:51:28', 62, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(129, 246, 'Nibh metus vel diam et consectetuer est', '913782202', '<img src="images/stories/demo/sport/cricket-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus</p>\r\n\r\n', '\r\n\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt. </p>\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n\r\n<p>Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>\r\n\r\n<p>A quis felis dictumst justo eleifend laoreet vel pellentesque eros ante. Nibh metus vel diam et consectetuer est condimentum volutpat pulvinar fermentum. Pellentesque congue justo tincidunt nibh Lorem Aliquam Vestibulum laoreet sed quis. Malesuada interdum amet parturient cursus et et dui justo vel Aenean. Vitae consectetuer adipiscing nibh pede sollicitudin sed interdum risus Aliquam interdum. Risus vel sociis ut consequat in tempor tempus nunc.</p>', 1, 92, '2008-04-14 08:16:30', 42, '', '2009-09-04 12:51:45', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:16:30', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(130, 247, 'Habitant lobortis vitae pretium vitae', 'habitant-lobortis-vitae-pretium-vitae', '<img src="images/stories/demo/sport/cricket-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce.</p>\r\n\r\n', '\r\n\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt. </p>\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n\r\n<p>Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>', 1, 92, '2008-04-14 08:15:52', 42, '', '2011-01-28 11:51:28', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:15:52', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(131, 248, 'Quisque odio adipiscing nullam', '1417134606', '<img src="images/stories/demo/sport/cricket-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption"/>\r\n\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at. </p>\r\n\r\n', '\r\n\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt. </p>\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>', 1, 92, '2008-04-14 08:14:01', 42, '', '2009-09-04 14:30:43', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:14:01', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 17, '', 0, '*', ''),
(132, 250, 'Russians Squeak Through Openers', '27299041', '<img src="images/stories/demo/sport/tennis-1.jpg" alt="Russians Squeak Through Openers" align="left" title="Russians Squeak Through Openers" class="caption" />\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. </p>\r\n\r\n', '\r\n\r\n<p>Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros. Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>\r\n\r\n<p>A quis felis dictumst justo eleifend laoreet vel pellentesque eros ante. Nibh metus vel diam et consectetuer est condimentum volutpat pulvinar fermentum. Pellentesque congue justo tincidunt nibh Lorem Aliquam Vestibulum laoreet sed quis. Malesuada interdum amet parturient cursus et et dui justo vel Aenean. Vitae consectetuer adipiscing nibh pede sollicitudin sed interdum risus Aliquam interdum. Risus vel sociis ut consequat in tempor tempus nunc.</p>\r\n\r\n<p>Fusce fringilla ut ante interdum velit et leo elit ligula pede. Mus malesuada pellentesque adipiscing Lorem est elit Lorem odio risus interdum. Nam tincidunt at cursus Curabitur Ut feugiat velit auctor eu Curabitur. Lobortis ac semper condimentum Vestibulum eget adipiscing Morbi parturient dignissim pretium. Sapien pede nunc neque Phasellus neque tempus auctor Sed at.</p>\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>', 1, 93, '2008-04-14 08:17:09', 42, '', '2009-09-04 12:36:16', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:17:09', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 4, '', 0, '*', ''),
(133, 251, 'Elena Baltacha\'s diary', 'elena-baltachas-diary', '<img src="images/stories/demo/sport/tennis-2.jpg" alt="Elena Baltacha\'s diary" align="left" title="Elena Baltacha\'s diary" class="caption" />\r\n\r\n<p>A quis felis dictumst justo eleifend laoreet vel pellentesque eros ante. Nibh metus vel diam et consectetuer est condimentum volutpat pulvinar fermentum. </p>\r\n\r\n', '\r\n<p>Pellentesque congue justo tincidunt nibh Lorem Aliquam Vestibulum laoreet sed quis. Malesuada interdum amet parturient cursus et et dui justo vel Aenean. Vitae consectetuer adipiscing nibh pede sollicitudin sed interdum risus Aliquam interdum. Risus vel sociis ut consequat in tempor tempus nunc.</p>\r\n\r\n<p>Fusce fringilla ut ante interdum velit et leo elit ligula pede. Mus malesuada pellentesque adipiscing Lorem est elit Lorem odio risus interdum. Nam tincidunt at cursus Curabitur Ut feugiat velit auctor eu Curabitur. Lobortis ac semper condimentum Vestibulum eget adipiscing Morbi parturient dignissim pretium. Sapien pede nunc neque Phasellus neque tempus auctor Sed at.</p>\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>', 1, 93, '2008-04-14 08:19:07', 42, '', '2011-01-28 11:47:12', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:19:07', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 7, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(134, 252, 'Murray eases through in Montreal ', '1033405739', '<img src="images/stories/demo/sport/tennis-3.jpg" alt="Murray eases through in Montreal " align="left" title="Murray eases through in Montreal " class="caption" />\r\n\r\n<p>Fusce fringilla ut ante interdum velit et leo elit ligula pede. Mus malesuada pellentesque adipiscing Lorem est elit Lorem odio risus interdum. </p>\r\n\r\n', '\r\n<p>Nam tincidunt at cursus Curabitur Ut feugiat velit auctor eu Curabitur. Lobortis ac semper condimentum Vestibulum eget adipiscing Morbi parturient dignissim pretium. Sapien pede nunc neque Phasellus neque tempus auctor Sed at.Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>\r\n\r\n<p>Et et nec Nulla semper elit sed morbi felis mauris nascetur. Sed ipsum cursus ut nibh magna condimentum ut nibh Pellentesque tortor. Nullam Phasellus cursus ullamcorper Vestibulum eros urna Curabitur ut libero turpis. Integer vel urna cursus Curabitur ac netus Nullam Duis nulla Vestibulum. Ut et at tincidunt interdum ipsum Lorem fringilla nunc urna dignissim. Curabitur hac nascetur In wisi purus Nulla urna dapibus risus convallis. Consectetuer Phasellus.</p>\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>', 1, 93, '2008-04-14 08:24:06', 42, '', '2009-09-04 12:35:10', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:24:06', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 58, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(135, 253, 'Consectetuer venenatis nulla', 'consectetuer-venenatis-nulla', '<img src="images/stories/demo/sport/tennis-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer accumsan pellentesque ligula a odio. Morbi Nam sit magna Curabitur ornare malesuada Nam commodo lacinia vitae. </p>\r\n\r\n', '\r\n\r\n<p>Pellentesque et interdum ante non eleifend pulvinar Aliquam dis Pellentesque laoreet. Fames eget id ligula Morbi scelerisque Quisque pede Sed nulla id. Habitasse et Aenean non dui sit eleifend Vestibulum libero eros Quisque. Laoreet porttitor sapien condimentum nulla accumsan consequat Nulla ut amet tristique. Vitae congue Phasellus tristique Mauris neque sed porttitor.</p>\r\n\r\n<p>In dolor fermentum nibh nulla convallis interdum Donec tincidunt Integer dis. Ac Phasellus Vivamus orci augue pulvinar consectetuer tortor orci quis Nam. Ac ut leo Phasellus gravida ut eros fermentum dapibus Vestibulum ullamcorper. Consectetuer venenatis nulla Nunc Morbi pretium penatibus Aenean velit malesuada pharetra. Curabitur interdum senectus semper cursus adipiscing eros et ac porttitor tincidunt. Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet.</p>\r\n\r\n<p>Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>', 1, 93, '2009-09-01 09:44:42', 42, '', '2011-01-28 11:42:39', 42, 0, '0000-00-00 00:00:00', '2009-09-01 09:44:42', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(136, 254, 'Fringilla Maecenas libero ut faucibus', 'fringilla-maecenas-libero-ut-faucibus', '<img src="images/stories/demo/sport/tennis-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Consectetuer venenatis nulla Nunc Morbi pretium penatibus Aenean velit malesuada pharetra. Curabitur interdum senectus semper cursus adipiscing eros et ac porttitor tincidunt. </p>\r\n\r\n', '\r\n\r\n<p>Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>', 1, 93, '2009-09-01 09:49:19', 42, '', '2011-01-28 11:51:00', 42, 0, '0000-00-00 00:00:00', '2009-09-01 09:49:19', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(137, 255, 'Ut id Quisque odio adipiscing', '424596484', '<img src="images/stories/demo/sport/tennis-7.jpg" alt="Ut id Quisque odio adipiscing" align="left" title="Ut id Quisque odio adipiscing" class="caption" />\r\n\r\n<p>Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros. Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>\r\n\r\n<p>A quis felis dictumst justo eleifend laoreet vel pellentesque eros ante. Nibh metus vel diam et consectetuer est condimentum volutpat pulvinar fermentum. Pellentesque congue justo tincidunt nibh Lorem Aliquam Vestibulum laoreet sed quis. Malesuada interdum amet parturient cursus et et dui justo vel Aenean. Vitae consectetuer adipiscing nibh pede sollicitudin sed interdum risus Aliquam interdum. Risus vel sociis ut consequat in tempor tempus nunc.</p>\r\n\r\n<p>Fusce fringilla ut ante interdum velit et leo elit ligula pede. Mus malesuada pellentesque adipiscing Lorem est elit Lorem odio risus interdum. Nam tincidunt at cursus Curabitur Ut feugiat velit auctor eu Curabitur. Lobortis ac semper condimentum Vestibulum eget adipiscing Morbi parturient dignissim pretium. Sapien pede nunc neque Phasellus neque tempus auctor Sed at.</p>\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>', 1, 93, '2008-04-14 08:17:09', 42, '', '2009-09-04 12:44:40', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:17:09', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 1, '*', ''),
(138, 256, 'Donec Curabitur consequat', 'donec-curabitur-consequat', '<img src="images/stories/demo/sport/tennis-6.jpg" alt="Donec Curabitur consequat" align="left" title="Donec Curabitur consequat" class="caption" />\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. </p>\r\n\r\n', '\r\n\r\n<p>Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros. Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>\r\n\r\n<p>A quis felis dictumst justo eleifend laoreet vel pellentesque eros ante. Nibh metus vel diam et consectetuer est condimentum volutpat pulvinar fermentum. Pellentesque congue justo tincidunt nibh Lorem Aliquam Vestibulum laoreet sed quis. Malesuada interdum amet parturient cursus et et dui justo vel Aenean. Vitae consectetuer adipiscing nibh pede sollicitudin sed interdum risus Aliquam interdum. Risus vel sociis ut consequat in tempor tempus nunc.</p>\r\n\r\n<p>Fusce fringilla ut ante interdum velit et leo elit ligula pede. Mus malesuada pellentesque adipiscing Lorem est elit Lorem odio risus interdum. Nam tincidunt at cursus Curabitur Ut feugiat velit auctor eu Curabitur. Lobortis ac semper condimentum Vestibulum eget adipiscing Morbi parturient dignissim pretium. Sapien pede nunc neque Phasellus neque tempus auctor Sed at.</p>\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>', 1, 93, '2008-04-14 08:17:09', 42, '', '2011-01-28 11:46:20', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:17:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(139, 257, 'Penatibus laoreet consectetuer', '1390503902', '<img src="images/stories/demo/sport/tennis-8.jpg" alt="Penatibus laoreet consectetuer" align="left" title="Penatibus laoreet consectetuer" class="caption" />\r\n\r\n<p>Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros. Et quis mauris pretium interdum felis velit sed et a et.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros. Et quis mauris pretium interdum felis velit sed et a et. Aenean tempus pede Pellentesque pulvinar Sed congue eget hac Aenean laoreet. Penatibus laoreet consectetuer tempus Ut penatibus in ante ac ac consectetuer. Netus elit Morbi et ac Nam parturient risus Cras nulla dolor. Pretium gravida Morbi consectetuer elit Quisque sodales est congue interdum Curabitur. Tellus nisl auctor Morbi fringilla id at consectetuer.</p>\r\n\r\n<p>A quis felis dictumst justo eleifend laoreet vel pellentesque eros ante. Nibh metus vel diam et consectetuer est condimentum volutpat pulvinar fermentum. Pellentesque congue justo tincidunt nibh Lorem Aliquam Vestibulum laoreet sed quis. Malesuada interdum amet parturient cursus et et dui justo vel Aenean. Vitae consectetuer adipiscing nibh pede sollicitudin sed interdum risus Aliquam interdum. Risus vel sociis ut consequat in tempor tempus nunc.</p>\r\n\r\n<p>Fusce fringilla ut ante interdum velit et leo elit ligula pede. Mus malesuada pellentesque adipiscing Lorem est elit Lorem odio risus interdum. Nam tincidunt at cursus Curabitur Ut feugiat velit auctor eu Curabitur. Lobortis ac semper condimentum Vestibulum eget adipiscing Morbi parturient dignissim pretium. Sapien pede nunc neque Phasellus neque tempus auctor Sed at.</p>\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>', 1, 93, '2008-04-14 08:17:09', 42, '', '2009-09-04 12:45:31', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:17:09', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(140, 259, 'Crash ends Raikkonen\'s WRC debut ', 'crash-ends-raikkonens-wrc-debut', '<img src="images/stories/demo/sport/motorsport-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Et et nec Nulla semper elit sed morbi felis mauris nascetur. Sed ipsum cursus ut nibh magna condimentum ut nibh Pellentesque tortor. Nullam Phasellus cursus ullamcorper Vestibulum eros urna Curabitur ut libero turpis. Integer vel urna cursus Curabitur ac netus Nullam Duis nulla Vestibulum.</p>\r\n\r\n', '\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc. </p>\r\n\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 94, '2008-04-14 08:38:01', 42, '', '2011-01-28 11:43:10', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:38:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(141, 260, 'Matt Roberts\' MotoGP column ', '799201696', '<img src="images/stories/demo/sport/motorsport-2.jpg" alt="Matt Roberts\' MotoGP column " align="left" title="Matt Roberts\' MotoGP column " class="caption" />\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur.</p>\r\n\r\n', '\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>', 1, 94, '2008-04-14 08:38:21', 42, '', '2009-09-04 12:47:46', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:38:21', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 0, '', 0, '*', ''),
(142, 261, 'Vestibulum Nullam pellentesque', '280927886', '<img src="images/stories/demo/sport/motorsport-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. </p>\r\n\r\n', '\r\n<p>Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>\r\n\r\n<p>Et et nec Nulla semper elit sed morbi felis mauris nascetur. Sed ipsum cursus ut nibh magna condimentum ut nibh Pellentesque tortor. Nullam Phasellus cursus ullamcorper Vestibulum eros urna Curabitur ut libero turpis. Integer vel urna cursus Curabitur ac netus Nullam Duis nulla Vestibulum. Ut et at tincidunt interdum ipsum Lorem fringilla nunc urna dignissim. Curabitur hac nascetur In wisi purus Nulla urna dapibus risus convallis. Consectetuer Phasellus.</p>\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>', 1, 94, '2008-04-14 08:39:13', 42, '', '2009-08-31 08:22:27', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:39:13', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 2, '', 0, '*', ''),
(143, 262, 'Vestibulum Nullam pellentesque', '1015627497', '<img src="images/stories/demo/sport/motorsport-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sit Vestibulum Nullam pellentesque ac Aenean ac urna pellentesque nunc orci. Vitae Curabitur interdum platea pede Quisque dui semper mauris non elit. Rutrum Lorem Suspendisse auctor arcu interdum odio est et nulla sodales. </p>\r\n\r\n', '\r\n<p>Vestibulum ante senectus adipiscing quam neque amet tortor id ipsum quis. Pellentesque Vivamus tempus laoreet Phasellus tincidunt Curabitur felis elit convallis tellus. Platea dui platea dui id Ut.</p>\r\n\r\n<p>Et et nec Nulla semper elit sed morbi felis mauris nascetur. Sed ipsum cursus ut nibh magna condimentum ut nibh Pellentesque tortor. Nullam Phasellus cursus ullamcorper Vestibulum eros urna Curabitur ut libero turpis. Integer vel urna cursus Curabitur ac netus Nullam Duis nulla Vestibulum. Ut et at tincidunt interdum ipsum Lorem fringilla nunc urna dignissim. Curabitur hac nascetur In wisi purus Nulla urna dapibus risus convallis. Consectetuer Phasellus.</p>\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>', 1, 94, '2008-04-14 08:39:13', 42, '', '2009-09-04 12:26:02', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:39:13', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(144, 263, 'Matt Roberts\' MotoGP column ', '595858640', '<img src="images/stories/demo/sport/motorsport-5.jpg" alt="Matt Roberts\' MotoGP column " align="left" title="Matt Roberts\' MotoGP column " class="caption" />\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>\r\n\r\n', '\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>', 1, 94, '2008-04-14 08:38:21', 42, '', '2009-09-04 12:26:10', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:38:21', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 1, '*', ''),
(145, 264, 'Pellentesque Morbi vel metus Vestibulum ', '507908079', '<img src="images/stories/demo/sport/motorsport-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Et et nec Nulla semper elit sed morbi felis mauris nascetur. Sed ipsum cursus ut nibh magna condimentum ut nibh Pellentesque tortor. Nullam Phasellus cursus ullamcorper Vestibulum eros urna Curabitur ut libero turpis. Integer vel urna cursus Curabitur ac netus Nullam Duis nulla Vestibulum.</p>\r\n\r\n', '\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer Aenean Nulla est nisl cursus. Eget enim eget et nunc urna libero augue convallis lacinia gravida. Et eros quis eget et vel turpis est nec ultrices Aliquam. Felis quam id vitae condimentum commodo Vivamus nascetur Suspendisse pellentesque Nunc. Nulla Mauris lacus at congue sem Nulla interdum sollicitudin dictumst nunc. Dolor ac Vestibulum.</p>\r\n\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed. Felis Nullam scelerisque volutpat Morbi Curabitur enim Nam nunc fames Phasellus. Fringilla quis lorem Nam facilisi Phasellus Nam tempus diam morbi tellus. Habitant.</p>\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>', 1, 94, '2008-04-14 08:38:01', 42, '', '2009-09-04 12:40:46', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:38:01', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 3, '', 0, '*', ''),
(146, 265, 'Dignissim Nam Nam ligula amet', 'dignissim-nam-nam-ligula-amet', '<img src="images/stories/demo/sport/motorsport-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Et et nec Nulla semper elit sed morbi felis mauris nascetur. Sed ipsum cursus ut nibh magna condimentum ut nibh Pellentesque tortor. Nullam Phasellus cursus ullamcorper Vestibulum eros urna Curabitur ut libero turpis. Integer vel urna cursus Curabitur ac netus Nullam Duis nulla Vestibulum.</p>\r\n\r\n', '\r\n\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus orci Vivamus Curabitur. In nec suscipit metus eros mauris eu ipsum orci sagittis pede. Curabitur lorem.</p>\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>', 1, 94, '2008-04-14 08:38:01', 42, '', '2011-01-28 11:45:02', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:38:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(147, 266, 'In nec suscipit metus eros mauris eu ipsum', 'in-nec-suscipit-metus-eros-mauris-eu-ipsum', '<p><img class="caption" src="images/stories/demo/sport/motorsport-8.jpg" border="0" alt="Matt Roberts\' MotoGP column " title="Matt Roberts\' MotoGP column " align="left" /></p>\r\n<p>Dignissim Nam Nam ligula amet Donec convallis urna pede tortor laoreet. Sed at nunc sed dui vitae semper enim Praesent mauris Nulla. At sollicitudin nibh velit vitae est Lorem dolor Aenean et egestas. Vestibulum Cum ligula lacus congue convallis tincidunt cursus.</p>\r\n', '\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>', 1, 94, '2008-04-14 08:38:21', 42, '', '2011-09-01 07:32:41', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:38:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(148, 268, 'Glorious Goodwood photos ', 'glorious-goodwood-photos', '<img src="images/stories/demo/sport/hr-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. </p>\r\n\r\n', '\r\n<p>Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>\r\n\r\n<p>Vestibulum eu Nam neque libero eros Nunc dui In in tellus. Tellus id tincidunt Duis tristique id Curabitur ridiculus interdum ante ipsum. Nibh Nam condimentum mus eu consectetuer tellus consequat Vestibulum quis turpis. Faucibus vel risus Nullam mollis iaculis Pellentesque at pretium tincidunt pharetra. Et Vestibulum id nibh interdum a dis lacinia fringilla id tincidunt. Sem interdum Curabitur urna eu fringilla orci suscipit.</p>', 1, 95, '2008-04-14 08:47:04', 42, '', '2011-01-28 11:51:20', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:47:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 9, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(149, 269, 'Racing - live!', '2055422040', '<img src="images/stories/demo/sport/hr-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor. </p>\r\n\r\n', '\r\n<p>Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut.</p>\r\n\r\n<p>Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>\r\n\r\n<p>Vestibulum eu Nam neque libero eros Nunc dui In in tellus. Tellus id tincidunt Duis tristique id Curabitur ridiculus interdum ante ipsum. Nibh Nam condimentum mus eu consectetuer tellus consequat Vestibulum quis turpis. Faucibus vel risus Nullam mollis iaculis Pellentesque at pretium tincidunt pharetra. Et Vestibulum id nibh interdum a dis lacinia fringilla id tincidunt. Sem interdum Curabitur urna eu fringilla orci suscipit.</p>\r\n\r\n<p>Nibh Curabitur quis tincidunt Curabitur nunc nisl porttitor quis turpis sit. Consequat et sagittis id commodo urna Lorem ut dictumst Morbi Vestibulum. Condimentum cursus tincidunt dictumst Nulla Maecenas Phasellus nec cursus malesuada porta. Parturient massa Nulla adipiscing leo Suspendisse ac tincidunt penatibus mi Phasellus. Magna id condimentum nibh consectetuer non enim ac pulvinar leo quam. Id et pretium tincidunt.</p>', 1, 95, '2008-04-14 08:48:08', 42, '', '2009-08-31 08:21:37', 62, 0, '0000-00-00 00:00:00', '2008-04-14 08:48:08', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 16, '', 0, '*', ''),
(150, 270, 'India Closes Torch Relay to Spectators', 'india-closes-torch-relay-to-spectators', '<p><img class="caption" src="images/stories/demo/sport/hr-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed.</p>\r\n', '\r\n<p>Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit. <a class="rss" href="#" title="Sample link">Nam neque libero eros Nunc dui</a> <a class="video" href="#" title="Sample link">Video</a></p>\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>\r\n<p>Vestibulum eu Nam neque libero eros Nunc dui In in tellus. Tellus id tincidunt Duis tristique id Curabitur ridiculus interdum ante ipsum. Nibh Nam condimentum mus eu consectetuer tellus consequat Vestibulum quis turpis. Faucibus vel risus Nullam mollis iaculis Pellentesque at pretium tincidunt pharetra. Et Vestibulum id nibh interdum a dis lacinia fringilla id tincidunt. Sem interdum Curabitur urna eu fringilla orci suscipit.</p>\r\n<p>Nibh Curabitur quis tincidunt Curabitur nunc nisl porttitor quis turpis sit. Consequat et sagittis id commodo urna Lorem ut dictumst Morbi Vestibulum. Condimentum cursus tincidunt dictumst Nulla Maecenas Phasellus nec cursus malesuada porta. Parturient massa Nulla adipiscing leo Suspendisse ac tincidunt penatibus mi Phasellus. Magna id condimentum nibh consectetuer non enim ac pulvinar leo quam. Id et pretium tincidunt.</p>\r\n<p>Lorem ac neque ac pretium tellus condimentum elit at molestie sapien. Montes hendrerit commodo nibh porttitor a habitant netus eget adipiscing felis. Pede non eget convallis laoreet diam ullamcorper nunc Nulla ipsum id. Justo orci tellus justo nibh tincidunt congue pellentesque felis nec vestibulum. Sed dui cursus velit pretium Curabitur elit semper Nulla nibh Nullam. A Donec cursus nibh aliquet nisl Cum.</p>', 1, 95, '2008-04-14 08:49:24', 42, '', '2011-09-01 07:33:15', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:49:24', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 14, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(151, 271, 'Enim sollicitudin habitasse', 'enim-sollicitudin-habitasse', '<img src="images/stories/demo/sport/horse-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed.</p>\r\n\r\n', '\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>', 1, 95, '2009-09-04 12:19:33', 42, '', '2011-01-28 11:48:01', 42, 0, '0000-00-00 00:00:00', '2009-09-04 12:19:33', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(152, 272, ' Morbi faucibus Sed Vivamus odio semper', 'morbi-faucibus-sed-vivamus-odio-semper', '<img src="images/stories/demo/sport/horse-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed.</p>\r\n\r\n', '\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>', 1, 95, '2009-09-04 12:21:57', 42, '', '2011-01-28 11:27:00', 42, 42, '2013-08-05 02:19:03', '2009-09-04 12:21:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(153, 273, 'Dignissim sagittis tristique', 'dignissim-sagittis-tristique', '<img src="images/stories/demo/sport/horse-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue.</p>\r\n\r\n', '\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>', 1, 95, '2009-09-04 12:21:57', 42, '', '2011-01-28 11:45:09', 42, 0, '0000-00-00 00:00:00', '2009-09-04 12:21:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(154, 274, 'Tortor est Aenean porttitor', '101159007', '<img src="images/stories/demo/sport/horse-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue.</p>\r\n\r\n', '\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>', 1, 95, '2009-09-04 12:21:57', 42, '', '2009-09-04 12:25:51', 62, 0, '0000-00-00 00:00:00', '2009-09-04 12:21:57', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(155, 275, 'Phasellus Curabitur euismod tincidunt', 'phasellus-curabitur-euismod-tincidunt', '<p><img class="caption" src="images/stories/demo/sport/horse-6.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur.</p>\r\n', '\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>', 1, 95, '2009-09-04 12:21:57', 42, '', '2011-09-01 08:07:33', 42, 0, '0000-00-00 00:00:00', '2009-09-04 12:21:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(156, 276, 'Interdum gravida massa quis ac', '1116499731', '<img src="images/stories/demo/sport/horse-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue.</p>\r\n\r\n', '\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>', -2, 95, '2009-09-04 12:21:57', 42, '', '2009-09-04 12:24:28', 62, 0, '0000-00-00 00:00:00', '2009-09-04 12:21:57', '0000-00-00 00:00:00', '', '', '', 1, 0, '', '', 1, 0, '', 0, '*', ''),
(157, 278, 'In id metus laoreet dignissim vel', 'in-id-metus-laoreet-dignissim-vel', '<p><img class="caption" src="images/stories/demo/sport/box-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar</p>\r\n<ul class="none-padding">\r\n<li><a class="rss" href="#" title="Sample image">Cursus senectus aliquet pretium at</a></li>\r\n<li><a class="rss" href="#" title="Sample image">Tristique hac ullamcorper adipiscing et Donec.</a></li>\r\n</ul>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 96, '2008-04-16 02:26:18', 42, '', '2011-09-01 07:27:23', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(158, 279, 'Vivamus lacinia velit velit amet', '479781770', '<img src="images/stories/demo/sport/box-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer ac Vivamus Aliquam id aliquam. Orci cursus interdum pulvinar sociis vestibulum sed vestibulum est condimentum ac. Ut adipiscing Morbi rhoncus vitae id convallis Proin Lorem Curabitur dolor. </p>\r\n\r\n', '\r\n\r\n<p>Quisque eget dapibus Quisque volutpat Vivamus lacinia velit velit amet Vivamus. Sed ante elit tellus et gravida quis urna nulla Donec Sed. Urna eu urna. Et Aliquam pretium faucibus sit magna at Sed cursus sociis at. Consectetuer mattis Lorem Nam Sed pellentesque ornare odio sit lorem sit. Morbi nulla non Curabitur sed Vestibulum nec augue tincidunt vitae condimentum. Dui Phasellus Nam pretium adipiscing dui et nec vel suscipit sollicitudin. Vestibulum scelerisque tellus ut nec a nec In et tincidunt condimentum. Ut.</p>\r\n\r\n<p>Sed id leo et vitae Nam tortor quis tortor nibh Sed. Porttitor lobortis Donec nisl turpis vitae amet ut Sed dolor Nullam. Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>', 1, 96, '2008-04-16 02:30:09', 42, '', '2009-08-31 08:20:28', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 0, '', 0, '*', ''),
(159, 280, 'A elit consequat interdum libero', 'a-elit-consequat-interdum-libero', '<img align="left" src="images/stories/demo/sport/box-1.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. </p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 96, '2008-04-16 02:35:58', 42, '', '2011-01-28 11:30:30', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(160, 281, 'Justo ligula nonummy ante nibh', 'justo-ligula-nonummy-ante-nibh', '<p><img class="caption" src="images/stories/demo/sport/box-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Consectetuer venenatis nulla Nunc Morbi pretium penatibus Aenean velit malesuada pharetra. Curabitur interdum senectus semper cursus adipiscing eros et ac porttitor tincidunt.</p>\r\n', '\r\n<p>Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>', 1, 96, '2009-09-01 09:31:27', 42, '', '2011-09-01 08:06:33', 42, 0, '0000-00-00 00:00:00', '2009-09-01 09:31:27', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(161, 282, 'Muscular African American Boxer', '595198955', '<img src="images/stories/demo/sport/box-5.jpg" alt="Boxer" align="left" title="Muscular African" class="caption" />\r\n\r\n<p>Consectetuer venenatis nulla Nunc Morbi pretium penatibus Aenean velit malesuada pharetra. Curabitur interdum senectus semper cursus adipiscing eros et ac porttitor tincidunt. </p>\r\n\r\n', '\r\n\r\n<p>Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet.Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>\r\n\r\n<p>Et Fusce ut Fusce a Pellentesque Curabitur arcu hendrerit lobortis quis. Et a convallis sed Morbi euismod elit in tincidunt elit penatibus. Urna dolor pede interdum malesuada Sed id Vestibulum hendrerit aliquam Vestibulum. Sem adipiscing tellus neque at fames Vivamus ullamcorper tellus adipiscing ligula. Tempus turpis pede Phasellus et massa pede habitasse vel Curabitur et. Vivamus fringilla laoreet sit eu nisl Mauris ipsum congue neque.</p>', 1, 96, '2009-09-01 09:37:35', 42, '', '2009-09-04 12:49:01', 62, 0, '0000-00-00 00:00:00', '2009-09-01 09:37:35', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(162, 283, 'Metus purus Vestibulum ac ut', '111287977', '<img src="images/stories/demo/sport/box-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n', '\r\n\r\n<p> Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>', 1, 96, '2009-09-01 09:31:27', 42, '', '2009-09-04 12:51:53', 62, 0, '0000-00-00 00:00:00', '2009-09-01 09:31:27', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(163, 284, 'Platea fringilla volutpat', '870155947', '<img src="images/stories/demo/sport/box-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis.</p>\r\n\r\n', '\r\n\r\n<p> Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>', 1, 96, '2009-09-01 09:31:27', 42, '', '2009-09-04 12:51:23', 62, 0, '0000-00-00 00:00:00', '2009-09-01 09:31:27', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 1, '', 0, '*', ''),
(164, 285, 'Tincidunt vestibulum justo pulvinar', '1765349972', '<img src="images/stories/demo/sport/box-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est.</p>\r\n\r\n', '\r\n\r\n<p> Dictumst et orci Nulla faucibus egestas risus mauris interdum Phasellus Nunc. Morbi urna Vestibulum Suspendisse risus orci metus accumsan id wisi est. Metus purus Vestibulum ac ut vitae Donec ullamcorper mus penatibus In. Pede Donec amet. Risus tempus lacinia pharetra justo magna nibh commodo ac vitae Lorem. Congue mattis justo Fusce sed rutrum mattis iaculis nisl nibh Nunc. At ut Nulla at Curabitur nisl Morbi lorem id congue neque. Platea fringilla volutpat malesuada laoreet Integer euismod et tempus in elit. Justo netus non consequat at Curabitur dictum mauris mauris.</p>\r\n\r\n<p>Tincidunt vestibulum justo pulvinar Vivamus eleifend mus Phasellus mi pretium est. Pretium pellentesque vitae nibh In adipiscing egestas lacus tempus molestie quis. Volutpat euismod tincidunt odio Aenean cursus ornare lorem consequat dolor pharetra. Vestibulum Duis pellentesque et laoreet vitae dapibus dui feugiat Aliquam natoque. Lacinia justo porttitor nibh nec pede dolor magnis turpis nunc mauris. Amet elit.</p>\r\n\r\n<p>Justo ligula nonummy ante nibh Duis sem egestas volutpat sagittis at. Est habitasse tempor quis Curabitur wisi dictumst orci laoreet Curabitur ut. Sapien scelerisque orci sit id tempor ac nibh mollis pretium justo. Gravida mauris turpis lacus sit pretium iaculis feugiat semper dui Sed. Mollis orci in nec gravida aliquam felis condimentum platea et ultrices. Arcu tincidunt venenatis ac.</p>\r\n\r\n<p>Facilisis tristique at wisi Donec fermentum Integer Nulla Vestibulum nulla nec. In Morbi dis elit mauris felis pede Lorem habitasse platea porttitor. Sapien metus orci penatibus Sed nulla semper Curabitur tellus odio nulla. Sed Morbi dolor Quisque ut velit In massa sit sed id. Platea et metus mus Curabitur Sed et turpis amet.</p>\r\n\r\n<p>Sociis sit urna et quis enim wisi nisl magna tellus vel. Tincidunt at eros ut dictum sed Curabitur Curabitur In lacus porta. Natoque ut enim nec convallis platea egestas enim Curabitur tempus Proin. Semper tempus gravida nulla laoreet Donec Suspendisse semper velit Proin Nunc. Nam tristique quis sed ut Nulla nibh Morbi malesuada Curabitur risus. Tincidunt quis orci a id Sed auctor Aenean augue sociis justo. Tempor.</p>\r\n\r\n<p>Fringilla Maecenas libero ut faucibus interdum volutpat eros elit Nunc et. Montes non nunc sollicitudin pellentesque Curabitur leo lobortis dolor eu penatibus. Curabitur Nulla consectetuer Phasellus mus Nulla nunc venenatis in elit Nam. Vivamus mi vitae laoreet et at ipsum a odio dis Aliquam. Ipsum massa tellus eu ut pede eget porttitor Morbi sit vitae. In tincidunt justo metus.</p>', 1, 96, '2009-09-01 09:31:27', 42, '', '2009-09-04 12:51:01', 62, 0, '0000-00-00 00:00:00', '2009-09-01 09:31:27', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(165, 288, 'Sed id leo et vitae', 'sed-id-leo-et-vitae', '<p><img class="caption" src="images/stories/demo/artist/art-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer ac Vivamus Aliquam id aliquam. Orci cursus interdum pulvinar sociis vestibulum sed vestibulum est condimentum ac.</p>\r\n', '\r\n<p>Ut adipiscing Morbi rhoncus vitae id convallis Proin Lorem Curabitur dolor. Quisque eget dapibus Quisque volutpat Vivamus lacinia velit velit amet Vivamus. Sed ante elit tellus et gravida quis urna nulla Donec Sed. Urna eu urna. Et Aliquam pretium faucibus sit magna at Sed cursus sociis at. Consectetuer mattis Lorem Nam Sed pellentesque ornare odio sit lorem sit. Morbi nulla non Curabitur sed Vestibulum nec augue tincidunt vitae condimentum. Dui Phasellus Nam pretium adipiscing dui et nec vel suscipit sollicitudin. Vestibulum scelerisque tellus ut nec a nec In et tincidunt condimentum. Ut.</p>\r\n<p>Sed id leo et vitae Nam tortor quis tortor nibh Sed. Porttitor lobortis Donec nisl turpis vitae amet ut Sed dolor Nullam. Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>', 1, 98, '2008-04-16 02:15:40', 42, '', '2013-07-30 08:59:48', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:15:40', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 8, '', '', 1, 1, '{"tags":[3,5,6],"robots":"","author":"","rights":"","xreference":""}', 1, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(166, 289, 'Spoken word  ', 'spoken-word', '<p><img class="caption" src="images/stories/demo/artist/art-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Et Aliquam pretium faucibus sit magna at Sed cursus sociis at. Consectetuer mattis Lorem Nam Sed pellentesque ornare odio sit lorem sit.</p>\r\n', '\r\n<p>Morbi nulla non Curabitur sed Vestibulum nec augue tincidunt vitae condimentum. Dui Phasellus Nam pretium adipiscing dui et nec vel suscipit sollicitudin. Vestibulum scelerisque tellus ut nec a nec In et tincidunt condimentum. Ut. Sed id leo et vitae Nam tortor quis tortor nibh Sed. Porttitor lobortis Donec nisl turpis vitae amet ut Sed dolor Nullam. Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>', 1, 98, '2008-04-16 02:17:10', 42, '', '2011-09-01 06:55:13', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:17:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(167, 290, 'Plinth moment for Booker authors', 'plinth-moment-for-booker-authors', '<p><img class="caption" src="images/stories/demo/artist/art-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Sed id leo et vitae Nam tortor quis tortor nibh Sed. Porttitor lobortis Donec nisl turpis vitae amet ut Sed dolor Nullam.</p>\r\n', '\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p><img class="caption" src="images/stories/demo/artist/art-1.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>', 1, 98, '2008-04-16 02:17:48', 42, '', '2011-09-01 06:53:46', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:17:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 21, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(168, 291, 'Consectetuer consequat pretium ', 'consectetuer-consequat-pretium', '<img src="images/stories/demo/artist/art-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n', '\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<img src="images/stories/demo/artist/art-1.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n<p>Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>', 1, 98, '2008-04-16 02:17:48', 42, '', '2011-01-28 11:42:26', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:17:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(169, 292, 'Egestas Phasellus leo porttitor', 'egestas-phasellus-leo-porttitor', '<img src="images/stories/demo/artist/art-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. </p>\r\n\r\n', '\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<img src="images/stories/demo/artist/art-1.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n<p>Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>', 1, 98, '2008-04-16 02:17:48', 42, '', '2011-01-28 11:46:42', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:17:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(170, 293, 'Ultrices semper sapien odio', 'ultrices-semper-sapien-odio', '<p><img class="caption" src="images/stories/demo/artist/art-6.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus./p&gt;</p>\r\n', '\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p><img class="caption" src="images/stories/demo/artist/art-1.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>', 1, 98, '2008-04-16 02:17:48', 42, '', '2011-09-01 06:55:51', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:17:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(171, 294, 'Dolor dapibus Phasellus', 'dolor-dapibus-phasellus', '<img src="images/stories/demo/artist/art-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. </p>\r\n\r\n', '\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<img src="images/stories/demo/artist/art-1.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n<p>Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>', 1, 98, '2008-04-16 02:17:48', 42, '', '2011-01-28 11:45:35', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:17:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(172, 295, 'Sed tempus pretium pretium', 'sed-tempus-pretium-pretium', '<p><img class="caption" src="images/stories/demo/artist/art-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue.</p>\r\n', '\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p><img class="caption" src="images/stories/demo/artist/art-1.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>', 1, 98, '2008-04-16 02:17:48', 42, '', '2011-09-01 06:55:04', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:17:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(173, 297, 'Egestas Phasellus leo porttitor', 'egestas-phasellus-leo-porttitor', '<img src="images/stories/demo/artist/architecture-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n', '\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>', 1, 99, '2008-04-16 02:18:20', 42, '', '2011-01-28 11:46:50', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:18:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(174, 298, 'Nec justo Ut et at risus Nam', 'nec-justo-ut-et-at-risus-nam', '<p><img class="caption" src="images/stories/demo/artist/architecture-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n', '\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>', 1, 99, '2008-04-16 02:18:45', 42, '', '2011-09-01 06:56:30', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:18:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(175, 299, 'Quam ligula Mauris ac a et morbi eu Vestibulum', 'quam-ligula-mauris-ac-a-et-morbi-eu-vestibulum', '<p><img class="caption" src="images/stories/demo/artist/architecture-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam.</p>\r\n', '\r\n<p>Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus. Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>', 1, 99, '2008-04-16 02:19:30', 42, '', '2011-09-01 06:58:04', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:19:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 922, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(176, 300, 'Pellentesque felis mollis', 'pellentesque-felis-mollis', '<p><img class="caption" src="images/stories/demo/artist/architecture-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor.</p>\r\n', '\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus. Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>', 1, 99, '2008-04-16 02:19:30', 42, '', '2011-09-01 06:56:16', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:19:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(177, 301, 'Nec justo Ut et at risus', 'nec-justo-ut-et-at-risus', '<p><img class="caption" src="images/stories/demo/artist/architecture-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis.</p>\r\n', '\r\n<p>Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus. Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>', 1, 99, '2008-04-16 02:19:30', 42, '', '2011-09-01 06:56:07', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:19:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(178, 302, 'Latest Joomla 3.0 template release', 'joomla-news-magazine-template', '<p><img class="caption" src="images/stories/demo/artist/architecture-6.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer.</p>\r\n', '\r\n<p>Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus. Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>', 1, 99, '2008-04-16 02:19:30', 42, '', '2012-02-10 02:54:18', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:19:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 4, 3, 'Joomla 3.0 News Template, Joomla 3.0 Magazine Template', 'Experience the differences on Magazine here with Teline Joomlart 2.5 Template', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(179, 303, 'Feugiat auctor et eros Integer', 'feugiat-auctor-et-eros-integer', '<img src="images/stories/demo/artist/architecture-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris.</p>\r\n\r\n', '\r\n<p>Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus. Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>', 1, 99, '2008-04-16 02:19:30', 42, '', '2011-01-28 11:50:07', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:19:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(180, 304, 'Sapien Nam eleifend sed pellentesque', 'sapien-nam-eleifend-sed-pellentesque', '<p><img class="caption" src="images/stories/demo/artist/architecture-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus.</p>\r\n', '\r\n<p>Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus. Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>', 1, 99, '2008-04-16 02:19:30', 42, '', '2011-09-01 06:58:13', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:19:30', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(181, 306, 'Curabitur est at id ut Sed urna', 'curabitur-est-at-id-ut-sed-urna', '<img src="images/stories/demo/artist/design-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus.</p>\r\n\r\n', '\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 100, '2008-04-16 02:19:56', 42, '', '2011-01-28 11:44:14', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:19:56', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(182, 307, 'Curabitur convallis laoreet', 'curabitur-convallis-laoreet', '<img src="images/stories/demo/artist/design-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/artist/design-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 100, '2008-04-16 02:20:34', 42, '', '2011-01-28 11:43:58', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:20:34', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 24, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(183, 308, 'Praesent Aenean Phasellus', 'praesent-aenean-phasellus', '<p><img class="caption" src="images/stories/demo/artist/design-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. <a href="#" title="Sample link">Est cursus fermentum venenatis</a> Curabitur lobortis Fusce lobortis convallis eros dictumst. At commodo hendrerit Vestibulum tincidunt dui.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 100, '2008-04-16 02:20:59', 42, '', '2011-09-01 06:58:36', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:20:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(184, 309, 'Cum mauris justo eros Donec Nulla', 'cum-mauris-justo-eros-donec-nulla', '<img src="images/stories/demo/artist/design-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum.</p>\r\n\r\n', '\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. <a href="#" title="Sample link">Est cursus fermentum venenatis</a> Curabitur lobortis Fusce lobortis convallis eros dictumst. At commodo hendrerit Vestibulum tincidunt dui.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 100, '2008-04-16 02:20:59', 42, '', '2011-01-28 11:43:34', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:20:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(185, 310, 'Enim montes parturient', 'enim-montes-parturient', '<img src="images/stories/demo/artist/design-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at.</p>\r\n\r\n', '\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. <a href="#" title="Sample link">Est cursus fermentum venenatis</a> Curabitur lobortis Fusce lobortis convallis eros dictumst. At commodo hendrerit Vestibulum tincidunt dui.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 100, '2008-04-16 02:20:59', 42, '', '2011-01-28 11:47:46', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:20:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(186, 311, 'Aenean pharetra faucibus eu', 'aenean-pharetra-faucibus-eu', '<img src="images/stories/demo/artist/design-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et.</p>\r\n\r\n', '\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. <a href="#" title="Sample link">Est cursus fermentum venenatis</a> Curabitur lobortis Fusce lobortis convallis eros dictumst. At commodo hendrerit Vestibulum tincidunt dui.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 100, '2008-04-16 02:20:59', 42, '', '2011-01-28 11:31:13', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:20:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(187, 312, 'Aliquet egestas aliquam vel', 'aliquet-egestas-aliquam-vel', '<img src="images/stories/demo/artist/design-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla.</p>\r\n\r\n', '\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. <a href="#" title="Sample link">Est cursus fermentum venenatis</a> Curabitur lobortis Fusce lobortis convallis eros dictumst. At commodo hendrerit Vestibulum tincidunt dui.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 100, '2008-04-16 02:20:59', 42, '', '2011-01-28 11:35:01', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:20:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(188, 313, 'Nunc Cras tincidunt mi vestibulum', 'nunc-cras-tincidunt-mi-vestibulum', '<p><img class="caption" src="images/stories/demo/artist/design-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. <a href="#" title="Sample link">Est cursus fermentum venenatis</a> Curabitur lobortis Fusce lobortis convallis eros dictumst. At commodo hendrerit Vestibulum tincidunt dui.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 100, '2008-04-16 02:20:59', 42, '', '2011-09-01 06:58:28', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:20:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(189, 315, 'Vitae tempus eget at lorem sapien', 'vitae-tempus-eget-at-lorem-sapien', '<p><img class="caption" src="images/stories/demo/artist/photography-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. N</p>\r\n', '\r\n<p>ibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>\r\n<p>Elit Nullam pellentesque vitae Nulla eget Sed eget sed adipiscing accumsan. Tincidunt felis non amet et eu Nulla egestas cursus accumsan condimentum. Tincidunt accumsan tincidunt dolor pellentesque accumsan Nullam convallis egestas nunc quis. Mauris Suspendisse at pretium ac Aenean faucibus Morbi convallis pharetra et. Sed ut sed Vestibulum ut elit congue convallis massa ante consectetuer. Curabitur non Phasellus cursus et Vestibulum enim lorem.</p>', 1, 101, '2008-04-16 02:25:12', 42, '', '2011-09-01 06:59:41', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:25:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(190, 316, 'Integer nisl Pellentesque', 'integer-nisl-pellentesque', '<p><img class="caption" src="images/stories/demo/artist/photography-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 101, '2008-04-16 02:25:40', 42, '', '2011-09-01 06:58:52', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:25:40', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(191, 317, 'Semper accumsan Integer', 'semper-accumsan-integer', '<p><img class="caption" src="images/stories/demo/artist/photography-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar</p>\r\n<ul class="none-padding">\r\n<li><a class="rss" href="#" title="Sample image">Cursus senectus aliquet pretium at</a></li>\r\n<li><a class="rss" href="#" title="Sample image">Tristique hac ullamcorper adipiscing et Donec.</a></li>\r\n</ul>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 101, '2008-04-16 02:26:18', 42, '', '2011-09-01 06:59:25', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(192, 318, 'Aliquam augue condimentum urna tortor id', 'aliquam-augue-condimentum-urna-tortor-id', '<img src="images/stories/demo/artist/photography-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris.</p>\r\n\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar<p>\r\n\r\n<ul class="none-padding">\r\n<li><a class="rss" href="#" title="Sample image">Cursus senectus aliquet pretium at</a></li>\r\n<li><a class="rss" href="#" title="Sample image">Tristique hac ullamcorper adipiscing et Donec.</a></li>\r\n</ul>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 101, '2008-04-16 02:26:18', 42, '', '2011-01-28 11:32:06', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(193, 319, 'Vivamus hac iaculis neque Morbi', 'vivamus-hac-iaculis-neque-morbi', '<p><img class="caption" src="images/stories/demo/artist/photography-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar</p>\r\n<ul class="none-padding">\r\n<li><a class="rss" href="#" title="Sample image">Cursus senectus aliquet pretium at</a></li>\r\n<li><a class="rss" href="#" title="Sample image">Tristique hac ullamcorper adipiscing et Donec.</a></li>\r\n</ul>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 101, '2008-04-16 02:26:18', 42, '', '2011-09-01 07:00:09', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(194, 320, 'Leo ornare egestas pretium odio', 'leo-ornare-egestas-pretium-odio', '<p><img class="caption" src="images/stories/demo/artist/photography-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar</p>\r\n<ul class="none-padding">\r\n<li><a class="rss" href="#" title="Sample image">Cursus senectus aliquet pretium at</a></li>\r\n<li><a class="rss" href="#" title="Sample image">Tristique hac ullamcorper adipiscing et Donec.</a></li>\r\n</ul>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 101, '2008-04-16 02:26:18', 42, '', '2011-09-01 06:59:08', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(195, 321, 'Nibh nibh consectetuer semper', 'nibh-nibh-consectetuer-semper', '<p><img class="caption" src="images/stories/demo/artist/photography-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla.</p>\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar</p>\r\n<ul class="none-padding">\r\n<li><a class="rss" href="#" title="Sample image">Cursus senectus aliquet pretium at</a></li>\r\n<li><a class="rss" href="#" title="Sample image">Tristique hac ullamcorper adipiscing et Donec.</a></li>\r\n</ul>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 101, '2008-04-16 02:26:18', 42, '', '2011-09-01 06:59:17', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(196, 322, 'Joomla 3.0 are now live on Magazine Template', 'joomla25-magazine-template', '<p><img class="caption" src="images/stories/demo/artist/photography-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et.</p>\r\n', '\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar</p>\r\n<ul class="none-padding">\r\n<li><a class="rss" href="#" title="Sample image">Cursus senectus aliquet pretium at</a></li>\r\n<li><a class="rss" href="#" title="Sample image">Tristique hac ullamcorper adipiscing et Donec.</a></li>\r\n</ul>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 101, '2008-04-16 02:26:18', 42, '', '2012-02-09 08:41:25', 42, 42, '2013-08-05 01:53:31', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 6, 1, 'Joomla 3.0 News Template, Joomla 3.0 Magazine Template', 'Experience the differences on Magazine here with Teline Joomlart 2.5 Template', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(197, 324, 'Porta sed nec feugiat Vivamus', 'porta-sed-nec-feugiat-vivamus', '<p><img class="caption" src="images/stories/demo/artist/gra-3.jpg" border="0" alt="Porta sed nec feugiat Vivamus" title="Sample image" align="left" /></p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam.</p>\r\n', '\r\n<p>Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac. Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>', 1, 102, '2008-04-16 04:34:54', 42, '', '2011-09-01 07:00:41', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:54', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(198, 325, 'Hendrerit velit orci sagittis eu Aenean', 'hendrerit-velit-orci-sagittis-eu-aenean', '<img src="images/stories/demo/artist/gra-2.jpg" alt="Hendrerit velit orci sagittis eu Aenean" align="left" title="Sample image" class="caption" />\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. </p>\r\n\r\n', '\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 102, '2008-04-16 04:33:57', 42, '', '2011-01-28 11:52:22', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:33:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(199, 326, 'Curabitur auctor risus sem', 'curabitur-auctor-risus-sem', '<img src="images/stories/demo/artist/gra-4.jpg" alt="Metus consequat in mauris mi Curabitur" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum.</p>\r\n\r\n', '\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus.</P>\r\n\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 102, '2009-08-11 07:32:55', 42, '', '2011-01-28 11:43:50', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(200, 327, 'Nam id Sed Donec pretium', 'nam-id-sed-donec-pretium', '<p><img class="caption" src="images/stories/demo/artist/gra-1.jpg" border="0" alt="Metus consequat in mauris mi Curabitur" title="Sample image" align="left" /></p>\r\n<p>Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus.</p>\r\n', '\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus.</p>\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 102, '2009-08-11 07:32:55', 42, '', '2011-09-01 07:00:22', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(201, 328, 'Switching to Joomla 3.0 template', 'joomla25-template-magazine', '<p><img class="caption" src="images/stories/demo/artist/gra-5.jpg" border="0" alt="Metus consequat in mauris mi Curabitur" title="Sample image" align="left" /></p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem.</p>\r\n', '\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus.</p>\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 102, '2009-08-11 07:32:55', 42, '', '2012-02-10 02:49:11', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 5, 4, 'Joomla 3.0 News Template, Joomla 3.0 Magazine Template', 'Experience the differences on Magazine here with Teline Joomlart 2.5 Template', 1, 12, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(202, 329, 'Praesent nibh leo eu justo', 'praesent-nibh-leo-eu-justo', '<p><img class="caption" src="images/stories/demo/artist/gra-6.jpg" border="0" alt="Metus consequat in mauris mi Curabitur" title="Sample image" align="left" /></p>\r\n<p>Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas.</p>\r\n', '\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus.</p>\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 102, '2009-08-11 07:32:55', 42, '', '2011-09-01 07:00:50', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(203, 330, ' Et Aenean id velit risus', 'et-aenean-id-velit-risus', '<img src="images/stories/demo/artist/gra-7.jpg" alt="Metus consequat in mauris mi Curabitur" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus.</p>\r\n\r\n', '\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus.</P>\r\n\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 102, '2009-08-11 07:32:55', 42, '', '2011-01-28 11:26:48', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(204, 331, 'Tortor facilisi et interdum Phasellus', 'tortor-facilisi-et-interdum-phasellus', '<p><img class="caption" src="images/stories/demo/artist/gra-8.jpg" border="0" alt="Metus consequat in mauris mi Curabitur" title="Sample image" align="left" /></p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget.</p>\r\n', '\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus.</p>\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 102, '2009-08-11 07:32:55', 42, '', '2011-09-01 07:01:00', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(205, 333, 'England stars offer summer coaching', 'england-stars-offer-summer-coaching', '<img src="images/stories/demo/artist/3d-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Et libero pretium accumsan convallis sapien elit orci tempus sed In. Nibh Praesent et eleifend Vivamus laoreet tortor metus habitant fames gravida. </p>\r\n\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n\r\n', '\r\n\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla. </p>\r\n\r\n<p>Aliquam Curabitur Vestibulum laoreet Aliquam elit id wisi porttitor Aliquam iaculis. Curabitur risus justo Phasellus hendrerit convallis lorem tincidunt ac porta sit. Ullamcorper et mus nec lacinia arcu Sed eros et fringilla habitant. Elit Nam massa vitae dolor et justo In et. Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 103, '2009-08-12 08:06:15', 42, '', '2011-01-28 11:47:36', 42, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(206, 334, 'Vel dolor ligula tristique magnis sit', 'vel-dolor-ligula-tristique-magnis-sit', '<p><img src="images/stories/demo/artist/3d-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. V</p>\r\n', '\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n<p>itae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at. Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt.</p>\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>', 1, 103, '2008-04-14 08:14:01', 42, '', '2011-09-01 07:09:30', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:14:01', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(207, 335, 'Wenger\'s recipe for success', 'wengers-recipe-for-success', '<p><img class="caption" src="images/stories/demo/artist/3d-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Fringilla ut Aenean suscipit ut lorem ac dui Nulla senectus eget. Et et Curabitur iaculis leo ullamcorper ut leo interdum enim elit.</p>\r\n', '\r\n<p>Faucibus quis eget felis Maecenas Fusce ornare pretium Vestibulum Pellentesque sagittis. Senectus consequat Nulla tempus elit nulla neque wisi consectetuer a Phasellus. Lacinia eros nibh malesuada ante In tellus ornare Vestibulum risus et. Tempus eget at Pellentesque et lacus Morbi tempus nec. Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at.</p>\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt.</p>\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n<p>Lorem ipsum dolor sit amet consectetuer ut mauris at Nam id. Nam nec semper quis congue Donec netus odio eu id consequat. Massa enim semper pellentesque Cras Sed neque congue dolor habitasse dui. Tempus In cursus Vestibulum Quisque at at ut dolor ut a. Tincidunt elit Integer venenatis Vestibulum libero at id orci dolor justo. Ornare dictum non orci ligula odio tempor orci neque urna Nam. Ornare vitae vitae.</p>\r\n<p class="box-grey">Vestibulum libero habitant sapien aliquet tortor Aenean lacinia laoreet justo sapien. Enim Pellentesque augue leo et montes consequat enim justo elit Nam. Feugiat cursus malesuada dui mollis fermentum justo congue nec nibh feugiat. Gravida justo nec risus ligula pede metus senectus tempor Maecenas massa. Laoreet nulla eros id congue ante purus scelerisque mauris semper elit. Duis Vestibulum cursus.</p>\r\n<p>Semper augue dolor tellus at vel magna vitae et Aliquam Vestibulum. Ut Sed eu orci auctor tellus interdum ac tincidunt id est. In rhoncus nibh Curabitur Curabitur quis massa mattis eget tincidunt cursus. Tortor ipsum nec cursus laoreet vitae feugiat id pellentesque Aenean Sed. Natoque Nulla risus magna justo Sed Phasellus leo.</p>\r\n<p>Scelerisque velit semper Suspendisse sociis consectetuer consequat Vestibulum semper vel interdum. Sed faucibus adipiscing augue justo nec cursus eget commodo semper lacinia. Donec tellus Sed porttitor Nullam natoque urna ac ut odio ut. Pellentesque enim Suspendisse natoque tellus risus Nam convallis dui ac massa. Urna id Nulla Nullam Sed mauris et ac sagittis Cum nunc. Vitae.</p>', 1, 103, '2008-04-14 08:10:21', 42, '', '2011-09-01 07:09:40', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:10:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(208, 336, 'Suspendisse ligula feugiat', 'suspendisse-ligula-feugiat', '<p><img class="caption" src="images/stories/demo/artist/3d-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus.</p>\r\n', '\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n<p>Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo. Et libero pretium accumsan convallis sapien elit orci tempus sed In. Nibh Praesent et eleifend Vivamus laoreet tortor metus habitant fames gravida.</p>\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla.</p>\r\n<p>Aliquam Curabitur Vestibulum laoreet Aliquam elit id wisi porttitor Aliquam iaculis. Curabitur risus justo Phasellus hendrerit convallis lorem tincidunt ac porta sit. Ullamcorper et mus nec lacinia arcu Sed eros et fringilla habitant. Elit Nam massa vitae dolor et justo In et. Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 103, '2009-08-12 08:06:15', 42, '', '2011-09-01 07:09:18', 42, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(209, 337, 'Maecenas nibh sed faucibus ', 'maecenas-nibh-sed-faucibus', '<p><img class="caption" src="images/stories/demo/artist/3d-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus.</p>\r\n', '\r\n<p>Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo. Et libero pretium accumsan convallis sapien elit orci tempus sed In. Nibh Praesent et eleifend Vivamus laoreet tortor metus habitant fames gravida.</p>\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla.</p>\r\n<p>Aliquam Curabitur Vestibulum laoreet Aliquam elit id wisi porttitor Aliquam iaculis. Curabitur risus justo Phasellus hendrerit convallis lorem tincidunt ac porta sit. Ullamcorper et mus nec lacinia arcu Sed eros et fringilla habitant. Elit Nam massa vitae dolor et justo In et. Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 103, '2009-08-12 08:06:15', 42, '', '2011-09-01 07:08:54', 42, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(210, 338, 'Condimentum nibh venenatis vitae', 'condimentum-nibh-venenatis-vitae', '<img src="images/stories/demo/artist/3d-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. </p>\r\n\r\n', '\r\n\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla. </p>\r\n\r\n<p>Aliquam Curabitur Vestibulum laoreet Aliquam elit id wisi porttitor Aliquam iaculis. Curabitur risus justo Phasellus hendrerit convallis lorem tincidunt ac porta sit. Ullamcorper et mus nec lacinia arcu Sed eros et fringilla habitant. Elit Nam massa vitae dolor et justo In et. Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 103, '2009-08-12 08:06:15', 42, '', '2011-01-28 11:41:39', 42, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(211, 339, 'Nulla semper quis sapien', 'nulla-semper-quis-sapien', '<p><img class="caption" src="images/stories/demo/artist/3d-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci.</p>\r\n', '\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla.</p>\r\n<p>Aliquam Curabitur Vestibulum laoreet Aliquam elit id wisi porttitor Aliquam iaculis. Curabitur risus justo Phasellus hendrerit convallis lorem tincidunt ac porta sit. Ullamcorper et mus nec lacinia arcu Sed eros et fringilla habitant. Elit Nam massa vitae dolor et justo In et. Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 103, '2009-08-12 08:06:15', 42, '', '2011-09-01 07:09:07', 42, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(212, 340, 'Id Vestibulum Donec Pellentesque', 'id-vestibulum-donec-pellentesque', '<p><img class="caption" src="images/stories/demo/artist/3d-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel.</p>\r\n', '\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n<p>Tortor pretium ipsum Maecenas justo ut lacus nec a sem Ut. Urna wisi wisi mauris pretium laoreet sit risus Nulla elit consequat. Auctor id enim leo condimentum lorem ipsum leo Quisque Vivamus fames. Condimentum nibh venenatis vitae felis mus adipiscing ridiculus eget lacus eros. Nulla semper quis sapien ut molestie pretium tempus interdum Sed orci. Ac tincidunt Suspendisse ligula feugiat sapien hendrerit feugiat egestas massa.</p>\r\n<p>Neque egestas Cras eget et neque neque Praesent condimentum orci ligula. Aenean dictumst metus vitae Aenean et Integer nibh mus cursus consectetuer. Id Vestibulum Donec Pellentesque dui Cum eleifend amet orci vitae sollicitudin. Dui egestas Donec tincidunt lorem a Cum ut et libero justo. Ante justo ac Sed ligula in convallis est pede hendrerit wisi. Dui Sed platea tempus odio fames Phasellus vitae id senectus nulla.</p>\r\n<p>Aliquam Curabitur Vestibulum laoreet Aliquam elit id wisi porttitor Aliquam iaculis. Curabitur risus justo Phasellus hendrerit convallis lorem tincidunt ac porta sit. Ullamcorper et mus nec lacinia arcu Sed eros et fringilla habitant. Elit Nam massa vitae dolor et justo In et. Et accumsan Quisque platea dictum enim nec id Vestibulum libero vel. Ac volutpat eu nibh Quisque risus faucibus laoreet nec dolor at. In consectetuer pretium Curabitur Sed at elit ut Curabitur porta et. Nisl libero eros pellentesque vitae feugiat porttitor quis In semper sapien. Quisque sociis tempor wisi ante mollis Aenean.</p>\r\n<p>Libero urna elit urna consequat ac nibh In quis Maecenas a. Vel enim Pellentesque porttitor lacinia hendrerit eleifend congue ac ligula metus. Maecenas nibh sed faucibus Aenean tristique vitae rhoncus lacinia eros vel. Velit consequat dolor pretium fringilla nibh Ut felis quis nascetur vel. Dis Vestibulum quam tempus egestas Nunc Integer id leo Mauris nibh. Dolor at leo.</p>\r\n<p>Quis eu laoreet porttitor nibh tellus justo ante a vitae adipiscing. Velit egestas euismod Nulla wisi In augue est nibh consequat Pellentesque. Aenean massa nibh malesuada laoreet vitae senectus Aenean ut pede cursus. Justo augue aliquet fringilla senectus dis sociis tellus ut Quisque tempus. Adipiscing turpis Pellentesque lacus eget magna dis leo lacinia metus et. Nam habitasse enim vel pellentesque nunc Nam dolor pede lorem.</p>\r\n<p>Est Nam felis est euismod pretium mauris tellus libero sem cursus. Condimentum vel Aenean pellentesque volutpat turpis euismod fames nec quis enim. Ac non eu In urna Lorem Lorem ac Nam mattis hendrerit. Consectetuer Donec neque justo felis platea porttitor eu pede morbi in. Consequat laoreet elit mattis nec lacus dolor Vestibulum lacus sit.</p>', 1, 103, '2009-08-12 08:06:15', 42, '', '2011-09-01 07:08:36', 42, 0, '0000-00-00 00:00:00', '2009-08-12 08:06:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(213, 343, 'Hawaii-style fun on the mainland', 'hawaii-style-fun-on-the-mainland', '<img src="images/stories/demo/travel/getaways-1.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.  </p>\r\n\r\n', '\r\n\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 105, '2008-04-11 06:53:59', 42, '', '2013-07-30 09:02:32', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:53:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 8, '', '', 1, 26, '{"tags":[7,8,3],"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(214, 344, 'Five festivals for last bit of summer fun', 'five-festivals-for-last-bit-of-summer-fun', '<img src="images/stories/demo/travel/getaways-2.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. </p>\r\n\r\n', '\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 105, '2008-04-11 06:55:31', 42, '', '2011-01-28 11:50:45', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:55:31', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 7, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(215, 345, 'Are travel agents making a comeback?', 'are-travel-agents-making-a-comeback', '<img src="images/stories/demo/travel/getaways-3.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/travel/getaways-2.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 105, '2008-04-11 06:56:02', 42, '', '2011-01-28 11:39:12', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:56:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 46, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(216, 346, 'Ut Mauris elit ipsum Pellentesque', 'ut-mauris-elit-ipsum-pellentesque', '<p><img class="caption" src="images/stories/demo/travel/getaways-4.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/travel/getaways-2.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 105, '2008-04-11 06:56:02', 42, '', '2011-09-01 07:10:28', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:56:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(217, 347, 'Tortor pretium orci semper platea', 'tortor-pretium-orci-semper-platea', '<p><img class="caption" src="images/stories/demo/travel/getaways-5.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/travel/getaways-2.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 105, '2008-04-11 06:56:02', 42, '', '2011-09-01 07:10:19', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:56:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(218, 348, 'Libero euismod ac orci condimentum', 'libero-euismod-ac-orci-condimentum', '<p><img class="caption" src="images/stories/demo/travel/getaways-6.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/travel/getaways-2.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 105, '2008-04-11 06:56:02', 42, '', '2011-09-01 07:10:11', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:56:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(219, 349, 'Lacinia vitae In ante ipsum', 'lacinia-vitae-in-ante-ipsum', '<p><img class="caption" src="images/stories/demo/travel/getaways-7.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/travel/getaways-2.jpg" border="0" alt="Sample image" title="Sample image" align="right" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 105, '2008-04-11 06:56:02', 42, '', '2011-09-01 07:10:01', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:56:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(220, 350, 'Feugiat convallis turpis massa', 'feugiat-convallis-turpis-massa', '<img src="images/stories/demo/travel/getaways-8.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n\r\n<p>Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/travel/getaways-2.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 105, '2008-04-11 06:56:02', 42, '', '2011-01-28 11:50:15', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:56:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(221, 352, 'How to slide on airline luggage fees', 'how-to-slide-on-airline-luggage-fees', '<p><img class="caption" src="images/stories/demo/travel/traveltips-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n', '\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>', 1, 106, '2008-04-11 06:56:47', 42, '', '2011-09-01 07:10:59', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:56:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(222, 353, 'How flight attendants deal with life on board', 'how-flight-attendants-deal-with-life-on-board', '<p><img class="caption" src="images/stories/demo/travel/traveltips-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>', 1, 106, '2008-04-11 06:57:22', 42, '', '2011-09-01 07:10:43', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:57:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(223, 354, 'How to avoid the hazards of booking online', 'how-to-avoid-the-hazards-of-booking-online', '<p><img class="caption" src="images/stories/demo/travel/traveltips-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n', '\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 106, '2008-04-11 06:57:51', 42, '', '2011-09-01 07:10:50', 42, 0, '0000-00-00 00:00:00', '2008-04-11 06:57:51', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(224, 355, 'Trapped on the tarmac? Try these escape tips', 'trapped-on-the-tarmac-try-these-escape-tips', '<p><img class="caption" src="images/stories/demo/travel/traveltips-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam.</p>\r\n', '\r\n<p>Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 106, '2008-04-11 07:00:14', 42, '', '2011-09-01 07:11:25', 42, 0, '0000-00-00 00:00:00', '2008-04-11 07:00:14', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(225, 356, 'Semper Sed eros dolor condimentum congue', 'semper-sed-eros-dolor-condimentum-congue', '<p><img class="caption" src="images/stories/demo/travel/traveltips-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nullam dictum quis orci ac netus wisi ac Nullam nibh iaculis. Tincidunt Sed nascetur id Lorem semper volutpat sodales vitae quis Vestibulum. Curabitur leo adipiscing in eget Suspendisse id tellus Nulla sagittis accumsan. Faucibus Nam at parturient Vivamus pretium ipsum amet Nam tempus auctor. Orci scelerisque tristique ac orci turpis.</p>\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/travel/traveltips-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Eu Vivamus et volutpat lobortis pellentesque Vestibulum et natoque adipiscing Suspendisse. Turpis libero egestas justo urna turpis dui scelerisque ullamcorper Integer vitae. Turpis eget neque orci orci id nulla dui interdum a id. Congue eu id quis neque Donec enim id tortor nibh urna. Quis Nam Nam Cras enim accumsan laoreet Morbi fermentum nibh tempus. Nibh mauris Curabitur enim Vestibulum tellus enim ligula euismod adipiscing.</p>\r\n<p>Lorem sapien justo ornare convallis massa et egestas eu ligula Vestibulum. Adipiscing est habitant mauris faucibus Praesent Vivamus fermentum eu mi a. Pede risus adipiscing vestibulum nonummy Suspendisse tellus et metus enim nibh. Cursus pharetra wisi magnis elit lacus sit auctor dui Aliquam Quisque. Accumsan faucibus congue wisi tincidunt nulla nibh consequat Suspendisse sem leo. Pellentesque venenatis Sed aliquam id elit.</p>\r\n<p>Sit orci Suspendisse nulla mauris Nam metus eros odio feugiat semper. Enim pellentesque est Phasellus Curabitur urna tincidunt sagittis gravida eget Ut. Gravida congue Maecenas faucibus Mauris congue lacus eu vitae eget neque. Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec.</p>\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>', 1, 106, '2008-04-21 03:55:05', 42, '', '2011-09-01 07:11:16', 42, 0, '0000-00-00 00:00:00', '2008-04-21 03:55:05', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 50, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(226, 357, 'Lobortis rhoncus porttitor Nunc Cum', 'lobortis-rhoncus-porttitor-nunc-cum', '<p><img class="caption" src="images/stories/demo/travel/traveltips-14.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare.</p>\r\n', '\r\n<p>Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 106, '2008-04-11 07:00:14', 42, '', '2011-09-01 07:11:08', 42, 0, '0000-00-00 00:00:00', '2008-04-11 07:00:14', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(227, 359, 'September\'s show: traveling with a conscience', 'septembers-show-traveling-with-a-conscience', '<p><img class="caption" src="images/stories/demo/travel/traveltips-10.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 107, '2008-04-11 07:01:19', 42, '', '2011-09-01 07:12:05', 42, 0, '0000-00-00 00:00:00', '2008-04-11 07:01:19', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(228, 360, 'Taking the ethical high road', 'taking-the-ethical-high-road', '<p><img class="caption" src="images/stories/demo/travel/traveltips-9.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>', 1, 107, '2008-04-11 07:01:48', 42, '', '2011-09-01 07:12:13', 42, 0, '0000-00-00 00:00:00', '2008-04-11 07:01:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(229, 361, '3 biggest mistakes business travelers make', '3-biggest-mistakes-business-travelers-make', '<img align="left" src="images/stories/demo/travel/traveltips-8.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum. </p>\r\n\r\n', '\r\n\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat.  Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 107, '2008-04-11 07:02:15', 42, '', '2011-01-28 11:27:37', 42, 0, '0000-00-00 00:00:00', '2008-04-11 07:02:15', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 21, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(230, 362, 'Giving something back', 'giving-something-back', '<img align="left" src="images/stories/demo/travel/traveltips-7.jpg" alt="Sample image I" title="Sample image I" class="caption" />\r\n\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.  </p>\r\n\r\n', '\r\n\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nunc nunc congue in <span class="highlight">quis quis vitae</span> semper tempor nunc quam.</p>\r\n\r\n<img align="left" src="images/stories/demo/travel/traveltips-7_1.jpg" alt="Sample image II" title="Sample image II" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n\r\n<img align="left" src="images/stories/demo/travel/traveltips-7_2.jpg" alt="Sample image III" title="Sample image III" class="caption" />\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n\r\n<img align="left" src="images/stories/demo/travel/traveltips-7_3.jpg" alt="Sample image IV" title="Sample image IV" class="caption" />\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 107, '2008-04-11 07:02:44', 42, '', '2011-01-28 11:51:08', 42, 0, '0000-00-00 00:00:00', '2008-04-11 07:02:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 171, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(231, 363, '9 essential travel strategies for 2009', '9-essential-travel-strategies-for-2009', '<img src="images/stories/demo/travel/traveltips-6.jpg" alt="9 essential travel strategies for 2009" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer eros nisl ut netus fermentum. Elit id lacus elit tellus id justo urna nec quis ridiculus. Hendrerit nunc pretium id lacinia Sed aliquam Phasellus velit ipsum Morbi. </p>\r\n\r\n', '\r\n\r\n<p>Auctor lorem neque interdum diam elit adipiscing lorem libero feugiat fringilla. Felis id sed tortor mattis elit libero Vivamus volutpat accumsan. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Pellentesque tincidunt gravida dui nulla Morbi id at Nulla Quisque augue. Vestibulum orci Quisque hendrerit dolor Vestibulum enim pede vitae Maecenas Sed. In eu leo id In ligula cursus nisl Nulla habitant at. Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n\r\n<p>Tortor magna pretium magna vel interdum pretium velit amet mauris sit. Cursus laoreet id sollicitudin Quisque Suspendisse adipiscing Suspendisse tellus vitae Donec. Molestie orci nulla habitasse nunc tempus et facilisis Nulla porta lorem. Interdum orci gravida risus a metus fringilla condimentum tincidunt condimentum ut. Tortor nunc et justo volutpat rhoncus Nam lacus lacinia orci id. Augue Mauris leo pellentesque urna pretium Donec montes Aliquam ligula Maecenas. Curabitur Suspendisse et.</p>\r\n\r\n<p>Nullam odio et vestibulum laoreet ridiculus dui eu eu pellentesque amet. Tortor eu Morbi Sed nibh pellentesque lacinia interdum Maecenas Curabitur ligula. Felis tempus et enim laoreet nunc nulla id Fusce mollis egestas. Lacus ac ornare tellus Vestibulum eu pede faucibus Maecenas sed ut. Lobortis enim nunc leo tellus natoque.</p>\r\n\r\n<p>Neque tortor aliquam pretium fringilla pretium a dolor convallis leo tincidunt. Ut consectetuer laoreet aliquam sit sem Aenean et dignissim nulla leo. Pretium consectetuer eget pellentesque Sed nec tincidunt Vestibulum at Curabitur egestas. Pretium platea pellentesque convallis nisl nulla felis sociis nonummy ipsum ante. Condimentum lobortis sit et tellus id cursus Curabitur in convallis eget. Nonummy dui Nam ut cursus in auctor eros mauris justo eget. Ornare nec.</p>\r\n\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n\r\n<p>Pellentesque pede tincidunt tellus lorem ultrices enim tristique tincidunt sem pretium. Mollis euismod lacinia et Curabitur orci pellentesque eget Vestibulum Duis penatibus. Vestibulum Donec id congue fames auctor interdum mauris auctor tellus cursus. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat. Est risus dui consequat commodo nibh Donec at risus condimentum Quisque. Rutrum tincidunt tincidunt porttitor ridiculus Vestibulum et semper vitae Vestibulum urna. </p>\r\n\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id. Auctor congue pretium Aenean turpis dui eget Curabitur nulla cursus pellentesque. Et Duis id urna elit.</p>', 1, 107, '2008-04-21 03:37:38', 42, '', '2011-01-28 11:30:06', 42, 0, '0000-00-00 00:00:00', '2008-04-21 03:37:38', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 12, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(232, 364, 'Vestibulum orci Quisque hendrerit', 'vestibulum-orci-quisque-hendrerit', '<p><img class="caption" src="images/stories/demo/travel/traveltips-11.jpg" border="0" alt="9 essential travel strategies for 2009" title="Sample image" align="left" /></p>\r\n<p>Pellentesque tincidunt gravida dui nulla Morbi id at Nulla Quisque augue. Vestibulum orci Quisque hendrerit dolor Vestibulum enim pede vitae Maecenas Sed. In eu leo id In ligula cursus nisl Nulla habitant at.</p>\r\n', '\r\n<p>Auctor lorem neque interdum diam elit adipiscing lorem libero feugiat fringilla. Felis id sed tortor mattis elit libero Vivamus volutpat accumsan. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Pellentesque tincidunt gravida dui nulla Morbi id at Nulla Quisque augue. Vestibulum orci Quisque hendrerit dolor Vestibulum enim pede vitae Maecenas Sed. In eu leo id In ligula cursus nisl Nulla habitant at. Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n<p>Tortor magna pretium magna vel interdum pretium velit amet mauris sit. Cursus laoreet id sollicitudin Quisque Suspendisse adipiscing Suspendisse tellus vitae Donec. Molestie orci nulla habitasse nunc tempus et facilisis Nulla porta lorem. Interdum orci gravida risus a metus fringilla condimentum tincidunt condimentum ut. Tortor nunc et justo volutpat rhoncus Nam lacus lacinia orci id. Augue Mauris leo pellentesque urna pretium Donec montes Aliquam ligula Maecenas. Curabitur Suspendisse et.</p>\r\n<p>Nullam odio et vestibulum laoreet ridiculus dui eu eu pellentesque amet. Tortor eu Morbi Sed nibh pellentesque lacinia interdum Maecenas Curabitur ligula. Felis tempus et enim laoreet nunc nulla id Fusce mollis egestas. Lacus ac ornare tellus Vestibulum eu pede faucibus Maecenas sed ut. Lobortis enim nunc leo tellus natoque.</p>\r\n<p>Neque tortor aliquam pretium fringilla pretium a dolor convallis leo tincidunt. Ut consectetuer laoreet aliquam sit sem Aenean et dignissim nulla leo. Pretium consectetuer eget pellentesque Sed nec tincidunt Vestibulum at Curabitur egestas. Pretium platea pellentesque convallis nisl nulla felis sociis nonummy ipsum ante. Condimentum lobortis sit et tellus id cursus Curabitur in convallis eget. Nonummy dui Nam ut cursus in auctor eros mauris justo eget. Ornare nec.</p>\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p>Pellentesque pede tincidunt tellus lorem ultrices enim tristique tincidunt sem pretium. Mollis euismod lacinia et Curabitur orci pellentesque eget Vestibulum Duis penatibus. Vestibulum Donec id congue fames auctor interdum mauris auctor tellus cursus. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat. Est risus dui consequat commodo nibh Donec at risus condimentum Quisque. Rutrum tincidunt tincidunt porttitor ridiculus Vestibulum et semper vitae Vestibulum urna.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id. Auctor congue pretium Aenean turpis dui eget Curabitur nulla cursus pellentesque. Et Duis id urna elit.</p>', 1, 107, '2008-04-21 03:37:38', 42, '', '2011-09-01 07:12:22', 42, 0, '0000-00-00 00:00:00', '2008-04-21 03:37:38', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(233, 365, 'Magazine Joomla 3.0 template is now available', 'magazine-template-joomla25', '<p><img class="caption" src="images/stories/demo/travel/traveltips-12.jpg" border="0" alt="9 essential travel strategies for 2009" title="Sample image" align="left" /></p>\r\n<p>Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo.</p>\r\n', '\r\n<p>Auctor lorem neque interdum diam elit adipiscing lorem libero feugiat fringilla. Felis id sed tortor mattis elit libero Vivamus volutpat accumsan. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Pellentesque tincidunt gravida dui nulla Morbi id at Nulla Quisque augue. Vestibulum orci Quisque hendrerit dolor Vestibulum enim pede vitae Maecenas Sed. In eu leo id In ligula cursus nisl Nulla habitant at. Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n<p>Tortor magna pretium magna vel interdum pretium velit amet mauris sit. Cursus laoreet id sollicitudin Quisque Suspendisse adipiscing Suspendisse tellus vitae Donec. Molestie orci nulla habitasse nunc tempus et facilisis Nulla porta lorem. Interdum orci gravida risus a metus fringilla condimentum tincidunt condimentum ut. Tortor nunc et justo volutpat rhoncus Nam lacus lacinia orci id. Augue Mauris leo pellentesque urna pretium Donec montes Aliquam ligula Maecenas. Curabitur Suspendisse et.</p>\r\n<p>Nullam odio et vestibulum laoreet ridiculus dui eu eu pellentesque amet. Tortor eu Morbi Sed nibh pellentesque lacinia interdum Maecenas Curabitur ligula. Felis tempus et enim laoreet nunc nulla id Fusce mollis egestas. Lacus ac ornare tellus Vestibulum eu pede faucibus Maecenas sed ut. Lobortis enim nunc leo tellus natoque.</p>\r\n<p>Neque tortor aliquam pretium fringilla pretium a dolor convallis leo tincidunt. Ut consectetuer laoreet aliquam sit sem Aenean et dignissim nulla leo. Pretium consectetuer eget pellentesque Sed nec tincidunt Vestibulum at Curabitur egestas. Pretium platea pellentesque convallis nisl nulla felis sociis nonummy ipsum ante. Condimentum lobortis sit et tellus id cursus Curabitur in convallis eget. Nonummy dui Nam ut cursus in auctor eros mauris justo eget. Ornare nec.</p>\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p>Pellentesque pede tincidunt tellus lorem ultrices enim tristique tincidunt sem pretium. Mollis euismod lacinia et Curabitur orci pellentesque eget Vestibulum Duis penatibus. Vestibulum Donec id congue fames auctor interdum mauris auctor tellus cursus. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat. Est risus dui consequat commodo nibh Donec at risus condimentum Quisque. Rutrum tincidunt tincidunt porttitor ridiculus Vestibulum et semper vitae Vestibulum urna.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id. Auctor congue pretium Aenean turpis dui eget Curabitur nulla cursus pellentesque. Et Duis id urna elit.</p>', 1, 107, '2008-04-21 03:37:38', 42, '', '2012-02-10 02:51:39', 42, 0, '0000-00-00 00:00:00', '2008-04-21 03:37:38', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 5, 2, 'Joomla 3.0 News Template, Joomla 3.0 Magazine Template', 'Experience the differences on Magazine here with Teline Joomlart 2.5 Template', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(234, 366, 'Porttitor fringilla sed natoque', 'porttitor-fringilla-sed-natoque', '<p><img class="caption" src="images/stories/demo/travel/traveltips-13.jpg" border="0" alt="9 essential travel strategies for 2009" title="Sample image" align="left" /></p>\r\n<p>Neque tortor aliquam pretium fringilla pretium a dolor convallis leo tincidunt. Ut consectetuer laoreet aliquam sit sem Aenean et dignissim nulla leo.</p>\r\n', '\r\n<p>Auctor lorem neque interdum diam elit adipiscing lorem libero feugiat fringilla. Felis id sed tortor mattis elit libero Vivamus volutpat accumsan. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Nisl elit tincidunt congue in libero Maecenas nec habitasse lacinia eros. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n<p>Pellentesque tincidunt gravida dui nulla Morbi id at Nulla Quisque augue. Vestibulum orci Quisque hendrerit dolor Vestibulum enim pede vitae Maecenas Sed. In eu leo id In ligula cursus nisl Nulla habitant at. Ut pellentesque quis turpis dui tincidunt tempus pellentesque ridiculus pretium vel. Orci Curabitur ligula pellentesque Curabitur nec fames vitae Curabitur odio laoreet. Fringilla Aenean Curabitur vel neque malesuada augue.</p>\r\n<p>Tortor magna pretium magna vel interdum pretium velit amet mauris sit. Cursus laoreet id sollicitudin Quisque Suspendisse adipiscing Suspendisse tellus vitae Donec. Molestie orci nulla habitasse nunc tempus et facilisis Nulla porta lorem. Interdum orci gravida risus a metus fringilla condimentum tincidunt condimentum ut. Tortor nunc et justo volutpat rhoncus Nam lacus lacinia orci id. Augue Mauris leo pellentesque urna pretium Donec montes Aliquam ligula Maecenas. Curabitur Suspendisse et.</p>\r\n<p>Nullam odio et vestibulum laoreet ridiculus dui eu eu pellentesque amet. Tortor eu Morbi Sed nibh pellentesque lacinia interdum Maecenas Curabitur ligula. Felis tempus et enim laoreet nunc nulla id Fusce mollis egestas. Lacus ac ornare tellus Vestibulum eu pede faucibus Maecenas sed ut. Lobortis enim nunc leo tellus natoque.</p>\r\n<p>Neque tortor aliquam pretium fringilla pretium a dolor convallis leo tincidunt. Ut consectetuer laoreet aliquam sit sem Aenean et dignissim nulla leo. Pretium consectetuer eget pellentesque Sed nec tincidunt Vestibulum at Curabitur egestas. Pretium platea pellentesque convallis nisl nulla felis sociis nonummy ipsum ante. Condimentum lobortis sit et tellus id cursus Curabitur in convallis eget. Nonummy dui Nam ut cursus in auctor eros mauris justo eget. Ornare nec.</p>\r\n<p>Dolor dapibus Phasellus id Aenean rhoncus Maecenas Nunc pellentesque In convallis. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n<p>Pellentesque pede tincidunt tellus lorem ultrices enim tristique tincidunt sem pretium. Mollis euismod lacinia et Curabitur orci pellentesque eget Vestibulum Duis penatibus. Vestibulum Donec id congue fames auctor interdum mauris auctor tellus cursus. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat. Est risus dui consequat commodo nibh Donec at risus condimentum Quisque. Rutrum tincidunt tincidunt porttitor ridiculus Vestibulum et semper vitae Vestibulum urna.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id. Auctor congue pretium Aenean turpis dui eget Curabitur nulla cursus pellentesque. Et Duis id urna elit.</p>', 1, 107, '2008-04-21 03:37:38', 42, '', '2011-09-01 07:11:56', 42, 0, '0000-00-00 00:00:00', '2008-04-21 03:37:38', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(235, 369, 'The Fall of Christian Lacroix', 'the-fall-of-christian-lacroix', '<p><img class="caption" src="images/stories/demo/style/fashion-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer eget nunc Phasellus facilisi et. At et ac pretium Sed senectus adipiscing nibh sodales laoreet id. Augue consequat Vestibulum est rutrum amet Nunc elit congue aliquam ut. Ligula lacinia dis a Vestibulum felis nunc lacinia quis ac id. Libero et turpis hendrerit sociis sociis Sed nibh Proin Aenean.</p>\r\n', '\r\n<p>Eleifend sapien id nec urna rutrum condimentum justo wisi vitae mollis. Ante tincidunt eros augue tincidunt id ut Curabitur nonummy neque accumsan. In Phasellus nibh aliquam id auctor consectetuer nibh libero nunc Sed. Id felis id Maecenas libero ac ut ipsum eu Curabitur nibh. Eget ut ridiculus consequat dignissim at id urna Nam interdum fringilla. Phasellus augue mi.</p>\r\n<p>Tortor eget Aenean eu elit urna Nulla pellentesque hac orci id. Netus mauris Aenean natoque Nam volutpat quis molestie habitant Cras Aliquam. Tristique euismod Curabitur dolor id turpis condimentum Aliquam facilisi Phasellus lorem. Consectetuer parturient Vestibulum scelerisque Cum a tellus et tempus elit nulla. Velit consectetuer Phasellus dis nunc eget hac vestibulum mollis fames a. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et.</p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum. Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat.</p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 109, '2008-04-11 09:33:49', 42, '', '2013-07-30 09:04:15', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:33:49', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 8, '', '', 1, 0, '{"tags":[9,3,10],"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(236, 370, 'Tips to Soothe Your Skin ', 'tips-to-soothe-your-skin', '<p><img class="caption" src="images/stories/demo/style/fashion-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n', '\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 109, '2008-04-11 09:34:25', 42, '', '2011-09-01 07:13:45', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:34:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(237, 371, '\'How to\' with Joomla 3.0 template!', 'joomla25-template-magazine-news', '<p><img class="caption" src="images/stories/demo/style/beauty-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh vitae metus eget ut condi eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/style/beauty-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 109, '2008-04-11 09:34:51', 42, '', '2012-02-10 09:31:05', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:34:51', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 6, 6, 'Joomla 3.0 News Template, Joomla 3.0 Magazine Template', 'Experience the differences on Magazine here with Teline Joomlart 2.5 Template', 1, 56, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(238, 372, 'Maecenas augue enim felis Nam', 'maecenas-augue-enim-felis-nam', '<p><img class="caption" src="images/stories/demo/style/fashion-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae.</p>\r\n', '\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 109, '2008-04-11 09:34:25', 42, '', '2011-09-01 07:13:04', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:34:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(239, 373, 'In condimentum mauris Integer', 'in-condimentum-mauris-integer', '<p><img class="caption" src="images/stories/demo/style/fashion-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris, Nibh leo a mauris ipsum.</p>\r\n', '\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 109, '2008-04-11 09:34:25', 42, '', '2011-09-01 07:12:46', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:34:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(240, 374, 'Lobortis rhoncus porttitor Nunc Cum', 'lobortis-rhoncus-porttitor-nunc-cum', '<p><img class="caption" src="images/stories/demo/style/fashion-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n', '\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 109, '2008-04-11 09:34:25', 42, '', '2011-09-01 07:12:55', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:34:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(241, 375, 'Enim sollicitudin habitasse Nam', 'enim-sollicitudin-habitasse-nam', '<img src="images/stories/demo/style/fashion-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium.</p>\r\n\r\n', '\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>\r\n\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc. </p>\r\n\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 109, '2009-09-04 08:35:38', 42, '', '2011-01-28 11:48:26', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:35:38', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(242, 376, 'Rhoncus tellus eros enim netus', 'rhoncus-tellus-eros-enim-netus', '<p><img class="caption" src="images/stories/demo/style/fashion-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede.</p>\r\n', '\r\n<p>Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>', 1, 109, '2009-09-04 08:40:24', 42, '', '2011-09-01 07:13:15', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:40:24', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(243, 378, 'Quisque Suspendisse consequat', 'quisque-suspendisse-consequat', '<p><img class="caption" src="images/stories/demo/style/food-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n', '\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 110, '2008-04-11 09:37:21', 42, '', '2011-09-01 07:19:42', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:37:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(244, 379, 'Podcast: the awards ceremony', 'podcast-the-awards-ceremony', '<p><img class="caption" src="images/stories/demo/style/food-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat.</p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 110, '2008-04-11 09:38:02', 42, '', '2011-09-01 07:19:31', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:38:02', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(245, 380, 'Best restaurant', 'best-restaurant', '<img src="images/stories/demo/style/food-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n\r\n', '\r\n<p> At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Pellentesque pede tincidunt tellus lorem ultrices enim tristique tincidunt sem pretium. Mollis euismod lacinia et Curabitur orci pellentesque eget Vestibulum Duis penatibus. Vestibulum Donec id congue fames auctor interdum mauris auctor tellus cursus. Odio interdum Aenean interdum egestas vitae pellentesque dictum diam nec feugiat.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 110, '2008-04-11 09:38:39', 42, '', '2011-01-28 11:40:28', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:38:39', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 903, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(246, 381, 'Vestibulum sem wisi eu at et Morbi congue', 'vestibulum-sem-wisi-eu-at-et-morbi-congue', '<p><img class="caption" src="images/stories/demo/style/drink-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium.</p>\r\n', '\r\n<p>Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>', 1, 110, '2009-09-04 08:47:03', 42, '', '2011-09-01 07:20:15', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:47:03', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(247, 382, 'Vestibulum sem wisi eu at et ', 'vestibulum-sem-wisi-eu-at-et', '<p><img class="caption" src="images/stories/demo/style/drink-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed.</p>\r\n', '\r\n<p>Felis Nullam scelerisque volutpat Morbi Curabitur enim Nam nunc fames Phasellus. Fringilla quis lorem Nam facilisi Phasellus Nam tempus diam morbi tellus. Habitant.</p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>', 1, 110, '2009-09-04 08:49:40', 42, '', '2011-09-01 07:20:44', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:49:40', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(248, 383, 'Morbi congue ac sapien sit', 'morbi-congue-ac-sapien-sit', '<p><img class="caption" src="images/stories/demo/style/drink-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet.</p>\r\n', '\r\n<p>Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>', 1, 110, '2009-09-04 08:50:47', 42, '', '2011-09-01 07:19:20', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:50:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(249, 384, 'Migrating to Joomla 3.0 - The path!', 'joomla25-news-magazine-templates', '<p><img class="caption" src="images/stories/demo/style/drink-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Et urna consectetuer males vel In nato ridig Nunc suscip. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede.</p>\r\n', '\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 110, '2009-09-04 08:56:26', 42, '', '2012-02-10 02:54:49', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:56:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 6, 2, 'Joomla 3.0 News Template, Joomla 3.0 Magazine Template', 'Experience the differences on Magazine here with Teline Joomlart 2.5 Template', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(250, 385, 'Vestibulum sem wisi congue', 'vestibulum-sem-wisi-congue', '<p><img class="caption" src="images/stories/demo/style/drink-6.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut.</p>\r\n', '\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>', 1, 110, '2009-09-04 08:59:51', 42, '', '2011-09-01 07:21:04', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:59:51', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(251, 387, 'Snooping around', 'snooping-around', '<p><img class="caption" src="images/stories/demo/style/garden-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n', '\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 111, '2008-04-11 09:55:12', 42, '', '2011-09-01 07:22:44', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:55:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(252, 388, 'Cause for alarm', 'cause-for-alarm', '<img src="images/stories/demo/style/garden-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n', '\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 111, '2008-04-11 09:56:04', 42, '', '2011-01-28 11:41:12', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:56:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(253, 389, 'Fit for a Bond baddy', 'fit-for-a-bond-baddy', '<img src="images/stories/demo/style/garden-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer eget nunc Phasellus facilisi et. At et ac pretium Sed senectus adipiscing nibh sodales laoreet id. Augue consequat Vestibulum est rutrum amet Nunc elit congue aliquam ut. </p>\r\n\r\n', '\r\n\r\n<p>Ligula lacinia dis a Vestibulum felis nunc lacinia quis ac id. Libero et turpis hendrerit sociis sociis Sed nibh Proin Aenean. Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Vestibulum scelerisque Cum a tellus et tempus elit nulla. Aenean dis nonummy metus senectus congue pellentesque. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et</p>\r\n\r\n<p>Eleifend sapien id nec urna rutrum condimentum justo wisi vitae mollis. Ante tincidunt eros augue tincidunt id ut Curabitur nonummy neque accumsan. In Phasellus nibh aliquam id auctor consectetuer nibh libero nunc Sed. Id felis id Maecenas libero ac ut ipsum eu Curabitur nibh. Eget ut ridiculus consequat dignissim at id urna Nam interdum fringilla. Phasellus augue mi.</p>\r\n\r\n<p>Tortor eget Aenean eu elit urna Nulla pellentesque hac orci id. Netus mauris Aenean natoque Nam volutpat quis molestie habitant Cras Aliquam. Tristique euismod Curabitur dolor id turpis condimentum Aliquam facilisi Phasellus lorem. Consectetuer parturient Vestibulum scelerisque Cum a tellus et tempus elit nulla. Velit consectetuer Phasellus dis nunc eget hac vestibulum mollis fames a. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et. </p>\r\n\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum. Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. </p>\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 111, '2008-04-11 09:57:45', 42, '', '2011-01-28 11:50:40', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:57:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 8, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(254, 390, 'Proin nisl urna pretium Aenean', 'proin-nisl-urna-pretium-aenean', '<p><img class="caption" src="images/stories/demo/style/garden-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer eget nunc Phasellus facilisi et. At et ac pretium Sed senectus adipiscing nibh sodales laoreet id. Augue consequat Vestibulum est rutrum amet Nunc elit congue aliquam ut.</p>\r\n', '\r\n<p>Ligula lacinia dis a Vestibulum felis nunc lacinia quis ac id. Libero et turpis hendrerit sociis sociis Sed nibh Proin Aenean. Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Vestibulum scelerisque Cum a tellus et tempus elit nulla. Aenean dis nonummy metus senectus congue pellentesque. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et</p>\r\n<p>Eleifend sapien id nec urna rutrum condimentum justo wisi vitae mollis. Ante tincidunt eros augue tincidunt id ut Curabitur nonummy neque accumsan. In Phasellus nibh aliquam id auctor consectetuer nibh libero nunc Sed. Id felis id Maecenas libero ac ut ipsum eu Curabitur nibh. Eget ut ridiculus consequat dignissim at id urna Nam interdum fringilla. Phasellus augue mi.</p>\r\n<p>Tortor eget Aenean eu elit urna Nulla pellentesque hac orci id. Netus mauris Aenean natoque Nam volutpat quis molestie habitant Cras Aliquam. Tristique euismod Curabitur dolor id turpis condimentum Aliquam facilisi Phasellus lorem. Consectetuer parturient Vestibulum scelerisque Cum a tellus et tempus elit nulla. Velit consectetuer Phasellus dis nunc eget hac vestibulum mollis fames a. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et.</p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum. Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat.</p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 111, '2008-04-11 09:57:45', 42, '', '2011-09-01 07:22:30', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:57:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(255, 391, 'At et ac pretium Sed senectus', 'at-et-ac-pretium-sed-senectus', '<img src="images/stories/demo/style/garden-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer eget nunc Phasellus facilisi et. At et ac pretium Sed senectus adipiscing nibh sodales laoreet id. Augue consequat Vestibulum est rutrum amet Nunc elit congue aliquam ut. </p>\r\n\r\n', '\r\n\r\n<p>Ligula lacinia dis a Vestibulum felis nunc lacinia quis ac id. Libero et turpis hendrerit sociis sociis Sed nibh Proin Aenean. Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Vestibulum scelerisque Cum a tellus et tempus elit nulla. Aenean dis nonummy metus senectus congue pellentesque. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et</p>\r\n\r\n<p>Eleifend sapien id nec urna rutrum condimentum justo wisi vitae mollis. Ante tincidunt eros augue tincidunt id ut Curabitur nonummy neque accumsan. In Phasellus nibh aliquam id auctor consectetuer nibh libero nunc Sed. Id felis id Maecenas libero ac ut ipsum eu Curabitur nibh. Eget ut ridiculus consequat dignissim at id urna Nam interdum fringilla. Phasellus augue mi.</p>\r\n\r\n<p>Tortor eget Aenean eu elit urna Nulla pellentesque hac orci id. Netus mauris Aenean natoque Nam volutpat quis molestie habitant Cras Aliquam. Tristique euismod Curabitur dolor id turpis condimentum Aliquam facilisi Phasellus lorem. Consectetuer parturient Vestibulum scelerisque Cum a tellus et tempus elit nulla. Velit consectetuer Phasellus dis nunc eget hac vestibulum mollis fames a. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et. </p>\r\n\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum. Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. </p>\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 111, '2008-04-11 09:57:45', 42, '', '2011-01-28 11:39:03', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:57:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(256, 392, 'Auctor et Sed at sodales', 'auctor-et-sed-at-sodales', '<img src="images/stories/demo/style/garden-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer eget nunc Phasellus facilisi et. At et ac pretium Sed senectus adipiscing nibh sodales laoreet id. Augue consequat Vestibulum est rutrum amet Nunc elit congue aliquam ut. </p>\r\n\r\n', '\r\n\r\n<p>Ligula lacinia dis a Vestibulum felis nunc lacinia quis ac id. Libero et turpis hendrerit sociis sociis Sed nibh Proin Aenean. Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Vestibulum scelerisque Cum a tellus et tempus elit nulla. Aenean dis nonummy metus senectus congue pellentesque. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et</p>\r\n\r\n<p>Eleifend sapien id nec urna rutrum condimentum justo wisi vitae mollis. Ante tincidunt eros augue tincidunt id ut Curabitur nonummy neque accumsan. In Phasellus nibh aliquam id auctor consectetuer nibh libero nunc Sed. Id felis id Maecenas libero ac ut ipsum eu Curabitur nibh. Eget ut ridiculus consequat dignissim at id urna Nam interdum fringilla. Phasellus augue mi.</p>\r\n\r\n<p>Tortor eget Aenean eu elit urna Nulla pellentesque hac orci id. Netus mauris Aenean natoque Nam volutpat quis molestie habitant Cras Aliquam. Tristique euismod Curabitur dolor id turpis condimentum Aliquam facilisi Phasellus lorem. Consectetuer parturient Vestibulum scelerisque Cum a tellus et tempus elit nulla. Velit consectetuer Phasellus dis nunc eget hac vestibulum mollis fames a. Auctor et Sed at sodales hendrerit pretium Nam convallis nibh et. </p>\r\n\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum. Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. </p>\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>', 1, 111, '2008-04-11 09:57:45', 42, '', '2011-01-28 11:39:45', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:57:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(257, 393, 'Ipsum sagittis venenatis Phasellus', 'ipsum-sagittis-venenatis-phasellus', '<p><img class="caption" src="images/stories/demo/style/home-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede.</p>\r\n', '\r\n<p>Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>', 1, 111, '2009-09-04 08:42:53', 42, '', '2011-09-01 07:22:21', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:42:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(258, 394, 'Curabitur euismod tincidunt Aenean ante', 'curabitur-euismod-tincidunt-aenean-ante', '<img src="images/stories/demo/style/home-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed. Felis Nullam scelerisque volutpat.</p>\r\n\r\n', '\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>', 1, 111, '2009-09-04 08:45:25', 42, '', '2011-01-28 11:44:29', 42, 0, '0000-00-00 00:00:00', '2009-09-04 08:45:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 1, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(259, 396, 'Karcher K2900M pressure washer', 'karcher-k2900m-pressure-washer', '<p><img class="caption" src="images/stories/demo/style/shop-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.</p>\r\n', '\r\n<p>Vitae Quisque justo tincidunt suscipit nec enim est tellus sapien Pellentesque. Aenean dis nonummy metus senectus congue pellentesque id pellentesque Curabitur elit. Odio ac accumsan malesuada semper tortor risus hac ut eget feugiat. Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent.</p>\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 112, '2008-04-11 10:10:59', 42, '', '2011-09-01 08:06:09', 42, 0, '0000-00-00 00:00:00', '2008-04-11 10:10:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(260, 397, 'Plug multiplier', '117424934', '<img src="images/stories/demo/style/shop-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n\r\n', '\r\n\r\n<p> At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 112, '2008-04-11 10:14:47', 42, '', '2009-08-31 07:42:43', 62, 0, '0000-00-00 00:00:00', '2008-04-11 10:14:47', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 3, '', 1, '*', ''),
(261, 398, 'Multi-purpose oval roaster', '1222165118', '<img src="images/stories/demo/style/shop-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl. </p>\r\n\r\n\r\n', '\r\n\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices.</p>\r\n\r\n<ul>\r\n<li><a href="#" title="Sample link">Pellentesque nec porta ipsum massa risus</a></li>\r\n<li><a href="#" title="Sample link">Curabitur Praesent Nam Donec Quisque</a></li>\r\n</ul>\r\n\r\n<p>Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 112, '2008-04-11 10:15:14', 42, '', '2009-08-31 07:42:27', 62, 0, '0000-00-00 00:00:00', '2008-04-11 10:15:14', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 14, '', 0, '*', ''),
(262, 399, 'Enim sollicitudin habitasse', 'enim-sollicitudin-habitasse', '<img src="images/stories/demo/style/shop-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>\r\n\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc. </p>\r\n\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 112, '2009-09-04 09:07:39', 42, '', '2011-01-28 11:48:09', 42, 0, '0000-00-00 00:00:00', '2009-09-04 09:07:39', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(263, 400, 'Rhoncus tellus eros enim netus', '1997173620', '<img src="images/stories/demo/style/shop-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed. Felis Nullam scelerisque volutpat Morbi Curabitur enim Nam nunc fames Phasellus. Fringilla quis lorem Nam facilisi Phasellus Nam tempus diam morbi tellus. Habitant.</p>\r\n\r\n', '\r\n\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus. </p>\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>', 1, 112, '2009-09-04 09:12:17', 42, '', '2009-09-04 09:17:11', 62, 0, '0000-00-00 00:00:00', '2009-09-04 09:12:17', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(264, 401, 'Vestibulum sem wisi', '1182389665', '<img src="images/stories/demo/style/shop-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n\r\n', '\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>\r\n\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc. </p>', 1, 112, '2009-09-04 09:17:15', 42, '', '2009-09-04 09:19:33', 62, 0, '0000-00-00 00:00:00', '2009-09-04 09:17:15', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(265, 402, 'Morbi congue ac sapien sit', '478080734', '<img src="images/stories/demo/style/shop-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n\r\n', '\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>\r\n\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc. </p>\r\n\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 112, '2009-09-04 09:19:36', 42, '', '2009-09-04 09:22:36', 62, 0, '0000-00-00 00:00:00', '2009-09-04 09:19:36', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(266, 403, 'Ipsum sagittis venenatis', 'ipsum-sagittis-venenatis', '<p><img class="caption" src="images/stories/demo/style/shop-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer Aenean Nulla est nisl cursus. Eget enim eget et nunc urna libero augue convallis lacinia gravida. Et eros quis eget et vel turpis est nec ultrices Aliquam. Felis quam id vitae condimentum commodo Vivamus nascetur Suspendisse pellentesque Nunc. Nulla Mauris lacus at congue sem Nulla interdum sollicitudin dictumst nunc. Dolor ac Vestibulum.</p>\r\n', '\r\n<p>Sem tincidunt urna amet eros nec metus elit nibh sagittis et. Elit et mauris ut sollicitudin convallis interdum lacus sapien sed Curabitur. Interdum gravida massa quis ac nibh Integer eget eu non Sed. Felis Nullam scelerisque volutpat Morbi Curabitur enim Nam nunc fames Phasellus. Fringilla quis lorem Nam facilisi Phasellus Nam tempus diam morbi tellus. Habitant.</p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>', 1, 112, '2009-09-04 09:22:39', 42, '', '2011-09-01 07:42:46', 42, 0, '0000-00-00 00:00:00', '2009-09-04 09:22:39', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(267, 405, 'Eu congue orci nascetur tellus Lorem', 'eu-congue-orci-nascetur-tellus-lorem', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/style/mother-3.jpg" />\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. </p>\r\n\r\n', '\r\n\r\n<p>Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et. Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>\r\n\r\n<p>Aenean tempus consequat euismod Pellentesque Aenean nec dictumst urna egestas tellus. Leo egestas pretium mattis quam Vestibulum enim natoque Maecenas dolor tempor. Orci Morbi nibh Vivamus at nunc enim consequat pellentesque orci elit. Amet porttitor et mauris Vestibulum semper metus tellus ipsum rhoncus dolor. Sem magnis id sed dictum pellentesque vel ante vitae purus netus. Eros volutpat sapien consequat Curabitur Vestibulum mus Vestibulum interdum dictum laoreet. Porttitor.</p>\r\n\r\n<p>Tempor ipsum et et nec in laoreet ornare convallis Curabitur Nam. Consectetuer ut nulla ullamcorper condimentum Duis tincidunt leo condimentum mauris elit. Et laoreet auctor nibh est Curabitur sodales sodales consectetuer mauris Fusce. Nulla Vivamus id Integer rhoncus enim Aliquam volutpat et leo nunc. Donec eros nulla molestie dui neque elit suscipit libero ut eleifend. Molestie.</p>', 1, 113, '2008-04-14 02:12:12', 42, '', '2011-01-28 11:49:22', 42, 0, '0000-00-00 00:00:00', '2008-04-14 02:12:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(268, 406, 'Est Cum elit consectetuer consectetuer', 'est-cum-elit-consectetuer-consectetuer', '<img src="images/stories/demo/style/mother-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n\r\n', '\r\n\r\n<p> At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>\r\n\r\n<p>Justo interdum mollis a enim volutpat Curabitur facilisi Aenean at elit. Justo est non dis elit ullamcorper tellus pharetra adipiscing eget ante. Neque libero natoque Nunc egestas fermentum senectus mauris at metus Integer. Velit quis Sed Sed Nam felis sagittis a Mauris ac rutrum. Nulla et habitant et tellus ipsum lacinia ac hendrerit Sed ac. Fames pellentesque et Aenean et neque convallis.</p>', 1, 113, '2008-04-11 09:37:21', 42, '', '2011-01-28 11:48:34', 42, 0, '0000-00-00 00:00:00', '2008-04-11 09:37:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(269, 407, 'Nibh vitae metus eget ut condimentum', 'nibh-vitae-metus-eget-ut-condimentum', '<p><img class="caption" src="images/stories/demo/style/mother-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh vitae metus eget ut condimentum eros tellus pede enim auctor. Vel platea mi dolor ut vitae fringilla metus pretium est elit. Ut Mauris elit ipsum Pellentesque nec porta ipsum massa risus nisl.</p>\r\n', '\r\n<p>At lacinia nulla porta Nam Nam porta at tristique ipsum ante. Libero euismod ac orci condimentum Vestibulum Nam et Praesent. Orci nibh tellus wisi dapibus justo Curabitur Praesent Nam Donec Quisque. Nulla orci sagittis pretium neque sapien orci nulla Vestibulum vitae at. Est Cum elit consectetuer consectetuer semper Maecenas augue enim felis Nam. Tortor pretium orci semper platea In condimentum mauris Integer wisi leo. Nibh leo a mauris ipsum justo convallis nunc at orci Fusce. Quis cursus condimentum mollis semper nulla elit congue urna sagittis eros. Fringilla.</p>\r\n<p>Nunc nunc congue in quis quis vitae semper tempor nunc quam. Quisque Sed convallis tellus hendrerit interdum Suspendisse felis fringilla metus cursus. Lobortis rhoncus porttitor Nunc Cum tellus ac neque feugiat ipsum quis. Ipsum lorem Vestibulum Nam lacinia Curabitur euismod eu urna neque nibh. Donec elit Integer malesuada eros dolor Suspendisse id ornare tincidunt Morbi. Nisl libero ac fermentum vel sed laoreet justo tempus magna.</p>\r\n<p>Pellentesque vitae Quisque Suspendisse consequat in metus cursus a ullamcorper tellus. At wisi quam molestie quis In Quisque vel euismod nibh ornare. Tincidunt at mauris accumsan tincidunt et felis sagittis fermentum sed Nulla. Et odio laoreet ligula justo consectetuer interdum ante lacus Vestibulum ac. Ligula tincidunt pede id id condimentum nulla elit porttitor dui eget. Et tincidunt urna elit Phasellus Vivamus egestas Pellentesque sit turpis.</p>\r\n<p>Lacinia vitae In ante ipsum Sed nec dapibus et orci dictumst. Vel lacus amet dictumst et sapien est ac Curabitur pellentesque ultrices. Feugiat convallis turpis massa ligula sagittis enim aliquet fringilla orci pretium. Ut Aenean Vestibulum suscipit eros pede et nibh laoreet Pellentesque mus. Aliquet ultrices dictumst justo justo tortor vitae nisl nec sem.</p>', 1, 113, '2008-04-11 10:14:47', 42, '', '2011-09-01 07:23:19', 42, 0, '0000-00-00 00:00:00', '2008-04-11 10:14:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(270, 408, 'Augue turpis eget In elit pellentesque', 'augue-turpis-eget-in-elit-pellentesque', '<img src="images/stories/demo/style/mother-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum.</p>\r\n\r\n', '\r\n\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit. </p>\r\n\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc. </p>\r\n\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 113, '2009-09-04 09:25:07', 42, '', '2011-01-28 11:40:11', 42, 0, '0000-00-00 00:00:00', '2009-09-04 09:25:07', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(271, 409, 'Montes nibh justo faucibus sit orci sed', 'montes-nibh-justo-faucibus-sit-orci-sed', '<p><img class="caption" src="images/stories/demo/style/mother-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n', '\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>', 1, 113, '2009-09-04 09:30:53', 42, '', '2011-09-01 07:23:29', 42, 0, '0000-00-00 00:00:00', '2009-09-04 09:30:53', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(272, 410, 'Morbi faucibus Sed Vivamus odio', 'morbi-faucibus-sed-vivamus-odio', '<p><img class="caption" src="images/stories/demo/style/mother-6.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Et urna consectetuer malesuada vel In natoque ridiculus gravida Nunc suscipit. Montes nibh justo faucibus sit orci sed pede dolor Nam risus. Tristique vitae rutrum semper Curabitur Nulla felis facilisi nec interdum pede. Tortor est Aenean porttitor pellentesque pharetra Aliquam turpis eros Nulla augue. Maecenas at leo tellus ut cursus pellentesque ut neque enim felis. Sed justo malesuada nibh semper odio tellus urna a augue lacus.</p>\r\n', '\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>', 1, 113, '2009-09-04 09:35:11', 42, '', '2011-09-01 07:23:10', 42, 0, '0000-00-00 00:00:00', '2009-09-04 09:35:11', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(273, 411, 'Rhoncus tellus eros enim netus', 'rhoncus-tellus-eros-enim-netus', '<p><img class="caption" src="images/stories/demo/style/mother-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ipsum sagittis venenatis Phasellus pretium pretium Suspendisse lorem accumsan non montes. Tellus ultrices Vestibulum at a porttitor ut pede elit nec laoreet. Egestas In semper auctor Pellentesque Quisque id In justo risus pretium. Curabitur mauris elit porta fringilla dictumst sollicitudin Nam a lacus ut. Cursus feugiat In Sed et tincidunt orci iaculis Duis.</p>\r\n', '\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 113, '2009-09-04 09:38:07', 42, '', '2011-09-01 07:23:52', 42, 0, '0000-00-00 00:00:00', '2009-09-04 09:38:07', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(274, 412, 'Porttitor ipsum mauris non semper', 'porttitor-ipsum-mauris-non-semper', '<p><img class="caption" src="images/stories/demo/style/mother-8.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque.</p>\r\n', '\r\n<p>Rhoncus tellus eros enim netus Phasellus Curabitur euismod tincidunt Aenean ante. Id vitae Aliquam dui nibh eros et Phasellus eu sociis Curabitur. Dignissim sagittis tristique interdum dolor ac porttitor Sed a sapien a. Orci mus Vivamus nibh nibh hendrerit congue scelerisque at Lorem sit. Augue turpis eget In elit pellentesque Aliquam lacinia urna felis et. Lacus et accumsan pede et laoreet.</p>\r\n<p>Vestibulum sem wisi eu at et Morbi congue ac sapien sit. Morbi faucibus Sed Vivamus odio semper Aliquam lacus ac malesuada congue. Adipiscing nibh sagittis semper Quisque laoreet sagittis rhoncus justo Ut vitae. Nulla id Nulla quam magna tristique Nulla elit Donec morbi non. Eget malesuada Nulla sem tellus pede enim diam eget nunc felis. Ultrices facilisi fermentum ut elit urna senectus semper tristique enim quis. Orci laoreet.</p>\r\n<p>Enim sollicitudin habitasse Nam et ante dictumst lacus metus libero ridiculus. Porttitor ipsum mauris non semper commodo volutpat felis aliquam pretium ac. Auctor Nunc nisl Sed congue euismod eu pulvinar volutpat condimentum eu. Auctor leo metus at dui Vestibulum vel eros sapien elit elit. Risus pretium auctor consequat Nam Suspendisse quis Nam ac vitae.</p>\r\n<p>Nunc feugiat venenatis diam ipsum augue semper condimentum id feugiat justo. Nunc Morbi mauris amet ut tincidunt Curabitur urna laoreet Aenean ac. Id nibh accumsan et id vitae habitant scelerisque tincidunt non id. Tincidunt Donec interdum velit consequat neque metus parturient Suspendisse laoreet leo. Semper Lorem Maecenas nibh Aenean dui urna et sagittis faucibus elit.</p>\r\n<p>A Phasellus eget lobortis purus et quis sit justo lacus consequat. Donec consequat eu rutrum eget augue senectus nunc dictum augue wisi. Et et penatibus Vivamus id Nunc pellentesque pede nisl Phasellus magna. Habitant justo gravida tempus porttitor dapibus ac Aliquam neque congue scelerisque. Pellentesque aliquam urna interdum interdum et id ac dapibus congue nunc.</p>\r\n<p>Sem lobortis id hendrerit pretium Suspendisse ut felis In aliquet mauris. Mauris Morbi augue Nunc mi cursus netus turpis malesuada sit ac. Id tristique a Nunc ligula morbi Pellentesque semper diam In enim. Nibh felis augue Donec cursus adipiscing id laoreet Duis lacus a. Suspendisse penatibus tempus sollicitudin at Cras congue ut.</p>', 1, 113, '2009-09-04 09:42:56', 42, '', '2011-09-01 07:23:37', 42, 0, '0000-00-00 00:00:00', '2009-09-04 09:42:56', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(275, 414, 'In id metus laoreet dignissim vel', 'in-id-metus-laoreet-dignissim-vel', '<p><img class="caption" src="images/stories/demo/style/wife-3.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus.</p>\r\n', '\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n<h2>This is an heading 2</h2>\r\n<ol>\r\n<li>Nibh volutpat tortor augue convallis aliquam</li>\r\n<li>Dolor ut id enim dolor auctor a Aenean</li>\r\n<li>Sed nibh dui Vestibulum sed ante fringilla est leo</li>\r\n</ol>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 114, '2008-04-16 02:26:18', 42, '', '2011-09-01 07:24:18', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(276, 415, 'Wenger\'s recipe for success', 'wengers-recipe-for-success', '<p><img class="caption" src="images/stories/demo/style/wife-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Fringilla ut Aenean suscipit ut lorem ac dui Nulla senectus eget. Et et Curabitur iaculis leo ullamcorper ut leo interdum enim elit. Faucibus quis eget felis Maecenas Fusce ornare pretium Vestibulum Pellentesque sagittis.</p>\r\n', '\r\n<p>Senectus consequat Nulla tempus elit nulla neque wisi consectetuer a Phasellus. Lacinia eros nibh malesuada ante In tellus ornare Vestibulum risus et. Tempus eget at Pellentesque et lacus Morbi tempus nec.</p>\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at.</p>\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt.</p>\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n<p>Lorem ipsum dolor sit amet consectetuer ut mauris at Nam id. Nam nec semper quis congue Donec netus odio eu id consequat. Massa enim semper pellentesque Cras Sed neque congue dolor habitasse dui. Tempus In cursus Vestibulum Quisque at at ut dolor ut a. Tincidunt elit Integer venenatis Vestibulum libero at id orci dolor justo. Ornare dictum non orci ligula odio tempor orci neque urna Nam. Ornare vitae vitae.</p>\r\n<p class="box-grey">Vestibulum libero habitant sapien aliquet tortor Aenean lacinia laoreet justo sapien. Enim Pellentesque augue leo et montes consequat enim justo elit Nam. Feugiat cursus malesuada dui mollis fermentum justo congue nec nibh feugiat. Gravida justo nec risus ligula pede metus senectus tempor Maecenas massa. Laoreet nulla eros id congue ante purus scelerisque mauris semper elit. Duis Vestibulum cursus.</p>\r\n<p>Semper augue dolor tellus at vel magna vitae et Aliquam Vestibulum. Ut Sed eu orci auctor tellus interdum ac tincidunt id est. In rhoncus nibh Curabitur Curabitur quis massa mattis eget tincidunt cursus. Tortor ipsum nec cursus laoreet vitae feugiat id pellentesque Aenean Sed. Natoque Nulla risus magna justo Sed Phasellus leo.</p>\r\n<p>Scelerisque velit semper Suspendisse sociis consectetuer consequat Vestibulum semper vel interdum. Sed faucibus adipiscing augue justo nec cursus eget commodo semper lacinia. Donec tellus Sed porttitor Nullam natoque urna ac ut odio ut. Pellentesque enim Suspendisse natoque tellus risus Nam convallis dui ac massa. Urna id Nulla Nullam Sed mauris et ac sagittis Cum nunc. Vitae.</p>', 1, 114, '2008-04-14 08:10:21', 42, '', '2011-09-01 07:24:48', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:10:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(277, 416, 'Glorious Goodwood photos ', 'glorious-goodwood-photos', '<img src="images/stories/demo/style/wife-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor.</p>\r\n\r\n', '\r\n\r\n<p> Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut. Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>\r\n\r\n<p>Vestibulum eu Nam neque libero eros Nunc dui In in tellus. Tellus id tincidunt Duis tristique id Curabitur ridiculus interdum ante ipsum. Nibh Nam condimentum mus eu consectetuer tellus consequat Vestibulum quis turpis. Faucibus vel risus Nullam mollis iaculis Pellentesque at pretium tincidunt pharetra. Et Vestibulum id nibh interdum a dis lacinia fringilla id tincidunt. Sem interdum Curabitur urna eu fringilla orci suscipit.</p>', 1, 114, '2008-04-14 08:47:04', 42, '', '2011-01-28 11:51:14', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:47:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(278, 417, 'Semper senectus elit eu nibh auctor', 'semper-senectus-elit-eu-nibh-auctor', '<p><img class="caption" src="images/stories/demo/style/wife-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Metus vitae pretium habitasse urna lorem Pellentesque Morbi vel metus Vestibulum. Ac tellus ut In sem semper eros congue nunc id Aenean. Purus et Nam ut mauris congue nibh dolor et convallis tortor.</p>\r\n', '\r\n<p>Semper senectus elit eu nibh auctor vel Vestibulum in arcu malesuada. Curabitur natoque condimentum feugiat wisi pede sed sem dis porta nibh. Libero et ut nibh wisi id habitant scelerisque Suspendisse vitae orci. Dignissim montes ut. Vivamus malesuada interdum eget Pellentesque ligula ante Aliquam Nulla tincidunt ullamcorper. Morbi laoreet ipsum Nullam Integer turpis platea mi Ut nec tincidunt. Nisl eget turpis morbi at dolor lacus Phasellus vitae pretium metus. Curabitur a nonummy Nulla auctor enim Vivamus consequat ac orci Vestibulum. Justo lobortis odio aliquam risus Sed Integer sagittis sed Sed risus. Et turpis id porttitor egestas.</p>\r\n<p>Semper Vestibulum consequat in euismod auctor volutpat semper Ut semper auctor. Eget wisi iaculis nisl sem cursus at porttitor volutpat Sed facilisi. Pede condimentum elit velit vitae risus ullamcorper Morbi Phasellus sapien sed. Et pretium cursus lacus vitae aliquet pharetra Vestibulum elit hac a. Nulla id libero nulla Cras sed tincidunt est semper laoreet Pellentesque. Tortor felis Curabitur sed vel in justo pulvinar lacus pellentesque Phasellus. Non sit.</p>\r\n<p>Ut nibh dui fames justo cursus augue Curabitur Curabitur dui consectetuer. Tortor Nulla quis suscipit hendrerit semper eget neque vel id leo. Quis dui In quam eu platea nec vitae sit et turpis. Pulvinar lacus pede nonummy tortor Phasellus Praesent tempus Ut sed Morbi. Tellus Mauris nibh Nam adipiscing cursus Vestibulum Maecenas pellentesque elit consectetuer. Wisi vel.</p>\r\n<p>Vestibulum eu Nam neque libero eros Nunc dui In in tellus. Tellus id tincidunt Duis tristique id Curabitur ridiculus interdum ante ipsum. Nibh Nam condimentum mus eu consectetuer tellus consequat Vestibulum quis turpis. Faucibus vel risus Nullam mollis iaculis Pellentesque at pretium tincidunt pharetra. Et Vestibulum id nibh interdum a dis lacinia fringilla id tincidunt. Sem interdum Curabitur urna eu fringilla orci suscipit.</p>', 1, 114, '2008-04-14 08:47:04', 42, '', '2011-09-01 07:24:08', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:47:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(279, 418, 'Vel dolor ligula tristique magnis', 'vel-dolor-ligula-tristique-magnis', '<p><img class="caption" src="images/stories/demo/style/wife-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Fringilla ut Aenean suscipit ut lorem ac dui Nulla senectus eget. Et et Curabitur iaculis leo ullamcorper ut leo interdum enim elit. Faucibus quis eget felis Maecenas Fusce ornare pretium Vestibulum Pellentesque sagittis.</p>\r\n', '\r\n<p>Senectus consequat Nulla tempus elit nulla neque wisi consectetuer a Phasellus. Lacinia eros nibh malesuada ante In tellus ornare Vestibulum risus et. Tempus eget at Pellentesque et lacus Morbi tempus nec.</p>\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at.</p>\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt.</p>\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n<p>Lorem ipsum dolor sit amet consectetuer ut mauris at Nam id. Nam nec semper quis congue Donec netus odio eu id consequat. Massa enim semper pellentesque Cras Sed neque congue dolor habitasse dui. Tempus In cursus Vestibulum Quisque at at ut dolor ut a. Tincidunt elit Integer venenatis Vestibulum libero at id orci dolor justo. Ornare dictum non orci ligula odio tempor orci neque urna Nam. Ornare vitae vitae.</p>\r\n<p class="box-grey">Vestibulum libero habitant sapien aliquet tortor Aenean lacinia laoreet justo sapien. Enim Pellentesque augue leo et montes consequat enim justo elit Nam. Feugiat cursus malesuada dui mollis fermentum justo congue nec nibh feugiat. Gravida justo nec risus ligula pede metus senectus tempor Maecenas massa. Laoreet nulla eros id congue ante purus scelerisque mauris semper elit. Duis Vestibulum cursus.</p>\r\n<p>Semper augue dolor tellus at vel magna vitae et Aliquam Vestibulum. Ut Sed eu orci auctor tellus interdum ac tincidunt id est. In rhoncus nibh Curabitur Curabitur quis massa mattis eget tincidunt cursus. Tortor ipsum nec cursus laoreet vitae feugiat id pellentesque Aenean Sed. Natoque Nulla risus magna justo Sed Phasellus leo.</p>\r\n<p>Scelerisque velit semper Suspendisse sociis consectetuer consequat Vestibulum semper vel interdum. Sed faucibus adipiscing augue justo nec cursus eget commodo semper lacinia. Donec tellus Sed porttitor Nullam natoque urna ac ut odio ut. Pellentesque enim Suspendisse natoque tellus risus Nam convallis dui ac massa. Urna id Nulla Nullam Sed mauris et ac sagittis Cum nunc. Vitae.</p>', 1, 114, '2008-04-14 08:10:21', 42, '', '2011-09-01 07:24:40', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:10:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(280, 419, 'Aenean Vestibulum lorem egestas', 'aenean-vestibulum-lorem-egestas', '<img src="images/stories/demo/style/wife-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi.</p>\r\n\r\n', '\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 114, '2008-04-16 02:26:18', 42, '', '2011-01-28 11:31:27', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(281, 420, 'Sed nibh dui Vestibulum sed ante fringilla est leo', 'sed-nibh-dui-vestibulum-sed-ante-fringilla-est-leo', '<p><img class="caption" src="images/stories/demo/style/wife-7.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis.</p>\r\n', '\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 114, '2008-04-16 02:26:18', 42, '', '2011-09-01 07:24:31', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:26:18', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(282, 421, 'Habitant lobortis vitae pretium vitae vitae', 'habitant-lobortis-vitae-pretium-vitae-vitae', '<img src="images/stories/demo/style/wife-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Fringilla ut Aenean suscipit ut lorem ac dui Nulla senectus eget. Et et Curabitur iaculis leo ullamcorper ut leo interdum enim elit. Faucibus quis eget felis Maecenas Fusce ornare pretium Vestibulum Pellentesque sagittis. </p>\r\n\r\n', '\r\n<p>Senectus consequat Nulla tempus elit nulla neque wisi consectetuer a Phasellus. Lacinia eros nibh malesuada ante In tellus ornare Vestibulum risus et. Tempus eget at Pellentesque et lacus Morbi tempus nec.</p>\r\n\r\n<p>Nibh risus Aenean porttitor pretium sem tempus vitae turpis volutpat consectetuer. Natoque pellentesque orci et ipsum vel a a quis porta et. Vitae senectus semper vel et et malesuada nec nibh Suspendisse amet. Vestibulum Vestibulum Curabitur pellentesque sem augue Donec Aliquam nibh semper quis. Lorem eget nunc Cum aliquet Nunc dui in Quisque eu at. </p>\r\n\r\n<p>Vel dolor ligula tristique magnis sit nunc neque commodo eros convallis. Sed sapien orci ut interdum dolor vel tempus id ipsum consectetuer. Ut eros egestas massa In porttitor sagittis Donec cursus Curabitur sed. Mauris Vivamus sociis et mauris ullamcorper Vestibulum ac lacus nibh metus. Iaculis sem turpis Curabitur Vestibulum Phasellus Pellentesque nec pede quis Fusce. Mattis habitasse tellus sem id magna libero Morbi lacus id habitasse. Sed lobortis arcu.</p>\r\n\r\n<p>Congue lacus Vivamus est at sed facilisis eu tincidunt Sed vitae. Porttitor nec nisl convallis auctor convallis amet facilisis Phasellus pharetra ut. Penatibus pretium tincidunt ridiculus molestie eros id pellentesque elit ridiculus ac. Tincidunt nisl lacinia metus Nam adipiscing nibh Curabitur Aliquam eu eu. Malesuada mi turpis eget accumsan eleifend Sed augue habitasse Quisque ornare. Eget Sed Nullam Curabitur lorem.</p>\r\n\r\n<p>Elit a nunc auctor vitae Maecenas tortor scelerisque dignissim semper eleifend. Nibh non Aenean ut velit eleifend id Phasellus netus laoreet morbi. Id condimentum eu habitant vel amet gravida porttitor Vestibulum consectetuer nibh. In elit Mauris ut id nonummy orci fringilla molestie sit fringilla. Malesuada interdum Nam nisl leo sem elit vel pretium mauris tincidunt. </p>\r\n\r\n<p>Phasellus nunc aliquet leo arcu turpis Donec Curabitur consequat Quisque vitae. Habitant lobortis vitae pretium vitae vitae ac penatibus ipsum mus Nam. Curabitur et vitae interdum Vivamus pede nunc vitae morbi tempor lorem. Consequat malesuada id Nulla ut dignissim pede dignissim eros faucibus porttitor. Integer eros sed Ut id Quisque odio adipiscing Nullam ipsum dictumst. Eros.</p>\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer ut mauris at Nam id. Nam nec semper quis congue Donec netus odio eu id consequat. Massa enim semper pellentesque Cras Sed neque congue dolor habitasse dui. Tempus In cursus Vestibulum Quisque at at ut dolor ut a. Tincidunt elit Integer venenatis Vestibulum libero at id orci dolor justo. Ornare dictum non orci ligula odio tempor orci neque urna Nam. Ornare vitae vitae.</p>\r\n\r\n<p class="box-grey">Vestibulum libero habitant sapien aliquet tortor Aenean lacinia laoreet justo sapien. Enim Pellentesque augue leo et montes consequat enim justo elit Nam. Feugiat cursus malesuada dui mollis fermentum justo congue nec nibh feugiat. Gravida justo nec risus ligula pede metus senectus tempor Maecenas massa. Laoreet nulla eros id congue ante purus scelerisque mauris semper elit. Duis Vestibulum cursus.</p>\r\n\r\n<p>Semper augue dolor tellus at vel magna vitae et Aliquam Vestibulum. Ut Sed eu orci auctor tellus interdum ac tincidunt id est. In rhoncus nibh Curabitur Curabitur quis massa mattis eget tincidunt cursus. Tortor ipsum nec cursus laoreet vitae feugiat id pellentesque Aenean Sed. Natoque Nulla risus magna justo Sed Phasellus leo.</p>\r\n\r\n<p>Scelerisque velit semper Suspendisse sociis consectetuer consequat Vestibulum semper vel interdum. Sed faucibus adipiscing augue justo nec cursus eget commodo semper lacinia. Donec tellus Sed porttitor Nullam natoque urna ac ut odio ut. Pellentesque enim Suspendisse natoque tellus risus Nam convallis dui ac massa. Urna id Nulla Nullam Sed mauris et ac sagittis Cum nunc. Vitae.</p>', 1, 114, '2008-04-14 08:10:21', 42, '', '2011-01-28 11:51:35', 42, 0, '0000-00-00 00:00:00', '2008-04-14 08:10:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(283, 424, 'Who\'s your daddy? A celebrity look-alike', '2023712157', '<img src="images/stories/demo/health/health-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Consequat ante parturient fringilla quis consectetuer tincidunt a in justo metus. Malesuada est Integer nibh velit ac quis parturient est libero cursus. </p>\r\n\r\n', '\r\n\r\n<p>Tempor natoque nec et Curabitur at nec Praesent consequat ut enim. Laoreet ullamcorper Curabitur pretium consectetuer lobortis dictumst Sed cursus pellentesque Donec. Nisl Phasellus vitae Aenean condimentum justo. Tincidunt leo id nec interdum pede sapien at purus velit justo. Elit Integer Aenean in consequat fringilla Donec Vestibulum Aliquam eu lacinia. Ut velit auctor tristique eget urna tristique est congue cursus mauris. Id facilisis mauris sapien tempus elit pretium cursus libero ac tincidunt. Mattis id ut Vestibulum laoreet cursus Sed sit tempor nibh quis. Mauris Nam orci adipiscing et quis congue Ut amet fringilla.</p>\r\n\r\n<p>Neque semper et massa orci accumsan venenatis tellus laoreet feugiat Curabitur. Condimentum porta id faucibus sit montes a dui nulla cursus nunc. Nec et congue et et Vestibulum Ut Vivamus eget Ut habitant. Velit auctor accumsan Donec ullamcorper eget sed ullamcorper penatibus laoreet id. Nam a lacus ac vitae vel elit porttitor nec at laoreet. Neque nunc.</p>\r\n\r\n<p>Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a. Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo. Nam nibh adipiscing turpis wisi gravida quis elit quis pellentesque turpis. Senectus sagittis ridiculus Curabitur elit pretium mus et Nam mattis.</p>\r\n\r\n<p>Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu.</p>\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>', 1, 116, '2008-04-14 02:07:04', 42, '', '2013-07-30 09:06:58', 42, 0, '0000-00-00 00:00:00', '2008-04-14 02:07:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 6, '', '', 1, 0, '{"tags":[11,3,12],"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(284, 425, 'Mommies who drink: No joking after the Schuler tragedy', '811849379', '<img src="images/stories/demo/health/health-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Tincidunt leo id nec interdum pede sapien at purus velit justo. Elit Integer Aenean in consequat fringilla Donec Vestibulum Aliquam eu lacinia. </p>\r\n\r\n', '\r\n\r\n<p>Ut velit auctor tristique eget urna tristique est congue cursus mauris. Id facilisis mauris sapien tempus elit pretium cursus libero ac tincidunt. Mattis id ut Vestibulum laoreet cursus Sed sit tempor nibh quis. Mauris Nam orci adipiscing et quis congue Ut amet fringilla. Neque semper et massa orci accumsan venenatis tellus laoreet feugiat Curabitur. Condimentum porta id faucibus sit montes a dui nulla cursus nunc. Nec et congue et et Vestibulum Ut Vivamus eget Ut habitant. Velit auctor accumsan Donec ullamcorper eget sed ullamcorper penatibus laoreet id. Nam a lacus ac vitae vel elit porttitor nec at laoreet. Neque nunc.</p>\r\n\r\n<p>Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a. Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo. Nam nibh adipiscing turpis wisi gravida quis elit quis pellentesque turpis. Senectus sagittis ridiculus Curabitur elit pretium mus et Nam mattis.</p>\r\n\r\n<p>Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu.</p>\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>\r\n\r\n<p>Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>', 1, 116, '2008-04-14 02:07:42', 42, '', '2009-09-01 12:25:45', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:07:42', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(285, 426, 'Peanut-free night lets allergic kids enjoy game', '1119525957', '<img align="left" src="images/stories/demo/health/health-4.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Neque semper et massa orci accumsan venenatis tellus laoreet feugiat Curabitur. Condimentum porta id faucibus sit montes a dui nulla cursus nunc. Nec et congue et et Vestibulum Ut Vivamus eget Ut habitant. </p>\r\n\r\n', '\r\n\r\n<img src="images/stories/demo/health/health-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Velit auctor accumsan Donec ullamcorper eget sed ullamcorper penatibus laoreet id. Nam a lacus ac vitae vel elit porttitor nec at laoreet. Neque nunc. Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a. Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo. Nam nibh adipiscing turpis wisi gravida quis elit quis pellentesque turpis. Senectus sagittis ridiculus Curabitur elit pretium mus et Nam mattis.</p>\r\n\r\n<p>Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu.</p>\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>\r\n\r\n<p>Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At.</p>', 1, 116, '2008-04-14 02:08:55', 42, '', '2009-08-31 07:05:58', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:08:55', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 15, '', 1, '*', ''),
(286, 427, 'Nam nibh adipiscing turpis', '1373958017', '<img align="left" src="images/stories/demo/health/health-5.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a. Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo.</p>\r\n\r\n', '\r\n\r\n<img src="images/stories/demo/health/health-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Velit auctor accumsan Donec ullamcorper eget sed ullamcorper penatibus laoreet id. Nam a lacus ac vitae vel elit porttitor nec at laoreet. Neque nunc. Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a. Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo. Nam nibh adipiscing turpis wisi gravida quis elit quis pellentesque turpis. Senectus sagittis ridiculus Curabitur elit pretium mus et Nam mattis.</p>\r\n\r\n<p>Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu.</p>\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>\r\n\r\n<p>Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At.</p>', 1, 116, '2008-04-14 02:08:55', 42, '', '2009-09-01 12:17:50', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:08:55', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 23, '', 0, '*', ''),
(287, 428, 'Phasellus suscipit ante leo', '1026802602', '<img align="left" src="images/stories/demo/health/health-6.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Neque nunc. Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a.</p>\r\n\r\n', '\r\n\r\n<img src="images/stories/demo/health/health-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Velit auctor accumsan Donec ullamcorper eget sed ullamcorper penatibus laoreet id. Nam a lacus ac vitae vel elit porttitor nec at laoreet. Neque nunc. Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a. Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo. Nam nibh adipiscing turpis wisi gravida quis elit quis pellentesque turpis. Senectus sagittis ridiculus Curabitur elit pretium mus et Nam mattis.</p>\r\n\r\n<p>Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu.</p>\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>\r\n\r\n<p>Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At.</p>', 1, 116, '2008-04-14 02:08:55', 42, '', '2009-09-01 12:21:21', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:08:55', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(288, 429, 'Aliquam pretium Aenean', 'aliquam-pretium-aenean', '<img align="left" src="images/stories/demo/health/health-7.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum.</p>\r\n\r\n', '\r\n\r\n<img src="images/stories/demo/health/health-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Velit auctor accumsan Donec ullamcorper eget sed ullamcorper penatibus laoreet id. Nam a lacus ac vitae vel elit porttitor nec at laoreet. Neque nunc. Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a. Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo. Nam nibh adipiscing turpis wisi gravida quis elit quis pellentesque turpis. Senectus sagittis ridiculus Curabitur elit pretium mus et Nam mattis.</p>\r\n\r\n<p>Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu.</p>\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>\r\n\r\n<p>Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At.</p>', 1, 116, '2008-04-14 02:08:55', 42, '', '2011-01-28 11:32:31', 42, 0, '0000-00-00 00:00:00', '2008-04-14 02:08:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(289, 431, 'Sex Therapists: a Few Minutes Is Best', '1555919076', '<img src="images/stories/demo/health/diet-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel Sed nibh Aenean tincidunt enim Sed velit penatibus id lorem. Massa Morbi ligula magna Sed enim dui dui libero Vivamus orci. Libero Nunc In Curabitur Suspendisse magna montes Nullam et Sed a.</p>\r\n\r\n', '\r\n\r\n<p> Aliquam pretium Aenean volutpat sollicitudin enim Suspendisse Phasellus suscipit ante leo. Nam nibh adipiscing turpis wisi gravida quis elit quis pellentesque turpis. Senectus sagittis ridiculus Curabitur elit pretium mus et Nam mattis. Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu.</p>\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>\r\n\r\n<p>Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At.</p>\r\n\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper.</p>', 1, 117, '2008-04-14 02:09:29', 42, '', '2009-08-31 07:05:36', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:09:29', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 5, '', 0, '*', ''),
(290, 432, 'Troops Suffering Trauma Reaches 320,000', '1942865633', '<img src="images/stories/demo/health/diet-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Laoreet Aenean vitae justo et risus convallis odio malesuada metus et. Orci ut Donec ipsum condimentum cursus pretium justo interdum at convallis. Elit justo nec et vitae Nulla at faucibus neque Phasellus neque. </p>\r\n\r\n', '\r\n\r\n<p>Euismod augue est accumsan lacus suscipit volutpat lacus mauris elit nunc. Id Cras consequat congue ante nec laoreet id eu. Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique.</p>\r\n\r\n<p>Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At.</p>\r\n\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper.</p>\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>', 1, 117, '2008-04-14 02:09:54', 42, '', '2009-08-31 07:05:21', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:09:54', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 1, '', 0, '*', ''),
(291, 433, 'Three Deaths... by Infected Hamster?', '714454338', '<img src="images/stories/demo/health/diet-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum massa cursus at in ut dui massa et semper justo. Turpis eget orci libero Vestibulum ut est turpis Aenean fermentum interdum. In pretium nibh tortor augue libero Phasellus condimentum gravida consequat velit. </p>\r\n\r\n', '\r\n\r\n<p>Phasellus Pellentesque nisl Aliquam quis turpis Vestibulum pulvinar Sed ut Sed. Wisi malesuada condimentum Phasellus dis ac condimentum a Aenean et ut. Semper tristique. Amet Nulla dolor dolor Duis tincidunt et nulla augue Ut Morbi. Sagittis vitae vestibulum condimentum id est at sollicitudin vestibulum quis gravida. Nibh semper consectetuer ornare convallis Aenean quis neque mauris Aliquam Curabitur. Ut pellentesque semper Sed ornare nonummy massa pretium In hendrerit et. Pulvinar sit Nullam vitae et vel morbi congue convallis justo.</p>\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At.</p>\r\n\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper.</p>\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>', 1, 117, '2008-04-14 02:10:26', 42, '', '2009-08-31 07:05:03', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:10:26', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 5, '', 0, '*', ''),
(292, 434, 'Nutrition -- It\'s a matter of fact', '121417272', '<img src="images/stories/demo/health/diet-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec.</p>\r\n\r\n', '\r\n<p>Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in.</p>\r\n<img src="images/stories/demo/health/diet-4_1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<img src="images/stories/demo/health/diet-4_2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper.</p>\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>', 1, 117, '2008-04-14 02:10:56', 42, '', '2009-08-31 07:00:22', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:10:56', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 118, '', 1, '*', ''),
(293, 435, 'Condimentum mauris interdum velit', 'condimentum-mauris-interdum-velit', '<img src="images/stories/demo/health/diet-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent.</p>\r\n\r\n', '\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in.</p>\r\n<img src="images/stories/demo/health/diet-4_1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<img src="images/stories/demo/health/diet-4_2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper.</p>\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>', 1, 117, '2008-04-14 02:10:56', 42, '', '2011-01-28 11:41:30', 42, 0, '0000-00-00 00:00:00', '2008-04-14 02:10:56', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(294, 436, 'Turpis nonummy id Cras et', '130176867', '<img src="images/stories/demo/health/diet-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n', '\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in.</p>\r\n<img src="images/stories/demo/health/diet-4_1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<img src="images/stories/demo/health/diet-4_2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper.</p>\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>', 1, 117, '2008-04-14 02:10:56', 42, '', '2009-09-01 12:43:27', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:10:56', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 4, '', 1, '*', ''),
(295, 438, 'Drinking, Smoking May Hasten Alzheimer\'s', 'drinking-smoking-may-hasten-alzheimers', '<img align="left" src="images/stories/demo/health/family-4.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>Proin augue Donec non nascetur congue dolor dignissim Aenean Duis consectetuer. Justo Vestibulum porta et pellentesque justo quis Vestibulum in wisi Donec. Elit interdum interdum sem cursus ut metus dignissim sit ut dignissim. </p>\r\n\r\n', '\r\n\r\n<p>Vestibulum consequat turpis commodo porttitor at ut laoreet at Vestibulum ligula. Condimentum mauris interdum velit elit massa non Aenean vitae ut vitae. Ut eros et tincidunt laoreet libero ac Cras In ornare in. At. Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper.</p>\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>', 1, 118, '2008-04-14 02:11:23', 42, '', '2011-01-28 11:46:27', 42, 0, '0000-00-00 00:00:00', '2008-04-14 02:11:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(296, 439, 'New Nerve Disorder From Pig Brain Mist', '290584745', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/health/family-3.jpg"/>\r\n\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. Dictum pulvinar dictum nibh orci arcu neque pede neque diam cursus. </p>\r\n\r\n', '\r\n\r\n<p>Quam mi consequat ut ante Curabitur accumsan ante Proin Phasellus dolor. Curabitur orci gravida aliquet auctor semper. Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et.</p>\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>\r\n\r\n<p>Aenean tempus consequat euismod Pellentesque Aenean nec dictumst urna egestas tellus. Leo egestas pretium mattis quam Vestibulum enim natoque Maecenas dolor tempor. Orci Morbi nibh Vivamus at nunc enim consequat pellentesque orci elit. Amet porttitor et mauris Vestibulum semper metus tellus ipsum rhoncus dolor. Sem magnis id sed dictum pellentesque vel ante vitae purus netus. Eros volutpat sapien consequat Curabitur Vestibulum mus Vestibulum interdum dictum laoreet. Porttitor.</p>', 1, 118, '2008-04-14 02:11:45', 42, '', '2009-08-31 07:02:28', 62, 0, '0000-00-00 00:00:00', '2008-04-14 02:11:45', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 1, '', 0, '*', ''),
(297, 440, 'Help for aging parents is clicks away', 'help-for-aging-parents-is-clicks-away', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/health/family-2.jpg" />\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. </p>\r\n\r\n', '\r\n\r\n<p>Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit Curabitur et. Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>\r\n\r\n<p>Aenean tempus consequat euismod Pellentesque Aenean nec dictumst urna egestas tellus. Leo egestas pretium mattis quam Vestibulum enim natoque Maecenas dolor tempor. Orci Morbi nibh Vivamus at nunc enim consequat pellentesque orci elit. Amet porttitor et mauris Vestibulum semper metus tellus ipsum rhoncus dolor. Sem magnis id sed dictum pellentesque vel ante vitae purus netus. Eros volutpat sapien consequat Curabitur Vestibulum mus Vestibulum interdum dictum laoreet. Porttitor.</p>\r\n\r\n<p>Tempor ipsum et et nec in laoreet ornare convallis Curabitur Nam. Consectetuer ut nulla ullamcorper condimentum Duis tincidunt leo condimentum mauris elit. Et laoreet auctor nibh est Curabitur sodales sodales consectetuer mauris Fusce. Nulla Vivamus id Integer rhoncus enim Aliquam volutpat et leo nunc. Donec eros nulla molestie dui neque elit suscipit libero ut eleifend. Molestie.</p>', 1, 118, '2008-04-14 02:12:12', 42, '', '2011-01-28 11:52:10', 42, 0, '0000-00-00 00:00:00', '2008-04-14 02:12:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(298, 441, 'Feds Back Stem Cell Surgery for Vets', 'feds-back-stem-cell-surgery-for-vets', '<img src="images/stories/demo/health/family-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus massa semper accumsan Cras egestas risus enim pretium pretium risus. Et libero elit ornare pretium massa Curabitur Nulla turpis sem et. Non Praesent elit convallis malesuada ac Donec ac vel sem natoque. Risus hendrerit augue eros felis tincidunt justo urna iaculis ligula porta. Tellus risus dictum eu elit.</p>\r\n\r\n<p>Leo egestas pretium mattis quam Vestibulum semper metus tellus ipsum rhoncus dolor Vestibulum enim natoque Maecenas dolor tempor. Orci Morbi nibh Vivamus at nunc enim consequat <a href="#" title="Sample image">pellentesque orci elit.</a></p>\r\n\r\n', '\r\n\r\n<p>Tortor feugiat Vestibulum parturient sit vitae morbi eu lacus felis suscipit. Pretium laoreet et est scelerisque sapien mauris odio ornare Integer vestibulum. Quis justo massa at pretium lacinia Nulla eget congue montes semper. Aliquam cursus pede hendrerit ut nascetur ligula risus nibh libero ligula. Diam ut mauris a sagittis volutpat non pulvinar Vestibulum ut justo. Eu congue orci nascetur tellus Lorem.</p>\r\n\r\n<p>Pretium non et condimentum enim at in euismod lacinia dictumst tempus. Magna amet neque suscipit Donec iaculis nunc mauris semper urna porttitor. Malesuada Sed metus venenatis ac tincidunt laoreet Nulla Phasellus ut semper. Rhoncus Mauris elit urna eu pulvinar dictum Quisque Vivamus porttitor amet. In Quisque turpis pede Nulla laoreet Quisque pellentesque sed.</p>\r\n\r\n<p>Aenean tempus consequat euismod Pellentesque Aenean nec dictumst urna egestas tellus. Leo egestas pretium mattis quam Vestibulum enim natoque Maecenas dolor tempor. Orci Morbi nibh Vivamus at nunc enim consequat pellentesque orci elit. Amet porttitor et mauris Vestibulum semper metus tellus ipsum rhoncus dolor. Sem magnis id sed dictum pellentesque vel ante vitae purus netus. Eros volutpat sapien consequat Curabitur Vestibulum mus Vestibulum interdum dictum laoreet. Porttitor.</p>\r\n\r\n<p>Tempor ipsum et et nec in laoreet ornare convallis Curabitur Nam. Consectetuer ut nulla ullamcorper condimentum Duis tincidunt leo condimentum mauris elit. Et laoreet auctor nibh est Curabitur sodales sodales consectetuer mauris Fusce. Nulla Vivamus id Integer rhoncus enim Aliquam volutpat et leo nunc. Donec eros nulla molestie dui neque elit suscipit libero ut eleifend. Molestie.</p>', 1, 118, '2008-04-14 02:12:59', 42, '', '2011-01-28 11:49:51', 42, 0, '0000-00-00 00:00:00', '2008-04-14 02:12:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(299, 444, 'Ut fames Duis nibh arcu', '615027045', '<img src="images/stories/demo/entertaiment/e-10.jpg" alt="Movies" align="left" title="Movies" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. </p>\r\n\r\n', '\r\n\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 120, '2008-04-16 02:29:45', 42, '', '2013-07-30 09:08:39', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:29:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 8, '', '', 1, 0, '{"tags":[13,3,14],"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(300, 445, 'Et Aliquam pretium faucibus', 'et-aliquam-pretium-faucibus', '<img src="images/stories/demo/entertaiment/e-9.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer ac Vivamus Aliquam id aliquam. Orci cursus interdum pulvinar sociis vestibulum sed vestibulum est condimentum ac. </p>\r\n\r\n', '\r\n\r\n<p>Ut adipiscing Morbi rhoncus vitae id convallis Proin Lorem Curabitur dolor. Quisque eget dapibus Quisque volutpat Vivamus lacinia velit velit amet Vivamus. Sed ante elit tellus et gravida quis urna nulla Donec Sed. Urna eu urna.< Et Aliquam pretium faucibus sit magna at Sed cursus sociis at. Consectetuer mattis Lorem Nam Sed pellentesque ornare odio sit lorem sit. Morbi nulla non Curabitur sed Vestibulum nec augue tincidunt vitae condimentum. Dui Phasellus Nam pretium adipiscing dui et nec vel suscipit sollicitudin. Vestibulum scelerisque tellus ut nec a nec In et tincidunt condimentum. Ut.</p>\r\n\r\n<p>Sed id leo et vitae Nam tortor quis tortor nibh Sed. Porttitor lobortis Donec nisl turpis vitae amet ut Sed dolor Nullam. Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>', 1, 120, '2008-04-16 02:30:09', 42, '', '2011-01-28 11:48:43', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(301, 446, 'Curabitur nec enim Lorem Morbi', 'curabitur-nec-enim-lorem-morbi', '<img src="images/stories/demo/entertaiment/inter-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. </p>\r\n\r\n', '\r\n\r\n\r\n<p>Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus. Quam ligula Mauris ac a et morbi eu Vestibulum congue Aenean. Elit diam ut egestas ut et fames Integer pretium interdum molestie. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam</p>\r\n\r\n<img src="images/stories/demo/entertaiment/e-2.jpg" alt="Sample movie" align="right" title="Sample movie" class="caption" />\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>', 1, 120, '2008-04-16 02:34:22', 42, '', '2011-01-28 11:44:44', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:34:22', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 12, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(302, 447, 'Nam feugiat mi id In urna', '403288359', '<img src="images/stories/demo/entertaiment/e-11.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n\r\n', '\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 120, '2008-04-16 02:30:09', 42, '', '2009-09-01 11:20:32', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(303, 448, 'Quis eros nisl leo Duis pede', '1062446762', '<img src="images/stories/demo/entertaiment/e-12.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n\r\n', '\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 120, '2008-04-16 02:30:09', 42, '', '2009-09-01 11:24:12', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(304, 449, 'Vestibulum nec Phasellus facilisi', '968342091', '<img src="images/stories/demo/entertaiment/e-13.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n\r\n', '\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 120, '2008-04-16 02:30:09', 42, '', '2009-09-01 11:26:53', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 1, '*', ''),
(305, 450, 'Magnis nibh fringilla Vivamus', '917687151', '<img src="images/stories/demo/entertaiment/e-18.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut.</p>\r\n\r\n', '\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 120, '2008-04-16 02:30:09', 42, '', '2009-09-09 10:44:04', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(306, 451, 'Sed Phasellus laoreet condimentum', '1358043324', '<img src="images/stories/demo/entertaiment/e-17.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n\r\n', '\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 120, '2008-04-16 02:30:09', 42, '', '2009-09-09 10:43:30', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 7, '', 1, '*', ''),
(307, 453, 'Curabitur nec enim id', 'curabitur-nec-enim-id', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/entertaiment/b-2.jpg" />\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. </p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 121, '2008-04-16 02:34:59', 42, '', '2011-01-28 11:44:36', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:34:59', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(308, 454, 'Orci rutrum lacus feugiat', '2040998531', '<img align="left" src="images/stories/demo/entertaiment/b-1.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus.</p>\r\n\r\n', '\r\n\r\n<p> At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 121, '2008-04-16 02:35:58', 42, '', '2009-08-31 06:50:45', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 1, '', 1, '*', ''),
(309, 455, 'Orci rutrum lacus feugiat', '1705656333', '<img src="images/stories/demo/entertaiment/tv-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. S</p>\r\n\r\n', '\r\n<p>apien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac. Porttitor fringilla sed natoque Aliquam wisi Sed tempus pretium pretium Pellentesque. Sed congue at magna nunc sociis gravida Donec elit accumsan nonummy. Lacinia mauris nunc malesuada sed laoreet elit ipsum malesuada Aenean nunc. Commodo mus nibh ac congue Aliquam orci Donec semper ipsum elit. Mattis lacus.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>', 1, 121, '2008-04-16 02:38:46', 42, '', '2009-08-31 06:50:36', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:38:46', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 1025, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(310, 456, 'Sed interdum sed dapibus quis', '1257508015', '<img src="images/stories/demo/entertaiment/tv-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. S</p>\r\n\r\n', '\r\n<p>Malesuada Sed sit Quisque id wisi aliquam sollicitudin leo est justo. Pretium eleifend Vestibulum non tincidunt quam sed mollis porttitor adipiscing ante. Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at. Velit sed et Nulla orci dolor faucibus eu laoreet urna Phasellus. Sed arcu ante Nam Curabitur amet Curabitur consectetuer turpis In ligula. Justo Sed.</p>\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>', 1, 121, '2008-04-16 02:38:46', 42, '', '2009-09-01 11:29:24', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:38:46', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(311, 457, 'Fames Ut lorem at est tincidunt', 'fames-ut-lorem-at-est-tincidunt', '<img src="images/stories/demo/entertaiment/tv-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. </p>\r\n\r\n', '\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 121, '2008-04-16 02:38:46', 42, '', '2011-01-28 11:49:44', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:38:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(312, 458, 'Congue condimentum orci id et', 'congue-condimentum-orci-id-et', '<img src="images/stories/demo/entertaiment/tv-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n\r\n', '\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 121, '2008-04-16 02:38:46', 42, '', '2011-01-28 11:41:46', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:38:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 5, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(313, 459, 'Interdum quis Nam et id nulla', 'interdum-quis-nam-et-id-nulla', '<p><img class="caption" src="images/stories/demo/entertaiment/tv-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer.</p>\r\n', '\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 121, '2008-04-16 02:38:46', 42, '', '2011-09-01 07:34:57', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:38:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(314, 460, 'Ultrices Phasellus', '1543119049', '<img src="images/stories/demo/entertaiment/tv-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem.</p>\r\n\r\n', '\r\n\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 121, '2008-04-16 02:38:46', 42, '', '2009-09-09 10:50:11', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:38:46', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(315, 462, 'Curabitur convallis', 'curabitur-convallis', '<img src="images/stories/demo/entertaiment/e-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. </p>\r\n\r\n', '\r\n\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 122, '2008-04-16 02:39:46', 42, '', '2011-01-28 11:43:43', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:39:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 3, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(316, 463, 'Semper accumsan Integer', '21505805', '<img src="images/stories/demo/entertaiment/e-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. </p>\r\n\r\n', '\r\n\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 122, '2008-04-16 02:40:12', 42, '', '2009-08-31 06:49:18', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 6, '', 0, '*', ''),
(317, 464, 'Dolor ut id enim dolor', 'dolor-ut-id-enim-dolor', '<img src="images/stories/demo/entertaiment/music-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi.</p>\r\n\r\n', '\r\n\r\n<img src="images/stories/demo/entertaiment/music-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<h3>This is an Heading 3</h3>\r\n\r\n<ul>\r\n<li>In id metus laoreet dignissim vel.</li>\r\n<li>Nibh volutpat tortor augue convallis</li>\r\n<li>Sed nibh dui Vestibulum sed ante</li>\r\n<li>Nam mauris. Ac dignissim et consectetuer convallis tincidunt</li>\r\n</ul>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p class="box-hilite">Elit Nullam pellentesque vitae Nulla eget Sed eget sed adipiscing accumsan. Tincidunt felis non amet et eu Nulla egestas cursus accumsan condimentum. Tincidunt accumsan tincidunt dolor pellentesque accumsan Nullam convallis egestas nunc quis. Mauris Suspendisse at pretium ac Aenean faucibus Morbi convallis pharetra et.</p>', 1, 122, '2008-04-16 02:40:33', 42, '', '2011-01-28 11:45:42', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:33', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 73, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(318, 465, 'Ac adipiscing et urna nibh', 'ac-adipiscing-et-urna-nibh', '<img src="images/stories/demo/entertaiment/music-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. </p>\r\n\r\n', '\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 122, '2008-04-16 02:39:46', 42, '', '2011-01-28 11:37:28', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:39:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(319, 466, 'Nam feugiat est dolor leo', '205815078', '<img src="images/stories/demo/entertaiment/music-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. </p>\r\n\r\n', '\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>\r\n<p>Aliquam Vestibulum est gravida nibh enim urna condimentum eu augue netus. Tempus eget leo Aliquam pulvinar Nam laoreet rhoncus eu parturient malesuada. Urna elit nunc Nunc Aenean Nunc et ut consectetuer Quisque cursus. Pulvinar magnis sodales aliquet urna ac feugiat justo lacus non purus. Leo pede in laoreet vitae pede Nulla montes congue condimentum nascetur. Laoreet Sed est Nam ante purus tincidunt ligula pharetra adipiscing vitae. Augue velit.</p>\r\n<p>Sed at pellentesque ut lacus orci mauris orci adipiscing Ut suscipit. Tempus ante Curabitur morbi fames non sed velit dui interdum tempor. Montes enim malesuada hendrerit Aliquam Pellentesque Maecenas egestas augue augue Suspendisse. Nullam sem dictum turpis mauris neque Sed augue tempus feugiat Nam. Odio quis tincidunt enim euismod velit ac volutpat massa lacinia in. Penatibus Lorem velit felis ac mus pretium In tincidunt senectus.</p>', 1, 122, '2008-04-16 02:39:46', 42, '', '2009-09-01 11:44:31', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:39:46', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(320, 467, 'Tempor magnis tincidunt euismod', '851889874', '<img src="images/stories/demo/entertaiment/music-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. </p>\r\n\r\n', '\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer urna Aenean dictumst risus est. Quis eros nisl leo Duis pede In Nunc consectetuer nec vitae. A nibh Curabitur vitae Curabitur mauris Aenean convallis convallis Phasellus diam. Risus et quam Sed Suspendisse consequat id justo Vestibulum et eu. Morbi ut justo semper convallis nulla et cursus congue a Morbi. </p>\r\n<p>Malesuada Sed sit Quisque id wisi aliquam sollicitudin leo est justo. Pretium eleifend Vestibulum non tincidunt quam sed mollis porttitor adipiscing ante. Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at. Velit sed et Nulla orci dolor faucibus eu laoreet urna Phasellus. Sed arcu ante Nam Curabitur amet Curabitur consectetuer turpis In ligula. Justo Sed.</p>\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>', 1, 122, '2008-04-16 02:39:46', 42, '', '2009-09-01 11:46:38', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:39:46', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 1, '', 0, '*', ''),
(321, 468, 'Vestibulum et eu', '533106958', '<img src="images/stories/demo/entertaiment/music-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Malesuada Sed sit Quisque id wisi aliquam sollicitudin leo est justo. Pretium eleifend Vestibulum non tincidunt quam sed mollis porttitor adipiscing ante.</p>\r\n\r\n', '\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer urna Aenean dictumst risus est. Quis eros nisl leo Duis pede In Nunc consectetuer nec vitae. A nibh Curabitur vitae Curabitur mauris Aenean convallis convallis Phasellus diam. Risus et quam Sed Suspendisse consequat id justo Vestibulum et eu. Morbi ut justo semper convallis nulla et cursus congue a Morbi. </p>\r\n<p>Malesuada Sed sit Quisque id wisi aliquam sollicitudin leo est justo. Pretium eleifend Vestibulum non tincidunt quam sed mollis porttitor adipiscing ante. Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at. Velit sed et Nulla orci dolor faucibus eu laoreet urna Phasellus. Sed arcu ante Nam Curabitur amet Curabitur consectetuer turpis In ligula. Justo Sed.</p>\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>', 1, 122, '2008-04-16 02:39:46', 42, '', '2009-09-09 11:05:51', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:39:46', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(322, 469, 'Nulla molestie congue', '1541126430', '<img src="images/stories/demo/entertaiment/music-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at.</p>\r\n\r\n', '\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer urna Aenean dictumst risus est. Quis eros nisl leo Duis pede In Nunc consectetuer nec vitae. A nibh Curabitur vitae Curabitur mauris Aenean convallis convallis Phasellus diam. Risus et quam Sed Suspendisse consequat id justo Vestibulum et eu. Morbi ut justo semper convallis nulla et cursus congue a Morbi. </p>\r\n<p>Malesuada Sed sit Quisque id wisi aliquam sollicitudin leo est justo. Pretium eleifend Vestibulum non tincidunt quam sed mollis porttitor adipiscing ante. Nunc adipiscing neque platea vitae Nulla molestie congue pretium Morbi Nam. Ut amet elit fringilla penatibus interdum porttitor ut id Aenean at. Velit sed et Nulla orci dolor faucibus eu laoreet urna Phasellus. Sed arcu ante Nam Curabitur amet Curabitur consectetuer turpis In ligula. Justo Sed.</p>\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>', 1, 122, '2008-04-16 02:39:46', 42, '', '2009-09-09 11:06:27', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:39:46', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 1, '', 0, '*', ''),
(323, 471, 'Vel arcu in Curabitur', '427468799', '<img src="images/stories/demo/entertaiment/e-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. </p>\r\n\r\n', '\r\n<pNullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 123, '2008-04-16 02:41:02', 42, '', '2009-08-31 06:48:04', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:02', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 3, '', 0, '*', ''),
(324, 472, 'Dolor ut id enim dolor', 'dolor-ut-id-enim-dolor-in', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/entertaiment/e-8.jpg" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. </p>\r\n\r\n', '\r\n\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 123, '2008-04-16 02:41:23', 42, '', '2011-01-28 11:46:04', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 6, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(325, 473, ' Paris\' Red-Hot London Jaunt', 'paris-red-hot-london-jaunt', '<img src="images/stories/demo/entertaiment/e-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin.</p>\r\n\r\n<p>Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n', '\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 123, '2008-04-16 02:41:45', 42, '', '2011-01-28 11:27:11', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 57, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(326, 474, 'Tincidunt nulla a Nulla eu', '813479192', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/entertaiment/e-14.jpg"/>\r\n\r\n<p>Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec.</p>\r\n\r\n', '\r\n\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 123, '2008-04-16 02:41:23', 42, '', '2009-09-01 11:50:49', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:23', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(327, 475, 'Justo quam orci ipsum enim', 'justo-quam-orci-ipsum-enim', '<p><img class="caption" src="images/stories/demo/entertaiment/e-15.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n', '\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 123, '2008-04-16 02:41:23', 42, '', '2011-09-01 08:18:34', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(328, 476, 'Vestibulum ac pede id Cum', '1920322838', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/entertaiment/e-16.jpg"/>\r\n\r\n<p>Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique.</p>\r\n\r\n', '\r\n\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 123, '2008-04-16 02:41:23', 42, '', '2009-09-01 11:55:21', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:23', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(329, 477, 'Sem laoreet congue Sed', '1330828373', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/entertaiment/b-4.jpg"/>\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl.</p>\r\n\r\n', '\r\n\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 123, '2008-04-16 02:41:23', 42, '', '2009-09-09 11:08:11', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:23', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(330, 478, 'Nulla Vivamus convallis nibh', '839593086', '<img align="left" class="caption" title="Sample image" alt="Sample image" src="images/stories/demo/entertaiment/b-5.jpg"/>\r\n\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer.</p>\r\n\r\n', '\r\n\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 123, '2008-04-16 02:41:23', 42, '', '2009-09-09 11:08:52', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:41:23', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(331, 480, 'Vel lorem fringilla ante nunc', '1687199530', '<img src="images/stories/demo/entertaiment/ga-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. </p>\r\n\r\n', '\r\n<p>Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus. Quam ligula Mauris ac a et morbi eu Vestibulum congue Aenean. Elit diam ut egestas ut et fames Integer pretium interdum molestie. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac. Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>\r\n\r\n<p>Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>', 1, 124, '2008-04-16 02:34:22', 42, '', '2009-08-31 06:55:22', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:34:22', '0000-00-00 00:00:00', '', '', '', 1, 9, '', '', 1, 0, '', 0, '*', ''),
(332, 481, 'Dui Phasellus Nam pretium', 'dui-phasellus-nam-pretium', '<img src="images/stories/demo/entertaiment/ga-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer ac Vivamus Aliquam id aliquam. Orci cursus interdum pulvinar sociis vestibulum sed vestibulum est condimentum ac. </p>\r\n\r\n', '\r\n<p>Ut adipiscing Morbi rhoncus vitae id convallis Proin Lorem Curabitur dolor. Quisque eget dapibus Quisque volutpat Vivamus lacinia velit velit amet Vivamus. Sed ante elit tellus et gravida quis urna nulla Donec Sed. Urna eu urna.</p>\r\n\r\n<p>Et Aliquam pretium faucibus sit magna at Sed cursus sociis at. Consectetuer mattis Lorem Nam Sed pellentesque ornare odio sit lorem sit. Morbi nulla non Curabitur sed Vestibulum nec augue tincidunt vitae condimentum. Dui Phasellus Nam pretium adipiscing dui et nec vel suscipit sollicitudin. Vestibulum scelerisque tellus ut nec a nec In et tincidunt condimentum. Ut.</p>\r\n\r\n<p>Sed id leo et vitae Nam tortor quis tortor nibh Sed. Porttitor lobortis Donec nisl turpis vitae amet ut Sed dolor Nullam. Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>', 1, 124, '2008-04-16 02:30:09', 42, '', '2011-01-28 11:46:35', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(333, 482, 'Congue non est velit Vivamus', 'congue-non-est-velit-vivamus', '<img src="images/stories/demo/entertaiment/ga-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. </p>\r\n\r\n', '\r\n\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 124, '2008-04-16 02:40:12', 42, '', '2011-01-28 11:42:17', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(334, 483, 'Vestibulum at Vestibulum condimentum', '1117323800', '<img src="images/stories/demo/entertaiment/ga-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum.</p>\r\n\r\n', '\r\n\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 124, '2008-04-16 02:40:12', 42, '', '2009-09-01 12:07:36', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 0, '', 0, '*', ''),
(335, 484, 'Convallis est urna tortor', 'convallis-est-urna-tortor', '<img src="images/stories/demo/entertaiment/ga-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut.</p>\r\n\r\n', '\r\n\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 124, '2008-04-16 02:40:12', 42, '', '2011-01-28 11:43:02', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(336, 485, 'Vitae nibh Vestibulum', '1785069886', '<img src="images/stories/demo/entertaiment/ga-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum.</p>\r\n\r\n', '\r\n\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 124, '2008-04-16 02:40:12', 42, '', '2009-09-09 11:25:03', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(337, 486, 'Velit Fusce accumsan elit', '613324819', '<img src="images/stories/demo/entertaiment/ga-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus.</p>\r\n\r\n', '\r\n\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 124, '2008-04-16 02:40:12', 42, '', '2009-09-09 11:25:34', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(338, 487, 'Ante ultrices vel adipiscing', 'ante-ultrices-vel-adipiscing', '<img src="images/stories/demo/entertaiment/ga-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl.</p>\r\n\r\n', '\r\n\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', 1, 124, '2008-04-16 02:40:12', 42, '', '2011-01-28 11:38:54', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(339, 488, 'Velit Fusce accumsan elit', '529904398', '<img src="images/stories/demo/entertaiment/ga-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum.</p>\r\n\r\n', '\r\n\r\n<p>Nisl Ut neque id ligula pulvinar et cursus velit pharetra Nullam. Vitae tincidunt natoque dui aliquet id accumsan nunc Maecenas lacinia platea. Convallis est urna tortor Sed tellus Mauris Vestibulum at Vestibulum condimentum. Id congue vel aliquet sodales condimentum id ullamcorper hendrerit justo ut. Velit Fusce accumsan elit nibh Phasellus malesuada ornare semper eget odio. Vitae nibh Vestibulum In convallis porttitor ligula nunc ipsum ligula adipiscing. Enim et.</p>\r\n<p>Nam feugiat mi id In urna Nam tempus tortor tincidunt porttitor. Aenean nunc lobortis orci nisl hac dictumst Mauris Integer auctor eleifend. Sem laoreet congue Sed Phasellus laoreet condimentum magnis nibh fringilla Vivamus. Non felis velit tempor et Vestibulum ac pede id Cum tristique. Donec feugiat pretium tellus convallis Mauris nascetur tortor montes Morbi vitae. Justo quam orci ipsum enim.</p>\r\n<p>Fames Ut lorem at est tincidunt parturient semper feugiat ac malesuada. Ante ultrices vel adipiscing id ligula sed id sem platea pede. Ac adipiscing et urna nibh Nam Fusce eu facilisis vitae nisl. Curabitur In Morbi consequat vel lacinia ante sagittis Phasellus Morbi pulvinar. Nulla Vivamus convallis nibh Ut interdum Pellentesque cursus elit nibh Ut. Mauris lorem pretium nec egestas lorem lacus.</p>\r\n<p>Ut eget ipsum mi ullamcorper nascetur convallis id congue ut id. Tempor magnis tincidunt euismod urna interdum quis Nam et id nulla. Vestibulum nec Phasellus facilisi Sed quis fames turpis magna Nullam consectetuer. Nam feugiat est dolor leo tincidunt eget eget faucibus et sed. Sed interdum sed dapibus quis ornare tristique nulla eu Nam Lorem. Est quis fames convallis elit tortor eu neque senectus eros Sed. Ultrices Phasellus.</p>\r\n<p>Vestibulum justo dignissim adipiscing congue dui vitae libero at pede vitae. Urna quis vel dapibus quis et sagittis eleifend Curabitur dui Vivamus. Congue Cum tincidunt nunc wisi turpis justo pretium Integer risus eros. Eu libero id et consectetuer Integer pede mauris ut tristique condimentum. Congue condimentum orci id et tellus fermentum elit Donec.</p>\r\n<p>Nulla justo eu ut lorem Vestibulum velit semper et Mauris tellus. Semper tempor tincidunt tellus ut et Phasellus sed leo tortor consectetuer. Nulla felis cursus ante Vestibulum convallis Donec sed Curabitur dui egestas. Tincidunt tellus vel eu et nibh faucibus quis est convallis mattis. Sed mauris ut ac sodales nec urna platea sem eu consequat. Rutrum Vestibulum Phasellus Curabitur est suscipit Aliquam ut risus in.</p>', -2, 124, '2008-04-16 02:40:12', 42, '', '2009-09-09 11:26:45', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '', 1, 0, '', '', 1, 0, '', 0, '*', ''),
(340, 490, 'Congue non est velit Vivamus', 'congue-non-est-velit-vivamus', '<img src="images/stories/demo/entertaiment/th-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. </p>\r\n\r\n', '\r\n\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 125, '2008-04-16 02:40:12', 42, '', '2011-01-28 11:42:09', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:40:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(341, 491, 'Et Aliquam pretium faucibus', 'et-aliquam-pretium-faucibus', '<img src="images/stories/demo/entertaiment/th-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer ac Vivamus Aliquam id aliquam. Orci cursus interdum pulvinar sociis vestibulum sed vestibulum est condimentum ac. </p>\r\n\r\n', '\r\n\r\n<p>Ut adipiscing Morbi rhoncus vitae id convallis Proin Lorem Curabitur dolor. Quisque eget dapibus Quisque volutpat Vivamus lacinia velit velit amet Vivamus. Sed ante elit tellus et gravida quis urna nulla Donec Sed. Urna eu urna. Et Aliquam pretium faucibus sit magna at Sed cursus sociis at. Consectetuer mattis Lorem Nam Sed pellentesque ornare odio sit lorem sit. Morbi nulla non Curabitur sed Vestibulum nec augue tincidunt vitae condimentum. Dui Phasellus Nam pretium adipiscing dui et nec vel suscipit sollicitudin. Vestibulum scelerisque tellus ut nec a nec In et tincidunt condimentum. Ut.</p>\r\n\r\n<p>Sed id leo et vitae Nam tortor quis tortor nibh Sed. Porttitor lobortis Donec nisl turpis vitae amet ut Sed dolor Nullam. Ante quis et nunc iaculis ligula urna porttitor pellentesque ligula ac. Orci Proin vel parturient Sed in velit pede tempus justo congue. Non dapibus hendrerit faucibus scelerisque dignissim at Nam consequat velit justo. Nullam enim nibh Proin ac id.</p>\r\n\r\n<p>Ultrices semper sapien odio Vestibulum velit netus neque est dis urna. Nunc lorem cursus Maecenas Nam nunc malesuada sit leo et nec. Lorem Morbi Curabitur ac tincidunt Vestibulum elit Morbi tristique Aenean malesuada. Metus urna In adipiscing risus pede semper et ac mollis nibh. Consectetuer consequat pretium turpis et tempus.</p>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis. Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada.</p>', 1, 125, '2008-04-16 02:30:09', 42, '', '2011-01-28 11:48:58', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:30:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(342, 492, 'Orci rutrum lacus feugiat', '1718761996', '<img align="left" src="images/stories/demo/entertaiment/th-1.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis.  </p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 125, '2008-04-16 02:35:58', 42, '', '2009-09-01 04:18:16', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 0, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(343, 493, 'Cum habitasse molestie rhoncus', 'cum-habitasse-molestie-rhoncus', '<img align="left" src="images/stories/demo/entertaiment/th-4.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>eo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 125, '2008-04-16 02:35:58', 42, '', '2011-01-28 11:43:26', 42, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(344, 494, 'Malesuada consectetuer hendrerit', '1440354585', '<img align="left" src="images/stories/demo/entertaiment/th-5.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 125, '2008-04-16 02:35:58', 42, '', '2009-09-09 11:13:11', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(345, 495, 'Ut nunc fames dui quis', '1469376722', '<img align="left" src="images/stories/demo/entertaiment/th-6.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 125, '2008-04-16 02:35:58', 42, '', '2009-09-09 11:14:11', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 1, '*', ''),
(346, 496, 'Phasellus molestie quis', '401401400', '<img align="left" src="images/stories/demo/entertaiment/th-7.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 125, '2008-04-16 02:35:58', 42, '', '2009-09-09 11:19:29', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(347, 497, 'Nulla vel in Nam id Phasellus', '1973816628', '<img align="left" src="images/stories/demo/entertaiment/th-8.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor.</p>\r\n\r\n', '\r\n\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', 1, 125, '2008-04-16 02:35:58', 42, '', '2009-09-09 11:20:09', 62, 0, '0000-00-00 00:00:00', '2008-04-16 02:35:58', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(348, 500, 'UAE\'s Aabar to Build Trucks in Algeria ', '593989370', '<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n', '\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>', 0, 127, '2008-04-16 04:26:33', 42, '', '2009-08-11 07:30:12', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:26:33', '0000-00-00 00:00:00', '', '', '', 1, 9, '', '', 1, 0, '', 0, '*', ''),
(349, 501, 'Anheuser Refreshes Bud Light Ads', 'anheuser-refreshes-bud-light-ads', '<img align="left" src="images/stories/demo/world/eu-3.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. </p>\r\n\r\n', '\r\n\r\n<img align="left" src="images/stories/demo/world/eu-4.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy. Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus.</p>\r\n\r\n<p>Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>\r\n<div id="html_content" style="display:none;">\r\nLaoreet ac Nullam pretium nibh ac Ut pellentesque nunc turpis rhoncus. Neque felis enim eget pellentesque ullamcorper Morbi nunc interdum eget Integer. Tristique vitae mauris scelerisque lacinia.\r\n</div>\r\n\r\nAdipiscing {highslide event=\'drop-shadow\' outlineType=\'drop-shadow\' type=\'html\' contentid=\'html_content\' width=300 height=150} leo quis wisi justo{/highslide} dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<blockquote><span class="open">L</span>orem ipsum dolor sit amet consectetuer ut mauris at Nam id. <span class="highlight">Nam nec semper quis congue Donec</span> netus odio eu id consequat. Massa enim semper pellentesque Cras Sed neque congue dolor habitasse dui. Tempus In cursus Vestibulum Quisque at at ut dolor ut a. Tincidunt elit Integer venenatis Vestibulum libero at id orci dolor justo. Ornare dictum non orci ligula odio tempor orci neque urna Nam. Ornare vitae vita<span class="close">e.</span></blockquote>\r\n\r\n<p>Vestibulum libero habitant sapien aliquet tortor Aenean lacinia laoreet justo sapien. Enim Pellentesque augue leo et montes consequat enim justo elit Nam. Feugiat cursus malesuada dui mollis fermentum justo congue nec nibh feugiat. Gravida justo nec risus ligula pede metus senectus tempor Maecenas massa. Laoreet nulla eros id congue ante purus scelerisque mauris semper elit. Duis Vestibulum cursus.</p>\r\n\r\n<p>Semper augue dolor tellus at vel magna vitae et Aliquam Vestibulum. Ut Sed eu orci auctor tellus interdum ac tincidunt id est. In rhoncus nibh Curabitur Curabitur quis massa mattis eget tincidunt cursus. Tortor ipsum nec cursus laoreet vitae feugiat id pellentesque Aenean Sed. Natoque Nulla risus magna justo Sed Phasellus leo.</p>\r\n\r\n<p>Scelerisque velit semper Suspendisse sociis consectetuer consequat Vestibulum semper vel interdum. Sed faucibus adipiscing augue justo nec cursus eget commodo semper lacinia. Donec tellus Sed porttitor Nullam natoque urna ac ut odio ut. Pellentesque enim Suspendisse natoque tellus risus Nam convallis dui ac massa. Urna id Nulla Nullam Sed mauris et ac sagittis Cum nunc. Vitae.</p>', 1, 127, '2008-04-16 04:28:44', 42, '', '2013-07-30 09:10:33', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:28:44', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 3, 8, '', '', 1, 141, '{"tags":[15,3,16],"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(350, 502, 'U.K. Taxpayers Face Less of a Bill', '2084237727', '<img align="left" src="images/stories/demo/world/eu-2.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. </p>\r\n\r\n', '\r\n\r\n\r\n<blockquote><span class="open">N</span>ullam odio et vestibulum laoreet ridiculus dui eu eu pellentesque amet. Tortor eu Morbi Sed nibh pellentesque lacinia interdum Maecenas Curabitur ligula. Felis tempus et enim laoreet nunc nulla id Fusce mollis egesta<span class="close">s.</span></blockquote>\r\n\r\n<img src="images/stories/demo/world/w-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut. Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>', 1, 127, '2008-04-16 04:29:13', 42, '', '2009-08-31 07:39:33', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:29:13', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 21, '', 0, '*', ''),
(351, 503, 'Friends Agrees to Resolution Takeover ', 'friends-agrees-to-resolution-takeover', '<img src="images/stories/demo/world/eu-1.jpg" alt="Friends Agrees to Resolution Takeover " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sit orci Suspendisse nulla mauris Nam metus eros odio feugiat semper. Enim pellentesque est Phasellus Curabitur urna tincidunt sagittis gravida eget Ut. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/eu-2.jpg" alt="Friends Agrees to Resolution Takeover " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim. </p>\r\n\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 127, '2008-04-21 04:04:48', 42, '', '2011-01-28 11:50:54', 42, 0, '0000-00-00 00:00:00', '2008-04-21 04:04:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 20, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(352, 504, 'Augue et montes montes ut', 'augue-et-montes-montes-ut', '<img src="images/stories/demo/world/eu-4.jpg" alt="Augue et montes montes ut" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/eu-2.jpg" alt="Friends Agrees to Resolution Takeover " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim. </p>\r\n\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 127, '2008-04-21 04:04:48', 42, '', '2011-01-28 11:39:52', 42, 0, '0000-00-00 00:00:00', '2008-04-21 04:04:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(353, 505, 'Ornare nisl nibh leo a nulla', '847245405', '<img src="images/stories/demo/world/eu-5.jpg" alt="Ornare nisl nibh leo a nulla" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/eu-4.jpg" alt="Friends Agrees to Resolution Takeover " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim. </p>\r\n\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 127, '2008-04-21 04:04:48', 42, '', '2009-09-09 08:14:46', 62, 0, '0000-00-00 00:00:00', '2008-04-21 04:04:48', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 1, '*', ''),
(354, 506, 'Congue eget tempus lacus', 'congue-eget-tempus-lacus', '<img src="images/stories/demo/world/eu-6.jpg" alt="Ornare nisl nibh leo a nulla" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/eu-4.jpg" alt="Friends Agrees to Resolution Takeover " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim. </p>\r\n\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 127, '2008-04-21 04:04:48', 42, '', '2011-01-28 11:41:54', 42, 0, '0000-00-00 00:00:00', '2008-04-21 04:04:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(355, 507, 'Lobortis Nunc hac quis', '89832189', '<img src="images/stories/demo/world/eu-7.jpg" alt="Lobortis Nunc hac quis" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/eu-6.jpg" alt="Friends Agrees to Resolution Takeover " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim. </p>\r\n\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 127, '2008-04-21 04:04:48', 42, '', '2009-09-09 08:16:07', 62, 0, '0000-00-00 00:00:00', '2008-04-21 04:04:48', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(356, 508, 'Consequat id Nam augue', 'consequat-id-nam-augue', '<img src="images/stories/demo/world/eu-8.jpg" alt="Consequat id Nam augue" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/eu-6.jpg" alt="Friends Agrees to Resolution Takeover " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue et montes montes ut wisi justo in ipsum gravida eleifend. Consequat id Nam augue justo Maecenas elit justo interdum tincidunt massa. Congue eget tempus lacus commodo id nulla ac quis Sed adipiscing. Donec. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Pede laoreet Aenean sit Phasellus hendrerit dignissim Sed Pellentesque pellentesque eros. Lobortis Nunc hac quis enim tortor tellus a condimentum natoque pede. Iaculis pede sit ornare ridiculus Donec Aliquam Curabitur eget libero Phasellus. Morbi Sed ligula gravida libero magna massa vestibulum eget velit tellus. Mattis In eu orci porttitor ipsum morbi Sed wisi elit condimentum. Praesent et Phasellus turpis consectetuer habitant nonummy justo Vestibulum Curabitur faucibus. Sem ut.</p>\r\n\r\n<p>Ornare nisl nibh leo a nulla elit dolor Nam Pellentesque Phasellus. Semper Sed eros dolor condimentum congue et enim at ut convallis. Interdum semper amet rhoncus ut quam natoque enim egestas non habitasse. Morbi mollis dis fermentum ut lobortis amet Sed tempus Quisque senectus. Sociis pretium semper Curabitur adipiscing sagittis neque est.</p>\r\n\r\n<p>Sed tellus Curabitur sit id et purus at vitae Vestibulum amet. Tellus elit quis Morbi Aenean pellentesque sed non tristique orci laoreet. Vel et et fames pellentesque semper eu arcu laoreet mauris Sed. Lobortis Donec neque sapien elit nibh egestas neque vel lorem id. Consequat Nulla at egestas et risus dis Sed semper id fringilla. Hendrerit tincidunt pretium lobortis at Curabitur id auctor semper pede hac. At gravida eu.</p>\r\n\r\n<p>Lacus Donec ac urna tellus ipsum magnis amet eu Morbi Phasellus. Pretium ante sem Lorem auctor est velit vel semper elit mauris. Justo sem Nam mattis et at diam Curabitur euismod ut feugiat. Wisi rhoncus sapien sem vitae nec et consequat In velit ac. Vitae sem semper sem condimentum nulla augue id Sed dolor enim. </p>\r\n\r\n<p>Et consequat et magnis fringilla urna massa dui mi eget vel. Rhoncus vestibulum leo ac eget et venenatis Curabitur eu at tortor. Nam Nulla consectetuer velit Nam in vel scelerisque ac dictum molestie. Natoque porttitor enim nulla id semper Sed Donec Nulla et Aenean. Pede pretium Aenean sit Curabitur sit. Vitae sem semper sem condimentum nulla augue id Sed dolor enim.</p>', 1, 127, '2008-04-21 04:04:48', 42, '', '2011-01-28 11:42:47', 42, 0, '0000-00-00 00:00:00', '2008-04-21 04:04:48', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(357, 510, 'Lawmakers Urged to Raise Debt Limit ', 'lawmakers-urged-to-raise-debt-limit', '<p><img class="caption" src="images/stories/demo/world/us-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis.</p>\r\n', '\r\n<p>Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut. Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<hr title="Tellus et Mauris wisi eu Curabitur" alt="page-2" class="system-pagebreak" />\r\n<p>Tellus et Mauris wisi eu Curabitur hac et Sed adipiscing augue. At ac Morbi sit cursus libero facilisis eget auctor mi semper. Tincidunt ante eu et diam faucibus Aenean pellentesque congue mauris ac. Et pretium augue odio eget orci dolor ipsum Nam senectus consequat. Sed Vivamus condimentum in Vestibulum auctor neque egestas Suspendisse congue ac. Vel quis Aenean hendrerit tortor.</p>\r\n<p>Et velit eu Vestibulum augue volutpat pede tincidunt feugiat tellus ac. Natoque Curabitur semper dictum Vestibulum urna quam et Proin tincidunt et. Phasellus Nam ridiculus et hac Donec platea et vitae convallis wisi. Tellus adipiscing neque et neque sapien augue id nisl Aliquam leo. Accumsan Lorem ipsum semper ligula ac lacinia Nam eget Nam sodales. Quis mauris eu sed et vitae lorem elit dui ipsum montes.</p>\r\n<p>Vitae turpis sit Phasellus ut hendrerit id et Nam Vivamus nulla. Curabitur vitae justo a id ipsum leo et turpis augue Aliquam. Fermentum tempus dui massa sed at Vivamus malesuada neque interdum vitae. Pellentesque Vestibulum quis orci magna eget magna a elit nisl sed. Commodo mollis nunc pretium Nam quis felis Ut Sed justo vel. Risus massa nisl mauris.</p>\r\n<p>Donec Nam commodo at et Vestibulum sed condimentum Donec a at. Morbi tempor Sed cursus Vivamus quis id Praesent pharetra turpis sed. Semper elit lobortis vitae nibh molestie adipiscing enim metus at Sed. Enim ultrices eget ipsum tincidunt ac est arcu lorem pede metus. Faucibus nibh convallis at laoreet tempus ornare commodo tincidunt platea velit. Tellus nibh platea laoreet Quisque Nulla Integer ut congue.</p>\r\n<p>In hendrerit adipiscing amet adipiscing Curabitur ut metus ipsum vel eleifend. Donec est tristique Aliquam nonummy pede augue eu turpis Vivamus felis. Vitae In Integer sagittis sit Quisque senectus dolor a pellentesque consectetuer. Hendrerit Sed elit congue ipsum Sed et ipsum congue ac Phasellus. Semper volutpat sit vel ut enim.</p>\r\n<hr title="What\'s new?" alt="page-3" class="system-pagebreak" />\r\n<p>Et velit eu Vestibulum augue volutpat pede tincidunt feugiat tellus ac. Natoque Curabitur semper dictum Vestibulum urna quam et Proin tincidunt et. Phasellus Nam ridiculus et hac Donec platea et vitae convallis wisi. Tellus adipiscing neque et neque sapien augue id nisl Aliquam leo. Accumsan Lorem ipsum semper ligula ac lacinia Nam eget Nam sodales. Quis mauris eu sed et vitae lorem elit dui ipsum montes.</p>\r\n<p>Vitae turpis sit Phasellus ut hendrerit id et Nam Vivamus nulla. Curabitur vitae justo a id ipsum leo et turpis augue Aliquam. Fermentum tempus dui massa sed at Vivamus malesuada neque interdum vitae. Pellentesque Vestibulum quis orci magna eget magna a elit nisl sed. Commodo mollis nunc pretium Nam quis felis Ut Sed justo vel. Risus massa nisl mauris.</p>\r\n<p>Donec Nam commodo at et Vestibulum sed condimentum Donec a at. Morbi tempor Sed cursus Vivamus quis id Praesent pharetra turpis sed. Semper elit lobortis vitae nibh molestie adipiscing enim metus at Sed. Enim ultrices eget ipsum tincidunt ac est arcu lorem pede metus. Faucibus nibh convallis at laoreet tempus ornare commodo tincidunt platea velit. Tellus nibh platea laoreet Quisque Nulla Integer ut congue.</p>\r\n<h3>This is an heading 3</h3>\r\n<ul>\r\n<li>Et velit eu Vestibulum augue volutpat pede tincidunt</li>\r\n<li>In hendrerit adipiscing amet adipiscing Curabitur</li>\r\n<li>Donec est tristique Aliquam nonummy pede augue eu turpis Vivamus felis</li>\r\n<li>Ac gravida mauris Aenean massa Pellentesque eget pellentesque</li>\r\n</ul>\r\n<p>In hendrerit adipiscing amet adipiscing Curabitur ut metus ipsum vel eleifend. Donec est tristique Aliquam nonummy pede augue eu turpis Vivamus felis. Vitae In Integer sagittis sit Quisque senectus dolor a pellentesque consectetuer. Hendrerit Sed elit congue ipsum Sed et ipsum congue ac Phasellus. Semper volutpat sit vel ut enim.</p>\r\n<p>Id risus convallis Nam magna at Quisque ligula turpis accumsan vitae. Ac gravida mauris Aenean massa Pellentesque eget pellentesque nisl convallis mauris. Magna suscipit wisi congue quis sed feugiat Nam a eget Sed. Nascetur quis malesuada diam gravida Pellentesque id leo turpis sapien nibh. Leo condimentum id pede gravida Nullam.</p>\r\n<p>Tincidunt eros In sed eros magna congue Suspendisse eleifend quis dui. Dis Sed turpis Cum Nulla congue dolor felis In porttitor eget. Risus Sed consectetuer Ut Sed et dui neque velit habitasse cursus. Dui Quisque eget suscipit scelerisque elit nec dignissim penatibus Vivamus mus. Condimentum ac consectetuer congue Nullam ac tristique venenatis sit Vestibulum nec.</p>\r\n<p>Sem consequat ipsum nisl vel Nam feugiat wisi porta tincidunt habitasse. Pellentesque vitae elit vitae accumsan sapien eu sem laoreet tellus ut. Lacus sed et ligula Sed nascetur Aliquam adipiscing sit Nam nulla. Urna iaculis augue neque enim In sed Pellentesque metus ridiculus amet. Nulla massa ut lacus vitae Fusce Lorem Aenean risus at at.</p>\r\n<p><a class="comment" href="#" title="Comment">Your comment</a><a class="video" href="#" title="View video">View video</a></p>', 1, 128, '2008-04-16 04:30:25', 42, '', '2011-09-01 08:18:55', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:30:25', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 20, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(358, 511, 'Clinton Addresses War Crimes in Congo ', 'clinton-addresses-war-crimes-in-congo', '<img align="left" src="images/stories/demo/world/us-3.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. </p>\r\n\r\n', '\r\n\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 128, '2008-04-16 04:31:20', 42, '', '2011-01-28 11:41:22', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:31:20', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(359, 512, 'U.S., Mexico, Canada Vow Cooperation ', '1684426383', '<img src="images/stories/demo/world/us-2.jpg" alt="U.S., Mexico, Canada Vow Cooperation " align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. </p>\r\n\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. ibh nibh consectetuer semper pretium Cum mauris justo eros. acinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Quam ligula Mauris ac a et morbi eu Vestibulum congue Aenean. Elit diam ut egestas ut et fames Integer pretium interdum molestie. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 128, '2008-04-16 04:32:12', 42, '', '2009-08-31 07:37:57', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:32:12', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 31, '', 0, '*', ''),
(360, 513, 'Obama and the Practice of Medicine ', '1372302989', '<img src="images/stories/demo/world/us-1.jpg" alt="Obama and the Practice of Medicine" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum et Curabitur Curabitur dapibus nibh pharetra tellus porttitor Lorem nibh. In et Sed amet semper sagittis vestibulum consectetuer sed wisi Proin. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/us-2.jpg" alt="Obama and the Practice of Medicine" align="left" title="Sample image" class="caption" />\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 128, '2009-08-11 07:32:55', 42, '', '2009-09-09 09:09:03', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 1028, '', 0, '*', ''),
(361, 514, 'In Maecenas quis ligula', 'in-maecenas-quis-ligula', '<p><img class="caption" src="images/stories/demo/world/us-5.jpg" border="0" alt="In Maecenas quis ligula" title="Sample image" align="left" /></p>\r\n<p>Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/world/us-2.jpg" border="0" alt="Obama and the Practice of Medicine" title="Sample image" align="left" /></p>\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 128, '2009-08-11 07:32:55', 42, '', '2011-09-01 07:28:40', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(362, 515, 'Pellentesque odio dapibus', '788586964', '<img src="images/stories/demo/world/us-6.jpg" alt="Pellentesque odio dapibus" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/us-2.jpg" alt="Obama and the Practice of Medicine" align="left" title="Sample image" class="caption" />\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 128, '2009-08-11 07:32:55', 42, '', '2009-09-09 08:27:39', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(363, 516, 'Ante semper sapien lorem', 'ante-semper-sapien-lorem', '<img src="images/stories/demo/world/us-7.jpg" alt="Ante semper sapien lorem" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/us-2.jpg" alt="Obama and the Practice of Medicine" align="left" title="Sample image" class="caption" />\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 128, '2009-08-11 07:32:55', 42, '', '2011-01-28 11:38:37', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(364, 517, 'Senectus Aliquam orci In sed', '1652297608', '<img src="images/stories/demo/world/us-8.jpg" alt="Senectus Aliquam orci In sed" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/world/us-2.jpg" alt="Obama and the Practice of Medicine" align="left" title="Sample image" class="caption" />\r\n<p>Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 128, '2009-08-11 07:32:55', 42, '', '2009-09-09 08:29:03', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 2, '', 0, '*', ''),
(365, 519, 'Attacks kill at least 42 in Iraq on Shiite religious holiday', 'attacks-kill-at-least-42-in-iraq-on-shiite-religious-holiday', '<img src="images/stories/demo/middle/mi-3.jpg" alt="Attacks kill at least 42 in Iraq on Shiite religious holiday" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. S</p>\r\n\r\n', '\r\n<p>ed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 129, '2008-04-16 04:33:21', 42, '', '2011-01-28 11:39:37', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:33:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(366, 520, 'Ex-homeless woman leaves $150,000 to Hebrew University', 'ex-homeless-woman-leaves-150000-to-hebrew-university', '<img src="images/stories/demo/middle/mi-2.jpg" alt="Ex-homeless woman leaves $150,000 to Hebrew University" align="left" title="Sample image" class="caption" />\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. </p>\r\n\r\n', '\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 129, '2008-04-16 04:33:57', 42, '', '2011-01-28 11:49:29', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:33:57', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 9, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(367, 521, 'Al Qaeda blamed for Iraq violence wave', 'al-qaeda-blamed-for-iraq-violence-wave', '<img src="images/stories/demo/middle/mi-1.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/middle/mi-2.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n<p> Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 129, '2008-04-16 04:34:23', 42, '', '2011-01-28 11:31:52', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 16, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(368, 522, 'Hac Morbi ac leo at felis', 'hac-morbi-ac-leo-at-felis', '<img src="images/stories/demo/middle/mi-4.jpg" alt="Hac Morbi ac leo at felis" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/middle/mi-2.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n<p> Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 129, '2008-04-16 04:34:23', 42, '', '2011-01-28 11:51:49', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(369, 523, 'Tincidunt cursus quam ', '214166192', '<img src="images/stories/demo/middle/mi-6.jpg" alt="Tincidunt cursus quam" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/middle/mi-2.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n<p> Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 129, '2008-04-16 04:34:23', 42, '', '2009-09-09 08:47:04', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:23', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(370, 524, 'Et Nunc mus sem Nunc Cras', 'et-nunc-mus-sem-nunc-cras', '<img src="images/stories/demo/middle/mi-7.jpg" alt=" Et Nunc mus sem Nunc Cras" align="left" title="Sample image" class="caption" />\r\n\r\n<p>In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/middle/mi-2.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n<p> Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 129, '2008-04-16 04:34:23', 42, '', '2011-01-28 11:49:06', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(371, 525, 'Sed et elit condimentum', '551567233', '<img src="images/stories/demo/middle/mi-8.jpg" alt="Sed et elit condimentum" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/middle/mi-2.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n<p> Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 129, '2008-04-16 04:34:23', 42, '', '2009-09-09 08:48:30', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:23', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 1, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(372, 526, 'Elit risus In justo', 'elit-risus-in-justo', '<img src="images/stories/demo/middle/mi-5.jpg" alt="Elit risus In justo" align="left" title="Sample image" class="caption" />\r\n\r\n<p>In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/middle/mi-2.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n<p> Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Et Nunc mus sem Nunc Cras tincidunt mi vestibulum justo at. Elit risus In justo ac ridiculus sed urna elit diam pretium. Aliquet egestas aliquam vel elit consequat fermentum Sed et elit condimentum. Est cursus fermentum venenatis Curabitur lobortis Fusce lobortis convallis eros dictumst. Leo ipsum et Ut morbi a ut id ligula lorem justo. Platea sagittis porttitor Duis In.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 129, '2008-04-16 04:34:23', 42, '', '2011-01-28 11:47:15', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:23', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 9, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(373, 528, 'Protests as Sudan \'tight pants\' trial delayed', '820304091', '<img src="images/stories/demo/world/af-3.jpg" alt="Protests as Sudan tight pants trial delayed" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam.</p>\r\n\r\n', '\r\n\r\n<p> Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac. Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>', 1, 130, '2008-04-16 04:34:54', 42, '', '2009-08-31 07:34:51', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:34:54', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 3, '', 0, '*', ''),
(374, 529, 'Hillary Clinton: We\'re committed to Africa\'s future', 'hillary-clinton-were-committed-to-africas-future', '<img src="images/stories/demo/world/af-2.jpg" alt="Al Qaeda blamed for Iraq violence wave" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. </p>\r\n\r\n', '\r\n\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 130, '2008-04-16 04:35:33', 42, '', '2011-01-28 11:52:29', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:35:33', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(375, 530, 'Zimbabwe\'s writers connected to their country', '1373788244', '<img src="images/stories/demo/world/af-1.jpg" alt="Voices from afar: Zimbabwe\'s writers connected to their country" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. </p>\r\n\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<img src="images/stories/demo/world/af-2.jpg" alt="Voices from afar: Zimbabwe\'s writers connected to their country" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 130, '2008-04-16 04:36:10', 42, '', '2009-08-31 11:17:04', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:36:10', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 40, '', 1, '*', ''),
(376, 531, 'Nunc egestas ut tempus', '1236290415', '<img src="images/stories/demo/world/af-4.jpg" alt="Nunc egestas ut tempus" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. </p>\r\n\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<img src="images/stories/demo/world/af-2.jpg" alt="Voices from afar: Zimbabwe\'s writers connected to their country" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 130, '2008-04-16 04:36:10', 42, '', '2009-09-09 08:58:50', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:36:10', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(377, 532, 'Aenean at vel interdum', 'aenean-at-vel-interdum', '<img src="images/stories/demo/world/af-5.jpg" alt="Aenean at vel interdum" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum.</p>\r\n\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<img src="images/stories/demo/world/af-2.jpg" alt="Voices from afar: Zimbabwe\'s writers connected to their country" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 130, '2008-04-16 04:36:10', 42, '', '2011-01-28 11:30:43', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:36:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(378, 533, 'Aenean Donec gravida hendrerit', 'aenean-donec-gravida-hendrerit', '<img src="images/stories/demo/world/af-6.jpg" alt="Aenean Donec gravida hendrerit" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel.</p>\r\n\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<img src="images/stories/demo/world/af-2.jpg" alt="Voices from afar: Zimbabwe\'s writers connected to their country" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 130, '2008-04-16 04:36:10', 42, '', '2011-01-28 11:30:57', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:36:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(379, 534, 'Nam cursus odio et quis convallis', '853972616', '<img src="images/stories/demo/world/af-7.jpg" alt="Nam cursus odio et quis convallis" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<img src="images/stories/demo/world/af-2.jpg" alt="Voices from afar: Zimbabwe\'s writers connected to their country" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 130, '2008-04-16 04:36:10', 42, '', '2009-09-09 09:06:13', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:36:10', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 1, '*', ''),
(380, 535, 'Felis tempor felis', 'felis-tempor-felis', '<img src="images/stories/demo/world/af-8.jpg" alt="Felis tempor felis" align="left" title="Sample image" class="caption" />\r\n\r\n<p>In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum.</p>\r\n\r\n', '\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<img src="images/stories/demo/world/af-2.jpg" alt="Voices from afar: Zimbabwe\'s writers connected to their country" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 130, '2008-04-16 04:36:10', 42, '', '2011-01-28 11:49:58', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:36:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(381, 537, 'Dolor ut id enim dolor auctor', 'dolor-ut-id-enim-dolor-auctor', '<img src="images/stories/demo/world/sc-1.jpg" alt="Dolor ut id enim dolor auctor" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. </p>\r\n', '\r\n\r\n\r\n<p>Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A. Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 131, '2008-04-16 04:36:10', 42, '', '2011-01-28 11:46:11', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:36:10', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(382, 538, 'Tellus laoreet pretium non auctor tincidunt', '1696733699', '<img src="images/stories/demo/world/sc-2.jpg" alt="Tellus laoreet pretium non auctor tincidunt" align="left" title="Sample image" class="caption" />\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. </p>\r\n\r\n', '\r\n\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient. Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 131, '2008-04-16 04:33:57', 42, '', '2009-09-09 09:10:34', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:33:57', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 0, '', 0, '*', ''),
(383, 539, 'Lacinia Sed convallis urna lacus interdum', '1334367459', '<img src="images/stories/demo/world/sc-3.jpg" alt="Lacinia Sed convallis urna lacus interdum" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum et Curabitur Curabitur dapibus nibh pharetra tellus porttitor Lorem nibh. In et Sed amet semper sagittis vestibulum consectetuer sed wisi Proin. </p>\r\n\r\n', '\r\n\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus. Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 131, '2009-08-11 07:32:55', 42, '', '2009-08-31 07:26:27', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 2, '', 1, '*', ''),
(384, 540, 'Metus felis faucibus sem', '1084666903', '<img src="images/stories/demo/world/sc-4.jpg" alt="Metus felis faucibus sem" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus. Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. </p>\r\n\r\n', '\r\n\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus. Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 131, '2009-08-11 07:32:55', 42, '', '2009-09-09 09:18:31', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(385, 541, 'Porttitor ut vitae pretium ut', '1799228648', '<img src="images/stories/demo/world/sc-5.jpg" alt="Porttitor ut vitae pretium ut" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. </p>\r\n\r\n', '\r\n\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus. Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 131, '2009-08-11 07:32:55', 42, '', '2009-09-09 09:29:19', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(386, 542, 'Nam leo consectetuer velit mauris', '847000198', '<img src="images/stories/demo/world/sc-6.jpg" alt="Nam leo consectetuer velit mauris" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n', '\r\n\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus. Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 131, '2009-08-11 07:32:55', 42, '', '2009-09-09 09:29:55', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(387, 543, 'A eget Vivamus Quisque senectus', 'a-eget-vivamus-quisque-senectus', '<img src="images/stories/demo/world/sc-7.jpg" alt="A eget Vivamus Quisque senectus" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem.</p>\r\n\r\n', '\r\n\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus. Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 131, '2009-08-11 07:32:55', 42, '', '2011-01-28 11:30:18', 42, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(388, 544, 'Tellus convallis et Nam enim', '92479796', '<img src="images/stories/demo/world/sc-8.jpg" alt="Tellus convallis et Nam enim" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris.</p>\r\n\r\n', '\r\n\r\n<p>Nulla commodo eu nibh libero nascetur Nam id Sed Donec pretium. Lorem et sit laoreet tincidunt cursus semper eget et leo auctor. Metus felis faucibus sem nec condimentum Nam leo consectetuer velit mauris. A eget Vivamus Quisque senectus. Laoreet ligula id In Maecenas quis ligula felis hendrerit justo elit. Metus consequat in mauris mi Curabitur auctor risus sem aliquam condimentum. Porttitor ut vitae pretium ut congue laoreet ante Ut at eros. Senectus Aliquam orci In sed urna auctor sed Curabitur augue rhoncus. Pellentesque odio dapibus Vestibulum ornare venenatis leo convallis Aliquam ac Aliquam. Pretium urna volutpat pretium Curabitur libero pretium tempor sollicitudin consectetuer.</p>\r\n\r\n<p>Adipiscing lacus nec tellus adipiscing hac nibh Vestibulum aliquam tortor et. Cursus laoreet urna gravida congue Curabitur Phasellus vel Curabitur aliquet sem. Donec justo at habitant Aenean enim nunc tincidunt et Sed consectetuer. Est convallis Nunc ante convallis libero auctor sodales lacus nec Donec. Vitae sapien tincidunt Sed lobortis metus Phasellus Aenean libero condimentum dapibus. Augue elit.</p>\r\n\r\n<p>Tellus convallis et Nam enim Cum tellus eros suscipit enim orci. Et Aenean id velit risus turpis amet ut iaculis nibh et. Ante et interdum ultrices ac vel fermentum tellus iaculis vel condimentum. Praesent nibh leo eu justo fringilla volutpat ut a nisl Maecenas. Ipsum laoreet ipsum consequat ut porttitor urna a orci eu odio. Congue leo pede sociis ligula Donec ut lobortis.</p>\r\n\r\n<p>Et semper et Curabitur laoreet et lorem velit Lorem eros condimentum. Lacinia ipsum id vitae hac lorem Curabitur condimentum eros Sed laoreet. Dui et augue sed ipsum Phasellus ultrices nibh tempus gravida porttitor. Dui Phasellus ac euismod Phasellus fames pretium lacus elit magna nibh. Wisi tincidunt tempor nunc id nec Nulla libero Lorem quis Vivamus. Gravida tempus ante volutpat sit nulla Morbi et tellus at id. Pede.</p>\r\n\r\n<p>Donec Ut ac eu Sed In augue tincidunt netus est sociis. Ante semper sapien lorem urna id eu risus Nullam dolor Sed. Tincidunt nonummy tellus Sed condimentum a mus feugiat mus lorem eget. Nulla ac sed Integer non vel ut gravida risus quis condimentum. Ante nascetur pretium ipsum pede nulla enim vel porttitor ut nibh. Tortor facilisi et interdum Phasellus.</p>', 1, 131, '2009-08-11 07:32:55', 42, '', '2009-09-09 09:31:15', 62, 0, '0000-00-00 00:00:00', '2009-08-11 07:32:55', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(389, 546, 'Nibh volutpat tortor augue convallis', '928065420', '<img align="left" src="images/stories/demo/world/pa-1.jpg" alt="Sample image" title="Sample image" class="caption"/>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. </p>\r\n\r\n', '\r\n\r\n<p>Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 132, '2008-04-16 04:31:20', 42, '', '2009-08-31 07:38:48', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:31:20', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 3, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(390, 547, 'Semper accumsan Integer nisl Pellentesque', '353457708', '<img src="images/stories/demo/world/pa-2.jpg" alt="Semper accumsan Integer nisl Pellentesque" align="left" title="Sample image" class="caption" />\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n\r\n', '\r\n<p> Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 132, '2008-04-16 04:33:57', 42, '', '2009-08-31 07:36:39', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:33:57', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 0, '', 0, '*', ''),
(391, 548, 'Aenean Vestibulum lorem egestas', 'aenean-vestibulum-lorem-egestas', '<img src="images/stories/demo/world/pa-3.jpg" alt="Aenean Vestibulum lorem egestas" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. </p>\r\n\r\n', '\r\n<p>Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 132, '2008-04-16 04:33:21', 42, '', '2011-01-28 11:31:40', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:33:21', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(392, 549, 'TIME', '2029285427', '<img src="images/stories/demo/world/rs-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Consequat ante ac ut sit vel molestie hendrerit et mollis Vestibulum. Laoreet leo ac pretium augue dolor nunc Sed tempor libero at. Gravida id malesuada Nulla enim enim nibh Nam vitae platea lacinia.</p>\r\n\r\n', '\r\n\r\n<p>Enim et vitae ligula laoreet congue Quisque Cras ipsum aliquam auctor. Libero ultrices dui tincidunt mauris commodo non semper gravida Donec nulla. Curabitur penatibus Nunc velit.</p>\r\n\r\n<p>Rhoncus Donec Curabitur in eu dui elit gravida wisi mi tempus. Enim sodales ligula Phasellus ligula Pellentesque Praesent in tempus natoque nec. Convallis eget justo justo laoreet auctor senectus porttitor et tristique wisi. Metus nonummy ut ante consequat rutrum tincidunt Vestibulum quam nec magna. Lacinia eros pulvinar consectetuer urna feugiat Curabitur Vestibulum ridiculus Nam leo. Habitant nulla mus In Phasellus natoque Morbi.</p>\r\n\r\n<img src="images/stories/demo/world/rs-2.jpg" alt="Sample image" align="left" title="Amet tempus id nascetur" class="caption" />\r\n\r\n<p>Semper sem magna at egestas consectetuer congue tincidunt laoreet dolor adipiscing. Amet tempus id nascetur rutrum Sed Phasellus Donec nonummy at convallis. Et vel eget semper pretium mauris pellentesque hendrerit tempus Nunc In. Semper dis pretium Curabitur et Vestibulum egestas sit lobortis fames nibh. Amet elit adipiscing tincidunt mus interdum eleifend adipiscing amet congue ac. Consequat arcu.</p>\r\n\r\n<p>Ipsum turpis Proin vel Nulla neque porttitor cursus dictumst sem pulvinar. Pede neque In ornare dolor arcu egestas ullamcorper consectetuer egestas in. Curabitur Lorem Curabitur vel venenatis adipiscing ante orci tincidunt turpis diam. Facilisi urna tempor consectetuer facilisis ultrices ante consectetuer fringilla nibh et. Mattis nibh platea id egestas orci.</p>\r\n\r\n<p>Consequat ante ac ut sit vel molestie hendrerit et mollis Vestibulum. Laoreet leo ac pretium augue dolor nunc Sed tempor libero at. Gravida id malesuada Nulla enim enim nibh Nam vitae platea lacinia. Turpis Aliquam sed eros semper orci consequat id id diam pharetra. Habitant ultrices consequat eget consectetuer ante ante dictumst Nam quis condimentum. Pede.</p>\r\n\r\n<img src="images/stories/demo/world/rs-3.jpg" alt="Sample image" align="right" title="Turpis Aliquam sed eros" class="caption" />\r\n<p>Libero cursus congue massa tincidunt Suspendisse accumsan eget mattis quis Curabitur. Curabitur et tellus dui quis enim nulla sodales pretium nibh Mauris. In quis rutrum semper In egestas interdum Curabitur eget egestas vitae. Nunc feugiat tortor ligula eros Vestibulum suscipit leo laoreet Curabitur consectetuer. Urna Suspendisse semper volutpat Donec Nam nisl semper condimentum metus nisl. Duis nonummy cursus orci Integer vitae Phasellus.</p>', 1, 132, '2009-08-31 14:15:46', 42, '', '2009-09-09 10:38:18', 62, 0, '0000-00-00 00:00:00', '2009-08-31 14:15:46', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 180, '', 1, '*', ''),
(393, 550, 'Rhoncus Donec Curabitur in', '798969686', '<img src="images/stories/demo/world/pa-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Enim et vitae ligula laoreet congue Quisque Cras ipsum aliquam auctor. Libero ultrices dui tincidunt mauris commodo non semper gravida Donec nulla. Curabitur penatibus Nunc velit.</p>\r\n\r\n', '\r\n\r\n<p>Rhoncus Donec Curabitur in eu dui elit gravida wisi mi tempus. Enim sodales ligula Phasellus ligula Pellentesque Praesent in tempus natoque nec. Convallis eget justo justo laoreet auctor senectus porttitor et tristique wisi. Metus nonummy ut ante consequat rutrum tincidunt Vestibulum quam nec magna. Lacinia eros pulvinar consectetuer urna feugiat Curabitur Vestibulum ridiculus Nam leo. Habitant nulla mus In Phasellus natoque Morbi.</p>\r\n\r\n<img src="images/stories/demo/world/rs-2.jpg" alt="Sample image" align="left" title="Amet tempus id nascetur" class="caption" />\r\n\r\n<p>Semper sem magna at egestas consectetuer congue tincidunt laoreet dolor adipiscing. Amet tempus id nascetur rutrum Sed Phasellus Donec nonummy at convallis. Et vel eget semper pretium mauris pellentesque hendrerit tempus Nunc In. Semper dis pretium Curabitur et Vestibulum egestas sit lobortis fames nibh. Amet elit adipiscing tincidunt mus interdum eleifend adipiscing amet congue ac. Consequat arcu.</p>\r\n\r\n<p>Ipsum turpis Proin vel Nulla neque porttitor cursus dictumst sem pulvinar. Pede neque In ornare dolor arcu egestas ullamcorper consectetuer egestas in. Curabitur Lorem Curabitur vel venenatis adipiscing ante orci tincidunt turpis diam. Facilisi urna tempor consectetuer facilisis ultrices ante consectetuer fringilla nibh et. Mattis nibh platea id egestas orci.</p>\r\n\r\n<p>Consequat ante ac ut sit vel molestie hendrerit et mollis Vestibulum. Laoreet leo ac pretium augue dolor nunc Sed tempor libero at. Gravida id malesuada Nulla enim enim nibh Nam vitae platea lacinia. Turpis Aliquam sed eros semper orci consequat id id diam pharetra. Habitant ultrices consequat eget consectetuer ante ante dictumst Nam quis condimentum. Pede.</p>\r\n\r\n<img src="images/stories/demo/world/rs-3.jpg" alt="Sample image" align="right" title="Turpis Aliquam sed eros" class="caption" />\r\n<p>Libero cursus congue massa tincidunt Suspendisse accumsan eget mattis quis Curabitur. Curabitur et tellus dui quis enim nulla sodales pretium nibh Mauris. In quis rutrum semper In egestas interdum Curabitur eget egestas vitae. Nunc feugiat tortor ligula eros Vestibulum suscipit leo laoreet Curabitur consectetuer. Urna Suspendisse semper volutpat Donec Nam nisl semper condimentum metus nisl. Duis nonummy cursus orci Integer vitae Phasellus.</p>', 1, 132, '2009-08-31 14:15:46', 42, '', '2009-09-09 09:42:01', 62, 0, '0000-00-00 00:00:00', '2009-08-31 14:15:46', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(394, 551, 'Enim sodales ligula Phasellus', 'enim-sodales-ligula-phasellus', '<img src="images/stories/demo/world/pa-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Convallis eget justo justo laoreet auctor senectus porttitor et tristique wisi. Metus nonummy ut ante consequat rutrum tincidunt Vestibulum quam nec magna.</p>\r\n\r\n', '\r\n\r\n<p>Rhoncus Donec Curabitur in eu dui elit gravida wisi mi tempus. Enim sodales ligula Phasellus ligula Pellentesque Praesent in tempus natoque nec. Convallis eget justo justo laoreet auctor senectus porttitor et tristique wisi. Metus nonummy ut ante consequat rutrum tincidunt Vestibulum quam nec magna. Lacinia eros pulvinar consectetuer urna feugiat Curabitur Vestibulum ridiculus Nam leo. Habitant nulla mus In Phasellus natoque Morbi.</p>\r\n\r\n<img src="images/stories/demo/world/rs-2.jpg" alt="Sample image" align="left" title="Amet tempus id nascetur" class="caption" />\r\n\r\n<p>Semper sem magna at egestas consectetuer congue tincidunt laoreet dolor adipiscing. Amet tempus id nascetur rutrum Sed Phasellus Donec nonummy at convallis. Et vel eget semper pretium mauris pellentesque hendrerit tempus Nunc In. Semper dis pretium Curabitur et Vestibulum egestas sit lobortis fames nibh. Amet elit adipiscing tincidunt mus interdum eleifend adipiscing amet congue ac. Consequat arcu.</p>\r\n\r\n<p>Ipsum turpis Proin vel Nulla neque porttitor cursus dictumst sem pulvinar. Pede neque In ornare dolor arcu egestas ullamcorper consectetuer egestas in. Curabitur Lorem Curabitur vel venenatis adipiscing ante orci tincidunt turpis diam. Facilisi urna tempor consectetuer facilisis ultrices ante consectetuer fringilla nibh et. Mattis nibh platea id egestas orci.</p>\r\n\r\n<p>Consequat ante ac ut sit vel molestie hendrerit et mollis Vestibulum. Laoreet leo ac pretium augue dolor nunc Sed tempor libero at. Gravida id malesuada Nulla enim enim nibh Nam vitae platea lacinia. Turpis Aliquam sed eros semper orci consequat id id diam pharetra. Habitant ultrices consequat eget consectetuer ante ante dictumst Nam quis condimentum. Pede.</p>\r\n\r\n<img src="images/stories/demo/world/rs-3.jpg" alt="Sample image" align="right" title="Turpis Aliquam sed eros" class="caption" />\r\n<p>Libero cursus congue massa tincidunt Suspendisse accumsan eget mattis quis Curabitur. Curabitur et tellus dui quis enim nulla sodales pretium nibh Mauris. In quis rutrum semper In egestas interdum Curabitur eget egestas vitae. Nunc feugiat tortor ligula eros Vestibulum suscipit leo laoreet Curabitur consectetuer. Urna Suspendisse semper volutpat Donec Nam nisl semper condimentum metus nisl. Duis nonummy cursus orci Integer vitae Phasellus.</p>', 1, 132, '2009-08-31 14:15:46', 42, '', '2011-01-28 11:47:54', 42, 0, '0000-00-00 00:00:00', '2009-08-31 14:15:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(395, 552, 'Convallis eget justo justo', 'convallis-eget-justo-justo', '<img src="images/stories/demo/world/pa-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Metus nonummy ut ante consequat rutrum tincidunt Vestibulum quam nec magna. Lacinia eros pulvinar consectetuer urna feugiat Curabitur Vestibulum ridiculus Nam leo.</p>\r\n\r\n', '\r\n\r\n<p>Rhoncus Donec Curabitur in eu dui elit gravida wisi mi tempus. Enim sodales ligula Phasellus ligula Pellentesque Praesent in tempus natoque nec. Convallis eget justo justo laoreet auctor senectus porttitor et tristique wisi. Metus nonummy ut ante consequat rutrum tincidunt Vestibulum quam nec magna. Lacinia eros pulvinar consectetuer urna feugiat Curabitur Vestibulum ridiculus Nam leo. Habitant nulla mus In Phasellus natoque Morbi.</p>\r\n\r\n<img src="images/stories/demo/world/rs-2.jpg" alt="Sample image" align="left" title="Amet tempus id nascetur" class="caption" />\r\n\r\n<p>Semper sem magna at egestas consectetuer congue tincidunt laoreet dolor adipiscing. Amet tempus id nascetur rutrum Sed Phasellus Donec nonummy at convallis. Et vel eget semper pretium mauris pellentesque hendrerit tempus Nunc In. Semper dis pretium Curabitur et Vestibulum egestas sit lobortis fames nibh. Amet elit adipiscing tincidunt mus interdum eleifend adipiscing amet congue ac. Consequat arcu.</p>\r\n\r\n<p>Ipsum turpis Proin vel Nulla neque porttitor cursus dictumst sem pulvinar. Pede neque In ornare dolor arcu egestas ullamcorper consectetuer egestas in. Curabitur Lorem Curabitur vel venenatis adipiscing ante orci tincidunt turpis diam. Facilisi urna tempor consectetuer facilisis ultrices ante consectetuer fringilla nibh et. Mattis nibh platea id egestas orci.</p>\r\n\r\n<p>Consequat ante ac ut sit vel molestie hendrerit et mollis Vestibulum. Laoreet leo ac pretium augue dolor nunc Sed tempor libero at. Gravida id malesuada Nulla enim enim nibh Nam vitae platea lacinia. Turpis Aliquam sed eros semper orci consequat id id diam pharetra. Habitant ultrices consequat eget consectetuer ante ante dictumst Nam quis condimentum. Pede.</p>\r\n\r\n<img src="images/stories/demo/world/rs-3.jpg" alt="Sample image" align="right" title="Turpis Aliquam sed eros" class="caption" />\r\n<p>Libero cursus congue massa tincidunt Suspendisse accumsan eget mattis quis Curabitur. Curabitur et tellus dui quis enim nulla sodales pretium nibh Mauris. In quis rutrum semper In egestas interdum Curabitur eget egestas vitae. Nunc feugiat tortor ligula eros Vestibulum suscipit leo laoreet Curabitur consectetuer. Urna Suspendisse semper volutpat Donec Nam nisl semper condimentum metus nisl. Duis nonummy cursus orci Integer vitae Phasellus.</p>', 1, 132, '2009-08-31 14:15:46', 42, '', '2011-01-28 11:42:55', 42, 0, '0000-00-00 00:00:00', '2009-08-31 14:15:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(396, 553, 'Vestibulum quam nec magna', '1986123368', '<img src="images/stories/demo/world/pa-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Lacinia eros pulvinar consectetuer urna feugiat Curabitur Vestibulum ridiculus Nam leo. Habitant nulla mus In Phasellus natoque Morbi.</p>\r\n\r\n', '\r\n\r\n<p>Rhoncus Donec Curabitur in eu dui elit gravida wisi mi tempus. Enim sodales ligula Phasellus ligula Pellentesque Praesent in tempus natoque nec. Convallis eget justo justo laoreet auctor senectus porttitor et tristique wisi. Metus nonummy ut ante consequat rutrum tincidunt Vestibulum quam nec magna. Lacinia eros pulvinar consectetuer urna feugiat Curabitur Vestibulum ridiculus Nam leo. Habitant nulla mus In Phasellus natoque Morbi.</p>\r\n\r\n<img src="images/stories/demo/world/rs-2.jpg" alt="Sample image" align="left" title="Amet tempus id nascetur" class="caption" />\r\n\r\n<p>Semper sem magna at egestas consectetuer congue tincidunt laoreet dolor adipiscing. Amet tempus id nascetur rutrum Sed Phasellus Donec nonummy at convallis. Et vel eget semper pretium mauris pellentesque hendrerit tempus Nunc In. Semper dis pretium Curabitur et Vestibulum egestas sit lobortis fames nibh. Amet elit adipiscing tincidunt mus interdum eleifend adipiscing amet congue ac. Consequat arcu.</p>\r\n\r\n<p>Ipsum turpis Proin vel Nulla neque porttitor cursus dictumst sem pulvinar. Pede neque In ornare dolor arcu egestas ullamcorper consectetuer egestas in. Curabitur Lorem Curabitur vel venenatis adipiscing ante orci tincidunt turpis diam. Facilisi urna tempor consectetuer facilisis ultrices ante consectetuer fringilla nibh et. Mattis nibh platea id egestas orci.</p>\r\n\r\n<p>Consequat ante ac ut sit vel molestie hendrerit et mollis Vestibulum. Laoreet leo ac pretium augue dolor nunc Sed tempor libero at. Gravida id malesuada Nulla enim enim nibh Nam vitae platea lacinia. Turpis Aliquam sed eros semper orci consequat id id diam pharetra. Habitant ultrices consequat eget consectetuer ante ante dictumst Nam quis condimentum. Pede.</p>\r\n\r\n<img src="images/stories/demo/world/rs-3.jpg" alt="Sample image" align="right" title="Turpis Aliquam sed eros" class="caption" />\r\n<p>Libero cursus congue massa tincidunt Suspendisse accumsan eget mattis quis Curabitur. Curabitur et tellus dui quis enim nulla sodales pretium nibh Mauris. In quis rutrum semper In egestas interdum Curabitur eget egestas vitae. Nunc feugiat tortor ligula eros Vestibulum suscipit leo laoreet Curabitur consectetuer. Urna Suspendisse semper volutpat Donec Nam nisl semper condimentum metus nisl. Duis nonummy cursus orci Integer vitae Phasellus.</p>', 1, 132, '2009-08-31 14:15:46', 42, '', '2009-09-09 09:44:13', 62, 0, '0000-00-00 00:00:00', '2009-08-31 14:15:46', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(397, 556, 'Nibh volutpat tortor', '403035504', '<img src="images/stories/demo/tech/tech-8.jpg" alt="Sample image" align="left" title="Sample imate" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. </p>\r\n\r\n', '\r\n<p>Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>\r\n\r\n<p>Elit Nullam pellentesque vitae Nulla eget Sed eget sed adipiscing accumsan. Tincidunt felis non amet et eu Nulla egestas cursus accumsan condimentum. Tincidunt accumsan tincidunt dolor pellentesque accumsan Nullam convallis egestas nunc quis. Mauris Suspendisse at pretium ac Aenean faucibus Morbi convallis pharetra et. Sed ut sed Vestibulum ut elit congue convallis massa ante consectetuer. Curabitur non Phasellus cursus et Vestibulum enim lorem.</p>', 1, 134, '2008-04-16 03:27:08', 42, '', '2013-07-30 09:11:53', 42, 0, '0000-00-00 00:00:00', '2008-04-16 03:27:08', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 2, 8, '', '', 1, 0, '{"tags":[17,3,18],"robots":"","author":"","rights":"","xreference":""}', 1, '*', ''),
(398, 557, 'Praesent Aenean Phasellus', '510465561', '<img src="images/stories/demo/tech/tech-7.jpg" alt="Sample content" align="left" title="Sample content" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. </p>\r\n\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>', 1, 134, '2008-04-16 04:01:09', 42, '', '2009-08-31 06:45:35', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:01:09', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 1, '', 0, '*', ''),
(399, 558, 'An Apple for Your Teacher', 'an-apple-for-your-teacher', '<img src="images/stories/demo/tech/tech-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/tech/tech-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Quam ligula Mauris ac a et morbi eu Vestibulum congue Aenean. Elit diam ut egestas ut et fames Integer pretium interdum molestie. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac.</p>\r\n\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Making Recycling Really Pay" align="left" title="Making Recycling Really Pay" class="caption" />\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>\r\n\r\n<p>Elit Nullam pellentesque vitae Nulla eget Sed eget sed adipiscing accumsan. Tincidunt felis non amet et eu Nulla egestas cursus accumsan condimentum. Tincidunt accumsan tincidunt dolor pellentesque accumsan Nullam convallis egestas nunc quis. Mauris Suspendisse at pretium ac Aenean faucibus Morbi convallis pharetra et. Sed ut sed Vestibulum ut elit congue convallis massa ante consectetuer. Curabitur non Phasellus cursus et Vestibulum enim lorem.</p>', 1, 134, '2008-04-16 04:03:33', 42, '', '2011-01-28 11:36:16', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:03:33', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 4, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(400, 559, 'Urna dis dictumst tempor', '1142803082', '<img src="images/stories/demo/tech/pt-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac.</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 134, '2009-09-09 09:45:07', 42, '', '2009-09-09 09:49:45', 62, 0, '0000-00-00 00:00:00', '2009-09-09 09:45:07', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(401, 560, 'Vestibulum tincidunt Vivamus et aliquam', '152001599', '<img src="images/stories/demo/tech/pt-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel.</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 134, '2009-09-09 09:49:47', 42, '', '2009-09-09 09:50:20', 62, 0, '0000-00-00 00:00:00', '2009-09-09 09:49:47', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(402, 561, 'Magna elit tempus neque Phasellus', '2073392084', '<img src="images/stories/demo/tech/pt-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 134, '2009-09-09 09:50:22', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2009-09-09 09:50:22', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(403, 562, 'Hac fames nunc et magna tempor gravida', 'hac-fames-nunc-et-magna-tempor-gravida', '<img src="images/stories/demo/tech/pt-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 134, '2009-09-09 09:50:47', 42, '', '2011-01-28 11:51:42', 42, 0, '0000-00-00 00:00:00', '2009-09-09 09:50:47', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(404, 563, 'Tempus pretium ullamcorper eget', '1921126032', '<img src="images/stories/demo/tech/pt-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 134, '2009-09-09 09:51:14', 42, '', '2009-09-09 09:55:27', 62, 0, '0000-00-00 00:00:00', '2009-09-09 09:51:14', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 12, '', 0, '*', ''),
(405, 565, 'Semper accumsan Integer', '1009190095', '<img src="images/stories/demo/tech/tech-10.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. </p>\r\n\r\n', '\r\n\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec. Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 135, '2008-04-16 04:04:13', 42, '', '2009-08-31 06:43:40', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:04:13', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 1, '', 0, '*', ''),
(406, 566, 'Nullam et nascetur vel', '794950370', '<img src="images/stories/demo/tech/tech-9.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis.</p>\r\n\r\n', '\r\n<p> Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 135, '2008-04-16 04:04:40', 42, '', '2009-08-31 06:43:17', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:04:40', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 3, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(407, 567, 'Sony, Stung by Losses, Delays Thin TV', '1982324066', '<img src="images/stories/demo/tech/tech-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 135, '2008-04-16 04:05:06', 42, '', '2009-08-31 11:22:40', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:06', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 12, '', 0, '*', ''),
(408, 568, 'Pellentesque In id metus', '1563784378', '<img src="images/stories/demo/tech/tech-12.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 135, '2008-04-16 04:05:06', 42, '', '2009-09-09 09:51:21', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:06', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(409, 569, 'Morbi faucibus et', '225892920', '<img src="images/stories/demo/tech/tech-13.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 135, '2008-04-16 04:05:06', 42, '', '2009-09-09 09:53:27', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:06', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 1, '*', ''),
(410, 570, 'Nunc lacus quis dui adipiscing', '1744168858', '<img src="images/stories/demo/tech/tech-14.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 135, '2008-04-16 04:05:06', 42, '', '2009-09-09 09:54:16', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:06', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', ''),
(411, 571, 'Interdum sagittis velit', 'interdum-sagittis-velit', '<p><img class="caption" src="images/stories/demo/tech/tech-15.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum.</p>\r\n', '\r\n<p><img class="caption" src="images/stories/demo/tech/tech-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 135, '2008-04-16 04:05:06', 42, '', '2011-09-01 07:37:51', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:06', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 3, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(412, 572, 'Magna convallis egestas', '1960541164', '<img src="images/stories/demo/tech/tech-16.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>eo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n', '\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n<p>Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Interdum nunc fringilla Proin nisl urna pretium Aenean dictum dapibus sem. Tellus laoreet pretium non auctor tincidunt Curabitur consequat at et Nam. Velit nibh Integer fringilla lobortis nisl nibh neque risus iaculis lacinia. Nam justo netus pede vel Aenean nibh scelerisque quis Integer id.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 135, '2008-04-16 04:05:06', 42, '', '2009-09-09 09:55:30', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:06', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(413, 574, 'Adipiscing leo quis wisi justo dui', 'adipiscing-leo-quis-wisi-justo-dui', '<p><img class="caption" src="images/stories/demo/tech/tech-4.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo.</p>\r\n', '\r\n<p>Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>', 1, 136, '2008-04-16 04:05:35', 42, '', '2011-09-01 07:25:42', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:35', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 8, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(414, 575, 'Curabitur convallis laoreet', 'curabitur-convallis-laoreet', '<img src="images/stories/demo/tech/tech-11.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. </p>\r\n\r\n', '\r\n<pAt Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>', 1, 136, '2008-04-16 04:06:14', 42, '', '2011-01-28 11:44:06', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:06:14', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 7, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(415, 576, 'Telescopes to show universe soon after Big Bang', '1801082437', '<img src="images/stories/demo/tech/spac-1.jpg" alt="Big bang" align="left" title="Big bang" class="caption" />\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. </p>\r\n\r\n', '\r\n<img src="images/stories/demo/tech/spac-2.jpg" alt="Big bang" align="left" title="Big bang" class="caption" />\r\n<p>Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis</p>\r\n\r\n<img src="images/stories/demo/tech/spac-1_1.jpg" alt="Big bang I" align="left" title="Big bang I" class="caption" />\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n<img src="images/stories/demo/tech/spac-1_2.jpg" alt="Big bang II" align="left" title="Big bang II" class="caption" />\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n<img src="images/stories/demo/tech/spac-1_3.jpg" alt="Big bang III" align="left" title="Big bang III" class="caption" />\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>', 1, 136, '2008-04-16 04:06:51', 42, '', '2009-09-04 09:10:43', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:06:51', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 91, '', 1, '*', ''),
(416, 577, 'Vivamus et aliquam Phasellus fames', '1516912537', '<img src="images/stories/demo/tech/space-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at.</p>\r\n\r\n', '\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer est non turpis consectetuer wisi. Libero adipiscing et egestas Nam facilisi et Mauris sit nulla ut. Rutrum eu euismod enim diam hendrerit id Curabitur morbi tristique dolor. Vestibulum Lorem Quisque egestas In rutrum Nulla pellentesque condimentum ut quis. Pulvinar wisi elit nisl sollicitudin sit vitae Nunc Vivamus quis leo. Tortor Vestibulum pellentesque dui.</p>\r\n\r\n<p>Vivamus at fringilla nunc egestas a ac aliquet Nam id at. Dictum vel Cras tincidunt nibh pretium ridiculus porttitor nibh ornare et. Elit tellus felis Donec porttitor congue pretium sed auctor interdum sagittis. Facilisi cursus tristique dis pede velit nulla turpis vel nulla Sed. Enim cursus eleifend sed urna mauris vitae dictum Curabitur nec Vestibulum. Donec tellus Curabitur enim egestas Nullam id urna dictumst.</p>\r\n\r\n<p>Sociis metus auctor eu interdum mollis accumsan vel et velit Vestibulum. Risus vitae dui Nam hac congue dolor Proin tellus Curabitur leo. Urna Donec cursus iaculis Nam Mauris semper ac enim aliquam leo. Adipiscing dui pellentesque porta tellus nulla libero dictum pellentesque convallis ut. Quisque orci in Lorem volutpat hendrerit.</p>\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at. Pretium porttitor orci consectetuer Aenean urna vestibulum tincidunt in dui et. Adipiscing nisl feugiat fermentum suscipit cursus pellentesque et leo quis.</p>\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>', 1, 136, '2009-09-09 09:58:58', 42, '', '2009-09-09 10:01:43', 62, 0, '0000-00-00 00:00:00', '2009-09-09 09:58:58', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(417, 578, 'In et et justo Donec amet velit sem cursus velit', 'in-et-et-justo-donec-amet-velit-sem-cursus-velit', '<p><img class="caption" src="images/stories/demo/tech/space-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt.</p>\r\n', '\r\n<p>Lorem ipsum dolor sit amet consectetuer est non turpis consectetuer wisi. Libero adipiscing et egestas Nam facilisi et Mauris sit nulla ut. Rutrum eu euismod enim diam hendrerit id Curabitur morbi tristique dolor. Vestibulum Lorem Quisque egestas In rutrum Nulla pellentesque condimentum ut quis. Pulvinar wisi elit nisl sollicitudin sit vitae Nunc Vivamus quis leo. Tortor Vestibulum pellentesque dui.</p>\r\n<p>Vivamus at fringilla nunc egestas a ac aliquet Nam id at. Dictum vel Cras tincidunt nibh pretium ridiculus porttitor nibh ornare et. Elit tellus felis Donec porttitor congue pretium sed auctor interdum sagittis. Facilisi cursus tristique dis pede velit nulla turpis vel nulla Sed. Enim cursus eleifend sed urna mauris vitae dictum Curabitur nec Vestibulum. Donec tellus Curabitur enim egestas Nullam id urna dictumst.</p>\r\n<p>Sociis metus auctor eu interdum mollis accumsan vel et velit Vestibulum. Risus vitae dui Nam hac congue dolor Proin tellus Curabitur leo. Urna Donec cursus iaculis Nam Mauris semper ac enim aliquam leo. Adipiscing dui pellentesque porta tellus nulla libero dictum pellentesque convallis ut. Quisque orci in Lorem volutpat hendrerit.</p>\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at. Pretium porttitor orci consectetuer Aenean urna vestibulum tincidunt in dui et. Adipiscing nisl feugiat fermentum suscipit cursus pellentesque et leo quis.</p>\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>', 1, 136, '2009-09-09 10:01:45', 42, '', '2011-09-01 07:27:40', 42, 0, '0000-00-00 00:00:00', '2009-09-09 10:01:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(418, 579, 'Augue nunc at neque vitae metus vel', 'augue-nunc-at-neque-vitae-metus-vel', '<img src="images/stories/demo/tech/space-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor Vestibulum tincidunt.</p>\r\n\r\n', '\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer est non turpis consectetuer wisi. Libero adipiscing et egestas Nam facilisi et Mauris sit nulla ut. Rutrum eu euismod enim diam hendrerit id Curabitur morbi tristique dolor. Vestibulum Lorem Quisque egestas In rutrum Nulla pellentesque condimentum ut quis. Pulvinar wisi elit nisl sollicitudin sit vitae Nunc Vivamus quis leo. Tortor Vestibulum pellentesque dui.</p>\r\n\r\n<p>Vivamus at fringilla nunc egestas a ac aliquet Nam id at. Dictum vel Cras tincidunt nibh pretium ridiculus porttitor nibh ornare et. Elit tellus felis Donec porttitor congue pretium sed auctor interdum sagittis. Facilisi cursus tristique dis pede velit nulla turpis vel nulla Sed. Enim cursus eleifend sed urna mauris vitae dictum Curabitur nec Vestibulum. Donec tellus Curabitur enim egestas Nullam id urna dictumst.</p>\r\n\r\n<p>Sociis metus auctor eu interdum mollis accumsan vel et velit Vestibulum. Risus vitae dui Nam hac congue dolor Proin tellus Curabitur leo. Urna Donec cursus iaculis Nam Mauris semper ac enim aliquam leo. Adipiscing dui pellentesque porta tellus nulla libero dictum pellentesque convallis ut. Quisque orci in Lorem volutpat hendrerit.</p>\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at. Pretium porttitor orci consectetuer Aenean urna vestibulum tincidunt in dui et. Adipiscing nisl feugiat fermentum suscipit cursus pellentesque et leo quis.</p>\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>', 1, 136, '2009-09-09 10:02:09', 42, '', '2011-01-28 11:39:59', 42, 0, '0000-00-00 00:00:00', '2009-09-09 10:02:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(419, 580, 'At laoreet eu lacus non Curabitur leo dui ut nibh', 'at-laoreet-eu-lacus-non-curabitur-leo-dui-ut-nibh', '<img src="images/stories/demo/tech/space-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce.</p>\r\n\r\n', '\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer est non turpis consectetuer wisi. Libero adipiscing et egestas Nam facilisi et Mauris sit nulla ut. Rutrum eu euismod enim diam hendrerit id Curabitur morbi tristique dolor. Vestibulum Lorem Quisque egestas In rutrum Nulla pellentesque condimentum ut quis. Pulvinar wisi elit nisl sollicitudin sit vitae Nunc Vivamus quis leo. Tortor Vestibulum pellentesque dui.</p>\r\n\r\n<p>Vivamus at fringilla nunc egestas a ac aliquet Nam id at. Dictum vel Cras tincidunt nibh pretium ridiculus porttitor nibh ornare et. Elit tellus felis Donec porttitor congue pretium sed auctor interdum sagittis. Facilisi cursus tristique dis pede velit nulla turpis vel nulla Sed. Enim cursus eleifend sed urna mauris vitae dictum Curabitur nec Vestibulum. Donec tellus Curabitur enim egestas Nullam id urna dictumst.</p>\r\n\r\n<p>Sociis metus auctor eu interdum mollis accumsan vel et velit Vestibulum. Risus vitae dui Nam hac congue dolor Proin tellus Curabitur leo. Urna Donec cursus iaculis Nam Mauris semper ac enim aliquam leo. Adipiscing dui pellentesque porta tellus nulla libero dictum pellentesque convallis ut. Quisque orci in Lorem volutpat hendrerit.</p>\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at. Pretium porttitor orci consectetuer Aenean urna vestibulum tincidunt in dui et. Adipiscing nisl feugiat fermentum suscipit cursus pellentesque et leo quis.</p>\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>', 1, 136, '2009-09-09 10:02:45', 42, '', '2011-01-28 11:39:21', 42, 0, '0000-00-00 00:00:00', '2009-09-09 10:02:45', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(420, 581, 'Morbi nibh Vestibulum venenatis nunc', '88075765', '<img src="images/stories/demo/tech/space-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo Phasellus porttitor.</p>\r\n\r\n', '\r\n\r\n<p>Lorem ipsum dolor sit amet consectetuer est non turpis consectetuer wisi. Libero adipiscing et egestas Nam facilisi et Mauris sit nulla ut. Rutrum eu euismod enim diam hendrerit id Curabitur morbi tristique dolor. Vestibulum Lorem Quisque egestas In rutrum Nulla pellentesque condimentum ut quis. Pulvinar wisi elit nisl sollicitudin sit vitae Nunc Vivamus quis leo. Tortor Vestibulum pellentesque dui.</p>\r\n\r\n<p>Vivamus at fringilla nunc egestas a ac aliquet Nam id at. Dictum vel Cras tincidunt nibh pretium ridiculus porttitor nibh ornare et. Elit tellus felis Donec porttitor congue pretium sed auctor interdum sagittis. Facilisi cursus tristique dis pede velit nulla turpis vel nulla Sed. Enim cursus eleifend sed urna mauris vitae dictum Curabitur nec Vestibulum. Donec tellus Curabitur enim egestas Nullam id urna dictumst.</p>\r\n\r\n<p>Sociis metus auctor eu interdum mollis accumsan vel et velit Vestibulum. Risus vitae dui Nam hac congue dolor Proin tellus Curabitur leo. Urna Donec cursus iaculis Nam Mauris semper ac enim aliquam leo. Adipiscing dui pellentesque porta tellus nulla libero dictum pellentesque convallis ut. Quisque orci in Lorem volutpat hendrerit.</p>\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at. Pretium porttitor orci consectetuer Aenean urna vestibulum tincidunt in dui et. Adipiscing nisl feugiat fermentum suscipit cursus pellentesque et leo quis.</p>\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>', 1, 136, '2009-09-09 10:03:33', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2009-09-09 10:03:33', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 1, '', 0, '*', ''),
(421, 583, 'Urna id in nibh sodales', '126732500', '<img src="images/stories/demo/tech/tech-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. </p>\r\n\r\n', '\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 137, '2008-04-16 04:08:17', 42, '', '2009-08-31 06:39:34', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 4, '', 0, '*', ''),
(422, 584, 'Vivamus arcu lorem sem urna', '1166607952', '<img src="images/stories/demo/tech/tech-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper.  </p>\r\n\r\n', '\r\n\r\n<p>Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>', 1, 137, '2008-04-16 04:08:45', 42, '', '2009-08-31 06:38:57', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:45', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 3, '', 0, '*', ''),
(423, 585, 'Hac Morbi ac leo at felis at convallis', 'hac-morbi-ac-leo-at-felis-at-convallis', '<img src="images/stories/demo/tech/tech-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. </p>\r\n\r\n', '\r\n\r\n<p>Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque. Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 137, '2008-04-16 04:09:12', 42, '', '2011-01-28 11:51:56', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:09:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 22, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(424, 586, 'Aliquet eu lacinia vitae', 'aliquet-eu-lacinia-vitae', '<img src="images/stories/demo/tech/sec-8.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n\r\n', '\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 137, '2008-04-16 04:09:12', 42, '', '2011-01-28 11:36:00', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:09:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 1, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(425, 587, 'Lorem pede at quis Nulla', '2059118808', '<img src="images/stories/demo/tech/sec-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n', '\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 137, '2008-04-16 04:09:12', 42, '', '2009-09-09 10:10:12', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:09:12', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 0, '', 0, '*', ''),
(426, 588, 'In Curabitur id risus sit', 'in-curabitur-id-risus-sit', '<p><img class="caption" src="images/stories/demo/tech/sec-5.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget.</p>\r\n', '\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 137, '2008-04-16 04:09:12', 42, '', '2011-09-01 07:28:00', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:09:12', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 3, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(427, 589, 'Porttitor ipsum dolor fermentum', '991282095', '<img src="images/stories/demo/tech/sec-6.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget.</p>\r\n\r\n', '\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 137, '2008-04-16 04:09:12', 42, '', '2009-09-09 10:11:50', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:09:12', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(428, 590, 'Vel arcu in Curabitur est at', '557782011', '<img src="images/stories/demo/tech/sec-7.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel.</p>\r\n\r\n', '\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>', 1, 137, '2008-04-16 04:09:12', 42, '', '2009-09-09 10:18:57', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:09:12', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(429, 592, 'Pellentesque nec orci molestie', '1219682267', '<img src="images/stories/demo/tech/gre-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. </p>\r\n\r\n', '\r\n<p>Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>\r\n\r\n<p>Quam ligula Mauris ac a et morbi eu Vestibulum congue Aenean. Elit diam ut egestas ut et fames Integer pretium interdum molestie. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac.</p>\r\n\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Making Recycling Really Pay" align="left" title="Making Recycling Really Pay" class="caption" />\r\n\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>\r\n\r\n<p>Elit Nullam pellentesque vitae Nulla eget Sed eget sed adipiscing accumsan. Tincidunt felis non amet et eu Nulla egestas cursus accumsan condimentum. Tincidunt accumsan tincidunt dolor pellentesque accumsan Nullam convallis egestas nunc quis. Mauris Suspendisse at pretium ac Aenean faucibus Morbi convallis pharetra et. Sed ut sed Vestibulum ut elit congue convallis massa ante consectetuer. Curabitur non Phasellus cursus et Vestibulum enim lorem.</p>', 1, 138, '2008-04-16 04:03:33', 42, '', '2009-08-31 06:45:00', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:03:33', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 1, '', 0, '*', ''),
(430, 593, 'Nam auctor suscipit interdum laoreet', '2108164104', '<img src="images/stories/demo/tech/gre-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. </p>\r\n\r\n', '\r\n<pAt Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 138, '2008-04-16 04:08:17', 42, '', '2009-08-31 06:40:06', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 3, '', 0, '*', ''),
(431, 594, 'Ligula Nunc lacus quis dui adipiscing', 'ligula-nunc-lacus-quis-dui-adipiscing', '<p><img class="caption" src="images/stories/demo/tech/gre-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo.</p>\r\n', '\r\n<p>Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>', 1, 138, '2008-04-16 04:05:35', 42, '', '2011-09-01 08:07:10', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:05:35', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 6, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(432, 595, 'Morbi nibh Vestibulum venenatis nunc libero', '412276552', '<img src="images/stories/demo/tech/gt-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at.</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 138, '2009-09-09 10:09:32', 42, '', '2009-09-09 10:21:42', 62, 0, '0000-00-00 00:00:00', '2009-09-09 10:09:32', '0000-00-00 00:00:00', '', '', '', 1, 5, '', '', 1, 0, '', 0, '*', ''),
(433, 596, 'Vivamus et aliquam Phasellus fames', '851883123', '<img src="images/stories/demo/tech/gt-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia.</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 138, '2009-09-09 10:21:08', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2009-09-09 10:21:08', '0000-00-00 00:00:00', '', '', '', 1, 4, '', '', 1, 6, '', 0, '*', ''),
(434, 597, 'Proin feugiat id enim nibh nulla auctor', '1579114850', '<img src="images/stories/demo/tech/gt-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at.</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 138, '2009-09-09 10:21:44', 42, '', '2009-09-11 03:41:34', 62, 0, '0000-00-00 00:00:00', '2009-09-09 10:21:44', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 24, '', 1, '*', ''),
(435, 598, 'Eget consequat hendrerit tempus porttitor', 'eget-consequat-hendrerit-tempus-porttitor', '<img src="images/stories/demo/tech/gt-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec.</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 138, '2009-09-09 10:22:33', 42, '', '2011-01-28 11:46:57', 42, 0, '0000-00-00 00:00:00', '2009-09-09 10:22:33', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 2, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(436, 599, 'Curabitur urna Suspendisse nibh laoreet', 'curabitur-urna-suspendisse-nibh-laoreet', '<img src="images/stories/demo/tech/gt-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Augue nunc at neque vitae metus vel tellus justo porta eget. In et et justo Donec amet velit sem cursus velit urna. Risus ac consequat at et enim ut est ipsum sapien at.</p>\r\n\r\n', '\r\n\r\n<p>Urna dis dictumst tempor Vestibulum tincidunt Vivamus et aliquam Phasellus fames. Vestibulum et Sed facilisis Lorem consequat elit convallis metus urna ac. Lorem neque ornare ultrices laoreet augue ipsum nulla diam tempor Lorem. Nulla cursus nisl augue urna laoreet lacinia tempor eget fringilla tincidunt. Tristique Quisque vel porttitor libero elit auctor Aenean velit Nam Vestibulum. Quisque semper eget congue tempus congue interdum In elit vel vestibulum. Justo interdum.</p>\r\n\r\n<p>Quis Sed dolor at et eget vitae Vestibulum sed mauris dolor. At laoreet eu lacus non Curabitur leo dui ut nibh dignissim. Aenean Vivamus ut tortor vitae Cras elit velit elit Phasellus porttitor. Hac fames nunc et magna tempor gravida lobortis malesuada et Praesent. Nam Aenean tortor Suspendisse tellus tempus suscipit sociis Vestibulum justo Phasellus. Laoreet tortor urna a eget id Curabitur justo.</p>\r\n\r\n<p>Id eu iaculis nibh ut interdum id augue lacus at amet. Eget consequat hendrerit tempus porttitor Cras interdum Nunc Nulla ante id. Morbi nibh Vestibulum venenatis nunc libero justo convallis sit egestas Fusce. Vel pede ridiculus congue condimentum natoque tincidunt eleifend ipsum Vestibulum Donec. Id eros massa interdum libero ligula tellus Curabitur eros ut rhoncus. Ut tempus lacinia ut quam arcu laoreet dictumst.</p>\r\n\r\n<p>Et sapien libero metus aliquet Aliquam eros orci diam eget laoreet. Orci interdum at ut sed Aliquam nibh quis nulla in et. Tempus pretium ullamcorper eget consequat urna quis lacus ante urna consectetuer. Lacus pulvinar in a convallis lacinia ullamcorper Curabitur convallis congue vitae. Congue id nibh congue magna porta sed Mauris.</p>\r\n\r\n<p>Magna elit tempus neque Phasellus et interdum sollicitudin pretium venenatis habitant. In tempor nascetur pretium ligula hendrerit molestie adipiscing consequat nec In. Id Fusce nascetur vitae Curabitur consectetuer nunc pede et sem risus. Curabitur urna Suspendisse nibh laoreet Quisque semper faucibus eu dui lacinia. Et semper nibh quis ac pede sodales Duis orci neque Curabitur. Lorem nibh Nam ante sodales In et Sed.</p>\r\n\r\n<p>Proin feugiat id enim nibh nulla auctor velit congue ac Vestibulum. Condimentum et tellus dui ridiculus eros molestie orci nunc non eros. Aenean fames risus vel id sociis in lacus risus ac Vestibulum. Donec nisl metus vitae odio vel Nulla Quisque sociis Morbi ac. Consequat leo vel Sed at auctor nulla vitae vitae Nam fermentum. Consectetuer fringilla.</p>', 1, 138, '2009-09-09 10:23:04', 42, '', '2011-01-28 11:44:55', 42, 0, '0000-00-00 00:00:00', '2009-09-09 10:23:04', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 1, '', '', 1, 7, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(437, 601, 'Ut fames Duis nibh arcu', '152575014', '<img src="images/stories/demo/tech/sec-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. </p>\r\n\r\n', '\r\n<p>Hac Morbi ac leo at felis at convallis ante magnis nibh. Tincidunt cursus quam dis ut aliquet ac Vivamus netus suscipit id. Velit tortor ornare tellus quis nec.</p>\r\n\r\n<p>Ut fames Duis nibh arcu pede elit nibh at risus tempus. Nulla semper ac nec sit massa In Curabitur id risus sit. Non ante gravida eros quis justo sed nonummy et Donec et. Hendrerit velit orci sagittis eu Aenean pharetra faucibus eu laoreet nunc. Tincidunt nulla a Nulla eu convallis scelerisque sociis nulla interdum et. Cursus senectus aliquet pretium at tristique hac ullamcorper adipiscing et Donec. Enim montes parturient.</p>\r\n\r\n<p>Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas. Nunc egestas ut tempus felis quam elit orci ut congue porttitor. Congue non est velit Vivamus hac iaculis neque Morbi faucibus et. Nibh nibh consectetuer semper pretium Cum mauris justo eros Donec Nulla. Ligula Nunc lacus quis dui adipiscing euismod Nam mus mus eu. Aenean at vel interdum nunc elit lorem id nulla nunc Proin. A.</p>\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien.</p>', 1, 139, '2008-04-16 04:04:13', 42, '', '2009-08-31 06:44:10', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:04:13', '0000-00-00 00:00:00', '', '', '', 1, 8, '', '', 1, 0, '', 0, '*', ''),
(438, 602, 'Semper accumsan Integer nisl Pellentesque', '1542262373', '<img src="images/stories/demo/tech/sec-2.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. </p>\r\n\r\n', '\r\n\r\n<p>Sed augue orci et libero sapien dui morbi quis faucibus ipsum. Leo ornare egestas pretium odio Nam cursus odio et quis convallis. Nam auctor suscipit interdum laoreet magna convallis egestas Suspendisse sem eu. Et cursus sapien. Quam ligula Mauris ac a et morbi eu Vestibulum congue Aenean. Elit diam ut egestas ut et fames Integer pretium interdum molestie. Orci pharetra Curabitur Nulla laoreet consectetuer Donec orci consectetuer justo ac.</p>\r\n\r\n<img src="images/stories/demo/tech/tech-1.jpg" alt="Making Recycling Really Pay" align="left" title="Making Recycling Really Pay" class="caption" />\r\n<p>Nibh volutpat tortor augue convallis aliquam augue condimentum urna tortor id. Sed nibh dui Vestibulum sed ante fringilla est leo Nam mauris. Ac dignissim et consectetuer convallis tincidunt eu eros at mauris morbi. Felis tempor felis Vestibulum sodales quis sed lorem quis Curabitur eros. Pellentesque nec orci molestie tellus Maecenas pellentesque ut vel hac nibh. Sem pulvinar hendrerit at metus urna adipiscing semper Sed.</p>\r\n\r\n<p>Praesent Aenean Phasellus risus enim vitae auctor Aenean Donec gravida hendrerit. Vitae tempus eget at lorem sapien nulla eget enim Morbi sit. At habitant enim id dolor risus urna Lorem nec mauris congue. Consequat congue orci id libero justo tellus Morbi nibh Proin interdum. Vestibulum accumsan at nibh pretium tortor Phasellus neque morbi sagittis gravida. Praesent Morbi Aliquam.</p>\r\n\r\n<p>Elit Nullam pellentesque vitae Nulla eget Sed eget sed adipiscing accumsan. Tincidunt felis non amet et eu Nulla egestas cursus accumsan condimentum. Tincidunt accumsan tincidunt dolor pellentesque accumsan Nullam convallis egestas nunc quis. Mauris Suspendisse at pretium ac Aenean faucibus Morbi convallis pharetra et. Sed ut sed Vestibulum ut elit congue convallis massa ante consectetuer. Curabitur non Phasellus cursus et Vestibulum enim lorem.</p>', 1, 139, '2008-04-16 04:03:33', 42, '', '2009-08-31 06:45:12', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:03:33', '0000-00-00 00:00:00', '', '', '', 1, 7, '', '', 1, 1, '', 1, '*', ''),
(439, 603, 'Vestibulum sodales quis sed lorem quis Curabitur eros', '1576770569', '<img src="images/stories/demo/tech/sec-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. </p>\r\n\r\n', '\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 139, '2008-04-16 04:08:17', 42, '', '2009-08-31 06:40:26', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '', 1, 6, '', '', 1, 2, '', 0, '*', ''),
(440, 604, 'At Pellentesque id quis', 'at-pellentesque-id-quis', '<img src="images/stories/demo/tech/security-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. </p>\r\n\r\n', '\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 139, '2008-04-16 04:08:17', 42, '', '2011-01-28 11:39:29', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 5, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(441, 605, 'Integer justo lorem sagittis', 'integer-justo-lorem-sagittis', '<p><img class="caption" src="images/stories/demo/tech/security-2.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n', '\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus.</p>\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 139, '2008-04-16 04:08:17', 42, '', '2011-09-01 07:37:04', 42, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","alternative_readmore":"","article_layout":""}', 2, 4, '', '', 1, 0, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(442, 606, 'Neque justo laoreet', '830299705', '<img src="images/stories/demo/tech/security-3.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. </p>\r\n\r\n', '\r\n\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 139, '2008-04-16 04:08:17', 42, '', '2009-09-09 10:24:52', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '', 1, 3, '', '', 1, 0, '', 0, '*', '');
INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `introtext`, `fulltext`, `state`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`) VALUES
(443, 607, 'Sed dolor condimentum', '1910378050', '<img src="images/stories/demo/tech/security-4.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus.</p>\r\n\r\n', '\r\n\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 139, '2008-04-16 04:08:17', 42, '', '2009-09-09 10:25:37', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '', 1, 2, '', '', 1, 0, '', 0, '*', ''),
(444, 608, 'Quisque leo non malesuada', '1280038709', '<img src="images/stories/demo/tech/security-5.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. </p>\r\n\r\n', '\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>\r\n\r\n<p>At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Urna id in nibh sodales id nulla diam turpis accumsan Curabitur. Neque justo laoreet aliquam molestie tempus Proin Integer Vestibulum lacinia semper. Interdum augue Nunc egestas magna gravida wisi Nullam id In tellus. Porta sed nec feugiat Vivamus tincidunt vitae vel quis accumsan faucibus. Tincidunt nisl vel lacinia felis et Quisque leo non malesuada risus. Faucibus Suspendisse sodales mollis nisl Maecenas turpis auctor et gravida.</p>\r\n\r\n<p>Adipiscing leo quis wisi justo dui Vivamus arcu lorem sem urna. Aliquet eu lacinia vitae id elit Pellentesque dolor ac et ante. Vestibulum Nulla vitae cursus quis dui lacinia vestibulum mus a Duis. Lorem pede at quis Nulla at lacinia orci magna pellentesque ac. Sed porttitor Nam auctor laoreet ut nisl montes wisi tellus orci. Et pellentesque.</p>\r\n\r\n<p>Curabitur convallis laoreet wisi pretium ante orci euismod tincidunt tortor Pellentesque. Volutpat habitasse sed adipiscing Sed elit eros sit Sed gravida Vivamus. Nullam et nascetur vel cursus justo accumsan at Nullam elit nunc. Porttitor ipsum dolor fermentum Vestibulum a tempus tempor magna Duis eget. Id eu hac dui et mus neque laoreet porttitor et magna. Proin libero nibh tempus Vivamus porta nibh elit.</p>', 1, 139, '2008-04-16 04:08:17', 42, '', '2009-09-09 10:26:15', 62, 0, '0000-00-00 00:00:00', '2008-04-16 04:08:17', '0000-00-00 00:00:00', '', '', '', 1, 1, '', '', 1, 0, '', 0, '*', ''),
(445, 612, '10 Things you MUST know about Teline III ', '10-things-you-must-know-about-teline-iii', '<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">1</span>New Joomla template framework introduced</h4>\r\n<img src="images/stories/demo/other/feature-1.jpg" border="0" alt="New Joomla template framework introduced" title="New Joomla template framework introduced" align="left" /> \r\n<ul>\r\n<li><a href="http://docs.google.com/present/view?id=0Aa34tsbQFaglZGc2bWZ2MjRfNjZjdzY3MnFnZg&amp;hl=en" target="_blank">Brainstorming &amp; approach</a></li>\r\n<li>Blocks &amp; layouts concept added to Joomla templates </li>\r\n<li>Add flexibility in  modules positions </li>\r\n</ul>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">2</span> 7 New  modules &amp; plugins</h4>\r\n<img src="images/stories/demo/other/feature-2.jpg" border="0" alt=" 9 New  modules &amp; plugins" title="7 New  modules &amp; plugins" align="right" /> \r\n<ul>\r\n<li><a href="http://www.joomlart.com/forums/showthread.php?t=34813" target="_blank">JA News II Modules</a> - <a href="http://www.joomlart.com/forums/showthread.php?t=34819" target="_blank">JA News II Frontpages Modules</a> (<em>revamped</em>) </li>\r\n<li><a href="http://www.joomlart.com/forums/showthread.php?t=34887" target="_blank">JA Mega menu</a></li>\r\n<li><a href="http://www.joomlart.com/forums/showthread.php?t=34827" target="_blank">JA News Sticker Module</a></li>\r\n<li><a href="http://www.joomlart.com/forums/showthread.php?t=34823" target="_blank">JA Comment Plugins</a></li>\r\n<li><a href="http://www.joomlart.com/forums/showthread.php?t=34824" target="_blank">JA Popup Plugin</a></li>\r\n<li><a href="http://www.joomlart.com/forums/showthread.php?t=34825" target="_blank">JA Bookmark Plugin</a></li>\r\n<li><a href="http://www.joomlart.com/forums/showthread.php?t=34826" target="_blank">JA Inline Image Galary Plugin</a></li>\r\n</ul>\r\n<p>You need a paid membership on JoomlArt to view links listed above. Not have account yet? You check <a href="http://www.joomlart.com/templates_club/club_portfolio/ja_teline_iii.html">screenshorts</a> and <a href="http://template15.joomlart.com/ja_teline_iii_extra">Live demo</a> instead.</p>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">3 </span>Iphone &amp; Handheld Native support &amp; optimization</h4>\r\n<img src="images/stories/demo/other/feature-3.jpg" border="0" alt="Iphone &amp; Handheld Native support &amp; optimization" title="Iphone &amp; Handheld Native support &amp; optimization" align="left" style="margin-right: 30px;" />\r\n<p>Cross-browser compatibility now refers to not only computer-based browsers but also handheld device screens. There might be time you wonder how your site looks in an iPhone?</p>\r\n<p>JA Teline III is fully compatible with handheld device. It automatically detects handheld device screen ((iPhone,  Android, Opera Mini, Blackberry, Palm, Windows etc.,) to load respective layout.</p>\r\n<ul>\r\n<li>Navigation is simplified with simple HTML</li>\r\n<li>Content is resized and rearranged but it still keeps the normal  arrangement (so that user can find his favorite content as when he views via his computer)</li>\r\n<li>Images is resized and optimized (internet connection via mobile is always slower than computer)</li>\r\n<li>Supports both portrait + landscape view on iphone</li>\r\n<li>Option to change to Desktop view (normal layout) if one wish </li>\r\n</ul>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">4</span> SEO Utimate - Content first , content on the top</h4>\r\n<img src="images/stories/demo/other/feature-4.jpg" border="0" alt="SEO Utimate - Content first , content on the top" title="SEO Utimate - Content first, content on the top" align="right" />\r\n<p class="feature-title">In default &amp; other Joomla templates, site content are normall loaded in the standard consequence: header »» left modules »» <span style="color: #ff0000;"><strong>mainbody </strong></span>»» right module »» footer. With JA teline III, this order has been improved:</p>\r\n<p class="feature-title">header »» <span style="color: #ff0000;"><strong>mainbody </strong></span> »» left modules »» right module »» footer</p>\r\n<p class="feature-title">So, with this new order, the search bots will be able to find important contents &amp; keywords easier and certainly will increase your ranking in the search result pages</p>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">5</span>Social &amp; Community Ready</h4>\r\n<img src="images/stories/demo/other/feature-5.jpg" border="0" alt="Social &amp; Community Ready" title="Social &amp; Community Ready" align="left" style="margin-right: 30px;" />\r\n<p>Increase  reader engagement around your content, generate social traffic drive via popular web2.0 tools:</p>\r\n<ul>\r\n<li> <a href="http://www.intensedebate.com">IntenseDebate</a>, <a href="http://www.disqus.com">DisQus</a>, <a href="http://www.js-kit.com/">JS-Kit</a>:  Noticeable commenting systems - Encourage conversation, bring the value of insightful comments. </li>\r\n<li><a href="http://www.addthis.com/">AddThis</a>, <a href="http://www.addtoany.com/">AddToAny</a>: Social bookmarking and sharing service.</li>\r\n<li><a href="http://twitter.com/">Twitter</a>: A real-time short messaging service - Share.Update.Connect Twitter stream </li>\r\n</ul>\r\n<p>JA Teline III puts all those handful tools together. It\'s just a matter of configuration, then your Joomla site is ready to enrich your site\'s community.</p>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">6</span>News, Community or Simple Cooperate Identity</h4>\r\n<img src="images/stories/demo/other/feature-6.jpg" border="0" alt="News, Community or Simple Cooperate Identity" title="News, Community or Simple Cooperate Identity" align="right" />\r\n<p>As you can see the customization power of JA Teline I &amp; II, JA Teline III is not just an online-magazine! Explore JA Teline III for more,  creating your own community or simply branding your cooperate identity etc.,. Rich addons and standardized development on JoomlArt new template framework base make all your custom use possible.</p>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">7</span>Flexibility Layout, Customization as easy as 1,2,3</h4>\r\n<img src="images/stories/demo/other/feature-7.jpg" border="0" alt="Flexibility Layout, Customization as easy as 1,2,3" title="Flexibility Layout, Customization as easy as 1,2,3" align="left" style="margin-right: 30px;" />\r\n<p>Starting new things from JA Teline III, you will find modification works are not too complicated. Div-based development approach,  well-commented code, validated markups drive you to custom our original design concept to new-high level without hassle.</p>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">8</span>JA Voice, JA Job Board Integration Ready</h4>\r\n<img src="images/stories/demo/other/feature-8.jpg" border="0" alt="JA Voice, JA Job Board Integration Ready" title="JA Voice, JA Job Board Integration Ready" align="right" />\r\n<p>JA Teline III is <a href="http://jobboard.joomlart.com">JA JobBoard</a> and <a href="http://javoice.joomlart.com">JA Voice</a> Ready. <a href="http://www.joomlart.com/forums/downloads.php?do=cat&amp;id=143">Download and Install the JA Teline   III Extra quickstart</a> and walk right into the back-end and front-ends of the two   enterprise components developed by JoomlArt. Or download the Enterprise   Components (<a href="http://www.joomlart.com/forums/downloads.php?do=cat&amp;id=139">JA Voice</a> | <a href="http://www.joomlart.com/forums/downloads.php?do=cat&amp;id=130">JA Job Board</a>) and install them as normal Joomla extensions, they will snugly fit   into your website...</p>\r\n<p><a href="http://javoice.joomlart.com">JA Voice</a>: A Joomla-based feedback component - a new way to start a constructive conversation, emails and forums are now history. It enables gathering thoughts, ideas, feedbacks from users/ customers in an organized structure, where ideas can be commented, voted up or down in a transparent way. Try it to Know it...</p>\r\n<p><a href="http://jobboard.joomlart.com">JA Jobboard</a>: A full-functioned recruitment component for Joomla 1.5. Allows you to create and run a fully automated Job site with tools to manage jobs, resumes, applications and subscriptions. Yes, its rich with features and strongly scalable and easy to use for you and for your users. Try the demo now...</p>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">9</span> It\'s in JA top priority for support, updates &amp; improvements</h4>\r\n<img src="images/stories/demo/other/feature-9.jpg" border="0" alt="It\'s in JA top priority for support, updates &amp; improvements" title="It\'s in JA top priority for support, updates &amp; improvements" align="left" style="margin-right: 20px;" />\r\n<p>JA Teline III is an hardwork of over 3 months of preparations, starting from new framework upto development of new compatible extensions. No doubt that Teline III is a major JA template for the year 2009 and be assured of priority support and future updates.</p>\r\n</div>\r\n<div class="ja-feature clearfix">\r\n<h4 class="feature-title"><span class="feature-number">10</span> JA Teline III Contest coming, so you get more chances to download the variations</h4>\r\n<img src="images/stories/demo/other/feature-10.jpg" border="0" alt="JA Teline III Contest coming, so you get more chances to download the variations" title="JA Teline III Contest coming, so you get more chances to download the variations" align="right" />\r\n<p class="feature-title">Above everything, its always a pleasure to see the real usage of JoomlArt templates. We are always keen and glad to see different instances of our templates. It also adds to our ideas about further developments. this strongly motivates JoomlArt to organize a community contest to choose the best JA Teline III implementation.</p>\r\n<p class="feature-title">We warmly welcome all web designers, developers or anyone who love web stuff to join us at the contest. Participation into this special event will surely bring in lots of fun, valuable connection to share web hobbies, knowledge or even make you/your skills widespread-known. Not to mention interesting Gifts from our side.</p>\r\n</div>\r\n<p>{jathumbnail off}</p>', '', 1, 9, '2011-01-28 10:12:46', 42, '', '2011-05-30 09:27:31', 42, 0, '0000-00-00 00:00:00', '2011-01-28 10:12:46', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"0","show_noauth":"0","alternative_readmore":"","article_layout":""}', 6, 0, '', '', 1, 18, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(446, 614, 'Content + Right laylout', 'content-right-laylout', '<p><img src="images/stories/demo/health/diet-3.jpg" border="0" style="border: 0; float: left; margin: 5px;" />Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis.</p>\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', '', 1, 14, '2012-03-22 02:39:26', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-03-22 02:39:26', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 2, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(447, 615, '3 Columns', '3-columns', '<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis.</p>\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', '', 1, 14, '2012-03-22 02:51:43', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-03-22 02:51:43', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 1, '', '', 1, 2, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', ''),
(448, 616, 'Full width', 'full-width', '<p>Egestas Phasellus leo porttitor arcu vel consequat malesuada justo augue ut. A elit consequat interdum libero massa Duis quis Aliquam id faucibus. At turpis lacinia vitae montes metus Quisque dolor vel quis felis.</p>\r\n<p>Curabitur leo eu justo dui non adipiscing nisl quis orci dui. Sed risus ac et est Curabitur nec enim id malesuada. Adipiscing et Cum habitasse molestie rhoncus Vivamus nibh auctor condimentum volutpat. Leo consequat auctor sem mus faucibus sapien mus at eros massa. Nec Sed laoreet elit condimentum mollis Aenean Curabitur tellus Curabitur consequat. Elit tempus Lorem tempus condimentum Nam eget justo fermentum cursus et. Massa malesuada libero Donec id aliquet id.</p>\r\n<p>Nonummy pulvinar semper arcu mauris Curabitur nibh Vivamus penatibus elit Aenean. Quis augue montes hendrerit Lorem et augue sollicitudin Vestibulum sodales Nam. Vel lorem fringilla ante nunc dui ligula malesuada at habitasse lobortis. Pellentesque felis mollis laoreet nec congue lacinia Curabitur sed mi tempor. Malesuada consectetuer hendrerit turpis Suspendisse ut Integer Phasellus felis tellus.</p>\r\n<p>Lorem quis ut neque Phasellus pede id magna mauris Nullam eget. Senectus semper venenatis tincidunt semper velit pede ante et ridiculus leo. Sapien Nam eleifend sed pellentesque Ut nunc fames dui quis Nullam. Quis natoque consequat quis Nam dictum ipsum Curabitur scelerisque ipsum tempor. Nulla vel in Nam id Phasellus molestie quis at eu Phasellus. Nulla ac.</p>\r\n<p>Nec justo Ut et at risus Nam In magnis nunc Mauris. Vitae montes et pede id urna massa dignissim eget malesuada orci. In tincidunt convallis sem felis ornare fringilla at ac ac convallis. Eu et lacinia eros amet nulla Aenean justo adipiscing at Integer. Vitae dolor wisi senectus vel fringilla gravida augue lacus wisi semper. Interdum a tortor congue pede risus ut.</p>\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. At Pellentesque id quis malesuada Aenean id Curabitur auctor nulla wisi. Tortor senectus Aenean nec mauris tellus velit id mauris interdum risus. Feugiat auctor et eros Integer justo lorem sagittis tincidunt Aenean tristique. Magna nulla malesuada id et dapibus nonummy.</p>', '', 1, 14, '2012-03-22 02:52:09', 42, '', '0000-00-00 00:00:00', 0, 0, '0000-00-00 00:00:00', '2012-03-22 02:52:09', '0000-00-00 00:00:00', '', '', '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, 0, '', '', 1, 1, '{"robots":"","author":"","rights":"","xreference":""}', 0, '*', '');

DROP TABLE IF EXISTS `#__content_frontpage`;
CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`) VALUES
(8, 55),
(35, 57),
(24, 54),
(50, 56),
(80, 19),
(120, 15),
(126, 46),
(130, 3),
(137, 45),
(144, 44),
(148, 4),
(152, 21),
(157, 43),
(165, 42),
(171, 1),
(175, 47),
(178, 48),
(182, 11),
(196, 53),
(201, 52),
(215, 17),
(230, 6),
(231, 20),
(233, 51),
(237, 50),
(249, 49),
(252, 14),
(256, 16),
(260, 41),
(266, 40),
(277, 5),
(285, 30),
(292, 29),
(294, 28),
(295, 8),
(298, 7),
(304, 27),
(306, 26),
(308, 25),
(317, 9),
(327, 24),
(345, 23),
(349, 10),
(353, 31),
(358, 13),
(368, 2),
(375, 39),
(379, 38),
(383, 37),
(392, 36),
(395, 12),
(397, 35),
(409, 34),
(415, 33),
(424, 18),
(434, 32),
(438, 22);

DROP TABLE IF EXISTS `#__content_rating`;
CREATE TABLE `#__content_rating` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(10) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(10) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__content_types`;
CREATE TABLE `#__content_types` (
  `type_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type_title` varchar(255) NOT NULL DEFAULT '',
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `table` varchar(255) NOT NULL DEFAULT '',
  `rules` text NOT NULL,
  `field_mappings` text NOT NULL,
  `router` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`type_id`),
  KEY `idx_alias` (`type_alias`)
) ENGINE=InnoDB ;

INSERT INTO `#__content_types` (`type_id`, `type_title`, `type_alias`, `table`, `rules`, `field_mappings`, `router`) VALUES
(1, 'Article', 'com_content.article', '{"special":{"dbtable":"#__content","key":"id","type":"Content","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"introtext", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"attribs", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"asset_id"}], "special": [{"fulltext":"fulltext"}]}', 'ContentHelperRoute::getArticleRoute'),
(2, 'Weblink', 'com_weblinks.weblink', '{"special":{"dbtable":"#__weblinks","key":"id","type":"Weblink","prefix":"WeblinksTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"state","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}], "special": []}', 'WeblinksHelperRoute::getWeblinkRoute'),
(3, 'Contact', 'com_contact.contact', '{"special":{"dbtable":"#__contact_details","key":"id","type":"Contact","prefix":"ContactTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"address", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"image", "core_urls":"webpage", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}], "special": [{"con_position":"con_position","suburb":"suburb","state":"state","country":"country","postcode":"postcode","telephone":"telephone","fax":"fax","misc":"misc","email_to":"email_to","default_con":"default_con","user_id":"user_id","mobile":"mobile","sortname1":"sortname1","sortname2":"sortname2","sortname3":"sortname3"}]}', 'ContactHelperRoute::getContactRoute'),
(4, 'Newsfeed', 'com_newsfeeds.newsfeed', '{"special":{"dbtable":"#__newsfeeds","key":"id","type":"Newsfeed","prefix":"NewsfeedsTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"name","core_state":"published","core_alias":"alias","core_created_time":"created","core_modified_time":"modified","core_body":"description", "core_hits":"hits","core_publish_up":"publish_up","core_publish_down":"publish_down","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"link", "core_version":"version", "core_ordering":"ordering", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"catid", "core_xreference":"xreference", "asset_id":"null"}], "special": [{"numarticles":"numarticles","cache_time":"cache_time","rtl":"rtl"}]}', 'NewsfeedsHelperRoute::getNewsfeedRoute'),
(5, 'User', 'com_users.user', '{"special":{"dbtable":"#__users","key":"id","type":"User","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"name","core_state":"null","core_alias":"username","core_created_time":"registerdate","core_modified_time":"lastvisitDate","core_body":"null", "core_hits":"null","core_publish_up":"null","core_publish_down":"null","access":"null", "core_params":"params", "core_featured":"null", "core_metadata":"null", "core_language":"null", "core_images":"null", "core_urls":"null", "core_version":"null", "core_ordering":"null", "core_metakey":"null", "core_metadesc":"null", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}], "special": [{}]}', 'UsersHelperRoute::getUserRoute'),
(6, 'Article Category', 'com_content.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'ContentHelperRoute::getCategoryRoute'),
(7, 'Contact Category', 'com_contact.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'ContactHelperRoute::getCategoryRoute'),
(8, 'Newsfeeds Category', 'com_newsfeeds.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'NewsfeedsHelperRoute::getCategoryRoute'),
(9, 'Weblinks Category', 'com_weblinks.category', '{"special":{"dbtable":"#__categories","key":"id","type":"Category","prefix":"JTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"null", "core_metadata":"metadata", "core_language":"language", "core_images":"null", "core_urls":"null", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"parent_id", "core_xreference":"null", "asset_id":"asset_id"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path","extension":"extension","note":"note"}]}', 'WeblinksHelperRoute::getCategoryRoute'),
(10, 'Tag', 'com_tags.tag', '{"special":{"dbtable":"#__tags","key":"tag_id","type":"Tag","prefix":"TagsTable","config":"array()"},"common":{"dbtable":"#__core_content","key":"ucm_id","type":"Corecontent","prefix":"JTable","config":"array()"}}', '', '{"common":[{"core_content_item_id":"id","core_title":"title","core_state":"published","core_alias":"alias","core_created_time":"created_time","core_modified_time":"modified_time","core_body":"description", "core_hits":"hits","core_publish_up":"null","core_publish_down":"null","core_access":"access", "core_params":"params", "core_featured":"featured", "core_metadata":"metadata", "core_language":"language", "core_images":"images", "core_urls":"urls", "core_version":"version", "core_ordering":"null", "core_metakey":"metakey", "core_metadesc":"metadesc", "core_catid":"null", "core_xreference":"null", "asset_id":"null"}], "special": [{"parent_id":"parent_id","lft":"lft","rgt":"rgt","level":"level","path":"path"}]}', 'TagsHelperRoute::getTagRoute');

DROP TABLE IF EXISTS `#__contentitem_tag_map`;
CREATE TABLE `#__contentitem_tag_map` (
  `type_alias` varchar(255) NOT NULL DEFAULT '',
  `core_content_id` int(10) unsigned NOT NULL COMMENT 'PK from the core content table',
  `content_item_id` int(11) NOT NULL COMMENT 'PK from the content type table',
  `tag_id` int(10) unsigned NOT NULL COMMENT 'PK from the tag table',
  `tag_date` timestamp NOT NULL COMMENT 'Date of most recent save for this tag-item',
  `type_id` mediumint(8) NOT NULL COMMENT 'PK from the content_type table',
  UNIQUE KEY `uc_ItemnameTagid` (`type_id`,`content_item_id`,`tag_id`),
  KEY `idx_tag_type` (`tag_id`,`type_id`),
  KEY `idx_date_id` (`tag_date`,`tag_id`),
  KEY `idx_tag` (`tag_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_core_content_id` (`core_content_id`)
) ENGINE=InnoDB COMMENT='Maps items from content tables to tags';

INSERT INTO `#__contentitem_tag_map` (`type_alias`, `core_content_id`, `content_item_id`, `tag_id`, `tag_date`, `type_id`) VALUES
('com_content.article', 1, 115, 2, '2013-07-30 15:57:53', 1),
('com_content.article', 1, 115, 3, '2013-07-30 15:57:53', 1),
('com_content.article', 1, 115, 4, '2013-07-30 15:57:53', 1),
('com_content.article', 2, 165, 3, '2013-07-30 15:59:49', 1),
('com_content.article', 2, 165, 5, '2013-07-30 15:59:49', 1),
('com_content.article', 2, 165, 6, '2013-07-30 15:59:49', 1),
('com_content.article', 3, 213, 3, '2013-07-30 16:02:34', 1),
('com_content.article', 3, 213, 7, '2013-07-30 16:02:34', 1),
('com_content.article', 3, 213, 8, '2013-07-30 16:02:34', 1),
('com_content.article', 4, 235, 3, '2013-07-30 16:04:16', 1),
('com_content.article', 4, 235, 9, '2013-07-30 16:04:16', 1),
('com_content.article', 4, 235, 10, '2013-07-30 16:04:16', 1),
('com_content.article', 5, 283, 3, '2013-07-30 16:06:59', 1),
('com_content.article', 5, 283, 11, '2013-07-30 16:06:59', 1),
('com_content.article', 5, 283, 12, '2013-07-30 16:06:59', 1),
('com_content.article', 6, 299, 3, '2013-07-30 16:08:40', 1),
('com_content.article', 6, 299, 13, '2013-07-30 16:08:40', 1),
('com_content.article', 6, 299, 14, '2013-07-30 16:08:40', 1),
('com_content.article', 7, 349, 3, '2013-07-30 16:10:37', 1),
('com_content.article', 7, 349, 15, '2013-07-30 16:10:37', 1),
('com_content.article', 7, 349, 16, '2013-07-30 16:10:37', 1),
('com_content.article', 8, 397, 3, '2013-07-30 16:11:54', 1),
('com_content.article', 8, 397, 17, '2013-07-30 16:11:54', 1),
('com_content.article', 8, 397, 18, '2013-07-30 16:11:54', 1);

DROP TABLE IF EXISTS `#__core_log_searches`;
CREATE TABLE `#__core_log_searches` (
  `search_term` varchar(128) NOT NULL DEFAULT '',
  `hits` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__extensions`;
CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned DEFAULT NULL,
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM ;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(1, 'com_mailto', 'component', 'com_mailto', '', 0, 1, 1, 1, '{"name":"com_mailto","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MAILTO_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(2, 'com_wrapper', 'component', 'com_wrapper', '', 0, 1, 1, 1, '{"name":"com_wrapper","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(3, 'com_admin', 'component', 'com_admin', '', 1, 1, 1, 1, '{"name":"com_admin","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_ADMIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(4, 'com_banners', 'component', 'com_banners', '', 1, 1, 1, 0, '{"name":"com_banners","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_BANNERS_XML_DESCRIPTION","group":""}', '{"purchase_type":"3","track_impressions":"0","track_clicks":"0","metakey_prefix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(5, 'com_cache', 'component', 'com_cache', '', 1, 1, 1, 1, '{"name":"com_cache","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CACHE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(6, 'com_categories', 'component', 'com_categories', '', 1, 1, 1, 1, '{"name":"com_categories","type":"component","creationDate":"December 2007","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(7, 'com_checkin', 'component', 'com_checkin', '', 1, 1, 1, 1, '{"name":"com_checkin","type":"component","creationDate":"Unknown","author":"Joomla! Project","copyright":"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CHECKIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(8, 'com_contact', 'component', 'com_contact', '', 1, 1, 1, 0, '{"name":"com_contact","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTACT_XML_DESCRIPTION","group":""}', '{"show_contact_category":"hide","show_contact_list":"0","presentation_style":"sliders","show_name":"1","show_position":"1","show_email":"0","show_street_address":"1","show_suburb":"1","show_state":"1","show_postcode":"1","show_country":"1","show_telephone":"1","show_mobile":"1","show_fax":"1","show_webpage":"1","show_misc":"1","show_image":"1","image":"","allow_vcard":"0","show_articles":"0","show_profile":"0","show_links":"0","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","contact_icons":"0","icon_address":"","icon_email":"","icon_telephone":"","icon_mobile":"","icon_fax":"","icon_misc":"","show_headings":"1","show_position_headings":"1","show_email_headings":"0","show_telephone_headings":"1","show_mobile_headings":"0","show_fax_headings":"0","allow_vcard_headings":"0","show_suburb_headings":"1","show_state_headings":"1","show_country_headings":"1","show_email_form":"1","show_email_copy":"1","banned_email":"","banned_subject":"","banned_text":"","validate_session":"1","custom_reply":"0","redirect":"","show_category_crumb":"0","metakey":"","metadesc":"","robots":"","author":"","rights":"","xreference":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(9, 'com_cpanel', 'component', 'com_cpanel', '', 1, 1, 1, 1, '{"name":"com_cpanel","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CPANEL_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10, 'com_installer', 'component', 'com_installer', '', 1, 1, 1, 1, '{"name":"com_installer","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_INSTALLER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(11, 'com_languages', 'component', 'com_languages', '', 1, 1, 1, 1, '{"name":"com_languages","type":"component","creationDate":"2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LANGUAGES_XML_DESCRIPTION","group":""}', '{"administrator":"en-GB","site":"en-GB"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(12, 'com_login', 'component', 'com_login', '', 1, 1, 1, 1, '{"name":"com_login","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(13, 'com_media', 'component', 'com_media', '', 1, 1, 0, 1, '{"name":"com_media","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MEDIA_XML_DESCRIPTION","group":""}', '{"upload_extensions":"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS","upload_maxsize":"10","file_path":"images","image_path":"images","restrict_uploads":"1","allowed_media_usergroup":"3","check_mime":"1","image_extensions":"bmp,gif,jpg,png","ignore_extensions":"","upload_mime":"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip","upload_mime_illegal":"text\\/html","enable_flash":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(14, 'com_menus', 'component', 'com_menus', '', 1, 1, 1, 1, '{"name":"com_menus","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MENUS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(15, 'com_messages', 'component', 'com_messages', '', 1, 1, 1, 1, '{"name":"com_messages","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MESSAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(16, 'com_modules', 'component', 'com_modules', '', 1, 1, 1, 1, '{"name":"com_modules","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_MODULES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(17, 'com_newsfeeds', 'component', 'com_newsfeeds', '', 1, 1, 1, 0, '{"name":"com_newsfeeds","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"show_feed_image":"1","show_feed_description":"1","show_item_description":"1","feed_word_count":"0","show_headings":"1","show_name":"1","show_articles":"0","show_link":"1","show_description":"1","show_description_image":"1","display_num":"","show_pagination_limit":"1","show_pagination":"1","show_pagination_results":"1","show_cat_items":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(18, 'com_plugins', 'component', 'com_plugins', '', 1, 1, 1, 1, '{"name":"com_plugins","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_PLUGINS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(19, 'com_search', 'component', 'com_search', '', 1, 1, 1, 1, '{"name":"com_search","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_SEARCH_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_date":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(20, 'com_templates', 'component', 'com_templates', '', 1, 1, 1, 1, '{"name":"com_templates","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_TEMPLATES_XML_DESCRIPTION","group":""}', '{"template_positions_display":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(21, 'com_weblinks', 'component', 'com_weblinks', '', 1, 1, 1, 0, '{"name":"com_weblinks","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\n\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_WEBLINKS_XML_DESCRIPTION","group":""}', '{"show_comp_description":"1","comp_description":"","show_link_hits":"1","show_link_description":"1","show_other_cats":"0","show_headings":"0","show_numbers":"0","show_report":"1","count_clicks":"1","target":"0","link_icons":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(22, 'com_content', 'component', 'com_content', '', 1, 1, 0, 1, '{"name":"com_content","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONTENT_XML_DESCRIPTION","group":""}', '{"article_layout":"_:default","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"1","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"1","readmore_limit":"100","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","category_layout":"_:blog","show_category_title":"0","show_description":"0","show_description_image":"0","maxLevel":"1","show_empty_categories":"0","show_no_articles":"1","show_subcat_desc":"1","show_cat_num_articles":"0","show_base_description":"1","maxLevelcat":"-1","show_empty_categories_cat":"0","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"1","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"0","show_pagination_limit":"1","filter_field":"hide","show_headings":"1","list_show_date":"0","date_format":"","list_show_hits":"1","list_show_author":"1","orderby_pri":"order","orderby_sec":"rdate","order_date":"published","show_pagination":"2","show_pagination_results":"1","show_feed_link":"1","feed_summary":"0","filters":{"1":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"6":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"7":{"filter_type":"NONE","filter_tags":"","filter_attributes":""},"2":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"3":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"4":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"5":{"filter_type":"BL","filter_tags":"","filter_attributes":""},"8":{"filter_type":"NONE","filter_tags":"","filter_attributes":""}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(23, 'com_config', 'component', 'com_config', '', 1, 1, 0, 1, '{"name":"com_config","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_CONFIG_XML_DESCRIPTION","group":""}', '{"filters":{"1":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"6":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"7":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"},"2":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"3":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"4":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"5":{"filter_tags":"","filter_attributes":"","filter_type":"BL"},"8":{"filter_tags":"","filter_attributes":"","filter_type":"NONE"}}}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(24, 'com_redirect', 'component', 'com_redirect', '', 1, 1, 0, 1, '{"name":"com_redirect","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(25, 'com_users', 'component', 'com_users', '', 1, 1, 0, 1, '{"name":"com_users","type":"component","creationDate":"April 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_USERS_XML_DESCRIPTION","group":""}', '{"allowUserRegistration":"1","new_usertype":"2","useractivation":"1","frontend_userparams":"1","mailSubjectPrefix":"","mailBodySuffix":""}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(100, 'PHPMailer', 'library', 'phpmailer', '', 0, 1, 1, 1, '{"name":"PHPMailer","type":"library","creationDate":"2001","author":"PHPMailer","copyright":"(c) 2001-2003, Brent R. Matzelle, (c) 2004-2009, Andy Prevost. All Rights Reserved., (c) 2010-2013, Jim Jagielski. All Rights Reserved.","authorEmail":"jimjag@gmail.com","authorUrl":"https:\\/\\/github.com\\/PHPMailer\\/PHPMailer","version":"5.2.6","description":"LIB_PHPMAILER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(101, 'SimplePie', 'library', 'simplepie', '', 0, 1, 1, 1, '{"name":"SimplePie","type":"library","creationDate":"2004","author":"SimplePie","copyright":"Copyright (c) 2004-2009, Ryan Parman and Geoffrey Sneddon","authorEmail":"","authorUrl":"http:\\/\\/simplepie.org\\/","version":"1.2","description":"LIB_SIMPLEPIE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(102, 'phputf8', 'library', 'phputf8', '', 0, 1, 1, 1, '{"name":"phputf8","type":"library","creationDate":"2006","author":"Harry Fuecks","copyright":"Copyright various authors","authorEmail":"hfuecks@gmail.com","authorUrl":"http:\\/\\/sourceforge.net\\/projects\\/phputf8","version":"0.5","description":"LIB_PHPUTF8_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(103, 'Joomla! Platform', 'library', 'joomla', '', 0, 1, 1, 1, '{"name":"Joomla! Platform","type":"library","creationDate":"2008","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"http:\\/\\/www.joomla.org","version":"12.2","description":"LIB_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(200, 'mod_articles_archive', 'module', 'mod_articles_archive', '', 0, 1, 1, 1, '{"name":"mod_articles_archive","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters.\\n\\t\\tAll rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(201, 'mod_articles_latest', 'module', 'mod_articles_latest', '', 0, 1, 1, 1, '{"name":"mod_articles_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(202, 'mod_articles_popular', 'module', 'mod_articles_popular', '', 0, 1, 1, 0, '{"name":"mod_articles_popular","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(203, 'mod_banners', 'module', 'mod_banners', '', 0, 1, 1, 1, '{"name":"mod_banners","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BANNERS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(204, 'mod_breadcrumbs', 'module', 'mod_breadcrumbs', '', 0, 1, 1, 1, '{"name":"mod_breadcrumbs","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_BREADCRUMBS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(205, 'mod_custom', 'module', 'mod_custom', '', 0, 1, 1, 1, '{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(206, 'mod_feed', 'module', 'mod_feed', '', 0, 1, 1, 1, '{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(207, 'mod_footer', 'module', 'mod_footer', '', 0, 1, 1, 1, '{"name":"mod_footer","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FOOTER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(208, 'mod_login', 'module', 'mod_login', '', 0, 1, 1, 1, '{"name":"mod_login","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(209, 'mod_menu', 'module', 'mod_menu', '', 0, 1, 1, 1, '{"name":"mod_menu","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(210, 'mod_articles_news', 'module', 'mod_articles_news', '', 0, 1, 1, 0, '{"name":"mod_articles_news","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_NEWS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(211, 'mod_random_image', 'module', 'mod_random_image', '', 0, 1, 1, 0, '{"name":"mod_random_image","type":"module","creationDate":"July 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RANDOM_IMAGE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(212, 'mod_related_items', 'module', 'mod_related_items', '', 0, 1, 1, 0, '{"name":"mod_related_items","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_RELATED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(213, 'mod_search', 'module', 'mod_search', '', 0, 1, 1, 0, '{"name":"mod_search","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SEARCH_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(214, 'mod_stats', 'module', 'mod_stats', '', 0, 1, 1, 0, '{"name":"mod_stats","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(215, 'mod_syndicate', 'module', 'mod_syndicate', '', 0, 1, 1, 1, '{"name":"mod_syndicate","type":"module","creationDate":"May 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SYNDICATE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(216, 'mod_users_latest', 'module', 'mod_users_latest', '', 0, 1, 1, 1, '{"name":"mod_users_latest","type":"module","creationDate":"December 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_USERS_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(217, 'mod_weblinks', 'module', 'mod_weblinks', '', 0, 1, 1, 0, '{"name":"mod_weblinks","type":"module","creationDate":"July 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WEBLINKS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(218, 'mod_whosonline', 'module', 'mod_whosonline', '', 0, 1, 1, 0, '{"name":"mod_whosonline","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WHOSONLINE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(219, 'mod_wrapper', 'module', 'mod_wrapper', '', 0, 1, 1, 0, '{"name":"mod_wrapper","type":"module","creationDate":"October 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_WRAPPER_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(220, 'mod_articles_category', 'module', 'mod_articles_category', '', 0, 1, 1, 1, '{"name":"mod_articles_category","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(221, 'mod_articles_categories', 'module', 'mod_articles_categories', '', 0, 1, 1, 1, '{"name":"mod_articles_categories","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(222, 'mod_languages', 'module', 'mod_languages', '', 0, 1, 1, 1, '{"name":"mod_languages","type":"module","creationDate":"February 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LANGUAGES_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(300, 'mod_custom', 'module', 'mod_custom', '', 1, 1, 1, 1, '{"name":"mod_custom","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_CUSTOM_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(301, 'mod_feed', 'module', 'mod_feed', '', 1, 1, 1, 0, '{"name":"mod_feed","type":"module","creationDate":"July 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FEED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(302, 'mod_latest', 'module', 'mod_latest', '', 1, 1, 1, 0, '{"name":"mod_latest","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LATEST_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(303, 'mod_logged', 'module', 'mod_logged', '', 1, 1, 1, 0, '{"name":"mod_logged","type":"module","creationDate":"January 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGGED_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(304, 'mod_login', 'module', 'mod_login', '', 1, 1, 1, 1, '{"name":"mod_login","type":"module","creationDate":"March 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_LOGIN_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(305, 'mod_menu', 'module', 'mod_menu', '', 1, 1, 1, 0, '{"name":"mod_menu","type":"module","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(307, 'mod_popular', 'module', 'mod_popular', '', 1, 1, 1, 0, '{"name":"mod_popular","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_POPULAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(308, 'mod_quickicon', 'module', 'mod_quickicon', '', 1, 1, 1, 1, '{"name":"mod_quickicon","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_QUICKICON_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(309, 'mod_status', 'module', 'mod_status', '', 1, 1, 1, 0, '{"name":"mod_status","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATUS_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(310, 'mod_submenu', 'module', 'mod_submenu', '', 1, 1, 1, 0, '{"name":"mod_submenu","type":"module","creationDate":"Feb 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_SUBMENU_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(311, 'mod_title', 'module', 'mod_title', '', 1, 1, 1, 0, '{"name":"mod_title","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TITLE_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(312, 'mod_toolbar', 'module', 'mod_toolbar', '', 1, 1, 1, 1, '{"name":"mod_toolbar","type":"module","creationDate":"Nov 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_TOOLBAR_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(313, 'mod_multilangstatus', 'module', 'mod_multilangstatus', '', 1, 1, 1, 0, '{"name":"mod_multilangstatus","type":"module","creationDate":"September 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_MULTILANGSTATUS_XML_DESCRIPTION","group":""}', '{"cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(400, 'plg_authentication_gmail', 'plugin', 'gmail', 'authentication', 0, 0, 1, 0, '{"name":"plg_authentication_gmail","type":"plugin","creationDate":"February 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_GMAIL_XML_DESCRIPTION","group":""}', '{"applysuffix":"0","suffix":"","verifypeer":"1","user_blacklist":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(401, 'plg_authentication_joomla', 'plugin', 'joomla', 'authentication', 0, 1, 1, 1, '{"name":"plg_authentication_joomla","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_AUTH_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(402, 'plg_authentication_ldap', 'plugin', 'ldap', 'authentication', 0, 0, 1, 0, '{"name":"plg_authentication_ldap","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LDAP_XML_DESCRIPTION","group":""}', '{"host":"","port":"389","use_ldapV3":"0","negotiate_tls":"0","no_referrals":"0","auth_method":"bind","base_dn":"","search_string":"","users_dn":"","username":"admin","password":"bobby7","ldap_fullname":"fullName","ldap_email":"mail","ldap_uid":"uid"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(404, 'plg_content_emailcloak', 'plugin', 'emailcloak', 'content', 0, 1, 1, 0, '{"name":"plg_content_emailcloak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION","group":""}', '{"mode":"1"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(406, 'plg_content_loadmodule', 'plugin', 'loadmodule', 'content', 0, 1, 1, 0, '{"name":"plg_content_loadmodule","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOADMODULE_XML_DESCRIPTION","group":""}', '{"style":"rounded"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(407, 'plg_content_pagebreak', 'plugin', 'pagebreak', 'content', 0, 1, 1, 1, '{"name":"plg_content_pagebreak","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION","group":""}', '{"title":"1","multipage_toc":"1","showall":"1"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(408, 'plg_content_pagenavigation', 'plugin', 'pagenavigation', 'content', 0, 1, 1, 1, '{"name":"plg_content_pagenavigation","type":"plugin","creationDate":"January 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_PAGENAVIGATION_XML_DESCRIPTION","group":""}', '{"position":"1"}', '', '', 0, '0000-00-00 00:00:00', 5, 0),
(409, 'plg_content_vote', 'plugin', 'vote', 'content', 0, 1, 1, 1, '{"name":"plg_content_vote","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_VOTE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(410, 'plg_editors_codemirror', 'plugin', 'codemirror', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_codemirror","type":"plugin","creationDate":"28 March 2011","author":"Marijn Haverbeke","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"1.0","description":"PLG_CODEMIRROR_XML_DESCRIPTION","group":""}', '{"linenumbers":"0","tabmode":"indent"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(411, 'plg_editors_none', 'plugin', 'none', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_none","type":"plugin","creationDate":"August 2004","author":"Unknown","copyright":"","authorEmail":"N\\/A","authorUrl":"","version":"3.0.0","description":"PLG_NONE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(412, 'plg_editors_tinymce', 'plugin', 'tinymce', 'editors', 0, 1, 1, 1, '{"name":"plg_editors_tinymce","type":"plugin","creationDate":"2005-2012","author":"Moxiecode Systems AB","copyright":"Moxiecode Systems AB","authorEmail":"N\\/A","authorUrl":"tinymce.moxiecode.com\\/","version":"3.5.6","description":"PLG_TINY_XML_DESCRIPTION","group":""}', '{"mode":"1","skin":"0","compressed":"0","cleanup_startup":"0","cleanup_save":"2","entity_encoding":"raw","lang_mode":"0","lang_code":"en","text_direction":"ltr","content_css":"1","content_css_custom":"","relative_urls":"1","newlines":"0","invalid_elements":"script,applet,iframe","extended_elements":"","toolbar":"top","toolbar_align":"left","html_height":"550","html_width":"750","element_path":"1","fonts":"1","paste":"1","searchreplace":"1","insertdate":"1","format_date":"%Y-%m-%d","inserttime":"1","format_time":"%H:%M:%S","colors":"1","table":"1","smilies":"1","media":"1","hr":"1","directionality":"1","fullscreen":"1","style":"1","layer":"1","xhtmlxtras":"1","visualchars":"1","nonbreaking":"1","template":"1","blockquote":"1","wordcount":"1","advimage":"1","advlink":"1","autosave":"1","contextmenu":"1","inlinepopups":"1","safari":"0","custom_plugin":"","custom_button":""}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(413, 'plg_editors-xtd_article', 'plugin', 'article', 'editors-xtd', 0, 1, 1, 1, '{"name":"plg_editors-xtd_article","type":"plugin","creationDate":"October 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_ARTICLE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(414, 'plg_editors-xtd_image', 'plugin', 'image', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_image","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_IMAGE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(415, 'plg_editors-xtd_pagebreak', 'plugin', 'pagebreak', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_pagebreak","type":"plugin","creationDate":"August 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(416, 'plg_editors-xtd_readmore', 'plugin', 'readmore', 'editors-xtd', 0, 1, 1, 0, '{"name":"plg_editors-xtd_readmore","type":"plugin","creationDate":"March 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_READMORE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(417, 'plg_search_categories', 'plugin', 'categories', 'search', 0, 1, 1, 0, '{"name":"plg_search_categories","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(418, 'plg_search_contacts', 'plugin', 'contacts', 'search', 0, 1, 1, 0, '{"name":"plg_search_contacts","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTACTS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(419, 'plg_search_content', 'plugin', 'content', 'search', 0, 1, 1, 0, '{"name":"plg_search_content","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_CONTENT_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(420, 'plg_search_newsfeeds', 'plugin', 'newsfeeds', 'search', 0, 1, 1, 0, '{"name":"plg_search_newsfeeds","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(421, 'plg_search_weblinks', 'plugin', 'weblinks', 'search', 0, 1, 1, 0, '{"name":"plg_search_weblinks","type":"plugin","creationDate":"November 2005","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION","group":""}', '{"search_limit":"50","search_content":"1","search_archived":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(422, 'plg_system_languagefilter', 'plugin', 'languagefilter', 'system', 0, 0, 1, 1, '{"name":"plg_system_languagefilter","type":"plugin","creationDate":"July 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(423, 'plg_system_p3p', 'plugin', 'p3p', 'system', 0, 1, 1, 1, '{"name":"plg_system_p3p","type":"plugin","creationDate":"September 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_P3P_XML_DESCRIPTION","group":""}', '{"headers":"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM"}', '', '', 0, '0000-00-00 00:00:00', 3, 0),
(424, 'plg_system_cache', 'plugin', 'cache', 'system', 0, 0, 1, 1, '{"name":"plg_system_cache","type":"plugin","creationDate":"February 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CACHE_XML_DESCRIPTION","group":""}', '{"browsercache":"0","cachetime":"15"}', '', '', 0, '0000-00-00 00:00:00', 4, 0),
(425, 'plg_system_debug', 'plugin', 'debug', 'system', 0, 1, 1, 0, '{"name":"plg_system_debug","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_DEBUG_XML_DESCRIPTION","group":""}', '{"profile":"1","queries":"1","memory":"1","language_files":"1","language_strings":"1","strip-first":"1","strip-prefix":"","strip-suffix":""}', '', '', 0, '0000-00-00 00:00:00', 6, 0),
(426, 'plg_system_log', 'plugin', 'log', 'system', 0, 1, 1, 1, '{"name":"plg_system_log","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_LOG_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 7, 0),
(427, 'plg_system_redirect', 'plugin', 'redirect', 'system', 0, 1, 1, 1, '{"name":"plg_system_redirect","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_REDIRECT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 8, 0),
(428, 'plg_system_remember', 'plugin', 'remember', 'system', 0, 1, 1, 1, '{"name":"plg_system_remember","type":"plugin","creationDate":"April 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_REMEMBER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 9, 0),
(429, 'plg_system_sef', 'plugin', 'sef', 'system', 0, 1, 1, 0, '{"name":"plg_system_sef","type":"plugin","creationDate":"December 2007","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SEF_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 10, 0),
(430, 'plg_system_logout', 'plugin', 'logout', 'system', 0, 1, 1, 1, '{"name":"plg_system_logout","type":"plugin","creationDate":"April 2009","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 11, 0),
(431, 'plg_user_contactcreator', 'plugin', 'contactcreator', 'user', 0, 0, 1, 1, '{"name":"plg_user_contactcreator","type":"plugin","creationDate":"August 2009","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTACTCREATOR_XML_DESCRIPTION","group":""}', '{"autowebpage":"","category":"34","autopublish":"0"}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(432, 'plg_user_joomla', 'plugin', 'joomla', 'user', 0, 1, 1, 0, '{"name":"plg_user_joomla","type":"plugin","creationDate":"December 2006","author":"Joomla! Project","copyright":"(C) 2005 - 2009 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_JOOMLA_XML_DESCRIPTION","group":""}', '{"autoregister":"1"}', '', '', 0, '0000-00-00 00:00:00', 2, 0),
(433, 'plg_user_profile', 'plugin', 'profile', 'user', 0, 0, 1, 1, '{"name":"plg_user_profile","type":"plugin","creationDate":"January 2008","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_USER_PROFILE_XML_DESCRIPTION","group":""}', '{"register-require_address1":"1","register-require_address2":"1","register-require_city":"1","register-require_region":"1","register-require_country":"1","register-require_postal_code":"1","register-require_phone":"1","register-require_website":"1","register-require_favoritebook":"1","register-require_aboutme":"1","register-require_tos":"1","register-require_dob":"1","profile-require_address1":"1","profile-require_address2":"1","profile-require_city":"1","profile-require_region":"1","profile-require_country":"1","profile-require_postal_code":"1","profile-require_phone":"1","profile-require_website":"1","profile-require_favoritebook":"1","profile-require_aboutme":"1","profile-require_tos":"1","profile-require_dob":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(434, 'plg_extension_joomla', 'plugin', 'joomla', 'extension', 0, 1, 1, 1, '{"name":"plg_extension_joomla","type":"plugin","creationDate":"May 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 1, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(435, 'plg_content_joomla', 'plugin', 'joomla', 'content', 0, 1, 1, 0, '{"name":"plg_content_joomla","type":"plugin","creationDate":"November 2010","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_JOOMLA_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(504, 'hathor', 'template', 'hathor', '', 1, 1, 1, 0, '{"name":"hathor","type":"template","creationDate":"May 2010","author":"Andrea Tarr","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"hathor@tarrconsulting.com","authorUrl":"http:\\/\\/www.tarrconsulting.com","version":"3.0.0","description":"TPL_HATHOR_XML_DESCRIPTION","group":""}', '{"showSiteName":"0","colourChoice":"0","boldText":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(600, 'English (United Kingdom)', 'language', 'en-GB', '', 0, 1, 1, 1, '{"name":"English (United Kingdom)","type":"language","creationDate":"2013-03-07","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.2","description":"en-GB site language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(601, 'English (United Kingdom)', 'language', 'en-GB', '', 1, 1, 1, 1, '{"name":"English (United Kingdom)","type":"language","creationDate":"2013-03-07","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.2","description":"en-GB administrator language","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(700, 'files_joomla', 'file', 'joomla', '', 0, 1, 1, 1, '{"name":"files_joomla","type":"file","creationDate":"July 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.4","description":"FILES_JOOMLA_XML_DESCRIPTION","group":""}', '', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10014, 'ja_teline_iii', 'template', 'ja_teline_iii', '', 0, 1, 1, 0, '{"name":"ja_teline_iii","type":"template","creationDate":"Sep 2012","author":"JoomlArt.com","copyright":"JoomlArt Design Team","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.2","description":"<p>JA Teline III has been updated for use with Joomla 2.5!<\\/p>\\n\\n<p>All time hit, best selling News template in the JA Teline Series of templates. If you find yourself confused about this template, please refer to userguide and install quickstart in your localhost for reference. It can be intimidating for new users.<\\/p>\\n\\n<p><strong>Resources :<\\/strong><\\/p>\\n<p>| \\n<a href=\'http:\\/\\/www.joomlart.com\\/joomla\\/templates\\/ja-teline-iii-v2\' title=\'Home\' target=\'_blank\' > Template Home Page<\\/a> | \\n<a href=\'http:\\/\\/www.joomlart.com\\/demo\\/#joomla25-templates.joomlart.com\\/ja_teline_iii\' title=\'Demo\' target=\'_blank\' > Demo<\\/a> | \\n<a href=\'http:\\/\\/www.joomlart.com\\/forums\\/forumdisplay.php?244\' title=\'forum\' target=\'_blank\' >Forum<\\/a> | <\\/p>\\n<p>|\\n<a href=\'http:\\/\\/wiki.joomlart.com\\/wiki\\/JA_T3_Framework_2\\/Overview\' title=\'T3 wiki\' target=\'_blank\' >T3 Framework Wiki<\\/a> | \\n<a href=\'http:\\/\\/update.joomlart.com\' title=\'Updates\' target=\'_blank\' >Updates<\\/a> | \\n<a href=\'http:\\/\\/pm.joomlart.com\\/browse\\/JATCTELINEIIIJ16\' title=\'Changelog\' target=\'_blank\' >JIRA<\\/a> | \\n<a href=\'http:\\/\\/www.joomlart.com\\/forums\\/downloads.php?do=cat&id=369\' title=\'Downloads\' target=\'_blank\' >Downloads<\\/a> | \\n<\\/p>","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10001, 'JA T3 Framework', 'plugin', 'jat3', 'system', 0, 1, 1, 0, '{"name":"JA T3 Framework","type":"plugin","creationDate":"24 Jul 2013","author":"www.JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.6.6","description":"\\n\\t\\n\\t\\t<h1>T3 Framework - JoomlArt Template Framework for Joomla 2.5 and Joomla 3.0<\\/h1>\\n\\t\\t<div style=\'font-weight: normal\'>\\n\\t\\t<p><span style=\'color: #ff6600;\'>\\n\\t\\t<strong>Features:<\\/strong><\\/span>\\n\\t\\tThis plugin is required for JA T3 Framework based templates to work.<\\/p>\\n\\t\\t\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Usage Instruction:<\\/span><\\/strong><br \\/>\\n\\t\\t<ul>\\n\\t\\t<li>Enable the JA T3 plugin in Plugin manager<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Upgrade Method:<\\/span><br \\/><\\/strong>\\n\\t\\t<ul>\\n\\t\\t  <li>You can install new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t  <li>Follow upgrade instructions and backup site \\/ plugin before upgrading<\\/li>\\n\\t\\t  <\\/ul>\\n\\t\\n\\t\\t<span style=\'color: #008000;\'><strong>Links:<\\/strong><\\/span><br \\/>\\n\\t\\t<ul>\\n\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/wiki.joomlart.com\\/wiki\\/JA_T3_Framework_2\\/Overview\\">Wiki Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/forumdisplay.php?241\'>JA T3 Framework Forum<\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t\\n\\t\\t","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 12, 0),
(10002, 'JA News Featured', 'module', 'mod_janews_featured', '', 0, 1, 0, 0, '{"name":"JA News Featured","type":"module","creationDate":"May 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t \\n\\t\\t<div style=\'text-align: left;\'>\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA News Featured Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA News Featured Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_newsfp_mod.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tJA News Featured provides you a lightweight but powerful news headline style of your most recent contents. Please refer to the template userguide for optimum backend settings\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Important Instruction:<\\/strong><\\/span><\\/p>\\n\\t \\t<ol><li>Please refer to Template userguide or install the template Quickstart to view the optimum settings for this module.<\\/li>\\n\\t\\t<li>The module display can be enhanced by CSS overrides in the demo templates. Thus when using this module in different templates, the results may vary and you may have to customize CSS again to get your desired effects.<\\/li>\\n\\t\\t<li>For Userguide, please visit <a href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?t=52039\' target=\'_blank\'>Here<\\/a><\\/li><\\/ol>\\n\\t \\t\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li><li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li><\\/ol>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul> <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51825\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li><\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","catsid":"","featured":"hide","ordering":"ordering","sort_order":"DESC","settingprofile":"","profile":"default","JPlugins":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10003, 'JA Bulletin', 'module', 'mod_jabulletin', '', 0, 1, 0, 0, '{"name":"JA Bulletin","type":"module","creationDate":"May 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t\\n\\t\\t<div style=\'text-align: left;\'>\\n\\t   <span style=\\"color: #008000;\\">\\n\\t   \\t<strong>JA Bulletin Module<\\/strong>\\n\\t   <\\/span>\\n\\t   <br \\/>\\n\\t   <div style=\'font-weight: normal\'>\\n\\t   <p><img alt=\\"JA Bulletin Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/ja_bulletin.png\\" \\/><\\/p>\\n\\t   This module mimicks default Joomla most read and latest modules, with added support to show date and thumbnail images.\\n\\t   \\n\\t   <p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t   <ol><li>Show \\/ hide Images in the list<\\/li><li>Show or hide Date of the article.<\\/li><li>Easy thumbnail generation. For more details on Thumbnail mode read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a>.<\\/li><\\/ol>\\n\\t   \\n\\t   <p><strong><span style=\\"color: #ff0000;\\">Important Instruction:<\\/span><\\/strong><\\/p>\\n\\t   <ol><li><strong>The module display can be enhanced by CSS overrides in the demo templates (used in over 20+ JA templates). Thus, when you used Bulletin in different templates, the results may vary and you may have to customize CSS to get desired effects.<\\/strong><\\/li><\\/ol>\\n\\t   <p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t   <ol>\\n\\t   <li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t   \\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video.<\\/a><\\/strong><\\/li>\\n\\t   <\\/ol>\\n\\t   <p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t   <ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?49878\\">JA Bulletin - General User guide<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/pm.joomlart.com\\/browse\\/JAECMODBULLETINJIVI\\">Report Bug<\\/a><\\/li><li><a target=\\"_blank\\" href=\\"http:\\/\\/update.joomlart.com\\/#products.list\\/\\/JA%20Bulletin%20Module%20for%20Joomla%202.5\\/\\">Updates &amp; Versions<\\/a><\\/li><\\/ul>\\n\\t   <p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t   <\\/div>\\n\\t   <\\/div>\\n\\t\\n\\t","group":""}', '{"moduleclass_sfx":"","content_setting":"","type":"latest","category":"","count":"5","show_featured":"1","show_date":"1","image_setting":"","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"40","height":"40","cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10004, 'JA News Ticker', 'module', 'mod_janewsticker', '', 0, 1, 0, 0, '{"name":"JA News Ticker","type":"module","creationDate":"15 July 2013","author":"Joomlart.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.6","description":"\\n\\t \\n\\t <div align=\\"left\\">\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA Newsticker Module for Joomla! 2.5 and Joomla! 3.x<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA Newsticker Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_janews.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tDisplay latest articles with cool animation effects as News Ticker, select categories to include, length of titles, sorting or even control buttons. Decent way to scroll out your latest information in limited space...\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>The module supports a lot of animations display<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ul>\\n\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t\\t\\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul>\\n\\t\\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51825\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","using_mode":"","rss_link":"","category":"","sort_order_field":"created","sort_order":"DESC","max_items":"10","title_max_chars":"200","settingdisplay":"","animation_type":"horizontal","animation_speed":"500","animation_interval":"3000","animation_transition":"Fx.Transitions.linear","show_headtext":"1","headtext":"Headlines:","show_buttons_control":"0","enable_cache":"1","cache_time":"30"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10005, 'JA Twitter Module', 'module', 'mod_jatwitter', '', 0, 1, 0, 0, '{"name":"JA Twitter Module","type":"module","creationDate":"Jun 2013","author":"Joomlart.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.7","description":"\\n\\t\\n\\t<div align=\\"left\\">\\n\\t\\t<h1><img border=\'0\' alt=\'JA Twitter Module\' src=\'http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/drupal\\/jdec_twitter.png?javer=1110040930\' style=\'float: left\'\\/>JA Twitter Module for Joomla! 2.5<\\/h1>\\n\\t\\t<div style=\\"font-weight:normal\\">\\n\\t\\tThis module provides API integration with the Twitter microblogging service to drive more traffic to your site. Tweets from your Twitter account and Friends are displayed neatly.\\n\\t\\t<br\\/><br\\/><br\\/><br\\/>\\n\\t\\t\\n\\t\\t<p style=\\"border:1px solid #F29A3C; padding: 10px 15px; background:#F7E6D4;\\">\\n\\t\\t<strong><span style=\'color: #ff0000;\'>NOTE: update OAuth information to get new version worked!<\\/span><\\/strong><br \\/><br \\/>\\n\\t\\tSince 2013-06-11, Twitter has stopped supporting API v1 and fully moved to API v1.1<br \\/>In API v1.1, Twitter deny non-Authorized request, that means you need to provide the information below to authorize your request.<br \\/>\\n\\t\\t<a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50154-Joomla-1.6-JA-Twitter-Module-Installation-Guide\\">Check how to get OAuth information now<\\/a>\\n\\t\\t<\\/p>\\n\\t\\t\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Usage Ideas:<\\/span><br \\/><\\/strong>\\n\\t\\t<ol>\\n\\t\\t  <li>Easily configure Twitter account, show or hide Friends list, account infomation, and Twitter updates.<\\/li>\\n\\t\\t  <li>Show Twitter account infomation.<\\/li>\\n\\t\\t  <li>Show Twitter friends list.<\\/li>\\n\\t\\t  <li>Display Twitter updates.<\\/li>\\n\\t\\t<\\/ol>\\n\\t\\n\\t\\t<strong><span style=\'color: #ff0000;\'>Upgrade Methods:<\\/span><\\/strong><br\\/>\\n\\t\\t<ol>\\n\\t\\t  <li>You can install new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t  <li>Backup any customized files (i.e. CSS files) before upgrading.<\\/li>\\n\\t\\t<\\/ol>\\n\\t\\n\\t\\t<span style=\'color: #008000;\'><strong>Links:<\\/strong><\\/span><br\\/>\\n\\t\\t<ul>\\n\\t\\t  <li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50154-Joomla-1.6-JA-Twitter-Module-Installation-Guide\\">General Userguide<\\/a><\\/li>\\n\\t\\t  <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/#products.list\\/\\/JA%20Twitter%20Module%20for%20Joomla%202.5\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2013 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t<\\/div>\\n\\t\\n\\t","group":""}', '{"moduleclass_sfx":"","content_setting":"","taccount":"JoomlartDemo","use_display_taccount":"0","size_iconaccount":"48","settingcontent":"","show_tweet":"1","show_limit":"5","show_icon":"1","icon_size":"30","show_username":"1","show_source":"1","showtextheading":"1","headingtext":"My Twitter Updates","friend_setting":"","use_friends":"0","size_iconfriend":"24","max_friends":"10","settingfollowbutton":"","showfollowlink":"1","typefollowbutton":"apiconnect","style_of_follow_button":"follow_me-a.png","apikey":"","enable_cache":"1","cache_time":"5"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10007, 'Content - JA Bookmark', 'plugin', 'jabookmark', 'content', 0, 1, 1, 0, '{"name":"Content - JA Bookmark","type":"plugin","creationDate":"07 June 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t<span style=\\"color: #008000;\\"><strong>JA Bookmark Plugin for Joomla 2.5 and Joomla 3.x<\\/strong><\\/span><br \\/><p><img alt=\\"JA Bookmark Logo\\" src=\\"http:\\/\\/joomlart.s3.amazonaws.com\\/images\\/mis\\/JA_Bookmark_logo.jpg\\" \\/><\\/p><p>JA Bookmark Plugin for Joomla! 2.5. Help your visitors to promote your site and allows visitors to bookmark your pages easily with many popular services.<\\/p>\\n\\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t\\t<li>Allows the integration of <a target=\\"_blank\\" href=\\"http:\\/\\/www.addthis.com\\/\\">Addthis<\\/a> and <a target=\\"_blank\\" href=\\"http:\\/\\/www.disqus.com\\/\\">AddToAny<\\/a> online Bookmark Services. <\\/li>\\n\\t\\t<li>Easy to use. Install and configure.<\\/li>\\n\\t\\t<li>Option to enable JA Bookmark Plugin for all. \\n\\t\\tEnable for limited categories or individual articles OR disable for individual articles too.<\\/li>\\n\\t<\\/ul>\\n\\t<strong><span>Links:<\\/span><\\/strong><br \\/>\\n\\t<ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51733\\">JA Bookmark  - General Userguide<\\/a><\\/li>\\n\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/update.joomlart.com\\/\\">Updates &amp; Versions<\\/a><\\/li><\\/ul>\\n\\t   <p>Copyright 2004 - 2013 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\n\\t","group":""}', '{"system":"addthis","system-addthis-brand_name":"joomlart.com","system-addthis-account":"joomlart","system-addthis-language_code":"en","system-addthis-custom_apps":"","system-addthis-button":"lg-share","system-addtoany-language":"en-US","system-addtoany-button":"share_save_106_16.gif","system-addtoany-showpagetitle":"1","system-addtoany-orientation":"automatic","mode":"auto","mode-auto-category":[""],"location":"onContentAfterDisplay","used_custom_button":"0","custom_button":"","class_sfx":"","widget_text":"","header_color":"47AA0E","system-addthis-header_background":"999999","system-addthis-vertical_offset":"","system-addthis-horizontal_offset":"","system-addtoany-maincolor":"D7E5ED","system-addtoany-border":"414C53","system-addtoany-linktext":"333333","system-addtoany-linktext_hover":"333333","system-addtoany-background":"FFFFFF"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10009, 'System - JA Popup', 'plugin', 'japopup', 'system', 0, 1, 1, 0, '{"name":"System - JA Popup","type":"plugin","creationDate":"Jul 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.6.0","description":"\\n\\t\\t\\n\\t\\t<div style=\\"text-align:left;\\">\\n\\t\\t\\t<h1>JA Popup Plugin for Joomla! 2.5<\\/h1>\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>JA Popup plugin supports many types of content to display using Framework like AJAX, iFrame, Youtube video, image, slideshow, Inline.<\\/strong><\\/span>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t\\t<img border=\\"0\\" alt=\\"JA Popup plugin\\" src=\\"http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec-popup_plg.png\\">Depending on each type of Popup that you select, you declare JA Popup tab in your content (i.e. module, article) to <code>{japopup type=\\"<span style=\\"color:#FF0000\\">iframe<\\/span>\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\" }Load a sample iFrame{\\/japopup}<\\/code>\\n\\t\\t\\t\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Usage Instructions:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<ol>   \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>ajax<\\/strong>: <em>loading external page or HTML content via AJAX method <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"ajax\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\"}Load an Url using AJAX{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li> \\n\\t\\t\\t\\t\\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>iFrame<\\/strong>: <em>loading external page or HTML content via iFrame method  <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"iframe\\" content=\\"http:\\/\\/www.bing.com\\/\\" width=\\"500\\" height=\\"400\\"}Load a sample iFrame{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>youtube<\\/strong>: <em>loading Youtube video. Note: use embeded link <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"youtube\\" content=\\"http:\\/\\/www.youtube.com\\/v\\/cdphzxz64BY?hl=en&fs=1\\" width=\\"640\\" height=\\"380\\" title=\\"Political Roast: Obama Emanuel 2005\\"}Political Roast: Obama Emanuel 2005{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li> \\n\\t\\t\\t\\t\\t<strong>image<\\/strong>:<em> loading a specified image <\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"image\\" content=\\"images\\/sampledata\\/fruitshop\\/apple.jpg\\" width=\\"400\\" height=\\"300\\" title=\\"Sample image\\"}Sample image{\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>   \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>slideshow<\\/strong>:<em> loading a group of images via a slideshow<\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/><code>{japopup type=\\"slideshow\\" content=\\"images\\/sampledata\\/fruitshop\\/apple.jpg,images\\/sampledata\\/fruitshop\\/bananas_2.jpg\\" width=\\"400\\" height=\\"300\\" title=\\"Sample image\\"} Sample image {\\/japopup}<\\/code>\\n\\t\\t\\t\\t<\\/li>  \\n\\t\\t\\t\\t<li>\\n\\t\\t\\t\\t\\t<strong>Inline<\\/strong>:<em> To display full HTML content in the expander<\\/em><br>\\n\\t\\t\\t\\t\\tExample: <br\\/>\\n\\t\\t\\t\\t\\t\\t<code>\\n\\t\\t\\t\\t\\t\\t\\t{japopup type=\\"inline\\" content=\\"inline1\\" width=\\"500\\" height=\\"400\\" }Inline{\\/japopup}\\t\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t\\t\\t<\\/code>\\n\\t\\t\\t\\t\\t<br \\/>\\n\\t\\t\\t\\t\\t<strong>inline1<\\/strong>:<em> The ID of block content<\\/em><br>\\t\\n\\t\\t\\t\\t<\\/li> \\n\\t\\t\\t<\\/ol> \\n\\t\\t\\t<p>The best showcase of JA Popup is used in JA Teline III.<\\/p> \\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t\\t<ol>\\n\\t\\t\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading.<\\/li>\\t\\t\\n\\t\\t\\t\\t<\\/ol>\\n\\t\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t\\t<ul>\\t\\t\\n\\t\\t\\t\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51150\\">General Userguide<\\/a><\\/li>\\n\\t\\t\\t\\t\\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\t\\t\\t<\\/ul>\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p> \\n\\t\\t<\\/div>\\n\\t\\t\\n\\t","group":""}', '{"group1":"fancybox","group1-fancybox-centerOnScroll":"1","group1-fancybox-image_scale":"1","group1-fancybox-speed_in":"500","group1-fancybox-speed_out":"500","group1-greybox-behavior":"","group1-highslide-outline":"drop-shadow","group1-highslide-speed_in":"250","group1-highslide-speed_out":"250","group1-shadowbox-animateFade":"1","group1-shadowbox-animate":"1","group1-shadowbox-animSequence":"wh","group1-shadowbox-overlayColor":"FFFFFF","group1-shadowbox-viewportPadding":"20","group1-multibox-contentColor":"FFFFFF","group1-multibox-showControls":"1","width":"600","height":"400","overlay":"1","overlay_opacity":"0.7","add_title":"1","add_desc":"1","image_slideshow":"one"}', '', '', 42, '2013-07-30 07:44:21', 5, 0),
(10010, 'Content - JA Thumbnail', 'plugin', 'plg_jathumbnail', 'content', 0, 1, 1, 0, '{"name":"Content - JA Thumbnail","type":"plugin","creationDate":"March 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.5","description":"\\n\\t\\n\\t<h1>JA Thumbnail Plugin for Joomla! 2.5<\\/h1>\\n\\tThis plugin helps to generate thumbnails automatically in Joomla Articles. This must be properly configured to get the best usage. Below are some important notes.\\n\\t<p><span style=\'color: #ff6600;\'><strong>Details:<\\/strong><\\/span><\\/p>\\n\\t<img border=\'0\' alt=\'JA Thumbnail Plugin\' src=\'http:\\/\\/asset.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_highslide.png?javer=1109130907\' style=\'float: left\'>\\n\\tThe Manual mode is recommended for sites with only a few images, the Auto mode is for sites with a massive volume of images\\n\\t<p><strong><span style=\'color: #ff0000;\'>Important Instructions :<\\/span><\\/strong><\\/p>\\n\\tNote: Add the following to disable the slideshow feature in the selected images in an article <code>{jathumbnail off images=\\"images\\/stories\\/demo\\/world\\/rs-3.jpg,images\\/stories\\/demo\\/world\\/rs-2.jpg\\"}<\\/code>\\n\\t<p><strong><span style=\'color: #ff0000;\'>Usage Instruction:<\\/span><br \\/><\\/strong><\\/p>\\n\\tIn the <strong>\\"Integration Mode\\"<\\/strong>  on the parameter list on the right: <br \\/>\\n\\t\\t<ul>\\n\\t\\t\\t<li>\\"<strong>Auto<\\/strong>\\" mode: JA Thumbnail Plugin is enabled automatically in all Joomla articles. To turn off this feature for specific articles, use the <font color=\\"red\\"><strong><em>{jathumbnail off}<\\/em><\\/strong><\\/font>tag in that article.<\\/li>   \\n\\t\\t\\t<li>\\"<strong>Manual<\\/strong>\\" mode: To enable JA thumbnail plugin for an article, you must place {jathumbnail} somewhere in your articles content.<\\/li>   \\n\\t\\t\\t<li> \\"<strong>Disable<\\/strong>\\" mode: Disable the Thumbnail generation (DO NOT use the Disable feature of Joomla if you have used the tag <em><strong>{jathumbnail}<\\/strong><\\/em> or <em><strong>{jathumbnail off}<\\/strong><\\/em> already. It will be parsed as normal text.<\\/li> \\n\\t\\t<\\/ul>\\n\\t<p><strong><span style=\'color: #ff0000;\'>Upgrade Method:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ol><li>You can install the new version directly over this version. Uninstallation is not required. <\\/li>\\n\\t\\t<li>Backup any customized files before upgrading.<\\/li><\\/ol>\\n\\t<p><span style=\'color: #008000;\'><strong>Links :<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50783\\">General Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t\\n\\t\\t<\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t\\n\\t","group":""}', '{"content_mode":"auto","content_mode-auto-content_position":"0","content_mode-auto-manual-content_width":"200","content_mode-auto-manual-content_height":"200","content_mode-auto-manual-crop_image":"1","content_mode-auto-manual-content_align":"left","view_on_page":"all","blog_mode-1-apply_catetories":["14","19","20","21","22","64","65","66","67","75","23","69","70","68","71","24","25","26","27","28","72","73","29","30","76","77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"blog_mode-1-blog_leading_width":"300","blog_mode-1-blog_leading_height":"300","blog_mode-1-blog_intro_width":"100","blog_mode-1-blog_intro_height":"100","blog_mode-1-crop_image":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10012, 'JA News Pro Module', 'module', 'mod_janewspro', '', 0, 1, 0, 0, '{"name":"JA News Pro Module","type":"module","creationDate":"25 May 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.7","description":"\\n\\t \\n\\t\\t<div style=\'text-align: left;\'>\\n\\t \\t<span style=\\"color: #008000;\\"><strong>JA News Pro Module for Joomla! 2.5<\\/strong><\\/span><br \\/>\\n\\t \\t<p><img alt=\\"JA News Pro Module\\" src=\\"http:\\/\\/static.joomlart.com\\/images\\/stories\\/extensions\\/joomla\\/jaec_newsfp_mod.png\\" \\/><\\/p>\\n\\t\\t<div style=\'font-weight:normal\'>\\n\\t \\tJA NEWS PRO Module comes with rich backend and advanced features for easy configuration. \\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Important Instructions:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>Please refer to Template userguide or install the template Quickstart to view the optimum settings for this module.<\\/li>\\n\\t\\t\\t<li>The module display can be enhanced by CSS overrides in the demo templates. Thus, when you use this module in different templates, the results may vary and you may have to customize CSS to get your desired effects.<\\/li>\\n\\t\\t<\\/ul>\\n\\t \\t<p style=\\"clear:both\\"><span style=\\"color: #ff6600;\\"><strong>Usage Instruction:<\\/strong><\\/span><\\/p>\\n\\t \\t<ul>\\n\\t\\t\\t<li>JA News Pro module configure easily with K2 component and Joomla Content<\\/li>\\n\\t\\t\\t<li>JA News Pro module support 4 themes and allow user config content in the front end which is displayed in module (User Setting Tool).<\\/li>\\n\\t\\t\\t<li>JA News Pro module is best used with JA Teline IV template.<\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t<ul>\\n\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading. OR<\\/li>\\n\\t\\t\\t<li>Use <strong><a href=\\"http:\\/\\/extensions.joomla.org\\/extensions\\/core-enhancements\\/installers\\/12077\\" target=\\"_blank\\">JA Extensions Manager<\\/a><\\/strong> Component for easy upgrades and rollbacks. <strong><a href=\\"http:\\/\\/www.youtube.com\\/user\\/JoomlArt#p\\/c\\/BC9B0C0BFE98657E\\/2\\/mNAuJRmifG8\\" target=\\"_blank\\">Watch Video..<\\/a><\\/strong><\\/li>\\n\\t\\t<\\/ul>\\n\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links:<\\/strong><\\/span><\\/p>\\n\\t\\t<ul> <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><li><a target=\'_blank\' href=\'http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51887\'>General Userguide<\\/a><\\/li><li>For more details on Thumbnail modes read this <a href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50325\\" title=\\"JA thumbanil modes\\" target=\\"_blank\\"><strong>tutorial<\\/strong><\\/a><\\/li><\\/ul>\\n\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p>\\n\\t\\t<\\/div>\\n\\t\\t<\\/div>\\n\\t \\n\\t","group":""}', '{"moduleclass_sfx":"","settingcontent":"","catsid":"","groupbysubcat":"0","maxSubCats":"-1","featured":"hide","ordering":"ordering","sort_order":"DESC","settingprofile":"","profile":"default","JPlugins":"1","cache":"1","cache_time":"900"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10013, 'System - JA Tabs', 'plugin', 'jatabs', 'system', 0, 1, 1, 0, '{"name":"System - JA Tabs","type":"plugin","creationDate":"04 May 2013","author":"JoomlArt.com","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights\\n\\t\\tReserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.6.0","description":"\\n\\t\\t\\n\\t\\t<div style=\\"text-align:left\\">\\n\\t\\t\\t<span style=\\"color: #008000;\\"><strong>JA Tabs Plugin for Joomla! 2.5<\\/strong><\\/span>\\n\\t\\t\\t<div style=\\"font-weight: normal\\">\\n\\t\\t\\t<p><strong><img src=\'..\\/plugins\\/system\\/jatabs\\/jatabs\\/tabs.png\' \\/>\\n\\t\\t\\t<span style=\'margin-top:10px;\'>JA Tabs plugin is a plugin which helps you to create tabs in any positions in Joomla contents<\\/span><\\/strong><\\/p>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<ol class=\\"checklist\\" style=\'clear:both\'>\\n\\t\\t\\t<li>Support multiple types of content: Module Position, Module name, HTML Content, Article IDs, Category ID<\\/li>\\n\\t\\t\\t<li>Configurable animations: Left\\/right, up\\/down, fading...<\\/li>\\n\\t\\t\\t<li>Multiple themes support<\\/li>\\n\\t\\t\\t<li>Extensive configuration options<\\/li>\\n\\t\\t\\t<\\/ol>\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Usage Instructions:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>General Parameter Options:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<h3 style=\\"color: blue\\">All available parameter options for JA Tabs Plugin.<\\/h3>\\n\\t\\t\\t<div  style=\\"font-weight: normal\\">\\n\\t\\t\\t<ol>\\n\\t\\t\\t<li><strong>type:<\\/strong> <br \\/> (modules, module, content, articles). JA Tabs type.<\\/li>\\n\\t\\t\\t<li><strong>position:<\\/strong> <br \\/> (top, left, right, bottom). Position of the tabs. Default value is top.<\\/li>\\n\\t\\t\\t<li><strong>style:<\\/strong><br \\/> JA Tabs styling (basic). The default setting is basic. <\\/li>\\n\\t\\t\\t<li><strong>width:<\\/strong><br \\/> Width of the tabs. It can be fixed or automatic. Example: empty or \'100%\' or \'600\'<\\/li>\\n\\t\\t\\t<li><strong>height:<\\/strong><br \\/> Height of the tabs. It can be fixed or automatic. Example: empty or \'auto\' or \'400\'.<\\/li>\\n\\t\\t\\t<li><strong>widthTabs:<\\/strong><br \\/> Width of the tabs. It should be \'empty\' for the \'Top\\/Bottom\' position of tabs title and fixed (such as \'150\') for the \'Left\\/Right\' position of tabs title.<\\/li>\\n\\t\\t\\t<li><strong>heightTabs:<\\/strong><br \\/> Height of the tabs. It should be \'empty\' for \'Left\\/Right\' position of tabs title and fixed (such as \'30\') for \'Top\\/Bottom\' position of tabs title.<\\/li>\\n\\t\\t\\t<li><strong>duration (ms):<\\/strong><br \\/> Time interval of effect transition (in milliseconds). The default setting is 1000. <\\/li>\\n\\t\\t\\t<li><strong>animType:<\\/strong><br \\/> (animFade, animMoveHor, animMoveVir, none). Define type of effect transition. The default setting is animMoveVir.<\\/li>\\n\\t\\t\\t<li><strong>mouseType:<\\/strong><br \\/> (click, mouseover, none). Action behavior of Control Panel. Default value is click. <\\/li>\\n\\t\\t\\t<li><strong>skipAnim:<\\/strong> <br \\/> (true, false). Skip animation. The default setting is false.<\\/li>\\n\\t\\t\\t<li><strong>ajax:<\\/strong> <br \\/> (true, false). Set to \\"True\\" if you want to use AJAX to load content in tabs (Does not apply for HTML Content type). The default setting is False.<\\/li>\\n\\t\\t\\t<li><strong>view:<\\/strong> <br \\/> (introtext, fulltext). Apply for Articles.<\\/li>\\n\\t\\t\\t<li><strong>jaclass:<\\/strong> <br \\/> Input the class for each tab in format: 1:class1,2:class2. The supported class depend on the tab style.<\\/li>\\n\\t\\t\\t<li><strong>module:<\\/strong> <br \\/> Apply for type=\\"modules\\". Input module position which will display in tabs. For example: articleslatestload<\\/li>\\n\\t\\t\\t<li><strong>modulename:<\\/strong> <br \\/> Apply for type=\\"module\\". Input one or more module names which are separated by commas. For example: mod_articles_news, mod_articles_latest<\\/li>\\n\\t\\t\\t<li><strong>ids:<\\/strong> <br \\/> Apply for type=\\"articles\\". Input one or more article IDs which are separated by commas. For example: 1, 2, 3, 4<\\/li>\\n\\t\\t\\t<li><strong>catid:<\\/strong> <br \\/> Apply for type=\\"articles\\". Input one catergory from which you want to display its articles in tabs. For example: 1<\\/li>\\n\\t\\t\\t<li><strong>maxitems:<\\/strong> <br \\/> Maximum number of articles to display<\\/li>\\n\\t\\t\\t<\\/div>\\t\\t\\t\\n\\t\\t\\t<p><span style=\\"color: #ff6600;\\"><strong>For Example tags:<\\/strong><\\/span><\\/p>\\n\\t\\t\\t<div  style=\\"font-weight: normal\\">\\n\\t\\t\\t<b>1. Type = modules<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"modules\\" module=\\"position-7\\" position=\\"top\\" \\n\\t\\t\\t\\tmouseType=\\"click\\" animType=\\"animFade\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<b>2. Type = module<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"module\\" modulename=\\"mod_menu, mod_login\\" \\n\\t\\t\\tposition=\\"left\\" widthTabs=\\"150\\" animType=\\"animMoveVir\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\n\\t\\t\\t<b>3. Type = content<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs  type=\\"content\\" position=\\"top\\" height=\\"240\\" mouseType=\\"mouseover\\" \\n\\t\\t\\t\\tanimType=\\"animMoveHor\\"}\\n\\t\\t\\t  [tab title=\\"Entertainment\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/apple.jpg\\" \\n\\t\\t\\t    alt=\\"Sample image\\" align=\\"left\\" class=\\"caption\\" \\/&gt;...\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t  [tab title=\\"Travel\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/bananas_2.jpg\\" \\/&gt;\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t  [tab title=\\"Artist\\"]\\n\\t\\t\\t    &lt;img src=\\"images\\/sampledata\\/fruitshop\\/tamarind.jpg\\" \\/&gt;\\n\\t\\t\\t  [\\/tab]\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<b>4. Type = articles<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"articles\\" ids=\\"25, 26, 27\\" ajax=true view=\\"introtext\\" position=\\"right\\" \\n\\t\\t\\t\\twidthTabs=150 width=530 animType=\\"animMoveVir\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\n\\t\\t\\t<b>5. Type = articles<\\/b>\\t\\t\\n\\t\\t\\t<p>\\n\\t\\t\\t<code>{jatabs type=\\"articles\\" catid=\\"55\\" view=\\"introtext\\" ajax=true position=\\"bottom\\"\\n\\t\\t\\t\\tanimType=\\"animMoveHor\\"}\\n\\t\\t\\t{\\/jatabs}<\\/code>\\n\\t\\t\\t<\\/p>\\t\\t\\t\\n\\t\\t\\t<\\/div>\\n\\t\\t\\t<p><strong><span style=\\"color: #ff0000;\\">Upgrade Methods:<\\/span><br \\/><\\/strong><\\/p>\\n\\t\\t\\t<ol>\\n\\t\\t\\t\\t<li>You can install new version directly over this version. Uninstallation is not required. Backup any customized files before upgrading.<\\/li>\\t\\t\\n\\t\\t\\t<\\/ol>\\n\\t\\t\\t<p><span style=\\"color: #008000;\\"><strong>Links :<\\/strong><\\/span><\\/p>\\t\\t\\t\\t\\t\\t\\n\\t\\t\\t\\t<ul><li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?50267\\">General Userguide<\\/a><\\/li>\\n\\t\\t \\t<li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li><\\/ul>\\t\\t\\t\\n\\t\\t\\t<p>Copyright 2004 - 2012 <a href=\\"http:\\/\\/www.joomlart.com\\/\\" title=\\"Visit Joomlart.com!\\">JoomlArt.com<\\/a>.<\\/p> \\n\\t\\t<\\/div>\\n\\t\\t\\n\\t","group":""}', '{"disable_tab":"0","style":"default","position":"top","width":"100%","height":"auto","widthTabs":"100%","heightTabs":"30","duration":"1000","animType":"animMoveVir","skipAnim":"false","mouseType":"click","view":"introtext","colors":""}', '', '', 0, '0000-00-00 00:00:00', 1, 0),
(10031, 'Content - JA Disqus Debate Echo', 'plugin', 'jadisqus_debate_echo', 'content', 0, 1, 1, 0, '{"name":"Content - JA Disqus Debate Echo","type":"plugin","creationDate":"14 June 2013","author":"JoomlArt.com","copyright":"J.O.O.M Solutions Co., Ltd.","authorEmail":"webmaster@joomlart.com","authorUrl":"www.joomlart.com","version":"2.5.8","description":"\\n\\t\\n\\t<div style=\\"font-weight: normal;text-align:left;\\">\\n\\t<span style=\\"color: #008000;\\"><strong>JA Disqus Debate Echo Plugin for Joomla 2.5 and Joomla 3.0<\\/strong><\\/span><br \\/><p><img alt=\\"JA Disqus Debate Echo Plugin\\" src=\\"http:\\/\\/joomlart.s3.amazonaws.com\\/images\\/mis\\/logo-JA-Disqus-Debate-Echo-Plugin.jpg\\" \\/><\\/p><p>JA Disqus Debate Echo plugin allows you to integrate popular external commenting systems into your Joomla! articles.<\\/p>\\n\\t<p><span style=\\"color: #ff6600;\\"><strong>Features:<\\/strong><\\/span><\\/p>\\n\\t<ul>\\n\\t\\t<li>Allows integration of <a target=\\"_blank\\" href=\\"http:\\/\\/www.intensedebate.com\\/\\">IntenseDebate<\\/a>, <a target=\\"_blank\\" href=\\"http:\\/\\/www.disqus.com\\/\\">Disqus<\\/a>. <\\/li>\\n\\t\\t<li>Easy to use. Install, configure and multiple options.<\\/li>\\n\\t\\t<li>Option to enable it for all, enable for limited categories or individual articles OR disable for individual articles too.<\\/li>\\n\\t<\\/ul>\\n\\t<strong><span style=\\"color: #ff0000;\\">Links:<\\/span><br \\/><\\/strong> \\n\\t<ul>\\n\\t\\t<li><a target=\\"_blank\\" href=\\"http:\\/\\/www.joomlart.com\\/forums\\/showthread.php?51776\\">General Userguide<\\/a><\\/li>\\n\\t\\t <li><a target=\'_blank\' href=\'http:\\/\\/update.joomlart.com\\/\'>Updates &amp; Versions<\\/a><\\/li>\\n\\t<\\/ul>\\n\\t<p>Copyright 2004 - 2013 <a href=\'http:\\/\\/www.joomlart.com\\/\' title=\'Visit Joomlart.com!\'>JoomlArt.com<\\/a>.<\\/p>\\n\\t<\\/div>\\n\\t\\n\\t","group":""}', '{"mode":"automatic","source":"com_content","mode-automatic-catsid":["77","78","79","80","81","82","83","84","85","86","87","88","89","90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"mode-automatic-k2catsid":[""],"provider":"disqus","provider-intensdebate-account":"","provider-disqus-subdomain":"joomlart","provider-disqus-devmode":"1","provider-jskit-domain":"","display_comment_count":"1","display_on_list":"1","display_on_home":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10034, 'com_jaextmanager', 'component', 'com_jaextmanager', '', 1, 1, 0, 0, '{"name":"com_jaextmanager","type":"component","creationDate":"May 2013","author":"JoomlArt","copyright":"Copyright (C), J.O.O.M Solutions Co., Ltd. All Rights Reserved.","authorEmail":"webmaster@joomlart.com","authorUrl":"http:\\/\\/www.joomlart.com","version":"2.5.7","description":"JA Extension Manager Component","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10017, 'com_finder', 'component', 'com_finder', '', 1, 1, 1, 0, '{"name":"com_finder","type":"component","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_FINDER_XML_DESCRIPTION","group":""}', '{"enabled":"0","show_description":"1","description_length":255,"allow_empty_query":"0","show_url":"1","show_autosuggest":"0","show_advanced":"1","show_advanced_tips":"0","expand_advanced":"0","show_date_filters":"0","sort_order":"relevance","sort_direction":"desc","highlight_terms":"1","opensearch_name":"","opensearch_description":"","batch_size":"50","memory_table_limit":30000,"title_multiplier":"1.7","text_multiplier":"0.7","meta_multiplier":"1.2","path_multiplier":"2.0","misc_multiplier":"0.3","stem":"1","stemmer":"snowball","enable_logging":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10018, 'mod_finder', 'module', 'mod_finder', '', 0, 1, 1, 0, '{"name":"mod_finder","type":"module","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_FINDER_XML_DESCRIPTION","group":""}', '{"searchfilter":"","show_autosuggest":"1","show_advanced":"0","moduleclass_sfx":"","field_size":"25","show_label":"1","label_pos":"top","show_button":"0","button_pos":"right","opensearch":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10019, 'mod_version', 'module', 'mod_version', '', 1, 1, 1, 0, '{"name":"mod_version","type":"module","creationDate":"January 2012","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_VERSION_XML_DESCRIPTION","group":""}', '{"format":"short","product":"1","cache":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10020, 'plg_captcha_recaptcha', 'plugin', 'recaptcha', 'captcha', 0, 1, 1, 0, '{"name":"plg_captcha_recaptcha","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION","group":""}', '{"public_key":"","private_key":"","theme":"clean"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10021, 'plg_content_finder', 'plugin', 'finder', 'content', 0, 0, 1, 0, '{"name":"plg_content_finder","type":"plugin","creationDate":"December 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_CONTENT_FINDER_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10022, 'plg_finder_categories', 'plugin', 'categories', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_categories","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CATEGORIES_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);
INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`) VALUES
(10023, 'plg_finder_contacts', 'plugin', 'contacts', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_contacts","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTACTS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10024, 'plg_finder_content', 'plugin', 'content', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_content","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_CONTENT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10025, 'plg_finder_newsfeeds', 'plugin', 'newsfeeds', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_newsfeeds","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10026, 'plg_finder_weblinks', 'plugin', 'weblinks', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_weblinks","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_WEBLINKS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10027, 'plg_quickicon_extensionupdate', 'plugin', 'extensionupdate', 'quickicon', 0, 1, 1, 0, '{"name":"plg_quickicon_extensionupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10028, 'plg_quickicon_joomlaupdate', 'plugin', 'joomlaupdate', 'quickicon', 0, 1, 1, 0, '{"name":"plg_quickicon_joomlaupdate","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{"context":"mod_quickicon"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10029, 'plg_system_highlight', 'plugin', 'highlight', 'system', 0, 1, 1, 0, '{"name":"plg_system_highlight","type":"plugin","creationDate":"August 2011","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10030, 'plg_system_languagecode', 'plugin', 'languagecode', 'system', 0, 0, 1, 0, '{"name":"plg_system_languagecode","type":"plugin","creationDate":"November 2011","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10032, 'com_joomlaupdate', 'component', 'com_joomlaupdate', '', 1, 1, 1, 0, '{"name":"com_joomlaupdate","type":"component","creationDate":"February 2012","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.\\t","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"COM_JOOMLAUPDATE_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10035, 'beez3', 'template', 'beez3', '', 0, 1, 1, 0, '{"name":"beez3","type":"template","creationDate":"25 November 2009","author":"Angie Radtke","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"a.radtke@derauftritt.de","authorUrl":"http:\\/\\/www.der-auftritt.de","version":"3.1.0","description":"TPL_BEEZ3_XML_DESCRIPTION","group":""}', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature","backgroundcolor":"#eee"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10036, 'protostar', 'template', 'protostar', '', 0, 1, 1, 0, '{"name":"protostar","type":"template","creationDate":"4\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_PROTOSTAR_XML_DESCRIPTION","group":""}', '{"templateColor":"#08C","templateBackgroundColor":"#F4F6F7","logoFile":"","sitetitle":"","sitedescription":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10037, 'isis', 'template', 'isis', '', 1, 1, 1, 0, '{"name":"isis","type":"template","creationDate":"3\\/30\\/2012","author":"Kyle Ledbetter","copyright":"Copyright (C) 2005 - 2013 Open Source Matters, Inc. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"","version":"1.0","description":"TPL_ISIS_XML_DESCRIPTION","group":""}', '{"templateColor":"#13294A","headerColor":"#184A7D","logoFile":"","admin_menus":"1","displayHeader":"1","statusFixed":"1","stickyToolbar":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(10038, 'mod_stats_admin', 'module', 'mod_stats_admin', '', 1, 1, 1, 0, '{"name":"mod_stats_admin","type":"module","creationDate":"July 2004","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"MOD_STATS_XML_DESCRIPTION","group":""}', '{"serverinfo":"0","siteinfo":"0","counter":"0","increase":"0","cache":"1","cache_time":"900","cachemode":"static"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(29, 'com_tags', 'component', 'com_tags', '', 1, 1, 1, 1, '{"name":"com_tags","type":"component","creationDate":"December 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"COM_TAGS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(316, 'mod_tags_popular', 'module', 'mod_tags_popular', '', 0, 1, 1, 0, '{"name":"mod_tags_popular","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_POPULAR_XML_DESCRIPTION","group":""}', '{"maximum":"5","timeframe":"alltime","owncache":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(317, 'mod_tags_similar', 'module', 'mod_tags_similar', '', 0, 1, 1, 0, '{"name":"mod_tags_similar","type":"module","creationDate":"January 2013","author":"Joomla! Project","copyright":"Copyright (C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.1.0","description":"MOD_TAGS_SIMILAR_XML_DESCRIPTION","group":""}', '{"maximum":"5","matchtype":"any","owncache":"1"}', '', '', 0, '0000-00-00 00:00:00', 0, 0),
(447, 'plg_finder_tags', 'plugin', 'tags', 'finder', 0, 1, 1, 0, '{"name":"plg_finder_tags","type":"plugin","creationDate":"February 2013","author":"Joomla! Project","copyright":"(C) 2005 - 2013 Open Source Matters. All rights reserved.","authorEmail":"admin@joomla.org","authorUrl":"www.joomla.org","version":"3.0.0","description":"PLG_FINDER_TAGS_XML_DESCRIPTION","group":""}', '{}', '', '', 0, '0000-00-00 00:00:00', 0, 0);

DROP TABLE IF EXISTS `#__finder_filters`;
CREATE TABLE `#__finder_filters` (
  `filter_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `state` tinyint(1) NOT NULL DEFAULT '1',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `created_by_alias` varchar(255) NOT NULL,
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `map_count` int(10) unsigned NOT NULL DEFAULT '0',
  `data` text NOT NULL,
  `params` mediumtext,
  PRIMARY KEY (`filter_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links`;
CREATE TABLE `#__finder_links` (
  `link_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `route` varchar(255) NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `indexdate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `md5sum` varchar(32) DEFAULT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '1',
  `state` int(5) DEFAULT '1',
  `access` int(5) DEFAULT '0',
  `language` varchar(8) NOT NULL,
  `publish_start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `start_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `end_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `list_price` double unsigned NOT NULL DEFAULT '0',
  `sale_price` double unsigned NOT NULL DEFAULT '0',
  `type_id` int(11) NOT NULL,
  `object` mediumblob NOT NULL,
  PRIMARY KEY (`link_id`),
  KEY `idx_type` (`type_id`),
  KEY `idx_title` (`title`),
  KEY `idx_md5` (`md5sum`),
  KEY `idx_url` (`url`(75)),
  KEY `idx_published_list` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`list_price`),
  KEY `idx_published_sale` (`published`,`state`,`access`,`publish_start_date`,`publish_end_date`,`sale_price`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms0`;
CREATE TABLE `#__finder_links_terms0` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms1`;
CREATE TABLE `#__finder_links_terms1` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms2`;
CREATE TABLE `#__finder_links_terms2` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms3`;
CREATE TABLE `#__finder_links_terms3` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms4`;
CREATE TABLE `#__finder_links_terms4` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms5`;
CREATE TABLE `#__finder_links_terms5` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms6`;
CREATE TABLE `#__finder_links_terms6` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms7`;
CREATE TABLE `#__finder_links_terms7` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms8`;
CREATE TABLE `#__finder_links_terms8` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_terms9`;
CREATE TABLE `#__finder_links_terms9` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsa`;
CREATE TABLE `#__finder_links_termsa` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsb`;
CREATE TABLE `#__finder_links_termsb` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsc`;
CREATE TABLE `#__finder_links_termsc` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsd`;
CREATE TABLE `#__finder_links_termsd` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termse`;
CREATE TABLE `#__finder_links_termse` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_links_termsf`;
CREATE TABLE `#__finder_links_termsf` (
  `link_id` int(10) unsigned NOT NULL,
  `term_id` int(10) unsigned NOT NULL,
  `weight` float unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`term_id`),
  KEY `idx_term_weight` (`term_id`,`weight`),
  KEY `idx_link_term_weight` (`link_id`,`term_id`,`weight`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_taxonomy`;
CREATE TABLE `#__finder_taxonomy` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL,
  `state` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `access` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `parent_id` (`parent_id`),
  KEY `state` (`state`),
  KEY `ordering` (`ordering`),
  KEY `access` (`access`),
  KEY `idx_parent_published` (`parent_id`,`state`,`access`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_taxonomy_map`;
CREATE TABLE `#__finder_taxonomy_map` (
  `link_id` int(10) unsigned NOT NULL,
  `node_id` int(10) unsigned NOT NULL,
  PRIMARY KEY (`link_id`,`node_id`),
  KEY `link_id` (`link_id`),
  KEY `node_id` (`node_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_terms`;
CREATE TABLE `#__finder_terms` (
  `term_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '0',
  `soundex` varchar(75) NOT NULL,
  `links` int(10) NOT NULL DEFAULT '0',
  `language` char(3) NOT NULL DEFAULT '',
  PRIMARY KEY (`term_id`),
  UNIQUE KEY `idx_term` (`term`),
  KEY `idx_term_phrase` (`term`,`phrase`),
  KEY `idx_stem_phrase` (`stem`,`phrase`),
  KEY `idx_soundex_phrase` (`soundex`,`phrase`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_terms_common`;
CREATE TABLE `#__finder_terms_common` (
  `term` varchar(75) NOT NULL,
  `language` varchar(3) NOT NULL,
  KEY `idx_word_lang` (`term`,`language`),
  KEY `idx_lang` (`language`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__finder_tokens`;
CREATE TABLE `#__finder_tokens` (
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `weight` float unsigned NOT NULL DEFAULT '1',
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `language` char(3) NOT NULL DEFAULT '',
  KEY `idx_word` (`term`),
  KEY `idx_context` (`context`)
) ENGINE=MEMORY;

DROP TABLE IF EXISTS `#__finder_tokens_aggregate`;
CREATE TABLE `#__finder_tokens_aggregate` (
  `term_id` int(10) unsigned NOT NULL,
  `map_suffix` char(1) NOT NULL,
  `term` varchar(75) NOT NULL,
  `stem` varchar(75) NOT NULL,
  `common` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `phrase` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `term_weight` float unsigned NOT NULL,
  `context` tinyint(1) unsigned NOT NULL DEFAULT '2',
  `context_weight` float unsigned NOT NULL,
  `total_weight` float unsigned NOT NULL,
  `language` char(3) NOT NULL DEFAULT '',
  KEY `token` (`term`),
  KEY `keyword_id` (`term_id`)
) ENGINE=MEMORY;

DROP TABLE IF EXISTS `#__finder_types`;
CREATE TABLE `#__finder_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `mime` varchar(100) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `title` (`title`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__jaem_log`;
CREATE TABLE `#__jaem_log` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ext_id` varchar(50) DEFAULT NULL,
  `service_id` int(11) DEFAULT NULL,
  `check_date` datetime DEFAULT NULL,
  `check_info` text,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ext_id` (`ext_id`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__jaem_services`;
CREATE TABLE `#__jaem_services` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `ws_name` varchar(255) NOT NULL,
  `ws_mode` varchar(50) NOT NULL DEFAULT 'local',
  `ws_uri` varchar(255) NOT NULL,
  `ws_user` varchar(100) NOT NULL,
  `ws_pass` varchar(100) NOT NULL,
  `ws_default` tinyint(1) NOT NULL DEFAULT '0',
  `ws_core` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM ;

INSERT INTO `#__jaem_services` (`id`, `ws_name`, `ws_mode`, `ws_uri`, `ws_user`, `ws_pass`, `ws_default`, `ws_core`) VALUES
(1, 'Local Service', 'local', '', '', '', 1, 1),
(2, 'JoomlArt Updates', 'remote', 'http://update.joomlart.com/service/', '', '', 0, 1);

DROP TABLE IF EXISTS `#__languages`;
CREATE TABLE `#__languages` (
  `lang_id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `lang_code` char(7) NOT NULL,
  `title` varchar(50) NOT NULL,
  `title_native` varchar(50) NOT NULL,
  `sef` varchar(50) NOT NULL,
  `image` varchar(50) NOT NULL,
  `description` varchar(512) NOT NULL,
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `sitename` varchar(1024) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`lang_id`),
  UNIQUE KEY `idx_sef` (`sef`),
  UNIQUE KEY `idx_image` (`image`),
  UNIQUE KEY `idx_langcode` (`lang_code`),
  KEY `idx_ordering` (`ordering`)
) ENGINE=MyISAM ;

INSERT INTO `#__languages` (`lang_id`, `lang_code`, `title`, `title_native`, `sef`, `image`, `description`, `metakey`, `metadesc`, `sitename`, `published`, `access`, `ordering`) VALUES
(1, 'en-GB', 'English (UK)', 'English (UK)', 'en', 'en', '', '', '', '', 1, 0, 0),
(3, 'xx-XX', 'xx (Test)', 'xx (Test)', 'xx', 'br', '', '', '', '', -2, 0, 0);

DROP TABLE IF EXISTS `#__menu`;
CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) binary NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned DEFAULT NULL,
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(1, '', 'Menu_Item_Root', 'root', '', '', '', '', 1, 0, 0, 0, 0, '0000-00-00 00:00:00', 0, 0, '', 0, '', 0, 509, 0, '*', 0),
(2, 'menu', 'com_banners', 'Banners', '', 'Banners', 'index.php?option=com_banners', 'component', 0, 1, 1, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 19, 28, 0, '*', 1),
(3, 'menu', 'com_banners', 'Banners', '', 'Banners/Banners', 'index.php?option=com_banners', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners', 0, '', 20, 21, 0, '*', 1),
(4, 'menu', 'com_banners_categories', 'Categories', '', 'Banners/Categories', 'index.php?option=com_categories&extension=com_banners', 'component', 0, 2, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-cat', 0, '', 22, 23, 0, '*', 1),
(5, 'menu', 'com_banners_clients', 'Clients', '', 'Banners/Clients', 'index.php?option=com_banners&view=clients', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-clients', 0, '', 24, 25, 0, '*', 1),
(6, 'menu', 'com_banners_tracks', 'Tracks', '', 'Banners/Tracks', 'index.php?option=com_banners&view=tracks', 'component', 0, 2, 2, 4, 0, '0000-00-00 00:00:00', 0, 0, 'class:banners-tracks', 0, '', 26, 27, 0, '*', 1),
(7, 'menu', 'com_contact', 'Contacts', '', 'Contacts', 'index.php?option=com_contact', 'component', 0, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 29, 34, 0, '*', 1),
(8, 'menu', 'com_contact', 'Contacts', '', 'Contacts/Contacts', 'index.php?option=com_contact', 'component', 0, 7, 2, 8, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact', 0, '', 30, 31, 0, '*', 1),
(9, 'menu', 'com_contact_categories', 'Categories', '', 'Contacts/Categories', 'index.php?option=com_categories&extension=com_contact', 'component', 0, 7, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:contact-cat', 0, '', 32, 33, 0, '*', 1),
(10, 'menu', 'com_messages', 'Messaging', '', 'Messaging', 'index.php?option=com_messages', 'component', 0, 1, 1, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages', 0, '', 35, 40, 0, '*', 1),
(11, 'menu', 'com_messages_add', 'New Private Message', '', 'Messaging/New Private Message', 'index.php?option=com_messages&task=message.add', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-add', 0, '', 36, 37, 0, '*', 1),
(12, 'menu', 'com_messages_read', 'Read Private Message', '', 'Messaging/Read Private Message', 'index.php?option=com_messages', 'component', 0, 10, 2, 15, 0, '0000-00-00 00:00:00', 0, 0, 'class:messages-read', 0, '', 38, 39, 0, '*', 1),
(13, 'menu', 'com_newsfeeds', 'News Feeds', '', 'News Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 1, 1, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 43, 48, 0, '*', 1),
(14, 'menu', 'com_newsfeeds_feeds', 'Feeds', '', 'News Feeds/Feeds', 'index.php?option=com_newsfeeds', 'component', 0, 13, 2, 17, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds', 0, '', 44, 45, 0, '*', 1),
(15, 'menu', 'com_newsfeeds_categories', 'Categories', '', 'News Feeds/Categories', 'index.php?option=com_categories&extension=com_newsfeeds', 'component', 0, 13, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:newsfeeds-cat', 0, '', 46, 47, 0, '*', 1),
(16, 'menu', 'com_redirect', 'Redirect', '', 'Redirect', 'index.php?option=com_redirect', 'component', 0, 1, 1, 24, 0, '0000-00-00 00:00:00', 0, 0, 'class:redirect', 0, '', 59, 60, 0, '*', 1),
(17, 'menu', 'com_search', 'Search', '', 'Search', 'index.php?option=com_search', 'component', 0, 1, 1, 19, 0, '0000-00-00 00:00:00', 0, 0, 'class:search', 0, '', 49, 50, 0, '*', 1),
(18, 'menu', 'com_weblinks', 'Weblinks', '', 'Weblinks', 'index.php?option=com_weblinks', 'component', 0, 1, 1, 21, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 53, 58, 0, '*', 1),
(19, 'menu', 'com_weblinks_links', 'Links', '', 'Weblinks/Links', 'index.php?option=com_weblinks', 'component', 0, 18, 2, 21, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks', 0, '', 54, 55, 0, '*', 1),
(20, 'menu', 'com_weblinks_categories', 'Categories', '', 'Weblinks/Categories', 'index.php?option=com_categories&extension=com_weblinks', 'component', 0, 18, 2, 6, 0, '0000-00-00 00:00:00', 0, 0, 'class:weblinks-cat', 0, '', 56, 57, 0, '*', 1),
(464, 'top', 'Home', 'home', '', 'home', 'index.php?Itemid=', 'alias', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"491","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 235, 236, 0, '*', 0),
(227, 'aboutjoomla', 'Weblinks Categories', 'weblinks-categories', '', 'using-joomla/extensions/components/weblinks-component/weblinks-categories', 'index.php?option=com_weblinks&view=categories&id=18', 'component', 1, 265, 5, 21, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"-1","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_links_cat":"","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_num_links":"","show_pagination_limit":"","show_headings":"","show_link_description":"","show_link_hits":"","show_pagination":"","show_pagination_results":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 95, 96, 0, '*', 0),
(233, 'mainmenu', 'Login', 'login', '', 'login', 'index.php?option=com_users&view=login', 'component', -2, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 11, 12, 0, '*', 0),
(229, 'aboutjoomla', 'Single Contact', 'single-contact', '', 'using-joomla/extensions/components/contact-component/single-contact', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 270, 5, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_crumb":"","presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 85, 86, 0, '*', 0),
(201, 'usermenu', 'Your Profile', 'your-profile', '', 'your-profile', 'index.php?option=com_users&view=profile', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 2, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 243, 244, 0, '*', 0),
(296, 'parks', 'Park Links', 'park-links', '', 'park-links', 'index.php?option=com_weblinks&view=category&id=31', 'component', 1, 1, 1, 21, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"maxLevel":"-1","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"","show_headings":"0","orderby_pri":"","show_pagination":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 257, 258, 0, 'en-GB', 0),
(234, 'parks', 'Park Blog', 'park-blog', '', 'park-blog', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"1","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 247, 248, 0, 'en-GB', 0),
(238, 'mainmenu', 'Sample Sites', 'sample-sites', '', 'sample-sites', 'index.php?option=com_content&view=article&id=38', 'component', -2, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 271, 276, 0, '*', 0),
(207, 'top', 'Joomla.org', 'joomlaorg', '', 'joomlaorg', 'http://joomla.org', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 241, 242, 0, '*', 0),
(242, 'parks', 'Write a Blog Post', 'write-a-blog-post', '', 'write-a-blog-post', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 3, '', 114, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 249, 250, 0, 'en-GB', 0),
(243, 'parks', 'Parks Home', 'parks-home', '', 'parks-home', 'index.php?option=com_content&view=article&id=6', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"show_noauth":"","show_title":"0","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"","show_print_icon":"0","show_email_icon":"0","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 245, 246, 0, 'en-GB', 0),
(244, 'parks', 'Image Gallery', 'image-gallery', '', 'image-gallery', 'index.php?option=com_content&view=categories&id=28', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 114, '{"show_base_description":"1","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_articles_cat":"","drill_down_layout":"1","show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"-1","show_empty_categories":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 251, 256, 0, 'en-GB', 0),
(270, 'aboutjoomla', 'Contact Component', 'contact-component', '', 'using-joomla/extensions/components/contact-component', 'index.php?option=com_content&view=article&id=9', 'component', 1, 268, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 80, 89, 0, '*', 0),
(279, 'aboutjoomla', 'The Joomla! Community', 'the-joomla-community', '', 'the-joomla-community', 'index.php?option=com_content&view=article&id=47', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"0","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 239, 240, 0, '*', 0),
(249, 'aboutjoomla', 'Submit a Weblink', 'submit-a-weblink', '', 'using-joomla/extensions/components/weblinks-component/submit-a-weblink', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', 1, 265, 5, 21, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 91, 92, 0, '*', 0),
(251, 'aboutjoomla', 'Contact Categories', 'contact-categories', '', 'using-joomla/extensions/components/contact-component/contact-categories', 'index.php?option=com_contact&view=categories&id=16', 'component', 1, 270, 5, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 81, 82, 0, '*', 0),
(252, 'aboutjoomla', 'News Feed Categories', 'new-feed-categories', '', 'using-joomla/extensions/components/news-feeds-component/new-feed-categories', 'index.php?option=com_newsfeeds&view=categories&id=0', 'component', 1, 267, 5, 17, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"Because this links to the root category the \\"uncategorised\\" category is displayed. ","maxLevel":"-1","show_empty_categories":"1","show_description":"1","show_description_image":"1","show_cat_num_articles":"1","display_num":"","show_headings":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 99, 100, 0, '*', 0),
(253, 'aboutjoomla', 'News Feed Category', 'news-feed-category', '', 'using-joomla/extensions/components/news-feeds-component/news-feed-category', 'index.php?option=com_newsfeeds&view=category&id=17', 'component', 1, 267, 5, 17, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 103, 104, 0, '*', 0),
(254, 'aboutjoomla', 'Single News Feed', 'single-news-feed', '', 'using-joomla/extensions/components/news-feeds-component/single-news-feed', 'index.php?option=com_newsfeeds&view=newsfeed&id=4', 'component', 1, 267, 5, 17, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 101, 102, 0, '*', 0),
(255, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/components/search-component/search', 'index.php?option=com_search&view=search', 'component', 1, 276, 5, 19, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"search_areas":"1","show_date":"1","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 121, 122, 0, '*', 0),
(256, 'aboutjoomla', 'Archived articles', 'archived-articles', '', 'using-joomla/extensions/components/content-component/archived-articles', 'index.php?option=com_content&view=archive', 'component', 1, 266, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"orderby_sec":"","order_date":"","display_num":"","filter_field":"","show_category":"1","link_category":"1","show_title":"1","link_titles":"1","show_intro":"1","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 75, 76, 0, '*', 0),
(257, 'aboutjoomla', 'Single Article', 'single-article', '', 'using-joomla/extensions/components/content-component/single-article', 'index.php?option=com_content&view=article&id=6', 'component', 1, 266, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 65, 66, 0, '*', 0),
(278, 'aboutjoomla', 'The Joomla! Project', 'the-joomla-project', '', 'the-joomla-project', 'index.php?option=com_content&view=article&id=48', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"","show_email_icon":"","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 237, 238, 0, '*', 0),
(259, 'aboutjoomla', 'Article Category Blog', 'article-category-blog', '', 'using-joomla/extensions/components/content-component/article-category-blog', 'index.php?option=com_content&view=category&layout=blog&id=27', 'component', 1, 266, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"0","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 69, 70, 0, '*', 0),
(260, 'aboutjoomla', 'Article Category List', 'article-category-list', '', 'using-joomla/extensions/components/content-component/article-category-list', 'index.php?option=com_content&view=category&id=19', 'component', 1, 266, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_category_title":"","page_subheading":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","article-allow_ratings":"","article-allow_comments":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 71, 72, 0, '*', 0),
(262, 'aboutjoomla', 'Featured Articles', 'featured-articles', '', 'using-joomla/extensions/components/content-component/featured-articles', 'index.php?option=com_content&view=featured', 'component', 1, 266, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 73, 74, 0, '*', 0),
(263, 'aboutjoomla', 'Submit Article', 'submit-article', '', 'using-joomla/extensions/components/content-component/submit-article', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 266, 5, 22, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 77, 78, 0, '*', 0),
(265, 'aboutjoomla', 'Weblinks Component', 'weblinks-component', '', 'using-joomla/extensions/components/weblinks-component', 'index.php?option=com_content&view=article&id=54', 'component', 1, 268, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 90, 97, 0, '*', 0),
(266, 'aboutjoomla', 'Content Component', 'content-component', '', 'using-joomla/extensions/components/content-component', 'index.php?option=com_content&view=article&id=10', 'component', 1, 268, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"article-allow_ratings":"","article-allow_comments":"","show_category":"","link_category":"","show_title":"","link_titles":"","show_intro":"","show_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 64, 79, 0, '*', 0),
(267, 'aboutjoomla', 'News Feeds Component', 'news-feeds-component', '', 'using-joomla/extensions/components/news-feeds-component', 'index.php?option=com_content&view=article&id=60', 'component', 1, 268, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"Newsfeeds Categories View ","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 98, 105, 0, '*', 0),
(268, 'aboutjoomla', 'Components', 'components', '', 'using-joomla/extensions/components', 'index.php?option=com_content&view=category&layout=blog&id=21', 'component', 1, 277, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"","maxLevel":"","show_empty_categories":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"7","num_columns":"1","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"0","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 63, 126, 0, '*', 0),
(277, 'aboutjoomla', 'Using Extensions', 'extensions', '', 'using-joomla/extensions', 'index.php?option=com_content&view=categories&id=20', 'component', 1, 280, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"1","categories_description":"","maxLevelcat":"1","show_empty_categories_cat":"1","show_subcat_desc_cat":"1","show_cat_num_articles_cat":"0","drill_down_layout":"0","show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"1","show_empty_categories":"1","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 62, 229, 0, '*', 0),
(271, 'aboutjoomla', 'Users Component', 'users-component', '', 'using-joomla/extensions/components/users-component', 'index.php?option=com_content&view=article&id=52', 'component', 1, 268, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 106, 119, 0, '*', 0),
(272, 'aboutjoomla', 'Article Categories', 'article-categories', '', 'using-joomla/extensions/components/content-component/article-categories', 'index.php?option=com_content&view=categories&id=14', 'component', 1, 266, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","category_layout":"","show_headings":"","show_date":"","date_format":"","filter_field":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 67, 68, 0, '*', 0),
(273, 'aboutjoomla', 'Administrator Components', 'administrator-components', '', 'using-joomla/extensions/components/administrator-components', 'index.php?option=com_content&view=article&id=1', 'component', 1, 268, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 124, 125, 0, '*', 0),
(274, 'aboutjoomla', 'Weblinks Single Category', 'weblinks-single-category', '', 'using-joomla/extensions/components/weblinks-component/weblinks-single-category', 'index.php?option=com_weblinks&view=category&id=32', 'component', 1, 265, 5, 21, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","orderby_pri":"","show_pagination":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 93, 94, 0, '*', 0),
(275, 'aboutjoomla', 'Contact Single Category', 'contact-single-category', '', 'using-joomla/extensions/components/contact-component/contact-single-category', 'index.php?option=com_contact&view=category&catid=26&id=36', 'component', 1, 270, 5, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"20","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 83, 84, 0, '*', 0),
(276, 'aboutjoomla', 'Search Component', 'search-component', '', 'using-joomla/extensions/components/search-component', 'index.php?option=com_content&view=article&id=39', 'component', 1, 268, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 120, 123, 0, '*', 0),
(280, 'aboutjoomla', 'Using Joomla!', 'using-joomla', '', 'using-joomla', 'index.php?option=com_content&view=article&id=53', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"0","show_intro":"1","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 61, 234, 0, '*', 0),
(281, 'aboutjoomla', 'Modules', 'modules', '', 'using-joomla/extensions/modules', 'index.php?option=com_content&view=category&id=22', 'component', 1, 277, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"1","maxLevel":"1","show_empty_categories":"1","show_no_articles":"0","show_subcat_desc":"1","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"","show_readmore":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 127, 184, 0, '*', 0),
(282, 'aboutjoomla', 'Templates', 'templates', '', 'using-joomla/extensions/templates', 'index.php?option=com_content&view=category&id=23', 'component', 1, 277, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"1","show_description_image":"","maxLevel":"2","show_empty_categories":"1","show_no_articles":"0","show_subcat_desc":"1","show_cat_num_articles":"","page_subheading":"","show_pagination_limit":"0","filter_field":"hide","show_headings":"0","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","show_pagination":"0","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"Templates","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 185, 210, 0, '*', 0),
(283, 'aboutjoomla', 'Languages', 'languages', '', 'using-joomla/extensions/languages', 'index.php?option=com_content&view=category&layout=blog&id=24', 'component', 1, 277, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 211, 212, 0, '*', 0),
(284, 'aboutjoomla', 'Plugins', 'plugins', '', 'using-joomla/extensions/plugins', 'index.php?option=com_content&view=category&layout=blog&id=25', 'component', 1, 277, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"7","num_columns":"1","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 213, 228, 0, '*', 0),
(285, 'aboutjoomla', 'Typography Atomic', 'typography-atomic', '', 'using-joomla/extensions/templates/atomic/typography-atomic', 'index.php?option=com_content&view=article&id=49', 'component', 1, 422, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 3, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 199, 200, 0, '*', 0),
(286, 'aboutjoomla', 'Typography Milky Way', 'typography-milky-way', '', 'using-joomla/extensions/templates/milky-way/typography-milky-way', 'index.php?option=com_content&view=article&id=49', 'component', 1, 421, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 205, 206, 0, '*', 0),
(290, 'mainmenu', 'Articles', 'articles', '', 'site-map/articles', 'index.php?option=com_content&view=categories&id=0', 'component', -2, 294, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","category_layout":"","show_headings":"","show_date":"","date_format":"","filter_field":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","article-allow_ratings":"","article-allow_comments":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 4, 5, 0, '*', 0),
(294, 'mainmenu', 'Site Map', 'site-map', '', 'site-map', 'index.php?option=com_content&view=article&id=42', 'component', -2, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 3, 10, 0, '*', 0),
(445, 'mainmenu', 'Parks', 'parks', '', 'sample-sites/parks', 'index.php?Itemid=', 'alias', -2, 238, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"aliasoptions":"243","menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 272, 273, 0, '*', 0),
(300, 'aboutjoomla', 'Latest Users', 'latest-users', '', 'using-joomla/extensions/modules/user-modules/latest-users', 'index.php?option=com_content&view=article&id=66', 'component', 1, 412, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 149, 150, 0, '*', 0),
(301, 'aboutjoomla', 'Who\'s Online', 'whos-online', '', 'using-joomla/extensions/modules/user-modules/whos-online', 'index.php?option=com_content&view=article&id=56', 'component', 1, 412, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 151, 152, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(302, 'aboutjoomla', 'Most Read', 'most-read', '', 'using-joomla/extensions/modules/content-modules/most-read', 'index.php?option=com_content&view=article&id=30', 'component', 1, 411, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 133, 134, 0, '*', 0),
(303, 'aboutjoomla', 'Menu', 'menu', '', 'using-joomla/extensions/modules/menu-modules/menu', 'index.php?option=com_content&view=article&id=29', 'component', 1, 415, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 129, 130, 0, '*', 0),
(304, 'aboutjoomla', 'Statistics', 'statistics', '', 'using-joomla/extensions/modules/utility-modules/statistics', 'index.php?option=com_content&view=article&id=44', 'component', 1, 414, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 175, 176, 0, '*', 0),
(305, 'aboutjoomla', 'Banner', 'banner', '', 'using-joomla/extensions/modules/display-modules/banner', 'index.php?option=com_content&view=article&id=7', 'component', 1, 413, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 159, 160, 0, '*', 0),
(306, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/modules/utility-modules/search', 'index.php?option=com_content&view=article&id=40', 'component', 1, 414, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 177, 178, 0, '*', 0),
(307, 'aboutjoomla', 'Random Image', 'random-image', '', 'using-joomla/extensions/modules/display-modules/random-image', 'index.php?option=com_content&view=article&id=36', 'component', 1, 413, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 157, 158, 0, '*', 0),
(309, 'aboutjoomla', 'News Flash', 'news-flash', '', 'using-joomla/extensions/modules/content-modules/news-flash', 'index.php?option=com_content&view=article&id=31', 'component', 1, 411, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 135, 136, 0, '*', 0),
(310, 'aboutjoomla', 'Latest Articles', 'latest-articles', '', 'using-joomla/extensions/modules/content-modules/latest-articles', 'index.php?option=com_content&view=article&id=27', 'component', 1, 411, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 137, 138, 0, '*', 0),
(311, 'aboutjoomla', 'Syndicate', 'syndicate', '', 'using-joomla/extensions/modules/utility-modules/syndicate', 'index.php?option=com_content&view=article&id=45', 'component', 1, 414, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 173, 174, 0, '*', 0),
(312, 'aboutjoomla', 'Login', 'login', '', 'using-joomla/extensions/modules/user-modules/login', 'index.php?option=com_content&view=article&id=28', 'component', 1, 412, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 153, 154, 0, '*', 0),
(313, 'aboutjoomla', 'Wrapper', 'wrapper', '', 'using-joomla/extensions/modules/display-modules/wrapper', 'index.php?option=com_content&view=article&id=59', 'component', 1, 413, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 165, 166, 0, '*', 0),
(451, 'aboutjoomla', 'Milky Way Home', 'milky-way-home', '', 'using-joomla/extensions/templates/milky-way/milky-way-home', 'index.php?option=com_content&view=featured', 'component', 1, 421, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 207, 208, 0, '*', 0),
(316, 'aboutjoomla', 'Home Page Atomic', 'home-page-atomic', '', 'using-joomla/extensions/templates/atomic/home-page-atomic', 'index.php?option=com_content&view=featured', 'component', 1, 422, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 3, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 201, 202, 0, '*', 0),
(317, 'aboutjoomla', 'System', 'system', '', 'using-joomla/extensions/plugins/system', 'index.php?option=com_content&view=article&id=46', 'component', 1, 284, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 226, 227, 0, '*', 0),
(318, 'aboutjoomla', 'Authentication', 'authentication', '', 'using-joomla/extensions/plugins/authentication', 'index.php?option=com_content&view=article&id=5', 'component', 1, 284, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 214, 215, 0, '*', 0),
(319, 'aboutjoomla', 'Content', 'content', '', 'using-joomla/extensions/plugins/content', 'index.php?option=com_content&view=article&id=62', 'component', 1, 284, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 216, 217, 0, '*', 0),
(320, 'aboutjoomla', 'Editors', 'editors', '', 'using-joomla/extensions/plugins/editors', 'index.php?option=com_content&view=article&id=14', 'component', 1, 284, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 218, 219, 0, '*', 0),
(321, 'aboutjoomla', 'Editors Extended', 'editors-extended', '', 'using-joomla/extensions/plugins/editors-extended', 'index.php?option=com_content&view=article&id=15', 'component', 1, 284, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 220, 221, 0, '*', 0),
(322, 'aboutjoomla', 'Search', 'search', '', 'using-joomla/extensions/plugins/search', 'index.php?option=com_content&view=article&id=41', 'component', 1, 284, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 222, 223, 0, '*', 0),
(323, 'aboutjoomla', 'User', 'user', '', 'using-joomla/extensions/plugins/user', 'index.php?option=com_content&view=article&id=51', 'component', 1, 284, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 224, 225, 0, '*', 0),
(324, 'aboutjoomla', 'Footer', 'footer', '', 'using-joomla/extensions/modules/display-modules/footer', 'index.php?option=com_content&view=article&id=19', 'component', 1, 413, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 163, 164, 0, '*', 0),
(325, 'aboutjoomla', 'Archive', 'archive', '', 'using-joomla/extensions/modules/content-modules/archive', 'index.php?option=com_content&view=article&id=2', 'component', 1, 411, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 139, 140, 0, '*', 0),
(326, 'aboutjoomla', 'Related Items', 'related-items', '', 'using-joomla/extensions/modules/content-modules/related-items', 'index.php?option=com_content&view=article&id=37', 'component', 1, 411, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 141, 142, 0, '*', 0),
(399, 'parks', 'Animals', 'animals', '', 'image-gallery/animals', 'index.php?option=com_content&view=category&layout=blog&id=72', 'component', 1, 244, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"6","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"0","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 252, 253, 0, 'en-GB', 0),
(400, 'parks', 'Scenery', 'scenery', '', 'image-gallery/scenery', 'index.php?option=com_content&view=category&layout=blog&id=73', 'component', 1, 244, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_empty_categories":"","show_description":"0","show_description_image":"0","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"0","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"0","show_category":"1","link_category":"","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"1","show_readmore":"1","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 254, 255, 0, 'en-GB', 0),
(402, 'aboutjoomla', 'Login Form', 'login-form', '', 'using-joomla/extensions/components/users-component/login-form', 'index.php?option=com_users&view=login', 'component', 1, 271, 5, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 107, 108, 0, '*', 0),
(403, 'aboutjoomla', 'User Profile', 'user-profile', '', 'using-joomla/extensions/components/users-component/user-profile', 'index.php?option=com_users&view=profile', 'component', 1, 271, 5, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 109, 110, 0, '*', 0),
(404, 'aboutjoomla', 'Edit User Profile', 'edit-user-profile', '', 'using-joomla/extensions/components/users-component/edit-user-profile', 'index.php?option=com_users&view=profile&layout=edit', 'component', 1, 271, 5, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 111, 112, 0, '*', 0),
(405, 'aboutjoomla', 'Registration Form', 'registration-form', '', 'using-joomla/extensions/components/users-component/registration-form', 'index.php?option=com_users&view=registration', 'component', 1, 271, 5, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 113, 114, 0, '*', 0),
(406, 'aboutjoomla', 'Username Reminder Request', 'username-reminder', '', 'using-joomla/extensions/components/users-component/username-reminder', 'index.php?option=com_users&view=remind', 'component', 1, 271, 5, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 115, 116, 0, '*', 0),
(409, 'aboutjoomla', 'Password Reset', 'password-reset', '', 'using-joomla/extensions/components/users-component/password-reset', 'index.php?option=com_users&view=reset', 'component', 1, 271, 5, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 117, 118, 0, '*', 0),
(410, 'aboutjoomla', 'Feed Display', 'feed-display', '', 'using-joomla/extensions/modules/display-modules/feed-display', 'index.php?option=com_content&view=article&id=16', 'component', 1, 413, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 161, 162, 0, '*', 0),
(411, 'aboutjoomla', 'Content Modules', 'content-modules', '', 'using-joomla/extensions/modules/content-modules', 'index.php?option=com_content&view=category&id=64', 'component', 1, 281, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"1","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 132, 147, 0, '*', 0),
(412, 'aboutjoomla', 'User Modules', 'user-modules', '', 'using-joomla/extensions/modules/user-modules', 'index.php?option=com_content&view=category&id=65', 'component', 1, 281, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 148, 155, 0, '*', 0),
(413, 'aboutjoomla', 'Display Modules', 'display-modules', '', 'using-joomla/extensions/modules/display-modules', 'index.php?option=com_content&view=category&id=66', 'component', 1, 281, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"1","list_show_date":"","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"hide","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 156, 171, 0, '*', 0),
(414, 'aboutjoomla', 'Utility Modules', 'utility-modules', '', 'using-joomla/extensions/modules/utility-modules', 'index.php?option=com_content&view=category&id=67', 'component', 1, 281, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"","show_description":"1","show_description_image":"1","show_cat_num_articles":"","display_num":"0","show_headings":"0","list_show_title":"0","list_show_date":"0","date_format":"","list_show_hits":"0","list_show_author":"0","filter_field":"","orderby_pri":"","orderby_sec":"order","order_date":"","show_pagination":"","show_pagination_limit":"0","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"1","link_category":"1","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 172, 183, 0, '*', 0),
(415, 'aboutjoomla', 'Menu Module', 'menu-modules', '', 'using-joomla/extensions/modules/menu-modules', 'index.php?option=com_content&view=category&id=75', 'component', 1, 281, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_category_title":"","page_subheading":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 128, 131, 0, '*', 0),
(416, 'aboutjoomla', 'Breadcrumbs', 'breadcrumbs', '', 'using-joomla/extensions/modules/utility-modules/breadcrumbs', 'index.php?option=com_content&view=article&id=61', 'component', 1, 414, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 179, 180, 0, '*', 0),
(417, 'aboutjoomla', 'Weblinks', 'weblinks', '', 'using-joomla/extensions/modules/display-modules/weblinks', 'index.php?option=com_content&view=article&id=55', 'component', 1, 413, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 167, 168, 0, '*', 0),
(418, 'aboutjoomla', 'Custom HTML', 'custom-html', '', 'using-joomla/extensions/modules/display-modules/custom-html', 'index.php?option=com_content&view=article&id=12', 'component', 1, 413, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 169, 170, 0, '*', 0),
(419, 'aboutjoomla', 'Beez 2', 'beez-2', '', 'using-joomla/extensions/templates/beez-2', 'index.php?option=com_content&view=category&layout=blog&id=69', 'component', 1, 282, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 186, 191, 0, '*', 0),
(421, 'aboutjoomla', 'Milky Way', 'milky-way', '', 'using-joomla/extensions/templates/milky-way', 'index.php?option=com_content&view=category&layout=blog&id=71', 'component', 1, 282, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 204, 209, 0, '*', 0),
(422, 'aboutjoomla', 'Atomic', 'atomic', '', 'using-joomla/extensions/templates/atomic', 'index.php?option=com_content&view=category&layout=blog&id=68', 'component', 1, 282, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"2","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 198, 203, 0, '*', 0),
(423, 'aboutjoomla', 'Typography Beez 2', 'typography-beez-2', '', 'using-joomla/extensions/templates/beez-2/typography-beez-2', 'index.php?option=com_content&view=article&id=49', 'component', 1, 419, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 187, 188, 0, '*', 0),
(424, 'aboutjoomla', 'Home Page Beez 2', 'home-page-beez-2', '', 'using-joomla/extensions/templates/beez-2/home-page-beez-2', 'index.php?option=com_content&view=featured', 'component', 1, 419, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 4, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 189, 190, 0, '*', 0),
(430, 'fruitshop', 'Contact Us', 'contact-us', '', 'contact-us', 'index.php?option=com_contact&view=category&catid=47&id=36', 'component', 1, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"20","show_headings":"0","filter_field":"hide","show_pagination":"","show_noauth":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 265, 266, 0, '*', 0),
(427, 'fruitshop', 'Fruit Encyclopedia', 'fruit-encyclopedia', '', 'fruit-encyclopedia', 'index.php?option=com_contact&view=categories&id=37', 'component', 1, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"show_base_description":"1","categories_description":"","maxLevel":"-1","show_empty_categories":"1","show_description":"1","show_description_image":"1","show_cat_num_articles":"1","display_num":"","show_headings":"0","filter_field":"hide","show_pagination":"","show_noauth":"","presentation_style":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":" categories-listalphabet","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 261, 262, 0, '*', 0),
(429, 'fruitshop', 'Welcome', 'welcome', 'Fruit store front page', 'welcome', 'index.php?option=com_content&view=article&id=20', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"show_noauth":"","show_title":"0","link_titles":"0","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 259, 260, 0, '*', 0),
(431, 'fruitshop', 'Growers', 'growers', '', 'growers', 'index.php?option=com_content&view=category&layout=blog&id=30', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"maxLevel":"0","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"1","show_cat_num_articles":"","num_leading_articles":"5","num_intro_articles":"0","num_columns":"1","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"alpha","order_date":"","show_pagination":"","show_noauth":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"0","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 263, 264, 0, '*', 0),
(432, 'fruitshop', 'Login ', 'shop-login', '', 'shop-login', 'index.php?option=com_users&view=login', 'component', 1, 1, 1, 25, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"login_redirect_url":"","logindescription_show":"1","login_description":"","login_image":"","logout_redirect_url":"","logoutdescription_show":"1","logout_description":"","logout_image":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 267, 268, 0, '*', 0),
(433, 'fruitshop', 'Directions', 'directions', '', 'directions', 'index.php?option=com_content&view=article&id=13', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 6, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 269, 270, 0, '*', 0),
(435, 'mainmenu', 'Home', 'homepage', '', 'homepage', 'index.php?option=com_content&view=featured', 'component', -2, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"1","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"2","show_noauth":"","show_title":"1","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_readmore":"1","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 1, 2, 0, '*', 0),
(436, 'aboutjoomla', 'Getting Help', 'getting-help', '', 'using-joomla/getting-help', 'index.php?option=com_content&view=article&id=21', 'component', 1, 280, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 232, 233, 0, '*', 0),
(437, 'aboutjoomla', 'Getting Started', 'getting-started', '', 'getting-started', 'index.php?option=com_content&view=article&id=22', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"1","link_titles":"0","show_intro":"","show_category":"0","link_category":"","show_parent_category":"0","link_parent_category":"","show_author":"0","link_author":"","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 51, 52, 0, '*', 0),
(455, 'mainmenu', 'Example Pages', 'example-pages', '', 'example-pages', 'index.php?Itemid=', 'alias', -2, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"aliasoptions":"268","menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 283, 284, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(438, 'mainmenu', 'Weblinks', 'weblinks', '', 'site-map/weblinks', 'index.php?option=com_weblinks&view=categories&id=0', 'component', -2, 294, 2, 21, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","orderby_pri":"","show_pagination":"","show_noauth":"","article-allow_ratings":"","article-allow_comments":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 6, 7, 0, '*', 0),
(439, 'mainmenu', 'Contacts', 'contacts', '', 'site-map/contacts', 'index.php?option=com_contact&view=categories&id=0', 'component', -2, 294, 2, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"categories_description":"","maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","article-allow_ratings":"","article-allow_comments":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 8, 9, 0, '*', 0),
(443, 'aboutjoomla', 'Article Categories', 'article-categories-view', '', 'using-joomla/extensions/modules/content-modules/article-categories-view', 'index.php?option=com_content&view=article&id=3', 'component', 1, 411, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 143, 144, 0, '*', 0),
(446, 'mainmenu', 'Shop', 'shop', '', 'sample-sites/shop', 'index.php?Itemid=', 'alias', -2, 238, 2, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"aliasoptions":"429","menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 274, 275, 0, '*', 0),
(447, 'aboutjoomla', 'Language Switcher', 'language-switcher', '', 'using-joomla/extensions/modules/utility-modules/language-switcher', 'index.php?option=com_content&view=article&id=26', 'component', 1, 414, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 181, 182, 0, '*', 0),
(448, 'mainmenu', 'Site Administrator', 'site-administrator', '', 'site-administrator', 'administrator', 'url', -2, 1, 1, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":""}', 277, 278, 0, '*', 0),
(449, 'usermenu', 'Submit an Article', 'submit-an-article', '', 'submit-an-article', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 279, 280, 0, '*', 0),
(450, 'usermenu', 'Submit a Web Link', 'submit-a-web-link', '', 'submit-a-web-link', 'index.php?option=com_weblinks&view=form&layout=edit', 'component', 1, 1, 1, 21, 0, '0000-00-00 00:00:00', 0, 3, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 281, 282, 0, '*', 0),
(452, 'aboutjoomla', 'Featured Contacts', 'featured-contacts', '', 'using-joomla/extensions/components/contact-component/featured-contacts', 'index.php?option=com_contact&view=featured&id=16', 'component', 1, 270, 5, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"-1","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","filter_field":"","show_pagination":"","show_noauth":"","presentation_style":"sliders","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"1","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 87, 88, 0, '*', 0),
(453, 'aboutjoomla', 'Parameters', 'parameters', '', 'using-joomla/parameters', 'index.php?option=com_content&view=article&id=32', 'component', 1, 280, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_noauth":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"1","link_parent_category":"1","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"1","show_publish_date":"1","show_item_navigation":"1","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 230, 231, 0, '*', 0),
(456, 'aboutjoomla', 'Beez5', 'beez5', '', 'using-joomla/extensions/templates/beez5', 'index.php?option=com_content&view=category&layout=blog&id=70', 'component', 1, 282, 4, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_empty_categories":"","show_description":"1","show_description_image":"","show_category_title":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 192, 197, 0, '*', 0),
(457, 'aboutjoomla', 'Typography Beez5', 'typography-beez-5', '', 'using-joomla/extensions/templates/beez5/typography-beez-5', 'index.php?option=com_content&view=article&id=49', 'component', 1, 456, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 193, 194, 0, '*', 0),
(458, 'aboutjoomla', 'Home Page Beez5', 'home-page-beez5', '', 'using-joomla/extensions/templates/beez5/home-page-beez5', 'index.php?option=com_content&view=featured', 'component', 1, 456, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"","show_empty_categories":"","show_description":"","show_description_image":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"3","num_columns":"3","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"front","order_date":"","show_pagination":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 195, 196, 0, '*', 0),
(459, 'aboutjoomla', 'Article Category', 'article-category', '', 'using-joomla/extensions/modules/content-modules/article-category', 'index.php?option=com_content&view=article&id=4', 'component', 1, 411, 5, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","robots":"","rights":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","secure":0}', 145, 146, 0, '*', 0),
(462, 'fruitshop', 'Add a recipe', 'add-a-recipe', '', 'add-a-recipe', 'index.php?option=com_content&view=form&layout=edit', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 4, '', 116, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":1,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 285, 286, 0, '*', 0),
(463, 'fruitshop', 'Recipes', 'recipes', '', 'recipes', 'index.php?option=com_content&view=category&id=76', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"maxLevel":"0","show_category_title":"1","page_subheading":"","show_empty_categories":"0","show_description":"1","show_description_image":"","show_cat_num_articles":"","display_num":"","show_headings":"","list_show_title":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","filter_field":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_limit":"","show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_readmore":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","show_page_heading":0,"page_title":"","page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0}', 287, 288, 0, '*', 0),
(466, 'mainmenu', 'Home', 'home2047631578', '', 'home2047631578', 'index.php?option=com_content&view=frontpage', 'component', -2, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"num_leading_articles":0,"num_intro_articles":0,"num_columns":2,"num_links":0,"orderby_pri":"","orderby_sec":"front","multi_column_order":1,"show_pagination":2,"show_pagination_results":1,"show_feed_link":1,"show_noauth":0,"show_title":1,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1,"feed_summary":"","page_title":"Welcome to the Frontpage","show_page_title":1,"pageclass_sfx":"","menu_image":-1,"secure":0}', 325, 326, 0, '*', 0),
(467, 'mainmenu', 'Joomla! License', 'joomla-license', '', 'joomla-license', 'index.php?option=com_content&view=article&id=105', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"0","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"1","link_author":"","show_create_date":"1","show_modify_date":"1","show_publish_date":"","show_item_navigation":"0","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 411, 412, 0, '*', 0),
(468, 'othermenu', 'Joomla! Home', 'joomla-home504402062', '', 'joomla-home504402062', 'http://www.joomla.org', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":-1}', 327, 328, 0, '*', 0),
(469, 'othermenu', 'Joomla! Forums', 'joomla-forums521603267', '', 'joomla-forums521603267', 'http://forum.joomla.org', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":-1}', 359, 360, 0, '*', 0),
(470, 'othermenu', 'Joomla! Help', 'joomla-help472669312', '', 'joomla-help472669312', 'http://help.joomla.org', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":-1}', 385, 386, 0, '*', 0),
(471, 'othermenu', 'OSM Home', 'osm-home1403772518', '', 'osm-home1403772518', 'http://www.opensourcematters.org', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":-1}', 413, 414, 0, '*', 0),
(472, 'othermenu', 'Administrator', 'administrator322550744', '', 'administrator322550744', 'administrator/', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":-1}', 435, 436, 0, '*', 0),
(473, 'topmenu', 'News', 'news1475601645', '', 'news1475601645', 'index.php?option=com_content&view=category&layout=blog&id=78', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_description":0,"show_description_image":0,"num_leading_articles":1,"num_intro_articles":4,"num_columns":2,"num_links":4,"orderby_pri":"","orderby_sec":"","show_pagination":2,"show_pagination_results":1,"show_feed_link":1,"show_noauth":"","show_title":"","link_titles":"","show_intro":"","show_section":"","link_section":"","show_category":"","link_category":"","show_author":"","show_create_date":"","show_modify_date":"","show_item_navigation":"","show_readmore":"","show_vote":"","show_icons":"","show_pdf_icon":"","show_print_icon":"","show_email_icon":"","show_hits":"","feed_summary":"","page_title":"News","show_page_title":1,"pageclass_sfx":"","menu_image":-1,"secure":0}', 387, 388, 0, '*', 0),
(474, 'usermenu', 'Your Details', 'your-details1233888687', '', 'your-details1233888687', 'index.php?option=com_user&view=user&task=edit', 'component', -2, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{}', 329, 330, 0, '*', 0),
(475, 'usermenu', 'Logout', 'logout1139483911', '', 'logout1139483911', 'index.php?option=com_user&view=login', 'component', -2, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{}', 415, 416, 0, '*', 0),
(476, 'topmenu', 'About Joomla!', 'about-joomla984487608', '', 'about-joomla984487608', 'index.php?option=com_content&view=article&id=25', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"pageclass_sfx":"","menu_image":-1,"secure":0,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 331, 332, 0, '*', 0),
(477, 'topmenu', 'Features', 'features122486270', '', 'features122486270', 'index.php?option=com_content&view=article&id=22', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"pageclass_sfx":"","menu_image":-1,"secure":0,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 361, 362, 0, '*', 0),
(478, 'topmenu', 'The Community', 'the-community1633529354', '', 'the-community1633529354', 'index.php?option=com_content&view=article&id=27', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"pageclass_sfx":"","menu_image":-1,"secure":0,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 417, 418, 0, '*', 0),
(479, 'keyconcepts', 'Content Layouts', 'content-layouts368553934', '', 'content-layouts368553934', 'index.php?option=com_content&view=article&id=24', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"pageclass_sfx":"","menu_image":-1,"secure":0,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 363, 364, 0, '*', 0),
(480, 'keyconcepts', 'Extensions', 'extensions419992081', '', 'extensions419992081', 'index.php?option=com_content&view=article&id=26', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"pageclass_sfx":"","menu_image":-1,"secure":0,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 333, 334, 0, '*', 0),
(481, 'mainmenu', 'FAQ', 'faq', '', 'faq', 'index.php?option=com_content&view=category&layout=blog&id=81', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"alpha","order_date":"created","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"0","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"1","link_author":"","show_create_date":"1","show_modify_date":"1","show_publish_date":"","show_item_navigation":"0","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"1","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 437, 438, 0, '*', 0),
(482, 'keyconcepts', 'Example Pages', 'example-pages803156744', '', 'example-pages803156744', 'index.php?option=com_content&view=article&id=43', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"pageclass_sfx":"","menu_image":-1,"secure":0,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 389, 390, 0, '*', 0),
(483, 'ExamplePages', 'Section Blog', 'section-blog585187891', '', 'section-blog585187891', 'index.php?option=com_content&view=category&layout=blog&id=81', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_page_title":1,"page_title":"Example of Section Blog layout (FAQ section)","show_description":0,"show_description_image":0,"num_leading_articles":1,"num_intro_articles":4,"num_columns":2,"num_links":4,"show_title":1,"pageclass_sfx":"","menu_image":-1,"secure":0,"orderby_pri":"","orderby_sec":"","show_pagination":2,"show_pagination_results":1,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 335, 336, 0, '*', 0),
(484, 'ExamplePages', 'Section Table', 'section-table1856882707', '', 'section-table1856882707', 'index.php?option=com_content&view=category&id=81', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_page_title":1,"page_title":"Example of Table Blog layout (FAQ section)","show_description":0,"show_description_image":0,"show_categories":1,"show_empty_categories":0,"show_cat_num_articles":1,"show_category_description":1,"pageclass_sfx":"","menu_image":-1,"secure":0,"orderby":"","show_noauth":0,"show_title":1,"nlink_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 365, 366, 0, '*', 0),
(485, 'ExamplePages', 'Category Blog', 'categoryblog1259114071', '', 'categoryblog1259114071', 'index.php?option=com_content&view=category&layout=blog&id=84', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_page_title":1,"page_title":"Example of Category Blog layout (FAQs\\/General category)","show_description":0,"show_description_image":0,"num_leading_articles":1,"num_intro_articles":4,"num_columns":2,"num_links":4,"show_title":1,"pageclass_sfx":"","menu_image":-1,"secure":0,"orderby_pri":"","orderby_sec":"","show_pagination":2,"show_pagination_results":1,"show_noauth":0,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 391, 392, 0, '*', 0),
(486, 'ExamplePages', 'Category Table', 'category-table320252360', '', 'category-table320252360', 'index.php?option=com_content&view=category&id=85', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_page_title":1,"page_title":"Example of Category Table layout (FAQs\\/Languages category)","show_headings":1,"show_date":0,"date_format":"","filter":1,"filter_type":"title","pageclass_sfx":"","menu_image":-1,"secure":0,"orderby_sec":"","show_pagination":1,"show_pagination_limit":1,"show_noauth":0,"show_title":1,"link_titles":0,"show_intro":1,"show_section":0,"link_section":0,"show_category":0,"link_category":0,"show_author":1,"show_create_date":1,"show_modify_date":1,"show_item_navigation":0,"show_readmore":1,"show_vote":0,"show_icons":1,"show_pdf_icon":1,"show_print_icon":1,"show_email_icon":1,"show_hits":1}', 419, 420, 0, '*', 0),
(487, 'mainmenu', 'The News', 'the-news', '', 'the-news', 'index.php?option=com_content&view=categories&id=14', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_base_description":"","categories_description":"","maxLevelcat":"","show_empty_categories_cat":"","show_subcat_desc_cat":"","show_cat_num_articles_cat":"","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"4","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_pagination_limit":"","filter_field":"","show_headings":"","list_show_date":"","date_format":"","list_show_hits":"","list_show_author":"","display_num":"10","show_title":"1","link_titles":"0","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"1","link_author":"","show_create_date":"1","show_modify_date":"1","show_publish_date":"","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"The News","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 393, 394, 0, '*', 0),
(488, 'usermenu', 'Submit an Article', 'submit-an-article874466494', '', 'submit-an-article874466494', 'index.php?option=com_content&view=article&layout=form', 'component', -2, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{}', 367, 368, 0, '*', 0),
(489, 'usermenu', 'Submit a Web Link', 'submit-a-web-link1250884756', '', 'submit-a-web-link1250884756', 'index.php?option=com_weblinks&view=weblink&layout=form', 'component', -2, 1, 1, 21, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{}', 395, 396, 0, '*', 0),
(490, 'mainmenu', 'Typography', 'typography', '', 'typography', 'index.php?option=com_content&view=article&id=49', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 369, 370, 0, '*', 0),
(491, 'magazine', 'Home', 'home-page', '', 'home-page', 'index.php?option=com_content&view=featured', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"featured_categories":[""],"layout_type":"blog","num_leading_articles":"0","num_intro_articles":"0","num_columns":"2","num_links":"0","multi_column_order":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Experience the differences on Magazine here with Teline Joomlart 3.x Template","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"Live update with your Magazine for Jooma 3.x Template. ","menu-meta_keywords":" Joomla 3.x News Template, Joomla 3.x Magazine Template","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 337, 358, 1, '*', 0),
(492, 'magazine', 'News', 'news', '', 'home-page/news', 'index.php?option=com_content&view=category&layout=blog&id=77', 'component', 1, 491, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"8","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 350, 357, 0, '*', 0),
(493, 'magazine', 'Latest', 'latest', '', 'home-page/news/latest', 'index.php?option=com_content&view=category&layout=blog&id=78', 'component', 1, 492, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 351, 352, 0, '*', 0),
(494, 'magazine', 'Newsflash', 'newsflash', '', 'home-page/news/newsflash', 'index.php?option=com_content&view=category&layout=blog&id=79', 'component', 1, 492, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"1","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 353, 354, 0, '*', 0),
(495, 'magazine', 'Hot topic', 'hot-topic', '', 'home-page/news/hot-topic', 'index.php?option=com_content&view=category&layout=blog&id=80', 'component', 1, 492, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 355, 356, 0, '*', 0),
(496, 'magazine', 'FAQs', 'faqs', '', 'home-page/faqs', 'index.php?option=com_content&view=category&layout=blog&id=81', 'component', 1, 491, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"8","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 348, 349, 0, '*', 0),
(497, 'magazine', 'Current Users', 'current-users', '', 'home-page/current-users', 'index.php?option=com_content&view=category&layout=blog&id=83', 'component', 1, 491, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 342, 343, 0, '*', 0),
(498, 'magazine', 'New to Joomla!', 'new-to-joomla', '', 'home-page/new-to-joomla', 'index.php?option=com_content&view=category&layout=blog&id=82', 'component', 1, 491, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 340, 341, 0, '*', 0),
(499, 'magazine', 'General', 'general', '', 'home-page/general', 'index.php?option=com_content&view=category&layout=blog&id=84', 'component', 1, 491, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 346, 347, 0, '*', 0),
(500, 'magazine', 'Languages', 'languages', '', 'home-page/languages', 'index.php?option=com_content&view=category&layout=blog&id=85', 'component', 1, 491, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"1","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 344, 345, 0, '*', 0),
(501, 'magazine', 'The CMS', 'the-cms', '', 'home-page/the-cms', 'index.php?option=com_content&view=category&layout=blog&id=19', 'component', 1, 491, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"4","num_columns":"2","num_links":"0","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 338, 339, 0, '*', 0),
(502, 'magazine', 'Sport', 'sport', '', 'sport', 'index.php?option=com_content&view=category&layout=blog&id=90', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"6","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Sport","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 489, 502, 0, '*', 0),
(503, 'magazine', 'Football', 'football', '', 'sport/football', 'index.php?option=com_content&view=category&layout=blog&id=91', 'component', 1, 502, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 490, 491, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(504, 'magazine', 'Cricket', 'cricket', '', 'sport/cricket', 'index.php?option=com_content&view=category&layout=blog&id=92', 'component', 1, 502, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 498, 499, 0, '*', 0),
(505, 'magazine', 'Tennis', 'tennis', '', 'sport/tennis', 'index.php?option=com_content&view=category&layout=blog&id=93', 'component', 1, 502, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 496, 497, 0, '*', 0),
(506, 'magazine', 'Motorsport', 'motorsport', '', 'sport/motorsport', 'index.php?option=com_content&view=category&layout=blog&id=94', 'component', 1, 502, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 494, 495, 0, '*', 0),
(507, 'magazine', 'Horse racing', 'horse-racing', '', 'sport/horse-racing', 'index.php?option=com_content&view=category&layout=blog&id=95', 'component', 1, 502, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 492, 493, 0, '*', 0),
(508, 'magazine', 'Boxing', 'boxing', '', 'sport/boxing', 'index.php?option=com_content&view=category&layout=blog&id=96', 'component', 1, 502, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 500, 501, 0, '*', 0),
(509, 'magazine', 'Artist', 'artist', '', 'artist', 'index.php?option=com_content&view=category&layout=blog&id=97', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"","link_titles":"","show_intro":"","show_category":"0","link_category":"0","show_parent_category":"","link_parent_category":"","show_author":"0","link_author":"0","show_create_date":"0","show_modify_date":"0","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Artist","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 475, 488, 0, '*', 0),
(510, 'magazine', 'Art', 'art', '', 'artist/art', 'index.php?option=com_content&view=category&layout=blog&id=98', 'component', 1, 509, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 476, 477, 0, '*', 0),
(511, 'magazine', 'Architecture', 'architecture', '', 'artist/architecture', 'index.php?option=com_content&view=category&layout=blog&id=99', 'component', 1, 509, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 486, 487, 0, '*', 0),
(512, 'magazine', 'Design', 'design', '', 'artist/design', 'index.php?option=com_content&view=category&layout=blog&id=100', 'component', 1, 509, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 484, 485, 0, '*', 0),
(513, 'magazine', 'Photography', 'photography', '', 'artist/photography', 'index.php?option=com_content&view=category&layout=blog&id=101', 'component', 1, 509, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 482, 483, 0, '*', 0),
(514, 'magazine', 'Graphics', 'graphics', '', 'artist/graphics', 'index.php?option=com_content&view=category&layout=blog&id=102', 'component', 1, 509, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 480, 481, 0, '*', 0),
(515, 'magazine', '3D Computer Graphics', '3d-computer-graphics', '', 'artist/3d-computer-graphics', 'index.php?option=com_content&view=category&layout=blog&id=103', 'component', 1, 509, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 478, 479, 0, '*', 0),
(516, 'magazine', 'Travel', 'travel', '', 'travel', 'index.php?option=com_content&view=category&layout=blog&id=104', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Travel","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 465, 472, 0, '*', 0),
(517, 'magazine', 'Getaways', 'getaways', '', 'travel/getaways', 'index.php?option=com_content&view=category&layout=blog&id=105', 'component', 1, 516, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 466, 467, 0, '*', 0),
(518, 'magazine', 'Travel Tips', 'travel-tips959679384', '', 'travel/travel-tips959679384', 'index.php?option=com_content&view=category&layout=blog&id=106', 'component', 1, 516, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 470, 471, 0, '*', 0),
(519, 'magazine', 'Business Travel', 'business-travel', '', 'travel/business-travel', 'index.php?option=com_content&view=category&layout=blog&id=107', 'component', 1, 516, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 468, 469, 0, '*', 0),
(520, 'magazine', 'Life and Style', 'life-and-style', '', 'life-and-style', 'index.php?option=com_content&view=category&layout=blog&id=108', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"1","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"8","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Life and Style","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 447, 460, 0, '*', 0),
(521, 'magazine', 'Fashion & Beauty', 'fashion-a-beauty', '', 'life-and-style/fashion-a-beauty', 'index.php?option=com_content&view=category&layout=blog&id=109', 'component', 1, 520, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 448, 449, 0, '*', 0),
(522, 'magazine', 'Food & Drink', 'food-a-drink', '', 'life-and-style/food-a-drink', 'index.php?option=com_content&view=category&layout=blog&id=110', 'component', 1, 520, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 452, 453, 0, '*', 0),
(523, 'magazine', 'Homes & Gardens', 'homes-a-gardens', '', 'life-and-style/homes-a-gardens', 'index.php?option=com_content&view=category&layout=blog&id=111', 'component', 1, 520, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 450, 451, 0, '*', 0),
(524, 'magazine', 'Shop', 'shop', '', 'life-and-style/shop', 'index.php?option=com_content&view=category&layout=blog&id=112', 'component', 1, 520, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 454, 455, 0, '*', 0),
(525, 'magazine', 'Mother & Children', 'mother-a-children', '', 'life-and-style/mother-a-children', 'index.php?option=com_content&view=category&layout=blog&id=113', 'component', 1, 520, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 456, 457, 0, '*', 0),
(526, 'magazine', 'Wife & husband', 'wife-a-husband', '', 'life-and-style/wife-a-husband', 'index.php?option=com_content&view=category&layout=blog&id=114', 'component', 1, 520, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 458, 459, 0, '*', 0),
(527, 'magazine', 'Health', 'health', '', 'health', 'index.php?option=com_content&view=category&layout=blog&id=115', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"8","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"0","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Health","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 439, 446, 0, '*', 0),
(528, 'magazine', 'What Ails You', 'what-ails-you', '', 'health/what-ails-you', 'index.php?option=com_content&view=category&layout=blog&id=116', 'component', 1, 527, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 440, 441, 0, '*', 0),
(529, 'magazine', 'Diet & Fitness', 'diet-a-fitness', '', 'health/diet-a-fitness', 'index.php?option=com_content&view=category&layout=blog&id=117', 'component', 1, 527, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 444, 445, 0, '*', 0),
(530, 'magazine', 'You & Your Family', 'you-a-your-family', '', 'health/you-a-your-family', 'index.php?option=com_content&view=category&layout=blog&id=118', 'component', 1, 527, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 442, 443, 0, '*', 0),
(531, 'magazine', 'Entertainment', 'entertainment', '', 'entertainment', 'index.php?option=com_content&view=category&layout=blog&id=119', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"1","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"8","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Entertainment","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 421, 434, 0, '*', 0),
(532, 'magazine', 'Movies', 'movies', '', 'entertainment/movies', 'index.php?option=com_content&view=category&layout=blog&id=120', 'component', 1, 531, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 422, 423, 0, '*', 0),
(533, 'magazine', 'TV', 'tv', '', 'entertainment/tv', 'index.php?option=com_content&view=category&layout=blog&id=121', 'component', 1, 531, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 424, 425, 0, '*', 0),
(534, 'magazine', 'Music', 'music', '', 'entertainment/music', 'index.php?option=com_content&view=category&layout=blog&id=122', 'component', 1, 531, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 426, 427, 0, '*', 0);
INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`) VALUES
(535, 'magazine', 'Books', 'books', '', 'entertainment/books', 'index.php?option=com_content&view=category&layout=blog&id=123', 'component', 1, 531, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 428, 429, 0, '*', 0),
(536, 'magazine', 'Games', 'games', '', 'entertainment/games', 'index.php?option=com_content&view=category&layout=blog&id=124', 'component', 1, 531, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 430, 431, 0, '*', 0),
(537, 'magazine', 'Theatre', 'theatre', '', 'entertainment/theatre', 'index.php?option=com_content&view=category&layout=blog&id=125', 'component', 1, 531, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 432, 433, 0, '*', 0),
(538, 'magazine', 'Technology', 'technology', '', 'technology', 'index.php?option=com_content&view=category&layout=blog&id=133', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"8","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"Technology","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 397, 410, 0, '*', 0),
(539, 'magazine', 'Personal Tech', 'personal-tech', '', 'technology/personal-tech', 'index.php?option=com_content&view=category&layout=blog&id=134', 'component', 1, 538, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"0","show_category":"0","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 398, 399, 0, '*', 0),
(540, 'magazine', 'Business Tech', 'business-tech', '', 'technology/business-tech', 'index.php?option=com_content&view=category&layout=blog&id=135', 'component', 1, 538, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 400, 401, 0, '*', 0),
(541, 'magazine', 'Space', 'space', '', 'technology/space', 'index.php?option=com_content&view=category&layout=blog&id=136', 'component', 1, 538, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 402, 403, 0, '*', 0),
(542, 'magazine', 'Science', 'science', '', 'technology/science', 'index.php?option=com_content&view=category&layout=blog&id=137', 'component', 1, 538, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 404, 405, 0, '*', 0),
(543, 'magazine', 'Green Tech', 'green-tech', '', 'technology/green-tech', 'index.php?option=com_content&view=category&layout=blog&id=138', 'component', 1, 538, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 406, 407, 0, '*', 0),
(544, 'magazine', 'Security', 'security', '', 'technology/security', 'index.php?option=com_content&view=category&layout=blog&id=139', 'component', 1, 538, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 408, 409, 0, '*', 0),
(545, 'othermenu', 'JoomlArt', 'joomlart1421343713', '', 'joomlart1421343713', 'http://www.joomlart.com', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":-1}', 461, 462, 0, '*', 0),
(546, 'othermenu', 'com_javoice', 'ja-voice1215901392', '', 'ja-voice1215901392', 'http://javoice.joomlart.com', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":-1}', 473, 474, 0, '*', 0),
(547, 'magazine', 'World', 'world', '', 'world', 'index.php?option=com_content&view=category&layout=blog&id=126', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"1","num_intro_articles":"8","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"-1","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"World","show_page_heading":1,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 371, 384, 0, '*', 0),
(548, 'magazine', 'Europe', 'europe', '', 'world/europe', 'index.php?option=com_content&view=category&layout=blog&id=127', 'component', 1, 547, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 372, 373, 0, '*', 0),
(549, 'magazine', 'U.S. Politics', 'us-politics', '', 'world/us-politics', 'index.php?option=com_content&view=category&layout=blog&id=128', 'component', 1, 547, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 374, 375, 0, '*', 0),
(550, 'magazine', 'Middle East', 'middle-east', '', 'world/middle-east', 'index.php?option=com_content&view=category&layout=blog&id=129', 'component', 1, 547, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 376, 377, 0, '*', 0),
(551, 'magazine', 'Africa', 'africa', '', 'world/africa', 'index.php?option=com_content&view=category&layout=blog&id=130', 'component', 1, 547, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"1","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 378, 379, 0, '*', 0),
(552, 'magazine', 'Science', 'science', '', 'world/science', 'index.php?option=com_content&view=category&layout=blog&id=131', 'component', 1, 547, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"1","link_category":"1","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"1","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 380, 381, 0, '*', 0),
(553, 'magazine', 'Pacific', 'pacific', '', 'world/pacific', 'index.php?option=com_content&view=category&layout=blog&id=132', 'component', 1, 547, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"layout_type":"blog","show_category_title":"","show_description":"0","show_description_image":"0","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"0","num_intro_articles":"20","num_columns":"2","num_links":"0","multi_column_order":"0","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"2","show_pagination_results":"1","show_title":"1","link_titles":"1","show_intro":"1","show_category":"0","link_category":"0","show_parent_category":"0","link_parent_category":"0","show_author":"1","link_author":"1","show_create_date":"1","show_modify_date":"0","show_publish_date":"0","show_item_navigation":"0","show_vote":"0","show_readmore":"0","show_readmore_title":"0","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"0","show_noauth":"0","show_feed_link":"1","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"-1","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 382, 383, 0, '*', 0),
(554, 'mainmenu', '10 Things you MUST know about Teline III', '10-things-you-must-know-about-teline-iii', '', '10-things-you-must-know-about-teline-iii', 'index.php?option=com_content&view=article&id=445', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"1","show_print_icon":"1","show_email_icon":"1","show_hits":"","show_noauth":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 463, 464, 0, '*', 0),
(560, 'topmega', 'Member', 'member', '', 'member', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"mod","mega_subcontent_mod_modules":["16"]}', 15, 16, 0, '*', 0),
(561, 'topmega', 'Features', 'features', '', 'features', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"mod","mega_subcontent_mod_modules":["103"]}', 13, 14, 0, '*', 0),
(559, 'topmega', 'Twitter', 'twitter', '', 'twitter', '#', 'url', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"mod","mega_subcontent_mod_modules":["80"]}', 17, 18, 0, '*', 0),
(583, 'main', 'COM_JAEXTMANAGER', 'com-jaextmanager', '', 'com-jaextmanager', 'index.php?option=com_jaextmanager', 'component', 0, 1, 1, 10034, 0, '0000-00-00 00:00:00', 0, 1, 'components/com_jaextmanager/assets/images/jauc.png', 0, NULL, 503, 504, 0, '', 1),
(563, 'topmega', 'More info', 'more-info', '', 'more-info', '', 'separator', 1, 1, 1, 0, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 289, 298, 0, '*', 0),
(564, 'topmega', 'Template info', 'template-info', '', 'more-info/template-info', 'http://www.joomlart.com/joomla/templates/ja-teline-iii-v2', 'url', 1, 563, 2, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 290, 291, 0, '*', 0),
(565, 'topmega', 'Module Positions', 'module-positions', '', 'more-info/module-positions', '?tp=1', 'url', 1, 563, 2, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 292, 293, 0, '*', 0),
(566, 'topmega', 'Userguide', 'userguide', '', 'more-info/userguide', '#', 'url', 1, 563, 2, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 294, 295, 0, '*', 0),
(567, 'topmega', 'Extensions', 'extensions', '', 'more-info/extensions', 'http://www.joomlart.com/joomla/templates/ja-teline-iii-v2', 'url', 1, 563, 2, 0, 0, '0000-00-00 00:00:00', 1, 1, '', 0, '{"menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 296, 297, 0, '*', 0),
(568, 'mainmenu', 'Contact us', 'contact-us-menu', '', 'contact-us-menu', 'index.php?option=com_contact&view=contact&id=1', 'component', 1, 1, 1, 8, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"presentation_style":"","show_contact_category":"","show_contact_list":"","show_name":"","show_position":"","show_email":"","show_street_address":"","show_suburb":"","show_state":"","show_postcode":"","show_country":"","show_telephone":"","show_mobile":"","show_fax":"","show_webpage":"","show_misc":"","show_image":"","allow_vcard":"","show_articles":"","show_links":"","linka_name":"","linkb_name":"","linkc_name":"","linkd_name":"","linke_name":"","show_email_form":"","show_email_copy":"","banned_email":"","banned_subject":"","banned_text":"","validate_session":"","custom_reply":"","redirect":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 299, 300, 0, '*', 0),
(569, 'main', 'COM_FINDER', 'com-finder', '', 'com-finder', 'index.php?option=com_finder', 'component', 0, 1, 1, 10017, 0, '0000-00-00 00:00:00', 0, 1, 'class:finder', 0, NULL, 301, 302, 0, '', 1),
(570, 'menu', 'com_finder', 'Smart Search', '', 'Smart Search', 'index.php?option=com_finder', 'component', 0, 1, 1, 27, 0, '0000-00-00 00:00:00', 0, 0, 'class:finder', 0, '', 41, 42, 0, '*', 1),
(571, 'magazine', 'Explore', 'explore', '', 'explore', 'index.php?option=com_content&view=category&layout=blog&id=19', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"layout_type":"blog","show_category_title":"","show_description":"","show_description_image":"","maxLevel":"","show_empty_categories":"","show_no_articles":"","show_subcat_desc":"","show_cat_num_articles":"","page_subheading":"","num_leading_articles":"","num_intro_articles":"","num_columns":"","num_links":"","multi_column_order":"","show_subcategory_content":"","orderby_pri":"","orderby_sec":"","order_date":"","show_pagination":"","show_pagination_results":"","show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_readmore":"","show_readmore_title":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","show_feed_link":"","feed_summary":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 303, 314, 0, '*', 0),
(572, 'magazine', 'Menu Style', 'mega-style', '', 'explore/mega-style', 'index.php?option=com_content&view=article&id=47', 'component', 1, 571, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 304, 313, 0, '*', 0),
(573, 'magazine', 'Split Menu', 'split-menu', '', 'explore/mega-style/split-menu', 'index.php?option=com_content&view=article&id=53', 'component', 1, 572, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 305, 306, 0, '*', 0),
(574, 'magazine', 'Dropline Menu', 'dropline-menu', '', 'explore/mega-style/dropline-menu', 'index.php?option=com_content&view=article&id=8', 'component', 1, 572, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 307, 308, 0, '*', 0),
(575, 'magazine', 'CSS Menu', 'css-menu', '', 'explore/mega-style/css-menu', 'index.php?option=com_content&view=article&id=231', 'component', 1, 572, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 309, 310, 0, '*', 0),
(576, 'magazine', 'Mega Menu', 'mega-menu', '', 'explore/mega-style/mega-menu', 'index.php?option=com_content&view=article&id=159', 'component', 1, 572, 3, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 116, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 311, 312, 0, '*', 0),
(577, 'magazine', 'Layout', 'layout', '', 'layout', 'index.php?option=com_content&view=article&id=325', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 315, 322, 0, '*', 0),
(578, 'magazine', 'Content + Right', 'content-right', '', 'layout/content-right', 'index.php?option=com_content&view=article&id=446', 'component', 1, 577, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 316, 317, 0, '*', 0),
(579, 'magazine', 'Full width', 'full-width', '', 'layout/full-width', 'index.php?option=com_content&view=article&id=448', 'component', 1, 577, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 318, 319, 0, '*', 0),
(580, 'magazine', '3 Columns', '3-columns', '', 'layout/3-columns', 'index.php?option=com_content&view=article&id=447', 'component', 1, 577, 2, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 320, 321, 0, '*', 0),
(581, 'main', 'com_joomlaupdate', 'com-joomlaupdate', '', 'com-joomlaupdate', 'index.php?option=com_joomlaupdate', 'component', 0, 1, 1, 10032, 0, '0000-00-00 00:00:00', 0, 1, 'class:component', 0, NULL, 323, 324, 0, '', 1),
(23, 'main', 'com_tags', 'Tags', '', 'Tags', 'index.php?option=com_tags', 'component', 0, 1, 1, 29, 0, '0000-00-00 00:00:00', 0, 1, 'class:tags', 0, '', 45, 46, 0, '', 1),
(584, 'mainmenu', 'Demo Joomla Tags', 'demo-joomla-tags', '', 'demo-joomla-tags', 'index.php?option=com_tags&view=tag&id[0]=3&tag_list_language_filter=', 'component', 1, 1, 1, 29, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_tag_title":"","tag_list_show_tag_image":"","tag_list_show_tag_description":"","tag_list_image":"","tag_list_description":"","show_tag_num_items":"","tag_list_orderby":"","tag_list_orderby_direction":"","tag_list_show_item_image":"","tag_list_show_item_description":"","tag_list_item_maximum_characters":0,"filter_field":"","show_pagination_limit":"","show_pagination":"","show_pagination_results":"","return_any_or_all":"","include_children":"","maximum":200,"show_feed_link":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 505, 506, 0, '*', 0),
(585, 'mainmenu', 'Demo Joomla Tag Item', 'demo-joomla-tag-item', '', 'demo-joomla-tag-item', 'index.php?option=com_content&view=article&id=349', 'component', 1, 1, 1, 22, 0, '0000-00-00 00:00:00', 0, 1, '', 0, '{"show_title":"","link_titles":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_vote":"","show_tags":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_hits":"","show_noauth":"","urls_position":"","menu-anchor_title":"","menu-anchor_css":"","menu_image":"","menu_text":1,"page_title":"","show_page_heading":0,"page_heading":"","pageclass_sfx":"","menu-meta_description":"","menu-meta_keywords":"","robots":"","secure":0,"mega_showtitle":"1","mega_desc":"","mega_cols":"1","mega_group":"0","mega_width":"","mega_colw":"","mega_colxw":"","mega_class":"","mega_subcontent":"0"}', 507, 508, 0, '*', 0);

DROP TABLE IF EXISTS `#__menu_types`;
CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM ;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`) VALUES
(2, 'usermenu', 'User Menu', 'A Menu for logged in Users'),
(3, 'top', 'Top', 'Links for major types of users'),
(4, 'aboutjoomla', 'About Joomla', 'All about Joomla!'),
(5, 'parks', 'Australian Parks', 'Main menu for a site about Australian  parks'),
(6, 'mainmenu', 'Main Menu', 'Simple Home Menu'),
(7, 'fruitshop', 'Fruit Shop', 'Menu for the sample shop site.'),
(8, 'topmenu', 'Top Menu', 'Top level navigation'),
(9, 'othermenu', 'Resources', 'Additional links'),
(10, 'ExamplePages', 'Example Pages', 'Example Pages'),
(11, 'keyconcepts', 'Key Concepts', 'This describes some critical information for new Users.'),
(12, 'magazine', 'magazine', ''),
(13, 'topmega', 'topmega', 'topmega');

DROP TABLE IF EXISTS `#__messages`;
CREATE TABLE `#__messages` (
  `message_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id_from` int(10) unsigned NOT NULL DEFAULT '0',
  `user_id_to` int(10) unsigned NOT NULL DEFAULT '0',
  `folder_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `date_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `priority` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(255) NOT NULL DEFAULT '',
  `message` text NOT NULL,
  PRIMARY KEY (`message_id`),
  KEY `useridto_state` (`user_id_to`,`state`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__messages_cfg`;
CREATE TABLE `#__messages_cfg` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `cfg_name` varchar(100) NOT NULL DEFAULT '',
  `cfg_value` varchar(255) NOT NULL DEFAULT '',
  UNIQUE KEY `idx_user_var_name` (`user_id`,`cfg_name`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__modules`;
CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) NOT NULL DEFAULT '',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned DEFAULT NULL,
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM ;

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(1, 'Main Menu', '', '', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"mainmenu","base":"","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(2, 'Login', '', '', 1, 'login', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 1, '', 1, '*'),
(3, 'Popular Articles', '', '', 3, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_popular', 3, 1, '{"count":"5","catid":"","user_id":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(4, 'Recently Added Articles', '', '', 4, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_latest', 3, 1, '{"count":"5","ordering":"c_dsc","catid":"","user_id":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(6, 'Unread Messages', '', '', 1, 'header', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_unread', 3, 1, '', 1, '*'),
(8, 'Toolbar', '', '', 1, 'toolbar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_toolbar', 3, 1, '', 1, '*'),
(9, 'Quick Icons', '', '', 1, 'icon', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_quickicon', 3, 1, '', 1, '*'),
(10, 'Logged-in Users', '', '', 2, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_logged', 3, 1, '', 1, '*'),
(12, 'Admin Menu', '', '', 1, 'menu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 3, 1, '{"layout":"","moduleclass_sfx":"","shownew":"1","showhelp":"1","cache":"0"}', 1, '*'),
(13, 'Admin Submenu', '', '', 1, 'submenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_submenu', 3, 1, '', 1, '*'),
(14, 'User Status', '', '', 2, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_status', 3, 1, '', 1, '*'),
(15, 'Title', '', '', 1, 'title', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_title', 3, 1, '', 1, '*'),
(16, 'member', '', '', 1, 'mega-item ', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_login', 1, 0, '{"pretext":"","posttext":"","login":"491","logout":"491","greeting":"1","name":"0","usesecure":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(17, 'Breadcrumbs', '', '', 1, 'position-2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_breadcrumbs', 1, 1, '{"moduleclass_sfx":"","showHome":"1","homeText":"Home","showComponent":"1","separator":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(18, 'Banners', '', '', 1, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_banners', 1, 1, '{"target":"1","count":"1","cid":"1","catid":["27"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(19, 'User Menu', '', '', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 2, 1, '{"menutype":"usermenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(20, 'Top', '', '', 1, 'footnav', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 0, '{"menutype":"top","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(22, 'Australian Parks ', '', '', 2, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"parks","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, 'en-GB'),
(23, 'About Joomla!', '', '', 1, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","base":"","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"_menu","cache":"0","cache_time":"900","cachemode":"itemid","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(68, 'About Parks', '', '<p>The Parks sample site is designed as a simple site that can be routinely updated from the front end of Joomla!.</p><p>As a site, it is largely focused on a blog which can be updated using the front end article submission.</p><p>New weblinks can also be added through the front end.</p><p>A simple image gallery uses com_content with thumbnails displayed in a blog layout and full size images shown in article layout.</p><p>The Parks site features the language switch module. All of the content and modules are tagged as English (en-GB). If a second language pack is added with sample data this can be filtered using the language switch.</p><p>Parks uses HTML5 which is a major web standard (along with XHTML which is used in other areas of sample data).</p>', 2, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(67, 'Extensions', '', '', 2, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"6","showAllChildren":"0","tag_id":"","class_sfx":"-menu","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(25, 'Site Map', '', '', 1, 'sitemapload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 0, '{"menutype":"mainmenu","startLevel":"2","endLevel":"3","showAllChildren":"1","tag_id":"","class_sfx":"sitemap","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(26, 'This Site', '', '', 5, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"1","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"_menu","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(27, 'Archived Articles', '', '', 1, 'archiveload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_archive', 1, 1, '{"count":"10","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(28, 'Latest News', '', '', 1, 'articleslatestload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_latest', 1, 1, '{"catid":["19"],"count":"5","ordering":"c_dsc","user_id":"0","show_featured":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(29, 'Articles Most Read', '', '', 1, 'articlespopularload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_popular', 1, 1, '{"show_front":"1","count":"5","catid":["26","29"],"layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(30, 'Feed Display', '', '', 1, 'feeddisplayload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_feed', 1, 1, '{"rssurl":"http:\\/\\/community.joomla.org\\/blogs\\/community.feed?type=rss","rssrtl":"0","rsstitle":"1","rssdesc":"1","rssimage":"1","rssitems":"3","rssitemdesc":"1","word_count":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(31, 'News Flash: Latest', '', '', 1, 'newsflashload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_news', 1, 1, '{"catid":["20"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"1","count":"1","ordering":"a.publish_up","layout":"horizontal","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(32, 'News Flash: Random', '', '', 1, 'newsflashload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_news', 1, 1, '{"catid":["19"],"image":"0","item_title":"0","link_titles":"","item_heading":"h4","showLastSeparator":"1","readmore":"0","count":"1","ordering":"rand()","layout":"vertical","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(33, 'Random Image', '', '', 1, 'randomimageload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_random_image', 1, 1, '{"type":"jpg","folder":"images\\/sampledata\\/parks\\/animals","link":"","width":"180","height":"","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(34, 'Articles Related Items', '', '', 1, 'relateditemsload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_related_items', 1, 1, '{"showDate":"0","layout":"","moduleclass_sfx":"","owncache":"1"}', 0, '*'),
(35, 'Search', '', '', 1, 'searchload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_search', 1, 1, '{"width":"20","text":"","button":"","button_pos":"right","imagebutton":"","button_text":"","set_itemid":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(36, 'Statistics', '', '', 1, 'statisticsload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_stats', 1, 1, '{"serverinfo":"1","siteinfo":"1","counter":"1","increase":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(37, 'Syndicate Feeds', '', '', 1, 'syndicateload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_syndicate', 1, 1, '{"text":"Feed Entries","format":"rss","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(38, 'Users Latest', '', '', 1, 'userslatestload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_users_latest', 1, 1, '{"shownumber":"5","linknames":"0","linktowhat":"0","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"static"}', 0, '*'),
(39, 'Who\'s Online', '', '', 3, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_whosonline', 1, 1, '{"showmode":"2","linknames":"0","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(40, 'Wrapper', '', '', 1, 'wrapperload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_wrapper', 1, 1, '{"url":"http:\\/\\/fsf.org","add":"1","scrolling":"auto","width":"100%","height":"200","height_auto":"1","target":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(41, 'Footer', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_footer', 1, 0, '{"layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(44, 'Login', '', '', 1, 'loginload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_login', 1, 1, '{"pretext":"","posttext":"","login":"280","logout":"280","greeting":"1","name":"0","usesecure":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(45, 'Menu', '', '', 1, 'menuload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"mainmenu","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(47, 'Latest Park Blogs', '', '', 6, 'position-7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_latest', 1, 1, '{"count":"5","ordering":"c_dsc","user_id":"0","show_front":"1","catid":"35","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, 'en-GB'),
(48, 'Custom HTML', '', '<p>This is a custom html module. That means you can enter whatever content you want.</p>', 1, 'customload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(49, 'Weblinks', '', '', 1, 'weblinksload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_weblinks', 1, 1, '{"catid":"32","count":"5","ordering":"title","direction":"asc","target":"3","description":"0","hits":"0","count_clicks":"0","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(52, 'Breadcrumbs', '', '', 1, 'breadcrumbs ', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_breadcrumbs', 1, 1, '{"showHere":"1","showHome":"1","homeText":"Home","showLast":"1","separator":"","layout":"_:default","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(61, 'Articles Categories', '', '', 1, 'articlescategoriesload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_categories', 1, 1, '{"parent":"29","show_description":"0","show_children":"0","maxlevel":"0","count":"0","layout":"","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(56, 'Advertisement', '', '', 1, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 1, '{"target":"1","count":"4","cid":"0","catid":["140"],"tag_search":"0","ordering":"0","header_text":"Featured Links:","footer_text":"<a href=\\"http:\\/\\/www.joomla.org\\">Ads by Joomla!<\\/a>","layout":"_:default","moduleclass_sfx":"_text","cache":"0","cache_time":"900","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(57, 'Fruit Shop', '', '', 3, 'position-5', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 1, '{"menutype":"fruitshop","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"","moduleclass_sfx":"","cache":"0","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(58, 'Special!', '', '<h1>This week we have a special, half price on delicious oranges!</h1><div>Only for our special customers!</div><div>Use the code: Joomla! when ordering</div><p><em>This module can only be seen by people in the customers group or higher.</em></p>', 1, 'position-12', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 4, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(62, 'Language Switcher', '', '', 3, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(63, 'Search', '', '', 1, 'search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_search', 1, 0, '{"label":"","width":"20","text":"","button":"","button_pos":"right","imagebutton":"1","button_text":"","set_itemid":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(64, 'Language Switcher', '', '', 1, 'languageswitcherload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_languages', 1, 1, '{"header_text":"","footer_text":"","image":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(65, 'About Fruit Shop', '', '<p>The Fruit Shop site shows a number of Joomla! features.</p><p>The template uses classes in cascading style sheets to change the layout of items, such as creating the horizontal alphabetical list in the Fruit Encyclopedia.</p><p> </p>', 1, 'position-4', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(69, 'Articles Category', '', '', 1, 'articlescategoryload', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_articles_category', 1, 1, '{"mode":"normal","show_on_article_page":"1","show_front":"show","count":"0","category_filtering_type":"1","catid":["72"],"show_child_category_articles":"0","levels":"1","author_filtering_type":"1","created_by":[""],"author_alias_filtering_type":"1","created_by_alias":[""],"excluded_articles":"","date_filtering":"off","date_field":"a.created","start_date_range":"","end_date_range":"","relative_date":"30","article_ordering":"a.title","article_ordering_direction":"ASC","article_grouping":"none","article_grouping_direction":"ksort","month_year_format":"F Y","item_heading":"4","show_date":"0","show_date_field":"created","show_date_format":"Y-m-d H:i:s","show_category":"0","show_hits":"0","show_author":"0","show_introtext":"0","introtext_limit":"100","layout":"","moduleclass_sfx":"","owncache":"1","cache_time":"900"}', 0, '*'),
(70, 'Search (Atomic Template)', '', '', 1, 'atomic-search', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_search', 1, 0, '{"width":"20","text":"","button":"","button_pos":"right","imagebutton":"","button_text":"","set_itemid":"","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(71, 'Top Menu (Atomic Template)', '', '', 1, 'atomic-topmenu', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_menu', 1, 0, '{"menutype":"aboutjoomla","startLevel":"1","endLevel":"0","showAllChildren":"0","tag_id":"","class_sfx":"","window_open":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"itemid"}', 0, '*'),
(72, 'Top Quote (Atomic Template)', '', '<hr />\r\n<h2 class="alt">Powerful Content Management and a Simple Extensible Framework.</h2>\r\n<hr />', 1, 'atomic-topquote', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(73, 'Bottom Left Column (Atomic Template)', '', '<h6>This is a nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', 1, 'atomic-bottomleft', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(74, 'Bottom Middle Column (Atomic Template)', '', '<h6>This is another nested column</h6>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.</p>', 1, 'atomic-bottommiddle', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(75, 'Sidebar (Atomic Template)', '', '<h3>A <span class="alt">Simple</span> Sidebar</h3>\r\n<p>Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<p class="quiet">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>\r\n<h5>Incremental leading</h5>\r\n<p class="incr">Vestibulum ante ipsum primis in faucibus orci luctus vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus.</p>\r\n<p class="incr">Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Cras ornare mattis nunc. Mauris venenatis, pede sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue. sed aliquet vehicula, lectus tellus pulvinar neque, non cursus sem nisi vel augue.</p>', 1, 'atomic-sidebar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(76, 'Login (Atomic Template)', '', '', 2, 'atomic-sidebar', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', -2, 'mod_login', 1, 0, '{"pretext":"","posttext":"","login":"","logout":"","greeting":"1","name":"0","usesecure":"0","layout":"","moduleclass_sfx":"","cache":"0"}', 0, '*'),
(77, 'JA News Featured Module', '', '', 1, 'content-top', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janews_featured', 1, 0, '{"moduleclass_sfx":"","source":"JANewsHelper","catsid":["90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"k2catsid":[""],"getChildren":"1","featured":"only","ordering":"ordering","sort_order":"DESC","profile":"telineiii","JPlugins":"1","K2Plugins":"1","cache":"0","cache_time":"0"}', 0, '*'),
(78, 'Most Read', '', '', 1, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 0, '{"moduleclass_sfx":"","type":"mostread","category":[""],"count":"5","show_featured":"1","show_date":"1","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"25","height":"25","cache":"1","cache_time":"900"}', 0, '*'),
(79, 'JA News Sticker Module', '', '', 1, 'headlines', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewsticker', 1, 1, '{"moduleclass_sfx":"","using_mode":"rss","external_link":"","k2catsid":[""],"rss_link":"http:\\/\\/feeds.joomla.org\\/JoomlaAnnouncements","category":[""],"sort_order_field":"created","sort_order":"DESC","max_items":5,"title_max_chars":50,"animation_type":"opacity","animation_speed":400,"animation_interval":2500,"animation_transition":"Fx.Transitions.linear","show_headtext":"1","headtext":"Headlines:","show_buttons_control":"0","enable_cache":"0","cache_time":900}', 0, '*'),
(80, 'JA Twitter Module', '', '', 1, 'mega-item', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jatwitter', 1, 0, '{"moduleclass_sfx":"","taccount":"JoomlartDemo","use_display_taccount":"0","size_iconaccount":"32","show_tweet":"1","show_limit":"2","show_icon":"0","icon_size":"30","show_username":"0","show_source":"0","showtextheading":"0","headingtext":"My Twitter Updates","use_friends":"0","size_iconfriend":"24","max_friends":"18","showfollowlink":"1","typefollowbutton":"apiconnect","style_of_follow_button":"follow_me-a.png","apikey":"wMOXZUmWegMztLtrPB9I1Q","enable_cache":"1","cache_time":"900"}', 0, '*'),
(81, 'Welcome to Joomla!', '', '<div style="padding: 5px"><p>Congratulations on choosing Joomla! as your content management system. We hope you are able to create a successful Web site with our program and maybe you will be able to give something back to the community later.</p><p>To make your start with Joomla! as smooth as possible, we want to give you some pointers to documentation, common questions and help on securing your server. A good place to start is the &quot;<a href="http://docs.joomla.org/beginners" target="_blank">Absolute Beginners Guide to Joomla!</a>&quot;.</p><p>For your most common questions the best place to start looking for answers is the <a href="http://help.joomla.org/component/option,com_easyfaq/Itemid,268/" target="_blank">Frequently Asked Questions (FAQ)</a> area.  If you are stuck on a particular screen in the Administration area of Joomla! (which is where you are now), then try clicking on the Help toolbar button which you will find on almost all screens.  This will take you to a page about that screen on our <a href="http://help.joomla.org" target="_blank">Help Site</a>.  If you still have questions then take a look on our <a href="http://forum.joomla.org" target="_blank">forum</a> which is most likely the biggest resource on Joomla! there is and you will find almost every question answered at least once, so please try using the search function before asking your question.</p><p>Security is a big concern for us, which is why we would like you to subscribe to the <a href="http://forum.joomla.org/index.php/board,8.0.html" target="_blank">announcement forum</a> (by clicking on the Notify button) to always get the latest information on new releases for Joomla! You should also read the <a href="http://help.joomla.org/component/option,com_easyfaq/task,view/id,167/Itemid,268/" target="_blank">Joomla! Administrator\'s Security Checklist</a> and regularly check the <a href="http://forum.joomla.org/index.php/board,267.0.html" target="_blank">security forum</a>.</p><p>We hope you have much fun and success with Joomla! and hope to see you in the forum among the hundreds and thousands of contributors.</p><p>Your Joomla! team.<img alt="Smile" border="0" src="../plugins/editors/tinymce/jscripts/tiny_mce/plugins/emotions/images/smiley-smile.gif" title="Smile" /></p><p>P.S.: To remove this message, delete the &quot;Welcome to Joomla!&quot; Module in the Administrator screen of the Module Manager (on the Extensions menu).  Here is a <a href="index.php?option=com_modules&amp;client=1">quick link</a> to this screen.</p></div>', 1, 'cpanel', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 1, '*'),
(82, 'Sport', '', '<img src="images/stories/demo/sport/sport-1.jpg" alt="Sport" />\r\n\r\nNulla tincidunt tincidunt <a href="#" title="Sport">velit tristique leo.</a>', 0, 'user9', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(83, 'Fashion', '', '<img src="images/stories/demo/style/fashion-1.jpg" alt="Fashion" />\r\n\r\nPellentesque porttitor Vestibulum Mauris', 0, 'user8', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(84, 'Art and Design', '', '<ul>\r\n<li><a target="_blank" href="#">Praesent ac libero ornare venenatis</a></li>\r\n\r\n<li><a target="_blank" href="#">Nunc auctor vel Aenean neque montes</a></li>\r\n\r\n<li><a target="_blank" href="#">Et id tortor Cras id nunc montes lobortis lacus et fringilla</a></li>\r\n\r\n<li><a target="_blank" href="#">Hendrerit semper eget convallis neque eleifend orci iaculis</a></li>\r\n\r\n<li><a target="_blank" href="#">Tortor et laoreet quis Nullam augue justo</a></li>\r\n</ul>', 0, 'user7', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(85, 'MarketWatch', '', '<ul>\r\n<li><a target="_blank" href="#">Currencies: U.S. dollar, yen reverse gains in Asia</a></li>\r\n\r\n<li><a target="_blank" href="#">Amcor buys most of Rio Tinto\'s Alcan Packaging</a></li>\r\n\r\n<li><a target="_blank" href="#">Mark Hulbert: Gold, stocks are more allies than enemies</a></li>\r\n\r\n<li><a target="_blank" href="#">Stocks to Watch: Stocks in focus for Tuesday</a></li>\r\n\r\n<li><a target="_blank" href="#">Steelmakers rise in volatile Shanghai market</a></li>\r\n</ul>', 0, 'user6', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(86, 'Feature news', '', '<div class="ja-innerdiv">\r\n<h4>World</h4>\r\n<img src="images/stories/demo/other/cat-1.jpg" border="0" alt="Obama" /> Ut justo id nibh pulvinar mauris pede Phasellus metus. <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Sport</h4>\r\n<img src="images/stories/demo/other/cat-2.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Food and Drink</h4>\r\n<img src="images/stories/demo/other/cat-3.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Art</h4>\r\n<img src="images/stories/demo/other/cat-4.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Entertaiment</h4>\r\n<img src="images/stories/demo/other/cat-5.jpg" border="0" alt="Obama" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Technology</h4>\r\n<img src="images/stories/demo/other/cat-6.jpg" border="0" alt="Technology" /> Ipsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>', 4, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(87, 'Adv', '', '<img src="images/stories/demo/other/bmw-x5.jpg" alt="BMW-X5" />', 4, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(88, 'Discussion', '', '<div class="discussion-wrap clearfix"><div class="discussion-content">\r\n<img src="images/stories/demo/other/discussion.jpg" alt="alt" align="left" />\r\n<h4><a href="#" title="Discussion">Iran appoints new judiciary head</a></h4>\r\nAc Nunc tempor a eget et morbi Vivamus vitae nunc metus. Morbi feugiat neque tellus justo commodo hac lacinia gravida Curabitur Curabitur. Risus ut Phasellus eget Vivamus dis justo cursus semper <a class="comment" title="Comment" href="#">Comment</a>&nbsp;&nbsp;<a class="video" title="Video" href="#">Video</a>&nbsp;&nbsp;<a class="photo" title="Slideshow" href="#">Slideshow</a>\r\n\r\n</div></div>\r\n\r\n<span class="author"><strong>Author:</strong> Mr Truly</span>', 1, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(89, 'Book reviews', '', '<div class="clearfix"><img src="images/stories/demo/other/book-review.jpg" border="0" alt="The Battle for America 2008" align="left" style="margin-right: 10px; padding: 5px; border: 5px solid #CCCCCC;" />\r\n<h4>The Battle for America 2008: The Story of an Extraordinary Election</h4>\r\n<p>Fringilla justo vel pretium dui tellus wisi congue auctor. Augue Nullam amet Phasellus Ut eu sociis libero id libero est. In interdum ac nibh habitasse malesuada nibh justo at orci Maecenas. Massa sociis quis et odio massa id id Pellentesque vestibulum interdum.</p>\r\n<a class="comment" href="#" title="Comment">Discuss: Do you think about this book?</a></div>', 1, 'col-mass2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"_hilite badge-top","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(90, 'Banner 1', '', '<a href="index.php/10-things-you-must-know-about-teline-iii" title="What\'s new in JA Teline iii?"><img src="images/stories/demo/other/what-new.jpg" alt="What\'s new in teline iii" /></a>', 5, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(91, 'Videos of the day', '', '<div class="ja-video-thumb">{japopup type="youtube" content="http://www.youtube.com/v/cdphzxz64BY" width="640" height="380" title="Political Roast : Obama Emanuel 2005"}<img src="http://img.youtube.com/vi/cdphzxz64BY/2.jpg" border="0" alt="Political Roast : Obama Emanuel 2005" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/i18_4jZbrQ4" width="640" height="380" title="Beardyman and Reggie Watts on Channel 4 Headspace"}<img src="http://img.youtube.com/vi/i18_4jZbrQ4/2.jpg" border="0" alt="Beardyman and Reggie Watts on Channel 4 Headspace" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/YgW7or1TuFk" width="640" height="380" title="A Closer Look At The iPhone"}<img src="http://img.youtube.com/vi/YgW7or1TuFk/2.jpg" border="0" alt="A Closer Look At The iPhone" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/DOvbv-LkK6w" width="640" height="380" title="Star Wars: The Old Republic E3 2009 Jedi vs. Sith Trailer [HQ]" }<img src="http://img.youtube.com/vi/DOvbv-LkK6w/2.jpg" border="0" alt="Star Wars: The Old Republic E3 2009 Jedi vs. Sith Trailer [HQ]" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/ezdfVbOqzRc" width="640" height="380" title="Bare-Knuckle Brawling : KICK ASS ! | 2009"}<img src="http://img.youtube.com/vi/ezdfVbOqzRc/2.jpg" border="0" alt="Bare-Knuckle Brawling : KICK ASS ! | 2009" />{/japopup} {japopup type="youtube" content="http://www.youtube.com/v/XOZw7sBUI7s" width="640" height="380" title="Bernard the bear:The desert island"}<img src="http://img.youtube.com/vi/XOZw7sBUI7s/2.jpg" border="0" alt="Bernard the bear:The desert island" />{/japopup}</div>', 1, 'ja-tabs2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(92, 'Tech banner', '', '<p><img src="images/stories/demo/other/imgad-2.jpg" border="0" alt="iPhone 3GS" /></p>', 4, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(93, 'Tech highlight', '', '<div class="ja-innerdiv">\r\n<h4>Business Tech</h4>\r\n<img src="images/stories/demo/other/tech-1.jpg" alt="Business Tech" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Science</h4>\r\n<img src="images/stories/demo/other/tech-2.jpg" alt="Science" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Personal Tech</h4>\r\n<img src="images/stories/demo/other/tech-3.jpg" alt="Personal Tech" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Space</h4>\r\n<img src="images/stories/demo/other/tech-4.jpg" alt="Space" />\r\nDolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Green Tech</h4>\r\n<img src="images/stories/demo/other/tech-5.jpg" alt="Green Tech" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 6, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(94, 'Entertainment highlight', '', '<div class="ja-innerdiv">\r\n<h4>Television</h4>\r\n<img src="images/stories/demo/other/enter-1.jpg" alt="Television" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Movies</h4>\r\n<img src="images/stories/demo/other/enter-2.jpg" alt="Movies" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Books</h4>\r\n<img src="images/stories/demo/other/enter-3.jpg" alt="Books" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Music</h4>\r\n<img src="images/stories/demo/other/enter-4.jpg" alt="Music" />\r\nDolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Games</h4>\r\n<img src="images/stories/demo/other/enter-5.jpg" alt="Movies" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Theatre</h4>\r\n<img src="images/stories/demo/other/enter-6.jpg" alt="Television" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 7, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(95, 'Health highlight', '', '<div class="ja-innerdiv">\r\n<h4>You &amp; Your Family</h4>\r\n<img src="images/stories/demo/other/hel-1.jpg" alt="You &amp; Your Family" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>What Ails You</h4>\r\n<img src="images/stories/demo/other/hel-2.jpg" alt="What Ails You" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Diet &amp; Fitness</h4>\r\n<img src="images/stories/demo/other/hel-3.jpg" alt="Diet &amp; Fitness" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 10, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(96, 'World highlight', '', '<div class="ja-innerdiv">\r\n<h4>Africa</h4>\r\n<img src="images/stories/demo/other/wor-1.jpg" alt="Africa" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Middle East</h4>\r\n<img src="images/stories/demo/other/wor-2.jpg" alt="Middle East" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>U.S Politics</h4>\r\n<img src="images/stories/demo/other/wor-3.jpg" alt="U.S Politics" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Europe</h4>\r\n<img src="images/stories/demo/other/wor-4.jpg" alt="Europe" />\r\nDolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 5, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(97, 'Life and Style', '', '<div class="ja-innerdiv">\r\n<h4>Fashion &amp; Beauty</h4>\r\n<img src="images/stories/demo/other/life-1.jpg" border="0" alt="Fashion &amp; Beauty" /> Ut justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Food &amp; Drink</h4>\r\n<img src="images/stories/demo/other/life-2.jpg" border="0" alt="Food &amp; Drink" /> Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Wife &amp; Husband</h4>\r\n<img src="images/stories/demo/other/life-3.jpg" border="0" alt="Wife &amp; Husband" /> Non ante gravida eros quis justo sed nonummy et Donec et.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Shop</h4>\r\n<img src="images/stories/demo/other/life-4.jpg" border="0" alt="Shop" /> Dolor ut id enim dolor auctor a Aenean Vestibulum lorem egestas.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Mother &amp; Children</h4>\r\n<img src="images/stories/demo/other/life-5.jpg" border="0" alt="Mother &amp; Children" /> Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>\r\n<div class="ja-innerdiv">\r\n<h4>Home &amp; Gardens</h4>\r\n<img src="images/stories/demo/other/life-6.jpg" border="0" alt="Home &amp; Gardens" /> Ut justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a class="Read more..." href="#" style="font-size: 92%;">More detail »</a></div>', 9, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static"}', 0, '*'),
(98, 'Photo gallery', '', '<div class="ja-video-thumb">\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-1.png" width="700" height="380" title="Sample image" }<img src="images/stories/demo/gallery/gl-1.png"  width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-2.png" width="700" height="380" title="Sample image" }<img src="images/stories/demo/gallery/gl-2.png" width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-3.png" width="700" height="380" title="Sample image"}<img src="images/stories/demo/gallery/gl-3.png" width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-4.jpg" width="700" height="380" title="Sample image" }<img src="images/stories/demo/gallery/gl-4.jpg"  width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-5.jpg" width="700" height="380" title="Sample image"}<img src="images/stories/demo/gallery/gl-5.jpg"  width="100" alt="Sample image" />{/japopup}\r\n\r\n{japopup type="image" group="ja-video-thumb" content="images/stories/demo/gallery/gl-6.jpg" width="700" height="380" title="Sample image"}<img src="images/stories/demo/gallery/gl-6.jpg"  width="100" alt="Sample image" />{/japopup}\r\n\r\n</div>', 2, 'ja-tabs2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(99, 'Travel highlight', '', '<div class="ja-innerdiv">\r\n<h4>Getaway</h4>\r\n<img src="images/stories/demo/other/travel-1.jpg" alt="Getaway" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus Sed congue. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Travel Tips</h4>\r\n<img src="images/stories/demo/other/travel-2.jpg" alt="Travel Tips" />\r\nOrci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Business Travel</h4>\r\n<img src="images/stories/demo/other/travel-3.jpg" alt="Business Travel" />\r\nNon ante gravida eros quis justo sed nonummy et Donec et.<a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 8, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(100, 'Bookmark pages', '', '<ul class="bookmark-links">\r\n<li><a href="http://www.facebook.com" title="www.facebook.com" target="_blank"> Facebook </a></li>\r\n<li><a href="http://www.joomlart.com" target="_blank">Joomla Templates Club - Professional - High quality Joomla template</a></li>\r\n<li><a href="http://www.magentocommerce.com" target="_blank">Magento - Home  - eCommerce Software for Growth</a></li>\r\n<li><a href="http://www.joomlancers.com" target="_blank">JoomLancers - Freelance Marketplace for Opensource Development</a></li>\r\n<li><a href="http://www.iconfinder.net/" target="_blank"><strong>Icon Finder</strong><br />Tool icons | Free icons | Search through more than 100,000 icons</a></li>\r\n</ul>', 3, 'ja-tabs2', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*');
INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`) VALUES
(101, 'Artist highlight', '', '<div class="ja-innerdiv">\r\n<h4>Photography</h4>\r\n<img src="images/stories/demo/other/artist-1.jpg" alt="Photography" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Design</h4>\r\n<img src="images/stories/demo/other/artist-2.jpg" alt="Design" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Architecture</h4>\r\n<img src="images/stories/demo/other/artist-3.jpg" alt="Architecture" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Art</h4>\r\n<img src="images/stories/demo/other/artist-4.jpg" alt="Art" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>3D Graphics</h4>\r\n<img src="images/stories/demo/other/artist-5.jpg" alt="3D Graphics" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Graphics</h4>\r\n<img src="images/stories/demo/other/artist-6.jpg" alt="Graphics" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 2, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(102, 'Sport highlight', '', '<div class="ja-innerdiv">\r\n<h4>Tennis</h4>\r\n<img src="images/stories/demo/other/sport-1.jpg" alt="Tennis" />\r\nUt justo id nibh pulvinar mauris pede Phasellus metus. <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Cricket</h4>\r\n<img src="images/stories/demo/other/sport-2.jpg" alt="Cricket" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Motosport</h4>\r\n<img src="images/stories/demo/other/sport-3.jpg" alt="Motosport" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Horse racing</h4>\r\n<img src="images/stories/demo/other/sport-4.jpg" alt="Horse racing" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Boxing</h4>\r\n<img src="images/stories/demo/other/sport-5.jpg" alt="Boxing" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>\r\n\r\n<div class="ja-innerdiv">\r\n<h4>Football</h4>\r\n<img src="images/stories/demo/other/sport-6.jpg" alt="Football" />\r\nIpsum vel Phasellus ligula dis convallis eu risus consequat justo justo <a href="#" class="Read more..." style="font-size: 92%;">More detail &raquo;</a>\r\n</div>', 3, 'left', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(103, 'Features', '', '<div>\r\n<p style="text-align: center"><img src="images/stories/demo/other/icon_feature.png" border="0" alt="Feature" title="Feature" /> <span style="color: #cc0000; font-size: 150%">10</span> Things you <span style="color: #cc0000">MUST</span> know about Teline III</p>\r\n<h4 style="text-align: center; padding-top: 5px;"><a href="index.php?option=com_content&amp;view=article&amp;id=389&amp;Itemid=467">Find out more... </a></h4>\r\n</div>', 0, 'mega-item', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"moduleclass_sfx":""}', 0, '*'),
(104, 'Follow us', '', '<img src="images/stories/demo/other/follow.jpg" alt="Follow us" />', 0, 'user10', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 1, '{"moduleclass_sfx":""}', 0, '*'),
(105, 'JA News Pro Module', '', '', 1, 'content-bot', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewspro', 1, 0, '{"moduleclass_sfx":"","catsid":["90","97","104","108","115","119","126","133"],"getChildren":"1","groupbysubcat":"1","maxSubCats":"3","featured":"show","ordering":"ordering","sort_order":"DESC","timerange":"","profile":"telineiii","JPlugins":"0","colors":"90:green\\r\\n108:pink\\r\\n104:deepblue\\r\\n119:cyan\\r\\n5:green\\r\\n9:pink\\r\\n115:lime\\r\\n133:orange\\r\\n126:red","jacache":"0","jacache_time":"900"}', 0, '*'),
(106, 'Banner right 1', '', '', 2, 'right', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_banners', 1, 0, '{"target":"1","count":"5","cid":"0","catid":["141"],"tag_search":"0","ordering":"0","header_text":"","footer_text":"","layout":"_:default","moduleclass_sfx":"","cache":"1","cache_time":"900"}', 0, '*'),
(107, 'JA Tabs', '', '<div>{jatabs type="modules" animType="animNone" style="teline_iii" position="top" widthTabs="auto" heightTabs="auto" width="auto" height="auto" mouseType="click" duration="1000" colors="10" module="ja-tabs" }{/jatabs}</div>', 4, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"1","backgroundimage":"","layout":"_:default","moduleclass_sfx":"_tabs","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(108, 'Latest News', '', '', 1, 'ja-tabs', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_jabulletin', 1, 0, '{"moduleclass_sfx":"","type":"latest","category":["","90","91","92","93","94","95","96","97","98","99","100","101","102","103","104","105","106","107","108","109","110","111","112","113","114","115","116","117","118","119","120","121","122","123","124","125","126","127","128","129","130","131","132","133","134","135","136","137","138","139"],"count":"5","show_featured":"0","show_date":"1","show_image":"1","thumbnail_mode":"crop","use_ratio":"1","width":"25","height":"25","cache":"0","cache_time":"30"}', 0, '*'),
(109, 'JA Tabs 2', '', '<div>{jatabs type="modules" animType="animNone" style="teline_iii" position="top" widthTabs="120" heightTabs="auto" width="100%" height="auto" mouseType="click" duration="1000" colors="10" module="ja-tabs2" }{/jatabs}</div>', 3, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_custom', 1, 0, '{"prepare_content":"0","backgroundimage":"","layout":"_:default","moduleclass_sfx":"_tabs","cache":"1","cache_time":"900","cachemode":"static","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(110, 'JA News Pro Mobile', '', '', 1, 'ja-news-mobile', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_janewspro', 1, 0, '{"moduleclass_sfx":"","catsid":["90","97","104","108","115","119","126"],"getChildren":"1","groupbysubcat":"1","maxSubCats":"3","featured":"show","ordering":"ordering","sort_order":"DESC","timerange":"","profile":"mobile","JPlugins":"1","colors":"90:green\\r\\n108:pink\\r\\n104:deepblue\\r\\n119:cyan\\r\\n5:green\\r\\n9:pink\\r\\n115:lime\\r\\n133:orange\\r\\n126:red","jacache":"0","jacache_time":"900"}', 0, '*'),
(111, 'Multilanguage status', '', '', 1, 'status', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 0, 'mod_multilangstatus', 3, 1, '{"layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(112, 'Joomla Version', '', '', 1, 'footer', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_version', 3, 1, '{"format":"short","product":"1","layout":"_:default","moduleclass_sfx":"","cache":"0"}', 1, '*'),
(113, 'Popular Tags', '', '', 1, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tags_popular', 1, 1, '{"maximum":"10","timeframe":"alltime","layout":"_:default","moduleclass_sfx":"","owncache":"1","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*'),
(114, 'Similar Tags', '', '', 2, 'col-mass1', 0, '0000-00-00 00:00:00', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, 'mod_tags_similar', 1, 1, '{"maximum":"10","matchtype":"any","layout":"_:default","moduleclass_sfx":"","owncache":"1","module_tag":"div","bootstrap_size":"0","header_tag":"h3","header_class":"","style":"0"}', 0, '*');

DROP TABLE IF EXISTS `#__modules_menu`;
CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`) VALUES
(1, 207),
(1, 234),
(1, 242),
(1, 243),
(1, 244),
(1, 296),
(1, 399),
(1, 400),
(1, 427),
(1, 429),
(1, 430),
(1, 431),
(1, 432),
(1, 433),
(1, 462),
(1, 463),
(1, 464),
(1, 467),
(1, 468),
(1, 469),
(1, 470),
(1, 471),
(1, 472),
(1, 473),
(1, 476),
(1, 477),
(1, 478),
(1, 479),
(1, 480),
(1, 481),
(1, 482),
(1, 483),
(1, 484),
(1, 485),
(1, 486),
(1, 487),
(1, 490),
(1, 491),
(1, 492),
(1, 493),
(1, 494),
(1, 495),
(1, 496),
(1, 497),
(1, 498),
(1, 499),
(1, 500),
(1, 501),
(1, 502),
(1, 503),
(1, 504),
(1, 505),
(1, 506),
(1, 507),
(1, 508),
(1, 509),
(1, 510),
(1, 511),
(1, 512),
(1, 513),
(1, 514),
(1, 515),
(1, 516),
(1, 517),
(1, 518),
(1, 519),
(1, 520),
(1, 521),
(1, 522),
(1, 523),
(1, 524),
(1, 525),
(1, 526),
(1, 527),
(1, 528),
(1, 529),
(1, 530),
(1, 531),
(1, 532),
(1, 533),
(1, 534),
(1, 535),
(1, 536),
(1, 537),
(1, 538),
(1, 539),
(1, 540),
(1, 541),
(1, 542),
(1, 543),
(1, 544),
(1, 545),
(1, 546),
(1, 547),
(1, 548),
(1, 549),
(1, 550),
(1, 551),
(1, 552),
(1, 553),
(1, 554),
(1, 559),
(1, 560),
(1, 561),
(1, 563),
(1, 564),
(1, 565),
(1, 566),
(1, 567),
(1, 568),
(1, 578),
(1, 580),
(1, 584),
(1, 585),
(2, 0),
(3, 0),
(4, 0),
(6, 0),
(7, 0),
(8, 0),
(9, 0),
(10, 0),
(12, 0),
(13, 0),
(14, 0),
(15, 0),
(16, 0),
(17, 0),
(18, 0),
(19, 464),
(19, 491),
(19, 578),
(20, 0),
(22, 231),
(22, 234),
(22, 238),
(22, 242),
(22, 243),
(22, 244),
(22, 296),
(22, 519),
(22, 520),
(23, 207),
(23, 234),
(23, 242),
(23, 243),
(23, 244),
(23, 296),
(23, 399),
(23, 400),
(23, 427),
(23, 429),
(23, 430),
(23, 431),
(23, 432),
(23, 433),
(23, 462),
(23, 463),
(23, 464),
(23, 467),
(23, 468),
(23, 469),
(23, 470),
(23, 471),
(23, 472),
(23, 473),
(23, 476),
(23, 477),
(23, 478),
(23, 479),
(23, 480),
(23, 481),
(23, 482),
(23, 483),
(23, 484),
(23, 485),
(23, 486),
(23, 487),
(23, 490),
(23, 491),
(23, 492),
(23, 493),
(23, 494),
(23, 495),
(23, 496),
(23, 497),
(23, 498),
(23, 499),
(23, 500),
(23, 501),
(23, 502),
(23, 503),
(23, 504),
(23, 505),
(23, 506),
(23, 507),
(23, 508),
(23, 509),
(23, 510),
(23, 511),
(23, 512),
(23, 513),
(23, 514),
(23, 515),
(23, 516),
(23, 517),
(23, 518),
(23, 519),
(23, 520),
(23, 521),
(23, 522),
(23, 523),
(23, 524),
(23, 525),
(23, 526),
(23, 527),
(23, 528),
(23, 529),
(23, 530),
(23, 531),
(23, 532),
(23, 533),
(23, 534),
(23, 535),
(23, 536),
(23, 537),
(23, 538),
(23, 539),
(23, 540),
(23, 541),
(23, 542),
(23, 543),
(23, 544),
(23, 545),
(23, 546),
(23, 547),
(23, 548),
(23, 549),
(23, 550),
(23, 551),
(23, 552),
(23, 553),
(23, 554),
(23, 559),
(23, 560),
(23, 561),
(23, 563),
(23, 564),
(23, 565),
(23, 566),
(23, 567),
(23, 568),
(23, 580),
(23, 584),
(23, 585),
(25, 294),
(26, -463),
(26, -462),
(26, -433),
(26, -432),
(26, -431),
(26, -430),
(26, -429),
(26, -427),
(26, -400),
(26, -399),
(26, -296),
(26, -244),
(26, -243),
(26, -242),
(26, -238),
(26, -234),
(27, 325),
(28, 310),
(29, 302),
(30, 527),
(31, 309),
(32, 309),
(33, 307),
(34, 326),
(35, 306),
(36, 304),
(37, 311),
(38, 300),
(39, 491),
(40, 313),
(41, 0),
(44, 312),
(45, 303),
(47, 231),
(47, 234),
(47, 242),
(47, 243),
(47, 244),
(47, 296),
(47, 519),
(47, 520),
(48, 535),
(49, 534),
(52, 0),
(56, 201),
(56, 207),
(56, 227),
(56, 229),
(56, 234),
(56, 242),
(56, 243),
(56, 244),
(56, 249),
(56, 251),
(56, 252),
(56, 253),
(56, 254),
(56, 255),
(56, 256),
(56, 257),
(56, 259),
(56, 260),
(56, 262),
(56, 263),
(56, 265),
(56, 266),
(56, 267),
(56, 268),
(56, 270),
(56, 271),
(56, 272),
(56, 273),
(56, 274),
(56, 275),
(56, 276),
(56, 277),
(56, 278),
(56, 279),
(56, 280),
(56, 281),
(56, 282),
(56, 283),
(56, 284),
(56, 285),
(56, 286),
(56, 296),
(56, 300),
(56, 301),
(56, 302),
(56, 303),
(56, 304),
(56, 305),
(56, 306),
(56, 307),
(56, 309),
(56, 310),
(56, 311),
(56, 312),
(56, 313),
(56, 316),
(56, 317),
(56, 318),
(56, 319),
(56, 320),
(56, 321),
(56, 322),
(56, 323),
(56, 324),
(56, 325),
(56, 326),
(56, 399),
(56, 400),
(56, 402),
(56, 403),
(56, 404),
(56, 405),
(56, 406),
(56, 409),
(56, 410),
(56, 411),
(56, 412),
(56, 413),
(56, 414),
(56, 415),
(56, 416),
(56, 417),
(56, 418),
(56, 419),
(56, 421),
(56, 422),
(56, 423),
(56, 424),
(56, 427),
(56, 429),
(56, 430),
(56, 431),
(56, 432),
(56, 433),
(56, 436),
(56, 437),
(56, 443),
(56, 447),
(56, 449),
(56, 450),
(56, 451),
(56, 452),
(56, 453),
(56, 456),
(56, 457),
(56, 458),
(56, 459),
(56, 462),
(56, 463),
(56, 464),
(56, 467),
(56, 468),
(56, 469),
(56, 470),
(56, 471),
(56, 472),
(56, 473),
(56, 476),
(56, 477),
(56, 478),
(56, 479),
(56, 480),
(56, 481),
(56, 482),
(56, 483),
(56, 484),
(56, 485),
(56, 486),
(56, 487),
(56, 491),
(56, 492),
(56, 493),
(56, 494),
(56, 495),
(56, 496),
(56, 497),
(56, 498),
(56, 499),
(56, 500),
(56, 501),
(56, 502),
(56, 503),
(56, 504),
(56, 505),
(56, 506),
(56, 507),
(56, 508),
(56, 509),
(56, 510),
(56, 511),
(56, 512),
(56, 513),
(56, 514),
(56, 515),
(56, 516),
(56, 517),
(56, 518),
(56, 519),
(56, 520),
(56, 521),
(56, 522),
(56, 523),
(56, 524),
(56, 525),
(56, 526),
(56, 527),
(56, 528),
(56, 529),
(56, 530),
(56, 531),
(56, 532),
(56, 533),
(56, 534),
(56, 535),
(56, 536),
(56, 537),
(56, 538),
(56, 539),
(56, 540),
(56, 541),
(56, 542),
(56, 543),
(56, 544),
(56, 545),
(56, 546),
(56, 547),
(56, 548),
(56, 549),
(56, 550),
(56, 551),
(56, 552),
(56, 553),
(56, 559),
(56, 560),
(56, 561),
(56, 584),
(56, 585),
(57, 238),
(57, 494),
(57, 496),
(57, 497),
(57, 498),
(57, 499),
(57, 500),
(57, 552),
(57, 553),
(58, 494),
(58, 496),
(58, 497),
(58, 498),
(58, 499),
(58, 500),
(58, 552),
(58, 553),
(60, 227),
(60, 229),
(60, 249),
(60, 251),
(60, 252),
(60, 253),
(60, 254),
(60, 255),
(60, 256),
(60, 257),
(60, 259),
(60, 260),
(60, 262),
(60, 263),
(60, 265),
(60, 266),
(60, 267),
(60, 270),
(60, 271),
(60, 272),
(60, 273),
(60, 274),
(60, 275),
(60, 276),
(60, 281),
(60, 282),
(60, 283),
(60, 284),
(60, 285),
(60, 286),
(60, 300),
(60, 301),
(60, 302),
(60, 303),
(60, 304),
(60, 305),
(60, 306),
(60, 307),
(60, 309),
(60, 310),
(60, 311),
(60, 312),
(60, 313),
(60, 314),
(60, 316),
(60, 317),
(60, 318),
(60, 319),
(60, 320),
(60, 321),
(60, 322),
(60, 323),
(60, 324),
(60, 325),
(60, 326),
(60, 405),
(60, 406),
(60, 409),
(60, 424),
(60, 492),
(60, 493),
(60, 522),
(60, 523),
(60, 524),
(60, 527),
(60, 528),
(60, 529),
(60, 530),
(60, 531),
(60, 532),
(60, 533),
(60, 534),
(60, 535),
(60, 538),
(60, 539),
(60, 540),
(60, 541),
(60, 542),
(61, 546),
(62, 231),
(62, 234),
(62, 242),
(62, 243),
(62, 244),
(62, 296),
(62, 519),
(62, 520),
(63, 0),
(64, 447),
(65, 494),
(65, 496),
(65, 497),
(65, 498),
(65, 499),
(65, 500),
(65, 552),
(65, 553),
(68, 243),
(69, 549),
(70, 285),
(70, 316),
(71, 285),
(71, 316),
(72, 285),
(72, 316),
(73, 285),
(73, 316),
(74, 285),
(74, 316),
(75, 285),
(75, 316),
(76, 285),
(76, 316),
(77, 491),
(78, 0),
(79, 0),
(80, 0),
(81, 435),
(82, 435),
(82, 491),
(82, 492),
(82, 493),
(82, 494),
(82, 495),
(82, 496),
(82, 497),
(82, 498),
(82, 499),
(82, 500),
(82, 501),
(82, 502),
(82, 503),
(82, 504),
(82, 505),
(82, 506),
(82, 507),
(82, 508),
(82, 509),
(82, 510),
(82, 511),
(82, 512),
(82, 513),
(82, 514),
(82, 515),
(82, 516),
(82, 517),
(82, 518),
(82, 519),
(82, 520),
(82, 521),
(82, 522),
(82, 523),
(82, 524),
(82, 525),
(82, 526),
(82, 527),
(82, 528),
(82, 529),
(82, 530),
(82, 531),
(82, 532),
(82, 533),
(82, 534),
(82, 535),
(82, 536),
(82, 537),
(82, 538),
(82, 539),
(82, 540),
(82, 541),
(82, 542),
(82, 543),
(82, 544),
(82, 547),
(82, 548),
(82, 549),
(82, 550),
(82, 551),
(82, 552),
(82, 553),
(83, 435),
(83, 491),
(83, 492),
(83, 493),
(83, 494),
(83, 495),
(83, 496),
(83, 497),
(83, 498),
(83, 499),
(83, 500),
(83, 501),
(83, 502),
(83, 503),
(83, 504),
(83, 505),
(83, 506),
(83, 507),
(83, 508),
(83, 509),
(83, 510),
(83, 511),
(83, 512),
(83, 513),
(83, 514),
(83, 515),
(83, 516),
(83, 517),
(83, 518),
(83, 519),
(83, 520),
(83, 521),
(83, 522),
(83, 523),
(83, 524),
(83, 525),
(83, 526),
(83, 527),
(83, 528),
(83, 529),
(83, 530),
(83, 531),
(83, 532),
(83, 533),
(83, 534),
(83, 535),
(83, 536),
(83, 537),
(83, 538),
(83, 539),
(83, 540),
(83, 541),
(83, 542),
(83, 543),
(83, 544),
(83, 547),
(83, 548),
(83, 549),
(83, 550),
(83, 551),
(83, 552),
(83, 553),
(84, 435),
(84, 491),
(84, 492),
(84, 493),
(84, 494),
(84, 495),
(84, 496),
(84, 497),
(84, 498),
(84, 499),
(84, 500),
(84, 501),
(84, 502),
(84, 503),
(84, 504),
(84, 505),
(84, 506),
(84, 507),
(84, 508),
(84, 509),
(84, 510),
(84, 511),
(84, 512),
(84, 513),
(84, 514),
(84, 515),
(84, 516),
(84, 517),
(84, 518),
(84, 519),
(84, 520),
(84, 521),
(84, 522),
(84, 523),
(84, 524),
(84, 525),
(84, 526),
(84, 527),
(84, 528),
(84, 529),
(84, 530),
(84, 531),
(84, 532),
(84, 533),
(84, 534),
(84, 535),
(84, 536),
(84, 537),
(84, 538),
(84, 539),
(84, 540),
(84, 541),
(84, 542),
(84, 543),
(84, 544),
(84, 547),
(84, 548),
(84, 549),
(84, 550),
(84, 551),
(84, 552),
(84, 553),
(85, 435),
(85, 491),
(85, 492),
(85, 493),
(85, 494),
(85, 495),
(85, 496),
(85, 497),
(85, 498),
(85, 499),
(85, 500),
(85, 501),
(85, 502),
(85, 503),
(85, 504),
(85, 505),
(85, 506),
(85, 507),
(85, 508),
(85, 509),
(85, 510),
(85, 511),
(85, 512),
(85, 513),
(85, 514),
(85, 515),
(85, 516),
(85, 517),
(85, 518),
(85, 519),
(85, 520),
(85, 521),
(85, 522),
(85, 523),
(85, 524),
(85, 525),
(85, 526),
(85, 527),
(85, 528),
(85, 529),
(85, 530),
(85, 531),
(85, 532),
(85, 533),
(85, 534),
(85, 535),
(85, 536),
(85, 537),
(85, 538),
(85, 539),
(85, 540),
(85, 541),
(85, 542),
(85, 543),
(85, 544),
(85, 547),
(85, 548),
(85, 549),
(85, 550),
(85, 551),
(85, 552),
(85, 553),
(86, 467),
(86, 472),
(86, 473),
(86, 476),
(86, 477),
(86, 478),
(86, 479),
(86, 480),
(86, 481),
(86, 482),
(86, 483),
(86, 484),
(86, 485),
(86, 486),
(86, 487),
(86, 491),
(86, 492),
(86, 493),
(86, 494),
(86, 495),
(86, 496),
(86, 497),
(86, 498),
(86, 499),
(86, 500),
(86, 501),
(86, 545),
(86, 546),
(87, 472),
(87, 473),
(87, 474),
(87, 475),
(87, 476),
(87, 477),
(87, 478),
(87, 479),
(87, 480),
(87, 481),
(87, 482),
(87, 483),
(87, 484),
(87, 485),
(87, 486),
(87, 487),
(87, 488),
(87, 489),
(87, 491),
(87, 492),
(87, 493),
(87, 494),
(87, 495),
(87, 496),
(87, 497),
(87, 498),
(87, 499),
(87, 500),
(87, 501),
(87, 516),
(87, 517),
(87, 518),
(87, 519),
(87, 520),
(87, 528),
(87, 529),
(87, 530),
(87, 545),
(87, 546),
(88, 491),
(89, 491),
(90, 472),
(90, 473),
(90, 474),
(90, 475),
(90, 476),
(90, 477),
(90, 478),
(90, 479),
(90, 480),
(90, 481),
(90, 482),
(90, 483),
(90, 484),
(90, 485),
(90, 486),
(90, 487),
(90, 488),
(90, 489),
(90, 491),
(90, 492),
(90, 493),
(90, 494),
(90, 495),
(90, 496),
(90, 497),
(90, 498),
(90, 499),
(90, 500),
(90, 501),
(90, 502),
(90, 503),
(90, 504),
(90, 505),
(90, 506),
(90, 507),
(90, 508),
(90, 509),
(90, 510),
(90, 511),
(90, 512),
(90, 513),
(90, 514),
(90, 515),
(90, 516),
(90, 517),
(90, 518),
(90, 519),
(90, 520),
(90, 521),
(90, 522),
(90, 523),
(90, 524),
(90, 525),
(90, 526),
(90, 527),
(90, 528),
(90, 529),
(90, 530),
(90, 531),
(90, 532),
(90, 533),
(90, 534),
(90, 535),
(90, 536),
(90, 537),
(90, 538),
(90, 539),
(90, 540),
(90, 541),
(90, 542),
(90, 543),
(90, 544),
(90, 545),
(90, 546),
(91, 0),
(92, 538),
(92, 539),
(92, 540),
(92, 541),
(92, 542),
(92, 578),
(93, 435),
(93, 538),
(93, 539),
(93, 540),
(93, 541),
(93, 542),
(93, 543),
(93, 544),
(94, 435),
(94, 531),
(94, 532),
(94, 533),
(94, 534),
(94, 535),
(95, 435),
(95, 527),
(95, 528),
(95, 529),
(95, 530),
(96, 435),
(96, 547),
(96, 548),
(96, 549),
(96, 550),
(96, 551),
(96, 552),
(96, 553),
(97, 520),
(97, 521),
(97, 522),
(97, 523),
(97, 524),
(97, 525),
(97, 526),
(97, 580),
(98, 0),
(99, 435),
(99, 516),
(100, 0),
(101, 435),
(101, 509),
(101, 510),
(101, 511),
(101, 512),
(101, 513),
(101, 514),
(101, 515),
(102, 502),
(102, 503),
(102, 504),
(102, 505),
(102, 506),
(102, 507),
(102, 508),
(102, 584),
(102, 585),
(103, 0),
(103, 435),
(104, 435),
(104, 491),
(104, 492),
(104, 493),
(104, 494),
(104, 495),
(104, 496),
(104, 497),
(104, 498),
(104, 499),
(104, 500),
(104, 501),
(104, 502),
(104, 503),
(104, 504),
(104, 505),
(104, 506),
(104, 507),
(104, 508),
(104, 509),
(104, 510),
(104, 511),
(104, 512),
(104, 513),
(104, 514),
(104, 515),
(104, 516),
(104, 517),
(104, 518),
(104, 519),
(104, 520),
(104, 521),
(104, 522),
(104, 523),
(104, 524),
(104, 525),
(104, 526),
(104, 527),
(104, 528),
(104, 529),
(104, 530),
(104, 531),
(104, 532),
(104, 533),
(104, 534),
(104, 535),
(104, 536),
(104, 537),
(104, 538),
(104, 539),
(104, 540),
(104, 541),
(104, 542),
(104, 543),
(104, 544),
(104, 547),
(104, 548),
(104, 549),
(104, 550),
(104, 551),
(104, 552),
(104, 553),
(105, 491),
(106, 491),
(106, 516),
(106, 531),
(106, 578),
(107, 201),
(107, 207),
(107, 227),
(107, 229),
(107, 234),
(107, 242),
(107, 243),
(107, 244),
(107, 249),
(107, 251),
(107, 252),
(107, 253),
(107, 254),
(107, 255),
(107, 256),
(107, 257),
(107, 259),
(107, 260),
(107, 262),
(107, 263),
(107, 265),
(107, 266),
(107, 267),
(107, 268),
(107, 270),
(107, 271),
(107, 272),
(107, 273),
(107, 274),
(107, 275),
(107, 276),
(107, 277),
(107, 278),
(107, 279),
(107, 280),
(107, 281),
(107, 282),
(107, 283),
(107, 284),
(107, 285),
(107, 286),
(107, 296),
(107, 300),
(107, 301),
(107, 302),
(107, 303),
(107, 304),
(107, 305),
(107, 306),
(107, 307),
(107, 309),
(107, 310),
(107, 311),
(107, 312),
(107, 313),
(107, 316),
(107, 317),
(107, 318),
(107, 319),
(107, 320),
(107, 321),
(107, 322),
(107, 323),
(107, 324),
(107, 325),
(107, 326),
(107, 399),
(107, 400),
(107, 402),
(107, 403),
(107, 404),
(107, 405),
(107, 406),
(107, 409),
(107, 410),
(107, 411),
(107, 412),
(107, 413),
(107, 414),
(107, 415),
(107, 416),
(107, 417),
(107, 418),
(107, 419),
(107, 421),
(107, 422),
(107, 423),
(107, 424),
(107, 427),
(107, 429),
(107, 430),
(107, 431),
(107, 432),
(107, 433),
(107, 436),
(107, 437),
(107, 443),
(107, 447),
(107, 449),
(107, 450),
(107, 451),
(107, 452),
(107, 453),
(107, 456),
(107, 457),
(107, 458),
(107, 459),
(107, 462),
(107, 463),
(107, 464),
(107, 467),
(107, 468),
(107, 469),
(107, 470),
(107, 471),
(107, 472),
(107, 473),
(107, 476),
(107, 477),
(107, 478),
(107, 479),
(107, 480),
(107, 481),
(107, 482),
(107, 483),
(107, 484),
(107, 485),
(107, 486),
(107, 487),
(107, 491),
(107, 492),
(107, 493),
(107, 494),
(107, 495),
(107, 496),
(107, 497),
(107, 498),
(107, 499),
(107, 500),
(107, 501),
(107, 502),
(107, 503),
(107, 504),
(107, 505),
(107, 506),
(107, 507),
(107, 508),
(107, 509),
(107, 510),
(107, 511),
(107, 512),
(107, 513),
(107, 514),
(107, 515),
(107, 516),
(107, 517),
(107, 518),
(107, 519),
(107, 520),
(107, 521),
(107, 522),
(107, 523),
(107, 524),
(107, 525),
(107, 526),
(107, 527),
(107, 528),
(107, 529),
(107, 530),
(107, 531),
(107, 532),
(107, 533),
(107, 534),
(107, 535),
(107, 536),
(107, 537),
(107, 538),
(107, 539),
(107, 540),
(107, 541),
(107, 542),
(107, 543),
(107, 544),
(107, 545),
(107, 546),
(107, 547),
(107, 548),
(107, 549),
(107, 550),
(107, 551),
(107, 552),
(107, 553),
(107, 559),
(107, 560),
(107, 561),
(107, 584),
(107, 585),
(108, 0),
(109, 201),
(109, 207),
(109, 227),
(109, 229),
(109, 234),
(109, 242),
(109, 243),
(109, 244),
(109, 249),
(109, 251),
(109, 252),
(109, 253),
(109, 254),
(109, 255),
(109, 256),
(109, 257),
(109, 259),
(109, 260),
(109, 262),
(109, 263),
(109, 265),
(109, 266),
(109, 267),
(109, 268),
(109, 270),
(109, 271),
(109, 272),
(109, 273),
(109, 274),
(109, 275),
(109, 276),
(109, 277),
(109, 278),
(109, 279),
(109, 280),
(109, 281),
(109, 282),
(109, 283),
(109, 284),
(109, 285),
(109, 286),
(109, 296),
(109, 300),
(109, 301),
(109, 302),
(109, 303),
(109, 304),
(109, 305),
(109, 306),
(109, 307),
(109, 309),
(109, 310),
(109, 311),
(109, 312),
(109, 313),
(109, 316),
(109, 317),
(109, 318),
(109, 319),
(109, 320),
(109, 321),
(109, 322),
(109, 323),
(109, 324),
(109, 325),
(109, 326),
(109, 399),
(109, 400),
(109, 402),
(109, 403),
(109, 404),
(109, 405),
(109, 406),
(109, 409),
(109, 410),
(109, 411),
(109, 412),
(109, 413),
(109, 414),
(109, 415),
(109, 416),
(109, 417),
(109, 418),
(109, 419),
(109, 421),
(109, 422),
(109, 423),
(109, 424),
(109, 427),
(109, 429),
(109, 430),
(109, 431),
(109, 432),
(109, 433),
(109, 436),
(109, 437),
(109, 443),
(109, 447),
(109, 449),
(109, 450),
(109, 451),
(109, 452),
(109, 453),
(109, 456),
(109, 457),
(109, 458),
(109, 459),
(109, 462),
(109, 463),
(109, 464),
(109, 467),
(109, 468),
(109, 469),
(109, 470),
(109, 471),
(109, 472),
(109, 473),
(109, 476),
(109, 477),
(109, 478),
(109, 479),
(109, 480),
(109, 481),
(109, 482),
(109, 483),
(109, 484),
(109, 485),
(109, 486),
(109, 487),
(109, 491),
(109, 492),
(109, 493),
(109, 494),
(109, 495),
(109, 496),
(109, 497),
(109, 498),
(109, 499),
(109, 500),
(109, 501),
(109, 502),
(109, 503),
(109, 504),
(109, 505),
(109, 506),
(109, 507),
(109, 508),
(109, 509),
(109, 510),
(109, 511),
(109, 512),
(109, 513),
(109, 514),
(109, 515),
(109, 516),
(109, 517),
(109, 518),
(109, 519),
(109, 520),
(109, 521),
(109, 522),
(109, 523),
(109, 524),
(109, 525),
(109, 526),
(109, 527),
(109, 528),
(109, 529),
(109, 530),
(109, 531),
(109, 532),
(109, 533),
(109, 534),
(109, 535),
(109, 536),
(109, 537),
(109, 538),
(109, 539),
(109, 540),
(109, 541),
(109, 542),
(109, 543),
(109, 544),
(109, 545),
(109, 546),
(109, 547),
(109, 548),
(109, 549),
(109, 550),
(109, 551),
(109, 552),
(109, 553),
(109, 559),
(109, 560),
(109, 561),
(109, 584),
(109, 585),
(110, 491),
(111, 0),
(112, 0),
(113, 584),
(113, 585),
(114, 585);

DROP TABLE IF EXISTS `#__newsfeeds`;
CREATE TABLE `#__newsfeeds` (
  `catid` int(11) NOT NULL DEFAULT '0',
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `link` varchar(200) NOT NULL DEFAULT '',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `numarticles` int(10) unsigned NOT NULL DEFAULT '1',
  `cache_time` int(10) unsigned NOT NULL DEFAULT '3600',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rtl` tinyint(4) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `description` text NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__newsfeeds` (`catid`, `id`, `name`, `alias`, `link`, `published`, `numarticles`, `cache_time`, `checked_out`, `checked_out_time`, `ordering`, `rtl`, `access`, `language`, `params`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `xreference`, `publish_up`, `publish_down`, `description`, `version`, `hits`, `images`) VALUES
(17, 1, 'Joomla! Announcements', 'joomla-announcements', 'http://www.joomla.org/announcements.feed?type=rss', 1, 5, 3600, 0, '0000-00-00 00:00:00', 1, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 42, '', '2010-07-10 23:40:09', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', 1, 0, ''),
(17, 2, 'New Joomla! Extensions', 'new-joomla-extensions', 'http://feeds.joomla.org/JoomlaExtensions', 1, 5, 3600, 0, '0000-00-00 00:00:00', 4, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 42, '', '2010-08-23 02:49:21', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', 1, 0, ''),
(17, 3, 'Joomla! Security News', 'joomla-security-news', 'http://feeds.joomla.org/JoomlaSecurityNews', 1, 5, 3600, 0, '0000-00-00 00:00:00', 2, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 42, '', '2010-08-23 02:49:21', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', 1, 0, ''),
(17, 4, 'Joomla! Connect', 'joomla-connect', 'http://feeds.joomla.org/JoomlaConnect', 1, 5, 3600, 0, '0000-00-00 00:00:00', 3, 0, 1, 'en-GB', '{"show_feed_image":"","show_feed_description":"","show_item_description":"","feed_character_count":"0"}', '0000-00-00 00:00:00', 42, '', '2010-08-23 02:49:21', 42, '', '', '{"robots":"","author":"","rights":""}', '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', '', 1, 0, '');

DROP TABLE IF EXISTS `#__overrider`;
CREATE TABLE `#__overrider` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `constant` varchar(255) NOT NULL,
  `string` text NOT NULL,
  `file` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__redirect_links`;
CREATE TABLE `#__redirect_links` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `old_url` varchar(255) DEFAULT NULL,
  `new_url` varchar(255) DEFAULT NULL,
  `referer` varchar(150) NOT NULL,
  `comment` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(4) NOT NULL,
  `created_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_link_old` (`old_url`),
  KEY `idx_link_modifed` (`modified_date`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__schemas`;
CREATE TABLE `#__schemas` (
  `extension_id` int(11) NOT NULL,
  `version_id` varchar(20) NOT NULL,
  PRIMARY KEY (`extension_id`,`version_id`)
) ENGINE=MyISAM;

INSERT INTO `#__schemas` (`extension_id`, `version_id`) VALUES
(700, '3.1.4');

DROP TABLE IF EXISTS `#__session`;
CREATE TABLE `#__session` (
  `session_id` varchar(200) NOT NULL DEFAULT '',
  `client_id` tinyint(3) unsigned NOT NULL DEFAULT '0',
  `guest` tinyint(4) unsigned DEFAULT '1',
  `time` varchar(14) DEFAULT '',
  `data` mediumtext,
  `userid` int(11) DEFAULT '0',
  `username` varchar(150) DEFAULT '',
  PRIMARY KEY (`session_id`),
  KEY `whosonline` (`guest`),
  KEY `userid` (`userid`),
  KEY `time` (`time`)
) ENGINE=MyISAM;

DROP TABLE IF EXISTS `#__tags`;
CREATE TABLE `#__tags` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext NOT NULL,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `tag_idx` (`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=InnoDB ;

INSERT INTO `#__tags` (`id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `created_by_alias`, `modified_user_id`, `modified_time`, `images`, `urls`, `hits`, `language`, `version`, `publish_up`, `publish_down`) VALUES
(1, 0, 0, 35, 0, '', 'ROOT', 'root', '', '', 1, 0, '0000-00-00 00:00:00', 1, '{}', '', '', '', 0, '2011-01-01 00:00:01', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(2, 1, 1, 2, 1, 'premier', 'Premier', 'premier', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 08:57:51', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(3, 1, 3, 4, 1, 'demo', 'Demo', 'demo', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 08:57:51', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(4, 1, 5, 6, 1, 'football', 'Football', 'football', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 08:57:51', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(5, 1, 7, 8, 1, 'joomla', 'Joomla', 'joomla', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 08:59:48', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(6, 1, 9, 10, 1, 'art', 'Art', 'art', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 08:59:48', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(7, 1, 11, 12, 1, 'hawaii-style', 'Hawaii-style', 'hawaii-style', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:02:32', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(8, 1, 13, 14, 1, 'getaways', 'Getaways', 'getaways', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:02:32', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(9, 1, 15, 16, 1, 'christian', 'Christian', 'christian', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:04:15', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(10, 1, 17, 18, 1, 'lorem', 'Lorem', 'lorem', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:04:15', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(11, 1, 19, 20, 1, 'consequat', 'Consequat', 'consequat', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:06:58', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(12, 1, 21, 22, 1, 'malesuada', 'Malesuada', 'malesuada', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:06:58', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(13, 1, 23, 24, 1, 'curabitur', 'Curabitur', 'curabitur', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:08:39', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(14, 1, 25, 26, 1, 'movie', 'Movie', 'movie', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:08:39', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(15, 1, 27, 28, 1, 'anheuser', 'Anheuser', 'anheuser', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:10:33', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(16, 1, 29, 30, 1, 'europe', 'Europe', 'europe', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:10:33', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(17, 1, 31, 32, 1, 'volutpat', 'Volutpat', 'volutpat', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:11:53', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00'),
(18, 1, 33, 34, 1, 'personal', 'Personal', 'personal', '', '', 1, 0, '0000-00-00 00:00:00', 1, '', '', '', '', 42, '2013-07-30 09:11:53', '', 0, '0000-00-00 00:00:00', '', '', 0, '*', 1, '0000-00-00 00:00:00', '0000-00-00 00:00:00');

DROP TABLE IF EXISTS `#__template_styles`;
CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM ;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`) VALUES
(5, 'hathor', 1, '0', 'Hathor - Default', '{"showSiteName":"0","highContrast":"0","boldText":"0","altMenu":"0"}'),
(116, 'ja_teline_iii', 0, '1', 'JA_Teline_III - Default', '{}'),
(117, 'beez3', 0, '0', 'beez3 - Default', '{"wrapperSmall":"53","wrapperLarge":"72","sitetitle":"","sitedescription":"","navposition":"center","templatecolor":"nature","backgroundcolor":"#eee"}'),
(118, 'isis', 1, '1', 'isis - Default', '{"templateColor":"#13294A","headerColor":"#184A7D","logoFile":"","admin_menus":"1","displayHeader":"1","statusFixed":"1","stickyToolbar":"1"}'),
(119, 'protostar', 0, '0', 'protostar - Default', '{"templateColor":"#08C","templateBackgroundColor":"#F4F6F7","logoFile":"","sitetitle":"","sitedescription":"","googleFont":"1","googleFontName":"Open+Sans","fluidContainer":"0"}');

DROP TABLE IF EXISTS `#__ucm_base`;
CREATE TABLE `#__ucm_base` (
  `ucm_id` int(10) unsigned NOT NULL,
  `ucm_item_id` int(10) NOT NULL,
  `ucm_type_id` int(11) NOT NULL,
  `ucm_language_id` int(11) NOT NULL,
  PRIMARY KEY (`ucm_id`),
  KEY `idx_ucm_item_id` (`ucm_item_id`),
  KEY `idx_ucm_type_id` (`ucm_type_id`),
  KEY `idx_ucm_language_id` (`ucm_language_id`)
) ENGINE=InnoDB;

INSERT INTO `#__ucm_base` (`ucm_id`, `ucm_item_id`, `ucm_type_id`, `ucm_language_id`) VALUES
(1, 115, 1, 0),
(2, 165, 1, 0),
(3, 213, 1, 0),
(4, 235, 1, 0),
(5, 283, 1, 0),
(6, 299, 1, 0),
(7, 349, 1, 0),
(8, 397, 1, 0);

DROP TABLE IF EXISTS `#__ucm_content`;
CREATE TABLE `#__ucm_content` (
  `core_content_id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `core_type_alias` varchar(255) NOT NULL DEFAULT '' COMMENT 'FK to the content types table',
  `core_title` varchar(255) NOT NULL,
  `core_alias` varchar(255) binary NOT NULL DEFAULT '',
  `core_body` mediumtext NOT NULL,
  `core_state` tinyint(1) NOT NULL DEFAULT '0',
  `core_checked_out_time` varchar(255) NOT NULL DEFAULT '',
  `core_checked_out_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_access` int(10) unsigned NOT NULL DEFAULT '0',
  `core_params` text NOT NULL,
  `core_featured` tinyint(4) unsigned NOT NULL DEFAULT '0',
  `core_metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `core_created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `core_created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `core_created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_modified_user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Most recent user that modified',
  `core_modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `core_language` char(7) NOT NULL,
  `core_publish_up` datetime NOT NULL,
  `core_publish_down` datetime NOT NULL,
  `core_content_item_id` int(10) unsigned DEFAULT NULL COMMENT 'ID from the individual type table',
  `asset_id` int(10) unsigned DEFAULT NULL COMMENT 'FK to the #__assets table.',
  `core_images` text NOT NULL,
  `core_urls` text NOT NULL,
  `core_hits` int(10) unsigned NOT NULL DEFAULT '0',
  `core_version` int(10) unsigned NOT NULL DEFAULT '1',
  `core_ordering` int(11) NOT NULL DEFAULT '0',
  `core_metakey` text NOT NULL,
  `core_metadesc` text NOT NULL,
  `core_catid` int(10) unsigned NOT NULL DEFAULT '0',
  `core_xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `core_type_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`core_content_id`),
  KEY `tag_idx` (`core_state`,`core_access`),
  KEY `idx_access` (`core_access`),
  KEY `idx_alias` (`core_alias`),
  KEY `idx_language` (`core_language`),
  KEY `idx_title` (`core_title`),
  KEY `idx_modified_time` (`core_modified_time`),
  KEY `idx_created_time` (`core_created_time`),
  KEY `idx_content_type` (`core_type_alias`),
  KEY `idx_core_modified_user_id` (`core_modified_user_id`),
  KEY `idx_core_checked_out_user_id` (`core_checked_out_user_id`),
  KEY `idx_core_created_user_id` (`core_created_user_id`),
  KEY `idx_core_type_id` (`core_type_id`)
) ENGINE=InnoDB  COMMENT='Contains core content data in name spaced fields';

INSERT INTO `#__ucm_content` (`core_content_id`, `core_type_alias`, `core_title`, `core_alias`, `core_body`, `core_state`, `core_checked_out_time`, `core_checked_out_user_id`, `core_access`, `core_params`, `core_featured`, `core_metadata`, `core_created_user_id`, `core_created_by_alias`, `core_created_time`, `core_modified_user_id`, `core_modified_time`, `core_language`, `core_publish_up`, `core_publish_down`, `core_content_item_id`, `asset_id`, `core_images`, `core_urls`, `core_hits`, `core_version`, `core_ordering`, `core_metakey`, `core_metadesc`, `core_catid`, `core_xreference`, `core_type_id`) VALUES
(1, 'com_content.article', 'Premier League summer transfer photos ', '1219606112', '<img src="images/stories/demo/sport/football-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Turpis nonummy id Cras et Curabitur eu urna Vivamus dolor non. Est condimentum sit orci ac arcu Donec amet aliquam tristique Praesent. </p>\r\n\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 0, '{"tags":[2,3,4],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-14 07:57:43', 0, '2013-07-30 08:57:51', '*', '2008-04-14 07:57:43', '0000-00-00 00:00:00', 115, 619, '', '', 9, 2, 8, '', '', 91, '', 1),
(2, 'com_content.article', 'Sed id leo et vitae', 'sed-id-leo-et-vitae', '<p><img class="caption" src="images/stories/demo/artist/art-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer ac Vivamus Aliquam id aliquam. Orci cursus interdum pulvinar sociis vestibulum sed vestibulum est condimentum ac.</p>\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, '{"tags":[3,5,6],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-16 02:15:40', 0, '2013-07-30 08:59:48', '*', '2008-04-16 02:15:40', '0000-00-00 00:00:00', 165, 620, '', '', 1, 3, 8, '', '', 98, '', 1),
(3, 'com_content.article', 'Hawaii-style fun on the mainland', 'hawaii-style-fun-on-the-mainland', '<img src="images/stories/demo/travel/getaways-1.jpg" alt="Sample image" align="right" title="Sample image" class="caption" />\r\n\r\n<p>Nascetur vel interdum vel ut nascetur velit Maecenas vitae risus a. Auctor facilisis et dolor semper in dignissim elit ante sit Quisque. Lacinia leo Ut Aenean eros ipsum interdum odio et Praesent condimentum.  </p>\r\n\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 0, '{"tags":[7,8,3],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-11 06:53:59', 0, '2013-07-30 09:02:32', '*', '2008-04-11 06:53:59', '0000-00-00 00:00:00', 213, 621, '', '', 26, 3, 8, '', '', 105, '', 1),
(4, 'com_content.article', 'The Fall of Christian Lacroix', 'the-fall-of-christian-lacroix', '<p><img class="caption" src="images/stories/demo/style/fashion-1.jpg" border="0" alt="Sample image" title="Sample image" align="left" /></p>\r\n<p>Lorem ipsum dolor sit amet consectetuer eget nunc Phasellus facilisi et. At et ac pretium Sed senectus adipiscing nibh sodales laoreet id. Augue consequat Vestibulum est rutrum amet Nunc elit congue aliquam ut. Ligula lacinia dis a Vestibulum felis nunc lacinia quis ac id. Libero et turpis hendrerit sociis sociis Sed nibh Proin Aenean.</p>\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 0, '{"tags":[9,3,10],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-11 09:33:49', 0, '2013-07-30 09:04:15', '*', '2008-04-11 09:33:49', '0000-00-00 00:00:00', 235, 622, '', '', 0, 3, 8, '', '', 109, '', 1),
(5, 'com_content.article', 'Who\'s your daddy? A celebrity look-alike', '2023712157', '<img src="images/stories/demo/health/health-1.jpg" alt="Sample image" align="left" title="Sample image" class="caption" />\r\n\r\n<p>Consequat ante parturient fringilla quis consectetuer tincidunt a in justo metus. Malesuada est Integer nibh velit ac quis parturient est libero cursus. </p>\r\n\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 0, '{"tags":[11,3,12],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-14 02:07:04', 0, '2013-07-30 09:06:58', '*', '2008-04-14 02:07:04', '0000-00-00 00:00:00', 283, 623, '', '', 0, 2, 6, '', '', 116, '', 1),
(6, 'com_content.article', 'Ut fames Duis nibh arcu', '615027045', '<img src="images/stories/demo/entertaiment/e-10.jpg" alt="Movies" align="left" title="Movies" class="caption" />\r\n\r\n<p>Vel arcu in Curabitur est at id ut Sed urna tincidunt. Justo cursus ante amet fringilla a tincidunt ac montes dui nec. Elit dapibus habitasse ac mauris eros consequat nunc laoreet dictum vel. </p>\r\n\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 0, '{"tags":[13,3,14],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-16 02:29:45', 0, '2013-07-30 09:08:39', '*', '2008-04-16 02:29:45', '0000-00-00 00:00:00', 299, 624, '', '', 0, 2, 8, '', '', 120, '', 1),
(7, 'com_content.article', 'Anheuser Refreshes Bud Light Ads', 'anheuser-refreshes-bud-light-ads', '<img align="left" src="images/stories/demo/world/eu-3.jpg" alt="Sample image" title="Sample image" class="caption" />\r\n\r\n<p>Orci rutrum lacus feugiat egestas venenatis Sed dolor condimentum montes ornare. Sapien magna libero Vivamus ipsum risus urna sed id tempus mauris. </p>\r\n\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, '{"tags":[15,3,16],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-16 04:28:44', 0, '2013-07-30 09:10:33', '*', '2008-04-16 04:28:44', '0000-00-00 00:00:00', 349, 625, '', '', 129, 3, 8, '', '', 127, '', 1),
(8, 'com_content.article', 'Nibh volutpat tortor', '403035504', '<img src="images/stories/demo/tech/tech-8.jpg" alt="Sample image" align="left" title="Sample imate" class="caption" />\r\n\r\n<p>Semper accumsan Integer nisl Pellentesque In id metus laoreet dignissim vel. Lacinia Sed convallis urna lacus interdum sagittis velit Nulla neque aliquet. </p>\r\n\r\n', 1, '', 0, 1, '{"show_title":"","link_titles":"","show_tags":"","show_intro":"","info_block_position":"","show_category":"","link_category":"","show_parent_category":"","link_parent_category":"","show_author":"","link_author":"","show_create_date":"","show_modify_date":"","show_publish_date":"","show_item_navigation":"","show_icons":"","show_print_icon":"","show_email_icon":"","show_vote":"","show_hits":"","show_noauth":"","urls_position":"","alternative_readmore":"","article_layout":"","show_publishing_options":"","show_article_options":"","show_urls_images_backend":"","show_urls_images_frontend":""}', 1, '{"tags":[17,3,18],"robots":"","author":"","rights":"","xreference":""}', 42, '', '2008-04-16 03:27:08', 0, '2013-07-30 09:11:53', '*', '2008-04-16 03:27:08', '0000-00-00 00:00:00', 397, 626, '', '', 0, 2, 8, '', '', 134, '', 1);

DROP TABLE IF EXISTS `#__update_categories`;
CREATE TABLE `#__update_categories` (
  `categoryid` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(20) DEFAULT '',
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `updatesite` int(11) DEFAULT '0',
  PRIMARY KEY (`categoryid`)
) ENGINE=MyISAM COMMENT='Update Categories';


DROP TABLE IF EXISTS `#__update_sites`;
CREATE TABLE `#__update_sites` (
  `update_site_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `location` text NOT NULL,
  `enabled` int(11) DEFAULT '0',
  `last_check_timestamp` bigint(20) DEFAULT '0',
  PRIMARY KEY (`update_site_id`)
) ENGINE=MyISAM  COMMENT='Update Sites';

INSERT INTO `#__update_sites` (`update_site_id`, `name`, `type`, `location`, `enabled`, `last_check_timestamp`) VALUES
(5, '', 'collection', 'http://update.joomlart.com/service/tracking/list.xml', 1, 1375669121),
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 1375669121),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 0, 0),
(3, 'Accredited Joomla! Translations', 'collection', 'http://update.joomla.org/language/translationlist_3.xml', 1, 1375669121);
INSERT IGNORE INTO `#__update_sites` VALUES
(1, 'Joomla Core', 'collection', 'http://update.joomla.org/core/list.xml', 1, 0),
(2, 'Joomla Extension Directory', 'collection', 'http://update.joomla.org/jed/list.xml', 1, 0),
(3,'Accredited Joomla! Translations','collection','http://update.joomla.org/language/translationlist_3.xml', 1 ,0);
DROP TABLE IF EXISTS `#__update_sites_extensions`;
CREATE TABLE `#__update_sites_extensions` (
  `update_site_id` int(11) NOT NULL DEFAULT '0',
  `extension_id` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`update_site_id`,`extension_id`)
) ENGINE=MyISAM COMMENT='Links extensions to update sites';
INSERT IGNORE INTO `#__update_sites_extensions` VALUES
(1, 700),
(2, 700),
(3, 600);
UPDATE `#__update_sites`
SET location = 'http://update.joomla.org/language/translationlist_3.xml'
WHERE location = 'http://update.joomla.org/language/translationlist.xml'
AND name = 'Accredited Joomla! Translations';
DROP TABLE IF EXISTS `#__updates`;
CREATE TABLE `#__updates` (
  `update_id` int(11) NOT NULL AUTO_INCREMENT,
  `update_site_id` int(11) DEFAULT '0',
  `extension_id` int(11) DEFAULT '0',
  `name` varchar(100) DEFAULT '',
  `description` text NOT NULL,
  `element` varchar(100) DEFAULT '',
  `type` varchar(20) DEFAULT '',
  `folder` varchar(20) DEFAULT '',
  `client_id` tinyint(3) DEFAULT '0',
  `version` varchar(10) DEFAULT '',
  `data` text NOT NULL,
  `detailsurl` text NOT NULL,
  `infourl` text NOT NULL,
  PRIMARY KEY (`update_id`)
) ENGINE=MyISAM  COMMENT='Available Updates';

DROP TABLE IF EXISTS `#__user_notes`;
CREATE TABLE `#__user_notes` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `subject` varchar(100) NOT NULL DEFAULT '',
  `body` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL,
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `review_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`user_id`),
  KEY `idx_category_id` (`catid`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__user_profiles`;
CREATE TABLE `#__user_profiles` (
  `user_id` int(11) NOT NULL,
  `profile_key` varchar(100) NOT NULL,
  `profile_value` varchar(255) NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `idx_user_id_profile_key` (`user_id`,`profile_key`)
) ENGINE=MyISAM COMMENT='Simple user profile storage table';


DROP TABLE IF EXISTS `#__user_usergroup_map`;
CREATE TABLE `#__user_usergroup_map` (
  `user_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__users.id',
  `group_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Foreign Key to #__usergroups.id',
  PRIMARY KEY (`user_id`,`group_id`)
) ENGINE=MyISAM;


DROP TABLE IF EXISTS `#__usergroups`;
CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`)
) ENGINE=MyISAM ;

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`) VALUES
(1, 0, 1, 20, 'Public'),
(2, 1, 6, 17, 'Registered'),
(3, 2, 7, 14, 'Author'),
(4, 3, 8, 11, 'Editor'),
(5, 4, 9, 10, 'Publisher'),
(6, 1, 2, 5, 'Manager'),
(7, 6, 3, 4, 'Administrator'),
(8, 1, 18, 19, 'Super Users');

DROP TABLE IF EXISTS `#__users`;
CREATE TABLE `#__users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `username` varchar(150) NOT NULL DEFAULT '',
  `email` varchar(100) NOT NULL DEFAULT '',
  `password` varchar(100) NOT NULL DEFAULT '',
  `block` tinyint(4) NOT NULL DEFAULT '0',
  `sendEmail` tinyint(4) DEFAULT '0',
  `registerDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `lastvisitDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `activation` varchar(100) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  `lastResetTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'Date of last password reset',
  `resetCount` int(11) NOT NULL DEFAULT '0' COMMENT 'Count of password resets since lastResetTime',
  PRIMARY KEY (`id`),
  KEY `idx_name` (`name`),
  KEY `idx_block` (`block`),
  KEY `username` (`username`),
  KEY `email` (`email`)
) ENGINE=MyISAM ;


DROP TABLE IF EXISTS `#__viewlevels`;
CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM ;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`) VALUES
(1, 'Public', 0, '[]'),
(2, 'Registered', 1, '[6,2,8]'),
(3, 'Special', 2, '[6,3,8]'),
(4, 'Customer Access Level', 3, '[6,3,12]');

DROP TABLE IF EXISTS `#__weblinks`;
CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) binary NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `images` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM ;

INSERT INTO `#__weblinks` (`id`, `catid`, `title`, `alias`, `url`, `description`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`, `version`, `images`) VALUES
(1, 32, 'Joomla!', 'joomla', 'http://www.joomla.org', '<p>Home of Joomla!</p>', 3, 1, 0, '0000-00-00 00:00:00', 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2005-02-14 15:19:02', 42, '', '2010-07-10 23:41:06', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(2, 33, 'php.net', 'php', 'http://www.php.net', '<p>The language that Joomla! is developed in</p>', 6, 1, 0, '0000-00-00 00:00:00', 1, 1, '{"target":"","count_clicks":""}', 'en-GB', '2004-07-07 11:33:24', 42, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(3, 33, 'MySQL', 'mysql', 'http://www.mysql.com', '<p>The database that Joomla! uses</p>', 1, 1, 0, '0000-00-00 00:00:00', 2, 1, '{"target":"","count_clicks":""}', 'en-GB', '2004-07-07 10:18:31', 42, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(4, 32, 'OpenSourceMatters', 'opensourcematters', 'http://www.opensourcematters.org', '<p>Home of OSM</p>', 11, 1, 0, '0000-00-00 00:00:00', 3, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2004-07-07 10:18:31', 42, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(5, 32, 'Joomla! - Forums', 'joomla-forums', 'http://forum.joomla.org', '<p>Joomla! Forums</p>', 4, 1, 0, '0000-00-00 00:00:00', 2, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2005-02-14 15:19:02', 42, '', '2010-07-10 23:41:15', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(6, 33, 'Ohloh Tracking of Joomla!', 'ohloh-tracking-of-joomla', 'http://www.ohloh.net/projects/20', '<p>Objective reports from Ohloh about Joomla\'s development activity. Joomla! has some star developers with serious kudos.</p>', 1, 1, 0, '0000-00-00 00:00:00', 3, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2007-07-19 09:28:31', 42, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(7, 31, 'Baw Baw National Park', 'baw-baw-national-park', 'http://www.parkweb.vic.gov.au/1park_display.cfm?park=44', '<p>Park of the Austalian Alps National Parks system, Baw Baw  features sub alpine vegetation, beautiful views, and opportunities for hiking, skiing and other outdoor activities.</p>', 0, 1, 0, '0000-00-00 00:00:00', 1, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2010-07-10 23:44:03', 42, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(8, 31, 'Kakadu', 'kakadu', 'http://www.environment.gov.au/parks/kakadu/index.html', '<p>Kakadu is known for both its cultural heritage and its natural features. It is one of a small number of places listed as World Heritage Places for both reasons. Extensive rock art is found there.</p>', 0, 1, 0, '0000-00-00 00:00:00', 2, 1, '{"target":"0","count_clicks":""}', 'en-GB', '2010-07-10 23:44:03', 42, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '0000-00-00 00:00:00', '0000-00-00 00:00:00', 1, ''),
(9, 31, 'Pulu Keeling', 'pulu-keeling', 'http://www.environment.gov.au/parks/cocos/index.html', '<p>Located on an atoll 2000 kilometers north of Perth, Pulu Keeling is Australia\'s smallest national park.</p>', 0, 1, 0, '0000-00-00 00:00:00', 3, 1, '{"target":"0","count_clicks":""}', 'en-GB', '0000-00-00 00:00:00', 42, '', '2010-07-10 23:44:03', 42, '', '', '{"robots":"","author":"","rights":""}', 0, '', '2010-07-10 23:44:03', '0000-00-00 00:00:00', 1, '');

